local Isotopes = {}
Isotopes.symbols = {"n","H","He","Li","Be","B","C","N","O","F","Ne","Na","Mg","Al","Si","P","S","Cl","Ar","K","Ca","Sc","Ti","V","Cr","Mn","Fe","Co","Ni","Cu","Zn","Ga","Ge","As","Se","Br","Kr","Rb","Sr","Y","Zr","Nb","Mo","Tc","Ru","Rh","Pd","Ag","Cd","In","Sn","Sb","Te","I","Xe","Cs","Ba","La","Ce","Pr","Nd","Pm","Sm","Eu","Gd","Tb","Dy","Ho","Er","Tm","Yb","Lu","Hf","Ta","W","Re","Os","Ir","Pt","Au","Hg","Tl","Pb","Bi","Po","At","Rn","Fr","Ra","Ac","Th","Pa","U","Np","Pu","Am","Cm","Bk","Cf","Es","Fm","Md","No","Lr","Rf","Db","Sg","Bh","Hs","Mt","Ds","Rg","Cn","Ed","Fl","Ef","Lv","Eh","Ei",["Ge"]=32,["Fe"]=26,["La"]=57,["He"]=2,["Li"]=3,["Pm"]=61,["Ni"]=28,["Ga"]=31,["C"]=6,["Tm"]=69,["F"]=9,["Ti"]=22,["Be"]=4,["B"]=5,["K"]=19,["Eu"]=63,["N"]=7,["Am"]=95,["H"]=1,["I"]=53,["S"]=16,["Ne"]=10,["Ta"]=73,["V"]=23,["Se"]=34,["P"]=15,["Au"]=79,["Te"]=52,["Rh"]=45,["Gd"]=64,["Md"]=101,["Ei"]=118,["Mt"]=109,["Tl"]=81,["Np"]=93,["Pt"]=78,["Ed"]=113,["Ac"]=89,["Cd"]=48,["Sm"]=62,["Bh"]=107,["Ef"]=115,["Fl"]=114,["Na"]=11,["Cl"]=17,["Ce"]=58,["Al"]=13,["Pd"]=46,["Ds"]=110,["Nd"]=60,["Hs"]=108,["Eh"]=117,["At"]=85,["Db"]=105,["O"]=8,["Rg"]=111,["U"]=92,["Fm"]=100,["Es"]=99,["Ca"]=20,["Mg"]=12,["Bk"]=97,["Cm"]=96,["Po"]=84,["Pu"]=94,["No"]=102,["Mo"]=42,["Pa"]=91,["Th"]=90,["Os"]=76,["Sg"]=106,["Ho"]=67,["Ag"]=47,["Cs"]=55,["Ra"]=88,["Cu"]=29,["Co"]=27,["Rn"]=86,["Bi"]=83,["In"]=49,["Ba"]=56,["Hg"]=80,["Re"]=75,["As"]=33,["Tc"]=43,["Sc"]=21,["Si"]=14,["Lu"]=71,["Mn"]=25,["Hf"]=72,["Yb"]=70,["W"]=74,["Zr"]=40,["Sr"]=38,["Sn"]=50,["Y"]=39,["Ru"]=44,["Lv"]=116,["Pr"]=59,["Ir"]=77,["Cf"]=98,["Zn"]=30,["Lr"]=103,["Er"]=68,["Fr"]=87,["Xe"]=54,["n"]=0,["Ar"]=18,["Br"]=35,["Cr"]=24,["Cn"]=112,["Dy"]=66,["Rb"]=37,["Sb"]=51,["Tb"]=65,["Rf"]=104,["Nb"]=41,["Kr"]=36,["Pb"]=82}
Isotopes.names = {"Neutronium","Hydrogen","Helium","Lithium","Beryllium","Boron","Carbon","Nitrogen","Oxygen","Fluorine","Neon","Sodium","Magnesium","Aluminium","Silicon","Phosphorus","Sulfur","Chlorine","Argon","Potassium","Calcium","Scandium","Titanium","Vanadium","Chromium","Manganese","Iron","Cobalt","Nickel","Copper","Zinc","Gallium","Germanium","Arsenic","Selenium","Bromine","Krypton","Rubidium","Strontium","Yttrium","Zirconium","Niobium","Molybdenum","Technetium","Ruthenium","Rhodium","Palladium","Silver","Cadmium","Indium","Tin","Antimony","Tellurium","Iodine","Xenon","Caesium","Barium","Lanthanum","Cerium","Praseodymium","Neodymium","Promethium","Samarium","Europium","Gadolinium","Terbium","Dysprosium","Holmium","Erbium","Thulium","Ytterbium","Lutetium","Hafnium","Tantalum","Tungsten","Rhenium","Osmium","Iridium","Platinum","Gold","Mercury","Thallium","Lead","Bismuth","Polonium","Astatine","Radon","Francium","Radium","Actinium","Thorium","Protactinium","Uranium","Neptunium","Plutonium","Americium","Curium","Berkelium","Californium","Einsteinium","Fermium","Mendelevium","Nobelium","Lawrencium","Rutherfordium","Dubnium","Seaborgium","Bohrium","Hassium","Meitnerium","Darmstadtium","Roentgenium","Copernicium","Nihonium","Flerovium","Moscovium","Livermorium","Tennessine","Oganesson",["Terbium"]=65,["Dysprosium"]=66,["Yttrium"]=39,["Nihonium"]=113,["Neptunium"]=93,["Promethium"]=61,["Copper"]=29,["Hassium"]=108,["Tennessine"]=117,["Antimony"]=51,["Neon"]=10,["Caesium"]=55,["Palladium"]=46,["Tin"]=50,["Cobalt"]=27,["Sodium"]=11,["Boron"]=5,["Rubidium"]=37,["Americium"]=95,["Potassium"]=19,["Ytterbium"]=70,["Calcium"]=20,["Molybdenum"]=42,["Iodine"]=53,["Mendelevium"]=101,["Bismuth"]=83,["Oganesson"]=118,["Nitrogen"]=7,["Selenium"]=34,["Bohrium"]=107,["Tellurium"]=52,["Carbon"]=6,["Cadmium"]=48,["Scandium"]=21,["Moscovium"]=115,["Meitnerium"]=109,["Flerovium"]=114,["Copernicium"]=112,["Silicon"]=14,["Roentgenium"]=111,["Darmstadtium"]=110,["Magnesium"]=12,["Hydrogen"]=1,["Hafnium"]=72,["Seaborgium"]=106,["Europium"]=63,["Thorium"]=90,["Lutetium"]=71,["Phosphorus"]=15,["Vanadium"]=23,["Livermorium"]=116,["Gadolinium"]=64,["Fermium"]=100,["Einsteinium"]=99,["Californium"]=98,["Gallium"]=31,["Actinium"]=89,["Tantalum"]=73,["Oxygen"]=8,["Lithium"]=3,["Polonium"]=84,["Tungsten"]=74,["Gold"]=79,["Curium"]=96,["Zirconium"]=40,["Sulfur"]=16,["Uranium"]=92,["Nickel"]=28,["Protactinium"]=91,["Chlorine"]=17,["Rutherfordium"]=104,["Radium"]=88,["Xenon"]=54,["Francium"]=87,["Argon"]=18,["Zinc"]=30,["Radon"]=86,["Astatine"]=85,["Plutonium"]=94,["Thallium"]=81,["Indium"]=49,["Niobium"]=41,["Platinum"]=78,["Iridium"]=77,["Osmium"]=76,["Lanthanum"]=57,["Holmium"]=67,["Erbium"]=68,["Strontium"]=38,["Thulium"]=69,["Lead"]=82,["Nobelium"]=102,["Helium"]=2,["Bromine"]=35,["Technetium"]=43,["Dubnium"]=105,["Mercury"]=80,["Rhenium"]=75,["Samarium"]=62,["Manganese"]=25,["Rhodium"]=45,["Iron"]=26,["Neodymium"]=60,["Krypton"]=36,["Barium"]=56,["Germanium"]=32,["Chromium"]=24,["Aluminium"]=13,["Lawrencium"]=103,["Praseodymium"]=59,["Ruthenium"]=44,["Titanium"]=22,["Silver"]=47,["Beryllium"]=4,["Cerium"]=58,["Berkelium"]=97,["Arsenic"]=33,["Fluorine"]=9}
Isotopes.keys = {"A","Z","MassExcess","","BindingEnergyPerNucleon","","BetaMinusEnergy","","AtomicMass","","stable","HalfLife","HalfLifeLimit","","","Spin","Parity","Discovery","Abundance","DecayModes","DecayModesIntensity","DecayModesIntensityRelation","","S_2n","","S_2p","","Q_a","","Q_2b-","","Q_ep","","Q_b-n","","S_n","","S_p","","Q_4b-","","Q_da","","Q_pa","","Q_na","",["Abundance"]=19,["Q_pa"]=44,["S_n"]=36,["Q_ep"]=32,["stable"]=11,["Q_na"]=46,["DecayModesIntensity"]=21,["Q_da"]=42,["Q_4b-"]=40,["Spin"]=16,["DecayModes"]=20,["Q_b-n"]=34,["HalfLife"]=12,["Z"]=2,["BetaMinusEnergy"]=7,["Discovery"]=18,["A"]=1,["S_2p"]=26,["S_p"]=38,["HalfLifeLimit"]=13,["BindingEnergyPerNucleon"]=5,["Q_a"]=28,["MassExcess"]=3,["S_2n"]=24,["DecayModesIntensityRelation"]=22,["AtomicMass"]=9,["Q_2b-"]=30,["Parity"]=17}
Isotopes.dkeys = {"","","","MassExcess","","BindingEnergyPerNucleon","","BetaMinusEnergy","","AtomicMass","","","","HalfLife","HalfLifeLimit","","","","","","","","DecayModesIntensity","","S_2n","","S_2p","","Q_a","","Q_2b-","","Q_ep","","Q_b-n","","S_n","","S_p","","Q_4b-","","Q_da","","Q_pa","","Q_na",["Q_pa"]=45,["S_n"]=37,["Q_ep"]=33,["BetaMinusEnergy"]=8,["DecayModesIntensity"]=23,["Q_4b-"]=41,["BindingEnergyPerNucleon"]=6,["HalfLife"]=14,["S_2p"]=27,["S_p"]=39,["HalfLifeLimit"]=15,["Q_na"]=47,["Q_da"]=43,["MassExcess"]=4,["Q_b-n"]=35,["Q_a"]=29,["AtomicMass"]=10,["Q_2b-"]=31,["S_2n"]=25}
Isotopes.units = {"","","keV","keV","keV","keV","keV","keV","u","u","","s","","s","","","","","percent","","percent","","percent","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV","keV"}
Isotopes.indexAZ = {[10246]=1125,[10342]=1135,[7235]=700,[10438]=1145,[14565]=1828,[25096]=3194,[16970]=2223,[7331]=708,[14757]=1852,[21385]=2819,[7427]=717,[17674]=2332,[10950]=1231,[7539]=742,[262106]=3291,[11046]=1242,[11142]=1253,[7635]=751,[18378]=2432,[15365]=1958,[18570]=2451,[7731]=760,[22793]=2985,[15557]=1983,[22985]=2997,[19082]=2530,[11654]=1343,[19274]=2547,[11750]=1355,[7939]=794,[11846]=1367,[15973]=2065,[19786]=2625,[8035]=804,[19978]=2643,[16165]=2090,[8131]=813,[24393]=3137,[4116]=309,[12358]=1458,[20682]=2733,[12454]=1470,[12550]=1482,[16971]=2224,[12646]=1494,[263106]=3297,[4324]=340,[8743]=908,[8839]=917,[263108]=3299,[8935]=927,[13062]=1576,[22090]=2908,[4516]=355,[13158]=1589,[13254]=1602,[18379]=2433,[13350]=1614,[18571]=2452,[22794]=2986,[9447]=1009,[9543]=1020,[9639]=1030,[9735]=1041,[13862]=1709,[23690]=3071,[4916]=404,[13958]=1722,[19787]=2626,[14054]=1734,[19979]=2644,[5028]=428,[24394]=3138,[5124]=436,[10343]=1136,[10439]=1146,[14566]=1829,[25098]=3196,[16972]=2225,[14662]=1841,[14758]=1853,[21387]=2821,[14854]=1865,[2714]=167,[17676]=2334,[10951]=1232,[17868]=2354,[11047]=1243,[11143]=1254,[15270]=1947,[5620]=490,[15366]=1959,[18572]=2453,[15462]=1972,[15558]=1984,[22987]=2999,[19084]=2532,[5828]=522,[19276]=2549,[261101]=3279,[11751]=1356,[5924]=530,[15974]=2066,[11943]=1379,[16070]=2079,[3010]=190,[3018]=198,[16262]=2104,[24395]=3139,[261103]=3281,[6132]=563,[8232]=828,[12359]=1459,[20684]=2735,[3114]=204,[261104]=3282,[12551]=1483,[16973]=2226,[6324]=579,[17165]=2249,[21388]=2822,[8744]=909,[3218]=217,[8840]=918,[261106]=3284,[8936]=928,[6532]=611,[22092]=2910,[9032]=938,[13159]=1590,[22284]=2924,[6628]=619,[18381]=2435,[13351]=1615,[18573]=2454,[6724]=627,[9448]=1010,[3410]=229,[3418]=237,[9640]=1031,[9736]=1042,[6932]=659,[23692]=3073,[13959]=1723,[3514]=243,[19981]=2646,[14151]=1748,[24396]=3140,[10248]=1127,[16462]=2136,[10344]=1137,[3618]=257,[10440]=1147,[14567]=1830,[16974]=2227,[7332]=709,[17166]=2250,[14759]=1854,[21389]=2823,[7428]=718,[21581]=2839,[17678]=2336,[10952]=1233,[17870]=2356,[11048]=1244,[11144]=1255,[3818]=278,[11240]=1267,[15367]=1960,[18574]=2455,[7732]=761,[15559]=1985,[22989]=3001,[7828]=770,[3922]=293,[11656]=1345,[19278]=2551,[11752]=1357,[7940]=795,[11848]=1369,[15975]=2067,[11944]=1380,[8036]=805,[19982]=2647,[16167]=2092,[8132]=814,[24397]=3141,[8233]=829,[20686]=2737,[12456]=1472,[20878]=2753,[4213]=317,[12552]=1484,[16975]=2228,[12648]=1496,[17167]=2251,[21390]=2824,[21582]=2840,[8841]=919,[8937]=929,[4517]=356,[13160]=1591,[22286]=2926,[13256]=1604,[13352]=1616,[18575]=2456,[13448]=1629,[4725]=388,[9545]=1022,[260101]=3272,[4821]=396,[9737]=1043,[13864]=1711,[23694]=3075,[4917]=405,[13960]=1724,[14056]=1736,[19983]=2648,[14152]=1749,[260103]=3274,[24398]=3142,[10249]=1128,[16464]=2138,[10345]=1138,[260104]=3275,[10441]=1148,[14568]=1831,[16976]=2229,[14664]=1843,[17168]=2252,[14760]=1855,[21391]=2825,[14856]=1867,[21583]=2841,[5429]=475,[17680]=2338,[10953]=1234,[17872]=2358,[5525]=483,[11145]=1256,[5621]=491,[15368]=1961,[18576]=2457,[15464]=1974,[15560]=1986,[22991]=3003,[5829]=523,[19280]=2553,[11753]=1358,[5925]=531,[11945]=1381,[16072]=2081,[6021]=539,[16168]=2093,[20176]=2665,[16264]=2106,[24399]=3143,[6133]=564,[8234]=830,[20688]=2739,[8330]=839,[6229]=572,[20880]=2755,[12553]=1485,[16977]=2230,[6325]=580,[17169]=2253,[12745]=1510,[21584]=2842,[8842]=920,[8938]=930,[6533]=612,[9034]=940,[13161]=1592,[22288]=2928,[6629]=620,[13353]=1617,[18577]=2458,[6725]=628,[22992]=3004,[9546]=1023,[9642]=1033,[9738]=1044,[13865]=1712,[23696]=3077,[13961]=1725,[14057]=1737,[19985]=2650,[14153]=1750,[20177]=2666,[7125]=677,[10250]=1129,[16466]=2140,[10346]=1139,[7237]=702,[10442]=1149,[14569]=1832,[10538]=1159,[7333]=710,[25296]=3209,[17170]=2254,[14761]=1856,[14857]=1868,[21585]=2843,[10954]=1235,[17874]=2360,[11050]=1246,[11146]=1257,[7637]=753,[11242]=1269,[15369]=1962,[18578]=2459,[7733]=762,[15561]=1987,[22993]=3005,[7829]=771,[259101]=3265,[19282]=2555,[11754]=1359,[7941]=796,[11850]=1371,[11946]=1382,[8037]=806,[19986]=2651,[16169]=2094,[259103]=3267,[20178]=2667,[8133]=815,[16361]=2119,[24593]=3153,[8235]=831,[259104]=3268,[8331]=840,[12458]=1474,[20882]=2757,[4214]=318,[12554]=1486,[16979]=2232,[259105]=3269,[12650]=1498,[17171]=2255,[12746]=1511,[21586]=2844,[259106]=3270,[2211]=121,[8939]=931,[9035]=941,[13162]=1593,[22290]=2930,[13258]=1606,[13354]=1618,[18579]=2460,[13450]=1631,[18771]=2479,[4726]=389,[9547]=1024,[2411]=138,[9739]=1045,[13866]=1713,[4918]=406,[13962]=1726,[23890]=3089,[14058]=1738,[19987]=2652,[14154]=1751,[20179]=2668,[5126]=438,[16468]=2142,[10347]=1140,[5222]=445,[10539]=1160,[14666]=1845,[25298]=3211,[5318]=453,[14762]=1857,[14858]=1869,[21587]=2845,[5430]=476,[17876]=2362,[5526]=484,[11147]=1258,[10]=1,[15370]=1963,[18580]=2461,[15466]=1976,[18772]=2480,[15562]=1988,[22995]=3007,[15658]=2001,[23187]=3019,[5830]=524,[19284]=2557,[11755]=1360,[19476]=2576,[5926]=532,[11947]=1383,[16074]=2083,[6022]=540,[16170]=2095,[20180]=2669,[16266]=2108,[11]=2,[24595]=3155,[8236]=832,[8332]=841,[3115]=205,[20884]=2759,[12555]=1487,[6326]=581,[17173]=2257,[12747]=1512,[6422]=589,[3219]=218,[8844]=922,[8940]=932,[6534]=613,[9036]=942,[13163]=1594,[22292]=2932,[6630]=621,[22484]=2946,[258100]=3257,[13355]=1619,[18581]=2462,[6726]=629,[18773]=2481,[258101]=3258,[9548]=1025,[3419]=238,[9644]=1035,[9740]=1046,[6934]=661,[9836]=1057,[13963]=1727,[23892]=3091,[7030]=670,[258103]=3260,[14155]=1752,[20181]=2670,[7126]=678,[24596]=3156,[16470]=2144,[3611]=250,[3619]=258,[10444]=1151,[258105]=3262,[10540]=1161,[7334]=711,[17174]=2258,[14763]=1858,[17366]=2281,[7430]=720,[21589]=2847,[14955]=1882,[21781]=2864,[7526]=729,[17878]=2364,[11052]=1248,[18070]=2384,[11148]=1259,[7638]=754,[11244]=1271,[15371]=1964,[18582]=2463,[7734]=763,[18774]=2482,[15563]=1989,[7830]=772,[23189]=3021,[11756]=1361,[19478]=2578,[11852]=1373,[11948]=1384,[8038]=807,[12044]=1396,[16171]=2096,[20182]=2671,[8134]=816,[16363]=2121,[24597]=3157,[4119]=312,[8333]=842,[12460]=1476,[20886]=2761,[4215]=319,[12556]=1488,[12652]=1500,[17175]=2259,[12748]=1513,[17367]=2282,[21590]=2848,[8845]=923,[8941]=933,[9037]=943,[9133]=953,[13260]=1608,[22486]=2948,[4615]=366,[13356]=1620,[18583]=2464,[13452]=1633,[18775]=2483,[4727]=390,[23190]=3022,[4823]=398,[9741]=1047,[4919]=407,[13964]=1728,[23894]=3093,[14060]=1740,[14156]=1753,[20183]=2672,[14252]=1765,[5127]=439,[16472]=2146,[10349]=1142,[16664]=2170,[10445]=1152,[10541]=1162,[14668]=1847,[5319]=454,[14764]=1859,[17368]=2283,[14860]=1871,[21591]=2849,[14956]=1883,[21783]=2866,[17880]=2366,[5527]=485,[18072]=2386,[11149]=1260,[257100]=3250,[21]=3,[15372]=1965,[11341]=1283,[15468]=1978,[18776]=2484,[15564]=1990,[15660]=2003,[23191]=3023,[5831]=525,[257102]=3252,[11757]=1362,[19480]=2580,[5927]=533,[11949]=1385,[257103]=3253,[6023]=541,[16172]=2097,[20184]=2673,[16268]=2110,[20376]=2691,[16364]=2122,[24599]=3159,[8238]=834,[8334]=843,[6231]=574,[20888]=2763,[8430]=853,[12557]=1489,[21080]=2779,[12653]=1501,[17177]=2261,[12749]=1514,[17369]=2284,[6423]=590,[21784]=2867,[8942]=934,[9038]=944,[9134]=954,[13261]=1609,[22488]=2950,[13357]=1621,[13453]=1634,[18777]=2485,[13549]=1646,[23192]=3024,[9646]=1037,[9742]=1048,[6935]=662,[9838]=1059,[13965]=1729,[23896]=3095,[14061]=1741,[14157]=1754,[20185]=2674,[14253]=1766,[20377]=2692,[16474]=2148,[10350]=1143,[16666]=2172,[10446]=1153,[10542]=1163,[14669]=1848,[10638]=1174,[14765]=1860,[17370]=2285,[14861]=1872,[14957]=1884,[21785]=2868,[7527]=730,[17882]=2368,[11054]=1250,[18074]=2388,[11150]=1261,[7639]=755,[11246]=1273,[11342]=1284,[15469]=1979,[18778]=2486,[15565]=1991,[7831]=773,[23193]=3025,[19482]=2582,[11854]=1375,[19674]=2600,[11950]=1386,[8039]=808,[12046]=1398,[16173]=2098,[20186]=2675,[8135]=817,[20378]=2693,[31]=4,[4120]=313,[8335]=844,[20890]=2765,[8431]=854,[12558]=1490,[21082]=2781,[12654]=1502,[17179]=2263,[12750]=1515,[33]=6,[12846]=1527,[2212]=122,[8943]=935,[9039]=945,[256100]=3243,[9135]=955,[13262]=1610,[22490]=2952,[4616]=367,[13358]=1622,[13454]=1635,[18779]=2487,[13550]=1647,[23194]=3026,[256102]=3245,[9647]=1038,[9743]=1049,[9839]=1060,[13966]=1730,[23898]=3097,[14062]=1742,[14158]=1755,[20187]=2676,[256104]=3247,[14254]=1767,[20379]=2694,[5128]=440,[16476]=2150,[10351]=1144,[16668]=2174,[2612]=156,[10543]=1164,[10639]=1175,[14766]=1861,[25498]=3226,[41]=7,[14862]=1873,[2716]=169,[21787]=2870,[42]=8,[5528]=486,[18076]=2390,[11151]=1262,[2812]=174,[11343]=1285,[15470]=1980,[5720]=502,[15566]=1992,[18972]=2507,[15662]=2005,[23195]=3027,[2916]=187,[23387]=3039,[19484]=2584,[11855]=1376,[19676]=2602,[11951]=1387,[3012]=192,[16174]=2099,[12143]=1411,[16270]=2112,[20380]=2695,[16366]=2124,[8240]=836,[24795]=3171,[8336]=845,[3116]=206,[8432]=855,[12559]=1491,[21084]=2783,[12655]=1503,[12751]=1516,[17373]=2288,[3212]=211,[21788]=2871,[8944]=936,[9040]=946,[9136]=956,[3316]=225,[51]=10,[13359]=1623,[22684]=2966,[13455]=1636,[18781]=2489,[52]=11,[18973]=2508,[6824]=639,[3420]=239,[9648]=1039,[53]=12,[9744]=1050,[6936]=663,[9840]=1061,[9936]=1071,[54]=13,[24092]=3109,[14159]=1756,[294118]=3435,[14255]=1768,[20381]=2696,[3612]=251,[3620]=259,[10448]=1155,[10544]=1165,[7336]=713,[10640]=1176,[14767]=1862,[17374]=2289,[14863]=1874,[14959]=1886,[21789]=2872,[7528]=731,[18078]=2392,[11152]=1263,[3820]=280,[11248]=1275,[11344]=1286,[7736]=765,[18782]=2490,[15567]=1993,[18974]=2509,[3916]=287,[255102]=3237,[15759]=2018,[23389]=3041,[61]=14,[19486]=2586,[11856]=1377,[19678]=2604,[11952]=1388,[4020]=302,[62]=15,[12048]=1400,[16175]=2100,[255104]=3239,[12144]=1412,[8136]=818,[20382]=2697,[63]=16,[8241]=837,[255105]=3240,[64]=17,[8337]=846,[8433]=856,[12560]=1492,[21086]=2785,[12656]=1504,[4313]=329,[12752]=1517,[17375]=2290,[12848]=1529,[17567]=2311,[4425]=352,[293117]=3432,[8945]=937,[9041]=947,[9137]=957,[71]=19,[9233]=967,[13360]=1624,[22686]=2968,[72]=20,[13456]=1637,[18783]=2491,[13552]=1649,[18975]=2510,[74]=22,[9649]=1040,[75]=23,[9745]=1051,[9841]=1062,[9937]=1072,[14064]=1744,[24094]=3111,[5017]=417,[14160]=1757,[14256]=1769,[20383]=2698,[14352]=1782,[24798]=3174,[16672]=2178,[10449]=1156,[16864]=2202,[10545]=1166,[82]=24,[5321]=456,[14768]=1863,[83]=25,[14864]=1875,[17568]=2312,[14960]=1887,[21791]=2874,[15056]=1899,[85]=27,[5529]=487,[18080]=2394,[86]=28,[11153]=1264,[18272]=2413,[11249]=1276,[11345]=1287,[15472]=1982,[11441]=1299,[15568]=1994,[18976]=2511,[15664]=2007,[15760]=2019,[23391]=3043,[292116]=3429,[11857]=1378,[92]=29,[11953]=1389,[93]=30,[12049]=1401,[1510]=69,[94]=31,[16272]=2114,[6121]=552,[95]=32,[8242]=838,[96]=33,[8338]=847,[6233]=576,[8434]=857,[21088]=2787,[8530]=867,[12657]=1505,[21280]=2802,[12753]=1518,[17377]=2292,[12849]=1530,[1610]=76,[21792]=2875,[21984]=2890,[254100]=3228,[9042]=948,[102]=34,[9138]=958,[6633]=624,[103]=35,[9234]=968,[13361]=1625,[22688]=2970,[104]=36,[13457]=1638,[105]=37,[18977]=2512,[6825]=640,[106]=38,[23392]=3044,[107]=39,[9746]=1052,[9842]=1063,[9938]=1073,[7033]=673,[24096]=3113,[14161]=1758,[7129]=681,[20385]=2700,[14353]=1783,[20577]=2716,[7225]=690,[1810]=89,[10450]=1157,[113]=40,[10546]=1167,[7337]=714,[114]=41,[10642]=1178,[14769]=1864,[115]=42,[7433]=723,[17570]=2314,[116]=43,[291117]=3428,[7529]=732,[117]=44,[18082]=2396,[11154]=1265,[1910]=96,[11250]=1277,[11346]=1288,[7737]=766,[11442]=1300,[15569]=1995,[18978]=2513,[7833]=775,[15761]=2020,[23393]=3045,[295118]=3436,[123]=45,[294117]=3434,[293118]=3433,[293116]=3431,[124]=46,[292117]=3430,[11954]=1390,[8041]=810,[125]=47,[12050]=1402,[291116]=3427,[291115]=3426,[126]=48,[8137]=819,[283113]=3407,[20386]=2701,[127]=49,[290115]=3424,[128]=50,[289116]=3423,[289115]=3422,[8339]=848,[289114]=3421,[288115]=3420,[8435]=858,[288114]=3419,[21090]=2789,[8531]=868,[12658]=1506,[21282]=2804,[134]=52,[12754]=1519,[135]=53,[2611]=155,[136]=54,[17571]=2315,[137]=55,[12946]=1544,[138]=56,[5724]=506,[21986]=2892,[287113]=3416,[286114]=3415,[9043]=949,[9544]=1021,[248101]=3184,[9139]=959,[285113]=3412,[17479]=2309,[9235]=969,[144]=57,[22690]=2972,[145]=58,[13458]=1639,[146]=59,[6129]=560,[13554]=1651,[18979]=2514,[148]=61,[13650]=1664,[149]=62,[7929]=784,[2413]=140,[284112]=3408,[290116]=3425,[9747]=1053,[23495]=3057,[23497]=3059,[4922]=410,[3211]=210,[154]=63,[9939]=1074,[155]=64,[24098]=3115,[156]=65,[14162]=1759,[157]=66,[282112]=3403,[158]=67,[20387]=2702,[159]=68,[14354]=1784,[20579]=2718,[22887]=2989,[22093]=2911,[16676]=2182,[22186]=2915,[2613]=157,[16868]=2206,[281111]=3399,[164]=70,[281110]=3398,[165]=71,[10643]=1179,[166]=72,[280113]=3397,[167]=73,[14866]=1877,[168]=74,[17572]=2316,[169]=75,[280112]=3396,[21491]=2837,[15058]=1901,[21987]=2893,[280110]=3394,[5530]=488,[20883]=2758,[20889]=2764,[11155]=1266,[18276]=2417,[253101]=3221,[11251]=1278,[279111]=3391,[176]=78,[11347]=1289,[177]=79,[20982]=2769,[178]=80,[15570]=1996,[179]=81,[18980]=2515,[15666]=2009,[279109]=3389,[278113]=3388,[15762]=2021,[23395]=3047,[253103]=3223,[15858]=2034,[20081]=2658,[20085]=2662,[5930]=536,[185]=84,[20188]=2677,[186]=85,[19876]=2628,[187]=86,[12051]=1403,[188]=87,[278109]=3384,[189]=88,[16274]=2116,[277112]=3383,[6122]=553,[16370]=2128,[277111]=3382,[20580]=2719,[16368]=2126,[4520]=359,[8340]=849,[3117]=207,[24995]=3186,[195]=91,[277108]=3379,[196]=92,[8532]=869,[197]=93,[21284]=2806,[198]=94,[12755]=1520,[199]=95,[17475]=2305,[12851]=1532,[17573]=2317,[276111]=3377,[12947]=1545,[18871]=2493,[17473]=2303,[21988]=2894,[276108]=3374,[17982]=2382,[9044]=950,[205]=99,[18071]=2385,[206]=100,[6634]=625,[207]=101,[9236]=970,[208]=102,[22692]=2974,[209]=103,[6730]=633,[275109]=3371,[275108]=3370,[13555]=1652,[18981]=2516,[5524]=482,[6826]=641,[19173]=2533,[17269]=2269,[23396]=3048,[274110]=3367,[215]=107,[9748]=1054,[216]=108,[5225]=448,[217]=109,[10348]=1141,[218]=110,[9940]=1075,[219]=111,[274107]=3364,[10036]=1086,[14163]=1760,[24292]=3127,[16576]=2166,[7130]=682,[273110]=3362,[16669]=2175,[14355]=1785,[20581]=2720,[16673]=2179,[7226]=691,[3621]=260,[226]=116,[24996]=3187,[227]=117,[16677]=2183,[228]=118,[7338]=715,[229]=119,[10644]=1180,[273106]=3358,[272111]=3357,[10740]=1191,[7434]=724,[272110]=3356,[17574]=2318,[14963]=1890,[15873]=2049,[272108]=3354,[7530]=733,[21989]=2895,[272107]=3353,[236]=125,[3917]=288,[237]=126,[3813]=273,[238]=127,[15663]=2006,[239]=128,[18470]=2437,[271109]=3350,[11348]=1290,[7738]=767,[15667]=2010,[11444]=1302,[15571]=1997,[15669]=2012,[18982]=2517,[7834]=776,[271106]=3347,[19174]=2534,[15763]=2022,[23397]=3049,[12045]=1397,[247]=134,[23589]=3061,[248]=135,[270109]=3345,[249]=136,[11655]=1344,[11956]=1392,[4021]=303,[4217]=321,[12052]=1404,[6224]=567,[270105]=3341,[12148]=1416,[8138]=820,[269110]=3340,[12244]=1428,[16371]=2129,[269109]=3339,[257]=143,[258]=144,[259]=145,[8341]=850,[2817]=179,[24997]=3188,[8437]=860,[269107]=3337,[269106]=3336,[8533]=870,[12660]=1508,[268]=152,[269]=153,[12756]=1521,[133]=51,[11045]=1241,[12852]=1533,[17575]=2319,[3513]=242,[12948]=1546,[268108]=3332,[278]=161,[279]=162,[4826]=401,[11245]=1272,[4523]=362,[268105]=3329,[252101]=3214,[9141]=961,[268104]=3328,[6426]=593,[4619]=370,[289]=171,[4424]=351,[267108]=3325,[13460]=1641,[22886]=2988,[4715]=378,[13556]=1653,[18983]=2518,[14055]=1735,[13652]=1666,[299]=180,[252103]=3216,[4827]=402,[267106]=3323,[4115]=308,[9749]=1055,[267104]=3321,[266109]=3320,[9845]=1066,[2910]=181,[309]=189,[9941]=1076,[13449]=1630,[266106]=3317,[5019]=419,[14164]=1761,[24294]=3129,[266105]=3316,[14260]=1773,[12251]=1435,[319]=199,[14356]=1786,[20583]=2722,[266103]=3314,[9643]=1034,[287114]=3417,[265107]=3311,[5227]=450,[16872]=2210,[287115]=3418,[10549]=1170,[17064]=2233,[265105]=3309,[10645]=1181,[265104]=3308,[265103]=3307,[10741]=1192,[14868]=1879,[3919]=290,[5419]=465,[14964]=1891,[3815]=275,[17768]=2340,[15060]=1903,[21991]=2897,[264106]=3304,[15156]=1916,[22183]=2912,[264105]=3303,[4822]=397,[18280]=2421,[4622]=373,[5627]=497,[18472]=2439,[264102]=3300,[11349]=1291,[263107]=3298,[263105]=3296,[5723]=505,[15572]=1998,[263104]=3295,[11541]=1315,[15668]=2011,[263103]=3294,[19176]=2536,[15764]=2023,[263102]=3293,[262107]=3292,[15860]=2036,[23591]=3063,[262105]=3290,[5931]=537,[262104]=3289,[262103]=3288,[11957]=1393,[19880]=2632,[262102]=3287,[6027]=545,[3719]=269,[261107]=3285,[12149]=1417,[16276]=2118,[261105]=3283,[6123]=554,[16372]=2130,[261102]=3280,[20584]=2723,[260107]=3278,[260106]=3277,[8342]=851,[260105]=3276,[24999]=3190,[8438]=861,[260102]=3273,[260100]=3271,[8534]=871,[12661]=1509,[21288]=2810,[259102]=3266,[12757]=1522,[21480]=2826,[259100]=3264,[6427]=594,[17577]=2321,[258106]=3263,[12949]=1547,[17769]=2341,[258104]=3261,[6523]=602,[258102]=3259,[25899]=3256,[9046]=952,[257105]=3255,[257104]=3254,[9142]=962,[257101]=3251,[286113]=3414,[9238]=972,[256105]=3248,[256103]=3246,[9334]=982,[6731]=634,[22888]=2990,[256101]=3244,[13557]=1654,[25699]=3242,[25698]=3241,[6827]=642,[19177]=2537,[255103]=3238,[13749]=1680,[255101]=3236,[255100]=3235,[23592]=3064,[6632]=623,[25598]=3233,[9846]=1067,[254104]=3232,[254103]=3231,[9942]=1077,[7035]=675,[254102]=3230,[10038]=1088,[14165]=1762,[24296]=3131,[254101]=3229,[7131]=683,[25499]=3227,[25497]=3225,[14357]=1787,[20585]=2724,[253104]=3224,[7227]=692,[253102]=3222,[253100]=3220,[6227]=570,[16874]=2212,[25398]=3218,[10550]=1171,[17066]=2235,[19285]=2558,[10646]=1182,[252102]=3215,[252100]=3213,[10742]=1193,[7435]=725,[25299]=3212,[17578]=2322,[14965]=1892,[25297]=3210,[17770]=2342,[7531]=734,[21993]=2899,[22986]=2998,[15157]=1917,[22185]=2914,[251102]=3207,[7627]=743,[18282]=2423,[251101]=3206,[11254]=1281,[18474]=2441,[251100]=3205,[11350]=1292,[7739]=768,[4522]=361,[11446]=1304,[15573]=1999,[22487]=2949,[11542]=1316,[7835]=777,[251103]=3208,[19178]=2538,[15765]=2024,[25196]=3201,[250102]=3200,[7931]=786,[23593]=3065,[21287]=2809,[17079]=2248,[25099]=3197,[25097]=3195,[11958]=1394,[19882]=2634,[21081]=2780,[12054]=1406,[249101]=3192,[285112]=3411,[12150]=1418,[8139]=821,[24998]=3189,[12246]=1430,[16373]=2131,[21083]=2782,[20586]=2725,[285114]=3413,[5624]=494,[8343]=852,[24899]=3182,[5018]=418,[4220]=324,[24897]=3180,[4519]=358,[8535]=872,[24895]=3178,[21290]=2812,[8631]=882,[12758]=1523,[21482]=2828,[247101]=3177,[12854]=1535,[17579]=2323,[247100]=3176,[12950]=1548,[17771]=2343,[24799]=3175,[24797]=3173,[24796]=3172,[24794]=3170,[4524]=363,[246101]=3169,[5021]=421,[9143]=963,[24699]=3167,[16776]=2198,[9239]=973,[24697]=3165,[17780]=2352,[9335]=983,[13462]=1643,[22890]=2992,[4716]=379,[13558]=1655,[24695]=3163,[16663]=2169,[13654]=1668,[19179]=2539,[4417]=344,[2414]=141,[245100]=3160,[24598]=3158,[23594]=3066,[24594]=3154,[244100]=3152,[9847]=1068,[24499]=3151,[10047]=1097,[9943]=1078,[24497]=3149,[19279]=2552,[5020]=420,[14166]=1763,[24298]=3133,[24495]=3147,[14262]=1775,[17477]=2307,[24493]=3145,[14358]=1788,[20587]=2726,[243100]=3144,[14454]=1800,[20779]=2742,[24392]=3136,[5228]=451,[16876]=2214,[4017]=299,[10551]=1172,[17068]=2237,[24299]=3134,[10647]=1183,[24297]=3132,[24295]=3130,[10743]=1194,[14870]=1881,[24293]=3128,[10839]=1205,[14966]=1893,[11253]=1280,[17772]=2344,[15062]=1905,[5428]=474,[24198]=3124,[15158]=1918,[22187]=2916,[7930]=785,[13263]=1611,[284113]=3409,[24194]=3120,[5628]=498,[18476]=2443,[284114]=3410,[11351]=1293,[24192]=3118,[2113]=115,[11447]=1305,[24099]=3116,[24097]=3114,[11543]=1317,[15670]=2013,[24095]=3112,[5820]=514,[15766]=2025,[24093]=3110,[24091]=3108,[15862]=2038,[23595]=3067,[32]=5,[5932]=538,[3712]=262,[4624]=375,[23996]=3104,[19884]=2636,[16473]=2147,[6028]=546,[20076]=2653,[16869]=2207,[12151]=1419,[17379]=2294,[23992]=3100,[6124]=555,[16374]=2132,[3313]=222,[20588]=2727,[23990]=3098,[23897]=3096,[3110]=200,[3118]=208,[23895]=3094,[8440]=863,[23893]=3092,[23891]=3090,[8536]=873,[6332]=587,[23798]=3088,[8632]=883,[12759]=1524,[21484]=2830,[250100]=3198,[6428]=595,[19875]=2627,[20477]=2704,[12951]=1549,[17773]=2345,[23794]=3084,[6524]=603,[250101]=3199,[21782]=2865,[22188]=2917,[21487]=2833,[23790]=3080,[3310]=219,[3318]=227,[23093]=3015,[9240]=974,[23697]=3078,[23695]=3076,[9336]=984,[6732]=635,[22892]=2994,[23693]=3074,[13559]=1656,[23691]=3072,[23689]=3070,[6828]=643,[19181]=2541,[23095]=3017,[13751]=1682,[19373]=2559,[23596]=3068,[6924]=651,[23590]=3062,[23588]=3060,[9848]=1069,[283111]=3405,[3715]=265,[9944]=1079,[7036]=676,[283112]=3406,[10040]=1090,[14167]=1764,[3515]=244,[10136]=1101,[7132]=684,[23493]=3055,[10651]=1187,[14359]=1789,[20589]=2728,[23491]=3053,[3614]=253,[20781]=2744,[3413]=232,[23489]=3051,[16878]=2216,[9033]=939,[10552]=1173,[17070]=2239,[23394]=3046,[10648]=1184,[23390]=3042,[23388]=3040,[10744]=1195,[3718]=268,[15055]=1898,[10840]=1206,[14967]=1894,[23295]=3037,[17774]=2346,[7532]=735,[15259]=1936,[23293]=3035,[15159]=1919,[22189]=2918,[16065]=2074,[3814]=274,[3822]=282,[23291]=3033,[12145]=1413,[18478]=2445,[23289]=3031,[11352]=1294,[7740]=769,[18069]=2383,[11448]=1306,[23287]=3029,[23196]=3028,[11544]=1318,[7836]=778,[23188]=3020,[19182]=2542,[15767]=2026,[23186]=3018,[19374]=2560,[7932]=787,[23597]=3069,[19077]=2525,[15959]=2051,[23789]=3079,[19886]=2638,[8028]=797,[4022]=304,[23091]=3013,[12056]=1408,[20078]=2655,[17677]=2335,[12152]=1420,[8140]=822,[23089]=3011,[12248]=1432,[16375]=2133,[11449]=1307,[12344]=1444,[23087]=3009,[22693]=2975,[20782]=2745,[22994]=3006,[22990]=3002,[4221]=325,[22988]=3000,[25197]=3202,[8537]=874,[22784]=2976,[22893]=2995,[4317]=333,[12760]=1525,[21486]=2832,[22891]=2993,[12856]=1537,[22889]=2991,[282111]=3402,[12952]=1550,[17775]=2347,[22885]=2987,[13048]=1562,[22792]=2984,[4320]=336,[4525]=364,[282113]=3404,[14961]=1888,[9145]=965,[2210]=120,[3817]=277,[9241]=975,[22786]=2978,[7832]=774,[9337]=985,[13464]=1645,[22894]=2996,[4717]=380,[13560]=1657,[23086]=3008,[22691]=2973,[13656]=1670,[19183]=2543,[22689]=2971,[13752]=1683,[19375]=2561,[22687]=2969,[22685]=2967,[13051]=1565,[15257]=1934,[4925]=413,[15461]=1971,[22590]=2962,[9945]=1080,[7029]=669,[16075]=2084,[10041]=1091,[16671]=2177,[22586]=2958,[10137]=1102,[14264]=1777,[24494]=3146,[5117]=429,[14360]=1790,[22584]=2956,[22493]=2955,[14456]=1802,[20783]=2746,[22492]=2954,[5229]=452,[22491]=2953,[22489]=2951,[25198]=3203,[17072]=2241,[22485]=2947,[10649]=1185,[22483]=2945,[249100]=3191,[10745]=1196,[22392]=2943,[18673]=2467,[5421]=467,[14968]=1895,[19180]=2540,[17776]=2348,[15064]=1907,[19677]=2603,[22388]=2939,[15160]=1920,[22191]=2920,[20578]=2717,[15256]=1933,[22383]=2934,[249102]=3193,[5629]=499,[18480]=2447,[22385]=2936,[11353]=1295,[18672]=2466,[22384]=2935,[5725]=507,[22293]=2933,[22291]=2931,[11545]=1319,[15672]=2015,[22289]=2929,[5821]=515,[15768]=2027,[22287]=2927,[19376]=2562,[15864]=2040,[22285]=2925,[22283]=2923,[15960]=2052,[23791]=3081,[65]=18,[22190]=2919,[281112]=3400,[22184]=2913,[6029]=547,[20080]=2657,[281113]=3401,[12153]=1421,[22091]=2909,[22089]=2907,[6125]=556,[16376]=2134,[4118]=311,[12345]=1445,[22087]=2905,[4316]=332,[20784]=2747,[22085]=2903,[14053]=1733,[8442]=865,[22083]=2901,[25199]=3204,[8538]=875,[6333]=588,[21992]=2898,[8634]=885,[12761]=1526,[21488]=2834,[21990]=2896,[6429]=596,[21680]=2851,[21985]=2891,[12953]=1551,[17777]=2349,[21983]=2889,[6525]=604,[17969]=2369,[21982]=2888,[22192]=2921,[21891]=2886,[6529]=608,[9146]=966,[21889]=2884,[15356]=1949,[9242]=976,[21887]=2882,[3512]=241,[9338]=986,[6733]=636,[21885]=2880,[9434]=996,[13561]=1658,[23088]=3010,[21883]=2878,[6829]=644,[1711]=83,[17176]=2260,[13753]=1684,[19377]=2563,[21881]=2876,[6925]=652,[21790]=2873,[21786]=2869,[23792]=3082,[16261]=2103,[21691]=2862,[9946]=1081,[17178]=2262,[21689]=2860,[10042]=1092,[5024]=424,[21687]=2858,[10138]=1103,[7133]=685,[24496]=3148,[21685]=2856,[14361]=1791,[20083]=2660,[16562]=2152,[7229]=694,[1811]=90,[21683]=2854,[14553]=1816,[21180]=2790,[21681]=2852,[21592]=2850,[17074]=2243,[21588]=2846,[10650]=1186,[17266]=2266,[21580]=2838,[10746]=1197,[7437]=727,[280111]=3395,[10842]=1208,[14969]=1896,[8237]=833,[17778]=2350,[7533]=736,[21489]=2835,[17970]=2370,[15161]=1921,[22193]=2922,[21485]=2831,[7629]=745,[1911]=97,[21483]=2829,[21481]=2827,[18482]=2449,[21386]=2820,[11354]=1296,[18674]=2468,[7636]=752,[11450]=1308,[13750]=1681,[21382]=2816,[11546]=1320,[7837]=779,[2610]=154,[11642]=1331,[15769]=2028,[21380]=2814,[19378]=2564,[7933]=788,[21291]=2813,[21289]=2811,[15961]=2053,[23793]=3083,[21286]=2808,[8029]=798,[2011]=105,[21285]=2807,[12058]=1410,[20082]=2659,[21283]=2805,[12154]=1422,[8141]=823,[21281]=2803,[12250]=1434,[5221]=444,[2515]=151,[12346]=1446,[16563]=2153,[5123]=435,[20786]=2749,[21188]=2798,[14457]=1803,[4222]=326,[6329]=584,[15061]=1904,[8539]=876,[6528]=607,[248100]=3183,[8635]=886,[3918]=289,[21490]=2836,[8731]=896,[12858]=1539,[21682]=2853,[4414]=341,[12954]=1552,[17779]=2351,[21089]=2788,[13050]=1564,[17971]=2371,[21087]=2786,[4526]=365,[21085]=2784,[248102]=3185,[22386]=2937,[21079]=2778,[4518]=357,[9243]=977,[3518]=247,[16275]=2117,[9339]=987,[12146]=1414,[20986]=2773,[9435]=997,[13562]=1659,[23090]=3012,[18182]=2410,[13658]=1672,[18873]=2495,[279110]=3390,[13754]=1685,[19379]=2565,[10845]=1211,[13850]=1697,[20279]=2681,[20780]=2743,[4926]=414,[279112]=3392,[20887]=2762,[9947]=1082,[20885]=2760,[279113]=3393,[5022]=422,[20881]=2756,[20879]=2754,[10139]=1104,[14266]=1779,[24498]=3150,[5118]=430,[14362]=1792,[20788]=2751,[16564]=2154,[14458]=1804,[20787]=2750,[20785]=2748,[2615]=159,[20979]=2766,[20778]=2741,[20689]=2740,[17076]=2245,[20687]=2738,[5326]=461,[17268]=2268,[20685]=2736,[10747]=1198,[20683]=2734,[20681]=2732,[2711]=164,[14970]=1897,[7236]=701,[10939]=1220,[15066]=1909,[20679]=2730,[17972]=2372,[15162]=1922,[14066]=1746,[20582]=2721,[15258]=1935,[22387]=2938,[5125]=437,[5630]=500,[20487]=2714,[11955]=1391,[11355]=1297,[18676]=2470,[20485]=2712,[5726]=508,[4013]=295,[20483]=2710,[11547]=1321,[147]=60,[20481]=2708,[5822]=516,[15770]=2029,[4321]=337,[19380]=2566,[15866]=2042,[20479]=2706,[3412]=231,[15962]=2054,[23795]=3085,[20388]=2703,[20384]=2699,[6328]=583,[20287]=2689,[3015]=195,[20084]=2661,[15459]=1969,[12155]=1423,[20276]=2678,[20285]=2687,[6126]=557,[16465]=2139,[20283]=2685,[12347]=1447,[16565]=2155,[3214]=213,[6222]=565,[20281]=2683,[18278]=2419,[20980]=2767,[20278]=2680,[20277]=2679,[8540]=877,[278110]=3385,[20087]=2664,[8636]=887,[19483]=2583,[278111]=3386,[8732]=897,[6430]=597,[21684]=2855,[278112]=3387,[12955]=1553,[17781]=2353,[20079]=2656,[6526]=605,[17973]=2373,[20077]=2654,[13147]=1578,[19984]=2649,[19980]=2645,[3311]=220,[3319]=228,[4015]=297,[9244]=978,[2415]=142,[11847]=1368,[9340]=988,[6734]=637,[19887]=2639,[9436]=998,[13563]=1660,[23092]=3014,[19885]=2637,[6830]=645,[19883]=2635,[19881]=2633,[13755]=1686,[19381]=2567,[19879]=2631,[6926]=653,[19878]=2630,[19877]=2629,[23796]=3086,[3915]=286,[11651]=1340,[9948]=1083,[3519]=248,[5422]=468,[10044]=1094,[7228]=693,[13363]=1627,[10140]=1105,[7134]=686,[9641]=1032,[4818]=393,[14363]=1793,[14865]=1876,[16566]=2156,[7230]=695,[20789]=2752,[6232]=575,[14555]=1818,[20981]=2768,[7429]=719,[7326]=703,[17078]=2247,[19686]=2612,[10652]=1188,[17270]=2270,[19685]=2611,[3711]=261,[7438]=728,[19684]=2610,[10844]=1210,[19683]=2609,[19682]=2608,[10940]=1221,[7534]=737,[19681]=2607,[17974]=2374,[15163]=1923,[19680]=2606,[19679]=2605,[7630]=746,[22389]=2940,[19675]=2601,[19586]=2599,[2513]=149,[19584]=2597,[11356]=1298,[18678]=2472,[15657]=2000,[11452]=1310,[277109]=3380,[16059]=2068,[11548]=1322,[7838]=780,[277110]=3381,[11644]=1333,[15771]=2030,[16875]=2213,[19382]=2568,[7934]=789,[3812]=272,[19574]=2587,[15963]=2055,[23797]=3087,[2311]=130,[8030]=799,[4023]=305,[18984]=2519,[19485]=2585,[20086]=2663,[19481]=2581,[12156]=1424,[8142]=824,[19479]=2579,[12252]=1436,[19477]=2577,[19475]=2575,[12348]=1448,[16567]=2157,[19474]=2574,[12444]=1460,[19473]=2573,[19386]=2572,[4223]=327,[16166]=2091,[18376]=2430,[8541]=878,[19073]=2521,[25397]=3217,[4319]=335,[19283]=2556,[19281]=2554,[8733]=898,[12860]=1541,[21686]=2857,[4415]=342,[12956]=1554,[19277]=2550,[19275]=2548,[13052]=1566,[17975]=2375,[19273]=2546,[13148]=1579,[19185]=2545,[19184]=2544,[22390]=2941,[19175]=2535,[19083]=2531,[4623]=374,[19081]=2529,[7436]=726,[9341]=989,[19079]=2527,[19078]=2526,[4719]=382,[13564]=1661,[23094]=3016,[12043]=1395,[13660]=1674,[19075]=2523,[2917]=188,[13756]=1687,[19383]=2569,[6024]=542,[13852]=1699,[19575]=2588,[14263]=1776,[4927]=415,[18883]=2505,[12649]=1497,[9949]=1084,[18881]=2503,[2010]=104,[5023]=423,[18879]=2501,[10748]=1199,[10141]=1106,[14268]=1781,[18877]=2499,[5119]=431,[14364]=1794,[24694]=3162,[16568]=2158,[14460]=1806,[18875]=2497,[276109]=3375,[14556]=1819,[20983]=2770,[18473]=2440,[276110]=3376,[18784]=2492,[18780]=2488,[5327]=462,[17272]=2272,[16667]=2173,[10749]=1200,[18683]=2477,[276112]=3378,[5423]=469,[18681]=2475,[18477]=2444,[10941]=1222,[15068]=1911,[18679]=2473,[5519]=477,[15164]=1924,[18677]=2471,[18675]=2469,[15260]=1937,[22391]=2942,[18671]=2465,[5631]=501,[18483]=2450,[18481]=2448,[18479]=2446,[18680]=2474,[18475]=2442,[5727]=509,[18872]=2494,[18471]=2438,[11549]=1323,[18382]=2436,[18380]=2434,[5823]=517,[15772]=2031,[10237]=1116,[19384]=2570,[15868]=2044,[13049]=1563,[19576]=2589,[15964]=2056,[4315]=331,[14059]=1739,[16060]=2069,[23991]=3099,[5721]=503,[6031]=549,[18281]=2422,[18279]=2420,[12157]=1425,[20280]=2682,[18277]=2418,[12253]=1437,[18275]=2416,[18274]=2415,[12349]=1449,[16569]=2159,[18273]=2414,[12445]=1461,[18271]=2412,[18270]=2411,[20984]=2771,[246100]=3168,[3113]=203,[8542]=879,[14663]=1842,[25399]=3219,[8638]=889,[13861]=1708,[15465]=1975,[8734]=899,[12861]=1542,[21688]=2859,[3716]=266,[12957]=1555,[2914]=185,[16675]=2181,[13053]=1567,[17977]=2377,[17075]=2244,[13149]=1580,[18169]=2397,[275107]=3369,[6623]=614,[18081]=2395,[18079]=2393,[9246]=980,[18077]=2391,[18075]=2389,[9342]=990,[6735]=638,[18073]=2387,[9438]=1000,[13565]=1662,[275110]=3372,[9534]=1011,[13661]=1675,[23288]=3030,[275111]=3373,[13757]=1688,[19385]=2571,[17980]=2380,[13853]=1700,[19577]=2590,[17576]=2320,[17976]=2376,[17881]=2367,[17879]=2365,[9950]=1085,[17877]=2363,[17875]=2361,[10046]=1096,[17873]=2359,[17871]=2357,[10142]=1107,[7135]=687,[17869]=2355,[10238]=1117,[14365]=1795,[24696]=3164,[16570]=2160,[7231]=696,[17681]=2339,[17679]=2337,[14557]=1820,[20985]=2772,[17675]=2333,[7327]=704,[17673]=2331,[5025]=425,[17671]=2329,[17274]=2274,[10547]=1168,[10750]=1201,[17466]=2296,[17669]=2327,[10846]=1212,[5322]=457,[17667]=2325,[10942]=1223,[15069]=1912,[17580]=2324,[17978]=2378,[15165]=1925,[17569]=2313,[18170]=2398,[15261]=1938,[22393]=2944,[17478]=2308,[15357]=1950,[22585]=2957,[5226]=449,[7727]=756,[18682]=2476,[13257]=1605,[11454]=1312,[18874]=2496,[13259]=1607,[11550]=1324,[7839]=781,[17471]=2301,[11646]=1335,[15773]=2032,[17470]=2300,[11742]=1347,[7935]=790,[17469]=2299,[19578]=2591,[15965]=2057,[17467]=2297,[17380]=2295,[8031]=800,[23993]=3101,[17378]=2293,[17376]=2291,[17372]=2287,[17371]=2286,[12158]=1426,[20282]=2684,[17279]=2279,[12254]=1438,[274108]=3365,[17277]=2277,[12350]=1450,[16571]=2161,[274109]=3366,[12446]=1462,[16763]=2185,[17275]=2275,[2112]=114,[17273]=2273,[17271]=2271,[8543]=880,[274111]=3368,[17267]=2267,[8639]=890,[17265]=2265,[17180]=2264,[8735]=900,[12862]=1543,[21690]=2861,[4416]=343,[12958]=1556,[21882]=2877,[17172]=2256,[13054]=1568,[17979]=2379,[17077]=2246,[13150]=1581,[18171]=2399,[17073]=2242,[17071]=2240,[17069]=2238,[17067]=2236,[2312]=131,[17065]=2234,[16978]=2231,[9343]=991,[2811]=173,[11243]=1270,[9439]=1001,[14258]=1771,[12245]=1429,[9535]=1012,[13662]=1676,[23290]=3032,[4816]=391,[13758]=1689,[14459]=1805,[16877]=2215,[13854]=1701,[19579]=2592,[16873]=2211,[13950]=1714,[16871]=2209,[16870]=2208,[23994]=3102,[16867]=2205,[16866]=2204,[2512]=148,[16865]=2203,[16863]=2201,[10143]=1108,[16778]=2200,[11241]=1268,[10239]=1118,[14366]=1796,[24698]=3166,[16572]=2162,[14462]=1808,[13253]=1601,[16764]=2186,[2616]=160,[20987]=2774,[3314]=223,[14654]=1833,[16772]=2194,[14558]=1821,[5328]=463,[17276]=2276,[245101]=3161,[10751]=1202,[17468]=2298,[4724]=387,[2712]=165,[15871]=2047,[16365]=2123,[10943]=1224,[15070]=1913,[16678]=2184,[5520]=478,[15166]=1926,[273107]=3359,[18172]=2400,[15262]=1939,[16674]=2180,[273108]=3360,[2816]=178,[22587]=2959,[16670]=2176,[273109]=3361,[18684]=2478,[16665]=2171,[11455]=1313,[18876]=2498,[16662]=2168,[11551]=1325,[6432]=599,[273111]=3363,[2912]=183,[15774]=2033,[6831]=646,[11743]=1348,[15870]=2046,[7233]=698,[19580]=2593,[15966]=2058,[16477]=2151,[16475]=2149,[16062]=2071,[23995]=3103,[16471]=2145,[3016]=196,[16469]=2143,[16467]=2141,[12159]=1427,[20284]=2686,[16463]=2137,[12255]=1439,[16461]=2135,[16369]=2127,[12351]=1451,[16573]=2163,[16367]=2125,[12447]=1463,[16765]=2187,[16362]=2120,[20988]=2775,[16273]=2115,[16271]=2113,[8544]=881,[16269]=2111,[16267]=2109,[8640]=891,[16265]=2107,[16263]=2105,[8736]=901,[3216]=215,[21692]=2863,[8832]=910,[12959]=1557,[21884]=2879,[16176]=2101,[13055]=1569,[17981]=2381,[3615]=254,[13151]=1582,[18173]=2401,[16162]=2087,[3312]=221,[9247]=981,[16160]=2085,[22588]=2960,[16073]=2082,[16071]=2080,[9344]=992,[16069]=2078,[11647]=1336,[9440]=1002,[16067]=2076,[5826]=520,[9536]=1013,[3416]=235,[23292]=3034,[10039]=1089,[13759]=1690,[16063]=2072,[16061]=2070,[13855]=1702,[19581]=2594,[11657]=1346,[13951]=1715,[3215]=214,[272106]=3352,[7024]=664,[3520]=249,[14867]=1878,[10048]=1098,[4121]=314,[15265]=1942,[10144]=1109,[7136]=688,[14065]=1745,[10240]=1119,[14367]=1797,[272109]=3355,[16574]=2164,[14463]=1809,[6127]=558,[16766]=2188,[14559]=1822,[20989]=2776,[15869]=2045,[14655]=1834,[21181]=2791,[8436]=859,[15867]=2043,[17278]=2278,[6223]=566,[10752]=1203,[3720]=270,[10641]=1177,[10848]=1214,[14554]=1817,[4216]=320,[10944]=1225,[7536]=739,[4224]=328,[11040]=1236,[15167]=1927,[15865]=2041,[18174]=2402,[7632]=748,[6327]=582,[15863]=2039,[15359]=1952,[22589]=2961,[8637]=888,[7728]=757,[15861]=2037,[4423]=350,[11456]=1314,[18878]=2500,[6431]=598,[11552]=1326,[3920]=291,[15859]=2035,[11648]=1337,[12847]=1528,[6527]=606,[11744]=1349,[7936]=791,[5420]=466,[19582]=2595,[15967]=2059,[6631]=622,[19774]=2613,[8032]=801,[23997]=3105,[2915]=186,[6727]=630,[9843]=1064,[4720]=383,[5728]=510,[20286]=2688,[3816]=276,[12256]=1440,[20478]=2705,[4113]=306,[12352]=1452,[16575]=2165,[1710]=82,[12448]=1464,[16767]=2189,[4824]=399,[20990]=2777,[9637]=1028,[6927]=654,[21182]=2792,[15673]=2016,[4920]=408,[8641]=892,[4928]=416,[8837]=915,[8737]=902,[15671]=2014,[9849]=1070,[8833]=911,[12960]=1558,[21886]=2881,[7031]=671,[13056]=1570,[271107]=3348,[11645]=1334,[13152]=1583,[18175]=2403,[271108]=3349,[13248]=1596,[12853]=1534,[15665]=2008,[4625]=376,[7127]=679,[2410]=137,[9345]=993,[271110]=3351,[5120]=432,[9441]=1003,[15661]=2004,[3616]=255,[9537]=1014,[13664]=1678,[23294]=3036,[4817]=392,[13760]=1691,[5224]=447,[15659]=2002,[13856]=1703,[19583]=2596,[7335]=712,[13952]=1716,[19775]=2614,[5320]=455,[23998]=3106,[7431]=721,[12455]=1471,[10049]=1099,[5424]=470,[14257]=1770,[10145]=1110,[8439]=862,[7535]=738,[10241]=1120,[14368]=1798,[14661]=1840,[10337]=1130,[14464]=1810,[10847]=1213,[16768]=2190,[14560]=1823,[7631]=747,[3714]=264,[14656]=1835,[21183]=2793,[5223]=446,[5329]=464,[17280]=2280,[7735]=764,[10753]=1204,[17472]=2302,[15471]=1981,[10849]=1215,[3912]=283,[14657]=1836,[10945]=1226,[5824]=518,[5832]=526,[11041]=1237,[15168]=1928,[15467]=1977,[18176]=2404,[15264]=1941,[15463]=1973,[5928]=534,[15360]=1953,[22591]=2963,[12053]=1405,[15456]=1966,[4012]=294,[4016]=298,[5729]=511,[18880]=2502,[6025]=543,[11553]=1327,[19072]=2520,[6032]=550,[11649]=1338,[14265]=1778,[15457]=1967,[11745]=1350,[15872]=2048,[6128]=559,[5921]=527,[15968]=2060,[270106]=3342,[19776]=2615,[16064]=2073,[23999]=3107,[270107]=3343,[6033]=551,[24191]=3117,[9445]=1007,[270108]=3344,[20288]=2690,[10043]=1093,[12257]=1441,[20480]=2707,[6424]=591,[12353]=1453,[16577]=2167,[270110]=3346,[12449]=1465,[16769]=2191,[2213]=123,[12545]=1477,[14261]=1774,[84]=26,[21184]=2794,[4521]=360,[15271]=1948,[8642]=893,[6624]=615,[25599]=3234,[8738]=903,[6433]=600,[15269]=1946,[8834]=912,[12961]=1559,[21888]=2883,[4617]=368,[13057]=1571,[15267]=1944,[6728]=631,[13153]=1584,[18177]=2405,[15263]=1940,[6625]=616,[4721]=384,[6832]=647,[22592]=2964,[2813]=175,[4825]=400,[9346]=994,[15255]=1932,[6928]=655,[9442]=1004,[13459]=1640,[4921]=409,[9538]=1015,[6833]=648,[23296]=3038,[7032]=672,[13761]=1692,[23488]=3050,[6933]=660,[13857]=1704,[19585]=2598,[10045]=1095,[13953]=1717,[19777]=2616,[3415]=234,[7025]=665,[7128]=680,[15071]=1914,[10050]=1100,[5121]=433,[14667]=1846,[10146]=1111,[7137]=689,[15067]=1910,[10242]=1121,[7232]=697,[15065]=1908,[10338]=1131,[14465]=1811,[24896]=3179,[16770]=2192,[14561]=1824,[15063]=1906,[7328]=705,[7329]=706,[21185]=2795,[7432]=722,[15059]=1902,[5425]=471,[269105]=3335,[15057]=1900,[17474]=2304,[5521]=479,[10850]=1216,[3011]=191,[43]=9,[10946]=1227,[7537]=740,[5625]=495,[11042]=1238,[15169]=1929,[269108]=3338,[18178]=2406,[7633]=749,[1912]=98,[18370]=2424,[15361]=1954,[22593]=2965,[3210]=209,[7729]=758,[22785]=2977,[7840]=782,[12057]=1409,[18882]=2504,[5825]=519,[11554]=1328,[19074]=2522,[7928]=783,[11650]=1339,[14869]=1880,[5929]=535,[11746]=1351,[7937]=792,[11845]=1366,[11842]=1363,[15969]=2061,[8040]=809,[19778]=2617,[8033]=802,[2012]=106,[3414]=233,[16161]=2086,[24193]=3119,[14859]=1870,[8129]=811,[14855]=1866,[4122]=315,[12258]=1442,[20482]=2709,[4114]=307,[12354]=1454,[6225]=568,[10243]=1122,[12450]=1466,[16771]=2193,[4218]=322,[12546]=1478,[4219]=323,[9237]=971,[21186]=2796,[4314]=330,[4322]=338,[8643]=894,[3112]=202,[6425]=592,[8739]=904,[14958]=1885,[4418]=345,[8835]=913,[12962]=1560,[21890]=2885,[14665]=1844,[13058]=1572,[22082]=2900,[4514]=353,[13154]=1585,[18179]=2407,[2514]=150,[13250]=1598,[18371]=2425,[15358]=1951,[2313]=132,[4618]=369,[4626]=377,[9347]=995,[14659]=1838,[2110]=112,[9443]=1005,[6729]=632,[14051]=1731,[9539]=1016,[4722]=385,[13551]=1648,[9635]=1026,[13762]=1693,[23490]=3052,[3417]=236,[13858]=1705,[268106]=3330,[15758]=2017,[13954]=1718,[19779]=2618,[268107]=3331,[13655]=1669,[6330]=585,[6929]=656,[5026]=426,[8843]=921,[14469]=1815,[10147]=1112,[268109]=3333,[3517]=246,[5122]=434,[14467]=1813,[268110]=3334,[10339]=1132,[14466]=1812,[24898]=3181,[5218]=441,[14562]=1825,[14461]=1807,[16964]=2217,[14658]=1837,[21187]=2797,[73]=21,[14754]=1849,[3613]=252,[3617]=256,[14455]=1801,[17476]=2306,[14453]=1799,[2713]=166,[17668]=2326,[2815]=177,[10947]=1228,[3713]=263,[3717]=267,[11043]=1239,[15170]=1930,[5426]=472,[18180]=2408,[15266]=1943,[13651]=1665,[18372]=2426,[15362]=1955,[14267]=1780,[5522]=480,[15458]=1968,[22787]=2979,[3821]=281,[5730]=512,[18884]=2506,[5626]=496,[11555]=1329,[19076]=2524,[14259]=1772,[2913]=184,[13251]=1599,[5722]=504,[11747]=1352,[15874]=2050,[3913]=284,[11843]=1364,[15970]=2062,[9140]=960,[19780]=2619,[16066]=2075,[11445]=1303,[12047]=1399,[3017]=197,[24195]=3121,[5922]=528,[3317]=226,[14067]=1747,[5827]=521,[12259]=1443,[20484]=2711,[242100]=3135,[12355]=1455,[8633]=884,[6026]=544,[12451]=1467,[16773]=2195,[3213]=212,[12547]=1479,[16965]=2218,[14063]=1743,[6322]=577,[6130]=561,[267105]=3322,[8644]=895,[4123]=316,[5623]=493,[8740]=905,[3217]=216,[6226]=569,[8836]=914,[267107]=3324,[21892]=2887,[8932]=924,[13059]=1573,[22084]=2902,[4924]=412,[13155]=1586,[18181]=2409,[267109]=3326,[6626]=617,[18373]=2427,[10738]=1189,[267110]=3327,[6434]=601,[11453]=1311,[22788]=2980,[2214]=124,[2412]=139,[9444]=1006,[6530]=609,[14962]=1889,[9540]=1017,[6834]=649,[13863]=1710,[9636]=1027,[13763]=1694,[23492]=3054,[2310]=129,[6930]=657,[2314]=133,[13859]=1706,[13955]=1719,[19781]=2620,[13553]=1650,[7026]=666,[13851]=1698,[12855]=1536,[24196]=3122,[4923]=411,[13665]=1679,[10148]=1113,[13663]=1677,[7034]=674,[10244]=1123,[13659]=1673,[2510]=146,[10340]=1133,[7234]=699,[13657]=1671,[16774]=2196,[14563]=1826,[13653]=1667,[16966]=2219,[7330]=707,[21189]=2799,[13649]=1663,[14755]=1850,[21381]=2815,[2614]=158,[7426]=716,[3721]=271,[10843]=1209,[10852]=1218,[17670]=2328,[5323]=458,[10948]=1229,[7538]=741,[12247]=1431,[11044]=1240,[15171]=1931,[10739]=1190,[11140]=1251,[7634]=750,[12850]=1531,[18374]=2428,[15363]=1956,[2710]=163,[5427]=473,[7730]=759,[22789]=2981,[13463]=1644,[13461]=1642,[9837]=1058,[266104]=3315,[11556]=1330,[3921]=292,[2810]=172,[11652]=1341,[2814]=176,[13451]=1632,[11748]=1353,[7938]=793,[13362]=1626,[11844]=1365,[15971]=2063,[266107]=3318,[19782]=2621,[8034]=803,[9437]=999,[266108]=3319,[16163]=2088,[24197]=3123,[8443]=866,[8130]=812,[10443]=1150,[9844]=1065,[13255]=1603,[20486]=2713,[8229]=825,[12356]=1456,[20678]=2729,[3014]=194,[12452]=1468,[16775]=2197,[12147]=1415,[12548]=1480,[16967]=2220,[13249]=1597,[21190]=2800,[13247]=1595,[175]=77,[4323]=339,[11255]=1282,[13063]=1577,[8741]=906,[10548]=1169,[6323]=578,[4419]=346,[6331]=586,[13061]=1575,[8933]=925,[13060]=1574,[22086]=2904,[4515]=354,[13156]=1587,[4420]=347,[8231]=827,[13252]=1600,[18375]=2429,[10451]=1158,[13348]=1612,[13047]=1561,[3013]=193,[22790]=2982,[11252]=1279,[4620]=371,[4723]=386,[12859]=1540,[4718]=381,[9541]=1018,[8239]=835,[12857]=1538,[4819]=394,[13764]=1695,[23494]=3056,[4820]=395,[13860]=1707,[4828]=403,[9045]=951,[13956]=1720,[19783]=2622,[10247]=1126,[14052]=1732,[19975]=2640,[12459]=1475,[5027]=427,[12659]=1507,[12651]=1499,[10149]=1114,[2911]=182,[241100]=3126,[10245]=1124,[12647]=1495,[5220]=443,[10341]=1134,[14468]=1814,[11051]=1247,[5219]=442,[14564]=1827,[5324]=459,[16968]=2221,[14660]=1839,[21191]=2801,[12457]=1473,[14756]=1851,[21383]=2817,[265106]=3310,[13364]=1628,[17480]=2310,[15155]=1915,[10853]=1219,[17672]=2330,[5622]=492,[10949]=1230,[265108]=3312,[12249]=1433,[5523]=481,[3914]=285,[265109]=3313,[11141]=1252,[15268]=1945,[11443]=1301,[5619]=489,[15364]=1957,[12055]=1407,[4014]=296,[15460]=1970,[22791]=2983,[4117]=310,[5731]=513,[9245]=979,[6228]=571,[2111]=113,[19080]=2528,[11853]=1374,[11653]=1342,[11851]=1372,[11849]=1370,[11749]=1354,[10841]=1207,[4421]=348,[5923]=529,[15972]=2064,[4621]=372,[19784]=2623,[16068]=2077,[11643]=1332,[19976]=2641,[16164]=2089,[24199]=3125,[11451]=1309,[16260]=2102,[7028]=668,[2511]=147,[6131]=562,[20488]=2715,[8230]=826,[12357]=1457,[20680]=2731,[11247]=1274,[12453]=1469,[16777]=2199,[5325]=460,[12549]=1481,[16969]=2222,[11053]=1249,[12645]=1493,[11049]=1245,[7628]=744,[21384]=2818,[9144]=964,[3315]=224,[8742]=907,[10851]=1217,[25799]=3249,[8838]=916,[4018]=300,[2715]=168,[8934]=926,[6531]=610,[22088]=2906,[10447]=1154,[13157]=1588,[3111]=201,[4318]=334,[6627]=618,[18377]=2431,[4422]=349,[13349]=1613,[264103]=3301,[10037]=1087,[6723]=626,[3411]=230,[264104]=3302,[9446]=1008,[9835]=1056,[3511]=240,[9542]=1019,[6835]=650,[9645]=1036,[9638]=1029,[13765]=1696,[23496]=3058,[262101]=3286,[6931]=658,[264107]=3305,[3819]=279,[13957]=1721,[19785]=2624,[264108]=3306,[7027]=667,[19977]=2642,[6030]=548,[288]=170,[6230]=573,[3516]=245,[10150]=1115,[4019]=301,[8441]=864}
Isotopes.indexZ = {{1}
,{2,3,4,7,10,14,19}
,{5,8,11,15,20,24,29,34}
,{6,9,12,16,21,25,30,35,40,45,51}
,{13,17,22,26,31,36,41,46,52,57,63,70}
,{18,23,27,32,37,42,47,53,58,64,71,77,84,91,99,107}
,{28,33,38,43,48,54,59,65,72,78,85,92,100,108,116,125}
,{39,44,49,55,60,66,73,79,86,93,101,109,117,126,134,143}
,{50,56,61,67,74,80,87,94,102,110,118,127,135,144,152,161,170}
,{62,68,75,81,88,95,103,111,119,128,136,145,153,162,171,180,189,199}
,{69,76,82,89,96,104,112,120,129,137,146,154,163,172,181,190,200,209,219,229}
,{83,90,97,105,113,121,130,138,147,155,164,173,182,191,201,210,220,230,240,250,261}
,{98,106,114,122,131,139,148,156,165,174,183,192,202,211,221,231,241,251,262,272,283,294}
,{115,123,132,140,149,157,166,175,184,193,203,212,222,232,242,252,263,273,284,295,306,317,329}
,{124,133,141,150,158,167,176,185,194,204,213,223,233,243,253,264,274,285,296,307,318,330,341,353}
,{142,151,159,168,177,186,195,205,214,224,234,244,254,265,275,286,297,308,319,331,342,354,366,378}
,{160,169,178,187,196,206,215,225,235,245,255,266,276,287,298,309,320,332,343,355,367,379,391,404}
,{179,188,197,207,216,226,236,246,256,267,277,288,299,310,321,333,344,356,368,380,392,405,417,429}
,{198,208,217,227,237,247,257,268,278,289,300,311,322,334,345,357,369,381,393,406,418,430,441,453}
,{218,228,238,248,258,269,279,290,301,312,323,335,346,358,370,382,394,407,419,431,442,454,465,477,489}
,{239,249,259,270,280,291,302,313,324,336,347,359,371,383,395,408,420,432,443,455,466,478,490,502,514}
,{260,271,281,292,303,314,325,337,348,360,372,384,396,409,421,433,444,456,467,479,491,503,515,527,539,552}
,{282,293,304,315,326,338,349,361,373,385,397,410,422,434,445,457,468,480,492,504,516,528,540,553,565,577,589}
,{305,316,327,339,350,362,374,386,398,411,423,435,446,458,469,481,493,505,517,529,541,554,566,578,590,602,614,626}
,{328,340,351,363,375,387,399,412,424,436,447,459,470,482,494,506,518,530,542,555,567,579,591,603,615,627,639,651,664}
,{352,364,376,388,400,413,425,437,448,460,471,483,495,507,519,531,543,556,568,580,592,604,616,628,640,652,665,677,690}
,{365,377,389,401,414,426,438,449,461,472,484,496,508,520,532,544,557,569,581,593,605,617,629,641,653,666,678,691,703,716,729}
,{390,402,415,427,439,450,462,473,485,497,509,521,533,545,558,570,582,594,606,618,630,642,654,667,679,692,704,717,730,743,756}
,{403,416,428,440,451,463,474,486,498,510,522,534,546,559,571,583,595,607,619,631,643,655,668,680,693,705,718,731,744,757,770,783,797}
,{452,464,475,487,499,511,523,535,547,560,572,584,596,608,620,632,644,656,669,681,694,706,719,732,745,758,771,784,798,811,825}
,{476,488,500,512,524,536,548,561,573,585,597,609,621,633,645,657,670,682,695,707,720,733,746,759,772,785,799,812,826,839,853,867}
,{501,513,525,537,549,562,574,586,598,610,622,634,646,658,671,683,696,708,721,734,747,760,773,786,800,813,827,840,854,868,882,896}
,{526,538,550,563,575,587,599,611,623,635,647,659,672,684,697,709,722,735,748,761,774,787,801,814,828,841,855,869,883,897,910,924,938}
,{551,564,576,588,600,612,624,636,648,660,673,685,698,710,723,736,749,762,775,788,802,815,829,842,856,870,884,898,911,925,939,953,967}
,{601,613,625,637,649,661,674,686,699,711,724,737,750,763,776,789,803,816,830,843,857,871,885,899,912,926,940,954,968,982,996,1011}
,{638,650,662,675,687,700,712,725,738,751,764,777,790,804,817,831,844,858,872,886,900,913,927,941,955,969,983,997,1012,1026,1041,1056}
,{663,676,688,701,713,726,739,752,765,778,791,805,818,832,845,859,873,887,901,914,928,942,956,970,984,998,1013,1027,1042,1057,1071,1086,1101}
,{689,702,714,727,740,753,766,779,792,806,819,833,846,860,874,888,902,915,929,943,957,971,985,999,1014,1028,1043,1058,1072,1087,1102,1116,1130}
,{715,728,741,754,767,780,793,807,820,834,847,861,875,889,903,916,930,944,958,972,986,1000,1015,1029,1044,1059,1073,1088,1103,1117,1131,1145,1159,1174,1189}
,{742,755,768,781,794,808,821,835,848,862,876,890,904,917,931,945,959,973,987,1001,1016,1030,1045,1060,1074,1089,1104,1118,1132,1146,1160,1175,1190,1205,1220}
,{769,782,795,809,822,836,849,863,877,891,905,918,932,946,960,974,988,1002,1017,1031,1046,1061,1075,1090,1105,1119,1133,1147,1161,1176,1191,1206,1221,1236,1251,1267}
,{796,810,823,837,850,864,878,892,906,919,933,947,961,975,989,1003,1018,1032,1047,1062,1076,1091,1106,1120,1134,1148,1162,1177,1192,1207,1222,1237,1252,1268,1283,1299,1315}
,{824,838,851,865,879,893,907,920,934,948,962,976,990,1004,1019,1033,1048,1063,1077,1092,1107,1121,1135,1149,1163,1178,1193,1208,1223,1238,1253,1269,1284,1300,1316,1331,1347,1363}
,{852,866,880,894,908,921,935,949,963,977,991,1005,1020,1034,1049,1064,1078,1093,1108,1122,1136,1150,1164,1179,1194,1209,1224,1239,1254,1270,1285,1301,1317,1332,1348,1364,1379,1395,1411}
,{881,895,909,922,936,950,964,978,992,1006,1021,1035,1050,1065,1079,1094,1109,1123,1137,1151,1165,1180,1195,1210,1225,1240,1255,1271,1286,1302,1318,1333,1349,1365,1380,1396,1412,1428,1444,1460}
,{923,937,951,965,979,993,1007,1022,1036,1051,1066,1080,1095,1110,1124,1138,1152,1166,1181,1196,1211,1226,1241,1256,1272,1287,1303,1319,1334,1350,1366,1381,1397,1413,1429,1445,1461,1477,1493,1510}
,{952,966,980,994,1008,1023,1037,1052,1067,1081,1096,1111,1125,1139,1153,1167,1182,1197,1212,1227,1242,1257,1273,1288,1304,1320,1335,1351,1367,1382,1398,1414,1430,1446,1462,1478,1494,1511,1527,1544}
,{981,995,1009,1024,1038,1053,1068,1082,1097,1112,1126,1140,1154,1168,1183,1198,1213,1228,1243,1258,1274,1289,1305,1321,1336,1352,1368,1383,1399,1415,1431,1447,1463,1479,1495,1512,1528,1545,1561,1578,1595}
,{1010,1025,1039,1054,1069,1083,1098,1113,1127,1141,1155,1169,1184,1199,1214,1229,1244,1259,1275,1290,1306,1322,1337,1353,1369,1384,1400,1416,1432,1448,1464,1480,1496,1513,1529,1546,1562,1579,1596,1612,1629}
,{1040,1055,1070,1084,1099,1114,1128,1142,1156,1170,1185,1200,1215,1230,1245,1260,1276,1291,1307,1323,1338,1354,1370,1385,1401,1417,1433,1449,1465,1481,1497,1514,1530,1547,1563,1580,1597,1613,1630,1646,1663,1680}
,{1085,1100,1115,1129,1143,1157,1171,1186,1201,1216,1231,1246,1261,1277,1292,1308,1324,1339,1355,1371,1386,1402,1418,1434,1450,1466,1482,1498,1515,1531,1548,1564,1581,1598,1614,1631,1647,1664,1681,1697,1714}
,{1144,1158,1172,1187,1202,1217,1232,1247,1262,1278,1293,1309,1325,1340,1356,1372,1387,1403,1419,1435,1451,1467,1483,1499,1516,1532,1549,1565,1582,1599,1615,1632,1648,1665,1682,1698,1715,1731,1748}
,{1173,1188,1203,1218,1233,1248,1263,1279,1294,1310,1326,1341,1357,1373,1388,1404,1420,1436,1452,1468,1484,1500,1517,1533,1550,1566,1583,1600,1616,1633,1649,1666,1683,1699,1716,1732,1749,1765,1782}
,{1204,1219,1234,1249,1264,1280,1295,1311,1327,1342,1358,1374,1389,1405,1421,1437,1453,1469,1485,1501,1518,1534,1551,1567,1584,1601,1617,1634,1650,1667,1684,1700,1717,1733,1750,1766,1783,1799,1816}
,{1235,1250,1265,1281,1296,1312,1328,1343,1359,1375,1390,1406,1422,1438,1454,1470,1486,1502,1519,1535,1552,1568,1585,1602,1618,1635,1651,1668,1685,1701,1718,1734,1751,1767,1784,1800,1817,1833,1849,1865}
,{1266,1282,1297,1313,1329,1344,1360,1376,1391,1407,1423,1439,1455,1471,1487,1503,1520,1536,1553,1569,1586,1603,1619,1636,1652,1669,1686,1702,1719,1735,1752,1768,1785,1801,1818,1834,1850,1866,1882,1898,1915,1932}
,{1298,1314,1330,1345,1361,1377,1392,1408,1424,1440,1456,1472,1488,1504,1521,1537,1554,1570,1587,1604,1620,1637,1653,1670,1687,1703,1720,1736,1753,1769,1786,1802,1819,1835,1851,1867,1883,1899,1916,1933,1949,1966}
,{1346,1362,1378,1393,1409,1425,1441,1457,1473,1489,1505,1522,1538,1555,1571,1588,1605,1621,1638,1654,1671,1688,1704,1721,1737,1754,1770,1787,1803,1820,1836,1852,1868,1884,1900,1917,1934,1950,1967,1983,2000}
,{1394,1410,1426,1442,1458,1474,1490,1506,1523,1539,1556,1572,1589,1606,1622,1639,1655,1672,1689,1705,1722,1738,1755,1771,1788,1804,1821,1837,1853,1869,1885,1901,1918,1935,1951,1968,1984,2001,2017,2034}
,{1427,1443,1459,1475,1491,1507,1524,1540,1557,1573,1590,1607,1623,1640,1656,1673,1690,1706,1723,1739,1756,1772,1789,1805,1822,1838,1854,1870,1886,1902,1919,1936,1952,1969,1985,2002,2018,2035,2051,2068}
,{1476,1492,1508,1525,1541,1558,1574,1591,1608,1624,1641,1657,1674,1691,1707,1724,1740,1757,1773,1790,1806,1823,1839,1855,1871,1887,1903,1920,1937,1953,1970,1986,2003,2019,2036,2052,2069,2085,2102}
,{1509,1526,1542,1559,1575,1592,1609,1625,1642,1658,1675,1692,1708,1725,1741,1758,1774,1791,1807,1824,1840,1856,1872,1888,1904,1921,1938,1954,1971,1987,2004,2020,2037,2053,2070,2086,2103,2119,2135}
,{1543,1560,1576,1593,1610,1626,1643,1659,1676,1693,1709,1726,1742,1759,1775,1792,1808,1825,1841,1857,1873,1889,1905,1922,1939,1955,1972,1988,2005,2021,2038,2054,2071,2087,2104,2120,2136,2152,2168}
,{1577,1594,1611,1627,1644,1660,1677,1694,1710,1727,1743,1760,1776,1793,1809,1826,1842,1858,1874,1890,1906,1923,1940,1956,1973,1989,2006,2022,2039,2055,2072,2088,2105,2121,2137,2153,2169,2185,2201}
,{1628,1645,1661,1678,1695,1711,1728,1744,1761,1777,1794,1810,1827,1843,1859,1875,1891,1907,1924,1941,1957,1974,1990,2007,2023,2040,2056,2073,2089,2106,2122,2138,2154,2170,2186,2202,2217,2233}
,{1662,1679,1696,1712,1729,1745,1762,1778,1795,1811,1828,1844,1860,1876,1892,1908,1925,1942,1958,1975,1991,2008,2024,2041,2057,2074,2090,2107,2123,2139,2155,2171,2187,2203,2218,2234,2249,2265}
,{1713,1730,1746,1763,1779,1796,1812,1829,1845,1861,1877,1893,1909,1926,1943,1959,1976,1992,2009,2025,2042,2058,2075,2091,2108,2124,2140,2156,2172,2188,2204,2219,2235,2250,2266,2281,2296}
,{1747,1764,1780,1797,1813,1830,1846,1862,1878,1894,1910,1927,1944,1960,1977,1993,2010,2026,2043,2059,2076,2092,2109,2125,2141,2157,2173,2189,2205,2220,2236,2251,2267,2282,2297,2311,2325}
,{1781,1798,1814,1831,1847,1863,1879,1895,1911,1928,1945,1961,1978,1994,2011,2027,2044,2060,2077,2093,2110,2126,2142,2158,2174,2190,2206,2221,2237,2252,2268,2283,2298,2312,2326,2340,2354}
,{1815,1832,1848,1864,1880,1896,1912,1929,1946,1962,1979,1995,2012,2028,2045,2061,2078,2094,2111,2127,2143,2159,2175,2191,2207,2222,2238,2253,2269,2284,2299,2313,2327,2341,2355,2369,2383,2397}
,{1881,1897,1913,1930,1947,1963,1980,1996,2013,2029,2046,2062,2079,2095,2112,2128,2144,2160,2176,2192,2208,2223,2239,2254,2270,2285,2300,2314,2328,2342,2356,2370,2384,2398,2411,2424,2437,2451}
,{1914,1931,1948,1964,1981,1997,2014,2030,2047,2063,2080,2096,2113,2129,2145,2161,2177,2193,2209,2224,2240,2255,2271,2286,2301,2315,2329,2343,2357,2371,2385,2399,2412,2425,2438,2452,2465,2479,2493}
,{1965,1982,1998,2015,2031,2048,2064,2081,2097,2114,2130,2146,2162,2178,2194,2210,2225,2241,2256,2272,2287,2302,2316,2330,2344,2358,2372,2386,2400,2413,2426,2439,2453,2466,2480,2494,2507,2520}
,{1999,2016,2032,2049,2065,2082,2098,2115,2131,2147,2163,2179,2195,2211,2226,2242,2257,2273,2288,2303,2317,2331,2345,2359,2373,2387,2401,2414,2427,2440,2454,2467,2481,2495,2508,2521,2533,2546,2559,2573}
,{2033,2050,2066,2083,2099,2116,2132,2148,2164,2180,2196,2212,2227,2243,2258,2274,2289,2304,2318,2332,2346,2360,2374,2388,2402,2415,2428,2441,2455,2468,2482,2496,2509,2522,2534,2547,2560,2574,2587,2600,2613}
,{2067,2084,2100,2117,2133,2149,2165,2181,2197,2213,2228,2244,2259,2275,2290,2305,2319,2333,2347,2361,2375,2389,2403,2416,2429,2442,2456,2469,2483,2497,2510,2523,2535,2548,2561,2575,2588,2601,2614,2627,2640}
,{2101,2118,2134,2150,2166,2182,2198,2214,2229,2245,2260,2276,2291,2306,2320,2334,2348,2362,2376,2390,2404,2417,2430,2443,2457,2470,2484,2498,2511,2524,2536,2549,2562,2576,2589,2602,2615,2628,2641,2653,2665,2678,2691}
,{2151,2167,2183,2199,2215,2230,2246,2261,2277,2292,2307,2321,2335,2349,2363,2377,2391,2405,2418,2431,2444,2458,2471,2485,2499,2512,2525,2537,2550,2563,2577,2590,2603,2616,2629,2642,2654,2666,2679,2692,2704,2716}
,{2184,2200,2216,2231,2247,2262,2278,2293,2308,2322,2336,2350,2364,2378,2392,2406,2419,2432,2445,2459,2472,2486,2500,2513,2526,2538,2551,2564,2578,2591,2604,2617,2630,2643,2655,2667,2680,2693,2705,2717,2729,2741,2753}
,{2232,2248,2263,2279,2294,2309,2323,2337,2351,2365,2379,2393,2407,2420,2433,2446,2460,2473,2487,2501,2514,2527,2539,2552,2565,2579,2592,2605,2618,2631,2644,2656,2668,2681,2694,2706,2718,2730,2742,2754,2766,2778}
,{2264,2280,2295,2310,2324,2338,2352,2366,2380,2394,2408,2421,2434,2447,2461,2474,2488,2502,2515,2528,2540,2553,2566,2580,2593,2606,2619,2632,2645,2657,2669,2682,2695,2707,2719,2731,2743,2755,2767,2779,2790,2802,2814,2826,2838,2851}
,{2339,2353,2367,2381,2395,2409,2422,2435,2448,2462,2475,2489,2503,2516,2529,2541,2554,2567,2581,2594,2607,2620,2633,2646,2658,2670,2683,2696,2708,2720,2732,2744,2756,2768,2780,2791,2803,2815,2827,2839,2852,2864,2876}
,{2368,2382,2396,2410,2423,2436,2449,2463,2476,2490,2504,2517,2530,2542,2555,2568,2582,2595,2608,2621,2634,2647,2659,2671,2684,2697,2709,2721,2733,2745,2757,2769,2781,2792,2804,2816,2828,2840,2853,2865,2877,2888,2900}
,{2450,2464,2477,2491,2505,2518,2531,2543,2556,2569,2583,2596,2609,2622,2635,2648,2660,2672,2685,2698,2710,2722,2734,2746,2758,2770,2782,2793,2805,2817,2829,2841,2854,2866,2878,2889,2901,2912,2923,2934,2945}
,{2478,2492,2506,2519,2532,2544,2557,2570,2584,2597,2610,2623,2636,2649,2661,2673,2686,2699,2711,2723,2735,2747,2759,2771,2783,2794,2806,2818,2830,2842,2855,2867,2879,2890,2902,2913,2924,2935,2946,2956,2966,2976}
,{2545,2558,2571,2585,2598,2611,2624,2637,2650,2662,2674,2687,2700,2712,2724,2736,2748,2760,2772,2784,2795,2807,2819,2831,2843,2856,2868,2880,2891,2903,2914,2925,2936,2947,2957,2967,2977,2987,2997}
,{2572,2586,2599,2612,2625,2638,2651,2663,2675,2688,2701,2713,2725,2737,2749,2761,2773,2785,2796,2808,2820,2832,2844,2857,2869,2881,2892,2904,2915,2926,2937,2948,2958,2968,2978,2988,2998,3008,3018}
,{2626,2639,2652,2664,2676,2689,2702,2714,2726,2738,2750,2762,2774,2786,2797,2809,2821,2833,2845,2858,2870,2882,2893,2905,2916,2927,2938,2949,2959,2969,2979,2989,2999,3009,3019,3029,3039}
,{2677,2690,2703,2715,2727,2739,2751,2763,2775,2787,2798,2810,2822,2834,2846,2859,2871,2883,2894,2906,2917,2928,2939,2950,2960,2970,2980,2990,3000,3010,3020,3030,3040,3050,3060}
,{2728,2740,2752,2764,2776,2788,2799,2811,2823,2835,2847,2860,2872,2884,2895,2907,2918,2929,2940,2951,2961,2971,2981,2991,3001,3011,3021,3031,3041,3051,3061,3070,3079}
,{2765,2777,2789,2800,2812,2824,2836,2848,2861,2873,2885,2896,2908,2919,2930,2941,2952,2962,2972,2982,2992,3002,3012,3022,3032,3042,3052,3062,3071,3080,3089,3098}
,{2801,2813,2825,2837,2849,2862,2874,2886,2897,2909,2920,2931,2942,2953,2963,2973,2983,2993,3003,3013,3023,3033,3043,3053,3063,3072,3081,3090,3099,3108,3117}
,{2850,2863,2875,2887,2898,2910,2921,2932,2943,2954,2964,2974,2984,2994,3004,3014,3024,3034,3044,3054,3064,3073,3082,3091,3100,3109,3118,3127,3136}
,{2899,2911,2922,2933,2944,2955,2965,2975,2985,2995,3005,3015,3025,3035,3045,3055,3065,3074,3083,3092,3101,3110,3119,3128,3137,3145,3153}
,{2986,2996,3006,3016,3026,3036,3046,3056,3066,3075,3084,3093,3102,3111,3120,3129,3138,3146,3154,3162,3170}
,{3007,3017,3027,3037,3047,3057,3067,3076,3085,3094,3103,3112,3121,3130,3139,3147,3155,3163,3171,3178,3186}
,{3028,3038,3048,3058,3068,3077,3086,3095,3104,3113,3122,3131,3140,3148,3156,3164,3172,3179,3187,3194,3201,3209}
,{3049,3059,3069,3078,3087,3096,3105,3114,3123,3132,3141,3149,3157,3165,3173,3180,3188,3195,3202,3210,3217,3225}
,{3088,3097,3106,3115,3124,3133,3142,3150,3158,3166,3174,3181,3189,3196,3203,3211,3218,3226,3233,3241}
,{3107,3116,3125,3134,3143,3151,3159,3167,3175,3182,3190,3197,3204,3212,3219,3227,3234,3242,3249,3256}
,{3126,3135,3144,3152,3160,3168,3176,3183,3191,3198,3205,3213,3220,3228,3235,3243,3250,3257,3264,3271}
,{3161,3169,3177,3184,3192,3199,3206,3214,3221,3229,3236,3244,3251,3258,3265,3272,3279,3286}
,{3185,3193,3200,3207,3215,3222,3230,3237,3245,3252,3259,3266,3273,3280,3287,3293,3300}
,{3208,3216,3223,3231,3238,3246,3253,3260,3267,3274,3281,3288,3294,3301,3307,3314}
,{3224,3232,3239,3247,3254,3261,3268,3275,3282,3289,3295,3302,3308,3315,3321,3328}
,{3240,3248,3255,3262,3269,3276,3283,3290,3296,3303,3309,3316,3322,3329,3335,3341}
,{3263,3270,3277,3284,3291,3297,3304,3310,3317,3323,3330,3336,3342,3347,3352,3358}
,{3278,3285,3292,3298,3305,3311,3318,3324,3331,3337,3343,3348,3353,3359,3364,3369}
,{3299,3306,3312,3319,3325,3332,3338,3344,3349,3354,3360,3365,3370,3374,3379}
,{3313,3320,3326,3333,3339,3345,3350,3355,3361,3366,3371,3375,3380,3384,3389}
,{3327,3334,3340,3346,3351,3356,3362,3367,3372,3376,3381,3385,3390,3394,3398}
,{3357,3363,3368,3373,3377,3382,3386,3391,3395,3399,3402,3405}
,{3378,3383,3387,3392,3396,3400,3403,3406,3408,3411}
,{3388,3393,3397,3401,3404,3407,3409,3412,3414,3416}
,{3410,3413,3415,3417,3419,3421}
,{3418,3420,3422,3424,3426}
,{3423,3425,3427,3429,3431}
,{3428,3430,3432,3434}
,{3433,3435,3436}
}
Isotopes.data = {{1,0,8071.31713,0.00046,0,0,782.347,0,1.008664915,0.00049,0,613.9,"",0.6,"",0.5,1,"","",{"B-"},{0},{"="},{0},"","","","","","","","","","","","",0,0,"","","","","","","","","",""}
,{1,1,7288.97061,0.00009,0,0,"","",1.007825032,0.00009,1,"s","","s","",0.5,1,"","",{},{},{},{},"","","","","","","","","","","","","","",0,0,"","","","","","","",""}
,{2,1,13135.72176,0.00011,1112.283,0,"","",2.014101778,0.00012,1,"s","","s","",1,1,"","",{},{},{},{},"","","","","","","","","","","","",2224.57,0,2224.57,0,"","",23846.53,0,"","","",""}
,{3,1,14949.80993,0.00022,2827.265,0,18.592,0,3.016049281,0.00023,0,388781328.32,"",631138.52,"",0.5,1,"","",{"B-"},{0},{"="},{0},8481.79,0,"","","","",-13717,2000,"","","","",6257.23,0,"","","","",17589.3,0,19813.86,0,"",""}
,{3,2,14931.21793,0.00021,2572.68,0,-13736,2000,3.016029322,0.00022,1,"s","","s","",0.5,1,"","",{},{},{},{},"","",7718.04,0,"","","","","","","","","","",5493.47,0,"","",18353.05,0,"","",20577.62,0}
,{3,3,28667,2000,-2267,667,"","",3.030775,2147,"","","","","","","","","","","","","","","",-6800,2000,"","","","",8242,2000,"","","","","","","","","","","","","",""}
,{4,1,24621.127,100,1720.449,25,22196.211,100,4.026431868,107.354,0,1.39e-22,"",1e-23,"",2,-1,"","",{"n"},{0},{"="},{0},4657.23,100,"","","","",-702.06,234.52,"","",1618.59,100,-1600,100,"","","","","","",21413.86,100,"",""}
,{4,2,2424.91561,0.00006,7073.915,0,-22898.273,212.132,4.002603254,0.00006,1,"s","","s","",0,1,"","",{},{},{},{},"","","","",0,0,"","","","",-34313,2000,20577.62,0,19813.86,0,"","",0,0,0,0,0,0}
,{4,3,25323.189,212.132,1153.76,53.033,"","",4.027185562,227.733,0,9.1e-23,"",9e-24,"",2,-1,"","",{"p"},{0},{"="},{0},"","",2390.47,212.13,"","","","",3084.41,212.13,"","",11415,2011,-3103,212.13,"","","","","","",23680.62,212.13}
,{5,1,32892.444,89.443,1336.359,17.889,21661.211,91.652,5.035311493,96.02,0,9.1e-22,"","s","",0.5,1,"","",{"2n"},{0},{"="},{0},-1800,89.44,"","","","",21213.56,102.47,"","",22396.21,89.44,-200,134.16,"","","","","","","","","",""}
,{5,2,11231.233,20,5512.132,4,-447.654,53.852,5.012057224,21.47,0,7e-22,"",3e-23,"",1.5,-1,"","",{"n"},{0},{"="},{0},19842.62,20,"","",735,20,-25907,2003,"","",-22163.27,213.07,-735,20,20678.86,101.98,"","",6992.23,20,2959.57,20,"",""}
,{5,3,11678.886,50,5266.132,10,-25460,2003,5.0125378,53.677,0,3.7e-22,"",3e-23,"",1.5,-1,"","",{"p"},{0},{"="},{0},33131,2001,17848.86,50,1965,50,"","",-20231.21,111.8,"","",21715.62,217.94,-1965,50,"","",7458.47,50,"","",4189.57,50}
,{5,4,37139,2003,18,401,"","",5.03987,2150,0,"s","","s","",0.5,1,"","",{},{},{},{},"","",-7630,2003,"","","","",27425,2003,"","","","",-4527,2014,"","",19183,2830,"","","",""}
,{6,1,41875.721,254.127,961.639,42.354,24283.626,254.127,6.044955437,272.816,0,2.9e-22,"",7e-23,"",2,-1,"","",{},{},{},{},-1111.96,273.09,"","","","",27788.84,254.13,"","",22573.17,254.91,-911.96,269.41,"","",-5444,2019,"","","","","",""}
,{6,2,17592.095,0.053,4878.519,0.009,3505.216,0.053,6.018885891,0.057,0,0.80692,"",0.00024,"",0,1,"","",{"B-","B-d"},{0,0.000278,0},{"=","="},{0,0.000278,0},975.45,0.05,"","","","",-782.94,5.45,"","",-2158.11,50,1710.45,20,22589.32,89.44,"","",3681.77,100,7506.34,0.05,"",""}
,{6,3,14086.87895,0.00144,5332.331,0,-4288.154,5.448,6.015122887,0.00155,1,"s","","s","",1,1,"","",{},{},{},{},27378.94,212.13,25112.19,100,-1473.76,0,-33233,2003,-26094.54,89.44,-31123,2003,5663.32,50,4433.32,20,"","",22372.77,0,4019.72,0,4783.47,0}
,{6,4,18375.033,5.448,4487.247,0.908,-28945,2003,6.019726409,5.848,0,5e-21,"",3e-22,"",0,1,"","",{"2p"},{0},{"="},{0},"","",-1372.18,5.45,"","","","",-145.17,20.73,"","",26835,2003,592.82,50.3,"","",3762.65,212.2,-5428,2000,9090.22,5.45}
,{6,5,47320,2003,-467,334,"","",6.0508,2150,"","","","","","","","","","","","","","","",-7419,2014,"","","","",28352,2003,"","","","",-2892,2832,"","","","","","",24299,2830}
,{7,1,49135,1004,940,143,23062,1004,7.052749,1078,0,5e-22,"","s","",0.5,1,"","",{},{},{},{},-100,1000,"","","","",34228,1004,"","",23472,1004,812,1036,"","",21459,1004,"","","","","",""}
,{7,2,26073.126,7.559,4123.057,1.08,11166.021,7.559,7.027990654,8.115,0,2.51e-21,"",7e-23,"",0,0,"","",{"n"},{0},{"="},{0},1300.74,21.38,"","","","",10304.13,7.56,"","",3914.93,7.56,-409.71,7.56,23091.56,254.24,"","",3891.49,89.76,6316.05,100.29,"",""}
,{7,3,14907.10529,0.00423,5606.439,0.001,-861.893,0.071,7.016003436,0.00454,1,"s","","s","",1.5,-1,"","",{},{},{},{},12914.42,50,32563.28,89.44,-2467.62,0,-12769.44,25.15,-34257.59,254.13,-11539.24,5.45,7251.09,0,9973.96,0.05,"","",14386.68,20,17346.24,0,-4067.62,100}
,{7,4,15768.999,0.071,5371.548,0.01,-11907.551,25.15,7.016928717,0.076,0,4598208,"",5184,"",1.5,-1,"","",{"EC"},{0},{"="},{0},37512,2003,10040.18,20,-1587.13,0.07,"","",-9112.07,0.09,-39622,2003,10677.35,5.45,5606.85,0.07,"","",14800.92,50,-4690.13,212.13,18990.48,0.07}
,{7,5,27676.55,25.15,3558.705,3.593,"","",7.029712,27,0,5.7e-22,"",1.4e-23,"",1.5,-1,"","",{"p"},{0},{"="},{0},"","",-1419.72,55.97,-3415,2000,"","",6300.7,25.15,"","",27715,2003,-2012.55,25.73,"","",1249,2003,"","",7999.76,213.62}
,{8,2,31609.681,0.089,3924.52,0.011,10663.878,0.1,8.03393439,0.095,0,0.1191,"",0.0012,"",0,1,"","",{"B-","B-n","B-t"},{0,16,0,0.9,0},{"=","=","="},{0,16,0,0.9,0},2125.05,0.1,"","","","",26668.01,0.1,"","",8631.26,0.09,2534.76,7.56,24814,1004,-3454.59,18.24,444.77,254.13,3581.29,89.44,"",""}
,{8,3,20945.804,0.047,5159.712,0.006,16004.133,0.059,8.022486246,0.05,0,0.8394,"",0.00036,"",2,1,"","",{"B-","B-A"},{0,100,0},{"=","="},{0,100,0},9283.71,0.05,35507.86,254.13,-6100.24,100,-1975.76,1,-35478,1004,-2894.51,0.09,2032.62,0.05,12416.29,7.56,"","",14064.51,0.07,14578.63,20,-6300.24,89.44}
,{8,4,4941.671,0.035,7062.435,0.004,-17979.896,1,8.005305102,0.037,0,8.19e-17,"",3.7e-18,"",0,1,"","",{"A"},{0},{"="},{0},29576,5.45,27228.37,0.06,91.84,0.04,-30122.6,18.24,-28420.43,7.56,-30806.2,25.15,18898.64,0.08,17254.4,0.04,"","",1565.6,0.04,-1873.16,50,-643.16,20}
,{8,5,22921.567,1,4717.155,0.125,-12142.701,18.27,8.024607316,1.073,0,0.77,"",0.003,"",2,1,"","",{"B+","B+A"},{0,100,0},{"=","="},{0,100,0},40541,2003,5743.25,1,-4826.54,212.13,"","",725.49,1,"","",12826.3,25.17,136.4,1,"","",15257.34,5.54,-9353,2003,16889.08,50.01}
,{8,6,35064.268,18.243,3101.524,2.28,"","",8.037643042,19.584,0,3.5e-21,"",1.4e-21,"",0,1,"","",{"2p"},{0},{"="},{0},"","",-2111.29,19.04,"","","","",12006.3,18.24,"","","","",-98.75,31.07,"","",-1545,2003,"","",3572,2003}
,{9,2,40935.826,46.816,3349.037,5.202,15980.924,46.817,9.043946419,50.259,0,2.5e-21,"",2.3e-21,"",0,0,"","",{"n"},{0},{"="},{0},1279.93,47.42,"","","","",29587.37,46.82,"","",11918.7,46.82,-1254.83,46.82,"","",12024.85,46.87,2512,1005,3924.16,258.4,"",""}
,{9,3,24954.902,0.186,5037.768,0.021,13606.449,0.201,9.026790191,0.2,0,0.1783,"",0.0004,"",1.5,-1,"","",{"B-","B-n"},{0,50.8,0},{"=","="},{0,50.8,0},6094.84,0.19,38758,1004,-10362.46,89.44,12538.41,0.92,"","",11941.91,0.19,4062.22,0.19,13943.75,0.21,"","",9592.58,7.56,12226.86,0.19,-11274.42,254.13}
,{9,4,11348.453,0.077,6462.668,0.009,-1068.035,0.899,9.012183066,0.082,1,"s","","s","",1.5,-1,"","",{},{},{},{},20563.18,0.1,29302.61,7.56,-2307.7,20,-17562.52,2.14,-27550.2,0.12,-19644.43,1,1664.54,0.08,16886.32,0.09,"","",7152.15,0.08,2125.63,0.08,-597.24,0.09}
,{9,5,12416.488,0.903,6257.07,0.1,-16494.484,2.319,9.013329649,0.969,0,8e-19,"",3e-19,"",1.5,-1,"","",{"p"},{0},{"="},{0},31402.7,25.17,17068.56,0.9,-1687.31,50.01,"","",-15818.29,0.9,-30719.1,18.27,18576.4,1.35,-185.85,0.9,"","",7358.3,0.91,-1094.49,5.52,3976.01,0.9}
,{9,6,28910.972,2.137,4337.423,0.237,"","",9.031037207,2.293,0,0.1265,"",0.0009,"",1.5,-1,"","",{"B+","B+p","B+A"},{0,61.6,0,38.4,0},{"=","=","="},{0,61.6,0,38.4,0},"","",1435.97,2.14,-10653,2003,"","",16680.33,2.14,"","",14224.61,18.37,1299.57,2.36,"","",11945.23,25.24,-13545,2003,16182.34,5.85}
,{10,2,49197.143,92.848,2995.134,9.285,16144.519,93.715,10.052815308,99.676,0,3.1e-21,"",2e-21,"",0,1,"","",{"2n"},{0},{"="},{0},-1444.83,92.85,"","","","",36589.66,92.85,"","",16170.92,92.85,-190,103.98,"","",33498.47,92.85,"","",4926,1008,"",""}
,{10,3,33052.624,12.721,4531.351,1.272,20445.136,12.722,10.035483453,13.656,0,2e-21,"",5e-22,"",1,-1,"","",{"n"},{0},{"="},{0},4035.81,12.72,"","",-11248.01,254.45,21002.01,12.72,"","",13632.85,12.72,-26.4,12.72,15172.17,48.51,-5747.4,400.2,12153.75,12.72,11843.55,14.8,-10436,1004}
,{10,4,12607.488,0.081,6497.63,0.008,556.878,0.082,10.013534695,0.086,0,47650958260000,"",1262277040000,"",0,1,"","",{"B-"},{0},{"="},{0},8476.82,0.09,33580.13,0.12,-7409.52,0.1,-3091.18,0.11,-35617.31,46.82,-7880.32,0.9,6812.28,0.05,19636.39,0.2,"","",2372.49,0.09,2564.44,0.08,-7819.24,7.56}
,{10,5,12050.609,0.015,6475.083,0.002,-3648.062,0.069,10.012936862,0.016,1,"s","","s","",3,1,"","",{},{},{},{},27013.59,1,23473.14,0.05,-4461.19,0.01,-26749.42,400,-20193.26,0.19,-24931.68,2.14,8437.2,0.9,6586.81,0.08,"","",17819.74,0.04,1145.67,0.07,2789.91,0.02}
,{10,6,15698.672,0.07,6032.042,0.007,-23101.355,400,10.016853218,0.075,0,19.3009,"",0.0017,"",0,1,"","",{"B+"},{0},{"="},{0},35508.23,18.24,3820.94,0.08,-5101.28,5.45,"","",-2938.75,0.1,"","",21283.62,2.14,4006.79,0.91,"","",3487.91,1,-7113.82,25.15,5576.07,0.1}
,{10,7,38800.026,400,3643.672,40,"","",10.041653543,429.417,0,2e-22,"",1.4e-22,"",2,-1,"","",{},{},{},{},"","",-1300.52,400,-10945,2042,"","",19094.57,400,"","","","",-2600.08,400.01,"","",14446.56,400.42,"","",16769.88,400.79}
,{11,3,40728.254,0.615,4155.381,0.056,20551.087,0.659,11.043723581,0.66,0,0.00875,"",0.00014,"",1.5,-1,"","",{"B-","B-n","B-2n","B-3n","B-A","B-d","B-t"},{0,86.3,0,4.1,0,1.9,0,1.7,0,0.013,0,0.0093,0},{"=","=","=","=","=","=","="},{0,86.3,0,4.1,0,1.9,0,1.7,0,0.013,0,0.0093,0},369.28,0.64,"","",-10832,1004,32060.55,0.61,"","",20049.45,0.62,395.69,12.74,15757.86,92.85,16424.69,46.16,10503.23,46.82,13982.63,0.62,"",""}
,{11,4,20177.167,0.238,5952.54,0.022,11509.46,0.238,11.021661081,0.255,0,13.76,"",0.07,"",0.5,1,"","",{"B-","B-A","B-p"},{0,2.9,0,0.00083,0},{"=","=","="},{0,2.9,0,0.00083,0},7313.92,0.25,35336.6,46.82,-8320.87,7.56,9527.77,0.25,-36308.95,92.85,55.24,0.24,501.64,0.25,20164.43,12.72,"","",5933.07,0.3,4095.42,0.24,-5786.11,0.25}
,{11,5,8667.707,0.012,6927.732,0.001,-1981.689,0.061,11.009305166,0.013,1,"s","","s","",1.5,-1,"","",{},{},{},{},19891.42,0.9,30865.14,0.19,-8664.31,0.01,-15635.85,46.15,-31673.89,12.72,-15102.28,0.07,11454.22,0.02,11228.75,0.08,"","",8030.06,0.08,8590.09,0.04,-6631.7,0.05}
,{11,6,10649.396,0.06,6676.456,0.005,-13654.163,46.154,11.011432597,0.064,0,1221.84,"",0.84,"",1.5,-1,"","",{"B+"},{0},{"="},{0},34404.21,2.14,15277,0.1,-7544.52,0.09,"","",-9247.06,0.1,-36221.95,400,13120.59,0.09,8690.18,0.06,"","",8943.71,0.9,-7408.12,1,11354.13,0.07}
,{11,7,24303.559,46.154,5364.046,4.196,"","",11.026090945,49.548,0,5.5e-22,"",2e-23,"",0.5,1,"","",{"p"},{0},{"="},{0},"","",2690.87,46.16,-5797.91,52.56,"","",4963.98,46.15,"","",22567.78,402.65,-1315.92,46.15,"","",6103.39,46.2,-5896.65,49.63,7028.39,46.16}
,{12,3,49009.571,30.006,3791.6,2.501,23931.812,30.067,12.052613941,32.213,0,1e-08,"","s","",0,0,"","",{},{},{},{},185.69,32.59,"","","","",35640.17,30.04,"","",20761.09,30.01,-210,30,"","",31671.5,30.02,10523.23,97.58,12937.8,55.61,"",""}
,{12,4,25077.76,1.909,5720.722,0.159,11708.363,2.321,12.026922083,2.048,0,0.0215,"",4e-05,"",0,1,"","",{"B-","B-n"},{0,0.5,0},{"=","="},{0,0.5,0},3672.36,1.91,38697.32,92.87,-8956.84,1.91,25077.76,1.91,"","",8338.74,1.91,3170.72,1.92,22939.47,2.01,-6836.85,24.08,2735.94,12.86,4986.91,1.92,-10211.66,46.86}
,{12,5,13369.397,1.321,6631.223,0.11,13369.397,1.321,12.014352638,1.418,0,0.0202,"",2e-05,"",1,1,"","",{"B-","B-A"},{0,1.6,0},{"=","="},{0,1.6,0},14823.85,1.32,34261.17,12.79,-10001.32,1.32,-3968.67,1.66,-34647.83,1.46,-5351.32,1.32,3369.63,1.32,14096.74,1.34,"","",11472.71,1.32,6885,1.32,-5939.1,1.33}
,{12,6,0,0,7680.144,0,-17338.068,1,12,0,1,"s","","s","",0,1,"","",{},{},{},{},31841.31,0.07,27185.43,0.08,-7366.59,0.04,-31914.61,24,-27466.14,0.24,-32374.88,46.15,18720.71,0.06,15956.68,0.01,"","",-1339.8,0.01,-7552.43,0.9,-5702.05,0.08}
,{12,7,17338.068,1,6170.109,0.083,-14576.544,24.021,12.018613182,1.073,0,0.011,"",1.6e-05,"",1,1,"","",{"B+","B+A"},{0,3.5,0},{"=","="},{0,3.5,0},37604.59,400,9290.48,1,-8008.41,1.41,"","",1381.39,1,"","",15036.81,46.16,600.3,1,"","",12350.2,1,-6708.85,2.36,10567.98,1.35}
,{12,8,31914.613,24,4890.202,2,"","",12.034261747,25.765,0,6.3e-21,"","s","",0,1,"","",{"2p"},{""},{"="},{""},"","",-1638,24,-5574.57,30.15,"","",13976.25,24,"","","","",-322.08,52.02,"","",3825.39,400.72,"","",8650.04,24.1}
,{13,3,56980.888,70.003,3507.63,5.385,23321.812,70.739,13.061171503,75.15,0,3.3e-21,"",1.2e-21,"",1.5,-1,"","",{"2n"},{0},{"="},{0},-110,70,"","","","",40418.94,70.01,"","",23831.81,70.03,100,76.16,"","",51635.41,70,"","",12647.8,116.28,"",""}
,{13,4,33659.077,10.18,5241.435,0.783,17097.13,10.23,13.036134507,10.929,0,1e-21,"",7e-22,"",0.5,-1,"","",{},{},{},{},2660.72,10.18,"","",-9701.66,47.91,30534.07,10.18,"","",12218.36,10.27,-510,10,22639.47,31.69,10543.64,13.94,3641.63,10.2,5470.51,16.29,-9891.67,93.4}
,{13,5,16561.947,1,6496.419,0.077,13436.938,1,13.017779981,1.073,0,0.01733,"",0.00017,"",1.5,-1,"","",{"B-","B-n"},{0,0.28,0},{"=","="},{0,0.28,0},8248.39,1,38744.25,1.17,-10817.87,1.02,11216.47,1.04,-39736.6,30.02,8490.63,1,4878.77,1.66,15804.78,2.15,"","",7095.59,1.03,8818.51,1,-10844.28,12.76}
,{13,6,3125.00888,0.00021,7469.849,0,-2220.472,0.27,13.003354835,0.00023,1,"s","","s","",0.5,-1,"","",{},{},{},{},23667.02,0.06,31630.1,0.24,-10648.36,0.08,-19990.42,9.53,-29241.72,1.91,-22284.38,1,4946.31,0,17533.36,1.32,"","",5168.11,0.01,-4061.55,0.01,-3836.08,0.08}
,{13,7,5345.481,0.27,7238.863,0.021,-17769.951,9.53,13.005738609,0.289,0,597.9,"",0.24,"",0.5,-1,"","",{"B+"},{0},{"="},{0},35100.71,46.15,17900.17,0.27,-9495.92,0.94,"","",-15312.89,1.35,-34640.45,24,20063.9,1.04,1943.49,0.27,"","",5406.89,0.28,-5489.14,0.28,-1058.73,0.27}
,{13,8,23115.432,9.526,5811.763,0.733,"","",13.024815437,10.226,0,0.00858,"",5e-05,"",1.5,-1,"","",{"B+","B+p"},{0,10.9,0},{"=","="},{0,10.9,0},"","",2111.91,9.53,-8220.46,9.76,"","",15826.46,9.53,"","",16870.5,25.82,1511.61,9.58,"","",9522.68,47.13,-10820.54,400.11,13063.16,9.53}
,{14,4,39954.498,132.245,4993.897,9.446,16290.813,133.936,14.04289292,141.97,0,0.00435,"",0.00017,"",0,1,"","",{"B-","B-n","B-2n","B-3n","B-t","B-A"},{0,98,0,0.8,0,0.2,0,0.02,0,0.004,0},{"=","=","=","=","=","<"},{0,98,0,0.8,0,0.2,0,0.02,0,0.004,0},1265.9,132.26,"","",-11667.56,161.58,36934.61,132.25,"","",15321.23,132.25,1775.9,132.64,24315.36,149.63,31946.72,132.25,1655.73,135.61,4090.3,132.25,"",""}
,{14,5,23663.685,21.213,6101.644,1.515,20643.792,21.213,14.025404012,22.773,0,0.0125,"",0.0005,"",2,-1,"","",{"B-","B-n"},{0,6.04,0},{"=","="},{0,6.04,0},5848.35,21.25,39923.83,36.75,-11813.85,24.74,20800.27,21.21,-40606.17,73.15,12467.36,21.21,969.58,21.24,17284.36,23.53,-8300.72,46.27,9296.73,21.3,8350.57,21.21,-11418.17,21.22}
,{14,6,3019.89278,0.00376,7520.319,0,156.476,0.004,14.003241988,0.00403,0,179874478200,"",946707780,"",0,1,"","",{"B-"},{0},{"="},{0},13122.74,0,36635.81,1.91,-12012.51,0.08,-4987.89,0.03,-37928.15,10.18,-10396.91,0.27,8176.43,0,20831.02,1,"","",361.3,1.32,-783.76,0.01,-11510.87,0.24}
,{14,7,2863.41672,0.00019,7475.614,0,-5144.364,0.025,14.003074004,0.00021,1,"s","","s","",1,1,"","",{},{},{},{},30617.29,1,25083.92,1.32,-11612.11,0.01,-29100.99,41.12,-20987.5,1,-28323.33,9.53,10553.38,0.27,7550.56,0,"","",13574.22,0,-2921.92,0.06,-157.89,0.01}
,{14,8,8007.781,0.025,7052.278,0.002,-23956.622,41.119,14.008596706,0.027,0,70.62,"",0.013,"",0,1,"","",{"B+"},{0},{"="},{0},40049.47,24,6570.16,0.03,-10115.81,0.07,"","",-2406.2,0.03,"","",23178.97,9.53,4626.67,0.27,"","",1380.52,1,-11431.72,46.15,3004.79,0.06}
,{14,9,31964.402,41.119,5285.208,2.937,"","",14.034315199,44.142,0,5e-22,"",6e-23,"",2,-1,"","",{},{},{},{},"","",-48.39,41.13,-9260.54,402.11,"","",19329.95,41.12,"","","","",-1560,40,"","",10760.6,47.61,"","",13307.24,61.81}
,{15,4,49825.815,165.797,4540.97,11.053,20867.573,167.126,15.053490215,177.99,0,7.9e-22,"",2.7e-22,"",2.5,1,"","",{"n"},{0},{"="},{0},-24.1,166.11,"","","","",39952.67,165.8,"","",18090.81,167.15,-1800,100,"","",46970.21,165.8,3555.73,179.97,5680.3,168.49,"",""}
,{15,5,28958.242,21.032,5879.985,1.402,19085.098,21.047,15.031087953,22.578,0,0.00993,"",7e-05,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,93.6,0,0.4,0},{"=","=","="},{0,93.6,0,0.4,0},3746.34,21.06,42600.59,73.09,-14194.93,21.04,28856.8,21.03,"","",17867.03,21.03,2776.76,29.87,18285.23,133.91,12391.49,25.27,6009.97,23.37,8744.54,21.12,-14404.93,36.64}
,{15,6,9873.144,0.8,7100.169,0.053,9771.705,0.8,15.010599256,0.858,0,2.449,"",0.005,"",0.5,1,"","",{"B-"},{0},{"="},{0},9394.5,0.8,38363.87,10.21,-12728.94,0.83,7017.54,0.94,-37370.32,132.25,-1061.59,0.8,1218.07,0.8,21079.51,21.23,-30342.23,66.69,4022,1.28,1367.8,1.54,-9558.21,2.07}
,{15,7,101.43871,0.0006,7699.46,0,-2754.166,0.491,15.000108898,0.00065,1,"s","","s","",0.5,-1,"","",{},{},{},{},21386.68,0.27,31038.45,1,-10991.18,0.01,-16465.31,14,-30851.22,21.21,-15977.66,0.03,10833.3,0,10207.42,0,"","",7687.24,0,4965.49,0,-7621.56,1.32}
,{15,8,2855.605,0.491,7463.692,0.033,-13711.146,14.009,15.003065618,0.526,0,122.24,"",0.16,"",0.5,-1,"","",{"B+"},{0},{"="},{0},36402.46,9.54,14847.34,0.49,-10218.71,0.49,-37359.77,66.69,-7453.26,0.49,-37180.11,41.12,13223.49,0.49,7296.78,0.49,"","",8220.93,0.56,-9618.41,1.11,8502.01,0.49}
,{15,9,16566.751,14,6497.459,0.933,-23648.622,68.138,15.017785139,15.029,0,1.1e-21,"",3e-22,"",0.5,1,"","",{"p"},{0},{"="},{0},"","",3356.67,14,-10161.72,48.23,"","",6414.36,14,"","",23468.97,43.44,-1270,14,"","",4162.13,16.93,-10483.81,27.78,4875.08,14.04}
,{15,10,40215.373,66.684,4868.728,4.446,"","",15.04317298,71.588,0,7.7e-22,"",3e-22,"",1.5,-1,"","",{"2p"},{0},{"="},{0},"","",-2522,66,"","","","",24918.62,66.68,"","","","",-962,77.18,"","","","","","",13947.16,70.87}
,{16,4,57447.132,165.797,4285.285,10.362,20334.623,167.608,16.061672036,177.99,0,6.5e-22,"",1.3e-22,"",0,1,"","",{"2n"},{0},{"="},{0},-1350,100,"","","","",43753,165.84,"","",20417.57,167.13,450,141.42,"","",62184.13,165.8,"","",5330.3,179.97,"",""}
,{16,5,37112.51,24.569,5507.302,1.536,23418.378,24.828,16.03984192,26.375,0,4.6e-21,"","s","",0,-1,"","",{},{},{},{},2693.81,32.46,"","",-14321.98,38.78,31428.6,24.68,"","",19168.05,24.58,-82.95,14.6,20002.28,167.61,26432.26,25.94,7868.82,134.51,8317.49,26.59,-14221.98,74.19}
,{16,6,13694.132,3.578,6922.054,0.224,8010.225,4.254,16.014701256,3.84,0,0.747,"",0.008,"",0,1,"","",{"B-","B-n"},{0,97.9,0},{"=","="},{0,97.9,0},5468.39,3.58,40838.31,132.29,-13808.54,4.05,18431.13,3.58,-43420.65,165.84,5521.38,3.58,4250.33,3.67,22553.08,21.33,-10292.64,20.79,741.25,21.51,1996.24,3.71,-14318.54,10.79}
,{16,7,5683.907,2.301,7373.796,0.144,10420.908,2.301,16.006101925,2.47,0,7.13,"",0.02,"",2,-1,"","",{"B-","B-A"},{0,0.00145,0},{"=","="},{0,0.00145,0},13322.14,2.3,32557.72,21.34,-10110.41,2.65,-4996.35,8.63,-30563.31,21.16,-5243.02,2.35,2488.85,2.3,11478.21,2.44,"","",13374.82,2.3,7422.95,2.3,-5231.64,2.51}
,{16,8,-4737.00135,0.00016,7976.206,0,-15417.254,8.321,15.994914619,0.00017,1,"s","","s","",0,1,"","",{},{},{},{},28887.42,0.03,22334.84,0,-7161.92,0,-28723.78,20.48,-21899.12,0.8,-29375.07,14,15663.92,0.49,12127.41,0,"","",3110.39,0,-5218.43,0.27,-2215.61,0}
,{16,9,10680.253,8.321,6963.731,0.52,-13306.523,22.106,16.011465723,8.932,0,1.1e-20,"",6e-21,"",0,-1,"","",{"p"},{0},{"="},{0},37426.78,41.95,6761.11,8.32,-9082.73,8.38,"","",3289.84,8.32,-37606.44,67.2,13957.82,16.29,-535.68,8.33,"","",13383.28,8.32,-7571.12,12.65,10981.17,8.32}
,{16,10,23986.776,20.48,6083.177,1.28,"","",16.025750864,21.986,0,5.7e-21,"","s","",0,1,"","",{"2p"},{0},{"="},{0},"","",-1401.05,20.48,-10352.75,31.55,"","",13842.2,20.49,"","",24299.91,69.76,-131.05,24.81,"","",2733.18,45.94,"","",6517.75,22.59}
,{17,5,43716.317,204.104,5269.667,12.006,22684.419,204.841,17.046931399,219.114,0,0.00508,"",5e-05,"",1.5,-1,"","",{"B-","B-n","B-2n","B-3n","B-4n"},{0,63,0,11,0,3.5,0,0.4,0},{"=","=","=","=","="},{0,63,0,11,0,3.5,0,0.4,0},1384.56,205.18,"","",-15689.49,215.77,35846.24,204.65,"","",21950.87,204.13,1467.51,205.58,21019.79,262.96,41764.62,204.1,4601.31,262.96,8625.87,243.2,"",""}
,{17,6,21031.898,17.365,6558.024,1.021,13161.82,22.946,17.022578672,18.641,0,0.193,"",0.005,"",1.5,1,"","",{"B-","B-n"},{0,28.4,0},{"=","="},{0,28.4,0},4983.88,17.38,43371.86,166.7,-15052.09,20.13,21840.66,17.36,-43704.2,166.7,7276.67,17.52,733.55,17.73,23369.58,30.09,4531.45,17.37,2784.46,27.27,2232.27,27.41,-13276.2,133.38}
,{17,7,7870.079,15,7286.229,0.882,8678.842,15,17.008448877,16.103,0,4.173,"",0.004,"",0.5,-1,"","",{"B-","B-n","B-A"},{0,95,0,0.0025,0},{"=","=","="},{0,95,0,0.0025,0},8373.99,15,35666.1,25.83,-11116.78,15.03,5918.38,15,-36531.4,28.79,4535.76,15,5885.15,15.18,13113.02,15.42,-27303.13,1001.47,8707.74,15.02,9714.24,15,-10147.2,25.98}
,{17,8,-808.76348,0.00066,7750.728,0,-2760.465,0.248,16.999131756,0.0007,1,"s","","s","",2.5,1,"","",{},{},{},{},19807,0.49,25259.85,0.8,-6358.69,0,-17309.21,0.35,-21791.87,3.58,-19560.33,8.32,4143.08,0,13781.64,2.3,"","",9800.6,0,1191.87,0,1817.75,0}
,{17,9,1951.702,0.248,7542.328,0.015,-14548.746,0.432,17.002095238,0.266,0,64.37,"",0.027,"",2.5,1,"","",{"B+"},{0},{"="},{0},30757.68,14,12727.68,0.25,-5818.69,0.37,-33221.51,1001.36,-11021.18,2.31,-30106.39,20.48,16799.87,8.32,600.27,0.25,"","",9806.9,0.55,-1192.02,0.25,4734.69,0.25}
,{17,10,16500.447,0.354,6640.499,0.021,-18672.766,1001.356,17.017713959,0.38,0,0.1092,"",0.0006,"",0.5,-1,"","",{"B+","B+p","B+A"},{0,96,0,2.7,0},{"=","=","="},{0,96,0,2.7,0},39857.56,66.68,933.1,0.61,-9039.9,9.53,"","",13948.48,0.35,"","",15557.65,20.48,1468.78,8.33,"","",10644.5,14,-10599.9,41.12,14139.07,0.36}
,{17,11,35173.214,1001.356,5496.08,58.903,"","",17.03776,1075,0,"s","","s","",1.5,1,"","",{},{},{},{},"","",-4028.52,1001.45,"","","","",17203.99,1001.39,"","","","",-3897.47,1001.57,"","",5668.65,1003.57,"","",8855.21,1002.2}
,{18,5,51792.634,204.165,4976.63,11.342,26873.37,206.357,18.055601682,219.18,0,2.6e-08,"","s","",2,-1,"","",{},{},{},{},1462.51,205.64,"","","","",38679.47,205.01,"","",22689.42,204.9,-5,5,"","",50919.52,204.17,5056.31,263.01,6830.87,263.01,"",""}
,{18,6,24919.264,30,6426.131,1.667,11806.096,35.282,18.026751932,32.206,0,0.092,"",0.002,"",0,1,"","",{"B-","B-n"},{0,31.5,0},{"=","="},{0,31.5,0},4917.5,30.21,47105.81,168.49,-17460.15,135.61,25702.08,30,"","",8977.87,33.54,4183.95,34.66,26086.02,206.3,19601.65,30,-1482.44,38.78,825.08,36.64,-19260.15,168.49}
,{18,7,13113.168,18.57,7038.562,1.032,13895.984,18.57,18.014077565,19.935,0,0.6192,"",0.0019,"",1,-1,"","",{"B-","B-n","B-A"},{0,7,0,12.2,0},{"=","=","="},{0,7,0,12.2,0},8713.37,18.71,38577.28,30.8,-12975.43,28.19,12240.06,18.58,-37892.12,204.95,5850.61,18.57,2828.23,23.87,15207.7,25.42,-11924.82,95.7,10129.84,18.91,8104.08,18.59,-10198.67,28.06}
,{18,8,-782.8156,0.00071,7767.097,0,-1655.929,0.463,17.999159612,0.00076,1,"s","","s","",0,1,"","",{},{},{},{},12188.45,0,29054.89,3.58,-6227.62,0,-6100.43,0.36,-29103.68,17.36,-10805.83,0.25,8045.37,0,15941.86,15,"","",4244.08,2.3,3979.8,0,-5009.56,0.8}
,{18,9,873.113,0.463,7631.638,0.026,-4444.501,0.589,18.000937325,0.497,0,6584.34,"",0.54,"",1,1,"","",{"B+"},{0},{"="},{0},25949.77,8.33,19388.74,2.35,-4415.22,0.46,-24164.87,93.88,-14285.94,15.01,-23698.65,0.58,9149.91,0.53,5607.09,0.46,"","",16320.92,0.46,2881.56,0.67,6418.08,0.46}
,{18,10,5317.614,0.363,7341.257,0.02,-19720.374,93.882,18.005708693,0.39,0,1.6642,"",0.00047,"",0,1,"","",{"B+"},{0},{"="},{0},34811.8,20.48,4523.33,0.36,-5115.08,0.36,"","",-1162.59,0.36,-37926.92,1001.36,19254.15,0.51,3923.06,0.44,"","",5348.17,8.33,-6385.08,14,8108.41,0.61}
,{18,11,25037.988,93.881,6202.217,5.216,"","",18.026879386,100.785,0,1.3e-21,"",4e-22,"",1,-1,"","",{"p"},{""},{""},{""},"","",220.21,94.25,-9351.33,102.49,"","",15797.32,93.88,"","",18206.54,1005.75,-1248.57,93.88,"","",11762.02,96.09,-10313.33,115.15,14117.64,94.92}
,{19,5,59770.244,525.363,4719.634,27.651,27356.492,534.496,19.064166,564,0,0.00292,"",0.00013,"",1.5,-1,"","",{"B-","B-n","B-2n","B-3n"},{0,71,0,17,0,9.1,0},{"=","=","=","<"},{0,71,0,17,0,9.1,0},88.71,563.62,"","","","",43913.96,525.62,"","",26779.66,526.22,93.71,563.64,"","",61257.69,525.36,"","",7187.17,550.9,"",""}
,{19,6,32413.752,98.389,6118.273,5.178,16557.471,99.748,19.034797596,105.625,0,0.0462,"",0.0023,"",0.5,1,"","",{"B-","B-n","B-2n"},{0,47,0,7,""},{"=","=","="},{0,47,0,7,""},4760.78,99.91,"","",-19836.98,192.79,29080.89,98.42,"","",11229.27,100.13,576.83,93.7,26667.85,226.64,30661.7,98.39,-591.76,226.58,165.3,101.41,-19386.98,192.79}
,{19,7,15856.282,16.404,6948.543,0.863,12523.424,16.614,19.017022419,17.61,0,0.336,"",0.003,"",0.5,-1,"","",{"B-","B-n"},{0,41.8,0},{"=","="},{0,41.8,0},8156.43,22.23,42437.98,204.76,-15526.88,26.67,17343.73,16.4,-43225.32,204.82,8567.78,16.4,5328.2,24.78,16351.95,34.19,2926.89,19.5,5535.19,23.89,7026.2,16.79,-15609.83,29.54}
,{19,8,3332.858,2.637,7566.495,0.139,4820.302,2.637,19.00357797,2.83,0,26.47,"",0.006,"",2.5,1,"","",{"B-"},{0},{"="},{0},12001.01,2.64,32276.98,17.56,-8965.2,2.76,1580.81,2.64,-28875.38,30.12,-5611.57,2.68,3955.64,2.64,17069.28,18.76,-28495.53,50.07,6173.59,15.23,2513.01,3.5,-4714.87,4.44}
,{19,9,-1487.4442,0.00086,7779.018,0,-3239.494,0.16,18.998403162,0.00093,1,"s","","s","",0.5,1,"","",{},{},{},{},19581.78,0.25,23935.46,15,-4013.8,0,-14416.83,10.54,-21889.58,18.57,-14876.38,0.36,10431.87,0.46,7993.6,0,"","",10032.13,0,8113.61,0,-1524.95,2.3}
,{19,10,1752.05,0.16,7567.343,0.008,-11177.34,10.536,19.001880903,0.171,0,17.274,"",0.01,"",0.5,1,"","",{"B+"},{0},{"="},{0},30891.03,0.39,12017.13,0.16,-3528.47,0.52,-30076.34,50,-4754.1,0.16,-31357.25,93.88,11636.88,0.4,6410.03,0.49,"","",10511.15,0.3,-4064.15,8.32,12135.45,0.16}
,{19,11,12929.39,10.535,6937.885,0.554,-18898.998,51.099,19.013880272,11.309,0,1e-18,"","s","",2.5,1,"","",{"p"},{0},{"="},{0},38386.46,1001.41,3600.25,10.54,-6062.28,17.52,"","",4767.31,10.55,"","",20179.91,94.47,-322.81,10.54,"","",7139.75,10.54,-6193.33,23.03,7895.54,13.42}
,{19,12,31828.389,50.001,5902.025,2.632,"","",19.034169182,53.678,0,5e-12,"",3e-12,"",0.5,-1,"","",{"2p"},{0},{"="},{0},"","",-750,50,-10811.9,83.35,"","",19221.8,50,"","","","",498.57,106.37,"","",7365.98,1002.6,"","",13488.01,54.03}
,{20,5,68450,800,4453,40,30946,833,20.073484,859,0,"s","","s","",0,0,"","",{},{},{},{},-515,826,"","","","",46683,804,"","",27965,806,-608,957,"","",68467,800,"","","","","",""}
,{20,6,37503.563,230.625,5961.435,11.531,15737.067,243.746,20.040261732,247.585,0,0.016,"",0.003,"",0,1,"","",{"B-","B-n","B-2n"},{0,70,"",18.6,0},{"=","=","<"},{0,70,"",18.6,0},3558.34,232.57,"","",-22368.49,284.04,33707.39,230.63,"","",13575.96,231.21,2981.51,250.74,29555.65,573.75,44545.49,230.62,-3578.27,308.01,-1348.7,307.97,"",""}
,{20,7,21766.496,78.894,6709.171,3.945,17970.324,78.899,20.023367295,84.696,0,0.136,"",0.003,"",0,0,"","",{"B-","B-n"},{0,42.9,0},{"=","="},{0,42.9,0},7489.31,81.05,44604.08,218.88,-17770.93,82.63,21783.96,78.89,-45292.72,531.25,10362.32,78.94,2161.1,80.58,17936.23,126.11,14915.89,78.9,7558.04,84.41,5598.65,80.78,-16303.42,218.82}
,{20,8,3796.172,0.885,7568.57,0.044,3813.635,0.885,20.004075358,0.95,0,13.51,"",0.05,"",0,1,"","",{"B-"},{0},{"="},{0},11563.65,0.88,35701.03,30.01,-12322.88,3.69,10838.1,0.88,-35906.55,98.39,-2787.7,0.88,7608,2.78,19349.08,16.43,-13681.52,2.06,1393.81,18.59,790.15,15.03,-11589.32,17.39}
,{20,9,-17.463,0.03,7720.134,0.002,7024.467,0.03,19.999981252,0.031,0,11.163,"",0.008,"",2,1,"","",{"B-"},{0},{"="},{0},17033.21,0.46,27708.57,18.57,-8126.29,2.3,-6868.07,1.11,-23162.72,16.4,-9840.83,0.16,6601.34,0.03,10639.29,2.64,"","",11476.16,0.03,5655.36,0.03,-2241.14,15}
,{20,10,-7041.93055,0.00157,8032.24,0,-13892.535,1.114,19.992440176,0.00168,1,"s","","s","",0,1,"","",{},{},{},{},28502.18,0.36,20837.06,0,-4729.84,0,-24519.62,1.86,-17663.76,2.64,-28042.64,10.54,16865.3,0.16,12843.46,0,"","",2795.76,0.46,-4129.58,0.25,-586.77,0}
,{20,11,6850.604,1.114,7298.496,0.056,-10627.088,2.171,20.007354426,1.195,0,0.4479,"",0.0023,"",2,1,"","",{"B+","B+A"},{0,25,0},{"=","="},{0,25,0},34330.02,93.89,8600.45,1.21,-6254.56,8.39,"","",1049.08,1.11,-33049.1,50.01,14150.1,10.59,2190.42,1.13,"","",12243.8,1.17,-4785.79,1.17,10545.3,1.14}
,{20,12,17477.692,1.863,6728.025,0.093,"","",20.018763075,2,0,0.093,"",0.005,"",0,1,"","",{"B+","B+p"},{0,30.3,0},{"=","="},{0,30.3,0},"","",2417.86,1.9,-8934,20.56,"","",8436.67,1.87,"","",22422.01,50.04,2740.67,10.7,"","",3150.51,93.9,-12831.47,1001.36,6623.65,1.9}
,{21,5,77330,900,4203,43,31687,1079,21.083017,966,0,2.6e-07,"","s","",1.5,-1,"","",{},{},{},{},-1417,1042,"","","","",52098,910,"","",31755,929,-809,1204,"","",77377,900,"","","","","",""}
,{21,6,45643,596,5674,28,20411,611,21.049,640,0,3e-08,"","s","",0.5,1,"","",{},{},{},{},2913,604,"","","","",37581,596,"","",15805,601,-68,639,30096,998,51375,596,-3416,795,-1285,630,"",""}
,{21,7,25231.913,134.048,6609.015,6.383,17169.878,134.584,21.027087573,143.906,0,0.084,"",0.007,"",0.5,-1,"","",{"B-","B-n"},{0,90.5,0},{"=","="},{0,90.5,0},6767,135.05,49116.27,542.19,-20909.32,244.19,25279.52,134.06,-50507,811,13364.42,134.05,4605.9,155.54,19560.62,266.75,27416.54,134.05,3528.97,166.28,5176.7,137.36,-20914.32,244.24}
,{21,8,8062.035,12,7389.374,0.571,8109.64,12.134,21.00865495,12.882,0,3.42,"",0.1,"",2.5,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},11413.46,12.29,38929.66,99.12,-15394.78,21.11,13793.81,12,-36730.5,230.94,8.18,12,3805.45,12.03,20993.43,79.8,-2841.81,12.02,2916.56,20.32,-187.08,22.11,-11210.83,32.31}
,{21,9,-47.605,1.8,7738.293,0.086,5684.171,1.8,20.999948894,1.932,0,4.158,"",0.02,"",2.5,1,"","",{"B-"},{0},{"="},{0},14702.79,1.8,30481.83,16.5,-10342.6,15.11,2137.03,1.8,-29103.07,78.91,-1076.99,1.8,8101.46,1.8,11132.75,2.01,-27038,596,7330.34,3.19,5599.27,1.8,-7514.37,18.66}
,{21,10,-5731.776,0.038,7971.713,0.002,-3547.145,0.09,20.993846685,0.041,1,"s","","s","",1.5,1,"","",{},{},{},{},23626.46,0.16,23642.57,2.64,-7347.93,0.04,-16635.63,0.76,-16816.92,0.89,-20653.7,1.11,6761.16,0.04,13003.28,0.05,"","",6466.47,0.04,-1740.83,0.46,697.44,0.04}
,{21,11,-2184.631,0.098,7765.547,0.005,-13088.48,0.761,20.997654702,0.105,0,22.422,"",0.01,"",1.5,1,"","",{"B+"},{0},{"="},{0},31256.66,10.54,15275.13,0.1,-6561.25,0.27,-29175,596,-9456.14,0.1,-27733.64,1.87,17106.55,1.12,2431.67,0.1,"","",6774.12,0.19,-2638.19,0.38,2588.66,0.47}
,{21,12,10903.85,0.755,7105.031,0.036,-16086,596,21.011705764,0.81,0,0.1186,"",0.0005,"",2.5,1,"","",{"B+","B+p","B+A","B+pA"},{0,32.6,0,"","",0.016,0},{"=","=","","="},{0,32.6,0,"","",0.016,0},37067.17,50.01,5426.14,0.77,-8021.51,0.83,"","",10656.81,0.75,"","",14645.16,2.01,3235.73,1.35,"","",8685.27,10.56,-9270.08,93.88,11232.64,0.84}
,{21,13,26990,596,6302,28,"","",21.028975,640,0,3.5e-08,"","s","",2.5,1,"","",{},{},{},{},"","",517,596,-10608,1165,"","",12850,596,"","","","",-2223,596,"","",5872,598,"","",7598,604}
,{22,6,53611.197,231.49,5421.077,10.522,21846.396,311.063,22.05755399,248.515,0,0.0062,"",0.0013,"",0,1,"","",{"B-","B-n","B-2n"},{0,61,"",37,0},{"=","=","<"},{0,61,"",37,0},35,20,"","","","",44328.16,238.39,"","",20307.97,267.5,103,640,31008,929,61635.92,231.49,-4128,833,-1294.99,574.1,"",""}
,{22,7,31764.801,207.779,6378.534,9.445,22481.768,215.435,22.034100918,223.06,0,0.023,"",0.003,"",0,-1,"","",{"B-","B-n","B-2n"},{0,34,0,12,0},{"=","=","="},{0,34,0,12,0},6144.33,222.25,51263,827,-22452.75,291.3,28971.43,208.15,-52854,924,15631.45,208.13,1538.43,247.27,21167,631,36946.31,207.78,4972.04,310.42,4215.1,229.9,-22359.04,564.96}
,{22,8,9283.033,56.921,7364.871,2.587,6489.66,58.256,22.009965746,61.107,0,2.25,"",0.09,"",0,1,"","",{"B-","B-n"},{0,22,0},{"=","<"},{0,22,0},10655.77,56.93,42798.47,237.55,-18061.15,64.34,17307.75,56.92,-43649,599,1259.32,56.95,6850.32,58.17,23237.85,145.63,9682.97,56.92,-1772.66,97.28,-1709.19,59.24,-17484.32,113.67}
,{22,9,2793.373,12.399,7624.295,0.564,10818.092,12.399,22.002998809,13.31,0,4.23,"",0.04,"",4,1,"","",{"B-","B-n"},{0,11,0},{"=","<"},{0,11,0},13331.8,12.4,33551.06,79.86,-12744.71,22.33,7974.88,12.4,-29727.51,134.62,453.83,12.4,5230.34,12.53,12557.63,17.26,-15408,401,9708.01,12.43,4324.57,12.68,-7416.51,20.56}
,{22,10,-8024.719,0.018,8080.465,0.001,-2843.207,0.171,21.991385109,0.018,1,"s","","s","",0,1,"","",{},{},{},{},17125.42,0.02,26398.83,0.89,-9666.82,0.02,-7624.79,0.31,-23375.72,12,-13911.4,0.1,10364.26,0.04,15266.08,1.8,-41363,503,2703.55,0.03,-1673.22,0.02,-5711.17,2.64}
,{22,11,-5181.511,0.171,7915.667,0.008,-4781.578,0.321,21.994437418,0.183,0,82104810.0668,"",69425.2372,"",3,1,"","",{"B+"},{0},{"="},{0},28174.75,1.13,19741.99,0.17,-8479.54,0.49,-23383,401,-12422.88,1.81,-24156.68,0.77,11068.2,0.2,6738.71,0.18,"","",12571.23,0.17,-2069.51,0.23,1952.33,0.17}
,{22,12,-399.933,0.313,7662.761,0.014,-18601,401,21.999570654,0.335,0,3.8755,"",0.0012,"",0,1,"","",{"B+"},{0},{"="},{0},34020.26,1.89,7935.94,0.31,-8142.46,0.48,-33738,503,-1957.13,0.32,-35461,596,19375.1,0.82,5504.27,0.33,"","",3460.27,1.16,-8465.27,10.54,3494.42,0.35}
,{22,13,18201,401,6782,18,-15137,643,22.01954,430,0,0.0911,"",0.0005,"",0,0,"","",{"B+","B+p","B+2p","B+A"},{0,55,0,1.1,0,0.038,0},{"=","=","=","="},{0,55,0,1.1,0,0.038,0},"","",3227,401,-9262,411,"","",13097,401,"","",16860,718,-9,401,"","",11435,401,-8763,404,10918,401}
,{22,14,33338,503,6058,23,"","",22.03579,540,0,0.029,"",0.002,"",0,1,"","",{"B+","B+p"},{0,32,0},{"=","="},{0,32,0},"","",-1283,503,"","","","",15145,503,"","","","",941,780,"","","","","","",7156,505}
,{23,6,64171,997,5077,43,27450,1082,23.06889,1070,0,"s","","s","",1.5,1,"","",{},{},{},{},-2385,1161,"","","","",49549,1004,"","",24335,1018,-2488,1023,"","",69325,997,-2448,1343,585,1278,"",""}
,{23,7,36720.425,420.57,6236.671,18.286,22099.056,437.827,23.039421,451.5,0,0.0139,"",0.0014,"",0.5,-1,"","",{"B-","B-n","B-2n","B-3n"},{0,42,0,8,"",3.4,0},{"=","=","=","<"},{0,42,0,8,"",3.4,0},4654.12,441.42,55187,993,-25474.73,672.97,33435.16,421.89,"","",19366.07,424.4,3115.69,469.1,24179.74,480.07,46250.28,420.57,1788,730,4080.92,479.65,-26083,904}
,{23,8,14621.369,121.712,7163.485,5.292,11336.106,126.19,23.015696686,130.663,0,0.097,"",0.008,"",0.5,1,"","",{"B-","B-n"},{0,7,""},{"=","="},{0,7,""},9583.3,122.3,45600,608,-20217.3,156.51,19775.42,121.71,-46278.8,261.54,3756.68,122.34,2732.98,134.36,24432.4,240.8,20094.88,121.71,100.26,181.06,-2281.07,145.05,-17235.79,260.77}
,{23,9,3285.263,33.32,7622.344,1.449,8439.312,33.321,23.003526874,35.77,0,2.23,"",0.14,"",2.5,1,"","",{"B-","B-n"},{0,14,0},{"=","<"},{0,14,0},12809.77,33.37,36524.59,138.13,-14995.93,37.14,12815.12,33.32,-35768.51,210.43,3238.66,33.32,7579.43,35.55,13286.74,65.96,-3462.81,33.32,5934.03,35.42,4353.15,33.33,-12834.83,85.64}
,{23,10,-5154.049,0.104,7955.256,0.005,4375.804,0.104,22.9944669,0.112,0,37.14,"",0.028,"",2.5,1,"","",{"B-"},{0},{"="},{0},15564.91,0.11,27794.02,12,-10911.82,2.64,319.46,0.19,-21726.05,56.92,-8043.85,0.2,5200.65,0.1,15236.39,12.4,-28851,503,5604.36,1.8,-272.53,0.11,-3303.82,0.89}
,{23,11,-9529.85248,0.00181,8111.493,0,-4056.34,0.158,22.989769281,0.00194,1,"s","","s","",1.5,1,"","",{},{},{},{},23487.86,0.1,24060.19,1.8,-10467.32,0,-16277.92,0.34,-19612.2,12.4,-17201.24,0.31,12419.66,0.17,8794.1,0.02,"","",6912.73,0.04,2376.13,0,-3865.99,0.03}
,{23,12,-5473.513,0.158,7901.115,0.007,-12221.583,0.379,22.994123941,0.17,0,11.317,"",0.011,"",1.5,1,"","",{"B+"},{0},{"="},{0},32520,0.77,14319.68,0.16,-9650.48,0.23,-29171,503,-4737.76,0.16,-31746,401,13144.9,0.35,7580.97,0.23,"","",7421.92,0.19,-7460.06,1.13,7214.82,0.16}
,{23,13,6748.07,0.345,7335.727,0.015,-16949,503,23.007244351,0.37,0,0.47,"",0.03,"",2.5,1,"","",{"B+","B+p"},{0,0.46,0},{"=","="},{0,0.46,0},36385,596,5645.24,0.36,-8606.24,10.54,"","",4640.61,0.38,-34661,503,19525,401,140.97,0.47,"","",6555.03,0.83,-5865.57,1.89,5543.87,1.17}
,{23,14,23697,503,6565,22,"","",23.02544,540,0,0.0423,"",0.0004,"",1.5,1,"","",{"B+","B+p","B+2p"},{0,88,0,3.6,0},{"=","~","="},{0,88,0,3.6,0},"","",1785,503,-10556,505,"","",16808,503,"","",17712,711,1793,643,"","",7418,780,"","",11866,503}
,{24,7,46938,401,5887,17,28438,433,24.05039,430,0,5.2e-08,"","s","",0,0,"","",{},{},{},{},969,451,"","",-23937,895,39393,412,"","",24245,419,-2146,581,24522,1074,55356,401,4038,463,6159,718,-24745,985}
,{24,8,18500.402,164.874,7039.685,6.87,10955.887,191.633,24.019861,177,0,0.0774,"",0.0045,"",0,1,"","",{"B-","B-n"},{0,43,0},{"=","="},{0,43,0},6925.27,174.42,49688.74,284.2,-21428.08,283.5,24452.05,164.88,-52959,1010,7143.82,168.21,4192.28,204.93,25508.99,451.73,32433.97,164.87,-2553.59,265.25,-1867.46,212.49,-21496,619}
,{24,9,7544.515,97.67,7463.582,4.07,13496.161,97.672,24.00809937,104.853,0,0.384,"",0.016,"",3,1,"","",{"B-","B-n"},{0,5.9,0},{"=","<"},{0,5.9,0},11391.49,98.45,38798.23,229.59,-16646.9,125.55,15962.42,97.67,-36464.88,431.76,4627.25,97.67,3812.06,103.2,14365.82,156.06,7593.38,97.67,8972.29,113.05,4346.54,98.4,-12041,165.86}
,{24,10,-5951.646,0.513,7993.325,0.021,2466.255,0.513,23.993610645,0.55,0,202.8,"",1.2,"",0,1,"","",{"B-"},{0},{"="},{0},14069.56,0.51,29812.62,56.92,-12172.73,1.02,7981.92,0.51,-27861.99,121.71,-4493.11,0.51,8868.91,0.52,16525.88,33.32,-16696.84,19.48,1965.79,12.41,-1039.99,1.87,-8367.28,12.01}
,{24,11,-8417.901,0.017,8063.488,0.001,5515.669,0.021,23.990963011,0.017,0,53845.2,"",14.4,"",4,1,"","",{"B-"},{0},{"="},{0},19379.02,0.17,25789.21,12.4,-10825.35,0.03,-8369.04,0.23,-18992.13,33.32,-11015.71,0.16,6959.37,0.02,10552.82,0.11,-41737,503,10317.62,0.02,2177.93,0.04,-2723.89,1.8}
,{24,12,-13933.569,0.013,8260.709,0.001,-13884.704,0.233,23.985041697,0.014,1,"s","","s","",0,1,"","",{},{},{},{},29676.27,0.31,20486.79,0.02,-9316.55,0.01,-24678.76,19.47,-16068.49,0.11,-28752.96,0.34,16531.37,0.16,11692.69,0.01,"","",1958.75,0.17,-6884.88,0.1,-2555.39,0.04}
,{24,13,-48.865,0.233,7649.582,0.01,-10794.06,19.473,23.999947541,0.25,0,2.053,"",0.004,"",4,1,"","",{"B+","B+A","B+p"},{0,0.035,0,0.0016,0},{"=","=","="},{0,0.035,0,0.0016,0},34393,401,9445.3,0.29,-9324.38,1.14,-33368,503,2192.02,0.23,-31817,503,14868.25,0.42,1864.32,0.28,"","",11061.87,0.39,-6088.66,0.79,7782.17,0.25}
,{24,14,10745.195,19.472,7167.232,0.811,-22574,503,24.011535441,20.904,0,0.14,"",0.008,"",0,1,"","",{"B+","B+p"},{0,37.6,0},{"=","="},{0,37.6,0},38736,503,3432.81,19.47,-9157.41,19.56,"","",8929.74,19.47,"","",21023,503,3291.85,19.48,"","",3255,401,-11381,596,5487.75,19.49}
,{24,15,33320,503,6194,21,"","",24.03577,540,0,"s","","s","",1,1,"","",{},{},{},{},"","",-540,643,"","","","",19282,503,"","","","",-2333,711,"","",10692,711,"","",11976,780}
,{25,7,55983,503,5613,20,28654,529,25.0601,540,0,2.6e-07,"","s","",0.5,-1,"","",{},{},{},{},-3120,656,"","",-23772,1031,44649,512,"","",29411,529,-973,643,"","",65341,503,2523,1116,7236,554,"",""}
,{25,8,27329.027,165.084,6727.805,6.603,15994.862,191.191,25.029338919,177.225,0,5.18e-21,"",3.5e-22,"",1.5,1,"","",{"n"},{0},{"="},{0},3434.98,205.1,51420,1010,-20739,619,29364.53,167.62,"","",11713.19,191.81,-757.31,8.32,26898,433,40521.81,165.08,1319.41,451.81,428.28,265.38,-20635.77,284.32}
,{25,9,11334.166,96.442,7336.306,3.858,13369.667,100.721,25.012167727,103.535,0,0.08,"",0.009,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,23.1,0,0,0},{"=","=","="},{0,23.1,0,0,0},8093.73,102.04,39964.2,431.49,-16322.66,165.14,20691.98,96.45,-42893,412,9214.49,96.44,4281.67,137.26,14455.21,191.01,20250.14,96.44,7423.6,155.29,6915.19,111.99,-14784.23,229.07}
,{25,10,-2035.502,29.045,7839.799,1.162,7322.312,29.07,24.997814799,31.181,0,0.602,"",0.008,"",0.5,1,"","",{"B-"},{0},{"="},{0},13024.09,29.05,31234.81,125.13,-12522.45,31.43,11157.28,29.05,-27824.87,167.41,-1688.92,29.05,4155.17,29.05,16868.99,101.9,-5862.83,30.72,5390.04,44.2,35.18,31.58,-5672.13,63.9}
,{25,11,-9357.813,1.2,8101.397,0.048,3834.969,1.201,24.989953973,1.288,0,59.1,"",0.6,"",2.5,1,"","",{"B-"},{0},{"="},{0},15970.59,1.2,27221.02,33.34,-11735.12,2.16,-441.84,1.2,-24191.3,97.68,-3495.56,1.2,9011.23,1.2,10695.14,1.3,-29096,401,6507.04,1.2,3530.96,1.2,-6504.78,12.46}
,{25,12,-13192.783,0.047,8223.502,0.002,-4276.808,0.045,24.985836964,0.05,1,"s","","s","",2.5,1,"","",{},{},{},{},23861.9,0.17,22616.68,0.11,-9885.92,0.06,-17020.11,10,-14530.11,0.51,-21215.23,0.24,7330.53,0.05,12063.85,0.05,"","",7047.88,0.05,-3147.22,0.18,478.34,0.05}
,{25,13,-8915.975,0.065,8021.136,0.003,-12743.299,10,24.990428306,0.069,0,7.183,"",0.012,"",2.5,1,"","",{"B+"},{0},{"="},{0},31806.68,0.35,13964.06,0.06,-9156.26,0.12,-28654,401,-7787.04,0.07,-27732.49,19.47,16938.43,0.24,2271.38,0.07,"","",7268.34,0.17,-3651.99,0.32,1911.94,0.18}
,{25,14,3827.324,10,7480.11,0.4,-15911,401,25.004108801,10.735,0,0.22,"",0.003,"",2.5,1,"","",{"B+","B+p"},{0,35,0},{"=","="},{0,35,0},36013,503,5277.1,10,-9501.44,10.03,"","",10471.92,10,-37564,503,14989.19,21.89,3412.78,10,"","",7790.06,10.01,-9510,401,9873.66,10}
,{25,15,19738,401,6812,16,"","",25.02119,430,0,3e-08,"","s","",0.5,1,"","",{},{},{},{},"","",1588,401,-9677,718,"","",12498,401,"","",21652,643,-1704,401,"","",6752,643,-8736,643,7183,566}
,{26,8,34661.037,164.95,6497.478,6.344,16012.161,198.932,26.037210155,177.081,0,4.2e-12,"",3.3e-12,"",0,1,"","",{"2n"},{0},{"="},{0},-18,5,"","",-21375.08,284.25,34179.92,165.98,"","",15255.55,191.08,739.31,9.71,28611,529,50875.58,164.95,-1566,433,2804.67,451.76,-23863,1010}
,{26,9,18648.875,111.199,7083.24,4.277,18167.762,112.716,26.020020392,119.377,0,0.0082,"",0.0009,"",1,1,"","",{"B-","B-n","B-2n"},{0,13.5,0,"",""},{"=","=",""},{0,13.5,0,"",""},5038.27,148,42867,416,-15540.84,235.66,25509.66,111.25,-44623,515,12613.06,114.93,756.61,147.2,15969.12,199.04,30859.03,111.2,10859.28,198.87,8891.56,164.86,-12425.15,435.02}
,{26,10,481.114,18.429,7751.91,0.709,7341.893,18.758,26.000516496,19.784,0,0.197,"",0.002,"",0,1,"","",{"B-","B-n"},{0,0.13,0},{"=","="},{0,0.13,0},9709.88,18.44,32597.23,165.9,-11226.84,59.83,16695.66,18.43,-34136.88,166.11,1767.61,18.47,5554.7,34.4,18142.02,98.19,7622.13,18.43,3647.4,99.39,2059.91,38.08,-8493.85,123.1}
,{26,11,-6860.78,3.502,8004.201,0.135,9353.763,3.502,25.992634649,3.759,0,1.07128,"",0.00025,"",3,1,"","",{"B-"},{0},{"="},{0},14585.51,3.5,28983.24,97.73,-12079.07,12.88,5349.37,3.5,-25483.92,96.51,-1739.31,3.5,5574.28,3.7,12114.25,29.26,-17834,196,9801.67,3.54,3157.32,3.5,-4499.64,33.5}
,{26,12,-16214.542,0.03,8333.87,0.001,-4004.391,0.063,25.982592971,0.032,1,"s","","s","",0,1,"","",{},{},{},{},18423.61,0.03,24840.84,0.51,-10614.74,0.03,-9073.53,0.11,-21468.01,29.05,-15369.88,0.06,11093.08,0.04,14145.7,1.2,-43293,596,2914.16,0.03,-1820.63,0.03,-5414.09,0.11}
,{26,13,-12210.151,0.067,8149.765,0.003,-5069.136,0.085,25.986891863,0.071,0,22626315942000,"",757366224000,"",5,1,"","",{"B+"},{0},{"="},{0},28303.92,0.24,18370.19,0.07,-9453.56,0.18,-23183,196,-10141.31,1.2,-24108.79,10,11365.49,0.07,6306.34,0.06,"","",12434.22,0.07,-1872.58,0.17,2966.1,0.07}
,{26,14,-7141.015,0.108,7924.708,0.004,-18114,196,25.992333804,0.115,0,2.2453,"",0.0007,"",0,1,"","",{"B+"},{0},{"="},{0},34028.84,19.47,7785.39,0.11,-9166,0.33,-34220,596,-1237.2,0.1,-34951,401,19039.66,10,5514.01,0.11,"","",3618.66,0.26,-9025.03,0.36,3978.9,0.19}
,{26,15,10973,196,7198,8,-16106,627,26.01178,210,0,0.0437,"",0.0006,"",0,0,"","",{"B+","B+p","B+2p"},{0,36.8,0,2.16,0},{"=","=","="},{0,36.8,0,2.16,0},38489,540,3556,196,-9653,446,"","",12600,196,"","",16837,446,143,196,"","",10939,197,-7860,540,9871,196}
,{26,16,27079,596,6548,23,"","",26.02907,640,0,7.9e-08,"","s","",0,1,"","",{},{},{},{},"","",-1755,596,-8685,780,"","",15962,596,"","","","",-51,718,"","",4470,780,"","",9028,780}
,{27,8,44670,500,6185,19,19220,634,27.047955,537,0,2.6e-07,"","s","",1.5,1,"","",{},{},{},{},-1198,527,"","",-21926,1115,37619,508,"","",17950,512,-1937,527,"","",59256,500,-602,709,2596,641,"",""}
,{27,9,25450.279,389.83,6867.932,14.438,18399.37,400.258,27.027322,418.5,0,0.0049,"",0.0002,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,77,"",5,0},{"=","=","="},{0,77,"",5,0},2026.52,401.58,45110,636,-13695.06,573.45,30968.07,389.85,"","",16897.85,390.27,1269.91,405.38,16499.73,423.29,42647.14,389.83,8832.06,423.34,11813.93,423.26,-15841,559}
,{27,10,7050.909,90.77,7520.414,3.362,12568.699,90.847,27.007569462,97.445,0,0.0315,"",0.0013,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,2,0,0,0},{"=","=","="},{0,2,0,0,0},7056.22,95.3,34856.06,188.39,-9995.38,151.83,21637.52,90.77,-34899.1,188.28,5840.37,90.84,1501.52,92.62,18886.94,143.54,19435.41,90.77,6427.55,132.44,4370.45,133.34,-5803.09,188.21}
,{27,11,-5517.79,3.726,7956.946,0.138,9068.821,3.727,26.994076408,4,0,0.301,"",0.006,"",2.5,1,"","",{"B-","B-n"},{0,0.13,0},{"=","="},{0,0.13,0},12302.61,3.91,31429.9,96.51,-11227.97,33.53,11679.07,3.73,-31455.64,111.26,2625.44,3.73,6728.33,5.11,13287.87,18.8,-4795.33,26.6,7228.52,29.28,5297.91,3.76,-7415.9,97.74}
,{27,12,-14586.611,0.05,8263.852,0.002,2610.251,0.069,26.984340628,0.053,0,566.1,"",1.62,"",0.5,1,"","",{"B-"},{0},{"="},{0},17536.46,0.06,27129.05,29.05,-11857.48,0.12,-2202.11,0.12,-22356.69,18.43,-10447.78,0.08,6443.39,0.04,15014.8,3.5,-31614,401,5482.01,1.2,-1304.66,0.05,-2988.56,0.52}
,{27,13,-17196.861,0.047,8331.553,0.002,-4812.359,0.096,26.981538408,0.05,1,"s","","s","",2.5,1,"","",{},{},{},{},24423.52,0.08,22416.99,1.2,-10091.92,0.05,-16474.4,26.34,-17625.05,3.5,-18127.16,0.12,13058.03,0.08,8271.29,0.06,"","",6706.73,0.07,1600.76,0.05,-3132.56,0.05}
,{27,14,-12384.503,0.107,8124.341,0.004,-11662.044,26.34,26.986704688,0.115,0,4.15,"",0.04,"",2.5,1,"","",{"B+"},{0},{"="},{0},32354.46,10,13769.66,0.12,-9335.91,0.19,-29412,401,-3458.93,0.11,-31429,196,13314.8,0.15,7463.32,0.13,"","",7242.28,0.13,-7471.58,0.26,7195.47,0.11}
,{27,15,-722.458,26.34,7663.438,0.976,-17750,400,26.999224409,28.277,0,0.26,"",0.08,"",0.5,1,"","",{"B+","B+p"},{0,0.07,0},{"=","="},{0,0.07,0},36603,401,6384.42,26.34,-9895.44,26.34,"","",4198.72,26.34,-35872,597,19767,197,870.41,26.34,"","",6161.02,28.17,-6603.6,32.76,4972.81,26.34}
,{27,16,17028,401,6977,15,"","",27.01828,430,0,0.0155,"",0.0015,"",2.5,1,"","",{"B+","B+p","B+2p"},{0,2.3,0,1.1,0},{"=","=","="},{0,2.3,0,1.1,0},"","",1378,401,-9095,643,"","",16880,401,"","",18122,718,1234,446,"","",8000,567,-11428,643,11929,401}
,{28,8,52080,699,5988,25,18338,802,28.05591,750,0,1e-07,"","s","",0,1,"","",{"B-"},{0},{"="},{0},-1276,718,"","","","",40780,710,"","",18558,800,661,859,"","",67099,699,"","",961,861,"",""}
,{28,9,33741.596,393.024,6614.792,14.037,22441.859,412.748,28.036223095,421.928,0,4.6e-20,"","s","",0,0,"","",{},{},{},{},1049.91,408.45,"","",-15621,561,34729.91,393.16,"","",18619.37,403.37,-220,50,18217,636,50592.24,393.02,9791.37,426.23,11276.62,426.29,-16595,638}
,{28,10,11299.737,126.068,7388.346,4.502,12288.052,126.483,28.012130767,135.339,0,0.02,"",0.001,"",0,1,"","",{"B-","B-n","B-2n"},{0,12,0,3.7,0},{"=","=","="},{0,12,0,3.7,0},5324.01,127.41,37939.24,207.61,-9625.58,207.55,26318.58,126.08,-40659,516,8746.21,126.12,3822.49,155.35,21439.51,409.71,32792.53,126.07,3361.67,168.1,4829.63,158.73,-10382.89,207.72}
,{28,11,-988.315,10.246,7799.264,0.366,14030.529,10.44,27.998939,11,0,0.0305,"",0.0004,"",1,1,"","",{"B-","B-n"},{0,0.58,0},{"=","="},{0,0.58,0},10270.17,10.83,34215.13,111.67,-10957.75,98.21,15862.33,10.25,-33727.56,389.96,5526.98,10.25,3541.84,10.9,15328.19,91.35,6159.42,10.31,9241.38,21.09,5911.24,30.8,-6676.08,96.99}
,{28,12,-15018.845,2.001,8272.413,0.071,1831.8,2,27.983876606,2.148,0,75294,"",32.4,"",0,1,"","",{"B-"},{0},{"="},{0},14946.94,2,30077.9,18.54,-11492.11,2.07,6473.95,2,-29358.72,90.79,-5893.3,2,8503.55,2,16790.03,4.23,-19092.05,160.01,2552.74,4.03,-796.98,2.33,-7336.94,29.11}
,{28,13,-16850.645,0.077,8309.894,0.003,4642.15,0.077,27.981910087,0.083,0,134.7,"",0.3,"",3,1,"","",{"B-"},{0},{"="},{0},20783.13,0.1,24567.81,3.5,-10857.66,0.08,-9702.91,1.15,-18621.83,3.73,-12537.46,0.11,7725.1,0.06,9553,0.09,-44367,596,10074.7,0.08,1206.19,0.09,-1846.43,1.2}
,{28,14,-21492.7943,0.00049,8447.744,0,-14345.055,1.152,27.976926534,0.00052,1,"s","","s","",0,1,"","",{},{},{},{},30494.41,0.11,19856.19,0.03,-9984.14,0.01,-25566,160,-14195.15,0.05,-28841.65,26.34,17179.61,0.11,11584.9,0.05,"","",1428.16,0.07,-7712.76,0.06,-2653.61,0.05}
,{28,15,-7147.74,1.152,7907.479,0.041,-11220.945,160.004,27.992326585,1.236,0,0.2703,"",0.0005,"",3,1,"","",{"B+","B+p","B+A"},{0,0.0013,0,0.00086,0},{"=","=","="},{0,0.0013,0,0.00086,0},34263,196,9515.53,1.15,-9523.79,1.18,-34664,596,2760.15,1.15,-32247,401,14496.6,26.37,2052.21,1.16,"","",10704.08,1.16,-6111.01,10.07,7414.64,1.15}
,{28,16,4073.206,160,7478.79,5.714,-23443,617,28.004372766,171.767,0,0.125,"",0.01,"",0,1,"","",{"B+","B+p"},{0,20.7,0},{"=","="},{0,20.7,0},39148,617,3363.72,160,-9096.9,161.18,"","",9168.74,160,"","",21026,432,2493.31,162.15,"","",3811,253,-10801,431,5892.28,160.31}
,{28,17,27516,596,6614,21,"","",28.02954,640,0,"s","","s","",1,1,"","",{},{},{},{},"","",-1965,627,-8228,780,"","",20950,597,"","","","",-3200,718,"","",11149,843,"","",13424,718}
,{29,9,40150.186,525.363,6444.031,18.116,21750.385,546.221,29.043103,564,0,0.0025,"",0.0003,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,60,"",5,0},{"=","=","="},{0,60,"",5,0},1442.73,654.2,"","",-18258,727,37470.19,525.41,"","",20779.13,540.28,1662.73,656.1,19219,874,58357.95,525.36,6191,725,10353.2,550.65,"",""}
,{29,10,18399.801,149.505,7167.067,5.155,15719.807,149.685,29.019753,160.5,0,0.0147,"",0.0004,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,28,0,4,""},{"=","=","="},{0,28,0,4,""},4793.74,174.9,40848,522,-11354.14,222.72,29002.63,149.94,-40969,714,11316.8,149.86,971.25,195.56,22630.77,420.5,40294.88,149.5,3660.33,417.52,4614.98,186.32,-10614.83,222.62}
,{29,11,2679.994,7.337,7682.151,0.253,13282.824,13.557,29.002877092,7.876,0,0.0441,"",0.0009,"",0,0,"","",{"B-","B-n","B-2n"},{0,25.9,0,0,0},{"=","=","="},{0,25.9,0,0,0},7944.85,8.23,37348.23,389.9,-11079.09,96.72,20887.75,7.34,-38350.57,393.09,9627.52,7.6,4403.01,12.6,15908.71,126.28,19632.84,7.35,6339.89,91.07,7062.94,19.84,-10322.48,111.44}
,{29,12,-10602.829,11.4,8113.202,0.393,7604.931,11.405,28.988617393,12.238,0,1.3,"",0.12,"",1.5,1,"","",{"B-"},{0},{"="},{0},12158.85,11.4,32231.68,91.48,-10992.24,31.2,11292.25,11.4,-29191.54,126.58,-1823.5,11.4,3655.3,11.57,16903.48,15.33,-7446.41,51.28,5625.77,11.99,1122.01,11.93,-5437.54,21.67}
,{29,13,-18207.76,0.345,8348.464,0.012,3687.318,0.345,28.980453164,0.37,0,393.6,"",3.6,"",2.5,1,"","",{"B-"},{0},{"="},{0},17153.53,0.35,27267.91,3.74,-11274.86,1.25,-1254.91,0.5,-24508.42,10.25,-4786.28,0.34,9428.43,0.35,10477.89,2.03,-31369.94,188.68,7089.66,0.35,2870.84,0.35,-5700.58,3.52}
,{29,14,-21895.07838,0.00056,8448.635,0,-4942.23,0.359,28.976494665,0.0006,1,"s","","s","",0.5,1,"","",{},{},{},{},25653.21,0.11,21886.41,0.05,-11127.21,0.05,-18738.66,50,-14165.2,2,-22818.66,1.15,8473.6,0,12333.4,0.08,"","",6012.59,0.05,-4820.87,0.07,-34.13,0.03}
,{29,15,-16952.848,0.359,8251.236,0.012,-13796.432,50.001,28.981800368,0.385,0,4.142,"",0.015,"",0.5,1,"","",{"B+"},{0},{"="},{0},32373.02,26.34,14333.93,0.36,-10461.79,0.36,-30115.02,188.68,-7391.17,0.37,-29097.37,160,17876.43,1.21,2749.02,0.36,"","",6142.46,0.37,-4947.78,0.37,903.7,0.37}
,{29,16,-3156.416,50,7748.52,1.724,-16318.592,195.192,28.996611448,53.677,0,0.188,"",0.004,"",2.5,1,"","",{"B+","B+p"},{0,46.4,0},{"=","="},{0,46.4,0},36327,404,5349.85,50,-9408.65,50.99,"","",11047.41,50,-38744,598,15300.94,167.63,3297.65,50.01,"","",8276.85,56.51,-9265,202,9631,50}
,{29,17,13162.176,188.68,7158.832,6.506,"","",29.014130178,202.555,0,1e-11,"","s","",0.5,1,"","",{"p"},{0},{"="},{0},"","",693.31,190.51,-9001,443,"","",13020.95,188.68,"","",22425,625,-1800,100,"","",6845,443,-9052,625,7836,272}
,{30,9,48112,596,6233,20,24832,648,30.05165,640,0,2.6e-07,"","s","",0,0,"","",{},{},{},{},1773,714,"","","","",39637,596,"","",21641,615,110,795,"","",63977,596,6743,918,8306,778,"",""}
,{30,10,23280.117,253.25,7034.531,8.442,14805.448,253.295,30.024992235,271.875,0,0.00722,"",0.00018,"",0,1,"","",{"B-","B-n","B-2n"},{0,13,0,8.9,0},{"=","=","="},{0,13,0,8.9,0},4162.25,282.89,43378,743,-13805.83,302.23,32163.94,253.27,"","",12528.81,253.36,3191,294.09,24159.04,583.22,47713.08,253.25,249.33,467.55,2693.89,464.87,-15743,561}
,{30,11,8474.67,4.727,7501.968,0.158,17358.49,5.85,30.009097932,5.074,0,0.0484,"",0.0017,"",2,1,"","",{"B-","B-n","B-2n","B-A"},{0,30,0,1.15,0,5.5,0},{"=","=","=","="},{0,30,0,1.15,0,5.5,0},6679.65,11.28,39844.87,393.05,-12599.12,111.3,24339.51,5.54,-38964.49,525.38,11006.18,12.34,2276.64,8.73,17214.1,149.58,28675.52,4.73,7885.74,126.16,6287.82,90.89,-11329.21,389.86}
,{30,12,-8883.82,3.447,8054.506,0.115,6981.024,4.496,29.990462826,3.7,0,0.313,"",0.004,"",0,1,"","",{"B-","B-n"},{0,0.06,0},{"=","<"},{0,0.06,0},10007.61,3.99,34761.5,126.11,-11789.85,18.75,15549.14,3.45,-34572.59,149.54,1252.62,3.46,6352.31,11.91,18852.79,8.11,5175.43,3.45,2815.3,10.81,1498.02,5.08,-10288.33,90.84}
,{30,13,-15864.844,2.888,8261.128,0.096,8568.116,2.888,29.982968388,3.1,0,3.62,"",0.06,"",3,1,"","",{"B-"},{0},{"="},{0},15156.83,2.89,29454.47,10.65,-11428.98,4.54,4336.01,2.89,-25833.81,7.88,-2041.08,2.89,5728.4,2.91,12550.99,11.76,-20308,196,9864.81,3.51,3585.82,2.89,-4700.65,4.71}
,{30,14,-24432.96,0.022,8520.654,0.001,-4232.106,0.061,29.973770136,0.023,1,"s","","s","",0,1,"","",{},{},{},{},19082.8,0.02,23992.06,2,-10643.33,0.04,-10373.71,0.21,-21119.1,11.4,-15551.43,0.36,10609.2,0.02,13514.17,0.35,-45364.11,206.16,3128.49,0.08,-2372.04,0.05,-4199.95,0.05}
,{30,15,-20200.854,0.065,8353.506,0.002,-6141.601,0.196,29.978313489,0.069,0,149.88,"",0.24,"",1,1,"","",{"B+"},{0},{"="},{0},29195.75,1.15,17928.15,0.1,-10415.62,0.09,-24644,196,-9282.06,0.35,-25115.76,50,11319.32,0.36,5594.75,0.07,"","",12002.75,0.07,-2952.3,0.13,2642.41,0.08}
,{30,16,-14059.253,0.206,8122.707,0.007,-18502,196,29.984906769,0.221,0,1.1759,"",0.0017,"",0,1,"","",{"B+"},{0},{"="},{0},34275.09,160,7144.4,0.21,-9343.15,0.23,-34990.4,206.16,546.85,0.21,-35292.75,188.68,18974.15,50,4395.38,0.41,"","",3799.29,1.17,-8472.74,26.34,3971.65,0.23}
,{30,17,4443,196,7480,7,-16488,284,30.00477,210,0,3e-08,"","s","",3,1,"","",{},{},{},{},39216,627,2987,196,-8955,277,"","",14107,196,"","",16790,272,-311,202,"","",11081,253,-7720,446,10812,197}
,{30,18,20931.147,206.155,6904.204,6.872,"","",30.022470511,221.316,0,1e-11,"","s","",0,1,"","",{"2p"},{0},{"="},{0},"","",-2280,130,-8572,631,"","",16798.59,212.13,"","","","",-480,164.01,"","",4126,631,"","",9550,451}
,{31,9,56143,546,6033,18,24961,608,31.060272,587,0,0.001,"",2.6e-07,">",2.5,1,"","",{"B-n","B-2n"},{0,0,0},{"=","="},{0,0,0},150,150,"","","","",43897,547,"","",24791,602,40,809,"","",71094,546,"","",8927,887,"",""}
,{31,10,31181.591,266.195,6813.09,8.587,18935.559,266.562,31.033474816,285.772,0,0.0034,"",0.0008,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,10,0,4,0},{"=","=","="},{0,10,0,4,0},3360.84,305.31,"","",-15913,567,34303.74,266.21,"","",14635.6,266.24,169.84,126.54,24219,653,54130.63,266.2,1742.21,588.95,2304.05,474.69,-15252,748}
,{31,11,12246.031,13.972,7398.677,0.451,15368.182,14.307,31.013146656,15,0,0.01735,"",0.0004,"",0,0,"","",{"B-","B-n","B-2n","B-3n"},{0,37.3,0,0.87,0,0.05,0},{"=","=","=","<"},{0,37.3,0,0.87,0,0.05,0},6576.6,15.78,42482.1,525.55,-15629.16,390.08,27196.74,14.15,-43155,596,13058.53,14.39,4299.96,14.75,18323.06,253.64,36686.57,13.97,4557.04,150.16,5810.35,126.84,-15849.16,393.27}
,{31,12,-3122.151,3.074,7869.188,0.099,11828.555,3.801,30.996648232,3.3,0,0.236,"",0.02,"",0,0,"","",{"B-","B-n"},{0,6.2,0},{"=","="},{0,6.2,0},8661.96,11.81,36099.89,149.54,-12597.98,90.82,19826.89,3.07,-33691.24,253.27,4671.38,4.22,2309.65,4.62,18885.79,5.64,15920.37,3.08,4908.66,7.95,2730.22,10.7,-8775.49,126.11}
,{31,13,-14950.706,2.236,8225.517,0.072,7998.33,2.236,30.983949756,2.4,0,0.644,"",0.025,"",0,0,"","",{"B-","B-n"},{0,1.6,0},{"=","<"},{0,1.6,0},12885.58,2.26,32208.64,7.67,-11857.83,4.35,9489.84,2.24,-30714.35,5.23,1410.94,2.24,7157.18,3.65,13355.86,4.11,-7916.15,4.11,6362.93,11.62,4932.19,3,-8315.99,10.49}
,{31,14,-22949.036,0.043,8458.291,0.001,1491.505,0.043,30.975363194,0.046,0,9441.6,"",15.6,"",1.5,1,"","",{"B-"},{0},{"="},{0},17196.59,0.04,26924.15,11.4,-10787.34,0.07,-3906.51,0.23,-21354.19,3.45,-10819.5,0.07,6587.39,0.04,14373.16,2.89,-34274,200,5969.53,0.35,-1234.34,0.09,-2283.79,2}
,{31,15,-24440.54095,0.00067,8481.167,0,-5398.016,0.229,30.973761998,0.00072,1,"s","","s","",0.5,1,"","",{},{},{},{},23630.33,0.36,20810.72,0.34,-9668.6,0.05,-17405.99,3.45,-15864.67,2.89,-18452.6,0.21,12311,0.07,7296.55,0.02,"","",8165.34,0,1916.31,0,-1943.49,0.08}
,{31,16,-19042.525,0.229,8281.8,0.007,-12007.974,3.454,30.979557007,0.246,0,2.5534,"",0.0018,"",0.5,1,"","",{"B+"},{0},{"="},{0},32028.74,50,11725.39,0.23,-9082.94,0.25,-30368,200,-1898.54,0.23,-31557,196,13054.59,0.31,6130.64,0.24,"","",8621.13,0.43,-7030.73,1.17,8096.67,0.23}
,{31,17,-7034.551,3.447,7869.209,0.111,-18360,200,30.992448098,3.7,0,0.19,"",0.001,"",1.5,1,"","",{"B+","B+p"},{0,2.4,0},{"=","="},{0,2.4,0},36339.36,188.71,4659.64,3.47,-8737.01,26.56,"","",5877.33,3.45,-36037.01,206.18,19549,196,264.27,3.45,"","",6832.67,50.12,-6243.7,160.04,5759.59,3.63}
,{31,18,11325,200,7252,6,"","",31.012158,215,0,0.0151,"",0.0003,"",2.5,1,"","",{"B+","B+p","B+2p","B+pA","B+3p","B+A","2p"},{0,68.3,0,9,0,0.38,0,0.07,0,0.03,0,0.0006,0},{"=","=","=","<","=","<","<"},{0,68.3,0,9,0,0.38,0,0.07,0,0.03,0,0.0006,0},"","",96,206,-8127,448,"","",18096,200,"","",17677,287,407,280,"","",8874,275,-11327,629,12899,256}
,{32,10,36999,503,6671,16,18359,504,32.03972,540,0,0.0035,"",0.0009,"",0,1,"","",{"B-","B-n","B-2n"},{0,30,0,7,0},{"=","=","="},{0,30,0,7,0},2424,563,"","",-17506,861,37828,503,"","",16682,503,2254,569,26433,743,61077,503,-402,780,1713,727,"",""}
,{32,11,18640.151,37.26,7219.881,1.164,19469.051,37.402,32.020011026,40,0,0.0129,"",0.0003,"",3,-1,"","",{"B-","B-n","B-2n"},{0,24,0,8,""},{"=","=","="},{0,24,0,8,""},5977.15,37.56,44049,597,-17526.36,394.79,29739.52,37.94,-44792,548,13690.98,37.39,1677.2,39.79,19830.41,268.79,42945.02,37.26,6070.84,255.98,5104.4,154.08,-15863.63,526.68}
,{32,12,-828.9,3.26,7803.84,0.102,10270.467,7.879,31.999110139,3.5,0,0.086,"",0.005,"",0,1,"","",{"B-","B-n"},{0,5.5,0},{"=","="},{0,5.5,0},8087.71,4.74,38686.96,253.27,-14553.55,126.11,23248.79,3.27,-39299.46,266.22,6050.49,3.95,5778.07,4.48,20363.9,14.35,25186.63,3.26,1407.24,5.74,1355.16,8.03,-13582.3,149.54}
,{32,13,-11099.367,7.173,8100.344,0.224,12978.319,7.179,31.988084339,7.7,0,0.033,"",0.0002,"",1,1,"","",{"B-","B-n"},{0,0.7,0},{"=","="},{0,0.7,0},11377.16,7.73,34151.98,8.59,-12535.97,12.51,13205.51,7.17,-30634.37,15.71,3778.35,7.17,4219.98,7.51,15266.19,7.8,2235.31,7.19,8495.26,7.96,4367.52,13.47,-8132.96,10.26}
,{32,14,-24077.686,0.298,8481.468,0.009,227.188,0.301,31.974151539,0.32,0,4828209678,"",599581594,"",0,1,"","",{"B-"},{0},{"="},{0},15787.36,0.3,29771.81,3.46,-11483.76,2.02,1937.85,0.3,-28244.51,3.09,-7708.46,0.3,9199.97,0.3,16415.95,2.26,-21877.34,1.79,2497.96,2.9,-1005.87,0.46,-7828.45,11.4}
,{32,15,-24304.874,0.04,8464.12,0.001,1710.66,0.04,31.973907643,0.042,0,1232755.2,"",432,"",1,1,"","",{"B-"},{0},{"="},{0},20246.65,0.08,23017.97,2.89,-9879.14,0.09,-10970.2,0.56,-16643.14,2.24,-13333.67,0.23,7935.65,0.04,8644.81,0.06,-45403,401,10838.89,0.05,2454.26,0.04,-450.71,0.35}
,{32,16,-26015.53355,0.00132,8493.129,0,-12680.86,0.562,31.972071174,0.00141,1,"s","","s","",0,1,"","",{},{},{},{},28098.91,0.21,16160.51,0.02,-6947.65,0,-23815.18,1.77,-10355.47,0.04,-27052.3,3.45,15044.33,0.23,8863.96,0,"","",4896.13,0.07,-4198.63,0.36,1525.95,0}
,{32,17,-13334.674,0.562,8072.404,0.018,-11134.323,1.857,31.985684637,0.603,0,0.298,"",0.001,"",1,1,"","",{"B+","B+A","B+p"},{0,0.054,0,0.026,0},{"=","=","="},{0,0.054,0,0.026,0},33921,196,7711.76,0.57,-8611.85,1.26,-34433,401,3816.9,0.56,-32731,200,14371.44,3.49,1581.12,0.53,"","",11435.39,0.6,-5314.2,50,9264.58,0.67}
,{32,18,-2200.351,1.77,7700.008,0.055,-23299,401,31.997637826,1.9,0,0.098,"",0.002,"",0,1,"","",{"B+","B+p"},{0,35.58,0},{"=","="},{0,35.58,0},39274.13,206.16,2719.04,1.78,-8698.47,160.01,"","",9553.2,1.78,"","",21597,200,2454.77,3.87,"","",4067,196,-10498.47,188.69,6602.47,50.03}
,{32,19,21098,401,6947,13,"","",32.02265,430,0,"s","","s","",1,1,"","",{},{},{},{},"","",-2077,446,-8843,718,"","",20844,401,"","","","",-2484,448,"","",10878,450,"","",13583,443}
,{33,10,45997,596,6440,18,22217,747,33.04938,640,0,2.6e-07,"","s","",3.5,-1,"","",{},{},{},{},1327,653,"","","","",41035,596,"","",19286,597,-927,780,"","",66511,596,565,809,2750,843,"",""}
,{33,11,23780.11,449.912,7089.926,13.634,18817.813,449.921,33.025529,483,0,0.0082,"",0.0004,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,47,0,13,0},{"=","=","="},{0,47,0,13,0},4608.56,450.13,46941,708,-18794.99,691.68,32277.49,449.97,"","",16537.69,449.92,2931.36,451.45,20508,675,50117.46,449.91,3309.33,522.76,5364.05,516.29,-18685,747}
,{33,12,4962.297,2.888,7636.455,0.088,13459.677,7.559,33.005327245,3.1,0,0.0905,"",0.0016,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,14,0,3,0},{"=","=","="},{0,14,0,3,0},8058.19,4.22,40797.23,266.21,-15862.42,149.53,25476.62,2.97,-39326,503,7990.35,7.73,2280.12,4.36,20966.82,37.37,31548.15,2.89,3427.07,14.27,1351.68,5.54,-12671.42,253.27}
,{33,13,-8497.38,6.986,8020.616,0.212,12016.945,7.021,32.990877687,7.5,0,0.0417,"",0.0002,"",2.5,1,"","",{"B-","B-n"},{0,8.5,0},{"=","="},{0,8.5,0},9689.31,7.34,35321.35,15.62,-13602.29,10.13,17839.97,7.07,-34426.5,37.91,7508.99,6.99,5469.33,10.01,14957.45,7.71,12505.96,7,5335.58,7.63,5250.5,7.79,-11325.65,8.44}
,{33,14,-20514.325,0.699,8361.059,0.021,5823.021,1.295,32.977976964,0.75,0,6.18,"",0.18,"",1.5,1,"","",{"B-"},{0},{"="},{0},13707.92,0.7,31970.12,3.15,-12336.41,11.42,6071.53,0.7,-26974.4,3.33,-4280.77,0.7,4507.96,0.76,16703.93,7.21,-11130.03,0.81,5147.19,2.34,214.57,2.97,-5984.1,3.52}
,{33,15,-26337.346,1.09,8513.806,0.033,248.508,1.09,32.971725694,1.17,0,2190240,"",9504,"",0.5,1,"","",{"B-"},{0},{"="},{0},18039.44,1.09,25964.58,2.49,-10554.5,1.14,-5334.01,1.16,-22526.95,7.25,-8393.13,1.09,10103.79,1.09,9548.63,1.13,-33379,196,7322.5,1.09,2959.67,1.09,-4826.1,3.09}
,{33,16,-26585.85434,0.00135,8497.63,0,-5582.517,0.391,32.971458909,0.00145,1,"s","","s","",1.5,1,"","",{},{},{},{},23685.96,0.23,18214.76,0.04,-7115.69,0,-17201.56,0.4,-9797.14,0.3,-21322.5,0.56,8641.64,0,9569.95,0.04,"","",8565.49,0,-1520.95,0.07,3493.51,0.02}
,{33,17,-21003.337,0.391,8304.755,0.012,-11619.044,0.56,32.977451989,0.419,0,2.5038,"",0.0022,"",1.5,1,"","",{"B+"},{0},{"="},{0},30111.42,3.47,11140.74,0.39,-6475.4,0.53,-28045,196,-3987.43,0.39,-26874.3,1.81,15739.98,0.68,2276.77,0.39,"","",8749.99,0.45,-2080.03,0.44,4843.92,0.4}
,{33,18,-9384.292,0.401,7928.955,0.012,-16426,196,32.989925547,0.43,0,0.173,"",0.002,"",0.5,1,"","",{"B+","B+p"},{0,38.7,0},{"=","="},{0,38.7,0},36852,200,4919.71,0.46,-8652.79,50,"","",9342.27,0.4,-38554,401,15255.26,1.81,3338.59,0.69,"","",8361.06,3.47,-8963,196,10321.36,0.45}
,{33,19,7042,196,7407,6,"","",33.00756,210,0,2.5e-08,"","s","",1.5,1,"","",{},{},{},{},"","",501,196,-8545,272,"","",13088,196,"","",22128,446,-1953,196,"","",6427,280,-9025,284,8245,277}
,{34,10,52842,513,6287,15,21161,789,34.056728,551,0,0.001,"",1.5e-06,">",0,1,"","",{"B-2n","B-n"},{0,1,0},{"=","="},{0,1,0},300,100,"","","","",44518,514,"","",20990,682,1227,786,"","",72798,513,"","",1563,749,"",""}
,{34,11,31680.111,599.416,6886.437,17.63,23356.764,600.112,34.03401,643.5,0,0.0055,"",0.001,"",1,1,"","",{"B-","B-2n","B-n"},{0,50,0,15,0},{"=","~","~"},{0,50,0,15,0},3102.67,600.57,"","",-18856,845,34680.4,599.42,"","",18646.5,599.42,171.32,749.48,21606,845,56228.81,599.42,5392,783,5362.58,655.87,-18816,811}
,{34,12,8323.348,28.876,7550.39,0.849,11323.637,29.039,34.008935481,31,0,0.02,"",0.01,"",0,1,"","",{"B-","B-n","B-2n"},{0,30,0,"",""},{"=","=",""},{0,30,0,"",""},6990.39,29.06,43254,504,-17381.69,254.89,28280.2,32.14,-44963,597,8749.41,29.71,4710.27,29.02,22745.73,450.84,38255.03,28.88,394,47.14,941.37,32.08,-17211.84,267.76}
,{34,13,-3000.289,3.074,7860.428,0.09,16956.563,14.448,33.996779057,3.3,0,0.0563,"",0.0005,"",4,-1,"","",{"B-","B-n","B-2n"},{0,26,0,"",""},{"=","=",""},{0,26,0,"",""},8043.56,7.8,36218.38,37.39,-13899.87,5.64,21548.41,3.18,-34069.37,449.92,9442.72,3.15,2574.23,7.63,15251.56,4.22,21439.79,3.07,8539.42,4.48,4985.92,4.35,-9599.92,14.31}
,{34,14,-19956.852,14.118,8336.141,0.415,4591.847,14.141,33.978575437,15.155,0,2.77,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},12021.8,14.12,33705.89,14.49,-13497.95,14.53,9974.83,14.12,-32208.12,14.41,-1690.82,14.16,7513.84,14.13,18748.44,15.75,-1578.56,14.12,1853.32,15.84,-142.09,14.29,-11188.3,14.45}
,{34,15,-24548.698,0.81,8448.185,0.024,5382.987,0.812,33.973645887,0.87,0,12.43,"",0.1,"",1,1,"","",{"B-"},{0},{"="},{0},16386.46,0.81,28027.27,7.22,-11108.77,3,-108.62,0.81,-23340.29,7.03,-6034.16,0.81,6282.67,1.36,11323.34,1.07,-23328,196,10239.79,0.86,3264.39,0.81,-3951.59,2.38}
,{34,16,-29931.685,0.045,8583.498,0.001,-5491.603,0.038,33.967867012,0.047,1,"s","","s","",0,1,"","",{},{},{},{},20058.79,0.04,20431.94,0.3,-7923.64,0.05,-11553.4,0.07,-16706.33,0.7,-16999.67,0.39,11417.15,0.04,10883.31,1.09,-43783,298,5083.99,0.06,-627.09,0.04,-1336.25,0.06}
,{34,17,-24440.082,0.049,8398.97,0.001,-6061.792,0.063,33.973762491,0.052,0,1.5266,"",0.0004,"",0,1,"","",{"B+"},{0},{"="},{0},27248.04,0.56,14713.15,0.06,-6664.14,0.08,-23220,196,-5391.71,1.09,-23127.11,0.4,11508.06,0.39,5143.2,0.05,"","",12286.26,0.05,-533.5,0.23,5646.86,0.05}
,{34,18,-18378.29,0.078,8197.672,0.002,-17158,196,33.980270093,0.083,0,0.8438,"",0.0004,"",0,1,"","",{"B+"},{0},{"="},{0},32320.57,1.77,6940.7,0.08,-6743.95,0.22,-32230,298,918.59,0.08,-33492,196,17065.31,0.41,4663.92,0.4,"","",5667.19,0.57,-6479.68,3.45,6310.64,0.24}
,{34,19,-1220,196,7670,6,-15072,357,33.99869,210,0,4e-08,"","s","",1,1,"","",{},{},{},{},38461,446,2464,196,-8088,277,"","",12494,196,"","",16334,277,-875,196,"","",11691,196,-7682,280,11461,196}
,{34,20,13851,298,7204,9,"","",34.01487,320,0,3.5e-08,"","s","",0,1,"","",{},{},{},{},"","",-1474,298,-9505,362,"","",15947,298,"","","","",480,357,"","",3464,499,"","",8172,359}
,{35,11,38231,670,6733,19,22592,723,35.041043,720,0,0.0015,"",0.0005,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,60,0,10,0},{"=","=","="},{0,60,0,10,0},1691,807,"","",-20336,865,38455,670,"","",21837,671,1520,300,21899,844,63089,670,2945,897,6097,838,"",""}
,{35,12,15639.784,269.668,7356.233,7.705,15863.512,269.768,35.01679,289.5,0,0.07,"",0.04,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,52,"",20,0},{"=","=","="},{0,52,"",20,0},5465.15,269.68,44935,654,-17966.72,378.92,30031.24,272.04,-44491,579,10568.76,269.69,754.88,271.21,23329.3,657.28,44485.99,269.67,2570.48,524.54,1863.69,272.23,-15713,571}
,{35,13,-223.728,7.359,7787.124,0.21,14167.729,36.605,34.999759817,7.9,0,0.0372,"",0.0008,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,38,0,"",""},{"=","=",""},{0,38,0,"",""},7868.98,10.15,38581.78,449.97,-14894.68,15.79,24634.07,7.59,-39192.81,599.46,11661.81,15.92,5294.76,7.98,15836.05,29.8,28789.8,7.36,5524.78,7.91,5469.23,8.05,-13217.48,37.98}
,{35,14,-14391.457,35.857,8169.563,1.024,10466.342,35.905,34.984550134,38.494,0,0.78,"",0.12,"",3.5,-1,"","",{"B-","B-n"},{0,5,0},{"=","<"},{0,5,0},10019.77,35.86,33931.7,35.97,-13694.22,35.99,14454.75,35.86,-30003.78,46.04,2085.92,35.87,2505.92,38.54,18680.14,35.99,8655.83,35.86,4816.73,36.53,1571.96,36.57,-7916.16,36.01}
,{35,15,-24857.799,1.866,8446.249,0.053,3988.407,1.867,34.973314053,2.003,0,47.3,"",0.8,"",0.5,1,"","",{"B-"},{0},{"="},{0},14663.09,2.16,30938.36,7.23,-12332.01,2.91,4155.73,1.87,-29146.48,3.6,-2997.43,1.87,8380.42,2.03,12189.92,14.24,-13684.91,1.94,6367.33,1.99,4083.94,1.89,-8112.03,7.41}
,{35,16,-28846.206,0.04,8537.85,0.001,167.322,0.026,34.969032322,0.043,0,7548768,"",3456,"",1.5,1,"","",{"B-"},{0},{"="},{0},18402.99,0.04,22909.82,0.7,-8322.09,0.06,-5798.92,0.68,-16178.33,14.12,-12477.44,0.05,6985.84,0.04,11586.48,0.81,-33634,196,8201.95,1.09,322.72,0.06,877.88,0.3}
,{35,17,-29013.528,0.035,8520.278,0.001,-5966.243,0.679,34.968852694,0.038,1,"s","","s","",1.5,1,"","",{},{},{},{},24152.83,0.39,17254.12,1.09,-6997.9,0.04,-17840.64,0.51,-11753.8,0.81,-18706.56,0.08,12644.76,0.05,6370.81,0.04,"","",8283.13,0.04,1866.06,0.04,937.75,0.05}
,{35,18,-23047.284,0.68,8327.461,0.019,-11874.394,0.852,34.975257721,0.73,0,1.7756,"",0.001,"",1.5,1,"","",{"B+"},{0},{"="},{0},29805.63,0.79,11039.37,0.68,-6429.68,0.72,-27835,196,-404.57,0.68,-29898,196,12740.31,0.68,5896.17,0.68,"","",8666.86,0.78,-4848.56,0.88,8614.65,0.68}
,{35,19,-11172.891,0.512,7965.84,0.015,-15961,196,34.988005407,0.55,0,0.178,"",0.008,"",1.5,1,"","",{"B+","B+p"},{0,0.37,0},{"=","="},{0,0.37,0},34358,196,4747.49,0.64,-6563.26,3.48,"","",5978.22,0.51,-33096,298,18024,196,83.57,0.52,"","",8922.21,0.65,-4108.48,1.84,7808.18,0.76}
,{35,20,4788,196,7487,6,"","",35.00514,210,0,0.0257,"",0.0002,"",0.5,1,"","",{"B+","B+p","B+2p"},{0,95.9,0,4.1,0},{"=","=","="},{0,95.9,0,4.1,0},"","",406,196,-8962,280,"","",15877,196,"","",17135,357,1281,277,"","",8457,277,-11446,446,12635,196}
,{36,11,46303,678,6546,19,25923,967,36.049708,728,0,1.8e-07,"","s","",0,0,"","",{},{},{},{},1520,316,"","","","",40352,694,"","",22592,729,0,100,"","",66554,678,4172,850,5170,903,"",""}
,{36,12,20380.157,690.237,7244.419,19.173,14429.774,706.243,36.021879,741,0,0.0039,"",0.0013,"",0,1,"","",{"B-","B-n","B-2n"},{0,30,0,3,0},{"=","=","="},{0,30,0,3,0},4085.82,690.84,47039,860,-19044,854,32816.28,693.96,"","",12532.57,690.28,3330.94,741.05,25140,962,51044.29,690.24,-589.15,914.18,1464.1,823.92,-19971,912}
,{36,13,5950.384,149.505,7623.515,4.153,18386.508,165.851,36.006388,160.5,0,0.09,"",0.04,"",0,0,"","",{"B-","B-n","B-2n"},{0,30,0,7,0},{"=","<","="},{0,30,0,7,0},7191.96,149.54,40307.67,617.78,-15114.68,154.08,26201.42,150.08,-39570,687,12270.52,153.74,1897.21,149.69,16978.37,308.34,35472.39,149.5,8337.84,152.27,5852.14,149.53,-12183.33,474.1}
,{36,14,-12436.124,71.797,8112.519,1.994,7814.911,72.985,35.986649271,77.077,0,0.45,"",0.06,"",0,1,"","",{"B-","B-n"},{0,12,0},{"=","="},{0,12,0},8621.91,73.17,35337.41,77.39,-14032.14,71.87,18228.01,71.8,-35364.88,279.06,4350.36,71.82,6115.98,80.25,19501.37,72.17,17795.42,71.8,1274.97,71.86,925.31,72.14,-11752.02,71.86}
,{36,15,-20251.034,13.114,8307.868,0.364,10413.096,13.112,35.978259619,14.078,0,5.6,"",0.3,"",4,-1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},11844.97,13.14,31828.69,13.47,-11576.58,14.95,9270.97,13.11,-27316.28,15.04,523.85,13.11,3464.55,13.24,13148.55,38.18,-2833.97,13.12,10416.62,19.27,5127.35,13.13,-6107.25,14.86}
,{36,16,-30664.131,0.188,8575.389,0.005,-1142.126,0.189,35.967080699,0.201,1,"s","","s","",0,1,"","",{},{},{},{},16875.08,0.19,25285.22,14.12,-9011.36,0.35,-432.59,0.19,-23561.64,35.86,-9721.92,0.19,9889.24,0.19,13095.3,1.86,-24212.98,40,4595.37,0.83,537.27,1.11,-4503.4,0.72}
,{36,17,-29522.005,0.036,8521.931,0.001,709.535,0.045,35.968306822,0.038,0,9508101803800,"",47335389000,"",2,1,"","",{"B-","B+"},{0,1.9,0},{"=","="},{0,1.9,0},21224.56,0.05,19551.25,0.81,-7642.05,0.05,-12104.94,0.34,-11953.18,1.87,-14546.04,0.68,8579.79,0,7964.77,0.03,-44873,298,11120.49,0.04,1927.9,0.04,2461.74,1.09}
,{36,18,-30231.54,0.027,8519.909,0.001,-12814.475,0.342,35.967545105,0.028,1,"s","","s","",0,1,"","",{},{},{},{},27995.88,0.08,14877.8,0.05,-6640.92,0.03,-23780.39,40,-8674.3,0.05,-27129.97,0.51,15255.57,0.68,8506.98,0.04,"","",4919.35,0.06,-4364.15,0.39,2000.72,0.03}
,{36,19,-17417.065,0.341,8142.219,0.009,-10965.916,40.001,35.98130201,0.366,0,0.341,"",0.003,"",2,1,"","",{"B+","B+p","B+A"},{0,0.048,0,0.0034,0},{"=","=","="},{0,0.048,0,0.0034,0},32339,196,7554.92,0.34,-6507.31,0.61,-32768,298,4307.49,0.34,-30276,196,14315.49,0.62,1658.75,0.76,"","",11672.03,0.35,-3168.72,0.53,9232.67,0.52}
,{36,20,-6451.149,40,7815.879,1.111,-21802,301,35.993074406,42.941,0,0.1012,"",0.0015,"",0,1,"","",{"B+","B+p"},{0,51.2,0},{"=","="},{0,51.2,0},36445,301,2650.8,40,-6675.71,40.04,"","",9307.16,40.01,"","",19310,200,2567.23,40,"","",5480,200,-8629,200,8579.55,40}
,{36,21,15351,298,7189,8,"","",36.01648,320,0,"s","","s","",0,0,"","",{},{},{},{},"","",-1993,357,-8172,499,"","",19235,298,"","","","",-3274,357,"","",12211,422,"","",13955,357}
,{37,11,53534,687,6392,19,25323,980,37.057471,737,0,0.001,"",1.5e-06,">",1.5,1,"","",{"B-n","B-2n"},{0,50,0},{"=","="},{0,50,0},840,150,"","","","",43724,710,"","",25083,974,840,180,"","",72530,688,"","",5557,857,"",""}
,{37,12,28211.474,698.947,7055.111,18.89,18401.911,721.814,37.030286265,750.35,0,0.008,"",0.004,"",1.5,-1,"","",{"B-n","B-2n"},{0,20,0},{"=","="},{0,20,0},3570.94,749.16,"","",-20211,919,34782.99,708.15,"","",14189.77,714.76,240,110,25380,974,55107.89,698.95,691,968,1395.42,920.78,-18984,867}
,{37,13,9809.563,180.244,7531.315,4.871,16381.075,213.168,37.010531,193.5,0,0.0115,"",0.0004,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,29,0,1,""},{"=",">",">"},{0,29,0,1,""},6109.34,180.39,43000,694,-16395.46,484.67,28805.56,184.2,-43782,701,14174.37,194.02,4212.14,234.18,17859.56,713.38,41571.1,180.24,4880.59,324.36,6350.27,182.54,-16224.15,625.93}
,{37,14,-6571.511,113.809,7952.903,3.076,12424.486,119.969,36.992945191,122.179,0,0.09,"",0.06,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,17,"","",""},{"=","=",""},{0,17,"","",""},8322.69,119.32,36789.24,292.7,-13958.72,113.85,20324.91,113.81,-34240.64,699.56,5608.21,114.56,2206.7,134.56,19810.87,187.89,24376.15,113.81,4363.02,114.05,1292.83,113.85,-9248.46,117.42}
,{37,15,-18995.998,37.948,8267.555,1.026,7900.419,37.947,36.979606956,40.738,0,2.31,"",0.13,"",0.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10280.83,37.99,33350.21,38.65,-12923.53,38.59,12765.54,37.95,-32235.35,154.25,3596.82,37.95,6816.28,40.15,13848.84,81.21,5804.2,37.95,6106.27,52.21,5824.91,40.49,-10349.31,38.07}
,{37,16,-26896.417,0.198,8459.935,0.005,4865.121,0.196,36.971125507,0.212,0,303,"",1.2,"",3.5,-1,"","",{"B-"},{0},{"="},{0},14192.84,0.2,27082.9,35.86,-8807.01,0.73,4051.25,0.28,-21749.26,71.8,-5445.73,0.2,4303.6,0.06,13934.35,13.11,-13760.35,0.66,8672.19,1.86,2516.34,0.83,-1293.16,14.12}
,{37,17,-31761.538,0.052,8570.281,0.001,-813.873,0.2,36.965902584,0.055,1,"s","","s","",1.5,1,"","",{},{},{},{},18890.64,0.06,21481.68,1.87,-7849.11,1.09,-6961.34,0.11,-18799.47,13.11,-9601.32,0.06,10310.85,0.06,8386.38,0.19,-35282,300,7795.47,0.07,3034.2,0.07,-1566.44,0.81}
,{37,18,-30947.664,0.207,8527.139,0.006,-6147.465,0.227,36.966776314,0.221,0,3024950.4,"",1641.6,"",1.5,1,"","",{"EC"},{0},{"="},{0},24043.01,0.71,16679.4,0.21,-6786.73,0.21,-17811.6,0.67,-7572.5,0.27,-21601.92,0.4,8787.44,0.21,8714.63,0.21,"","",8776.67,0.21,-1643.53,0.21,4630.42,0.21}
,{37,19,-24800.199,0.094,8339.847,0.003,-11664.133,0.641,36.973375889,0.1,0,1.2365,"",0.0009,"",1.5,1,"","",{"B+"},{0},{"="},{0},29769.94,0.52,10364.61,0.1,-6221.78,0.4,-28320,300,-2567.16,0.1,-26420.37,40,15454.45,0.35,1857.63,0.09,"","",8957.89,0.69,-1557.85,0.12,5286.28,0.11}
,{37,20,-13136.066,0.634,8003.456,0.017,-16656,300,36.985897852,0.68,0,0.1811,"",0.001,"",1.5,1,"","",{"B+","B+p"},{0,82.1,0},{"=","="},{0,82.1,0},34067,196,4666.72,0.93,-6176.69,0.75,"","",9806.5,0.63,-36558,298,14756.23,40.01,3007.97,0.72,"","",8747.63,0.82,-7052,196,10888.63,0.64}
,{37,21,3520,300,7532,8,"","",37.003779,322,0,"s","","s","",3.5,-1,"","",{},{},{},{},"","",-115,300,-5947,358,"","",13648,300,"","",19902,423,-2682,303,"","",9443,358,-5467,423,10387,358}
,{38,12,34074,503,6928,13,17864,627,38.03658,540,0,0.001,"",2.6e-07,">",0,1,"","",{"B-","B-n","B-2n"},{0,80,0,7,0},{"=","=","="},{0,80,0,7,0},2449,854,"","",-21192,718,38244,514,"","",16193,534,2209,861,26749,851,60935,503,-1518,844,707,838,"",""}
,{38,13,16209.859,374.461,7377.097,9.854,20380.157,388.847,38.017402,402,0,0.009,"",0.0007,"",0,0,"","",{"B-","B-n","B-2n"},{0,0,0,10,0},{"=","=","="},{0,0,0,10,0},5883.16,403.2,44671,774,-17895.17,706.77,30831.42,381.43,-44613,782,14710.05,391.37,1671.02,415.58,19290.59,792.94,46007.96,374.46,6540.51,785.27,5434.13,461.46,-16375,768}
,{38,14,-4170.299,104.793,7892.829,2.758,10451.265,127.474,37.995523,112.5,0,0.09,"",1e-06,">",0,1,"","",{"B-","B-n"},{0,30,0},{"=","="},{0,30,0},7876.81,127.03,39128.4,698.15,-14918.56,108.7,22690.9,105.04,-39670.74,706.76,6754.38,111.45,5670.1,154.71,21268.83,208.49,30544.52,104.79,590.12,182.57,917.48,105.05,-14163.68,289.31}
,{38,15,-14621.563,72.581,8147.274,1.91,12239.64,72.934,37.984303105,77.918,0,0.64,"",0.14,"",2,-1,"","",{"B-","B-n"},{0,12,0},{"=","="},{0,12,0},10513.16,73.76,35149.89,166.19,-14046.19,72.65,15176.54,72.58,-31720.1,194.31,4203.54,72.58,3696.88,81.9,15339.02,134.98,14179.19,72.58,8525.37,102.09,4633.95,80.95,-8751.43,72.95}
,{38,16,-26861.203,7.172,8448.782,0.189,2936.9,7.171,37.97116331,7.699,0,10218,"",42,"",0,1,"","",{"B-"},{0},{"="},{0},12339.71,7.17,29003.02,72.15,-9329.27,15.83,7853.62,7.17,-27578.66,114.04,-3170.98,7.17,8036.1,7.17,15154.18,38.62,-4802.7,7.17,4100.64,14.95,2860.65,7.41,-6823.34,36.57}
,{38,17,-29798.103,0.098,8505.481,0.003,4916.718,0.218,37.968010418,0.105,0,2234.4,"",3,"",2,-1,"","",{"B-"},{0},{"="},{0},16418.73,0.1,24125.01,13.11,-7674.32,0.82,-997.35,0.22,-18091.08,37.95,-6921.76,0.22,6107.88,0.08,10190.66,0.21,-25549,200,11576.83,0.2,3912.16,0.11,706.1,1.87}
,{38,18,-34714.821,0.195,8614.28,0.005,-5914.066,0.045,37.962732104,0.209,1,"s","","s","",0,1,"","",{},{},{},{},20625.92,0.2,18628.63,0.27,-7208.05,0.2,-12656.32,0.06,-15107.37,0.28,-17985.94,0.22,11838.47,0.28,10242.25,0.2,-45584,300,5517.99,0.2,-837.24,0.2,-222.21,0.2}
,{38,19,-28800.755,0.195,8438.058,0.005,-6742.256,0.063,37.969081116,0.209,0,458.16,"",1.08,"",3,1,"","",{"B+"},{0},{"="},{0},27526.32,0.39,13856.69,0.2,-6785.59,0.2,-24551,200,-4328.19,0.2,-23736.01,0.66,12071.87,0.22,5142.06,0.28,"","",12141.59,0.2,-889.42,0.71,5859.17,0.2}
,{38,20,-22058.499,0.194,8240.043,0.005,-17809,200,37.976319226,0.208,0,0.4437,"",0.00025,"",0,1,"","",{"B+"},{0},{"="},{0},31749.98,40,6404.9,0.2,-6105.12,0.21,-32928,300,1600.19,0.28,-33650,300,16993.75,0.66,4547.27,0.22,"","",6069.37,0.39,-6021.55,0.55,6635.19,0.71}
,{38,21,-4249,200,7751,5,-15119,361,37.995438,215,0,3e-07,"","s","",2,-1,"","",{},{},{},{},35743,359,1410,200,-5454,280,"","",13262,200,"","",15841,361,-1598,200,"","",12912,204,-4173,280,12570,200}
,{38,22,10870,300,7332,8,"","",38.011669,322,0,1.2e-07,"","s","",0,1,"","",{},{},{},{},"","",-2743,303,-5407,423,"","",16717,300,"","","","",-61,424,"","",6229,423,"","",11728,358}
,{39,12,42275,513,6747,13,21625,650,39.045384,551,0,1.8e-07,"","s","",3.5,-1,"","",{},{},{},{},2079,867,"","","","",39955,530,"","",17994,635,-130,100,"","",65438,515,-548,857,837,850,"",""}
,{39,13,20650,400,7281,10,18330,422,39.022169,429,0,0.0076,"",0.0016,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,90,0,1,0},{"=","=","="},{0,90,0,1,0},5302,438,47462,795,-20006,780,33425,415,"","",16749,413,3631,548,20713,642,50450,400,3150,805,5134,798,-20006,787}
,{39,14,2320.352,135.532,7730.979,3.475,15094.986,176.232,39.002491,145.5,0,0.0475,"",0.002,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,25,0,2,0},{"=","=","="},{0,25,0,2,0},7250.77,176.98,40469.06,711.97,-15744.35,301.81,25483.02,144.46,-39043,521,8870.6,153.74,1580.67,171.32,21178.48,398.23,35562.54,135.62,3221.59,225.51,1234.02,201.79,-12413.4,703.42}
,{39,15,-12774.634,112.645,8097.969,2.888,10388.033,123.243,38.986285865,120.929,0,0.282,"",0.024,"",0.5,1,"","",{"B-","B-n"},{0,26,0},{"=","="},{0,26,0},9921.27,118.86,37162.14,212.55,-14975.82,112.88,17025.57,112.66,-36273.46,391.04,6015.25,112.87,6224.39,134,15893.31,153.85,21032.56,112.64,4507.68,160.13,4525.54,133.58,-13078.62,187.19}
,{39,16,-23162.667,50,8344.269,1.282,6637.538,50.03,38.975133852,53.677,0,11.5,"",0.5,"",0,0,"","",{"B-"},{0},{"="},{0},12408.88,50,31169.1,124.31,-11196.13,61.53,10079.52,50.25,-26281.34,116.11,-1435.88,50,4372.78,50.51,15830.07,88.14,4120.04,50,6544.14,62.77,1952.42,51.69,-5080.14,87.49}
,{39,17,-29800.205,1.732,8494.402,0.044,3441.985,5.292,38.968008162,1.859,0,3372,"",36,"",1.5,1,"","",{"B-"},{0},{"="},{0},14181.3,1.73,25382.15,37.99,-7367.32,2.55,4006.99,1.73,-22467.61,72.6,-3156.7,1.74,8073.42,1.73,10227.97,7.38,-15627.5,24.06,7807.02,1.74,5727.98,1.74,-3902.77,13.23}
,{39,18,-33242.19,5,8562.598,0.128,565,5,38.964313039,5.367,0,8488813094,"",94670778,"",3.5,-1,"","",{"B-"},{0},{"="},{0},18437.16,5,20923.71,5,-6820.9,5,-5959.49,5.04,-13669.96,8.74,-12512.75,5,6598.69,5,10733.06,5,-35442,200,9230.15,5,1143.87,5,3068.34,5}
,{39,19,-33807.1901,0.00458,8557.025,0,-6524.488,0.596,38.963706486,0.00492,1,"s","","s","",1.5,1,"","",{},{},{},{},25149.63,0.09,16623.59,0.05,-7218.58,0.04,-19634.48,24,-11298.06,0.1,-19820.01,0.19,13077.75,0.2,6381.34,0.19,"","",7851.28,0.21,1288.4,0.03,1361.22,0.04}
,{39,20,-27282.702,0.596,8369.67,0.015,-13109.993,24.007,38.970710813,0.64,0,0.8603,"",0.0008,"",1.5,1,"","",{"B+"},{0},{"="},{0},30289.27,0.87,10912.98,0.63,-6660.33,0.9,-29483,200,143.15,0.63,-31105,200,13295.52,0.63,5770.92,0.63,"","",8228.3,0.6,-5001.58,0.69,8595.24,0.6}
,{39,21,-14172.709,24,8013.456,0.615,-16373,202,38.98478497,25.765,0,3e-07,"","s","",3.5,-1,"","",{"p"},{0},{"="},{0},33835,301,3950.45,24,-5424.73,24.01,"","",7339.08,24,-33114,301,17995,202,-596.82,24,"","",9674.16,24.01,-2857.5,46.65,8890.76,24}
,{39,22,2200,200,7574,5,"","",39.002362,215,0,0.0285,"",0.0009,"",1.5,1,"","",{"B+","B+p","B+2p"},{0,93.7,0,15,0},{"=","=","="},{0,93.7,0,15,0},"","",-758,200,-5013,280,"","",16970,200,"","",16741,361,839,283,"","",9391,361,-8287,359,14298,204}
,{40,12,48350,500,6628,13,20760,640,40.051906,537,0,0.001,"",1.7e-07,">",0,1,"","",{"B-n","B-2n"},{0,50,0},{"=","="},{0,50,0},1867,709,"","","","",42920,608,"","",19629,640,1997,716,"","",71188,500,"","",-320,850,"",""}
,{40,13,27590,400,7127,10,22160,528,40.029619,429,0,0.01,"",2.6e-07,">",0,0,"","",{"B-n","B-2n"},{0,90,0},{"=","="},{0,90,0},4763,548,"","",-21138,787,35704,428,"","",17198,422,1132,565,21974,650,55148,401,4227,642,4243,805,-20298,795}
,{40,14,5429.679,345.119,7661.754,8.628,13544.049,377.749,40.005829,370.5,0,0.033,"",0.001,"",0,1,"","",{"B-","B-n","B-2n"},{0,40,0,60,0},{"=","=","="},{0,40,0,60,0},6542.66,360.68,43222,610,-17375.39,771.71,28267.52,345.14,-44135,618,10133,363.04,4961.99,370.78,22510,528,40469.57,345.12,-69.37,509.24,484.17,389.35,-17135.39,779.51}
,{40,15,-8114.37,153.582,7980.796,3.84,14723.476,153.633,39.991288865,164.876,0,0.15,"",0.008,"",2,-1,"","",{"B-","B-n","B-2n"},{0,15.8,0,2,0},{"=","=","="},{0,15.8,0,2,0},9635.44,169.87,38902.17,404.73,-16489.67,214.33,19443.44,156.89,-36054,428,6976.98,161.52,3411.05,190.46,17723.69,204.83,25421.12,153.58,6766.73,185.93,3321.2,191.15,-12277.53,236.8}
,{40,16,-22837.846,3.982,8329.325,0.1,4719.967,32.312,39.975482562,4.274,0,8.8,"",2.2,"",0,1,"","",{"B-"},{0},{"="},{0},12119.28,8.2,33245.49,104.87,-12826.64,71.91,12202.05,3.98,-32447.17,135.59,-1108.96,4.34,7746.5,50.16,17352.18,112.72,12008.54,3.98,2494.52,72.69,1022.21,38.16,-10619.93,113.88}
,{40,17,-27557.813,32.066,8427.765,0.802,7482.082,32.066,39.970415469,34.423,0,81,"",1.2,"",2,-1,"","",{"B-"},{0},{"="},{0},13902.34,32.07,27514.19,79.35,-9731.69,34.64,5977.68,32.07,-22072.15,117.12,-2386.94,32.45,5828.93,32.11,11684.12,59.4,-7034.48,32.19,10014.2,32.86,4202.66,32.07,-2915.41,49.68}
,{40,18,-35039.89464,0.00224,8595.259,0,-1504.403,0.056,39.962383123,0.0024,1,"s","","s","",0,1,"","",{},{},{},{},16467.71,0.19,22756.63,7.17,-6800.68,0.19,-193.51,0.02,-19166.2,50,-9304.02,0,9869.02,5,12528.66,1.73,-26189.51,160,5469.01,0.1,1585.7,0.05,-2497.08,0.2}
,{40,19,-33535.492,0.056,8538.09,0.001,1310.893,0.06,39.963998166,0.06,0,3.9383043648e+16,"",94670778000000,"",4,-1,"","",{"B-","B+"},{0,10.72,0},{"=","="},{0,10.72,0},20877.37,0.2,18315.33,0.11,-6438.4,0.07,-13012.16,2.83,-11024.26,1.73,-14324.11,0.6,7799.62,0.06,7582.27,5,-45705,300,11890.14,0.2,2276.23,0.21,3872.45,0.08}
,{40,20,-34846.384,0.021,8551.303,0.001,-14323.05,2.828,39.962590865,0.022,1,"s","","s","",0,1,"","",{},{},{},{},28930.52,0.2,14709.5,0.2,-7039.76,0.03,-25996,160,-8893.16,5,-28744.99,24,15635,0.6,8328.16,0.02,"","",4665.18,0.2,-5182.13,0.1,1747.68,0.21}
,{40,21,-20523.335,2.828,8173.669,0.071,-11672.95,160.025,39.977967292,3.036,0,0.1823,"",0.0007,"",4,-1,"","",{"B+","B+p","B+A"},{0,0.44,0,0.017,0},{"=","=","="},{0,0.44,0,0.017,0},32416,200,6300.52,2.83,-5531.19,2.85,-32693,300,5994.88,2.83,-30795,200,14421.94,24.17,529.6,2.89,"","",12245.97,2.83,-2523.21,2.9,9923.27,2.83}
,{40,22,-8850.384,160,7862.286,4,-21020,340,39.990498721,171.767,0,0.0524,"",0.0003,"",0,1,"","",{"B+","B+p"},{0,95.8,0},{"=","="},{0,95.8,0},35863,340,1369.83,160,-4824.15,164.92,"","",11143.35,160,"","",19122,256,1966.65,161.79,"","",6110,256,-7506,340,9932.08,160}
,{40,23,12170,300,7317,7,"","",40.013065,322,0,"s","","s","",2,-1,"","",{},{},{},{},"","",-1842,361,-5606,423,"","",19054,301,"","","","",-2681,361,"","",12011,424,"","",14296,424}
,{41,13,33420,500,7008,12,21300,747,41.035878,537,0,0.002,"",2.6e-07,">",2.5,1,"","",{"B-n","B-2n"},{0,10,0},{"=","="},{0,10,0},3373,640,"","",-22539,850,38400,514,"","",19919,608,2241,640,22219,707,60727,505,1856,716,4210,709,"",""}
,{41,14,12119.668,554.705,7508.573,13.529,17099.435,567.571,41.013011,595.5,0,0.02,"",0.0025,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,45,0,10,0},{"=","=","="},{0,45,0,10,0},6343.32,571.02,44734,755,-18516.72,892.31,31128.25,554.72,-43519,747,12162.72,575.57,1381.33,653.3,22759,684,45187.17,554.7,2180,684,773.86,669.27,-16308,749}
,{41,15,-4979.767,120.163,7906.551,2.931,14028.81,120.233,40.994654,129,0,0.101,"",0.005,"",0.5,1,"","",{"B-","B-n","B-2n"},{0,30,"","",""},{"=","=",""},{0,30,"","",""},8347.77,164.71,40208,417,-17214.25,216.63,22327.42,138.43,-39859,417,9786.76,120.23,4936.71,195,17698.42,365.44,30579.78,120.16,3410.69,181.13,4054.59,159.44,-15543.22,393.27}
,{41,16,-19008.577,4.099,8229.635,0.1,8298.611,68.846,40.979593451,4.4,0,1.99,"",0.05,"",3.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11988.54,50.17,35906.87,135.59,-14861.98,113.88,14058.93,4.11,-31727.23,345.14,477.92,32.33,4242.05,5.71,18183.18,153.64,16129.31,4.1,4476.86,112.72,477.04,72.7,-9191.88,104.87}
,{41,17,-27307.189,68.723,8412.959,1.676,5760.317,68.724,40.970684525,73.777,0,38.4,"",0.8,"",0.5,1,"","",{"B-"},{0},{"="},{0},13649.62,68.75,29110.5,131.95,-10736.11,78.5,8252.35,68.72,-26481.79,168.26,-338.61,68.72,7820.69,75.84,11758.31,68.84,1335.22,68.72,6566.28,84.99,4418.07,69.1,-7039.22,99.95}
,{41,18,-33067.505,0.347,8534.372,0.008,2492.038,0.347,40.964500571,0.372,0,6576.6,"",2.4,"",3.5,-1,"","",{"B-"},{0},{"="},{0},15967.95,5.01,24482.78,50,-8596,0.4,2070.38,0.37,-17518.63,4,-7603.33,0.35,6098.93,0.35,12798.66,32.07,-17369.97,27.95,7443.51,1.77,1594.65,0.36,-559.9,7.18}
,{41,19,-35559.54331,0.0038,8576.072,0,-421.653,0.138,40.961825257,0.00408,1,"s","","s","",1.5,1,"","",{},{},{},{},17894.99,0.01,20337.28,1.73,-6222.92,0.05,-6917.13,0.08,-15290.7,32.07,-8784.48,0.02,10095.37,0.06,7808.62,0,-35880,200,8393.45,5,4019.33,0.2,-115.04,0.1}
,{41,20,-35137.89,0.138,8546.706,0.003,-6495.478,0.158,40.962277921,0.147,0,3136758444400,"",47335389000,"",3.5,-1,"","",{"EC"},{0},{"="},{0},23997.82,0.61,16473.64,5,-6615.14,0.25,-19440.35,27.95,-7386.97,0.14,-22685.87,2.83,8362.82,0.14,8891.37,0.15,"","",9380.11,0.14,-1473.08,0.24,5223.33,0.24}
,{41,21,-28642.412,0.083,8369.198,0.002,-12944.875,27.945,40.969251104,0.088,0,0.5963,"",0.0017,"",3.5,-1,"","",{"B+"},{0},{"="},{0},30612.34,24,9413.16,0.08,-6267.13,0.13,-28963,200,-2395.89,0.1,-27863.34,160,16190.39,2.83,1085,0.08,"","",9351.1,0.6,-1719.86,0.21,5804.74,0.21}
,{41,22,-15697.537,27.945,8034.388,0.682,-16018,202,40.983148,30,0,0.0819,"",0.0005,"",1.5,1,"","",{"B+","B+p"},{0,91.1,0},{"=","="},{0,91.1,0},34040,202,2992.78,27.95,-4986.39,27.95,"","",11859.88,27.94,-35939,301,14918.47,162.42,2463.17,28.09,"","",9185.98,36.84,-6584,202,12007.36,27.95}
,{41,23,320,200,7625,5,"","",41.000344,215,0,"s","","s","",3.5,-1,"","",{},{},{},{},"","",85,202,-5625,361,"","",13555,200,"","",19921,361,-1882,256,"","",8831,283,-5685,361,10216,283}
,{42,13,40100,600,6874,14,23630,781,42.043049,644,0,0.001,"",1.7e-07,">",0,0,"","",{"B-n","B-2n"},{0,40,0},{"=","="},{0,40,0},3633,721,"","","","",39090,677,"","",19909,817,1392,781,"","",64932,603,2461,781,2689,789,"",""}
,{42,14,16470,500,7418,12,15460,591,42.017681,537,0,0.0125,"",0.0035,"",0,1,"","",{"B-","B-n","B-2n"},{0,40,0,60,0},{"=","=","="},{0,40,0,60,0},5103,608,46458,707,-20029,709,34107,500,"","",13378,514,3721,747,24239,707,50892,500,-409,640,684,640,-20159,716}
,{42,15,1009.74,314.379,7767.866,7.485,18647.485,314.392,42.001084,337.5,0,0.0485,"",0.0015,"",0,0,"","",{"B-","B-n","B-2n"},{0,50,"",20,0},{"=","=","="},{0,50,"",20,0},7018.52,349.89,41158,508,-17625.03,488.93,25841.51,319.98,-39699,591,11947,314.41,2081.81,336.56,18398.9,637.6,36031.77,314.38,6290.87,466.84,3553.44,342.35,-13994,508}
,{42,16,-17637.746,2.794,8193.227,0.067,7194.021,59.681,41.9810651,3,0,1.016,"",0.015,"",0,1,"","",{"B-","B-n"},{0,4,0},{"=","<"},{0,4,0},10942.53,4.86,37645.37,345.13,-15892.36,104.83,16784.93,6.42,-37046.38,554.71,1598.13,68.78,6700.49,4.96,19946.95,120.2,20909.5,2.8,1187.43,153.61,0.94,112.68,-14311.7,135.56}
,{42,17,-24831.767,59.616,8345.886,1.419,9590.908,59.895,41.973342,64,0,6.8,"",0.3,"",2,-1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},13416.59,67.69,31295.34,164.75,-12635.12,93.93,10190.26,59.62,-27140.97,134.14,164.42,59.62,5595.9,90.98,13112.16,59.76,7289.39,59.62,8716.88,59.75,3194.95,77.81,-6410.73,127.45}
,{42,18,-34422.675,5.775,8555.613,0.138,599.351,5.776,41.963045736,6.2,0,1038222865.4,"",34712618.6,"",0,1,"","",{"B-"},{0},{"="},{0},15525.41,5.78,26162.77,7.02,-9986.39,9.21,4124.57,5.78,-22703.07,7.08,-6934.45,5.78,9426.49,5.79,14404.46,68.97,-9318,5.78,3845.94,32.58,241.58,6.03,-5613.61,50.33}
,{42,19,-35022.026,0.106,8551.256,0.003,3525.219,0.183,41.962402306,0.113,0,44478,"",25.2,"",2,-1,"","",{"B-"},{0},{"="},{0},17629.17,0.12,22042.15,32.07,-7648.84,0.14,-2900.87,0.2,-15003.81,68.72,-7955.45,0.17,7533.8,0.11,9243.49,0.36,-27402,196,10728.67,0.11,3084.22,5,424.58,1.74}
,{42,20,-38547.245,0.149,8616.563,0.004,-6426.092,0.097,41.958617828,0.159,1,"s","","s","",0,1,"","",{},{},{},{},19843.49,0.15,18085.29,0.15,-6257.34,0.25,-13442.57,0.24,-12768.71,0.38,-17976.15,0.16,11480.67,0.06,10276.67,0.15,-45277,400,5699.05,0.16,124,0.15,341.35,5}
,{42,21,-32121.153,0.169,8444.933,0.004,-7016.479,0.224,41.965516522,0.181,0,0.68079,"",0.00028,"",0,1,"","",{"B+"},{0},{"="},{0},27740.45,2.83,13163.6,0.18,-5745.31,0.26,-24502,196,-3850.58,0.17,-24494.93,27.95,11550.06,0.16,4272.23,0.1,"","",13436.04,0.17,25.6,0.62,7332.44,0.17}
,{42,22,-25104.674,0.277,8259.247,0.007,-17485,196,41.973049022,0.297,0,0.20865,"",0.0008,"",0,1,"","",{"B+"},{0},{"="},{0},32396.92,160,4836.23,0.28,-5471.09,0.34,-31835,400,2744.25,0.24,-33496,200,17478.45,27.95,3751.23,0.27,"","",6129.47,2.84,-6067.91,24,7824.43,0.66}
,{42,23,-7620,196,7824,5,-14350,445,41.99182,210,0,5.5e-08,"","s","",2,-1,"","",{},{},{},{},35932,358,1674,196,-5795,280,"","",13734,196,"","",16011,280,-789,198,"","",11942,253,-4956,280,12199,197}
,{42,24,6730,400,7464,10,"","",42.007225,429,0,0.0133,"",0.001,"",0,1,"","",{"B+","B+p"},{0,94.4,0},{"~","="},{0,94.4,0},"","",-1002,430,-6564,500,"","",15139,401,"","","","",879,447,"","",5271,500,"","",10176,447}
,{43,13,47020,800,6741,19,23919,998,43.050478,859,0,0.001,"",1.7e-07,">",2.5,1,"","",{"B-n","B-2n"},{0,50,0},{"=","="},{0,50,0},2543,944,"","","","",42340,974,"","",22479,944,1151,1000,"","",71179,803,"","",3534,944,"",""}
,{43,14,23101,596,7279,14,18421,814,43.0248,640,0,0.015,"",2.6e-07,">",1.5,-1,"","",{"B-n","B-2n"},{0,30,0},{"=","="},{0,30,0},5161,814,"","",-21599,786,35297,596,"","",14020,674,1440,778,24288,846,55111,596,392,778,375,718,-19603,778}
,{43,15,4679.826,554.705,7689.572,12.9,16875.285,554.727,43.005024,595.5,0,0.0358,"",0.0013,"",0.5,1,"","",{"B-","B-n","B-2n"},{0,100,0,10,0},{"=","=","="},{0,100,0,10,0},6483.04,567.57,43318,747,-18395,684,28839.33,558.14,-42709,817,14246.25,554.71,4401.23,637.6,19079,747,41255.21,554.7,3270.96,784.47,4114.2,653.3,-17264,684}
,{43,16,-12195.459,4.97,8063.827,0.116,11964.049,62.058,42.986907635,5.335,0,0.265,"",0.013,"",1.5,-1,"","",{"B-","B-n"},{0,40,""},{"=","="},{0,40,""},9329.52,6.44,38893.07,554.73,-16940.73,135.62,19814.35,7.27,-35954,500,4564.99,59.82,2629.03,5.7,20494.17,314.42,26213.36,4.98,3495.11,120.27,782.97,153.66,-11978.74,345.15}
,{43,17,-24159.508,61.858,8323.866,1.439,7850.3,62.086,42.9740637,66.407,0,3.13,"",0.09,"",1.5,1,"","",{"B-","B-n"},{0,2,0},{"=","="},{0,2,0},12994.95,92.46,33757.68,135.15,-13809.79,128.51,12415.88,61.86,-32458.22,320.41,2191.85,62.13,7399.06,85.91,13810.73,61.92,12028.59,61.89,5559.88,61.99,3542.39,61.99,-10398.74,165.57}
,{43,18,-32009.808,5.31,8488.237,0.123,4565.581,5.325,42.965636055,5.7,0,322.2,"",3.6,"",0,0,"","",{"B-"},{0},{"="},{0},15084.94,5.32,27579.17,6.71,-11272.06,50.28,6399.01,5.31,-21661.03,6,-5059.1,5.31,5658.45,7.85,14467.01,59.85,-2688.73,8.98,6008.19,68.93,412.06,32.5,-3525.56,6.64}
,{43,19,-36575.389,0.41,8576.22,0.01,1833.434,0.469,42.960734703,0.44,0,80280,"",360,"",1.5,1,"","",{"B-"},{0},{"="},{0},17158.48,0.41,23846.14,68.72,-9200.1,1.78,-387.29,1.91,-19032.59,59.62,-6099.46,0.44,9624.68,0.42,9441.68,5.79,-18659.03,42.85,7202.92,0.54,3328.56,0.41,-3371.17,32.07}
,{43,20,-38408.822,0.228,8600.663,0.005,-2220.72,1.865,42.95876643,0.244,1,"s","","s","",3.5,-1,"","",{},{},{},{},19413.57,0.18,19919.26,0.42,-7591.55,5.01,-9087.74,7.25,-11275.12,5.78,-14358.99,0.2,7932.89,0.17,10675.77,0.25,-36439,400,7861.53,0.23,-9.28,0.23,2277.47,0.23}
,{43,21,-36188.102,1.863,8530.825,0.043,-6867.02,7.481,42.961150472,1.999,0,14007.6,"",43.2,"",3.5,-1,"","",{"B+"},{0},{"="},{0},23688.32,1.86,15206.5,1.86,-4805.83,1.86,-18271.75,42.89,-8455.05,1.87,-19154.75,1.87,12138.27,1.86,4929.83,1.86,"","",9660.59,1.86,3522.34,1.86,2993.79,1.86}
,{43,22,-29321.082,7.245,8352.932,0.168,-11404.726,43.457,42.968522521,7.777,0,0.509,"",0.005,"",3.5,-1,"","",{"B+"},{0},{"="},{0},29766.18,28.87,8761.13,7.25,-4463.3,7.27,-27351,400,1937.19,7.25,-29773,196,12287.73,7.25,4488.9,7.25,"","",10032.14,7.25,-3933.69,7.78,11171.7,7.25}
,{43,23,-17916.356,42.849,8069.512,0.996,-15946,402,42.980766,46,0,0.0793,"",0.0024,"",3.5,-1,"","",{"B+","B+p"},{0,2.5,0},{"=","<"},{0,2.5,0},34379,205,3851.88,42.85,-6168.56,49.11,"","",6915.83,42.85,-32718,402,18368,200,100.65,42.85,"","",8491.99,51.16,-4201.92,165.64,8253.38,42.94}
,{43,24,-1970,400,7680,9,"","",42.997885,429,0,0.0211,"",0.0003,"",1.5,1,"","",{"B+","B+p","B+2p","B+3p"},{0,79.3,0,11.6,0,0.13,0},{"=","=","=","="},{0,79.3,0,11.6,0,0.13,0},"","",851,401,-6595,447,"","",15846,400,"","",16771,565,1639,445,"","",8420,447,-9276,500,12527,430}
,{44,14,28513,596,7174,14,18063,778,44.03061,640,0,0.01,"",3.6e-07,">",0,1,"","",{"B-n","B-2n"},{0,50,0},{"=","="},{0,50,0},4099,778,"","",-22262,778,37717,596,"","",15762,814,2659,843,25796,998,61186,596,-876,846,-43,778,"",""}
,{44,15,10450,500,7567,11,19655,500,44.011219,537,0,0.0185,"",0.0025,"",0,0,"","",{"B-","B-n","B-2n"},{0,20,0,70,0},{"=","=","="},{0,20,0,70,0},6702,591,44227,781,-19564,640,30835,518,-43858,944,14575,500,2301,747,19940,778,46232,500,4691,707,3195,747,-17323,707}
,{44,16,-9204.233,5.216,7996.015,0.119,11180.29,136.421,43.990118848,5.6,0,0.1,"",0.001,"",0,1,"","",{"B-","B-n"},{0,18,0},{"=","="},{0,18,0},7709.12,5.92,40252,500,-17058.83,345.16,23469.02,5.45,-39594,596,6883.96,62.08,5080.09,7.21,21173.03,554.73,32264.44,5.23,496.83,314.42,639.59,120.28,-15677.5,554.73}
,{44,17,-20384.523,136.321,8232.332,3.098,12288.731,136.33,43.978116312,146.346,0,0.56,"",0.11,"",2,-1,"","",{"B-","B-n"},{0,8,0},{"=","<"},{0,8,0},11695.39,148.79,35972.2,342.66,-14695.07,205.36,15396.97,136.32,-32353.32,571.21,3553.97,136.42,4296.33,149.7,15478.03,136.41,17431.46,136.33,7964.03,136.35,3488.11,136.38,-9758.35,181.72}
,{44,18,-32673.255,1.584,8493.84,0.036,3108.237,1.638,43.964923816,1.7,0,712.2,"",3,"",0,1,"","",{"B-"},{0},{"="},{0},14393.21,5.99,29613.45,3.21,-12260.32,4.29,8795.42,1.62,-27766.77,5.22,-4169.18,1.64,8734.76,5.54,15802.72,61.88,4875.31,1.73,2869.32,59.64,-502.01,68.74,-8018.28,4.39}
,{44,19,-35781.492,0.419,8546.701,0.01,5687.183,0.53,43.961586986,0.45,0,1327.8,"",11.4,"",2,-1,"","",{"B-"},{0},{"="},{0},16902.1,0.43,25527.67,59.62,-10648.59,32.07,2034.49,1.8,-18910.95,61.86,-5443.99,0.48,7277.42,0.59,11060.65,5.33,-11665.11,181.64,9351.99,5.79,2150.07,0.54,-2827.9,68.72}
,{44,20,-41468.675,0.325,8658.175,0.007,-3652.69,1.757,43.955481543,0.348,1,"s","","s","",0,1,"","",{},{},{},{},19064.06,0.29,21623.94,5.78,-8853.7,0.32,-3920.11,0.77,-16747.84,5.32,-13351.89,1.88,11131.17,0.23,12182.26,0.52,-28108,300,4264.16,0.34,-1045.08,0.33,-2754.77,0.48}
,{44,21,-37815.985,1.756,8557.379,0.04,-267.416,1.89,43.959402867,1.884,0,14551.2,"",9,"",2,1,"","",{"B+"},{0},{"="},{0},21837.47,1.75,17371.9,1.76,-6705.41,1.76,-13699.61,181.65,-8529.57,1.8,-16566.22,7.45,9699.2,2.55,6696.13,1.74,-44846,500,11442.07,1.75,2185.96,1.75,3389.96,1.76}
,{44,22,-37548.569,0.7,8533.52,0.016,-13432.189,181.643,43.959689951,0.751,0,1865014326.6,"",9467077.8,"",0,1,"","",{"EC"},{0},{"="},{0},28586.53,0.75,13579.27,0.72,-5127.1,0.7,-24188,300,-6428.72,0.74,-27703.53,42.85,16298.8,7.28,8649.44,1.99,"","",5283.39,0.72,-4042.1,0.7,3235.72,0.71}
,{44,23,-24116.38,181.641,8210.463,4.128,-10756,351,43.97411,195,0,0.111,"",0.007,"",0,0,"","",{"B+","B+A"},{0,"",""},{"=",""},{0,"",""},32639,267,6573.17,181.64,-6017.96,181.66,-31146,532,4782.75,181.65,-30218,439,14271.34,186.63,2084.27,181.79,"","",11699.1,181.64,-3554.79,183.78,10172.43,181.64}
,{44,24,-13360,300,7948,7,-20390,583,43.985657,322,0,0.0428,"",0.0006,"",0,1,"","",{"B+","B+p"},{0,14,0},{"=","="},{0,14,0},36233,500,2834,300,-6935,340,"","",8672,300,"","",19462,500,2733,303,"","",4970,358,-8817,361,7984,301}
,{44,25,7030,500,7467,11,"","",44.007547,537,0,1.05e-07,"","s","",2,-1,"","",{},{},{},{},"","",-72,537,-7565,583,"","",17657,502,"","","","",-1711,640,"","",11011,640,"","",12356,539}
,{45,14,37490,700,6995,16,21890,860,45.040247,751,0,0.001,"","s","",1.5,-1,"","",{"B-n","B-2n"},{0,50,0},{"=","="},{0,50,0},1754,919,"","","","",41479,1250,"","",18968,860,-905,919,"","",67261,700,1181,1063,2254,922,"",""}
,{45,15,15600,500,7464,11,19589,1150,45.016747,537,0,0.008,"",2e-07,">",0.5,1,"","",{"B-n","B-2n"},{0,30,0},{"=","="},{0,30,0},5223,747,45998,944,-20245,707,33862,518,"","",16733,500,2922,707,20202,778,52215,500,3209,778,3994,707,-18854,781}
,{45,16,-3989.589,1035.356,7881.807,23.008,14272.954,1044.271,44.995717,1111.5,0,0.068,"",0.002,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,54,0,4,0},{"=","=","="},{0,54,0,4,0},7936.76,1035.37,41669,1195,-18534.17,1174.59,25781.21,1035.36,-39792,1195,8323.62,1044.29,2856.67,1035.37,21729,1150,36822.59,1035.36,2041.39,1174.59,-135.27,1082.03,-14813,1150}
,{45,17,-18262.543,136.163,8181.598,3.026,11508.254,136.164,44.980394353,146.177,0,0.413,"",0.025,"",1.5,1,"","",{"B-","B-n"},{0,24,0},{"=","="},{0,24,0},10245.67,149.56,37520.31,571.17,-15707.69,181.6,18353.1,136.16,-36002,518,6339.4,136.17,5949.34,192.68,16347.28,136.26,22809.35,136.17,4643.72,136.25,4239.26,136.19,-13625.88,342.6}
,{45,18,-29770.796,0.512,8419.952,0.011,6844.841,0.731,44.968039733,0.55,0,21.48,"",0.15,"",2.5,-1,"","",{"B-"},{0},{"="},{0},13903.62,5.33,32153.28,5,-13187.13,4.13,11041.38,0.63,-27855.53,5.24,-2060.62,0.66,5168.86,1.66,16675.24,136.32,9239.04,0.99,5099.52,61.86,-74.97,59.62,-6486.65,2.84}
,{45,19,-36615.638,0.522,8554.674,0.012,4196.536,0.637,44.960691493,0.56,0,1068,"",36,"",1.5,1,"","",{"B-"},{0},{"="},{0},16182.88,0.66,27034.07,61.86,-11733.36,68.73,4456.26,0.85,-23520.08,136.32,-3218.28,0.61,8905.46,0.67,11231.35,1.67,-4729.62,1.02,6104.98,5.34,2671.09,5.8,-6137.47,59.62}
,{45,20,-40812.174,0.366,8630.545,0.008,259.722,0.747,44.956186326,0.392,0,14049504,"",7776,"",3.5,-1,"","",{"B-"},{0},{"="},{0},18545.99,0.29,23380.31,5.32,-10169.58,0.5,-1802.33,0.9,-15427.89,1.63,-11067.51,1.76,7414.82,0.17,12319.65,0.56,-21297.37,35.4,6474.02,0.55,-926.09,0.38,-743.1,5.79}
,{45,21,-41071.896,0.675,8618.931,0.015,-2062.056,0.509,44.955907503,0.724,1,"s","","s","",3.5,-1,"","",{},{},{},{},21026.43,1.98,19074.45,0.79,-7937.27,0.67,-9185.88,0.55,-12579.37,0.79,-11594.64,0.97,11327.23,1.88,6892.19,0.73,-35822,400,8047.73,0.7,2339.4,0.69,-403.47,0.68}
,{45,22,-39009.84,0.845,8555.722,0.019,-7123.824,0.214,44.958121211,0.907,0,11088,"",30,"",3.5,-1,"","",{"B+"},{0},{"="},{0},25831.39,7.29,15178.96,0.87,-6296.87,0.85,-19495.04,35.41,-4830.14,0.89,-22964.78,181.64,9532.59,1.1,8482.83,1.95,-52772,400,7889.07,2.04,-2024.63,0.86,5183.81,0.86}
,{45,23,-31886.016,0.872,8380.029,0.019,-12371.217,35.408,44.965768951,0.935,0,0.547,"",0.006,"",3.5,-1,"","",{"B+"},{0},{"="},{0},30112.29,42.86,10275.86,2.06,-5668.52,0.88,-26636,400,-1359,1.96,-26597,300,15840.95,181.64,1626.42,1.12,"","",8145.87,7.3,-1917.29,0.91,5881.54,0.89}
,{45,24,-19514.799,35.397,8087.728,0.787,-14265,401,44.97905,38,0,0.0609,"",0.0004,"",3.5,-1,"","",{"B+","B+p"},{0,34.4,0},{"=","="},{0,34.4,0},33687,401,4771.66,36.13,-6242.18,45.1,-33277,401,10744.8,35.4,-34616,501,14226,302,2687.39,185.06,"","",9112.36,55.58,-7031,199,11236.28,35.4}
,{45,25,-5250,400,7753,9,-19012,565,44.994364,429,0,7e-08,"","s","",3.5,-1,"","",{},{},{},{},"","",1911,402,-7995,447,"","",11578,439,"","",20351,640,-822,500,"","",7431,565,-7116,565,8016,445}
,{45,26,13762,400,7313,9,"","",45.014774,429,0,0.0022,"",0.0003,"",1.5,1,"","",{"2p","B+","B+p","B+p"},{"",43,0,43,0,25,0},{"=","<","<","="},{"",43,0,43,0,25,0},"","",-1154,16,"","","","",19833,500,"","","","",557,640,"","","","","","",12678,565}
,{46,15,22970,700,7317,15,22630,860,46.024659,751,0,0.004,"",2e-07,">",0,0,"","",{"B-n","B-2n"},{0,90,0},{"=","="},{0,90,0},3623,860,"","",-19555,922,36829,730,"","",18888,1250,701,860,21809,989,58384,700,5167,919,4733,919,-18404,1063}
,{46,16,340,500,7792,11,14199,542,46.000365,537,0,0.05,"",0.008,"",0,1,"","",{"B-","B-n","B-2n"},{0,70,0,3,0},{"=","=","="},{0,70,0,3,0},6598,500,42751,778,-18555,707,30113,500,-44439,860,10531,518,3742,1150,22549,707,43479,500,600,707,524,747,-17115,778}
,{46,17,-13859.398,208.661,8083.48,4.536,15913.528,208.664,45.985121323,224.006,0,0.232,"",0.002,"",2,-1,"","",{"B-","B-n","B-2n"},{0,60,0,"",""},{"=","=",""},{0,60,0,"",""},9617.51,249.24,38888,542,-17294.05,377.32,21554.53,208.66,-36748,542,7840.08,208.66,3668.17,249.16,17158.78,1056.17,27901.82,208.66,6055.64,208.73,3200.12,208.72,-12892.82,592.65}
,{46,18,-29772.926,1.118,8412.419,0.024,5640.997,1.333,45.968037446,1.2,0,8.4,"",0.6,"",0,1,"","",{"B-"},{0},{"="},{0},13242.31,1.94,35146.63,5.33,-14560.1,3.01,13366.43,2.5,-33072.31,1035.36,-1228.61,1.23,8073.45,1.23,18799.35,136.17,14354.87,1.13,1322.4,136.33,-749.36,61.87,-11931.07,5.09}
,{46,19,-35413.924,0.727,8518.042,0.016,7725.438,2.35,45.961981586,0.78,0,105,"",10,"",2,-1,"","",{"B-"},{0},{"="},{0},15775.07,0.84,29607.34,136.32,-13007.07,59.62,6347.29,1,-24440.35,136.17,-2673.07,0.81,6869.6,0.89,12932.1,0.89,1661.43,0.75,7970.14,1.74,1459.94,5.36,-5608.01,61.86}
,{46,20,-43139.361,2.235,8668.979,0.049,-1378.143,2.333,45.953687988,2.399,1,"s","","s","",0,1,"","",{},{},{},{},17813.32,2.26,25044.05,2.74,-11141.6,6.19,988.44,2.24,-20657.54,2.29,-10138.78,2.33,10398.5,2.26,13812.69,2.3,-13667.79,11.67,3352.94,2.27,-1699.92,2.27,-5483.15,5.76}
,{46,21,-41761.219,0.683,8622.012,0.015,2366.581,0.667,45.955167485,0.732,0,7240320,"",2592,"",4,1,"","",{"B-"},{0},{"="},{0},20087.87,1.88,20557.67,0.8,-9164.11,0.69,-4685.87,0.67,-12434.55,0.86,-10822.7,0.52,8760.64,0.1,8238.02,0.75,-29192,400,10418.26,0.74,1511.66,0.71,460.57,0.8}
,{46,22,-44127.799,0.165,8656.451,0.004,-7052.449,0.093,45.952626856,0.176,1,"s","","s","",0,1,"","",{},{},{},{},22721.86,0.72,17237.07,0.36,-8005.47,0.22,-14656.23,11.45,-10604.6,0.4,-20313.1,0.86,13189.28,0.83,10344.87,0.66,-45038,500,4398.99,1.76,-3075.64,1.87,-72.58,0.28}
,{46,23,-37075.351,0.202,8486.13,0.004,-7603.784,11.455,45.960197971,0.216,0,0.42264,"",5e-05,"",0,1,"","",{"B+"},{0},{"="},{0},29101.61,181.64,13837.31,1.77,-7379.11,0.26,-24506,400,-3292.43,0.67,-25631.87,35.4,13260.65,0.86,5354.48,0.84,"","",11184.02,0.73,-2890.21,7.25,4759.15,1.87}
,{46,24,-29471.567,11.453,8303.823,0.249,-16902,400,45.96836097,12.295,0,0.2243,"",0.0013,"",0,1,"","",{"B+"},{0},{"="},{0},32254,300,6500.94,11.47,-6791.81,11.46,-30382,500,2249.3,11.48,-32293,400,18028.08,37.2,4874.52,11.49,"","",5355.62,182,-6691.16,44.35,5495.92,13.55}
,{46,25,-12570,400,7919,9,-13480,640,45.986506,429,0,0.0362,"",0.0004,"",4,1,"","",{"B+","B+p","B+2p"},{0,57,0,18,0},{"=","=","~"},{0,57,0,18,0},35742,640,3031,439,-7375,445,"","",12027,400,-34403,565,15391,565,344,401,"","",11502,500,-5735,565,10993,402}
,{46,26,910,500,7609,11,"","",46.000977,537,0,0.013,"",0.002,"",0,1,"","",{"B+","B+p","B+2p"},{0,78.7,0,"",""},{"=","=",""},{0,78.7,0,"",""},"","",307,583,-8245,640,"","",13136,501,"","",20923,640,1129,640,"","",4591,707,"","",8527,640}
,{47,15,29710,800,7190,17,22340,944,47.031895,859,0,0.002,"","s","",0.5,1,"","",{"B-n","B-2n"},{"","",""},{"",""},{"","",""},2032,944,"","",-19735,1132,39490,894,"","",21299,944,1331,1063,"","",65422,800,2931,1063,6061,998,"",""}
,{47,16,7370,500,7648,11,17150,640,47.007912,537,0,0.02,"",2e-07,">",1.5,-1,"","",{"B-n","B-2n"},{0,10,0},{"=","="},{0,10,0},4783,1150,44698,860,-18156,778,32736,500,"","",13158,542,1041,707,22889,860,49714,500,2481,707,1784,707,-15497,778}
,{47,17,-9780,400,7996,9,15587,400,46.989501,429,0,0.101,"",0.005,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,3,0,"",""},{"=","<",""},{0,3,0,"",""},7660,422,39957,640,-16884,684,25932,400,-40038,806,11922,400,3992,451,17409,640,34557,400,4921,1110,4289,400,-14584,640}
,{47,18,-25366.338,1.118,8311.404,0.024,10345.638,1.789,46.972768114,1.2,0,1.23,"",0.03,"",0,0,"","",{"B-","B-n"},{0,0.2,0},{"=","<"},{0,0.2,0},11738.18,1.23,35954.69,1035.36,-15595.79,5.09,16978.08,2.49,-32995,500,1976.27,1.33,3664.73,1.58,18795.91,208.66,19571.03,1.12,3607.01,136.17,-117.76,136.33,-10515.7,5.33}
,{47,19,-35711.976,1.397,8514.879,0.03,6632.442,2.625,46.961661614,1.5,0,17.5,"",0.24,"",0.5,1,"","",{"B-"},{0},{"="},{0},15238.97,1.49,32027.37,136.17,-13977.38,61.87,8624.62,2.38,-29141.55,208.67,-643.93,2.64,8369.37,1.57,13228.02,1.79,6294.64,1.41,4769.63,1.49,1825.33,2.11,-9681.05,136.33}
,{47,20,-42344.418,2.222,8639.349,0.047,1992.177,1.185,46.954541394,2.385,0,391910.4,"",259.2,"",3.5,-1,"","",{"B-"},{0},{"="},{0},17674.88,2.25,27151.56,2.28,-12759.53,5.76,2592.95,2.22,-19860.46,2.49,-8654.52,2.32,7276.37,0.27,14219.46,2.34,-7781.84,6.43,4982.03,2.28,-1698.87,2.26,-4024.76,2.73}
,{47,21,-44336.595,1.933,8665.09,0.041,600.769,1.929,46.952402704,2.074,0,289370.88,"",51.84,"",3.5,-1,"","",{"B-"},{0},{"="},{0},19407.33,2.04,22298.9,2,-10186.12,1.98,-2329.98,1.93,-16211.64,2.06,-8280.11,1.93,10646.69,2.04,8486.2,1.21,-21770.22,31.73,7186.39,1.97,1996.14,1.96,-2908.7,1.98}
,{47,22,-44937.364,0.115,8661.227,0.002,-2930.746,0.138,46.951757752,0.123,1,"s","","s","",2.5,-1,"","",{},{},{},{},22070.16,0.84,18703.13,0.38,-8953.46,0.25,-10374.79,6.03,-9086.97,2.23,-15933.33,0.18,8880.88,0.13,10465.12,0.68,-38068,500,6845.34,0.67,-2257.32,1.76,2177.71,0.34}
,{47,23,-42006.618,0.169,8582.225,0.004,-7444.04,6.032,46.954904038,0.181,0,1956,"",18,"",1.5,-1,"","",{"B+"},{0},{"="},{0},26263.24,0.86,15512.66,0.66,-8243.43,1.87,-19440.24,31.67,-7534.37,0.67,-20606.37,11.45,13002.58,0.11,5167.79,0.07,-52377,600,7714.03,0.83,406.01,0.72,1455.77,1.76}
,{47,24,-34562.578,6.03,8407.195,0.128,-11996.204,32.24,46.962895544,6.473,0,0.5,"",0.015,"",1.5,-1,"","",{"B+"},{0},{"="},{0},31190.41,35.91,10130.68,6.09,-7666.41,9.43,-27693,500,2276.25,6.03,-30064,400,13162.33,12.94,4776.2,6.03,"","",8034.24,6.09,-5582.14,181.74,8632.39,6.07}
,{47,25,-22566.374,31.671,8135.311,0.674,-15697,501,46.975774,34,0,0.088,"",0.0013,"",2.5,-1,"","",{"B+","B+p"},{0,1.7,0},{"=","<"},{0,1.7,0},33459,401,5258.3,31.68,-7074.93,53.28,-32937,601,7220.01,31.67,-31548,501,18068,401,383.78,33.68,"","",7659.23,47.5,-4342,302,7196.41,184.38}
,{47,26,-6870,500,7785,11,-17240,781,46.992625,537,0,0.0219,"",0.0002,"",3.5,-1,"","",{"B+","B+p"},{0,88.4,0},{"=","="},{0,88.4,0},36774,640,1933,501,-7325,640,"","",15313,500,"","",15851,707,1589,640,"","",9091,640,-9036,707,12137,583}
,{47,27,10370,600,7401,13,"","",47.011133,644,0,"s","","s","",3.5,-1,"","",{},{},{},{},"","",-1042,721,"","","","",15651,721,"","","","",-2171,781,"","",7319,721,"","",8987,781}
,{48,16,12761,596,7545,12,17042,778,48.0137,640,0,0.01,"",2e-07,">",0,1,"","",{"B-n","B-2n"},{0,10,0},{"=","="},{0,10,0},3721,778,"","",-18176,843,35043,671,"","",14470,718,2680,778,24238,998,56986,596,503,919,2026,778,-19082,919}
,{48,17,-4280,500,7883,10,18001,587,47.995405,537,0,0.1,"",2e-07,">",0,0,"","",{"B-n","B-2n"},{0,40,0},{"=","="},{0,40,0},6563,542,41828,860,-17156,707,28004,500,-41279,944,13015,500,2572,640,18939,707,40224,500,6091,707,4573,1150,-14234,707}
,{48,18,-22281.337,307.393,8242.132,6.404,10003.14,307.394,47.97608,330,0,0.415,"",0.015,"",0,1,"","",{"B-","B-n"},{0,38,0},{"=","="},{0,38,0},8651.04,307.4,37199,587,-15502.02,307.44,21943.29,307.39,-36940,587,5359.32,307.4,4986.32,307.4,19791,504,26211.37,307.39,2288.87,371.52,845.26,336.2,-12645.35,1080.02}
,{48,19,-32284.477,0.773,8434.232,0.016,11940.153,0.779,47.965341186,0.83,0,6.8,"",0.2,"",1,-1,"","",{"B-","B-n"},{0,1.14,0},{"=","="},{0,1.14,0},13013.19,1.06,33003.02,208.66,-14324.87,136.32,12219.37,5.01,-29794,400,1988.62,2.35,4643.82,1.6,14207.11,1.36,12193.22,1.24,8199.26,1.36,2350.37,0.93,-8375.53,136.17}
,{48,20,-44224.629,0.096,8666.686,0.002,279.213,4.95,47.952522904,0.103,0,1.42006167e+27,"",1.89341556e+26,"",0,1,"","",{"2B-"},{0},{"="},{0},17227.9,2.23,29029.64,1.12,-13976.29,1.59,4268.08,0.08,-26147.26,1.12,-7959.35,1.93,9951.53,2.22,15801.62,1.4,-1402.61,7.32,1900.1,0.73,-2744.94,0.53,-8807.43,0.52}
,{48,21,-44503.842,4.951,8656.204,0.103,3988.866,4.95,47.952223157,5.314,0,157212,"",324,"",6,1,"","",{"B-"},{0},{"="},{0},18885.26,5,23667.86,5,-11147.27,4.97,-26.15,5.04,-16080.84,5.14,-7637.8,4.95,8238.56,5.31,9448.39,5.42,-15207.5,8.52,9346.33,5.43,1172.39,4.96,-2241.8,4.98}
,{48,22,-48492.709,0.109,8723.006,0.002,-4015.015,0.969,47.947940932,0.117,1,"s","","s","",0,1,"","",{},{},{},{},20507.54,0.14,19931.29,2.23,-9448.95,0.34,-5670.69,7.32,-13437.26,2.22,-14557.41,0.14,11626.66,0.04,11445.08,1.93,-30493,400,3979.32,0.68,-2556.76,0.67,-2034.13,0.38}
,{48,23,-44477.694,0.975,8623.061,0.02,-1655.673,7.388,47.952251229,1.046,0,1380110.4,"",216,"",4,1,"","",{"B+"},{0},{"="},{0},23544.98,0.98,17294.42,1.18,-9086.62,2.01,-15181.36,7.01,-7430.07,2.16,-17986.43,6.11,10542.39,0.98,6829.3,0.97,-45977,500,10360.91,0.98,-603.8,1.28,2240.6,1.18}
,{48,24,-42822.02,7.324,8572.269,0.153,-13525.682,10.087,47.954028667,7.862,0,77616,"",108,"",0,1,"","",{"B+"},{0},{"="},{0},29493.09,13.59,13272.16,7.33,-7698.37,7.36,-24822,400,-5173.63,7.32,-28326.96,32.51,16330.76,9.48,8104.37,7.33,-59615,502,4964.14,7.33,-6071.95,7.38,1834.22,7.37}
,{48,25,-29296.338,6.939,8274.185,0.145,-11296,400,47.968549085,7.449,0,0.1581,"",0.0022,"",4,1,"","",{"B+","B+p","B+A"},{0,0.28,0,6,0},{"=","=","="},{0,0.28,0,6,0},32869,400,6798.93,6.94,-7604.87,181.77,-30796,500,5421.31,6.94,-30498,500,14801.28,32.42,2022.73,6.44,"","",10886.03,13.39,-4917.48,36.07,8236.08,6.99}
,{48,26,-18000,400,8023,8,-19500,640,47.980676,429,0,0.0453,"",0.0006,"",0,1,"","",{"B+","B+p"},{0,15.3,0},{"=","="},{0,15.3,0},35053,640,3107,400,-7065,500,-34793,641,9273,400,-36442,721,19202,640,2723,401,"","",5280,565,-7886,565,7161,401}
,{48,27,1500,500,7600,10,-15293,708,48.00161,537,0,"s","","s","",6,1,"","",{},{},{},{},"","",509,640,-7955,707,"","",16777,501,"","",16942,781,-1081,707,"","",11300,707,-7398,640,12396,640}
,{48,28,16793,502,7265,10,"","",48.018028,538,0,0.0028,"",0.0008,"",0,1,"","",{"2p","B+"},{"",30,""},{"=","="},{"",30,""},"","",-1305.17,37.14,"","","","",16374,708,"","","","",866,782,"","","","","","",8678,642}
,{49,16,21093,667,7385,14,20153,897,49.022644,716,0,2e-07,"","s","",1.5,-1,"","",{"B-n","B-2n"},{0,30,0},{"=","="},{0,30,0},2420,834,"","",-18822,967,38283,778,"","",17302,834,-260,300,"","",62393,667,2094,1042,2987,967,"",""}
,{49,17,940,600,7781,12,18130,721,49.001009,644,0,0.05,"",2e-07,">",1.5,1,"","",{"B-n","B-2n"},{0,20,0},{"=","="},{0,20,0},5423,721,43348,1000,-17085,781,30551,600,"","",15150,674,2851,781,19111,846,47501,600,4281,781,5464,781,-16383,922}
,{49,18,-17190,400,8135,8,12422,400,48.981546,429,0,0.236,"",0.008,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,29,0,"",""},{"=","=",""},{0,29,0,"",""},7966,400,39138,640,-15625,1110,24110,400,-37240,718,7023,400,2980,504,20199,640,31374,400,3301,565,1534,451,-11883,640}
,{49,19,-29611.49,0.801,8372.274,0.016,11688.275,0.826,48.968210755,0.86,0,1.26,"",0.05,"",0.5,1,"","",{"B-","B-n"},{0,86,0},{"=","="},{0,86,0},10042.15,1.61,34410,400,-13773.86,136.17,16949.77,2.81,-32620,500,6541.82,0.81,5398.33,1.11,14619.12,307.39,18350.44,1.15,6465.65,1.38,5025.49,1.38,-10105.69,208.66}
,{49,20,-41299.765,0.201,8594.844,0.004,5261.5,2.702,48.955662875,0.216,0,523.08,"",0.36,"",1.5,-1,"","",{"B-"},{0},{"="},{0},15097.98,2.23,30511.37,1.14,-13953.88,0.55,7264.02,0.19,-26307.4,307.39,-4867.24,4.95,5146.45,0.18,16304.26,0.8,4033.29,2.25,5123.02,1.41,-1021.79,0.75,-5880.44,1.14}
,{49,21,-46561.265,2.698,8686.256,0.055,2002.522,2.697,48.950014423,2.896,0,3430.8,"",7.8,"",3.5,-1,"","",{"B-"},{0},{"="},{0},18367.3,3.32,25427.23,3.04,-12370.54,2.75,1400.67,2.82,-21565.76,2.81,-6139.87,2.7,10128.74,5.64,9625.61,2.7,-8940.63,3.52,6493.96,3.49,1442.15,3.5,-5500.94,2.79}
,{49,22,-48563.787,0.114,8711.157,0.002,-601.856,0.82,48.947864627,0.122,1,"s","","s","",3.5,-1,"","",{},{},{},{},19769.06,0.05,20797.31,2.22,-10176.53,0.38,-3230.73,2.25,-11628.13,0.08,-12157.41,0.97,8142.4,0.03,11348.92,4.95,-23813.06,24.22,6483.61,1.93,-1938.51,0.68,221.98,2.23}
,{49,23,-47961.931,0.828,8682.908,0.017,-2628.871,2.391,48.948510746,0.889,0,28512000,"",1296000,"",3.5,-1,"","",{"EC"},{0},{"="},{0},22097.95,0.83,18203.28,2.1,-9314.95,1.06,-10341.3,2.4,-10747.06,5.02,-13211.23,7.37,11555.55,1.27,6758.19,0.82,-38082,500,7686.24,0.82,1029.92,0.83,-554.31,1.07}
,{49,24,-45333.06,2.243,8613.291,0.046,-7712.426,0.233,48.951332955,2.407,0,2538,"",6,"",2.5,-1,"","",{"B+"},{0},{"="},{0},26913.12,6.43,14973.64,2.25,-8748.14,2.4,-20582.33,24.32,-4129.32,2.25,-24108.04,7.29,10582.36,7.63,8144.34,2.45,-53533,600,7384.36,2.25,-3393.65,2.25,4441.14,2.25}
,{49,25,-37620.634,2.255,8439.929,0.046,-12869.907,24.324,48.959612585,2.42,0,0.382,"",0.007,"",2.5,-1,"","",{"B+"},{0},{"="},{0},31196.89,31.75,10191.96,2.26,-8159.53,2.42,-27740,500,-431.91,2.46,-27692,400,16395.61,7.29,2087.58,7.64,"","",7652.75,6.43,-3285.01,11.67,5101.12,2.26}
,{49,26,-24750.727,24.219,8161.311,0.494,-14870,501,48.973429,26,0,0.0647,"",0.0003,"",3.5,-1,"","",{"B+","B+p"},{0,56.7,0},{"=","="},{0,56.7,0},34024,501,4766.09,24.96,-7660.84,42.89,-32951,600,10782.32,25.3,-34322,501,14822,400,2743.36,25.19,"","",8526.45,39.87,-7317,400,10367.24,26.79}
,{49,27,-9880,500,7842,10,-18080,781,48.989393,537,0,3.5e-08,"","s","",3.5,-1,"","",{},{},{},{},36393,781,1892,501,-7055,640,"","",12127,500,-34745,708,19451,707,-831,640,"","",7700,707,-5926,707,8336,640}
,{49,28,8200,600,7457,12,"","",49.008803,644,0,0.0075,"",0.001,"",3.5,-1,"","",{"B+","B+p"},{0,83,""},{"=","="},{0,83,""},"","",-492,781,-7987,721,"","",18911,721,"","",16665,782,589,781,"","",8540,848,"","",12936,781}
,{50,17,7740,600,7651,12,21069,781,50.008309,644,0,0.02,"",6.2e-07,">",0,0,"","",{"B-n","B-2n"},{0,30,0},{"=","="},{0,30,0},4123,781,"","",-17655,922,33468,600,"","",16858,721,1271,848,20642,897,52287,600,5689,846,5234,781,-16324,1000}
,{50,18,-13330,500,8056,10,12398,500,49.98569,537,0,0.106,"",0.006,"",0,1,"","",{"B-","B-n","B-2n"},{0,37,0,"",""},{"=","=",""},{0,37,0,"",""},7191,587,40669,778,-16095,707,26260,500,-41711,834,8210,500,4211,640,21559,781,38102,500,1661,707,1314,640,-15053,707}
,{50,19,-25727.848,7.731,8288.582,0.155,13861.376,7.892,49.972380017,8.3,0,0.472,"",0.004,"",0,-1,"","",{"B-","B-n","B-2n"},{0,29,0,10,0},{"=","=","="},{0,29,0,10,0},9586.01,7.77,36026,500,-14293.37,208.8,18819.53,16.88,-33957,600,7500.6,7.73,4187.67,7.77,15827,400,23496.17,7.74,7264.29,307.49,4502.54,7.81,-10302,400}
,{50,20,-39589.224,1.584,8550.163,0.032,4958.158,15.084,49.957499217,1.7,0,13.9,"",0.6,"",0,1,"","",{"B-"},{0},{"="},{0},11507.23,1.59,31885.83,307.4,-12241.21,1.94,11842.44,1.59,-29688,400,-1099.28,3.13,6360.78,1.6,17266.7,1.77,10672.85,1.64,3406.06,1.76,986.81,2.11,-8576.48,1.94}
,{50,21,-44547.382,15,8633.679,0.3,6884.278,15,49.952176415,16.103,0,102.5,"",0.5,"",5,1,"","",{"B-"},{0},{"="},{0},16186.17,15.8,26840.85,15.02,-11558.37,15.02,4676.63,15.01,-22224.86,15.02,-4054.91,15,6057.43,15.24,10536.59,15,-1919.79,15.01,10388.05,15,2661.09,15.16,-3189,15.07}
,{50,22,-51431.66,0.121,8755.718,0.002,-2207.647,0.426,49.944785839,0.129,1,"s","","s","",0,1,"","",{},{},{},{},19081.59,0.05,21784.97,0.09,-10717.21,2.23,-1169.59,0.45,-17420.87,0.2,-11541.05,0.82,10939.19,0.04,12159.37,2.7,-16955.2,8.38,3782.99,4.95,-2231.01,1.93,-3440.84,2.22}
,{50,23,-49224.013,0.409,8695.918,0.008,1038.059,0.299,49.947155845,0.438,0,4.7335389e+24,"",1.26227704e+24,"",6,1,"","",{"B+","B-"},{"",17,""},{"=","="},{"",17,""},20888.95,1.06,19298.11,4.97,-9887.71,0.8,-6596.42,0.31,-9951.72,2.73,-11962.27,2.22,9333.4,0.92,7949.2,0.42,-31594,400,9979.5,0.42,577.41,0.42,758.98,1.98}
,{50,24,-50262.072,0.437,8701.032,0.009,-7634.477,0.067,49.946041443,0.468,1,"s","","s","",0,1,"","",{},{},{},{},23582.69,7.31,16347.3,0.45,-8559.19,0.47,-15785.62,8.39,-8987.26,0.45,-20712.75,2.21,13000.33,2.2,9589.11,0.94,-46142,500,4926.43,1.07,-3391.4,0.47,321.69,0.45}
,{50,25,-42627.595,0.442,8532.696,0.009,-8151.139,8.395,49.954237391,0.474,0,0.28319,"",0.0001,"",0,1,"","",{"B+"},{0},{"="},{0},29473.89,6.95,12727.84,1.07,-7977.16,0.49,-24997,400,-1954.63,0.94,-25948.19,24.22,13078.28,2.21,4583.51,2.2,"","",10905.23,7.31,-3200.96,6.04,5025.42,0.47}
,{50,26,-34476.456,8.383,8354.026,0.168,-16846,400,49.962988,9,0,0.1521,"",0.0006,"",0,1,"","",{"B+","B+p"},{0,0,0},{"=","~"},{0,0,0},32619,400,6232.38,11.13,-7429.81,14.19,-30356,500,3567.63,8.68,-32667,500,17797.05,25.63,4144.79,8.68,"","",5530.69,10.88,-7046.03,32.76,5732.52,10.33}
,{50,27,-17630,400,8001,8,-13510,640,49.981073,429,0,0.0388,"",0.0002,"",6,1,"","",{"B+","B+p"},{0,70.5,0},{"=","="},{0,70.5,0},35273,640,2912,400,-7486,565,"","",12701,400,-33902,721,15821,640,169,400,"","",11081,565,-5897,640,10582,401}
,{50,28,-4120,500,7716,10,"","",49.995577,537,0,0.0185,"",0.0012,"",0,1,"","",{"B+","B+p"},{0,86.7,0},{"=","="},{0,86.7,0},37056,708,698,640,-7455,707,"","",13342,501,"","",20391,781,1529,707,"","",5091,707,-9626,781,8396,707}
,{51,17,14290,700,7530,14,20980,922,51.015341,751,0,0.002,"",2e-07,">",1.5,1,"","",{"B-n","B-2n"},{0,20,0},{"=","="},{0,20,0},2792,922,"","",-17845,1063,36806,700,"","",19548,860,1521,922,"","",57519,700,3908,967,6393,919,"",""}
,{51,18,-6690,600,7926,12,15826,600,50.992818,644,0,0.06,"",2e-07,">",1.5,-1,"","",{"B-n","B-2n"},{0,10,0},{"=","="},{0,10,0},5643,721,42361,897,-16485,781,29642,600,"","",10967,600,1432,781,21719,848,43043,600,3081,848,2454,781,-13805,846}
,{51,19,-22516.196,13.047,8221.349,0.256,13816.107,13.057,50.975827867,14.006,0,0.365,"",0.005,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,65,0,4,0},{"=","=","="},{0,65,0,4,0},9047.34,13.07,38034,600,-15161,400,20712.49,23.88,-37545,600,9001.71,13.14,4859.67,15.17,16475,500,29687.65,13.04,5384,400,4629.2,307.67,-12590,500}
,{51,20,-36332.304,0.522,8476.913,0.01,6896.381,20.007,50.960995665,0.56,0,10,"",0.8,"",1.5,-1,"","",{"B-","B-n"},{0,3,0},{"=","="},{0,3,0},11175.17,0.56,33720,400,-13390.88,1.23,13400.53,0.73,-30292,500,143.76,15.01,4814.4,1.67,17893.43,7.75,15119.09,0.66,3989.99,0.96,816.23,0.93,-8404.57,307.39}
,{51,21,-43228.684,20,8596.796,0.392,6504.153,20.006,50.953592095,21.471,0,12.4,"",0.1,"",0,0,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},12810.05,20.18,28195.14,20.02,-9941.62,20.05,8975.16,20,-24789.81,21.44,131.66,20,6752.62,25,10928.43,20.06,5015.19,20.01,8781.89,20,5860,20,-5297.81,20.02}
,{51,22,-49732.837,0.505,8708.988,0.01,2471.005,0.644,50.9466096,0.541,0,345.6,"",0.6,"",1.5,-1,"","",{"B-"},{0},{"="},{0},17311.68,0.49,23011.01,0.53,-9813.33,2.27,1718.56,0.64,-17432.58,1.66,-8580.14,0.65,6372.49,0.49,12474.43,15.01,-9530.28,8.98,7539.23,2.74,-364.94,4.97,138.19,0.5}
,{51,23,-52203.842,0.401,8742.099,0.008,-752.447,0.213,50.943956867,0.43,1,"s","","s","",3.5,-1,"","",{},{},{},{},20384.55,0.92,20220.52,2.73,-10292.16,1.97,-3959.96,0.4,-14945.43,15.01,-10013.09,0.29,11051.15,0.08,8061.15,0.42,-24861.7,48.44,7070.75,0.42,1152.92,0.42,-2053.6,4.97}
,{51,24,-51451.395,0.4,8712.005,0.008,-3207.518,0.346,50.944764652,0.429,0,2393366.4,"",95.04,"",3.5,-1,"","",{"EC"},{0},{"="},{0},22260.97,2.21,17465.55,0.42,-8938.95,0.42,-11248.84,8.97,-7308.71,0.42,-16895.12,0.21,9260.64,0.2,9516.35,0.23,-39552,500,7221.34,0.92,-2109.65,1.05,2687.72,0.41}
,{51,25,-48243.877,0.502,8633.772,0.01,-8041.321,8.977,50.948208065,0.539,0,2772,"",6,"",2.5,-1,"","",{"B+"},{0},{"="},{0},26765.88,2.23,14859.89,0.97,-8662.17,0.53,-20901.73,48.44,-6308.83,0.41,-21838.74,8.4,13687.6,0.3,5270.78,0.29,"","",7799.99,2.22,-557.8,7.32,1880.22,1.1}
,{51,26,-40202.555,8.964,8460.759,0.176,-12860.412,49.26,50.956840779,9.623,0,0.3054,"",0.0023,"",2.5,-1,"","",{"B+"},{0},{"="},{0},31594.46,25.82,9447.44,9.24,-8064.89,10.8,-28303,500,2770.55,8.97,-30643,400,13797.42,12.27,4863.93,8.97,"","",8128.89,9.24,-6042.16,11.34,8265.87,11.57}
,{51,27,-27342.143,48.438,8193.254,0.95,-15442,503,50.970647,52,0,0.0688,"",0.0019,"",3.5,-1,"","",{"B+","B+p"},{0,3.8,0},{"=","<"},{0,3.8,0},33604,503,4299.45,48.49,-7200.69,57.87,"","",7996.48,48.44,-31293,503,17783,403,154.66,49.16,"","",8119.39,54.15,-4478,403,7600.6,48.93}
,{51,28,-11900,500,7875,10,"","",50.987225,537,0,0.0238,"",0.0002,"",3.5,-1,"","",{"B+","B+p","B+2p"},{0,87.2,0,0.5,0},{"=","=","="},{0,87.2,0,0.5,0},36242,781,1727,501,-7455,707,"","",15288,500,"","",15851,707,1558,640,"","",8691,707,-8535,707,11747,640}
,{52,18,-1280,600,7825,12,15858,601,51.998626,644,0,0.01,"",6.2e-07,">",0,1,"","",{"B-n","B-2n"},{0,7,0},{"=","="},{0,7,0},4093,781,"","",-16466,846,32986,600,"","",13165,600,2661,848,22859,922,48190,600,1691,848,2644,848,-16726,897}
,{52,19,-17137.627,33.534,8115.029,0.645,17128.639,33.54,51.981602,36,0,0.11,"",0.004,"",2,-1,"","",{"B-","B-n","B-2n"},{0,74,0,2.3,0},{"=","=","="},{0,74,0,2.3,0},7552.41,34.41,39455,601,-15282,501,23305.65,88.45,-38717,700,11123.36,33.54,2692.75,35.98,17737,601,34306.14,33.54,6903,501,4916,401,-12431,601}
,{52,20,-34266.266,0.671,8429.381,0.013,6177.013,81.855,51.963213648,0.72,0,4.6,"",0.3,"",0,1,"","",{"B-","B-n"},{0,2,0},{"=","<"},{0,2,0},10819.68,1.72,35515,500,-14409.84,307.39,15203.55,7.1,-34865,600,891.1,20.01,6005.28,0.85,19039.04,13.06,21152.98,0.75,2172.39,7.76,209.28,1.04,-11430,400}
,{52,21,-40443.279,81.852,8533.125,1.574,9026.541,82.157,51.956582351,87.871,0,8.2,"",0.2,"",0,0,"","",{"B-","B-n"},{0,4,0},{"=","="},{0,4,0},12038.53,83.21,29293.37,82.22,-10583.72,81.86,11000.49,81.85,-25216.05,82.89,1218.24,81.85,5285.91,84.26,11399.95,81.85,10264,81.87,9856.75,81.87,5720.54,81.85,-5185.39,81.86}
,{52,22,-49469.82,7.072,8691.667,0.136,1973.948,7.085,51.94689196,7.592,0,102,"",6,"",0,1,"","",{"B-"},{0},{"="},{0},14180.79,7.07,24458.54,7.25,-7670.11,7.07,5949.42,7.08,-20426.49,7.09,-5337.3,7.08,7808.3,7.09,13530.11,21.21,-1139.46,8.73,5788.37,16.58,1955.5,7.57,-2523.65,7.07}
,{52,23,-51443.769,0.42,8714.582,0.008,3975.473,0.531,51.944772839,0.45,0,224.58,"",0.3,"",3,1,"","",{"B-"},{0},{"="},{0},18362.39,0.15,21474.33,15.01,-9364.84,4.97,-736.49,1.88,-15504.06,20,-8063.69,0.25,7311.24,0.13,8999.9,0.66,-17082.82,8.39,10698.7,0.44,1984.07,0.43,763.9,2.73}
,{52,24,-55419.242,0.34,8775.989,0.007,-4711.958,1.851,51.940504992,0.364,1,"s","","s","",0,1,"","",{},{},{},{},21299.8,0.54,18565.52,0.36,-9351.45,0.36,-7088.88,5.12,-12975.38,0.61,-15246.68,0.59,12039.16,0.51,10504.37,0.52,-33089,400,4515.58,0.52,-2593.26,0.89,-1209.05,0.36}
,{52,25,-50707.284,1.845,8670.329,0.035,-2376.92,5.017,51.945563488,1.98,0,483062.4,"",259.2,"",6,1,"","",{"B+"},{0},{"="},{0},24222.32,1.89,16061.21,1.88,-8654.51,2.09,-16346.33,8.58,-5792.41,1.88,-18576.05,9.15,10534.72,1.9,6544.86,1.88,-48427,600,10265.59,1.89,-510.17,2.9,2901.05,2.02}
,{52,26,-48330.363,5.117,8609.574,0.098,-13969.413,9.822,51.948115217,5.493,0,29790,"",28.8,"",0,1,"","",{"B+"},{0},{"="},{0},29996.54,9.82,12646.23,5.13,-7933.26,8.93,-26001,400,-4167.94,5.13,-29059.54,48.71,16199.13,10.32,7375.46,5.14,"","",5008.04,5.13,-5845.67,5.59,2649.1,5.58}
,{52,27,-34360.951,8.383,8325.886,0.161,-12031,400,51.963112,9,0,0.1111,"",0.0023,"",6,1,"","",{"B+"},{0},{"="},{0},32873,400,6311.3,8.4,-7489.53,10.88,-32081,600,6593.96,8.4,-30532,500,15090.12,49.16,1447.37,12.27,"","",10826.31,11.86,-4746.17,25.63,8906.09,8.68}
,{52,28,-22330,400,8079,8,-20049,721,51.976028,429,0,0.0418,"",0.001,"",0,1,"","",{"B+","B+p"},{0,31.1,0},{"=","="},{0,31.1,0},34352,640,2431,400,-6754,565,"","",10584,400,"","",18501,640,2277,403,"","",6011,565,-7585,640,8067,400}
,{52,29,-2280,600,7679,12,"","",51.997552,644,0,"s","","s","",3,1,"","",{},{},{},{},"","",-772,721,-6205,781,"","",17773,602,"","","","",-2331,781,"","",12551,781,-5616,848,13246,781}
,{53,18,6791,699,7677,13,19086,708,53.00729,750,0,0.003,"",6.2e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,30,0},{"=","="},{0,30,0},2662,921,"","",-16727,966,36178,700,"","",15857,699,1,921,"","",53622,706,3211,989,3915,921,"",""}
,{53,19,-12295.721,111.779,8022.848,2.109,17091.983,120.047,52.9868,120,0,0.03,"",0.005,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,64,"",10,0},{"=","=","~"},{0,64,"",10,0},5922.16,112.54,41164,708,-15661,610,26611.09,146.11,"","",13899.23,111.78,3229.41,116.7,18305,610,39555.34,111.82,5105,610,5898,513,-14389,610}
,{53,20,-29387.704,43.78,8330.577,0.826,9519.104,103.774,52.968451,47,0,0.461,"",0.09,"",1.5,-1,"","",{"B-","B-n"},{0,40,""},{"=","="},{0,40,""},9198.04,43.78,37276,601,-14623,402,17443.36,109.21,-35397,601,2984.26,92.82,3192.76,43.79,19539.05,55.15,25899.29,43.78,3839.3,45.68,1204.2,44.46,-10412,502}
,{53,21,-38906.808,94.087,8495.421,1.775,7924.253,137.339,52.958231821,101.006,0,2.4,"",0.6,"",3.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11820.76,96.19,30968.55,94.99,-11720.23,94.09,12944.25,94.14,-29058.15,99.88,2491.7,94.35,6534.85,124.71,11929.51,94.09,15783.31,94.09,8136.3,94.09,5546.47,94.1,-7532.56,94.4}
,{53,22,-46831.061,100.049,8630.174,1.888,5020,100,52.949724785,107.406,0,32.7,"",0.9,"",0,0,"","",{"B-"},{0},{"="},{0},13240.86,100.05,25076.7,100.05,-7956.21,100.05,8455.94,100.05,-19853.77,100.05,-3458.61,100.05,5432.56,100.3,13676.75,129.27,4116.47,100.06,7108.43,102.03,2580.38,101.17,-1595.44,100.06}
,{53,23,-51851.061,3.12,8710.13,0.059,3435.938,3.102,52.944335593,3.349,0,92.58,"",0.84,"",3.5,-1,"","",{"B-"},{0},{"="},{0},15789.85,3.14,23200.32,20.24,-7714.71,4.12,2839.05,3.12,-18696.75,81.91,-4503.14,3.11,8478.61,3.15,9670.21,7.73,-9191.63,3.54,8592.58,3.16,4444.65,3.12,-1657.28,15.32}
,{53,24,-55286.999,0.348,8760.198,0.007,-596.884,0.356,52.940646961,0.373,1,"s","","s","",1.5,-1,"","",{},{},{},{},19978.24,0.52,20132.1,0.61,-9148.13,0.36,-4339.47,1.66,-13106.15,7.08,-12651.03,1.85,7939.07,0.14,11132.2,0.54,-25656.17,25.15,7627.65,0.52,-1198.93,0.53,1791.06,0.37}
,{53,25,-54690.116,0.45,8734.175,0.009,-3742.586,1.686,52.941287742,0.483,0,1.167606262e+14,"",12622770400000,"",3.5,-1,"","",{"EC"},{0},{"="},{0},22588.87,0.66,17064.22,0.59,-9153.1,0.94,-12030.69,1.74,-10535.32,0.61,-14431.07,5.13,12054.15,1.87,6559.84,0.33,-41420,500,7472.09,0.59,436.01,0.62,180.3,0.6}
,{53,26,-50947.53,1.656,8648.799,0.031,-8288.101,0.443,52.945305574,1.777,0,510.6,"",1.2,"",3.5,-1,"","",{"B+"},{0},{"="},{0},26887.61,9.11,14074.08,1.69,-8039.39,2.78,-21316.71,25.2,-2817.26,1.66,-24657.9,8.55,10688.48,5.16,7529.22,2.39,"","",8007.15,1.71,-3455.88,1.7,4960.94,1.7}
,{53,27,-42659.428,1.713,8477.658,0.032,-13028.604,25.209,52.954203217,1.839,0,0.242,"",0.008,"",3.5,-1,"","",{"B+"},{0},{"="},{0},31459.92,48.47,8993.49,1.77,-7463.71,2.82,-29389,500,758.88,2.43,-28401,400,16369.79,8.56,1618.04,5.17,"","",8253.93,9.12,-3318.92,8.56,5614.57,1.76}
,{53,28,-29630.824,25.15,8217.074,0.475,-16361,501,52.96819,27,0,0.0552,"",0.0007,"",3.5,-1,"","",{"B+","B+p"},{0,22.7,0},{"=","="},{0,22.7,0},33874,501,4006.21,26.7,-7305.01,34.92,"","",11410.57,25.67,-35422,600,15372,400,2558.84,26.51,"","",8422.13,54.58,-7136,400,10492.03,26.51}
,{53,29,-13270,500,7894,9,"","",52.985754,537,0,1.3e-07,"","s","",1.5,-1,"","",{},{},{},{},"","",506,503,-5815,707,"","",13802,500,"","",19061,781,-1771,640,"","",9341,707,-4286,707,10007,640}
,{54,19,-5002,596,7889,11,20158,598,53.99463,640,0,0.01,"",0.005,"",2,-1,"","",{"B-","B-n","B-2n"},{0,1,0,30,0},{"=","=","="},{0,1,0,30,0},4007,597,"","",-15167,846,28889,656,"","",16314,598,778,607,19082,918,44891,596,6989,846,6552,846,-13646,919}
,{54,20,-25160.585,48.438,8247.496,0.897,8730.315,277.066,53.972989,52,0,0.09,"",0.006,"",0,1,"","",{"B-","B-n","B-2n"},{0,7,0,0,0},{"=","=","="},{0,7,0,0,0},7036.95,48.44,38459,602,-14256,503,20461.4,95.64,-39240,700,5674.91,105.82,3844.2,65.29,20153.83,121.82,31774.18,48.44,2687.85,58.91,2219.67,50.16,-12824,602}
,{54,21,-33890.9,272.8,8394.681,5.052,11731.081,284.99,53.96361662,292.862,0,0.526,"",0.015,"",0,0,"","",{"B-","B-n"},{0,16,0},{"=","="},{0,16,0},9590.25,284.81,31331.21,274.85,-10587.97,272.91,16002.27,273.21,-28884.15,294.81,4868.84,290.57,3055.41,288.57,11792.17,276.29,21666.73,272.8,11086.17,272.8,7305.46,272.8,-5728.3,273.11}
,{54,22,-45621.981,82.461,8597.435,1.527,4271.192,83.815,53.951022786,88.526,0,2.1,"",1,"",0,1,"","",{"B-"},{0},{"="},{0},12294.79,82.76,25933.66,82.46,-8457.67,82.48,11312.78,82.46,-23523.25,93.36,-1842.24,82.52,6862.24,129.65,14004.14,125.11,10632.52,82.46,5532.1,116.19,2470.76,84.85,-3643.28,82.46}
,{54,23,-49893.173,15.004,8662.043,0.278,7041.592,15,53.946437472,16.107,0,49.8,"",0.5,"",3,1,"","",{"B-"},{0},{"="},{0},14592.04,15.01,24027.83,83.22,-7770.71,21.22,5664.46,15.03,-18275.34,95.28,-2677.49,15,6113.43,15.32,10351.08,101.17,-1883.22,15.01,10287.45,16.59,4703.72,15.01,-1018.09,25}
,{54,24,-56934.765,0.353,8777.955,0.007,-1377.136,1.008,53.938878012,0.378,1,"s","","s","",0,1,"","",{},{},{},{},17658.16,0.18,22042.89,7.08,-7928.02,0.37,-680.26,0.39,-17392.67,100.05,-10315.97,0.37,9719.08,0.12,12372.67,3.1,-17656.46,4.67,5219.81,0.54,133.13,0.52,-1555.53,0.61}
,{54,25,-55557.629,1.059,8737.965,0.02,696.872,1.076,53.940356429,1.136,0,26974080,"",17280,"",3,1,"","",{"EC","B-","e+"},{0,0.93,0,1.28,0},{"=","=","="},{0,0.93,0,1.28,0},20992.98,2.1,18691.8,1.13,-8758.53,1.13,-7547.68,1.08,-10995.54,3.26,-12681.42,1.94,8938.83,1.06,7559.6,1,-34147,400,10572.42,1.01,757.82,1.13,2292.61,1.13}
,{54,26,-56254.5,0.372,8736.382,0.007,-8244.547,0.089,53.939608306,0.399,1,"s","","s","",0,1,"","",{},{},{},{},24066.77,5.1,15413.2,0.4,-8417.34,0.54,-16976.19,4.67,-8256.47,0.4,-21666.39,1.67,13378.29,1.61,8853.36,0.49,-49983,400,5163.59,1.81,-3146.57,0.58,843.3,0.52}
,{54,27,-48009.953,0.383,8569.217,0.007,-8731.646,4.673,53.948459192,0.411,0,0.19328,"",7e-05,"",0,1,"","",{"B+"},{0},{"="},{0},29791.64,8.39,11880.61,1.81,-7807.27,0.55,-26600,400,-608.81,0.5,-26450.45,25.15,13421.84,1.67,4351.39,1.62,"","",11031.22,5.1,-2943.34,8.97,5880.32,0.59}
,{54,28,-39278.308,4.657,8393.032,0.086,-17868,400,53.957833,5,0,0.1142,"",0.0003,"",0,1,"","",{"B+"},{0},{"="},{0},33091,400,5525.89,6.92,-7226.77,9.59,-33006,400,4380.25,4.94,-34080,500,17718.8,25.58,3907.85,4.96,"","",5793.45,9.59,-7072.11,48.66,6570.65,10.1}
,{54,29,-21410,400,8048,7,-15139,565,53.977015,429,0,7.5e-08,"","s","",3,1,"","",{},{},{},{},35273,721,1627,400,-6205,565,"","",13960,400,"","",16212,640,-931,400,"","",11630,565,-4646,640,11578,403}
,{54,30,-6272,400,7753,7,"","",53.993267,430,0,0.0018,"",0.0005,"",0,1,"","",{"2p"},{0},{"="},{0},"","",-1480,20,-4577,641,"","",16070,401,"","","","",291,641,"","",6719,721,"","",11274,641}
,{55,19,708,699,7788,13,19058,760,55.00076,750,0,0.003,"",6.2e-07,">",1.5,1,"","",{"B-n","B-2n"},{0,1,0},{"=","="},{0,1,0},3139,708,"","",-16007,989,30867,833,"","",17797,700,2361,918,"","",49853,705,4628,988,6852,921,"",""}
,{55,20,-18350,300,8120,5,11809,544,54.9803,322,0,0.022,"",0.002,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,1,0,"",""},{"=","=",""},{0,1,0,"",""},5105,303,39719,760,-14085,671,23318,341,"","",7469,405,1261,304,20637,667,36759,300,4656,320,3651,302,-11424,671}
,{55,21,-30159.352,454.342,8320.955,8.261,11508.735,482.226,54.967622601,487.756,0,0.096,"",0.002,"",0,0,"","",{"B-","B-n","B-2n"},{0,17,0,0,0},{"=","=","="},{0,17,0,0,0},7395.18,463.98,32441.57,467.89,-10068.07,454.53,18985.23,464.19,-32446,750,7391.31,461.76,4339.77,529.95,12287.74,456.92,27553.06,454.34,9939.16,456.45,8970.97,454.34,-7375.32,455.58}
,{55,22,-41668.088,161.602,8515.98,2.938,7476.498,157.206,54.955267465,173.486,0,1.3,"",0.1,"",0,0,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},10979.66,190.07,26858.32,167.43,-7760.7,161.6,13441.62,161.6,-23796.47,168.7,153.77,162.3,4117.42,181.42,15066.16,317.07,15813.21,161.6,7949.53,187,3639.25,181.15,-1755.42,161.6}
,{55,23,-49144.586,95.104,8637.692,1.729,5965.125,95.103,54.947241114,102.098,0,6.54,"",0.15,"",3.5,-1,"","",{"B-"},{0},{"="},{0},13436.16,95.15,24815.72,133.78,-8340.82,97.18,8567.83,95.1,-22542.66,288.9,-281.14,95.1,7322.73,96.28,10811.58,125.88,4885.3,95.1,8397.28,138.04,5189.29,95.37,-3054.91,125.48}
,{55,24,-55109.71,0.399,8731.924,0.007,2602.703,0.368,54.940837289,0.428,0,209.82,"",0.18,"",1.5,-1,"","",{"B-"},{0},{"="},{0},15965.35,0.22,22856.59,100.05,-7801.79,0.64,2371.59,0.41,-16776.7,82.46,-7623.4,1.02,6246.26,0.19,12505.51,15,-9773.86,0.76,7452.16,3.11,1198.11,0.57,6.51,7.08}
,{55,25,-57712.413,0.303,8765.022,0.006,-231.114,0.179,54.938043172,0.325,1,"s","","s","",2.5,-1,"","",{},{},{},{},19164.93,0.43,20439.29,3.12,-7933.49,0.48,-3682.53,0.34,-15108.21,15,-9529.23,0.25,10226.1,1.05,8066.62,0.32,-26077.01,155.56,8285.39,0.32,2570.88,0.33,-622.24,0.5}
,{55,26,-57481.3,0.342,8746.595,0.006,-3451.417,0.324,54.938291283,0.367,0,86592204.944,"",284012.334,"",1.5,-1,"","",{"EC"},{0},{"="},{0},22676.4,1.62,16772.24,0.36,-8454.82,0.5,-12145.45,0.66,-7835.51,0.36,-17542.66,0.21,9298.12,0.19,9212.64,1.06,-42911,400,7919.62,0.46,-1909.96,1.82,3584.34,0.37}
,{55,27,-54029.883,0.428,8669.618,0.008,-8694.034,0.578,54.941996531,0.459,0,63108,"",108,"",3.5,-1,"","",{"B+"},{0},{"="},{0},27513.09,1.7,13917.71,0.53,-8210.92,0.62,-22394.48,155.56,-5761.22,1.1,-22822.89,4.68,14091.25,0.31,5064.35,0.3,"","",7628.45,1.64,-835.46,5.11,2323.8,1.83}
,{55,28,-45335.849,0.719,8497.32,0.013,-13700.449,155.561,54.951329961,0.771,0,0.2047,"",0.0017,"",3.5,-1,"","",{"B+"},{0},{"="},{0},31847.66,25.16,8966.26,1.74,-7558.21,8.99,-30765,400,3629.68,0.65,-31997,400,14128.86,4.71,4614.87,0.66,"","",8034.39,1.79,-6110.84,8.41,8640.92,5.14}
,{55,29,-31635.399,155.559,8233.996,2.828,-17065,429,54.966038,167,0,0.057,"",0.003,"",1.5,-1,"","",{"B+","B+p"},{0,15,0},{"=","="},{0,15,0},34508,524,3553.91,155.57,-6718.17,162.93,"","",9085.58,155.56,-33435,429,18296,429,-353.94,155.63,"","",8706.23,157.58,-4442,429,8371.95,155.79}
,{55,30,-14570,400,7909,7,"","",54.984358,429,0,0.0198,"",0.0013,"",2.5,-1,"","",{"B+","B+p"},{0,91,0},{"=","="},{0,91,0},"","",-482,400,-5096,640,"","",17419,400,"","",16370,565,449,565,"","",9410,640,-7426,721,13406,565}
,{56,19,7927,801,7664,14,21825,895,56.00851,860,0,0.001,"",6.2e-07,">",2,-1,"","",{"B-n","B-2n"},{0,40,0},{"=","="},{0,40,0},3213,999,"","","","",32779,993,"","",18206,855,852,1063,"","",54082,820,"","",6000,1063,"",""}
,{56,20,-13898,400,8040,7,10954,710,55.98508,429,0,0.011,"",0.002,"",0,1,"","",{"B-","B-n","B-2n"},{0,5,0,"",""},{"=","=",""},{0,5,0,"",""},4880,403,"","",-15043,721,25422,418,"","",8190,605,3619,500,21895,805,41387,400,1815,718,3262,415,-15042,805}
,{56,21,-24852.26,586.841,8221.728,10.479,14467.788,599.236,55.97332,630,0,0.026,"",0.006,"",1,1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},7103.99,647.15,34428,837,-10139.55,587.8,21302.62,612.92,-32849,912,8744.51,608.69,2764.22,742.17,13791,659,32059.28,586.84,11019.13,588.84,9399.5,588.47,-6910.14,597.39}
,{56,22,-39320.048,121.247,8466.11,2.165,6834.833,194.55,55.95778819,130.164,0,0.2,"",0.005,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9840.7,146.63,28737.4,130.56,-7478.7,121.25,15964.95,121.25,-28259,324,1753.22,154.1,5723.28,202.03,16449.67,470.24,21287.03,121.25,5281.66,298.53,4450.82,153.47,-4285.94,128.91}
,{56,23,-46154.881,176.898,8574.191,3.159,9130.12,176.899,55.950450694,189.907,0,0.216,"",0.004,"",1,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},12404.34,177.53,26841.92,325.13,-8136.52,194.92,10756.66,176.9,-23284.5,487.57,883.51,176.9,5081.61,200.84,11775.76,239.6,9885.52,176.9,10177.91,195.17,5540.24,203.23,-1601.67,200.36}
,{56,24,-55285.001,0.603,8723.258,0.011,1626.538,0.561,55.940649107,0.647,0,356.4,"",6,"",0,1,"","",{"B-"},{0},{"="},{0},14492.87,0.62,24240.96,82.46,-8240.1,7.1,5322.08,0.52,-20905.88,161.6,-5643.9,0.54,8246.61,0.65,13429.39,95.11,-1377.46,0.61,5318.98,15.01,1430.12,3.16,-2807.54,100.05}
,{56,25,-56911.538,0.331,8738.333,0.006,3695.544,0.207,55.938902947,0.355,0,9284.04,"",0.36,"",3,1,"","",{"B-"},{0},{"="},{0},17496.54,1.06,21596.31,15,-7892.68,0.52,-871.14,0.45,-15055.92,95.1,-7501.56,0.22,7270.44,0.13,9090.8,0.39,-18268.51,14.91,10734.03,0.34,3239.52,0.35,585.92,3.12}
,{56,26,-60607.082,0.302,8790.354,0.005,-4566.68,0.411,55.934935617,0.324,1,"s","","s","",0,1,"","",{},{},{},{},20495.22,0.28,18250.26,0.33,-7612.76,0.34,-6699.54,0.32,-12786.34,0.38,-14648.52,0.34,11197.1,0.23,10183.64,0.16,-35217,400,5661.35,1.06,-1052.91,0.43,326.32,0.34}
,{56,27,-56040.402,0.493,8694.836,0.009,-2132.863,0.374,55.93983815,0.529,0,6673190.4,"",2246.4,"",4,1,"","",{"B+"},{0},{"="},{0},24173.08,0.47,15060.71,1.13,-7758.03,1.87,-17397.37,14.91,-5616.96,0.43,-18775.87,0.74,10081.84,0.46,5848.07,0.45,-52651,500,10924.9,0.46,-228.82,1.68,4296.11,0.59}
,{56,28,-53907.539,0.422,8642.779,0.008,-15264.511,14.91,55.942127872,0.452,0,524880,"",864,"",0,1,"","",{"B+"},{0},{"="},{0},30771.87,4.68,12230.98,0.36,-8002.09,5.12,-28518,400,-3715.21,0.35,-30343.46,155.56,16643.01,0.67,7166.63,0.34,"","",4813.22,0.37,-6384.06,1.71,2686.39,1.65}
,{56,29,-38643.029,14.904,8356.227,0.266,-13253,400,55.958515,16,0,0.093,"",0.003,"",4,1,"","",{"B+","B+p"},{0,0.4,0},{"=","="},{0,0.4,0},33375,400,5211.02,14.91,-6706.99,17.1,-35253,500,8097.88,14.91,-32144,400,15078.95,156.27,596.15,14.92,"","",11346.09,15.61,-4148.15,29.23,9662.8,15}
,{56,30,-25390,400,8106,7,-22000,640,55.972743,429,0,0.0329,"",0.0008,"",0,1,"","",{"B+","B+p"},{0,88,0},{"=","="},{0,88,0},35261,565,689,400,-5485,565,"","",12657,400,"","",18891,565,1043,429,"","",6731,565,-7256,640,9887,400}
,{56,31,-3390,500,7699,9,"","",55.996361,537,0,"s","","s","",3,1,"","",{},{},{},{},"","",-3443,640,-3534,781,"","",20957,524,"","","","",-3892,640,"","",13593,641,"","",15527,707}
,{57,20,-6874,400,7917,7,14121,1364,56.99262,429,0,0.005,"",6.2e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},4667,500,"","",-16090,805,27041,475,"","",9907,710,1048,565,22090,895,45650,400,3128,805,2992,718,"",""}
,{57,21,-20995.875,1304.092,8151.433,22.879,12919.758,1329.062,56.97746,1400,0,0.022,"",0.002,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,30,0,1,0},{"=","=","="},{0,30,0,1,0},6979.16,1380.97,36282,1479,-11125.07,1308.87,23417.58,1306.57,-36212,1530,10252.86,1309.72,4214.93,1430.05,14387,1364,36490.38,1304.09,8065,1338,9028.76,1304.99,-10347,1434}
,{57,22,-33915.633,256.417,8364.37,4.499,10497.818,268.75,56.963590068,275.274,0,0.095,"",0.008,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},8390.18,303.09,30143,395,-6952.84,260.13,18609.07,256.42,-27307,475,4167.93,311.52,2666.9,283.64,16352.34,640.42,26266.21,256.42,6954.53,521.71,4839.32,374.39,-3108.65,260.95}
,{57,23,-44413.45,80.479,8534.817,1.412,8111.252,80.486,56.952320197,86.397,0,0.35,"",0.01,"",3.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11411.5,124.59,28832.04,461.41,-7931.56,123.81,13072.8,80.49,-26850.16,592.33,2800.23,80.48,6329.89,194.34,12382.37,145.53,14932.11,80.48,7965.44,180.53,6072.59,115.22,-4876.15,284.42}
,{57,24,-52524.702,1.068,8663.394,0.019,4961.548,1.846,56.943612409,1.146,0,21.1,"",1,"",0,0,"","",{"B-"},{0},{"="},{0},13557.63,1.14,25434.56,161.61,-8118.56,100.05,7657.14,1.11,-20493.63,121.25,-3684.48,1.12,5311.02,1.23,13658.79,176.9,3559.13,1.22,7330.69,95.11,2232.53,15.04,-1256.32,82.47}
,{57,25,-57486.251,1.505,8736.713,0.026,2695.589,1.526,56.938285968,1.615,0,85.4,"",1.8,"",2.5,-1,"","",{"B-"},{0},{"="},{0},15916.47,1.52,22919.61,95.12,-8060.11,3.46,1859.31,1.59,-18620.34,176.9,-4950.49,1.53,8646.03,1.53,9490.22,1.61,-10177.36,1.58,8334.27,1.55,4312.57,1.54,-1946.68,15.08}
,{57,26,-60181.839,0.304,8770.279,0.005,-836.276,0.451,56.935392134,0.326,1,"s","","s","",0.5,-1,"","",{},{},{},{},18843.17,0.23,19650.07,0.38,-7319.76,0.34,-4098.01,0.51,-12185.81,0.52,-12212.75,0.41,7646.07,0.04,10559.27,0.21,-27632,200,8241.38,0.16,239.84,1.06,2399.33,0.34}
,{57,27,-59345.564,0.533,8741.882,0.009,-3261.731,0.642,56.936289913,0.572,0,23474880,"",8640,"",3.5,-1,"","",{"EC"},{0},{"="},{0},21458.32,0.54,16211.09,0.47,-7080.36,0.62,-12036.68,0.6,-9723,0.49,-13509.34,0.52,11376.48,0.57,6027.45,0.45,-44335,400,8846.54,0.5,1772.99,0.52,1858.47,1.14}
,{57,28,-56083.833,0.582,8670.933,0.01,-8774.947,0.439,56.939791525,0.624,0,128160,"",216,"",1.5,-1,"","",{"B+"},{0},{"="},{0},26890.62,0.81,13180.47,0.55,-7561.22,1.71,-23534,200,-2765.72,0.51,-25512.12,14.92,10247.61,0.52,7332.4,0.59,"","",8656.86,0.57,-3209.82,0.57,5817.07,0.56}
,{57,29,-47308.886,0.519,8503.262,0.009,-14759,200,56.949211819,0.557,0,0.1963,"",0.0007,"",1.5,-1,"","",{"B+"},{0},{"="},{0},31816.12,155.56,7856.94,0.49,-7074.37,1.74,-32299,400,1442.55,0.52,-29990,400,16737.17,14.91,690.32,0.41,"","",8737.77,0.76,-3166.52,4.69,6347.47,0.49}
,{57,30,-32550,200,8231,4,-17540,447,56.965056,215,0,0.038,"",0.004,"",3.5,-1,"","",{"B+","B+p"},{0,65,0},{"=","~"},{0,65,0},34122,447,1792,200,-5344,202,"","",14068,200,-37232,539,15232,447,1196,201,"","",9796,254,-6276,447,12375,200}
,{57,31,-15010,400,7909,7,"","",56.983886,429,0,"s","","s","",0.5,-1,"","",{},{},{},{},"","",-2047,429,-4165,640,"","",16344,400,"","",19692,640,-3091,565,"","",10271,565,-3874,565,12047,565}
,{58,20,-1919,500,7835,9,12957,640,57.99794,537,0,0.003,"",6.2e-07,">",0,1,"","",{"B-n","B-2n"},{0,4,0},{"=","="},{0,4,0},4164,640,"","","","",29191,539,"","",11006,1397,3116,640,"","",50073,500,865,944,2237,859,"",""}
,{58,21,-14876,400,8045,7,16234,447,57.98403,429,0,0.012,"",0.005,"",3,1,"","",{"B-","B-n","B-2n"},{0,20,0,1,0},{"=","=","="},{0,20,0,1,0},6166,710,37381,895,-12299,718,25526,409,"","",10968,475,1951,1364,15291,565,40952,400,9733,565,8339,500,-9937,805}
,{58,22,-31110,200,8311,3,9292,219,57.966602,215,0,0.055,"",0.006,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},7933,234,31790,447,-8374,206,20882,200,-31525,447,5232,216,5266,325,17403,1319,31045,200,4453,620,3913,497,-7113,361}
,{58,23,-40401.753,89.374,8457.658,1.541,11590.049,89.386,57.956626932,95.947,0,0.191,"",0.01,"",1,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10389.51,198.19,30127.43,593.61,-8935.77,287.07,15425.81,89.41,-26694.85,1307.15,4051.63,89.38,4059.62,120.27,13775.09,271.55,19445.41,89.38,9629.1,150.63,6130.39,184.67,-4596,463.05}
,{58,24,-51991.801,1.49,8643.998,0.026,3835.759,3.085,57.944184502,1.6,0,7,"",0.3,"",0,1,"","",{"B-"},{0},{"="},{0},12849.43,1.61,27249.69,121.26,-8794.74,82.47,10163.31,1.53,-25365.14,256.42,-2576.87,2.12,7538.42,1.83,14867.32,80.49,8236.94,1.54,4873.89,176.9,2016.84,95.12,-4677.31,161.61}
,{58,25,-55827.56,2.701,8696.643,0.047,6327.553,2.723,57.940066646,2.9,0,3,"",0.1,"",1,1,"","",{"B-"},{0},{"="},{0},15058.66,2.72,24250.62,176.92,-8359.3,15.25,4019.6,2.94,-18703.08,80.52,-3717.04,2.72,6412.63,3.09,10591.83,2.9,-4159.84,2.76,10168.25,2.77,4146.21,2.73,-1036.57,95.14}
,{58,26,-62155.113,0.343,8792.25,0.006,-2307.955,1.139,57.933273738,0.368,1,"s","","s","",0,1,"","",{},{},{},{},17690.66,0.18,21448.05,0.55,-7645.26,0.38,-1926.37,0.3,-16919.38,1.12,-10880.87,0.5,10044.59,0.18,11957.83,1.54,-19856.37,50,5467.23,0.28,421.36,0.24,-1399,0.42}
,{58,27,-59847.158,1.16,8738.969,0.02,381.586,1.107,57.935751429,1.245,0,6122304,"",5184,"",2,1,"","",{"B+"},{0},{"="},{0},19949.39,1.17,17513.56,1.14,-6714.45,1.54,-8179.43,1.19,-9649.88,1.89,-11834.64,1.21,8572.91,1.18,6954.29,1.13,-36307,300,11470.73,1.13,2498.2,1.15,3511.66,1.14}
,{58,28,-60228.744,0.373,8732.059,0.006,-8561.019,0.443,57.93534178,0.4,1,"s","","s","",0,1,"","",{},{},{},{},22463.84,0.35,14199.6,0.25,-6399.16,0.35,-17930,50,-7335.88,0.25,-20991.18,0.45,12216.23,0.5,8172.15,0.43,-53148,500,6522.46,0.39,-1334.81,0.38,2898.96,0.32}
,{58,29,-51667.725,0.578,8570.967,0.01,-9368.981,50.002,57.944532413,0.621,0,3.204,"",0.007,"",1,1,"","",{"B+"},{0},{"="},{0},29167.33,14.92,10205.26,0.59,-6082.69,0.57,-28128,300,388.87,0.62,-27189,200,12430.16,0.63,2872.86,0.67,"","",12950.62,0.56,-1467.82,0.82,8008.56,0.58}
,{58,30,-42298.744,50.001,8395.944,0.862,-18759,304,57.954590428,53.678,0,0.0867,"",0.0024,"",0,1,"","",{"B+","B+p"},{0,3,0},{"=","<"},{0,3,0},33052,403,2969.15,50,-5445.35,50.22,-35218,503,6496.12,50,-35360,403,17820,206,2278.83,50,"","",7055.09,52.18,-5799.29,163.4,8683.51,50}
,{58,31,-23540,300,8059,5,-16459,583,57.974729,322,0,"s","","s","",2,1,"","",{},{},{},{},36293,583,-525,300,-4554,500,"","",16480,300,"","",16601,500,-1721,361,"","",12561,500,-4105,500,13742,338}
,{58,32,-7080,500,7762,9,"","",57.992399,537,0,"s","","s","",0,1,"","",{},{},{},{},"","",-3732,640,-3233,641,"","",18181,539,"","","","",-641,640,"","",7020,707,"","",13137,640}
,{59,21,-10302,400,7967,7,15208,447,58.98894,429,0,0.01,"",6.2e-07,">",3.5,-1,"","",{"B-n","B-2n"},{0,1,0},{"=","="},{0,1,0},5449,1364,"","",-13435,805,27530,431,"","",12736,447,3498,565,15672,640,45223,400,7283,565,8460,565,-12583,895}
,{59,22,-25510,200,8212,3,12322,258,58.972614,215,0,0.0285,"",0.0019,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,"","","",""},{"=","",""},{0,"","","",""},7737,325,33213,447,-9584,361,22576,295,-30880,539,6821,219,2471,283,17923,447,35155,200,6197,1319,4206,620,-5966,447}
,{59,23,-37832.015,161.874,8407.555,2.744,10253.745,270.218,58.959385659,173.778,0,0.095,"",0.006,"",2.5,-1,"","",{"B-","B-n"},{0,6,0},{"=","="},{0,6,0},9561.2,180.78,31414.08,1314.1,-10097.58,482.32,17693.31,161.89,-30245,431,6088.47,161.88,5501.58,184.91,14011,258,24397.69,161.87,6794.42,303.24,6352.09,202.25,-7333.35,608.76}
,{59,24,-48085.76,216.367,8568.087,3.667,7439.56,216.38,58.94837781,232.279,0,1.05,"",0.09,"",0.5,-1,"","",{"B-"},{0},{"="},{0},11703.69,216.37,28748.07,335.51,-8842.59,270.06,12579.05,216.37,-24265,295,-329.52,216.38,4165.28,216.37,14972.98,234.1,13070.95,216.37,7038.5,230.85,2933.18,279.48,-3119.31,248.02}
,{59,25,-55525.32,2.329,8680.921,0.039,5139.485,2.356,58.940391113,2.5,0,4.59,"",0.05,"",2.5,-1,"","",{"B-"},{0},{"="},{0},14181.7,2.77,25689.81,80.51,-8805.65,95.13,6704.39,2.37,-22412.54,89.4,-1441.52,2.35,7769.08,3.57,10822.49,2.76,833.01,2.39,7710.19,2.56,4623.74,2.41,-3724.04,176.91}
,{59,26,-60664.805,0.355,8754.771,0.006,1564.903,0.369,58.934873649,0.38,0,3844368,"",777.6,"",1.5,-1,"","",{"B-"},{0},{"="},{0},16625.6,0.21,22718.04,1.13,-7980.01,0.43,491.9,0.32,-15961.97,1.53,-8888.96,1.14,6581.01,0.11,12126.22,2.72,-13449.25,0.75,7532.25,1.54,1110.79,0.29,266.6,0.56}
,{59,27,-62229.709,0.418,8768.035,0.007,-1073.002,0.194,58.933193656,0.448,1,"s","","s","",3.5,-1,"","",{},{},{},{},19026.78,0.44,19321.4,1.55,-6942.21,0.34,-5871.38,0.44,-13691.12,2.73,-10072.28,0.2,10453.87,1.1,7363.57,0.35,-28470,170,8662.94,0.32,3241.43,0.32,328.23,0.37}
,{59,28,-61156.707,0.374,8736.588,0.006,-4798.38,0.397,58.934345571,0.402,0,2556111006000,"",157784630000,"",1.5,-1,"","",{"B+"},{0},{"="},{0},21215.51,0.5,15552.81,0.26,-6100.32,0.33,-13941.16,0.67,-6290.56,0.31,-17560.3,0.45,8999.28,0.05,8598.52,1.11,-45287,400,8899.66,0.43,-252.25,0.4,5096.78,0.26}
,{59,29,-56358.327,0.544,8642,0.009,-9142.775,0.602,58.939496844,0.584,0,81.5,"",0.5,"",1.5,-1,"","",{"B+"},{0},{"="},{0},25192.08,0.6,11590.7,0.58,-4753.36,0.55,-22598,170,-3800.14,1.18,-22130.9,50,12761.92,0.56,3418.55,0.39,"","",10436.31,0.63,2413.27,0.53,5328.48,0.56}
,{59,30,-47215.551,0.771,8473.777,0.013,-13455,170,58.949312017,0.827,0,0.182,"",0.0018,"",1.5,-1,"","",{"B+","B+p"},{0,0.1,0},{"=","="},{0,0.1,0},30808,200,5709.66,0.84,-4304.62,0.96,-31346,400,5724.22,0.67,-31747,300,12988.12,50,2836.8,0.73,"","",10804.14,0.81,-3708.47,14.92,12338.39,0.76}
,{59,31,-33760,170,8232,3,-17890,434,58.963757,183,0,4.3e-08,"","s","",1.5,-1,"","",{},{},{},{},34893,434,1029,170,-4550,231,"","",10619,170,-34751,528,18292,345,-1250,178,"","",9501,263,-3506,434,10529,171}
,{59,32,-15870,400,7916,7,"","",58.982963,429,0,0.008,"",6.2e-07,">",3.5,-1,"","",{},{},{},{},"","",-2102,447,-3724,565,"","",19140,403,"","",16861,640,-381,500,"","",9851,565,-7616,640,15166,565}
,{60,21,-4052,500,7865,8,18278,583,59.99565,537,0,0.003,"",6.2e-07,">",3,1,"","",{"B-n","B-2n"},{"",50,0},{"","="},{"",50,0},5319,640,"","",-14404,944,29190,547,"","",13387,539,1821,640,"","",48916,500,8578,707,7686,640,"",""}
,{60,22,-22330,300,8157,5,10912,372,59.976028,322,0,0.0222,"",0.0016,"",0,1,"","",{"B-","B-n","B-2n"},{0,2,0,0,0},{"=","=","="},{0,2,0,0,0},7362,361,34989,583,-10857,500,24340,357,"","",7431,341,4891,361,19316,500,39083,300,3257,500,3530,1338,-9809,500}
,{60,23,-33241.956,220.159,8325.45,3.669,13427.621,293.169,59.96431329,236.35,0,0.122,"",0.018,"",3,1,"","",{"B-","B-n","B-2n"},{0,5,0,"",""},{"=","=",""},{0,5,0,"",""},8982.84,237.61,32944,456,-10814.61,626.78,19725.98,220.17,-30229,456,6772.49,308.68,3481.26,273.26,15021,298,28408.35,220.16,8579,298,5537.73,337.96,-6599.68,1322.54}
,{60,24,-46669.576,193.593,8536.205,3.227,6298.361,193.607,59.949898146,207.83,0,0.49,"",0.01,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},10820.41,193.6,30137,279,-9774.44,228.43,14743.44,193.62,-28449,279,784.43,193.61,6655.13,290.33,16126.53,252.35,17803.54,193.59,4442.98,213.23,2607.93,209.65,-7107.54,321.29}
,{60,25,-52967.938,2.329,8628.138,0.039,8445.079,4.128,59.943136576,2.5,0,0.28,"",0.02,"",1,1,"","",{"B-"},{0},{"="},{0},13283.01,3.57,27144.13,89.4,-9237.97,176.91,8682.37,2.37,-22424.89,161.89,-374.45,2.36,5513.93,3.29,12171.15,216.38,5377.2,2.84,9734.67,2.76,4420.82,2.56,-2908.09,80.51}
,{60,26,-61413.017,3.409,8755.851,0.057,237.293,3.411,59.934070411,3.659,0,82679146120000,"",1262277040000,"",0,1,"","",{"B-"},{0},{"="},{0},15400.54,3.39,23999.16,3.72,-8552.93,3.44,3060.1,3.41,-20616.23,216.39,-7254.63,3.41,8819.53,3.39,13176.67,4.13,-7238.68,3.43,5125.35,4.35,937.29,3.72,-3241.91,3.57}
,{60,27,-61650.309,0.424,8746.766,0.007,2822.809,0.212,59.933815667,0.455,0,166342868.3312,"",12622.7704,"",5,1,"","",{"B-"},{0},{"="},{0},17945.79,1.1,20400.69,2.73,-7163.69,0.38,-3305.17,1.59,-13413.96,2.37,-8564.92,0.21,7491.92,0.07,8274.47,0.38,-22060,200,11215.61,0.36,3395.59,0.32,1482.34,1.56}
,{60,28,-64473.118,0.376,8780.774,0.006,-6127.982,1.573,59.930785256,0.403,1,"s","","s","",0,1,"","",{},{},{},{},20387.01,0.07,16895.95,0.31,-6290.95,0.26,-10298.78,0.42,-11097.28,0.33,-16186.11,0.4,11387.73,0.05,9532.38,0.2,-37383,300,6084.85,1.11,-263.5,0.43,1355.12,0.26}
,{60,29,-58345.137,1.618,8665.602,0.027,-4170.797,1.629,59.937363916,1.736,0,1422,"",24,"",2,1,"","",{"B+"},{0},{"="},{0},22820.05,1.64,13075.92,1.92,-4729.65,1.62,-18755,200,-3404.4,1.59,-19200.9,1.71,10058.13,1.62,4477.4,1.57,-52875,400,12594.41,1.58,2602.75,1.65,6646.83,1.63}
,{60,30,-54174.34,0.564,8583.05,0.009,-14584,200,59.94184145,0.605,0,142.8,"",3,"",0,1,"","",{"B+"},{0},{"="},{0},28018.23,50,8523.54,0.41,-2691.72,0.54,-27085,300,-306.6,0.42,-28486,170,15030.11,0.71,5104.98,0.41,"","",8204.19,0.59,-2001.4,0.61,7555.89,0.65}
,{60,31,-39590,200,8327,3,-12501,361,59.957498,215,0,0.07,"",0.01,"",2,1,"","",{"B+","B+p","B+A"},{0,1.6,0,0.023,0},{"=","=","<"},{0,1.6,0,0.023,0},32193,361,2501,200,-3372,201,-34121,447,9479,200,-31792,447,13902,263,-336,200,"","",13419,206,-2176,283,13365,200}
,{60,32,-27090,300,8106,5,-21620,500,59.970918,322,0,0.03,"",1.1e-07,">",0,1,"","",{},{},{},{},36152,583,-631,304,-4125,500,"","",12837,300,"","",19291,500,619,345,"","",7161,424,-7216,500,11107,361}
,{60,33,-5470,400,7732,7,"","",59.994128,429,0,"s","","s","",5,1,"","",{},{},{},{},"","",-3492,500,-4505,640,"","",21001,434,"","","","",-3111,565,"","",12321,640,"","",15187,565}
,{61,21,931,600,7787,10,17281,721,61.001,644,0,0.002,"",6.2e-07,">",3.5,-1,"","",{"B-n","B-2n"},{0,1,0},{"=","="},{0,1,0},4909,721,"","","","",31438,1077,"","",15190,671,3088,781,"","",52674,600,"","",7714,781,"",""}
,{61,22,-16350,400,8057,7,14157,979,60.982448,429,0,0.015,"",0.004,"",0.5,-1,"","",{"B-","B-n","B-2n"},{0,1,0,1,0},{"=","=","="},{0,1,0,1,0},6982,447,"","",-11900,565,26126,412,"","",8821,456,2091,500,19587,640,42571,400,4664,565,3390,565,-8784,640}
,{61,23,-30506.429,894.234,8276.439,14.66,11968.8,899.958,60.96725,960,0,0.0482,"",0.0008,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=",">",""},{0,10,0,"",""},8817.05,908.77,34782,979,-11935.47,1581.24,21235.69,894.24,-33743,1025,8091.83,914.95,5335.79,920.94,15466,943,32391.64,894.23,5714,916,5468,916,-9984,979}
,{61,24,-42475.229,101.341,8459.824,1.661,9266.893,101.367,60.954400963,108.793,0,0.243,"",0.009,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10532.1,238.92,31543,224,-10984.51,275.72,16445.26,101.37,-27434,317,2421.39,101.37,3876.97,218.51,16522.24,242.36,21746.68,101.34,6067.59,190.98,2790.58,135.12,-5719,224}
,{61,25,-51742.122,2.329,8598.915,0.038,7178.372,3.497,60.944452544,2.5,0,0.709,"",0.008,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},12359.44,3.29,28488.05,161.89,-9753.59,80.51,11155.94,2.48,-25789.14,220.17,1599.58,4.13,6845.5,3.29,12361.52,193.61,10241.94,2.52,7054.44,216.38,5113.73,2.76,-5693.97,89.4}
,{61,26,-58920.494,2.608,8703.768,0.043,3977.572,2.742,60.936746244,2.8,0,358.8,"",3.6,"",1.5,-1,"","",{"B-"},{0},{"="},{0},14398.32,2.63,25412.68,216.38,-8820.71,2.82,5301.41,2.64,-19539.89,193.61,-5341.5,2.64,5578.79,4.29,13241.53,3.5,-2571.59,16.11,7315.63,3.5,1771.12,3.75,-1282.29,3}
,{61,27,-62898.066,0.846,8756.148,0.014,1323.839,0.79,60.932476145,0.908,0,5936.4,"",18,"",3.5,-1,"","",{"B-"},{0},{"="},{0},16810.99,0.82,21950.69,2.48,-7836.73,1.72,-914.01,1.2,-17219.1,2.48,-6496.26,0.79,9319.07,0.82,8774.02,3.49,-15763.41,38,8477.55,0.84,4121.1,0.84,-1424.1,2.83}
,{61,28,-64221.905,0.378,8765.025,0.006,-2237.845,0.966,60.931054945,0.405,1,"s","","s","",1.5,-1,"","",{},{},{},{},19207.83,0.07,18135.04,0.33,-6464.98,0.26,-7873,15.9,-10097.86,3.41,-13948.09,1.57,7820.1,0.05,9860.57,0.22,-30862,300,8718.61,0.21,489.31,1.11,3579.61,0.31}
,{61,29,-61984.059,0.953,8715.514,0.016,-5635.156,15.903,60.933457371,1.023,0,12020.4,"",28.8,"",1.5,-1,"","",{"B+"},{0},{"="},{0},21768.37,1.04,14332.29,0.98,-5063.41,1.04,-14849.4,38,-7622.72,0.99,-15881.04,1.05,11710.24,1.85,4799.91,0.97,-45084,300,9883.45,0.97,3108.74,0.97,3509.5,1.46}
,{61,30,-56348.903,15.899,8610.309,0.261,-9214.245,37.679,60.93950696,17.068,0,89.1,"",0.2,"",1.5,-1,"","",{"B+"},{0},{"="},{0},25275.99,15.91,9770.14,15.9,-2689.99,15.91,-22989,300,835.24,15.9,-24830,201,10245.88,15.91,5292.74,15.98,"","",10720.23,15.91,182.88,15.91,9526.24,15.9}
,{61,31,-47134.659,37.994,8446.431,0.623,-13775,302,60.949398859,40.787,0,0.167,"",0.003,"",1.5,-1,"","",{"B+","B+p"},{0,0.25,0},{"=","<"},{0,0.25,0},29517,175,5354.27,38,-2250.69,38,-30235,302,3921.51,38.03,-28116,302,15616,204,249.29,38,"","",10791.7,38,28.14,62.8,10179.47,38}
,{61,32,-33360,300,8208,5,-16459,424,60.964187,322,0,0.044,"",0.006,"",1.5,-1,"","",{"B+","B+p"},{0,62,0},{"=",">"},{0,62,0},33632,500,722,300,-3234,361,"","",13526,300,-35961,500,14341,424,1058,361,"","",11111,345,-4956,424,14586,304}
,{61,33,-16900,300,7925,5,"","",60.981857,322,0,"s","","s","",1.5,-1,"","",{},{},{},{},"","",-2282,345,-4315,500,"","",15401,361,"","",19502,500,-2901,424,"","",9681,500,-4956,583,12286,424}
,{62,22,-12500,400,7995,6,12977,499,61.986581,429,0,0.01,"",6.2e-07,">",0,1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},6313,500,"","",-13006,640,28395,426,"","",9935,979,4221,565,20720,721,46378,400,2263,640,2667,565,"",""}
,{62,23,-25476,298,8192,5,15419,333,61.97265,320,0,0.0336,"",0.0023,"",3,1,"","",{"B-","B-n","B-2n"},{0,20,0,"",""},{"=","=",""},{0,20,0,"",""},8377,371,36002,582,-13025,499,23048,298,-33697,670,8928,315,3041,943,16416,499,35948,299,7564,423,4898,359,-9528,499}
,{62,24,-40894.961,148.099,8428.069,2.389,7628.996,148.244,61.956097451,158.991,0,0.206,"",0.012,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},10368.02,243.74,33143,335,-12210,249,17983.09,148.13,-31834,426,2775.84,148.12,6491.05,179.45,17677.5,906.42,25851.36,148.1,3057.8,265.34,1801.11,219.4,-9739,249}
,{62,25,-48523.957,6.542,8538.499,0.106,10354.091,7.114,61.947907386,7.023,0,0.092,"",0.013,"",1,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11698.65,6.94,29859.94,220.26,-10547.12,89.61,12900.33,19.69,-25306.5,894.26,2325.22,7.04,4853.15,6.94,13337.7,101.55,14263.47,6.57,8856.43,193.7,4425.86,216.47,-5045.54,162.01}
,{62,26,-58878.048,2.794,8692.882,0.045,2546.235,18.784,61.936791812,3,0,68,"",2,"",0,1,"","",{"B-"},{0},{"="},{0},13607.67,4.41,26786.41,193.61,-9311.16,3.17,7868.27,2.83,-23691.79,101.38,-4051.3,2.92,8028.87,3.82,14424.9,3.64,2289.92,2.86,4800.7,3.64,1511.33,3.64,-5145.89,216.39}
,{62,27,-61424.282,18.575,8721.332,0.3,5322.04,18.57,61.934058317,19.94,0,92.4,"",6,"",0,0,"","",{"B-"},{0},{"="},{0},15916.61,18.57,23034.29,18.72,-8021.64,18.77,1363.14,18.58,-16971.13,18.72,-5273.69,18.57,6597.53,18.58,9792.76,18.76,-9437.38,18.58,10699.54,18.88,4104.58,18.57,-252.56,18.72}
,{62,28,-66746.323,0.439,8794.553,0.007,-3958.896,0.475,61.928344871,0.47,1,"s","","s","",0,1,"","",{},{},{},{},18415.84,0.31,19911.25,3.42,-7016.13,0.42,-5578.35,0.44,-15114.8,2.64,-12833.58,0.95,10595.73,0.31,11137.23,0.73,-25006,140,5614.79,0.37,347.44,0.37,-435.12,0.43}
,{62,29,-62787.426,0.647,8718.081,0.01,-1619.455,0.651,61.932594921,0.694,0,580.2,"",1.8,"",1,1,"","",{"B+"},{0},{"="},{0},20584.92,1.67,15715.06,0.6,-5365.18,1.24,-10800.52,0.67,-7178.33,0.87,-14509.84,15.91,8874.68,1.07,5854.49,0.57,-38467,300,12396.5,0.57,3233.34,0.57,5088.68,0.6}
,{62,30,-61167.972,0.625,8679.343,0.01,-9181.066,0.376,61.934333477,0.67,0,33094.8,"",54,"",0,1,"","",{"B+"},{0},{"="},{0},23136.27,0.69,11272.79,0.54,-3364.14,0.55,-19428,140,-4235.04,0.54,-22104.63,38,12890.39,15.91,6472.88,1.05,"","",7887.97,1.66,54.41,0.67,5635.14,0.54}
,{62,31,-51986.906,0.647,8518.642,0.01,-10247,140,61.944189757,0.694,0,0.116121,"",2.1e-05,"",0,1,"","",{"B+"},{0},{"="},{0},28539,200,8219.71,1.67,-2744.1,0.72,-27667,300,2708.18,1.07,-26699,300,12923.56,38,2926.97,15.91,"","",12898.24,0.71,92.7,0.88,10017.82,0.69}
,{62,32,-41740,140,8341,2,-17420,331,61.95519,150,0,0.129,"",0.035,"",0,1,"","",{"B+"},{0},{"="},{0},30793,331,2144,140,-1866,148,"","",7320,141,-32911,331,16452,331,1895,145,"","",8561,244,-3116,220,11122,140}
,{62,33,-24320,300,8047,5,"","",61.973891,322,0,"s","","s","",1,1,"","",{"p"},{0},{"="},{0},34993,500,-692,361,-3206,424,"","",15525,302,"","",15492,424,-1750,424,"","",13480,424,-3586,500,15086,345}
,{63,22,-5750,500,7889,8,16140,640,62.993827,537,0,0.003,"",6.2e-07,">",0.5,-1,"","",{"B-n","B-2n"},{0,4,0},{"=","="},{0,4,0},5543,640,"","","","",30257,615,"","",11655,582,1322,640,"","",49886,500,4029,781,3166,707,"",""}
,{63,23,-21890,400,8133,6,14117,537,62.9765,429,0,0.0196,"",0.0009,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,35,0,"",""},{"=",">",""},{0,35,0,"",""},7526,979,37400,721,-14013,565,24997,400,"","",10934,426,4485,499,16679,565,39961,400,5170,565,5304,500,-12192,640}
,{63,24,-36007.474,358.073,8344.828,5.684,10879.579,358.092,62.961344384,384.407,0,0.129,"",0.002,"",0.5,-1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},9674.88,372.14,34236,537,-12922,410,19628.15,358.1,-30797,537,4445.17,358.13,3183.83,387.49,17820,466,29505.3,358.07,5209.76,963.26,2098.54,420.34,-8031,467}
,{63,25,-46887.053,3.726,8505.101,0.059,8748.568,5.692,62.949664675,4,0,0.275,"",0.004,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11287.57,4.39,30958.57,894.24,-11479.95,161.92,14964.39,18.95,-28700,298,3919.68,4.66,6434.41,7.53,13281.06,148.15,18692.7,3.75,6298.98,101.41,4646.58,193.63,-7998.7,220.19}
,{63,26,-55635.621,4.302,8631.549,0.068,6215.819,19.067,62.9402727,4.618,0,6.1,"",0.6,"",2.5,-1,"","",{"B-"},{0},{"="},{0},12857.76,5.03,27738.33,101.43,-9974.78,216.41,9877.15,4.32,-22029.63,148.16,-2282.66,19.07,4828.89,5.13,14400.63,7.83,6577.78,4.58,6817.31,4.89,2196.37,4.89,-3319.64,193.64}
,{63,27,-61851.44,18.575,8717.795,0.295,3661.335,18.57,62.933599744,19.941,0,26.9,"",0.4,"",3.5,-1,"","",{"B-"},{0},{"="},{0},15096.01,18.58,24687.26,18.72,-8751.04,18.72,3728.31,18.57,-20616.45,19.69,-3176.43,18.57,8498.48,26.26,10262.36,18.78,-5304.35,18.62,7779.86,18.76,4425.63,18.88,-3237.1,18.72}
,{63,28,-65512.775,0.44,8763.493,0.007,66.977,0.015,62.929669139,0.472,0,3193560911.2,"",47335389,"",0.5,-1,"","",{"B-"},{0},{"="},{0},17433.5,0.31,21170.22,2.65,-7272.89,0.43,-3299.38,1.55,-13923.7,2.83,-10796.67,0.48,6837.77,0.06,11377.46,18.57,-18591.56,37.26,8096.1,0.73,1001.59,0.38,1546.64,3.42}
,{63,29,-65579.752,0.44,8752.138,0.007,-3366.355,1.546,62.929597236,0.472,1,"s","","s","",1.5,-1,"","",{},{},{},{},19738.33,0.95,17259.63,0.73,-5774.96,0.37,-9032.66,1.38,-11444.44,18.57,-12483.1,0.45,10863.64,0.48,6122.4,0.06,-32080,200,9352.96,0.31,3757.42,0.31,1716.96,0.38}
,{63,30,-62213.397,1.561,8686.285,0.025,-5666.304,2.034,62.933211167,1.676,0,2308.2,"",3,"",1.5,-1,"","",{"B+"},{0},{"="},{0},22007.13,15.96,12569.43,1.56,-3481.61,1.56,-15292.18,37.29,-2756.05,1.55,-18297.81,1.62,9116.74,1.61,6714.94,1.62,"","",10481.47,1.63,995.79,2.22,7906.12,1.56}
,{63,31,-56547.093,1.304,8583.926,0.021,-9625.877,37.283,62.939294195,1.4,0,32.4,"",0.5,"",0,0,"","",{"B+"},{0},{"="},{0},25555.07,38.02,9140.97,1.62,-2613.68,1.41,-23047,200,-1048.64,1.46,-22878,140,12631.5,1.46,2668.09,1.45,"","",10512.62,15.95,2491.3,1.42,7444.45,2.08}
,{63,32,-46921.216,37.26,8418.716,0.591,-13421,204,62.949628,40,0,0.142,"",0.008,"",1.5,-1,"","",{"B+"},{0},{"="},{0},29704,302,5150.25,40.51,-2130.58,37.27,"","",6957.79,37.26,-30672,302,13252,145,2223.28,37.27,"","",10924.25,53.21,-2467,204,12899.53,37.26}
,{63,33,-33500,200,8193,3,"","",62.964036,215,0,4.3e-08,"","s","",1.5,-1,"","",{"p"},{0},{"="},{0},32743,361,944,204,-2165,263,"","",11198,200,"","",17251,361,-951,244,"","",10570,361,-1546,361,11737,283}
,{64,22,-1025,600,7818,9,15295,721,63.9989,644,0,0.004,"",6.2e-07,">",0,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},4668,721,"","","","",32455,744,"","",12794,721,3346,781,"","",53945,600,"","",2908,848,"",""}
,{64,23,-16320,400,8045,6,17160,594,63.98248,429,0,0.015,"",0.002,"",0,0,"","",{"B-","B-n","B-2n"},{0,30,0,4,0},{"=","=","="},{0,30,0,4,0},6986,499,"","",-14693,640,26669,400,"","",11616,537,2501,565,17859,640,43473,400,6891,565,4894,565,-11605,721}
,{64,24,-33479.757,439.665,8301.058,6.87,9509.277,439.679,63.964058,472,0,0.043,"",0.001,"",0,1,"","",{"B-","B-n"},{0,2,0},{"=","="},{0,2,0},8727.43,463.94,35558,594,-13575,532,21489.79,439.69,-35019,666,5335.98,439.68,5543.6,567.03,18879,594,33619.16,439.67,2707,531,1890.73,996.47,-11484,594}
,{64,25,-42989.035,3.54,8437.417,0.055,11980.51,6.14,63.95384937,3.8,0,0.0888,"",0.0024,"",1,1,"","",{"B-","B-n"},{0,33,0},{"=","="},{0,33,0},10607.71,7.44,32091,298,-12171.99,220.19,16803.29,20.32,-28388,400,4575.27,5.57,4173.3,5.14,14270.53,358.09,22435.51,3.57,8616.73,148.14,4350.25,101.4,-6836.2,894.24}
,{64,26,-54969.544,5.017,8612.388,0.078,4822.785,20.625,63.940987763,5.386,0,2,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},12234.13,5.74,28652.52,148.18,-10724.88,193.66,12129.38,5.04,-26251.04,358.11,-1189.42,19.24,7405.24,6.61,15371.46,6.25,11034.47,5.06,4265.22,8.24,1636.63,5.53,-6847.91,101.46}
,{64,27,-59792.329,20.006,8675.52,0.313,7306.592,20,63.935810291,21.476,0,0.3,"",0.03,"",1,1,"","",{"B-"},{0},{"="},{0},14510.68,27.29,25846.31,21.05,-9249.31,20.14,5632.22,20,-20194.25,20.35,-2350.87,20,6012.21,27.29,11445.68,20.46,-959.51,20.06,9796.52,20.2,3992.22,20.17,-2403.81,20.14}
,{64,28,-67098.921,0.475,8777.461,0.007,-1674.376,0.225,63.927966341,0.51,1,"s","","s","",0,1,"","",{},{},{},{},16495.23,0.21,22798.81,2.83,-8110.82,3.42,-1094.91,0.68,-18752.27,4.33,-9590.49,0.2,9657.46,0.2,12536.45,18.57,-12783.43,3.76,5036.17,18.57,663.2,0.7,-2532.03,2.65}
,{64,29,-65424.545,0.448,8739.075,0.007,579.469,0.65,63.929763857,0.481,0,45721.44,"",7.2,"",1,1,"","",{"B+","B-"},{0,38.48,0},{"=","="},{0,38.48,0},18779.75,0.49,18578.2,18.57,-6199.15,0.39,-6591.72,1.48,-10862.08,18.57,-11282.47,1.55,7916.11,0.1,7200.74,0.1,-25892,203,12032.58,0.11,3661.41,0.32,3119.92,0.74}
,{64,30,-66004.014,0.647,8735.905,0.01,-7171.194,1.483,63.929141772,0.694,1,"s","","s","",0,1,"","",{},{},{},{},20978.68,0.79,13835.63,0.65,-3955.81,0.67,-11688.52,3.78,-7780.21,0.65,-17528.24,1.46,11861.93,1.48,7713.23,0.65,-39304,503,7494.22,0.8,844.1,0.7,3864.29,0.67}
,{64,31,-58832.821,1.429,8611.631,0.022,-4517.325,3.991,63.936840365,1.533,0,157.62,"",0.72,"",0,0,"","",{"B+"},{0},{"="},{0},22988.55,1.55,10623.34,1.55,-2912.6,2.15,-19301,203,-542.04,1.47,-19982.92,37.29,10357.05,1.93,3908.39,2.07,"","",13045.96,1.54,2380.14,15.96,8797.64,1.64}
,{64,32,-54315.496,3.726,8528.823,0.058,-14783,203,63.941689913,4,0,63.7,"",2.5,"",0,1,"","",{"B+"},{0},{"="},{0},28718,140,7725.47,3.78,-2566.07,3.77,-27615,503,608.93,4.04,-28887,200,15465.6,37.45,5057.37,3.95,"","",8382.22,3.78,-2316.78,38.18,7679.81,16.33}
,{64,33,-39532,203,8286,3,-12832,543,63.95756,218,0,0.04,"",0.03,"",0,1,"","",{"B+"},{0},{"="},{0},31355,362,2123,203,-2367,285,"","",9726,203,"","",14103,285,-100,200,"","",12919,247,-1309,362,13249,207}
,{64,34,-26700,503,8073,8,"","",63.971336,540,0,0.03,"",1.8e-07,">",0,1,"","",{},{},{},{},"","",-462,522,-2036,586,"","",12932,504,"","","","",489,541,"","",8331,586,-4936,586,12306,586}
,{65,23,-11780,500,7976,8,16440,583,64.987354,537,0,0.01,"",6.2e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,1,0},{"=","="},{0,1,0},6032,640,"","",-15136,781,29188,500,"","",13629,666,3531,640,18044,781,47406,500,4681,707,5584,640,"",""}
,{65,24,-28220,300,8217,5,12748,300,64.969705,322,0,0.0275,"",0.0021,"",0.5,-1,"","",{"B-","B-n","B-2n"},{0,5,0,"",""},{"=","=",""},{0,5,0,"",""},8355,467,37047,583,-14295,500,22998,300,-34484,671,6698,300,2811,532,19189,500,36906,300,4381,500,2121,423,-10073,500}
,{65,25,-40967.339,3.726,8400.681,0.057,10250.557,6.326,64.95601975,4,0,0.0919,"",0.0007,"",2.5,-1,"","",{"B-","B-n"},{0,7,0},{"=","="},{0,7,0},10222.92,5.27,33655,400,-12885.83,894.24,18217.86,4.27,-31937,400,5930.89,6.25,6049.62,5.14,14776.55,439.68,26296.32,3.78,5750.94,358.09,4791.68,148.15,-9845,298}
,{65,26,-51217.895,5.112,8546.346,0.079,7967.303,5.52,64.945015324,5.487,0,0.81,"",0.05,"",0.5,-1,"","",{"B-","B-n"},{0,7.9,0},{"=","="},{0,7.9,0},11724.91,6.68,29788.36,358.11,-11167.58,101.47,13907.79,5.14,-25027.11,439.69,503.12,20.65,4319.67,7.16,15517.83,6.22,14694.12,5.15,6379.96,6.33,2170.12,8.3,-4676.53,148.19}
,{65,27,-59185.198,2.083,8656.884,0.032,5940.487,2.141,64.936462073,2.235,0,1.16,"",0.03,"",0,0,"","",{"B-"},{0},{"="},{0},13476.39,18.69,26876.09,4.27,-9867.99,3.12,8078.46,2.18,-23485.13,4.11,-157.59,2.14,7464.19,20.11,11504.62,5.43,3472.31,2.24,7161.23,4.78,4556.9,3.49,-5014.84,6.87}
,{65,28,-65125.685,0.495,8736.24,0.008,2137.975,0.706,64.930084697,0.531,0,9063,"",1.8,"",2.5,-1,"","",{"B-"},{0},{"="},{0},15755.54,0.25,24068,4.33,-8630.11,2.65,786.33,0.7,-17445.11,5.04,-7772.46,0.26,6098.08,0.14,12622.33,20,-8647.47,2.22,7436.56,18.57,1162.65,18.57,-601.24,2.84}
,{65,29,-67263.66,0.65,8757.096,0.01,-1351.64,0.36,64.927789487,0.697,1,"s","","s","",1.5,-1,"","",{},{},{},{},17826.54,0.67,19990.16,18.58,-6790.51,0.98,-4606.15,0.73,-14760.3,20.01,-9330.96,0.39,9910.43,0.67,7453.71,0.69,-20326.61,84.77,8959.92,0.67,4346.72,0.67,-192.98,18.58}
,{65,30,-65912.019,0.65,8724.265,0.01,-3254.513,0.662,64.929240532,0.697,0,21075552,"",7776,"",2.5,-1,"","",{"B+"},{0},{"="},{0},19841.26,1.49,14977.19,0.65,-4115.03,0.67,-9433.8,2.26,-6102.07,0.68,-15150.52,1.49,7979.32,0.17,7776.44,0.66,-32892,300,10378.54,0.65,1739.46,0.81,6480.7,0.65}
,{65,31,-62657.507,0.815,8662.16,0.013,-6179.291,2.313,64.932734395,0.874,0,912,"",12,"",1.5,-1,"","",{"B+"},{0},{"="},{0},22253.05,1.54,11655.7,0.84,-3098.36,0.95,-15720.46,84.77,-4521.93,0.84,-16413.33,3.81,11896,1.58,3942.46,0.64,"","",10266.7,1.6,3374.52,0.95,5776.32,0.96}
,{65,32,-56478.216,2.165,8555.058,0.033,-9541.165,84.794,64.939368137,2.323,0,30.9,"",0.5,"",1.5,-1,"","",{"B+","B+p"},{0,0.011,0},{"=","="},{0,0.011,0},25699.63,37.32,8842.76,2.67,-2554.23,16.05,-23459,300,2236.83,2.26,-25017,203,10234.04,4.31,4934.37,2.59,"","",10779.68,2.53,372.75,2.26,10336.16,2.25}
,{65,33,-46937.051,84.766,8396.234,1.304,-13917,312,64.949611,91,0,0.17,"",0.03,"",1.5,-1,"","",{"B+"},{0},{"="},{0},29579,217,4967.9,84.78,-2227.31,92.89,"","",4606.8,84.78,-28308,510,15476,220,-89.47,84.85,"","",10694.97,92.59,-333,163,10696.26,84.77}
,{65,34,-33020,300,8170,5,"","",64.964552,322,0,0.033,"",0.004,"",1.5,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},"","",676,302,-2085,424,"","",14007,300,"","",14391,586,776,362,"","",11191,361,-3835,424,14367,331}
,{66,23,-5610,500,7884,8,19110,640,65.993977,537,0,0.005,"",6.2e-07,">",0,0,"","",{"B-n","B-2n"},{0,40,0},{"=","="},{0,40,0},5433,640,"","","","",31140,500,"","",14538,583,1902,707,"","",50798,500,6125,781,5004,707,"",""}
,{66,24,-24720,400,8161,6,12030,400,65.973462,429,0,0.0238,"",0.0018,"",0,1,"","",{"B-","B-n","B-2n"},{0,7,0,0,0},{"=","=","="},{0,7,0,0,0},7383,594,38273,721,-14645,565,25348,400,"","",8176,400,4572,500,20229,640,41286,400,2311,565,2034,565,-13323,640}
,{66,25,-36750.387,11.178,8331.798,0.169,13317.452,11.906,65.960546834,12,0,0.0642,"",0.0008,"",1,1,"","",{"B-","B-n","B-2n"},{0,8.4,0,"",""},{"=","=",""},{0,8.4,0,"",""},9903.99,11.72,35009,400,-13699,298,19658.15,17.89,-32260,500,6396.19,12.29,3854.37,11.78,15820,300,29507.89,11.2,7440.18,439.81,4121.14,358.25,-9214,400}
,{66,26,-50067.839,4.099,8521.724,0.062,6340.694,14.561,65.94624996,4.4,0,0.351,"",0.006,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},11240.93,6.48,31166.02,439.68,-11597.79,148.16,15938.45,4.33,-29137,300,1046.04,4.6,6921.26,6.55,16389.47,5.54,18831.32,4.17,3632,5.42,1683.27,5.54,-8413.96,358.1}
,{66,27,-56408.533,13.972,8605.941,0.212,9597.752,14.042,65.939442945,15,0,0.194,"",0.017,"",1,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},12758.84,24.4,27997.44,14.41,-10309.49,15.43,9849.74,13.99,-22730.17,14.46,645.83,13.98,5294.65,14.13,12479.61,14.88,7315.13,14.02,9271.82,14.85,4091.14,14.62,-3875.08,14.46}
,{66,28,-66006.285,1.397,8739.508,0.021,251.987,1.543,65.929139334,1.5,0,196560,"",1080,"",0,1,"","",{"B-"},{0},{"="},{0},15050,1.48,25614.68,5.21,-9553.15,3.12,2892.88,1.59,-22077.36,5.3,-6813.94,1.54,8951.92,1.48,14110.06,2.51,-4399.25,2.78,4496.85,20.05,709.21,18.63,-4724.26,4.52}
,{66,29,-66258.272,0.655,8731.472,0.01,2640.888,0.931,65.928868814,0.703,0,307.2,"",0.84,"",1,1,"","",{"B-"},{0},{"="},{0},16976.36,0.67,21043.88,20.01,-7258.91,18.58,-2534.61,1.23,-14362.05,2.18,-8417.57,0.37,7065.93,0.09,8421.56,0.71,-14233.2,5.72,11551.45,0.7,4118.56,0.67,1239.57,18.58}
,{66,30,-68899.16,0.749,8759.632,0.011,-5175.5,0.8,65.926033704,0.804,1,"s","","s","",0,1,"","",{},{},{},{},19037.78,0.92,16378.18,0.72,-4577.75,0.69,-7292.13,2.51,-11062.45,0.73,-14312.97,1.06,11058.46,0.92,8924.47,0.93,-27239,200,7236.19,0.7,1544.65,0.69,2260.02,0.69}
,{66,31,-63723.66,1.096,8669.361,0.017,-2116.628,2.639,65.931589832,1.176,0,33494.4,"",28.8,"",0,1,"","",{"B+"},{0},{"="},{0},21033.47,1.79,12877.06,1.06,-3361.15,1.16,-11698.58,5.79,-3748.97,1.22,-15316.76,2.43,9137.47,1.32,5100.61,1.22,"","",12991.16,1.22,3353.79,1.86,7502.49,1.06}
,{66,32,-61607.032,2.401,8625.437,0.036,-9581.955,6.168,65.933862126,2.577,0,8136,"",180,"",0,1,"","",{"B+"},{0},{"="},{0},23434.17,4.43,10180.96,2.49,-2863.98,2.48,-19947,200,-2983.98,2.49,-22741.3,84.8,13200.13,3.23,6238.5,2.54,"","",7936.59,2.79,-195.88,2.73,6252.77,2.86}
,{66,33,-52025.077,5.682,8468.403,0.086,-10365,200,65.944148779,6.1,0,0.09577,"",0.00023,"",0,1,"","",{"B+"},{0},{"="},{0},28635,204,7770.2,5.86,-2463.09,5.72,"","",3343.46,5.74,-27077,300,13159.34,84.96,2835.83,6.08,"","",13001.22,6.79,-239.81,37.69,10168.42,5.83}
,{66,34,-41660,200,8300,3,"","",65.955276,215,0,0.033,"",0.012,"",0,1,"","",{"B+"},{0},{"="},{0},31102,541,1923,200,-2345,244,"","",7529,200,"","",16712,361,2012,217,"","",8583,285,-3296,283,10907,204}
,{67,23,-650,600,7812,9,18030,721,66.999302,644,0,0.002,"",6.2e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,3,0},{"=","="},{0,3,0},5013,781,"","","","",32810,671,"","",15998,721,3111,781,"","",54672,600,"","",5239,848,"",""}
,{67,24,-18680,400,8070,6,14780,500,66.979946,429,0,0.01,"",3e-07,">",0.5,-1,"","",{"B-n","B-2n"},{0,1,0},{"=","="},{0,1,0},6603,500,"","",-15355,640,26930,482,"","",9999,400,2032,565,20359,640,45062,400,3810,640,2504,565,-12009,721}
,{67,25,-33460,300,8279,4,12150,404,66.964079,322,0,0.0467,"",0.0023,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},8635,300,36258,583,-13995,500,21862,300,-35139,583,8536,300,4781,300,16029,500,33859,300,5470,424,4884,532,-11494,500}
,{67,26,-45610.155,270.285,8448.469,4.034,9711.62,270.362,66.951035482,290.163,0,0.394,"",0.009,"",0.5,-1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},10534.89,270.33,31968,404,-12027.6,448.63,18132.53,270.3,-28179,482,2727.06,270.65,3613.63,270.32,16148.74,270.52,22270.16,270.29,6067.99,270.31,2242.93,270.31,-6484,516.1}
,{67,27,-55321.775,6.443,8581.741,0.096,8420.905,7.061,66.940609628,6.917,0,0.329,"",0.028,"",3.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},12279.21,6.77,28932.38,7.44,-10859.64,7.44,11997.74,6.5,-25860.36,12.9,2613.19,6.59,6984.56,15.39,12542.91,7.64,11557.27,6.55,6606.93,8.22,4511.82,8.17,-6686.34,7.35}
,{67,28,-63742.68,2.888,8695.75,0.043,3576.832,3.023,66.931569414,3.1,0,21,"",1,"",0.5,-1,"","",{"B-"},{0},{"="},{0},14759.63,2.93,27102.73,5.87,-10531.97,5.18,4137.63,2.99,-20963.81,5.01,-5555.72,2.96,5807.71,3.21,14623.12,14.27,-1084.45,5.48,6153.32,3.56,913.7,20.21,-3126.73,5.79}
,{67,29,-67319.513,0.894,8737.458,0.013,560.8,0.83,66.927729526,0.959,0,222588,"",432,"",1.5,-1,"","",{"B-"},{0},{"="},{0},16198.49,1.07,22712.26,2.27,-7892.99,18.59,-440.46,1.33,-18199.95,14,-6491.67,0.85,9132.56,1.08,8602.2,1.66,-10732.29,1,8516.98,0.94,4643.46,0.93,-1880.78,20.02}
,{67,30,-67880.313,0.76,8734.152,0.011,-1001.265,1.122,66.927127482,0.815,1,"s","","s","",2.5,-1,"","",{},{},{},{},18110.93,0.93,17332.57,0.75,-4792.45,0.71,-5222.08,4.71,-9163,1.59,-12227.97,0.83,7052.47,0.23,8911.01,0.94,-21300.02,67.07,10094.15,0.94,2408.29,0.71,4865.01,0.74}
,{67,31,-66879.048,1.181,8707.531,0.018,-4220.819,4.799,66.928202384,1.268,0,281810.88,"",43.2,"",1.5,-1,"","",{"EC"},{0},{"="},{0},20364.18,1.41,14193.33,1.32,-3724.21,1.19,-10291.82,1.26,-7909.75,1.32,-13343.33,2.68,11226.7,1.39,5268.86,1.13,-34089,400,9743.78,1.32,3989.02,1.32,4191.9,1.2}
,{67,32,-62658.23,4.661,8632.857,0.07,-6071.005,4.682,66.93273362,5.003,0,1134,"",18,"",0.5,-1,"","",{"B+"},{0},{"="},{0},22322.65,5.14,11324.15,4.62,-2869.75,4.85,-16077.94,67.23,-1048.04,4.71,-18704.47,7.35,9122.51,5.24,6223.54,4.77,"","",10710.08,4.66,1038.65,4.85,8992.19,4.62}
,{67,33,-56587.225,0.443,8530.568,0.007,-10006.936,67.069,66.939251111,0.475,0,42.5,"",1.2,"",2.5,-1,"","",{"B+"},{0},{"="},{0},25792.81,84.77,8507.66,0.93,-2465.05,1.38,-23797,400,-152.54,1.18,-22998,200,12633.47,5.7,2269.16,2.44,"","",10601.8,2.21,2592.33,3.75,7892,1.5}
,{67,34,-46580.289,67.068,8369.534,1.001,-13790,405,66.949994,72,0,0.133,"",0.011,"",2.5,-1,"","",{"B+","B+p"},{0,0.5,0},{"=","="},{0,0.5,0},29703,307,4680.01,67.1,-2083.99,76.72,"","",7737.77,67.11,"","",12991,211,1844.18,67.31,"","",11067.57,108.09,-2184,214,13381.61,67.17}
,{67,35,-32790,400,8152,6,"","",66.964798,429,0,"s","","s","",0.5,-1,"","",{},{},{},{},"","",431,409,-1715,447,"","",11946,400,"","","","",-1581,447,"","",10940,500,-1226,642,12388,448}
,{68,24,-14800,500,8013,7,13580,640,67.984112,537,0,0.005,"",6.2e-07,">",0,1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},6222,640,"","",-16200,781,28687,619,"","",10589,583,4191,640,21438,781,48664,500,1522,707,1844,707,"",""}
,{68,25,-28380,400,8201,6,15107,541,67.969533,429,0,0.0337,"",0.0015,"",0,0,"","",{"B-","B-n","B-2n"},{0,10,0,2,0},{"=","=","="},{0,10,0,2,0},7772,400,37347,640,-14485,565,23551,442,-35019,721,9159,482,2991,500,16989,565,37187,400,7051,565,4704,500,-10954,640}
,{68,26,-43486.914,365.259,8411.698,5.371,8443.751,411.489,67.953314875,392.121,0,0.188,"",0.004,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=",">"},{0,0,0},9561.71,365.28,33345,541,-12432.07,571.59,19976.9,365.27,-32096,541,3763.54,365.32,5948.08,454.39,17316,473,26520.18,365.26,3974.28,365.43,2344.48,365.28,-9621,473}
,{68,27,-51930.665,189.497,8524.366,2.787,11533.15,189.52,67.944250135,203.433,0,0.2,"",0.02,"",7,-1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},11664.77,190.01,29758.22,189.83,-11366.55,189.53,13636.37,189.5,-25759,355,3740.7,189.52,4680.21,189.61,13609.48,330.1,15155.33,189.5,8847.98,189.54,4151.29,189.57,-5316.92,189.53}
,{68,28,-63463.814,2.981,8682.466,0.044,2103.22,3.375,67.931868789,3.2,0,29,"",2,"",0,1,"","",{"B-"},{0},{"="},{0},13600.16,3.29,27973.92,5.07,-10919.19,5.84,6543.28,3.08,-25142.63,270.3,-4215.62,3.11,7792.45,4.15,15431.01,7.1,3514.97,3.52,3655.52,14.29,585.44,3.64,-6599.52,5.92}
,{68,29,-65567.035,1.584,8701.89,0.023,4440.057,1.767,67.929610889,1.7,0,30.9,"",0.6,"",1,1,"","",{"B-"},{0},{"="},{0},15451.4,1.71,23736.44,14.06,-8199.62,20.07,1518.96,2.14,-17534.23,6.63,-5758.04,1.76,6318.84,1.82,9113.33,3.29,-6672.52,2.43,11150.06,2.11,4422.7,1.66,-735.44,2.62}
,{68,30,-70007.092,0.784,8755.68,0.012,-2921.1,1.2,67.924844291,0.841,1,"s","","s","",0,1,"","",{},{},{},{},17250.57,0.3,18578.75,1.6,-5333.09,0.76,-3028.3,2.03,-13553.38,2.99,-11199.36,1.14,10198.1,0.19,9976.55,0.85,-15817.65,0.93,6961.99,0.96,2120.62,0.96,764.99,0.77}
,{68,31,-67085.992,1.433,8701.218,0.021,-107.203,2.361,67.927980221,1.538,0,4070.7,"",1.08,"",1,1,"","",{"B+"},{0},{"="},{0},19504.97,1.47,15405.66,1.54,-4086.36,1.41,-8191.47,2.34,-7055.45,1.47,-12499.08,4.86,8278.26,1.65,6494.65,1.22,-28295,259,12523.97,1.24,3690.08,1.53,5824.07,1.54}
,{68,32,-66978.789,1.876,8688.136,0.028,-8084.27,2.632,67.928095308,2.014,0,23408352,"",11232,"",0,1,"","",{"EC"},{0},{"="},{0},21514.39,3.05,12657.57,2.02,-3399.69,1.98,-12789.35,1.94,-6387.45,2.02,-18462.88,1.93,12391.88,5.02,7388.71,2.22,"","",7455.68,2.17,542.77,2.05,4579.63,1.99}
,{68,33,-58894.519,1.846,8557.745,0.027,-4705.078,1.911,67.93677413,1.981,0,151.6,"",0.8,"",3,1,"","",{"B+"},{0},{"="},{0},23012.08,5.97,9748.8,2.15,-2486.61,2.33,-20103,259,695.56,2.19,-20385.55,67.09,10378.61,1.9,3525.26,5.01,"","",13423.32,3.03,2447.75,2.84,9409.39,2.02}
,{68,34,-54189.441,0.496,8477.047,0.007,-15398,259,67.941825239,0.532,0,35.5,"",0.7,"",0,1,"","",{"B+"},{0},{"="},{0},28672,200,7160.35,2.45,-2298.86,3.76,"","",1179.82,4.69,-29470,400,15680.47,67.07,4891.19,0.66,"","",8546.44,5.7,-2388.33,84.77,7935.18,2.22}
,{68,35,-38791,259,8239,4,"","",67.958356,278,0,1.5e-06,"","s","",3,1,"","",{},{},{},{},"","",1344,259,-1684,329,"","",10507,259,"","",14072,476,-500,250,"","",13580,327,-908,396,13792,272}
,{69,24,-8580,500,7924,7,16190,640,68.990789,537,0,0.002,"",6.2e-07,">",3.5,1,"","",{"B-n","B-2n"},{0,6,0},{"=","="},{0,6,0},6042,640,"","","","",30450,640,"","",11729,640,1852,707,"","",51399,500,2781,781,1894,707,"",""}
,{69,25,-24770,400,8147,6,14259,565,68.973408,429,0,0.0221,"",0.0016,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,50,"","",""},{"=","=",""},{0,50,"","",""},7453,500,38698,721,-15416,640,25509,424,"","",10645,541,4462,565,17260,640,40966,400,4621,565,4814,565,-13513,640}
,{69,26,-39030,400,8342,6,11250,424,68.9581,429,0,0.1082,"",0.0045,"",0.5,-1,"","",{"B-","B-n","B-2n"},{0,7,0,0,0},{"=","=","="},{0,7,0,0,0},9562,482,34927,565,-13235,500,20949,400,-31519,640,4830,442,3614,541,17939,565,29388,400,5141,500,2585,400,-8663,565}
,{69,27,-50279.157,140.506,8493.865,2.036,9699.492,140.556,68.946023102,150.839,0,0.18,"",0.02,"",3.5,-1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},11100.02,140.65,31397,331,-11736.73,140.56,15457.06,140.51,-29188,424,5113.34,140.54,6419.81,235.91,14081.21,391.35,19048.65,140.51,6041.8,304.62,4652.74,140.57,-7882.37,140.95}
,{69,28,-59978.648,3.726,8623.099,0.054,5757.564,3.979,68.935610268,4,0,11.4,"",0.3,"",4.5,1,"","",{"B-"},{0},{"="},{0},12378.6,4.71,28946.43,270.31,-11185.67,6.33,8439.2,3.81,-23780.71,365.28,-2482.93,4.05,4586.15,4.77,15336.95,189.53,7122.01,3.95,6053.93,7.44,1293.94,14.46,-4264.41,5.54}
,{69,29,-65736.213,1.397,8695.204,0.02,2681.632,1.61,68.929429268,1.5,0,171,"",9,"",1.5,-1,"","",{"B-"},{0},{"="},{0},14559.33,1.66,24992.38,6.59,-8975.93,2.51,3591.6,1.84,-21094.52,189.5,-3800.44,1.6,8240.5,2.11,9561.37,3.29,-2624.04,32.03,8717.27,3.21,5134.13,1.98,-3681.28,14.04}
,{69,30,-68417.845,0.8,8722.729,0.012,909.964,1.426,68.926550418,0.858,0,3384,"",54,"",0.5,-1,"","",{"B-"},{0},{"="},{0},16680.17,0.25,19253.11,3,-5717.08,0.79,-1317.18,1.53,-12243,3.09,-9403.17,1.21,6482.07,0.16,10139.78,1.77,-11983.14,1.69,9612.47,0.87,2704.48,0.97,3234.84,1.61}
,{69,31,-69327.809,1.197,8724.579,0.017,-2227.146,0.55,68.925573531,1.285,1,"s","","s","",1.5,-1,"","",{},{},{},{},18591.39,1.68,16586.24,1.49,-4489.06,1.36,-6215.64,31.99,-11049.74,1.99,-10420.34,2.23,10313.13,1.86,6609.69,1.42,-23068.34,42.02,9263.31,1.41,4435.41,1.4,2576.87,1.36}
,{69,32,-67100.663,1.318,8680.963,0.019,-3988.492,31.982,68.927964471,1.414,0,140580,"",360,"",2.5,-1,"","",{"B+"},{0},{"="},{0},20585.07,4.84,13798.29,1.51,-3613.56,1.47,-10665.96,1.99,-4382.54,1.52,-16277.46,2.27,8193.19,2.29,7303.64,1.94,-34666,401,10489.19,1.76,1487.05,1.7,7444.9,1.5}
,{69,33,-63112.171,31.999,8611.821,0.464,-6677.465,32.021,68.932246294,34.352,0,912,"",12,"",2.5,-1,"","",{"B+"},{0},{"="},{0},22667.58,32,10811.06,32.02,-2879.58,32.01,-16852.7,52.8,-3315.15,32.03,-16994.05,32,12288.97,32.05,3422.35,32.05,"","",10256.87,32.34,3358.92,32.09,6257.89,32.02}
,{69,34,-56434.706,1.49,8503.707,0.022,-10175.236,42.029,68.939414847,1.599,0,27.4,"",0.2,"",0.5,-1,"","",{"B+","B+p"},{0,0.045,0},{"=","="},{0,0.045,0},25997.05,67.08,8354.42,4.89,-2381.41,2.63,-24000,401,3255.11,2.4,-25715,259,10316.58,1.57,4829.16,2.37,"","",10863.33,1.55,454.43,5.87,10818.73,2.83}
,{69,35,-46259.47,42.003,8344.902,0.609,-13825,403,68.950338413,45.092,0,2.4e-08,"","s","",2.5,-1,"","",{"p"},{0},{"="},{0},29612,402,4250.19,42.01,-1747.33,94.6,"","",5346.08,42.04,"","",15539,262,-641,42,"","",11031.62,79.13,265,205,11412.01,42.39}
,{69,36,-32435,401,8133,6,"","",68.96518,430,0,0.028,"",0.001,"",2.5,-1,"","",{"B+","B+p"},{0,55,0},{"=","="},{0,55,0},"","",432,406,-1840,500,"","",14466,401,"","","","",932,477,"","",11067,566,"","",14872,448}
,{70,24,-4480,600,7867,9,15020,781,69.995191,644,0,0.001,"",6.2e-07,">",0,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},5823,781,"","","","",32030,721,"","",12219,721,3971,781,"","",54734,600,"","",1035,848,"",""}
,{70,25,-19500,500,8070,7,17010,640,69.979066,537,0,0.0199,"",0.0017,"",0,0,"","",{"B-","B-n","B-2n"},{0,20,0,7,0},{"=","=","="},{0,20,0,7,0},7263,640,"","",-16314,707,27130,583,"","",11458,640,2801,640,18209,707,43476,500,6010,707,4044,640,-13203,781}
,{70,26,-36510,400,8302,6,10120,500,69.960805,429,0,0.063,"",0.0045,"",0,1,"","",{"B-","B-n"},{0,10,0},{"=","="},{0,10,0},9166,541,36288,640,-14215,565,22704,400,-35219,640,5698,424,5552,565,19029,565,33055,400,2581,565,1814,500,-12183,565}
,{70,27,-46630,300,8436,4,12584,300,69.949941,322,0,0.112,"",0.007,"",6,-1,"","",{"B-","B-n","B-2n"},{0,3,0,0,0},{"=","=","="},{0,3,0,0,0},10842,355,32828,500,-12304,300,16347,300,-29148,500,5278,300,4422,331,14889,500,22280,300,7568,473,3845,404,-7523,424}
,{70,28,-59213.86,2.144,8604.291,0.031,3762.513,2.401,69.936431303,2.301,0,6,"",0.3,"",0,1,"","",{"B-"},{0},{"="},{0},11892.68,3.67,30304.89,365.27,-11570.94,4.63,10350.87,2.88,-27473,400,-1548.96,2.56,7306.53,4.3,16223.67,140.52,11348.02,2.3,3427.61,189.51,971.97,6.79,-7957.3,270.29}
,{70,29,-62976.373,1.082,8646.865,0.015,6588.362,2.202,69.932392079,1.161,0,44.5,"",0.2,"",6,-1,"","",{"B-"},{0},{"="},{0},13551.97,1.92,25623.65,189.5,-8992.76,14.01,5933.77,1.62,-19986.19,140.51,-2629.84,1.35,5311.48,1.77,10286.69,3.88,1365.5,50.02,11198.25,3.17,5630.36,3.08,-2008.2,6.53}
,{70,30,-69564.735,1.918,8729.808,0.027,-654.595,1.574,69.925319181,2.058,1,"s","","s","",0,1,"","",{},{},{},{},15700.28,2.04,20678.86,3.54,-5983.37,2.37,997.14,2.09,-16875.06,4.19,-8308.24,1.58,9218.21,2.05,11117.49,2.37,-7634.84,2.49,6713.11,2.49,2618.83,2.1,-175.65,3.47}
,{70,31,-68910.14,1.201,8709.28,0.017,1651.736,1.462,69.926021917,1.289,0,1268.4,"",1.8,"",1,1,"","",{"B-","EC"},{0,0.41,0},{"~","="},{0,0.41,0},17966.78,1.86,17921.05,1.99,-5076.78,1.37,-4568.26,50.02,-10462.9,1.84,-9880.79,0.58,7653.65,0.17,7781.27,1.43,-17484.52,14.95,11807.76,1.42,3834.23,1.41,4055.77,1.49}
,{70,32,-70561.876,0.838,8721.7,0.012,-6220,50,69.924248706,0.9,1,"s","","s","",0,1,"","",{},{},{},{},19725.72,2.06,15132.72,1.06,-4087.63,1.04,-8631.98,1.79,-9433,1.07,-15521.02,32.01,11532.53,1.56,8523.04,1.46,-29462,200,7234.92,1.6,1181.23,1.16,2964.84,1.04}
,{70,33,-64341.876,50.007,8621.666,0.714,-2411.985,50.032,69.930926151,53.684,0,3156,"",18,"",4,1,"","",{"B+"},{0},{"="},{0},21589.99,50.04,11833.82,50.03,-3043.13,50.02,-12916.26,52.18,-2303.04,50.02,-15978.49,50.03,9301.02,59.37,4530.18,50.02,"","",13347.72,50.04,3180.41,50.22,8183.57,50.01}
,{70,34,-61929.891,1.584,8576.033,0.023,-10504.272,14.988,69.933515523,1.7,0,2466,"",18,"",0,1,"","",{"B+"},{0},{"="},{0},23883.08,1.66,9529.04,2.46,-2747.77,2.88,-20830,200,-2118.2,2.06,-23741.74,42.03,13566.5,2.17,6106.69,32.04,"","",7675.43,2.43,-478.61,1.64,6374.74,4.92}
,{70,35,-51425.619,14.904,8414.796,0.213,-10325,201,69.944792323,16,0,0.0791,"",0.0008,"",0,1,"","",{"B+"},{0},{"="},{0},28777,259,7109.04,15.02,-1825.46,15.95,"","",4397.58,35.3,-27062,401,13237.47,44.57,2279.88,14.98,"","",13474.63,14.91,18.72,68.7,10808.01,14.91}
,{70,36,-41100,200,8256,3,"","",69.955877,215,0,0.052,"",0.017,"",0,1,"","",{"B+","B+p"},{0,1.3,0},{"=","<"},{0,1.3,0},"","",1489,200,-1865,283,"","",8045,200,"","",16737,448,2130,205,"","",8402,327,-3446,447,11126,211}
,{71,25,-15570,500,8015,7,15860,640,70.983285,537,0,0.005,"",4e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,3,0},{"=","="},{0,3,0},6942,640,"","",-17345,781,28800,683,"","",12869,640,4141,707,18379,781,47141,500,3721,707,4094,707,"",""}
,{71,26,-31430,400,8227,6,12940,613,70.966259,429,0,0.0337,"",0.0038,"",3.5,1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},8543,565,37427,640,-15174,565,23977,400,-34239,721,7129,500,2991,565,19219,640,35899,400,4052,565,1814,565,-10984,640}
,{71,27,-44369.926,465.03,8398.734,6.55,11036.302,465.035,70.952366923,499.23,0,0.08,"",0.003,"",3.5,-1,"","",{"B-","B-n"},{0,3,""},{"=","="},{0,3,""},10233.4,485.79,34178,613,-13335,553,18341.2,465.03,-32159,683,6772.62,465.03,5812,553,15149,613,25769.21,465.03,5370,613,3981.04,591.33,-10344,613}
,{71,28,-55406.228,2.237,8543.156,0.032,7304.899,2.688,70.940518964,2.401,0,2.56,"",0.03,"",4.5,1,"","",{"B-"},{0},{"="},{0},11570.21,4.35,30955,400,-12220.99,270.29,11922.55,3.47,-26185,400,-501.17,2.48,4263.68,3.1,16066,300,14500.27,2.39,5583.74,140.52,1388.49,189.51,-6272.91,365.27}
,{71,29,-62711.127,1.49,8635.022,0.021,4617.651,3.044,70.932676832,1.6,0,19.4,"",1.4,"",1.5,-1,"","",{"B-"},{0},{"="},{0},13117.55,2.04,27009.91,140.51,-9814.27,6.61,7428.01,1.7,-23370,300,-1217.71,2.43,7806.07,1.84,10786.24,2.61,5181.97,4.43,7978.33,4.01,5616.74,3.33,-5134.06,189.5}
,{71,30,-67328.777,2.654,8689.041,0.037,2810.358,2.775,70.92771958,2.849,0,147,"",6,"",0.5,-1,"","",{"B-"},{0},{"="},{0},15053.57,2.77,21928.07,4.57,-6011.01,3.92,2577.72,2.78,-15403.89,3.41,-6489.95,2.88,5835.36,3.19,11641.38,2.87,-4182.27,3.85,9118.24,3,3102.31,3.09,1781.44,3.99}
,{71,31,-70139.135,0.812,8717.604,0.011,-232.638,0.223,70.924702536,0.871,1,"s","","s","",1.5,-1,"","",{},{},{},{},16953.96,1.44,18980.86,1.62,-5244.54,1.16,-2246.04,4.09,-14451.73,1.35,-7648.58,0.25,9300.31,1.45,7863.37,2.08,-13636.72,5.46,8989.52,1.06,4732.01,1.05,1074.3,1.78}
,{71,32,-69906.497,0.834,8703.309,0.012,-2013.4,4.082,70.924952284,0.894,0,987552,"",2592,"",0.5,-1,"","",{"EC"},{0},{"="},{0},18948.47,1.56,16066.59,1.07,-4451.1,1.04,-6759.99,2.92,-7630.73,2.09,-13635.94,50,7415.94,0.11,8285.33,1.46,-23579.29,128.77,10132.12,1.46,2043.55,1.6,5747,1.06}
,{71,33,-67893.097,4.167,8663.932,0.059,-4746.59,5.017,70.927113758,4.473,0,235080,"",252,"",2.5,-1,"","",{"B+"},{0},{"="},{0},20923.56,32.27,13143.23,4.33,-3438.96,4.24,-11390.68,6.82,-6271.93,4.34,-14034.52,4.46,11622.54,50.17,4620.19,4.08,-35833,400,9918.37,4.37,3949.75,4.57,4839.3,4.38}
,{71,34,-63146.507,2.794,8586.06,0.039,-6644.089,6.082,70.932209432,3,0,284.4,"",3,"",2.5,-1,"","",{"B+"},{0},{"="},{0},22854.44,3.17,10623.79,3.09,-2913.19,5.43,-16819.3,128.8,126.4,2.92,-19792.2,15.16,9287.93,3.21,6093.6,50.09,"","",10676.47,32.12,612.07,3.35,9478.68,3.37}
,{71,35,-56502.418,5.402,8481.462,0.076,-10175.212,128.845,70.939342156,5.799,0,21.4,"",0.6,"",0,0,"","",{"B+"},{0},{"="},{0},26385.58,42.35,7968.19,32.45,-2340.11,5.42,-24442,400,550.49,50.3,-23473,200,13148.12,15.85,1861.5,5.63,"","",10643.09,5.6,2551.08,5.42,8038.5,5.71}
,{71,36,-46327.205,128.769,8327.13,1.814,-14267,420,70.950265696,138.238,0,0.1,"",0.003,"",0,0,"","",{"B+","B+p"},{0,2.1,0},{"=","="},{0,2.1,0},30035,421,4470.44,128.78,-2171.83,145.19,"","",8313.71,128.78,"","",13298,238,2190.56,129.63,"","",10643.07,135.45,-2672,289,13508.64,128.77}
,{71,37,-32060,400,8115,6,"","",70.965582,429,0,"s","","s","",2.5,-1,"","",{},{},{},{},"","",379,402,-1695,565,"","",12076,400,"","","","",-1751,447,"","",11085,566,"","",12378,476}
,{72,25,-9900,600,7937,8,18530,781,71.989372,644,0,0.002,"",6.2e-07,">",0,0,"","",{"B-n","B-2n"},{0,10,0},{"=","="},{0,10,0},6543,781,"","","","",30300,721,"","",13458,721,2401,781,"","",49883,600,5290,848,3544,781,"",""}
,{72,26,-28430,500,8184,7,11769,640,71.969479,537,0,0.019,"",0.004,"",0,1,"","",{"B-","B-n","B-2n"},{"",10,0,0,0},{"","=","="},{"",10,0,0,0},8063,640,38529,781,-16055,707,25796,500,"","",7868,683,5072,640,20149,707,39715,500,1781,707,1204,640,-14204,707}
,{72,27,-40200,400,8336,6,14027,400,71.956844,429,0,0.0525,"",0.0003,"",6,-1,"","",{"B-","B-n","B-2n"},{0,6,"","",""},{"=",">",""},{0,6,"","",""},9713,500,35278,640,-14245,565,19583,400,-31919,640,7135,400,3901,613,16059,565,28389,400,7021,565,3694,565,-9783,565}
,{72,28,-54226.06,2.237,8520.211,0.031,5556.938,2.637,71.941785926,2.401,0,1.57,"",0.05,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},11154.83,3.1,32294,400,-13164.06,365.27,13919.43,3.1,-30085,400,413.75,2.69,6891.15,3.16,17145.11,465.04,18359.84,2.24,3114,300,917.15,140.52,-9550,400}
,{72,29,-59782.999,1.397,8586.525,0.019,8362.487,2.558,71.935820307,1.5,0,6.63,"",0.03,"",2,-1,"","",{"B-"},{0},{"="},{0},12949.26,1.77,27731,300,-10277.25,189.5,8805.29,1.62,-22702.04,465.03,-525.54,3,5143.19,2.04,11665.74,2.64,8446.8,4.32,10141.67,2.56,5059.7,3.98,-3857.44,140.51}
,{72,30,-68145.486,2.142,8691.805,0.03,442.807,2.294,71.926842807,2.3,0,167400,"",360,"",0,1,"","",{"B-"},{0},{"="},{0},14723.39,2.88,23509.57,3.03,-7106.59,3.67,4440.41,2.14,-20028.23,3.1,-6077.67,2.29,8888.03,3.41,12723.33,2.61,-277.31,2.9,5541.69,2.4,2454.78,2.56,-2520.44,4.3}
,{72,31,-68588.293,0.819,8687.089,0.011,3997.607,0.822,71.926367434,0.878,0,50490,"",36,"",3,-1,"","",{"B-"},{0},{"="},{0},15820.79,1.45,20189.86,1.36,-5446.17,1.78,-358.5,4.16,-13166.14,1.7,-6753.11,0.29,6520.47,0.19,8548.49,2.78,-9526.55,1.31,11687.25,2.08,4693.61,1.07,2794.32,1.62}
,{72,32,-72585.9,0.076,8731.745,0.001,-4356.102,4.082,71.922075826,0.081,1,"s","","s","",0,1,"","",{},{},{},{},18166.66,0.84,17599.11,1.92,-5003.72,0.79,-4717.72,1.96,-12546.09,2.65,-12764.12,4.17,10750.72,0.84,9735.74,0.82,-18645.33,8.01,7035.05,1.2,1605.96,1.2,1478.35,0.8}
,{72,33,-68229.798,4.083,8660.378,0.057,-361.618,4.528,71.926752295,4.383,0,93600,"",360,"",2,-1,"","",{"B+"},{0},{"="},{0},20030.56,50.17,13897.6,4.26,-3568.72,4.33,-9168.06,4.21,-5379.63,4.16,-13154.61,4.95,8408.02,5.83,5612.27,4.17,-29900,500,13042.88,4.17,3734.92,4.29,6744.41,4.26}
,{72,34,-67868.18,1.956,8644.489,0.027,-8806.437,2.208,71.927140507,2.1,0,725760,"",6912,"",0,1,"","",{"EC"},{0},{"="},{0},22080.92,2.52,11884.25,2.13,-3314.31,2.71,-13927.61,8.25,-5250.65,2.13,-19437.08,5.75,12792.99,3.41,7264.05,4.6,"","",7184.5,50.05,108.05,32.06,4878.88,2.36}
,{72,35,-59061.743,1.025,8511.312,0.014,-5121.168,8.076,71.936594607,1.1,0,78.6,"",2.4,"",1,1,"","",{"B+"},{0},{"="},{0},23778.76,14.94,9297.81,50.02,-2592.14,2.11,-20732,500,1542.38,4.29,-20805.85,128.77,10630.64,5.5,3204.21,2.98,"","",13578.95,1.89,2237.02,1.81,9696.83,32.02}
,{72,36,-53940.575,8.011,8429.319,0.111,-15611,500,71.942092407,8.6,0,17.16,"",0.18,"",0,1,"","",{"B+"},{0},{"="},{0},28983,200,6588.63,8.17,-2176.05,8.03,"","",1916.96,8.48,-29952,400,15684.69,129.02,4727.13,9.66,"","",8195.85,16.92,-2817.05,42.76,8140.53,8.15}
,{72,37,-38330,500,8202,7,"","",71.958851,537,0,1.5e-06,"","s","",1,1,"","",{},{},{},{},"","",1482,500,-1964,563,"","",10883,500,"","",14341,640,-708,517,"","",13481,539,-1031,641,13576,502}
,{73,26,-22900,500,8106,7,14518,640,72.975416,537,0,0.0129,"",0.0016,"",3.5,1,"","",{"B-n","B-2n"},{0,4,0},{"=","="},{0,4,0},7613,640,"","",-16745,707,27208,500,"","",9228,640,2541,707,20289,781,42694,500,3381,707,1464,707,-12774,781}
,{73,27,-37418,400,8295,5,12690,400,72.95983,429,0,0.0407,"",0.0013,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,9,"","",""},{"=","=",""},{0,9,"","",""},9191,613,36426,640,-15073,565,21569,400,-34807,721,8737,400,5290,565,16277,640,32281,400,4722,565,3956,565,-12272,640}
,{73,28,-50108.152,2.423,8457.652,0.033,8879.285,3.104,72.946206683,2.601,0,0.84,"",0.03,"",4.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10844.56,3.3,33257,400,-13503,400,15485.25,3.06,-28967,500,1603.53,2.8,3953.41,3.3,17198,400,21189.37,2.42,4972.58,465.04,1386,300,-7952,400}
,{73,29,-58987.437,1.942,8568.569,0.027,6605.966,2.691,72.936674378,2.084,0,4.2,"",0.3,"",1.5,-1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},12418.94,2.45,29195.45,465.03,-11133.2,140.52,10711.9,2.57,-26077,400,1086.73,2.89,7275.75,2.39,12050.35,2.96,11965.31,4.31,7129.6,2.96,5090.48,2.89,-6711,300}
,{73,30,-65593.402,1.863,8648.345,0.026,4105.932,2.506,72.929582582,2,0,23.5,"",1,"",0,0,"","",{"B-"},{0},{"="},{0},14407.26,3.24,24765.12,2.91,-8039.67,4.17,5704.12,1.86,-18656.31,2.91,-5076.43,2.03,5519.23,2.84,13099.37,2.33,2633.98,7.65,7828.53,2.39,2247.03,2.15,-733.14,2.84}
,{73,31,-69699.335,1.677,8693.873,0.023,1598.188,1.678,72.925174682,1.8,0,17496,"",108,"",0.5,-1,"","",{"B-"},{0},{"="},{0},15702.83,1.86,21566.15,2.24,-6388.04,2.18,1253.41,4.2,-17205.31,2.18,-5184.75,1.68,9182.36,1.87,8842.82,2.72,-6051.86,7.46,8340.25,3.14,4729.45,2.55,-1076.56,2}
,{73,32,-71297.523,0.057,8705.049,0.001,-344.776,3.853,72.923458956,0.061,1,"s","","s","",4.5,1,"","",{},{},{},{},17533.66,0.84,18546.69,2.65,-5304.59,0.8,-3070.14,7.42,-10441.01,2.14,-11139.04,4.08,6782.94,0.05,9998.2,0.82,-14745.77,6.58,9552.42,0.81,2476.67,1.2,3913.61,1.92}
,{73,33,-70952.747,3.853,8689.609,0.053,-2725.36,7.399,72.923829089,4.136,0,6937920,"",5184,"",1.5,-1,"","",{"EC"},{0},{"="},{0},19202.28,5.68,15391.55,3.94,-4049.85,4.03,-7305.27,8.22,-9653.42,3.94,-11155.88,4.32,10794.27,5.61,5655.82,3.85,-24871,200,9664.56,3.94,4473.18,3.94,3603.8,4.04}
,{73,34,-68227.387,7.424,8641.558,0.102,-4579.912,10.388,72.926754883,7.969,0,25740,"",288,"",4.5,1,"","",{"B+"},{0},{"="},{0},21223.51,7.93,12898.83,7.47,-3551.64,7.54,-11675.64,9.92,-2930.46,7.42,-17236.96,7.49,8430.52,7.68,7286.56,8.47,-36277,401,10376.52,8.51,978.54,50.56,7980.89,7.47}
,{73,35,-63647.475,7.266,8568.103,0.1,-7095.725,9.801,72.931671621,7.8,0,204,"",12,"",0.5,-1,"","",{"B+"},{0},{"="},{0},23287.69,9.05,10332.32,8.38,-2960.22,32.81,-17566,200,-2706.65,8.33,-17778.22,10.81,12657.05,7.34,3068.27,7.52,"","",10209.84,7.78,3146.47,7.44,6340.8,50.53}
,{73,36,-56551.751,6.578,8460.184,0.09,-10470,200,72.939289195,7.061,0,27.3,"",1,"",1.5,-1,"","",{"B+","B+p"},{0,0.25,0},{"=","="},{0,0.25,0},26367.18,128.94,7983.19,7.15,-2541.96,6.74,-24602,401,4027.46,6.86,-26293,500,10682.49,10.37,4778.98,6.66,"","",10661.47,8.51,-262.08,16.29,11024.54,6.77}
,{73,37,-46082,200,8306,3,-14131,448,72.950529,215,0,3e-08,"","s","",1.5,-1,"","",{},{},{},{},30164,447,4157,200,-2247,205,"","",5691,200,"","",15823,539,-570,200,"","",10956,238,-117,283,10990,201}
,{73,38,-31950,401,8102,5,"","",72.9657,430,0,0.025,"","s","",0.5,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},"","",201,421,-1941,566,"","",14701,401,"","","","",909,641,"","",10821,566,"","",14796,448}
,{74,26,-19590,600,8061,8,13230,781,73.978969,644,0,0.002,"",4e-07,">",0,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},7303,781,"","",-17536,848,28866,631,"","",9757,721,4762,781,"","",46166,600,1020,848,844,781,"",""}
,{74,27,-32820,500,8229,7,15636,537,73.964766,537,0,0.0313,"",0.0013,"",0,0,"","",{"B-","B-n","B-2n"},{0,26,0,1,0},{"=",">","="},{0,26,0,1,0},8763,640,37498,781,-15745,707,23186,500,"","",9217,500,3473,640,17209,707,35229,500,6321,707,3473,640,-11604,707}
,{74,28,-48456,196,8430,3,7550,196,73.94798,210,0,0.5077,"",0.0046,"",0,1,"","",{"B-","B-n"},{0,5,0},{"=","="},{0,5,0},10373,196,34604,537,-14371,445,17300,196,-32845,537,2460,196,6419,196,18327,445,24966,196,2454,445,778,504,-11380,445}
,{74,29,-56006.205,6.148,8521.562,0.083,9750.507,6.642,73.939874862,6.6,0,1.63,"",0.05,"",2,-1,"","",{"B-","B-n"},{0,40,0},{"=","="},{0,40,0},12365.84,6.3,30385,400,-11801,300,12043.41,6.84,-25877,400,1515.88,6.42,5090.09,6.45,13187.02,6.61,14853.85,6.38,8930.66,6.54,4264.08,6.54,-5989.88,465.07}
,{74,30,-65756.712,2.515,8642.754,0.034,2292.905,3.91,73.929407262,2.7,0,95.6,"",1.2,"",0,1,"","",{"B-"},{0},{"="},{0},13753.86,3.3,26108.59,3.37,-8967.77,3.3,7665.73,2.52,-22937.53,3.49,-4128.69,3.02,8234.63,3.13,14058.25,3.18,6456.49,2.52,4737.09,2.88,1818.47,2.92,-4704.08,3.37}
,{74,31,-68049.617,2.994,8663.167,0.04,5372.824,2.994,73.926945726,3.214,0,487.2,"",7.2,"",3,-1,"","",{"B-"},{0},{"="},{0},15603.96,3.1,22844.56,3.3,-7498.16,3.18,2810.44,3.44,-16351.15,3.57,-4823.41,2.99,6421.6,3.43,9745.19,3.53,-2761.46,6.56,10806.67,3.68,4143.21,4,307.91,3.34}
,{74,32,-73422.442,0.013,8725.2,0,-2562.387,1.693,73.921177762,0.013,1,"s","","s","",0,1,"","",{},{},{},{},16979.18,0.07,19854.9,2.14,-6282.62,1.92,-1209.24,0.01,-15118.01,1.86,-10541.01,3.85,10196.24,0.06,11012.08,1.68,-11090.61,2.01,5876.66,0.82,1580.75,0.81,-447.26,2.65}
,{74,33,-70860.054,1.693,8680.001,0.023,1353.147,1.693,73.923928598,1.817,0,1535328,"",1728,"",2,-1,"","",{"B+","B-"},{0,34,0},{"=","="},{0,34,0},18772.89,4.42,16849.7,1.88,-4374.83,2.08,-5571.9,6.08,-8449.69,2.38,-10703.98,7.61,7978.62,4.21,6851.5,1.69,-18944.05,3.47,12436.65,1.69,3910.5,1.89,4925.48,1.88}
,{74,34,-72213.201,0.015,8687.715,0,-6925.049,5.835,73.922475935,0.015,1,"s","","s","",0,1,"","",{},{},{},{},20487.66,1.96,14205.24,0.08,-4076.24,0.84,-9881.37,2.01,-8204.65,0.06,-16637.04,7.27,12057.13,7.42,8549.43,3.85,-31386,100,6727.4,4.08,543.95,4.17,3339.7,0.83}
,{74,35,-65288.153,5.835,8583.561,0.079,-2956.317,6.173,73.929910281,6.264,0,1524,"",18,"",0,-1,"","",{"B+"},{0},{"="},{0},22369.04,5.92,11636.3,7.12,-3371.19,50.35,-13372.14,6.57,-1624.38,6.99,-16807.72,8.79,9711.99,9.32,4349.74,9.44,"","",13290.83,6.15,2722.41,6.47,8251.35,7.17}
,{74,36,-62331.836,2.013,8533.038,0.027,-10415.827,3.424,73.933084017,2.161,0,690,"",6.6,"",0,1,"","",{"B+"},{0},{"="},{0},24533.9,8.26,9041.6,2.81,-2826.86,2.56,-21504,100,-1393.42,7.69,-24322,200,13851.4,6.88,5973.33,7.54,"","",7440.71,2.26,-965.36,5.77,6461.07,3.44}
,{74,37,-51916.009,3.027,8381.712,0.041,-11089,100,73.944265868,3.249,0,0.064776,"",3e-05,"",0,1,"","",{"B+"},{0},{"="},{0},29729,500,7432.21,3.2,-2915.31,15.21,"","",4442.5,7.87,-28037,401,13906,200,2653.23,7.24,"","",12735.37,8.56,-724.75,128.8,10232.81,6.19}
,{74,38,-40827,100,8221,1,"","",73.95617,107,0,0.027,"",0.008,"",0,1,"","",{"B+"},{0},{"="},{0},"","",1465,100,-2152,224,"","",8435,100,"","",16948,413,2035,224,"","",8213,510,-3903,412,11146,163}
,{75,26,-13640,600,7982,8,16010,781,74.985357,644,0,0.002,"",6.2e-07,">",4.5,1,"","",{"B-n","B-2n"},{0,20,0},{"=","="},{0,20,0},6883,781,"","","","",30390,671,"","",11109,781,2121,848,"","",48919,600,"","",1124,848,"",""}
,{75,27,-29649,500,8185,7,14380,583,74.96817,537,0,0.0265,"",0.0012,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,16,0,"",""},{"=","<",""},{0,16,0,"",""},8374,640,"","",-16504,707,24822,500,"","",10736,537,4901,707,17348,781,38815,500,3961,707,3645,707,-14103,781}
,{75,28,-44030,300,8366,4,10441,300,74.952732,322,0,0.3316,"",0.0032,"",3.5,1,"","",{"B-","B-n"},{0,10,0},{"=","="},{0,10,0},10064,300,35708,583,-15025,500,18529,300,-31729,671,3905,300,3645,358,18499,583,27827,300,4099,500,1034,500,-9953,583}
,{75,29,-54471.341,2.33,8495.094,0.031,8087.567,3.042,74.941522606,2.501,0,1.224,"",0.003,"",2.5,-1,"","",{"B-","B-n"},{0,3.5,0},{"=","="},{0,3.5,0},11626.54,3.03,31631,400,-12526.33,465.04,13993.24,3.36,-28940,500,3214.05,3.43,6536.45,6.57,13304,196,18562.85,2.49,6347.62,3.36,4618.77,3.23,-8625,400}
,{75,30,-62558.908,1.956,8592.497,0.026,5905.672,3.113,74.932840246,2.1,0,10.2,"",0.2,"",3.5,1,"","",{"B-"},{0},{"="},{0},13108.14,2.7,27028.7,3.11,-9577.6,2.97,9298.06,1.96,-21392,196,-2580.61,3.58,4873.51,3.19,13841.67,6.45,9610.57,1.96,7139.33,2.76,2088.15,2.4,-2686.45,2.97}
,{75,31,-68464.58,2.422,8660.808,0.032,3392.384,2.422,74.926500246,2.6,0,126,"",2,"",1.5,-1,"","",{"B-"},{0},{"="},{0},14907.88,2.95,24055.08,3.1,-8178.37,2.84,4569.62,2.58,-19747.35,6.61,-3113.46,2.42,8486.28,3.85,9996.84,3.49,642.43,4.92,7839.63,3.06,4544.96,3.23,-3035.18,2.8}
,{75,32,-71856.965,0.052,8695.609,0.001,1177.231,0.885,74.922858371,0.055,0,4966.8,"",2.4,"",0.5,-1,"","",{"B-"},{0},{"="},{0},16702.08,0.07,20841.5,1.86,-6953.1,2.65,312.52,0.09,-13389.22,2.52,-9068.23,1.69,6505.84,0.05,11096.32,2.99,-7533.34,8.1,8553.18,1.68,1595.38,0.82,1934.92,2.14}
,{75,33,-73034.195,0.884,8700.874,0.012,-864.714,0.882,74.921594562,0.948,1,"s","","s","",1.5,-1,"","",{},{},{},{},18224.08,3.95,17912.8,1.9,-5319.98,1.2,-3927.19,4.38,-12273.55,3.12,-8892.31,0.88,10245.46,1.91,6900.72,0.88,-15815.5,1.47,8974.13,0.89,4415.76,0.89,1200.5,1.2}
,{75,34,-72169.481,0.073,8678.913,0.001,-3062.472,4.285,74.922522871,0.078,0,10348992,"",4320,"",2.5,1,"","",{"EC"},{0},{"="},{0},20084.73,7.42,15449.9,0.09,-4687.9,0.84,-7845.86,8.1,-6036.01,0.07,-14952.65,5.84,8027.6,0.07,8598.4,1.69,-25550.79,220,9494.07,3.85,924.37,4.08,6062.82,0.1}
,{75,35,-69107.009,4.285,8627.649,0.057,-4783.385,9.167,74.92581057,4.6,0,5802,"",78,"",1.5,-1,"","",{"B+"},{0},{"="},{0},21602.17,8.44,12732.2,5.76,-3638.83,5.98,-11888.31,4.44,-5535.93,4.61,-14846.49,4.73,11890.17,7.24,4182.78,4.28,-37287,300,9831.18,8.57,3625.23,4.71,4769.19,5.92}
,{75,36,-64323.624,8.104,8553.439,0.108,-7104.929,8.189,74.930945746,8.7,0,276,"",4.2,"",2.5,1,"","",{"B+"},{0},{"="},{0},23914.51,10.44,10674.18,10.99,-3602.03,8.57,-17704.93,220.15,600.61,8.1,-20478.93,8.65,10063.1,8.35,6324.44,9.99,"","",10034.66,10.88,-397.83,8.17,9190.96,8.34}
,{75,37,-57218.694,1.18,8448.275,0.016,-10600,220,74.938573201,1.266,0,19,"",1.2,"",0,0,"","",{"B+"},{0},{"="},{0},27280,200,8149.16,7.36,-3141.19,5.53,-25399,300,780.49,5.95,-24463,100,13374,3.25,2175.83,2.33,"","",10043.86,6.68,1585.94,8.1,7489.45,1.56}
,{75,38,-46618.694,220.003,8296.511,2.933,-14799,372,74.94995277,236.183,0,0.088,"",0.003,"",1.5,-1,"","",{"B+","B+p"},{0,5.2,0},{"=","="},{0,5.2,0},30811,457,4644.88,220.1,-2716.4,254.92,"","",8424.17,220.01,"","",13863,242,1991.66,220.02,"","",10174,297,-3425,546,12968.28,220.15}
,{75,39,-31820,300,8089,4,"","",74.96584,322,0,0.0001,"","s","",2.5,1,"","",{},{},{},{},"","",316,361,-2185,500,"","",12807,300,"","","","",-1719,316,"","",10841,500,"","",12157,583}
,{76,27,-24510,600,8116,8,17120,721,75.973687,644,0,0.023,"",0.006,"",8,-1,"","",{"B-","B-n","B-2n"},{0,4,0,6,0},{"=","=","="},{0,4,0,6,0},7833,781,"","",-17035,848,26466,600,"","",11448,671,2932,781,18160,848,41786,600,5791,848,3254,781,"",""}
,{76,28,-41630,400,8331,5,9346,400,75.955308,429,0,0.2346,"",0.0027,"",0,1,"","",{"B-","B-n"},{0,14,""},{"=","="},{0,14,""},9317,445,36618,721,-15625,640,20673,400,-35279,721,4770,400,5672,500,19270,640,31583,400,1901,640,652,565,-13084,640}
,{76,29,-50975.985,6.707,8443.527,0.088,11327.031,6.863,75.945275025,7.2,0,0.6377,"",0.0055,"",0,0,"","",{"B-","B-n"},{0,7.2,0},{"=","="},{0,7.2,0},11112.41,9.1,32734,500,-13201,400,15320.65,6.99,-28616,500,3511.61,6.99,4575.96,7.1,14235,300,21315.39,6.77,8191,196,3996.22,7.13,-7911,400}
,{76,30,-62303.016,1.456,8582.273,0.019,3993.624,2.438,75.933114957,1.562,0,5.7,"",0.3,"",0,1,"","",{"B-"},{0},{"="},{0},12688.94,2.91,28425,196,-10501.87,2.67,10909.87,1.46,-25562,300,-1909.75,2.83,7815.43,2.44,15120.65,2.75,12948.93,1.46,4414,6.32,1548.48,2.43,-6548.46,2.83}
,{76,31,-66296.64,1.956,8624.526,0.026,6916.249,1.956,75.928827625,2.1,0,32.6,"",0.6,"",2,-1,"","",{"B-"},{0},{"="},{0},14389.66,3.58,24868.38,6.45,-8938.56,2.4,5994.74,2.15,-19114.27,3.04,-2510.99,1.96,5903.38,3.11,11026.7,2.77,3992.43,9.52,10170.88,3.19,4160.82,2.7,-1662.8,2.76}
,{76,32,-73212.889,0.018,8705.236,0,-921.512,0.886,75.921402726,0.019,0,5.238449716e+28,"",4.10240038e+27,"",0,1,"","",{"2B-"},{0},{"="},{0},15933.08,0.02,22034.12,2.52,-7492.32,2.14,2039.06,0.01,-17942.95,1.96,-8250.01,0.88,9427.24,0.05,12037.28,2.42,-4199.18,4.01,5547.53,2.99,1350.5,1.68,-1973.08,1.86}
,{76,33,-72291.377,0.886,8682.816,0.012,2960.573,0.886,75.92239201,0.951,0,93121.92,"",172.8,"",2,-1,"","",{"B-","EC"},{0,0.02,0},{"~","<"},{0,0.02,0},17573.96,1.91,18819.7,3.12,-6128,1.21,-2002.31,9.36,-11115.77,2.58,-8193.21,0.88,7328.5,0.07,7723.38,0.89,-11812.3,1.29,11841.87,0.89,3870.2,0.89,3054.36,1.9}
,{76,34,-75251.95,0.016,8711.477,0,-4962.881,9.322,75.919213704,0.017,1,"s","","s","",0,1,"","",{},{},{},{},19181.38,0.02,16407.45,0.02,-5090.97,0.08,-6238.24,4.01,-10683.96,0.05,-14216.26,4.28,11153.79,0.07,9506.73,0.88,-21004.31,34.47,6318.91,1.69,564.85,3.85,1691.97,0.06}
,{76,35,-70289.068,9.322,8635.882,0.123,-1275.355,10.149,75.924541577,10.007,0,58320,"",720,"",1,-1,"","",{"B+"},{0},{"="},{0},21143.55,11,14006.96,9.47,-4484.19,10.18,-9809.99,9.37,-4543.84,9.36,-14036.76,12.35,9253.38,10.26,5408.56,9.32,-31809,300,12634.94,9.32,2802.37,11.92,6310.08,10.09}
,{76,36,-69013.714,4.013,8608.807,0.053,-8534.633,4.121,75.925910726,4.308,0,53280,"",360,"",0,1,"","",{"B+"},{0},{"="},{0},22824.51,4.49,11378.45,4.01,-3570.45,4.46,-14766.07,34.7,-4133.2,4.01,-19866.34,4.18,12761.41,9.04,7195.68,5.87,"","",6985.25,7.08,-502.18,8.3,4860.07,8.44}
,{76,37,-60479.081,0.938,8486.215,0.012,-6231.442,34.478,75.935073032,1.006,0,36.5,"",0.6,"",0,0,"","",{"B+","B+A"},{0,3.8,0},{"=","="},{0,3.8,0},24705.71,3.17,9768.87,5.91,-3842.25,1.39,-21999,300,1338.96,4.39,-21931.7,220.01,11331.7,1.51,3444.43,8.16,"","",12563.56,2.22,936.72,6.64,8814.8,7.33}
,{76,38,-54247.639,34.465,8393.929,0.453,-15768,302,75.941762761,37,0,7.89,"",0.07,"",0,1,"","",{"B+","B+p"},{0,3.4,0},{"=","="},{0,3.4,0},29563,105,6493.74,34.52,-2731.98,35.38,"","",2787.01,35.41,-30499,302,15700.26,222.69,4317.92,34.49,"","",8379.18,34.6,-3302,203,7950.51,35.09}
,{76,39,-38480,300,8176,4,"","",75.95869,322,0,0.00012,"",2e-07,">",1,-1,"","",{},{},{},{},"","",1142,300,-2575,583,"","",11450,300,"","",14731,424,-850,372,"","",13058,316,-1666,500,13248,361}
,{77,27,-21015,600,8070,8,15785,781,76.97744,644,0,0.015,"",0.006,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,90,0,5,0},{"=","=","="},{0,90,0,5,0},7508,781,"","","","",27609,618,"","",12545,721,4575,848,"","",44978,600,3336,848,3440,848,"",""}
,{77,28,-36800,500,8265,6,11824,522,76.960494,537,0,0.1589,"",0.0042,"",4.5,1,"","",{"B-","B-n","B-2n"},{0,30,"",0,0},{"=","=","="},{0,30,"",0,0},8912,583,37738,781,-16325,707,21990,500,"","",6105,500,3241,640,19578,781,34413,500,3561,707,885,707,-11563,781}
,{77,29,-48624,149,8408,2,10165,149,76.9478,160,0,0.4679,"",0.0021,"",2.5,-1,"","",{"B-","B-n"},{0,30.3,0},{"=","="},{0,30.3,0},10295,149,33552,522,-13631,426,17368,149,-31403,618,5608,149,5719,149,14283,426,25292,149,6117,335,4696,246,-10157,522}
,{77,30,-58789.195,1.973,8530.003,0.026,7203.149,3.124,76.936887199,2.117,0,2.08,"",0.05,"",3.5,1,"","",{"B-"},{0},{"="},{0},12372.92,2.78,29337,300,-11105.96,3.12,12423.67,1.97,-24448,400,-563.87,2.78,4557.5,2.45,15102.18,6.99,15810.29,1.97,6392.95,3.05,2081.06,6.46,-4686,196}
,{77,31,-65992.344,2.422,8613.39,0.031,5220.518,2.422,76.9291543,2.6,0,13.2,"",0.2,"",0,0,"","",{"B-"},{0},{"="},{0},13670.4,3.43,26098.94,3.36,-9429.82,3.1,7923.97,2.95,-22305.33,7.13,-850.77,2.42,7767.02,3.11,10978.3,2.83,7242.46,3.71,7277.37,3.11,4628.42,3.49,-4339.74,6.61}
,{77,32,-71212.862,0.053,8671.028,0.001,2703.456,1.694,76.923549844,0.056,0,40359.6,"",10.8,"",3.5,1,"","",{"B-"},{0},{"="},{0},15498.53,0.07,23231.89,1.96,-8044.37,1.86,3386.63,0.08,-16198.82,1.46,-6992.8,0.89,6071.29,0.05,12205.19,1.96,-1043.42,1.96,7962.52,2.42,1700.81,2.99,190.25,2.52}
,{77,33,-73916.318,1.693,8695.978,0.022,683.17,1.693,76.920647564,1.817,0,139644,"",180,"",1.5,-1,"","",{"B-"},{0},{"="},{0},17024.76,1.91,20029.68,2.95,-6641.9,2.38,-681.51,3.28,-14908.65,2.59,-6735.69,1.69,9696.26,1.91,7992.4,1.69,-9085.83,2.14,8651.45,1.69,4370.18,1.69,-220.3,3.44}
,{77,34,-74599.488,0.062,8694.69,0.001,-1364.68,2.81,76.91991415,0.067,1,"s","","s","",0.5,-1,"","",{},{},{},{},18572.64,0.1,17320.47,0.08,-5726.88,0.08,-4430.05,1.96,-8675.57,0.06,-12381.74,9.32,7418.86,0.06,9597.08,0.89,-16796.05,7.92,9145.51,0.89,1124.62,1.69,4469.35,0.06}
,{77,35,-73234.809,2.811,8666.806,0.037,-3065.366,3.424,76.921379194,3.017,0,205344,"",432,"",1.5,-1,"","",{"B+"},{0},{"="},{0},20270.43,5.12,14778.55,2.95,-4706.98,4.77,-8404.32,3.1,-8232.4,2.95,-12292.41,4.9,11017.06,9.74,5271.83,2.81,-26796,203,9645.48,2.81,3842.45,2.81,3271.65,3.28}
,{77,36,-70169.443,1.956,8616.836,0.025,-5338.951,2.351,76.92467,2.1,0,4464,"",36,"",2.5,1,"","",{"B+"},{0},{"="},{0},21988.45,8.34,12577.9,1.96,-4366.97,7.68,-12366.01,8.16,-2206.46,1.96,-17761.68,2.17,9227.05,4.46,7169.34,9.52,-38130,400,9648.37,4.71,-17.23,6.15,7690.16,1.96}
,{77,37,-64830.492,1.304,8537.339,0.017,-7027.055,8.024,76.9304016,1.4,0,226.8,"",2.4,"",1.5,-1,"","",{"B+"},{0},{"="},{0},23754.43,1.76,10301.42,4.48,-3607.93,7.38,-18392,203,-1830.39,9.41,-18654.17,34.49,12422.73,1.61,3105.75,4.22,"","",10203.94,8.21,2365.4,2.4,6104.06,5.98}
,{77,38,-57803.436,7.918,8435.918,0.103,-11365,203,76.937945455,8.5,0,9,"",0.2,"",2.5,1,"","",{"B+","B+p"},{0,0.08,0},{"=","="},{0,0.08,0},27327.38,220.15,8057.75,11.33,-3676.6,10.29,-25764,400,3921.31,8.88,-27395,300,11627.11,35.36,4613.33,7.97,"","",10126.06,8.01,-1023.37,8.48,10174.8,8.17}
,{77,39,-46439,203,8278,3,-14399,448,76.950146,218,0,0.063,"",0.017,"",2.5,1,"","",{"B+","p"},{"",10,0},{"","<"},{"",10,0},30761,362,3798,203,-2782,285,"","",6751,203,"","",16030,362,-520,200,"","",10891,299,-747,226,11124,203}
,{77,40,-32040,400,8081,5,"","",76.965604,429,0,0.0001,"","s","",1.5,-1,"","",{},{},{},{},"","",-1,456,-2514,566,"","",14919,401,"","","","",849,500,"","",10491,500,"","",14434,412}
,{78,28,-33890,600,8225,8,10608,783,77.963618,644,0,0.1222,"",0.0051,"",0,1,"","",{"B-","B-n","B-2n"},{0,50,0,0,0},{"=","=","="},{0,50,0,0,0},8402,721,"","",-16724,848,23594,600,"","",6663,618,5161,781,20164,848,37972,600,1332,848,624,781,-14603,848}
,{78,29,-44497.469,503.007,8350.925,6.449,12985.766,503.011,77.95223,540,0,0.3307,"",0.002,"",5,-1,"","",{"B-","B-n","B-2n"},{0,50.6,0,"",""},{"=","=",""},{0,50.6,0,"",""},9664.12,503.05,34565,783,-14102,709,19208.48,503.01,-30772,783,6220.41,503.01,3945,525,14987,709,28319.47,503.1,7844,642,4396,586,-9202,709}
,{78,30,-57483.235,1.944,8507.379,0.025,6222.716,2.719,77.938289205,2.086,0,1.47,"",0.15,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},11322.85,2.43,30431,400,-11452,196,14378.81,4.03,-27973,500,437.79,3.11,6765.36,2.77,16148,149,19542.71,1.95,4203.56,6.98,1852.16,3.03,-7807,300}
,{78,31,-63705.95,1.903,8577.127,0.024,8156.099,4.015,77.931608845,2.043,0,5.09,"",0.05,"",2,-1,"","",{"B-"},{0},{"="},{0},13551.95,2.73,27307.91,6.97,-10124.66,6.44,9110.99,9.96,-22371,149,-564.41,1.9,5784.92,3.08,12205.73,2.74,9746.21,4.05,9307.87,2.39,3717.01,2.73,-3588.21,3.01}
,{78,32,-71862.05,3.536,8671.663,0.045,954.89,10.4,77.922852912,3.795,0,5280,"",60,"",0,1,"","",{"B-"},{0},{"="},{0},14791.79,3.54,24136.97,3.82,-8530.25,4.34,5163.89,3.54,-20361.82,4.05,-6017.05,3.92,8720.5,3.54,13158.68,4.29,2316.23,3.55,5145.4,4.04,1466.59,4.29,-3656.74,4.04}
,{78,33,-72816.94,9.781,8673.875,0.125,4209.004,9.782,77.921827795,10.5,0,5442,"",12,"",2,-1,"","",{"B-"},{0},{"="},{0},16668.2,9.82,21098.24,9.97,-7192.24,10.23,635.22,10.41,-14113.57,10.08,-6288.77,9.78,6971.94,9.89,8893.05,9.78,-5881.52,10.3,11106.75,9.78,3904.08,9.78,1294.04,10.08}
,{78,34,-77025.944,0.179,8717.806,0.002,-3573.784,3.575,77.917309243,0.191,1,"s","","s","",0,1,"","",{},{},{},{},17916.63,0.18,18391,0.18,-6028.42,0.18,-2847.67,0.26,-13102.05,0.19,-11862.45,2.81,10497.77,0.17,10398.6,1.7,-13852,7.45,5976.24,0.9,872.31,0.9,477.42,0.19}
,{78,35,-73452.16,3.58,8661.959,0.046,726.116,3.584,77.921145859,3.842,0,387,"",2.4,"",1,1,"","",{"B+","B-"},{0,0.01,0},{"~","<"},{0,0.01,0},19305.73,9.99,15738.72,3.69,-5017.02,3.96,-6516.74,4.83,-6824.81,3.96,-11354.03,4.08,8288.67,4.55,6141.64,3.58,-21279,298,12510.6,3.58,3581.38,3.58,5228.44,3.69}
,{78,36,-74178.275,0.307,8661.238,0.004,-7242.857,3.252,77.920366341,0.329,1,"s","","s","",0,1,"","",{},{},{},{},21307.2,4.02,13504.27,0.31,-4389.99,0.31,-11004.33,7.46,-6867.76,0.3,-17419.1,1.34,12080.15,1.98,8232.44,2.83,-33329,400,6821.6,9.33,-207.21,4.3,3637.61,0.32}
,{78,37,-66935.419,3.237,8558.35,0.042,-3761.477,8.125,77.928141868,3.475,0,1059.6,"",1.8,"",0,0,"","",{"B+"},{0},{"="},{0},22598.97,3.37,11224.29,9.87,-4072.18,6.67,-14762,298,-989.58,4.29,-17203.3,8.55,10176.24,3.49,4054.95,3.78,"","",12789.1,5.16,2252.26,8.73,7817.99,5.37}
,{78,38,-63173.941,7.452,8500.096,0.096,-11001,298,77.93217998,8,0,156.1,"",2.7,"",0,1,"","",{"B+"},{0},{"="},{0},25068.94,35.26,8738.17,8.46,-3267.02,7.72,-22324,400,-293.47,7.7,-24807,203,13441.82,10.87,5632.42,7.57,"","",8015.95,7.51,-1091.19,7.54,6796.08,11.01}
,{78,39,-52173,298,8349,4,-11323,499,77.94399,320,0,0.054,"",0.005,"",0,1,"","",{"B+"},{0},{"="},{0},29836,423,6272,298,-2682,298,"","",5369,298,-28205,499,13806,361,1659,298,"","",12785,300,-690,370,10692,298}
,{78,40,-40850,400,8194,5,"","",77.956146,429,0,0.05,"",2e-07,">",0,1,"","",{},{},{},{},"","",1180,401,-2447,412,"","",9665,400,"","",16881,565,1700,448,"","",8341,500,-4166,500,11415,456}
,{79,28,-27570,600,8143,8,14170,671,78.970402,644,0,0.044,"",0.008,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,60,0,40,0},{"=","=","="},{0,60,0,40,0},6913,781,"","",-16355,848,25862,600,"","",8856,783,1752,848,"","",41956,601,4155,848,1804,848,"",""}
,{79,29,-41740,300,8312,4,11692,300,78.95519,322,0,0.241,"",0.0032,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,66,"",0,0},{"=","=","="},{0,66,"",0,0},9259,335,35304,671,-14516,583,20807,300,"","",7672,300,5314,586,15140,671,31896,300,5770,583,4754,500,-11583,671}
,{79,30,-53432.295,2.225,8450.582,0.028,9115.384,2.901,78.942638068,2.388,0,0.746,"",0.042,"",4.5,1,"","",{"B-","B-n"},{0,1.7,0},{"=","="},{0,1.7,0},10785.73,2.97,31211,500,-11827,300,16094.3,37.25,-26832,600,2202.34,2.93,4020.38,2.95,16223.8,503.01,22485.16,2.24,5902,149,2407.75,7.07,-6156,400}
,{79,31,-62547.679,1.868,8556.063,0.024,6978.913,37.147,78.932852301,2.005,0,2.848,"",0.003,"",0,0,"","",{"B-","B-n"},{0,0.089,0},{"=","="},{0,0.089,0},12697.97,3.06,28502,149,-10501.25,2.99,11088.37,5.64,-25339.18,503.01,1243.05,4,6913.05,2.66,12353.41,2.69,13520.36,2.13,6952.32,2.72,4619.39,2.37,-5925.29,6.96}
,{79,32,-69526.592,37.181,8634.501,0.471,4109.457,37.456,78.925360129,39.915,0,18.98,"",0.03,"",0,0,"","",{"B-"},{0},{"="},{0},14456.36,37.18,25315.34,37.23,-9392.6,37.23,6390.87,37.18,-19332.33,37.23,-4780.97,38.44,5735.86,37.35,13109.61,37.23,4915.66,37.34,7176.56,37.26,1634.1,37.23,-1577.17,37.21}
,{79,33,-73636.049,5.328,8676.616,0.067,2281.41,5.331,78.920948445,5.719,0,540.6,"",9,"",1.5,-1,"","",{"B-"},{0},{"="},{0},15862.37,5.53,22221.65,5.85,-7596.38,5.85,2431.99,5.25,-17219.07,5.66,-4681.42,5.33,8890.43,11.05,9062.97,6.39,-2833.06,5.74,8287.62,5.33,4440.89,5.33,-1693.01,5.68}
,{79,34,-75917.459,0.223,8695.592,0.003,150.576,1.038,78.918499251,0.238,0,10319114802000,"",883593928000,"",3.5,1,"","",{"B-"},{0},{"="},{0},17460.6,0.21,19282.54,0.23,-6485.41,0.23,-1475.2,3.49,-11344.38,3.54,-10536.62,3.58,6962.83,0.13,10389.49,9.78,-10440.57,8.39,8709.67,1.7,1237.97,0.91,2941.83,0.22}
,{79,35,-76068.035,1.021,8687.594,0.013,-1625.778,3.333,78.918337601,1.095,1,"s","","s","",1.5,-1,"","",{},{},{},{},18975.86,2.99,16729.66,1.8,-5458.75,1.35,-5265.05,2.37,-10540.07,9.74,-9961.08,1.06,10687.19,3.72,6331.06,1.03,-18250.2,79.18,9242.26,1.02,4047.97,1.02,1869.74,1.35}
,{79,36,-74442.257,3.486,8657.112,0.044,-3639.271,4.092,78.920082945,3.742,0,126144,"",360,"",0.5,-1,"","",{"B+"},{0},{"="},{0},20415.45,4,14420.71,3.49,-4697.69,3.49,-8965.37,9.08,-4705.28,3.49,-15578.16,4.76,8335.3,3.5,8279.07,5,-27672,300,9503.36,4.48,710.87,9.95,6456.09,3.49}
,{79,37,-70802.985,2.142,8601.142,0.027,-5326.096,8.653,78.923989864,2.3,0,1374,"",30,"",2.5,1,"","",{"B+"},{0},{"="},{0},22115.13,2.51,12146.12,3.53,-4120.89,4.79,-12985.15,79.21,-4639.8,4.17,-15700.36,7.75,11938.88,3.88,3913.68,2.16,-39153,500,10077.26,2.9,3074.78,4.55,5132.48,9.56}
,{79,38,-65476.889,8.383,8523.82,0.106,-7659.056,79.62,78.929707664,9,0,135,"",6,"",0,0,"","",{"B+"},{0},{"="},{0},23816.09,11.53,9885.39,8.61,-3578.18,11.66,-18707,300,1412.42,8.39,-21375,298,10374.26,11.22,5830.44,8.99,"","",10064.41,8.48,-133.75,8.44,9183.23,9.29}
,{79,39,-57817.833,79.177,8416.967,1.002,-11048,310,78.93793,85,0,14.8,"",0.6,"",2.5,1,"","",{"B+"},{0},{"="},{0},27522,218,7565.28,79.19,-3024.05,79.19,-26168,506,1828.62,79.24,-25039,407,13716,308,1932.86,79.53,"","",10696.41,79.57,1293.86,86.35,8307.65,79.18}
,{79,40,-46770,300,8267,4,-15120,583,78.94979,322,0,0.056,"",0.03,"",2.5,1,"","",{"B+"},{0},{"="},{0},30873,500,3545,300,-2577,372,"","",9115,300,"","",13992,500,1886,423,"","",10379,362,-3426,424,13124,302}
,{79,41,-31650,500,8066,6,"","",78.966022,537,0,"s","","s","",4.5,1,"","",{},{},{},{},"","",-210,540,-2255,583,"","",13234,582,"","","","",-1910,640,"","",11100,640,"","",12476,583}
,{80,28,-22630,700,8080,9,13570,806,79.975706,751,0,0.03,"",0.022,"",0,1,"","",{"B-","B-n","B-2n"},{0,60,0,40,0},{"=","=","="},{0,60,0,40,0},4883,922,"","","","",29019,700,"","",11039,761,3131,922,"","",46906,700,"","",3249,922,"",""}
,{80,29,-36200,400,8240,5,15449,400,79.961138,429,0,0.1133,"",0.0064,"",0,0,"","",{"B-n","B-2n"},{0,20,0},{"=","="},{0,20,0},7845,642,"","",-14114,721,23024,400,"","",9161,400,2531,500,15918,721,36015,400,8401,721,5464,640,-9539,721}
,{80,30,-51648.612,2.585,8423.545,0.032,7575.055,3.877,79.94455293,2.774,0,0.5622,"",0.003,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},10308.01,3.23,32337,600,-12443,400,17886.69,3.3,-31367,600,2827.75,3.19,6287.63,3.41,17197,300,26110.84,2.76,3559.66,503.01,1839,149,-9203,500}
,{80,31,-59223.667,2.891,8508.454,0.036,10311.639,3.541,79.936420774,3.103,0,1.9,"",0.1,"",0,0,"","",{"B-","B-n"},{0,0.86,0},{"=","="},{0,0.86,0},11660.35,3.46,29304.14,503.02,-10672.6,7.3,12990.83,4.41,-24772,300,2231.61,37.29,4747.31,3.44,13080.34,3.64,16665.33,3.06,8970.37,3.48,4429.58,3.5,-4953,149}
,{80,32,-69535.306,2.054,8627.57,0.026,2679.187,3.915,79.925350774,2.205,0,29.5,"",0.4,"",0,1,"","",{"B-"},{0},{"="},{0},13815.89,4.09,26630.01,2.82,-9657.21,2.51,8224.15,2.27,-23391.98,3.02,-3970.57,5.71,8080.03,37.24,14276.6,2.77,8358.04,2.17,4881.45,2.8,1321.09,3.18,-5099.71,2.85}
,{80,33,-72214.493,3.333,8651.28,0.042,5544.964,3.445,79.922474548,3.577,0,15.2,"",0.2,"",1,1,"","",{"B-"},{0},{"="},{0},15540.19,10.32,23086.48,3.84,-8342.77,3.86,3674.5,3.46,-16955.79,3.82,-4368.35,3.34,6649.76,6.27,9976.87,37.33,-39.03,3.82,10358.36,4.86,3862.42,3.33,-575.75,4.12}
,{80,34,-77759.457,0.963,8710.813,0.012,-1870.464,0.31,79.916521785,1.034,1,"s","","s","",0,1,"","",{},{},{},{},16876.15,0.97,20475.35,3.66,-6971.48,0.96,133.89,1.11,-15521.84,37.19,-9762.74,0.34,9913.31,0.98,11412.38,5.24,-7448,3.6,5768.29,9.73,1020.92,1.77,-900.19,0.96}
,{80,35,-75888.993,1.012,8677.653,0.013,2004.353,1.154,79.91852981,1.086,0,1060.8,"",1.2,"",1,1,"","",{"B-","B+"},{0,8.3,0},{"=","="},{0,8.3,0},18579.47,3.72,17649.99,9.74,-6022.53,1.34,-3713.53,2.12,-9541.91,5.25,-9518.05,3.34,7892.28,0.13,7260.5,1.03,-14740.84,6.32,11847.76,1.02,3574.55,1.01,3673.73,1.8}
,{80,36,-77893.346,0.691,8692.928,0.009,-5717.879,1.987,79.916378048,0.742,1,"s","","s","",0,1,"","",{},{},{},{},19857.71,0.75,15445.34,0.71,-5066.31,0.69,-7581.89,3.53,-9264.86,0.73,-15161.68,2.25,11522.41,3.53,9114.28,1.16,-23533,300,6269.62,3.65,205.52,2.89,2352.54,0.69}
,{80,37,-72175.467,1.863,8611.675,0.023,-1864.009,3.933,79.922516444,2,0,33.4,"",0.7,"",1,1,"","",{"B+"},{0},{"="},{0},21382.68,3.74,13301.25,4.04,-4311.31,9.51,-11027.32,6.51,-3396.4,2.12,-14769.9,8.59,9443.8,2.84,5022.18,3.95,-33755,400,12713.61,1.89,2858.03,2.7,6705.74,3.37}
,{80,38,-70311.459,3.464,8578.596,0.043,-9163.307,7.139,79.92451754,3.718,0,6378,"",90,"",0,1,"","",{"B+"},{0},{"="},{0},23280.15,8.22,10711.12,3.48,-3722.66,5.3,-15951,300,-3158.17,4.91,-20564.94,79.25,12905.89,9.07,6797.44,4.07,"","",7334.77,4.74,-616.91,3.7,5504.39,3.98}
,{80,39,-61148.152,6.242,8454.275,0.078,-6788,300,79.934354755,6.701,0,30.1,"",0.5,"",4,-1,"","",{"B+"},{0},{"="},{0},25118,298,8790.67,7.03,-3093.99,6.31,-22728,400,2365.86,6.6,-22449,300,11401.64,79.42,2960.23,10.45,"","",12736.6,9.72,1519.34,10.08,9328.74,6.38}
,{80,40,-54360,300,8360,4,-15940,500,79.941642,322,0,4.6,"",0.6,"",0,1,"","",{"B+"},{0},{"="},{0},29653,500,5764,300,-2537,302,"","",3828,300,-30781,583,15661,424,3831,310,"","",8524,423,-3057,362,9090,300}
,{80,41,-38420,400,8151,5,"","",79.958754,429,0,"s","","s","",4,-1,"","",{},{},{},{},"","",825,499,-2365,500,"","",12108,407,"","",14841,640,-1061,500,"","",13140,565,-1517,565,13665,448}
,{81,29,-31420,500,8179,6,14779,500,80.966269,537,0,0.0732,"",0.0068,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,70,0,30,0},{"=","=","="},{0,70,0,30,0},5823,583,"","",-12831,781,26208,500,"","",12157,500,3292,640,16079,860,41113,500,6861,781,7333,781,"",""}
,{81,30,-46199.663,5.03,8351.925,0.062,11428.292,5.996,80.950402619,5.4,0,0.3032,"",0.0026,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,9.1,0,0,0},{"=","=","="},{0,9.1,0,0,0},8910,5.5,33207,600,-11825,500,20092.02,5.43,-30859,700,4952.69,5.8,2622.37,5.66,17289,400,30189.32,5.13,6251,300,3161.86,503.03,-6664,600}
,{81,31,-57627.954,3.264,8483.357,0.04,8663.733,3.851,80.938133842,3.503,0,1.217,"",0.005,"",2.5,-1,"","",{"B-","B-n"},{0,11.9,0},{"=","="},{0,11.9,0},11222.91,3.75,30466,300,-11429,149,14905.35,4.2,-28717,400,3836.03,3.85,6475.6,4.36,13268.31,4.16,20349.08,3.41,6515.15,3.95,4719.34,3.8,-7484.08,503.02}
,{81,32,-66291.687,2.055,8580.658,0.025,6241.617,3.344,80.928832942,2.205,0,8,"",2,"",4.5,1,"","",{"B-"},{0},{"="},{0},12907.73,37.24,27437.33,3.02,-9927.41,2.85,10097.3,2.28,-21932.05,3.3,-2148.51,3.92,4827.7,2.9,14356.99,3.54,11404.49,2.32,6966.8,2.77,2278.32,2.8,-3162.05,2.82}
,{81,33,-72533.304,2.644,8648.056,0.033,3855.684,2.812,80.92213229,2.838,0,33.3,"",0.8,"",1.5,-1,"","",{"B-"},{0},{"="},{0},15039.89,5.94,24563.57,3.23,-8965.88,3.59,5443.73,2.82,-20598.61,3.91,-2845.16,2.8,8390.13,4.25,10286.97,3.34,2923.37,5.57,7704.09,37.27,4192.8,4.41,-3180.95,3.26}
,{81,34,-76388.988,0.992,8685.999,0.012,1588.046,1.389,80.917993044,1.065,0,1107,"",7.2,"",0.5,-1,"","",{"B-"},{0},{"="},{0},16614.16,1.01,21440.34,37.19,-7601.04,0.99,1307.19,1.46,-14142.65,2.28,-8571.31,0.47,6700.85,0.35,11463.47,3.45,-4860.86,3.28,7957.87,5.25,1292.01,9.74,1119.46,3.67}
,{81,35,-77977.034,0.978,8695.946,0.012,-280.853,0.471,80.916288206,1.049,1,"s","","s","",1.5,-1,"","",{},{},{},{},18051.63,1.41,18918.93,5.42,-6485.63,1.95,-2520.36,5,-13051.51,3.47,-8155,1.17,10159.36,1.4,7506.55,1.37,-12264.12,5.49,8651.23,1,3912.96,0.99,486.31,9.83}
,{81,36,-77696.181,1.074,8682.82,0.013,-2239.511,5.019,80.916589714,1.152,0,7226536054000,"",347126186000,"",3.5,1,"","",{"EC"},{0},{"="},{0},19396.56,3.65,16356.66,1.1,-5521.61,1.08,-6168.06,3.31,-7225.7,1.44,-13592.03,2.15,7874.15,1.25,9096.16,1.47,-20236.04,94.09,9082.66,1.48,620.03,3.74,4976.16,1.09}
,{81,37,-75456.67,4.904,8645.513,0.061,-3928.545,5.817,80.918993927,5.264,0,16459.2,"",14.4,"",1.5,-1,"","",{"B+"},{0},{"="},{0},20796.32,5.35,13966.58,5.01,-4646.78,5.65,-9743.76,7.3,-6856.65,5,-13216.53,6,11352.52,5.25,4852.29,4.93,-29096,400,9696.39,6.01,3585.66,4.91,3641.89,6.07}
,{81,38,-71528.125,3.128,8587.354,0.039,-5815.214,6.245,80.923211394,3.358,0,1338,"",24,"",0.5,-1,"","",{"B+"},{0},{"="},{0},22193.87,8.95,11663.81,4.68,-3783.6,3.69,-14067.99,94.13,-923.75,3.2,-18451.29,6.98,9287.98,4.67,6641.63,3.64,-39778,500,9985.67,3.79,271.35,4.5,8296.55,3.14}
,{81,39,-65712.912,5.405,8505.902,0.067,-8252.773,94.236,80.929454283,5.802,0,70.4,"",1,"",2.5,1,"","",{"B+"},{0},{"="},{0},24037.71,79.36,9487.87,5.81,-3307.34,5.56,-19352,400,-826.41,5.72,-19424,300,12636.08,8.26,2690.42,6.42,"","",10474.78,9.97,2325.08,9.21,6868.91,6.3}
,{81,40,-57460.139,94.081,8394.358,1.161,-11100,411,80.938314,101,0,5.5,"",0.4,"",1.5,-1,"","",{"B+","B+p"},{0,0.12,0},{"=","="},{0,0.12,0},26832,314,6561.19,94.45,-2081.62,94.41,-25710,509,5562.35,94.14,-27111,411,11171,314,3600.96,94.29,"","",11068.5,122.96,-423,313,11360.2,94.38}
,{81,41,-46360,400,8248,5,-14610,640,80.95023,429,0,4.4e-08,"","s","",4.5,1,"","",{},{},{},{},30853,640,3121,407,-2347,448,"","",7499,400,"","",16011,565,-711,500,"","",11121,500,-647,565,11459,499}
,{81,42,-31750,500,8058,6,"","",80.965915,537,0,0.001,"",4e-07,">",2.5,1,"","",{},{},{},{},"","",-442,583,-2135,640,"","",15321,583,"","","","",619,640,"","",10611,707,"","",14746,640}
,{82,29,-25320,600,8103,7,16994,600,81.972818,644,0,0.05,"",4e-07,">",0,0,"","",{"B-n","B-2n"},{0,60,0},{"=","="},{0,60,0},5263,721,"","","","",27611,600,"","",12808,600,1971,781,"","",44786,600,8021,922,7115,848,"",""}
,{82,30,-42313.954,3.074,8301.117,0.037,10616.764,3.916,81.954574099,3.3,0,0.1779,"",0.0025,"",0,1,"","",{"B-","B-n","B-2n"},{0,69,0,0,0},{"=","=","="},{0,69,0,0,0},6807.98,4.02,34262,700,-10849,600,23101.11,3.8,"","",7242.68,4.48,4185.61,5.89,18183,500,35279.93,3.11,4597,400,4290,300,-9097,600}
,{82,31,-52930.719,2.426,8421.049,0.03,12484.348,3.296,81.943176533,2.604,0,0.599,"",0.002,"",0,0,"","",{"B-","B-n","B-2n"},{0,21.3,0,0,0},{"=","=","="},{0,21.3,0,0,0},9849.69,3.77,31309,400,-10858.17,503.01,17174.7,4.44,-28799,500,5289.65,3.17,3374.08,4.06,14020.03,5.58,24567.94,2.61,9428.7,3.54,5365.63,3.29,-5544,300}
,{82,32,-65415.067,2.241,8563.756,0.027,4690.352,4.345,81.929774033,2.405,0,4.56,"",0.26,"",0,1,"","",{"B-"},{0},{"="},{0},12022.4,3.03,28344.4,3.42,-10356.75,2.96,12178.81,2.29,-26504.37,5.51,-953.08,3.46,7194.7,3.03,15076.08,3.95,15176.72,2.24,4519.41,3.65,1996.67,2.91,-6336.37,3.15}
,{82,33,-70105.419,3.729,8611.414,0.045,7488.463,3.758,81.924738733,4.003,0,19.1,"",0.5,"",2,-1,"","",{"B-"},{0},{"="},{0},14033.56,5,25459.69,4.71,-8824.38,4.18,7393.24,3.85,-19766.44,4.95,-1787.75,3.86,5643.43,4.57,11102.7,4.25,6082.38,4.79,10140.69,4.25,4285.23,37.37,-1911.34,4.17}
,{82,34,-77593.882,0.467,8693.196,0.006,-95.221,1.077,81.916699537,0.5,0,2.903237192e+27,"",2.20898482e+26,"",0,1,"","",{"2B-"},{0},{"="},{0},15977.06,0.94,22636.52,2.11,-8156.75,3.57,2997.9,0.47,-18591.17,2.11,-7688.16,1.08,9276.21,0.97,12349.55,2.66,-1583.83,6.01,5331.42,3.36,906.22,5.32,-2420.89,37.18}
,{82,35,-77498.661,0.971,8682.494,0.012,3093.124,0.971,81.91680176,1.042,0,127015.2,"",25.2,"",5,-1,"","",{"B-"},{0},{"="},{0},17752.3,1.4,19862.11,3.46,-7106.64,9.83,-1310.86,3.16,-12254.33,2.82,-7873.8,0.49,7592.94,0.12,8398.64,1.38,-9434.57,5.58,10971.6,1.36,3282.85,1,1783.79,5.41}
,{82,36,-80591.78515,0.00549,8710.675,0,-4403.982,3.009,81.913481155,0.00589,1,"s","","s","",0,1,"","",{},{},{},{},18841.07,0.69,17410.27,0.96,-5990.76,0.18,-4581.73,5.99,-11491.77,0.99,-13206.43,4.9,10966.92,1.07,9903.72,0.98,-16960.5,11.18,6008.01,1.01,340.3,1.02,972.08,0.22}
,{82,37,-76187.803,3.009,8647.427,0.037,-177.751,6.705,81.918209024,3.23,0,76.38,"",0.12,"",1,1,"","",{"B+"},{0},{"="},{0},20154.97,3.54,14876.75,3.17,-5160.56,4.68,-8123.71,6.27,-5499.74,3.16,-12731,4.34,8802.45,5.75,5780.59,3.19,-24098,300,12416.35,3.09,3118.51,4.6,5526.63,3.18}
,{82,38,-76010.053,5.992,8635.718,0.073,-7945.961,8.132,81.918399847,6.432,0,2191104,"",2592,"",0,1,"","",{"EC"},{0},{"="},{0},21841.23,6.92,12694.65,6.03,-4256.69,6,-12378.77,12.68,-5602.84,6.09,-18368.46,8.07,12553.24,6.76,7842.35,7.74,-35640,400,6876.22,6.27,-343.01,6.36,4078.61,6.93}
,{82,39,-68064.091,5.499,8529.275,0.067,-4432.804,12.457,81.926930188,5.902,0,8.3,"",0.2,"",1,1,"","",{"B+"},{0},{"="},{0},23058.57,8.32,10466.56,5.81,-3553.59,6.38,-15974,300,103.61,7.37,-18675.27,94.24,10422.5,7.71,3824.94,6.33,"","",12958.17,6.5,2276.85,10.03,8385.3,5.9}
,{82,40,-63631.287,11.178,8465.676,0.136,-11541,300,81.931689,12,0,32,"",5,"",0,1,"","",{"B+"},{0},{"="},{0},25414,300,7897.77,11.7,-2882.26,13.43,-23261,400,607.87,11.61,-25342,400,14242.46,94.74,5207.35,12.42,"","",8227.67,12.8,-949.4,79.96,7492,13.97}
,{82,41,-52090,300,8315,4,-11720,500,81.944079,322,0,0.05,"",0.005,"",0,1,"","",{"B+"},{0},{"="},{0},29812,500,5520,300,-2342,423,"","",6334,300,-28411,583,13801,500,1919,314,"","",12981,424,-456,424,11374,310}
,{82,42,-40370,400,8163,5,"","",81.956661,429,0,0.03,"",4e-07,">",0,1,"","",{},{},{},{},"","",588,500,-1945,565,"","",9801,411,"","",16691,640,1299,565,"","",8761,565,-3856,640,12047,500}
,{83,30,-36290,300,8226,4,12967,300,82.961041,322,0,0.119,"",0.016,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,10,0,3,0},{"=","=","="},{0,10,0,3,0},6233,300,"","",-11145,671,24686,300,"","",8569,300,2047,300,18259,671,39050,300,5841,583,4774,500,-8014,761}
,{83,31,-49257.122,2.613,8372.575,0.031,11719.312,3.559,82.947120301,2.804,0,0.3081,"",0.001,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,62.8,0,0,0},{"=","=","="},{0,62.8,0,0,0},7771.8,4.18,32415,500,-9942,300,20412.2,3.82,-31226,600,8086.63,3.44,4397.72,3.56,14232.14,4.03,29756.59,4.61,7653.35,5.67,7255.55,3.67,-7411,400}
,{83,32,-60976.435,2.427,8504.345,0.029,8692.888,3.698,82.934539101,2.605,0,1.85,"",0.06,"",2.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10827.38,3.17,29354.71,5.58,-9969.06,3.29,14364.1,3.89,-25951.45,3.92,1057.67,4.44,3632.68,3.3,15334.69,3.43,19014.2,2.43,7362.33,4.06,3111.29,3.77,-3681.42,3.54}
,{83,33,-69669.323,2.799,8599.653,0.034,5671.207,4.129,82.925206901,3.004,0,13.4,"",0.4,"",2.5,-1,"","",{"B-"},{0},{"="},{0},13278.65,3.85,26619.31,4.29,-9546.56,3.36,9344.39,4.72,-24027.57,3.7,-146.76,2.84,7635.22,4.66,11543.23,3.58,9401.31,3.64,7333.17,3.47,4730.04,3.47,-4799.25,4.02}
,{83,34,-75340.53,3.036,8658.555,0.037,3673.179,4.839,82.919118609,3.259,0,1335,"",2.4,"",4.5,1,"","",{"B-"},{0},{"="},{0},15094.18,3.15,23626.78,3.67,-8238.85,37.3,4650.1,3.04,-17214.43,3.77,-5913.19,3.19,5817.97,3,12524.08,4.81,1457.08,7.48,7903.58,4.01,1738.02,4.51,-158.82,3.67}
,{83,35,-79013.709,3.795,8693.384,0.046,976.924,3.795,82.915175289,4.073,0,8546.4,"",14.4,"",1.5,-1,"","",{"B-"},{0},{"="},{0},17179.31,3.92,21058.35,4.62,-7802.58,6.53,56.92,4.45,-16197.26,5.32,-6493.24,3.79,9586.37,3.92,8708.8,3.8,-6808.04,19.01,8086.08,3.91,3609.8,3.9,-1152.81,5.05}
,{83,36,-79990.633,0.009,8695.729,0,-920.004,2.329,82.914126518,0.009,1,"s","","s","",4.5,1,"","",{},{},{},{},18437.09,1.07,18179.59,0.99,-6498.09,0.22,-3193.03,6.83,-9685.72,0.47,-11874.15,3.01,7470.17,0.01,9780.94,0.97,-14078.98,6.43,8697.21,0.98,762.41,1.01,3415.22,0.96}
,{83,37,-79070.63,2.329,8675.218,0.028,-2273.024,6.424,82.915114182,2.5,0,7447680,"",8640,"",2.5,-1,"","",{"EC"},{0},{"="},{0},19756.59,5.43,15671.54,2.53,-5427.51,2.54,-6864.96,18.78,-8860.94,2.52,-11131.89,6.43,10954.14,3.8,5767.82,2.33,-21514.55,150.92,9336.36,2.56,3686.77,2.43,2464.77,2.54}
,{83,38,-76797.606,6.834,8638.407,0.082,-4591.941,19.844,82.917554374,7.336,0,116676,"",108,"",3.5,1,"","",{"B+"},{0},{"="},{0},21412.11,7.52,13679.37,6.92,-4780.26,7.67,-10885.95,9.38,-3494.79,6.83,-16804.83,8.77,8858.87,9.09,7898.77,7.47,-30458,401,9369.87,8.41,241.92,7.08,6742.14,6.87}
,{83,39,-72205.665,18.631,8573.656,0.224,-6294.012,19.707,82.922484025,20,0,424.8,"",4.8,"",4.5,1,"","",{"B+"},{0},{"="},{0},22635.39,19.4,11326.94,19.27,-3827.6,18.75,-14649.58,152.05,-3306.83,18.87,-16645.7,21.73,12212.89,19.42,3484.58,19.57,-40886,501,10033.27,18.89,2969.85,18.95,5616.2,18.72}
,{83,40,-65911.654,6.43,8488.399,0.077,-8355.571,151.039,82.929240925,6.902,0,42,"",2,"",0.5,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},24594.15,94.3,8961.47,7.15,-2859.68,10.57,-19572,401,2809.43,8.79,-21893,300,10351.68,12.9,5136.53,8.46,"","",10512.06,8.4,100.55,8.96,10046.21,7.3}
,{83,41,-57556.083,150.902,8378.304,1.818,-11216,428,82.938211,162,0,3.9,"",0.2,"",4.5,1,"","",{"B+"},{0},{"="},{0},27338,427,6421.11,151,-2163.17,170.41,-26236,522,3219.04,151,-25257,427,13537,336,1213.77,151.32,"","",10614.86,177.83,1668,336,9238.47,151.03}
,{83,42,-46340,401,8234,5,-15020,641,82.950252,430,0,0.023,"",0.019,"",1.5,-1,"","",{"B+"},{0},{"="},{0},30733,641,3458,411,-1995,500,"","",10002,401,"","",14041,566,1539,500,"","",10731,566,-3056,566,13667,500}
,{83,43,-31320,500,8043,6,"","",82.966377,537,0,"s","","s","",0.5,-1,"","",{},{},{},{},"","",-463,640,-2094,707,"","",13481,583,"","","","",-1761,640,"","",11141,707,"","",12747,640}
,{84,30,-31930,400,8172,5,12158,447,83.965722,429,0,0.05,"",4e-07,">",0,1,"","",{"B-n","B-2n"},{0,4,0},{"=","="},{0,4,0},5758,400,"","",-11725,806,26219,400,"","",9256,400,3711,500,"","",44018,400,4101,721,4355,640,"",""}
,{84,31,-44088,200,8307,2,14061,200,83.95267,215,0,0.085,"",0.01,"",0,-1,"","",{"B-","B-n","B-2n"},{0,40,0,2,0},{"=","=","="},{0,40,0,2,0},7300,200,33346,632,-10313,447,21766,200,"","",8818,200,2902,200,15087,361,33695,202,8937,200,6976,200,-7021,539}
,{84,32,-58148.428,3.171,8465.524,0.038,7705.132,4.479,83.937575091,3.403,0,0.951,"",0.009,"",0,1,"","",{"B-","B-n"},{0,10.7,0},{"=","="},{0,10.7,0},8876,3.88,30412.41,4.42,-8924.73,4.09,17799.29,3.72,-29147,300,3449.58,4.22,5243.31,3.99,16180.28,4.1,24290.91,3.17,5493.1,3.99,4343.58,4.55,-6302.36,5.95}
,{84,33,-65853.56,3.171,8547.938,0.038,10094.161,3.722,83.929303291,3.403,0,4.02,"",0.03,"",3,-1,"","",{"B-","B-n"},{0,0.28,0},{"=","="},{0,0.28,0},11890.78,4.89,27500.78,3.99,-9054.81,4.29,11929.52,25.92,-23885.41,4.1,1415.65,4.39,4255.55,4.22,12166.1,3.99,13905.4,3.86,10272.31,3.88,5302.18,3.77,-2579.2,4.55}
,{84,34,-75947.721,1.961,8658.793,0.023,1835.363,25.765,83.918466762,2.105,0,195.6,"",6,"",0,1,"","",{"B-"},{0},{"="},{0},14496.47,2.02,25110.6,2.97,-8837.33,2.83,6491.61,1.96,-22260.26,3.11,-5005.33,4.27,8678.51,3.61,13567.37,3.41,4701.85,2.32,4868.5,4.21,1449.64,3.29,-4009.63,2.83}
,{84,35,-77783.084,25.73,8671.329,0.306,4656.251,25.73,83.916496419,27.622,0,1905.6,"",4.8,"",2,-1,"","",{"B-"},{0},{"="},{0},16427.06,25.75,22255.61,26,-7993.51,25.94,1975.88,25.82,-15402.73,25.88,-5863.77,25.73,6840.69,26.01,9731.52,25.91,-3888.65,26.09,10521.6,25.73,3469.96,25.75,396.62,25.87}
,{84,36,-82439.3351,0.00379,8717.446,0,-2680.371,2.194,83.911497728,0.00407,1,"s","","s","",0,1,"","",{},{},{},{},17990.18,0,19423.39,0.47,-7104.79,0.96,-1789.76,1.24,-14387.78,3.04,-11440.02,2.33,10520.02,0.01,10714.6,3.79,-11017.65,5.5,5770.13,0.97,401.75,0.98,-403.95,0.99}
,{84,37,-79758.964,2.194,8676.224,0.026,890.606,2.336,83.914375225,2.355,0,2835648,"",6048,"",2,-1,"","",{"B+","B-"},{0,3.9,0},{"=","="},{0,3.9,0},19713.8,3.72,16838.24,2.4,-6294.89,2.42,-5864.53,4.81,-8034.23,4.38,-11032.68,7.18,8759.65,3.2,7057.3,2.19,-18540.25,13.22,11543.63,2.19,2801.27,2.44,3864.47,2.4}
,{84,38,-80649.57,1.243,8677.512,0.015,-6755.139,4.411,83.91341912,1.334,1,"s","","s","",0,1,"","",{},{},{},{},20782.15,6.03,14635.73,1.24,-5181.14,1.42,-9227.88,5.64,-7947.91,1.24,-16515.22,18.67,11923.28,6.95,8867.91,2.64,-26479,298,6249.04,3.26,-328.84,5.06,2693.01,1.64}
,{84,39,-73894.431,4.299,8587.78,0.051,-2472.745,6.977,83.920671061,4.615,0,2370,"",48,"",6,1,"","",{"B+"},{0},{"="},{0},21972.97,6.98,12284.57,5.25,-4143.88,4.69,-12675.71,13.73,-2112.77,4.89,-16054.09,7.73,9760.08,19.12,4385.8,8.07,-36194,400,12826.43,7.36,2497.75,5.32,7208.64,6.52}
,{84,40,-71421.686,5.499,8549.029,0.065,-10202.968,14.153,83.923325662,5.903,0,1548,"",30,"",0,1,"","",{"B+"},{0},{"="},{0},23933.03,12.46,9989.57,8.13,-3535.14,6.5,-17252,298,-1913.05,8.77,-21936.92,151,13581.35,8.46,6504.99,19.42,"","",7353.21,7.77,-844.72,7.71,5752.84,6.33}
,{84,41,-61218.717,13.041,8418.252,0.155,-7049,298,83.934279,14,0,9.8,"",0.9,"",1,1,"","",{"B+"},{0},{"="},{0},25271,300,7732.57,14.15,-2495.48,14.46,-23518,400,3697.98,22.74,-22950,401,11733.95,151.46,2596.03,14.54,"","",13123.38,17.18,1105.48,94.98,10140.6,14.12}
,{84,42,-54170,298,8325,4,-16470,499,83.941846,320,0,2.3,"",0.3,"",0,1,"","",{"B+"},{0},{"="},{0},29943,499,5117,298,-2235,423,"","",4453,298,-30922,582,15901,499,3903,334,"","",8631,423,-2946,499,8936,313}
,{84,43,-37700,400,8120,5,"","",83.959527,429,0,"s","","s","",1,1,"","",{},{},{},{},"","",188,500,-1705,565,"","",12567,427,"","",14452,640,-1351,566,"","",13380,565,-1086,640,14307,565}
,{85,30,-25230,500,8092,6,14619,582,84.972914,537,0,0.05,"",4e-07,">",2.5,1,"","",{"B-n","B-2n"},{0,7,0},{"=","="},{0,7,0},5083,583,"","","","",27893,500,"","",10786,539,1372,640,"","",47183,500,"","",4953,781,"",""}
,{85,31,-39849,298,8255,4,13274,298,84.95722,320,0,0.0922,"",0.0035,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,35,0,6,0},{"=",">","="},{0,35,0,6,0},6735,298,"","",-10854,582,23340,298,"","",10228,298,3833,359,15209,499,38726,298,7152,423,7329,298,-8883,670}
,{85,32,-53123.42,3.729,8401.768,0.044,10065.724,4.83,84.942969659,4.003,0,0.494,"",0.008,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,16.5,0,0,0},{"=","=","="},{0,16.5,0,0,0},8289.62,4.44,31411,300,-9348.67,6.26,19290.22,4.55,-28483,400,4658.82,4.89,3046.31,4.89,16325,200,28356.91,4.23,6844.51,4.55,4671.35,4.44,-5163.06,4.83}
,{85,33,-63189.144,3.078,8510.984,0.036,9224.492,4.031,84.932163659,3.304,0,2.021,"",0.012,"",2.5,-1,"","",{"B-","B-n"},{0,62.9,0},{"=","="},{0,62.9,0},9662.46,4.15,28509.96,4.03,-7986.11,4.48,15386.32,4.35,-26391,200,4687.26,3.64,5406.9,4.41,12329.69,4.41,18978.19,3.08,8498.1,3.91,7089.98,3.8,-4612.02,3.91}
,{85,34,-72413.636,2.613,8610.304,0.031,6161.833,4.031,84.922260759,2.804,0,32.9,"",0.3,"",0,0,"","",{"B-"},{0},{"="},{0},13215.74,4.01,26015.14,3.56,-8546.86,3.32,9066.69,3.29,-21554.18,4.1,-2701.87,25.86,4537.23,3.26,13849.05,4.1,8689.64,3.84,7966.49,3.82,2555.84,4.55,-1352.17,3.44}
,{85,35,-78575.469,3.078,8673.592,0.036,2904.861,3.671,84.915645759,3.304,0,174,"",3.6,"",1.5,-1,"","",{"B-"},{0},{"="},{0},15704.39,4.89,23484.09,4.15,-8467.08,4.05,3591.86,3.08,-20010.88,4.41,-4207.45,3.08,8863.7,25.91,9916.72,3.64,-733.35,19.21,7475.87,4.32,3882.47,3.11,-2823.65,4.83}
,{85,36,-81480.331,2,8698.562,0.024,687,2,84.912527262,2.147,0,338889828.314,"",441796.964,"",4.5,1,"","",{"B-"},{0},{"="},{0},17632.33,2,20717.74,3.64,-7516.26,2.23,-377.05,3.45,-12821.58,2.8,-9792.68,2.97,7112.31,2,10986.22,25.81,-8305.14,6.73,8244.19,4.29,882.39,2.22,1759.95,2.05}
,{85,37,-82167.3305,0.00498,8697.441,0,-1064.051,2.813,84.911789737,0.00534,1,"s","","s","",2.5,-1,"","",{},{},{},{},19239.34,2.33,17731.56,3.79,-6615.21,0.98,-4325.21,18.97,-11673.22,25.73,-9589.08,1.24,10479.68,2.19,7016.97,0,-15887.65,4.1,8534.11,0.01,3288.51,0.01,977.73,0.97}
,{85,38,-81103.28,2.813,8675.718,0.033,-3261.157,19.173,84.912932043,3.02,0,5602953.6,"",604.8,"",4.5,1,"","",{"EC"},{0},{"="},{0},20448.31,7.39,15690.59,2.81,-5832.01,3.01,-7928.09,7.02,-5952.92,2.81,-15280.17,5.13,8525.03,3.01,8633.29,3.55,-23593.53,16.08,8678.16,3.65,-51.42,4.12,5134.91,2.81}
,{85,39,-77842.123,18.965,8628.148,0.223,-4666.934,20.026,84.916433039,20.36,0,9648,"",180,"",0,0,"","",{"B+"},{0},{"="},{0},21779.09,26.59,13349.43,19.11,-4810.37,19.59,-11562.45,19.4,-5372.13,19.09,-14491.75,19.75,12019.01,19.45,4481.52,19.01,-31992,400,9666.29,20.16,3031.98,19.89,3992.08,19.2}
,{85,40,-73175.189,6.43,8564.039,0.076,-6895.514,7.625,84.921443198,6.902,0,471.6,"",2.4,"",3.5,1,"","",{"B+"},{0},{"="},{0},23406.17,9.09,10955.52,9.38,-4071.98,7.15,-15665.44,17.09,185.41,6.55,-20027.79,14.54,9824.82,8.46,6569.73,7.73,-42225,500,9741.28,19.71,-247.04,8.46,8481.26,8.79}
,{85,41,-66279.676,4.099,8473.711,0.048,-8769.923,16.357,84.928845837,4.4,0,20.5,"",0.7,"",4.5,1,"","",{"B+"},{0},{"="},{0},24866.23,150.96,8651.95,19.08,-2991.68,6.78,-20430,400,325.78,5.94,-20181,298,13132.28,13.67,2146.96,6.86,"","",10342.78,7.62,2215.67,11.91,7430.82,6.86}
,{85,42,-57509.753,15.835,8361.331,0.186,-11660,400,84.938260737,17,0,3.2,"",0.2,"",0.5,1,"","",{"B+","B+p"},{0,0.14,0},{"=","="},{0,0.14,0},27312,401,6176.04,17.09,-2474.53,95.4,-26560,500,6622.96,16.76,-27881,400,11411,298,3580.01,20.51,"","",10757.14,151.73,-556,300,11767.94,19.38}
,{85,43,-45850,400,8215,5,-14900,640,84.950778,429,0,1.1e-07,"","s","",0.5,-1,"","",{},{},{},{},30673,640,2872,427,-1914,565,"","",8080,400,"","",16221,565,-1031,499,"","",11201,566,-616,565,11886,500}
,{85,44,-30950,500,8030,6,"","",84.966774,537,0,0.001,"",4e-07,">",1.5,-1,"","",{},{},{},{},"","",-812,641,-1625,707,"","",15931,582,"","","","",538,640,"","",11081,707,"","",15067,640}
,{86,31,-34080,400,8186,5,15320,593,85.963414,429,0,0.047,"",0.018,"",0,0,"","",{"B-","B-n","B-2n"},{0,60,"",20,""},{"=","=","="},{0,60,"",20,""},6135,447,"","",-11185,721,24883,400,"","",10972,400,2302,499,16138,640,41553,400,8561,565,7074,500,"",""}
,{86,32,-49399.922,437.802,8354.629,5.091,9562.221,437.816,85.946967,470,0,0.226,"",0.021,"",0,1,"","",{"B-","B-n"},{0,45,""},{"=","="},{0,45,""},7394.13,437.81,32048,593,-9510.88,437.81,21103.25,437.81,-31458,665,5717.91,437.81,4347.82,437.82,16840,530,33865.74,437.8,5398,481,4721.26,437.81,-7463,531}
,{86,33,-58962.142,3.45,8456.721,0.04,11541.024,4.267,85.936701533,3.703,0,0.945,"",0.008,"",1,-1,"","",{"B-","B-n","B-2n"},{0,35.5,0,"",""},{"=","=",""},{0,35.5,0,"",""},9251.22,4.68,29452,200,-8456.34,4.21,16670.11,4.62,-26402,298,5380.18,4.32,3844.32,4.62,13127.69,5.08,23784.85,3.46,9897.09,4.68,6878.35,4.21,-4058.62,4.32}
,{86,34,-70503.167,2.52,8581.822,0.029,5129.085,3.972,85.924311733,2.705,0,14.3,"",0.3,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},10698.08,3.19,26932.68,4.04,-7513.02,3.37,12762.5,2.52,-24668.72,4.5,0.99,3.97,6160.85,3.62,14602.99,3.97,14019.92,2.52,6061.2,4.04,4030.21,3.76,-3880.33,3.49}
,{86,35,-75632.252,3.078,8632.365,0.036,7633.414,3.078,85.918805433,3.304,0,55.1,"",0.4,"",1,-1,"","",{"B-"},{0},{"="},{0},13991.8,25.91,24356.63,4.41,-7951.75,4.83,7114.74,3.08,-19732.08,4.35,-2223.24,3.67,5128.1,4.35,10507.59,4.03,3650.84,14.47,11026.28,3.64,4572.33,4.32,-316.53,4.15}
,{86,36,-83265.66564,0.00369,8712.029,0,-518.672,0.2,85.910610626,0.00396,1,"s","","s","",0,1,"","",{},{},{},{},16968.96,0,21895.89,1.96,-8096.7,0.47,1257.42,0,-18141,2.61,-9169.65,0,9856.65,2,11979.17,3.08,-5296.65,3.57,5228.22,25.73,612.1,3.79,-2278.73,3.04}
,{86,37,-82746.993,0.2,8696.901,0.002,1776.096,0.2,85.911167443,0.214,0,1610668.8,"",1555.2,"",2,-1,"","",{"B-","EC"},{0,0.0052,0},{"~","="},{0,0.0052,0},19130.66,2.2,19541.85,25.73,-7673.25,0.99,-3463.9,14.14,-11460.49,3.08,-9715.03,2.82,8650.98,0.2,8555.63,2.01,-13612.94,5.5,10403.15,0.2,2107.7,0.2,1913.12,3.8}
,{86,38,-84523.08935,0.00522,8708.456,0,-5240,14.142,85.909260726,0.00561,1,"s","","s","",0,1,"","",{},{},{},{},20016.15,1.24,16661.7,0,-6356.22,0.01,-6554.07,3.57,-10331.73,2,-14752.28,18.97,11491.13,2.81,9644.73,0.01,-20412.84,3.73,5946.68,2.19,-588.4,2.33,1113.95,0.01}
,{86,39,-79283.089,14.142,8638.428,0.164,-1314.075,14.585,85.914886098,15.182,0,53064,"",72,"",4,-1,"","",{"B+"},{0},{"="},{0},21531.29,14.78,14102.07,14.31,-5520.2,14.46,-10149.03,15.17,-4404.73,14.14,-14179.22,15.54,9512.28,23.66,5468.78,14.42,-27713,300,12077.29,14.2,2378.57,15.71,5433.94,14.33}
,{86,40,-77969.014,3.566,8614.051,0.041,-8834.96,6.552,85.916296815,3.827,0,59400,"",360,"",0,1,"","",{"B+"},{0},{"="},{0},22689.96,6.55,11897.39,3.78,-4383.88,6.97,-13858.77,5.16,-4154.71,4.54,-19760.66,5.43,12865.14,7.35,7415.86,19.3,-38199,400,6636.22,5.58,-899.29,18.97,4474.99,7.71}
,{86,41,-69134.054,5.499,8502.222,0.064,-5023.81,6.642,85.925781535,5.903,0,88,"",1,"",6,1,"","",{"B+"},{0},{"="},{0},24057.97,14.15,9817.56,6.98,-3494.88,7.77,-17564,300,1419.1,19.75,-19695.62,16.76,10925.7,6.86,3247.84,8.46,"","",12998.44,7.77,1641.65,8.46,8718.01,19.42}
,{86,42,-64110.245,3.726,8434.709,0.043,-12540,300,85.931174817,4,0,19.1,"",0.3,"",0,1,"","",{"B+"},{0},{"="},{0},26083,298,7266.5,6.64,-2903.87,11.78,-24340,400,1775.97,7.43,-26332,400,14671.81,16.27,5119.54,5.54,"","",7819.28,13.56,-1690.11,150.95,7447.81,7.43}
,{86,43,-51570,300,8280,3,-11800,500,85.944637,322,0,0.055,"",0.007,"",0,1,"","",{"B+"},{0},{"="},{0},30013,500,4930,300,-1905,424,"","",7420,300,-28692,583,13792,500,1350,300,"","",13311,423,-366,500,11632,336}
,{86,44,-39770,400,8133,5,"","",85.957305,429,0,0.05,"",4e-07,">",0,1,"","",{},{},{},{},"","",178,499,-1825,565,"","",10451,400,"","",16892,640,1209,565,"","",8641,565,-3586,640,12216,566}
,{87,31,-29250,500,8129,6,14828,583,86.968599,537,0,0.01,"",4e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,7,0},{"=","="},{0,7,0},5543,582,"","","","",26368,500,"","",12079,665,3242,640,"","",44642,500,6691,707,7544,640,"",""}
,{87,32,-44078,300,8290,3,11540,300,86.95268,322,0,0.15,"",3e-07,">",2.5,1,"","",{"B-n","B-2n"},{0,1,0},{"=","="},{0,1,0},7098,300,33426,583,-10213,424,22348,300,"","",6813,300,2750,531,17288,500,36631,300,6482,423,4873,361,-6502,500}
,{87,33,-55617.907,2.985,8413.851,0.034,10808.218,3.726,86.940291718,3.204,0,0.492,"",0.025,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,15.4,0,0,0},{"=","=","="},{0,15.4,0,0,0},8571.4,4.28,30347,298,-8785.7,3.96,18273.77,4.35,-28827,400,6813.94,3.9,4727.08,4.56,13506.96,437.81,28979.88,2.98,8216.32,4.77,7394.58,4.35,-5884,200}
,{87,34,-66426.125,2.241,8529.091,0.026,7465.552,3.877,86.928688618,2.405,0,5.5,"",0.14,"",1.5,1,"","",{"B-","B-n"},{0,0.36,0},{"=","="},{0,0.36,0},10155.12,3.44,27880.65,4.35,-7874.61,3.3,14283.4,2.25,-24315.17,437.81,1134.81,3.8,3994.28,3.37,14752.95,4.11,18453.94,2.24,7473.83,3.8,4291.49,3.88,-2631.3,3.88}
,{87,35,-73891.676,3.171,8605.91,0.036,6817.845,3.181,86.920674018,3.404,0,55.65,"",0.12,"",2.5,-1,"","",{"B-","B-n"},{0,2.6,0},{"=","="},{0,2.6,0},11458.84,4.41,25280.47,4.41,-6647.27,4.22,10706.11,3.17,-22218.5,4.68,1302.67,3.17,6330.74,4.41,10677.48,4.04,9126.7,3.37,9232.77,4.1,6920.1,3.72,-2391.71,4.48}
,{87,36,-80709.522,0.246,8675.283,0.003,3888.269,0.246,86.913354759,0.264,0,4578,"",30,"",2.5,1,"","",{"B-"},{0},{"="},{0},15371.83,2.02,22873.83,2.62,-7793.91,3.05,4170.54,0.25,-17495.33,2.53,-6033.85,0.32,5515.17,0.25,12366.24,3.09,-1362.38,4.15,8576.75,3.09,1937.62,25.73,884.6,1.98}
,{87,37,-84597.791,0.006,8710.983,0,282.275,0.006,86.909180531,0.006,0,1.5683792222e+18,"",9.4670778e+15,"",1.5,-1,"","",{"B-"},{0},{"="},{0},18573.09,0.01,20600.26,3.08,-8009,3.79,-1579.41,1.13,-16254.51,3.08,-8146.02,0.01,9922.11,0.2,8621.1,0.01,-10723.3,6.8,7593.35,2,2705.6,0.01,-1168.3,25.73}
,{87,38,-84880.06595,0.0051,8705.236,0,-1861.69,1.128,86.908877496,0.00548,1,"s","","s","",4.5,1,"","",{},{},{},{},19919.42,2.81,17977.68,2,-7314.35,0.01,-5532.93,4.15,-8903.37,0,-13668.29,14.14,8428.29,0.01,9422.04,0.2,-17995.26,2.86,7998.07,0,-257.05,2.19,3205.67,0}
,{87,39,-83018.376,1.128,8674.844,0.013,-3671.239,4.296,86.910876102,1.21,0,287280,"",1080,"",0.5,-1,"","",{"B+"},{0},{"="},{0},21318.89,19,15428.99,1.13,-6372.66,2.59,-9143.89,6.9,-7560.35,1.15,-13120.68,3.74,11806.6,14.19,5784.26,1.13,-25328.33,4.34,8795.71,3.03,2495.25,1.68,2386.99,2.47}
,{87,40,-79347.137,4.146,8623.654,0.048,-5472.651,7.963,86.914817339,4.45,0,6048,"",36,"",4.5,1,"","",{"B+"},{0},{"="},{0},22314.58,7.65,12821.8,5.01,-4974.45,7.99,-12462.33,5.03,-2113.02,4.15,-18284.4,6.88,9449.44,5.47,7353.02,14.74,-33827,400,9205.79,19.41,-588.65,5.97,6948.83,4.33}
,{87,41,-73874.486,6.802,8551.757,0.078,-6989.678,7.378,86.920692472,7.302,0,222,"",6,"",0,0,"","",{"B+"},{0},{"="},{0},23737.44,7.94,10610.3,20.15,-4093.74,19.83,-16184.44,7.99,-1880.37,15.69,-17835.56,7.76,12811.75,8.74,3194.44,7.68,"","",10011.51,9.36,2411.25,8.74,5666.35,8.04}
,{87,42,-66884.808,2.857,8462.424,0.033,-9194.764,5.073,86.928196201,3.067,0,14.1,"",0.3,"",3.5,1,"","",{"B+","B+p"},{0,15,0},{"=","="},{0,15,0},25517.69,16.09,8287.56,7.04,-3398.07,7.04,-21365,400,3795.24,4.57,-23386,300,10845.88,4.7,5039.72,6.2,"","",10105.67,5,-802.04,13.35,10183.28,6.2}
,{87,43,-57690.044,4.192,8347.744,0.048,-12170,400,86.938067187,4.5,0,2.2,"",0.2,"",4.5,1,"","",{"B+"},{0},{"="},{0},27983,400,5988.31,5.86,-2558.88,150.96,"","",4155.04,6.91,-25991,400,14191,300,868.77,5.61,"","",10530.51,16.38,1344,298,9175.08,13.7}
,{87,44,-45520,400,8199,5,"","",86.951132,429,0,0.05,"",1.5e-06,">",0.5,-1,"","",{},{},{},{},30713,640,2588,400,-1605,566,"","",11301,400,"","",13821,565,1239,500,"","",11041,565,-2956,565,14296,499}
,{88,32,-40138,400,8243,5,10582,445,87.95691,429,0,0.1,"",3e-07,">",0,1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},6881,593,"","",-10633,565,23746,400,"","",7409,400,4131,500,18177,640,39553,400,4652,565,4575,499,-9261,640}
,{88,33,-50720,196,8354,2,13164,196,87.94555,210,0,0.27,"",0.15,"",0,0,"","",{"B-","B-n"},{0,30,0},{"=","="},{0,30,0},7900,196,31218,445,-9057,280,19996,196,-28759,537,7635,196,3173,196,13931,358,31889,196,9391,480,7268,196,-5224,357}
,{88,34,-63884.195,3.357,8495.004,0.038,6831.763,4.613,87.931417491,3.604,0,1.53,"",0.06,"",0,1,"","",{"B-","B-n"},{0,0.99,0},{"=","="},{0,0.99,0},9523.66,4.19,29062.22,437.82,-8160.68,4.61,15807.09,4.25,-27095,300,1936.16,4.61,5529.39,4.03,15555.26,4.49,24037.42,3.36,5788.75,4.81,4169,4.55,-5114.37,5.01}
,{88,35,-70715.959,3.171,8563.747,0.036,8975.327,4.106,87.924083291,3.404,0,16.34,"",0.08,"",1,-1,"","",{"B-","B-n"},{0,6.58,0},{"=","="},{0,6.58,0},11226.34,4.41,26331.76,4.68,-7287.31,4.48,11893.04,3.17,-22387.02,4.35,1922.25,3.18,4895.6,4.48,11578.8,3.88,13583.06,3.51,10498.01,4.04,6561.73,4.1,-1880.41,4.41}
,{88,36,-79691.286,2.608,8656.849,0.03,2917.709,2.613,87.914447881,2.8,0,10170,"",68.4,"",0,1,"","",{"B-"},{0},{"="},{0},12568.25,2.61,23766.06,3.63,-6168.48,3.26,8230.33,2.61,-20554.13,3.44,-3164.81,2.61,7053.08,2.62,13088.58,4.11,3937.59,6,6651.77,4.03,3748.24,4.03,-1631.25,3.69}
,{88,37,-82608.995,0.159,8681.115,0.002,5312.623,0.159,87.911315591,0.171,0,1066.38,"",1.08,"",2,-1,"","",{"B-"},{0},{"="},{0},16004.64,0.26,21554.68,3.07,-7250.83,25.73,1690.02,1.51,-16006.29,3.17,-5800.25,0.16,6082.52,0.16,9188.44,0.29,-6435.41,58.81,11367.48,0.16,3735.39,2.01,1612.88,3.07}
,{88,38,-87921.61793,0.00558,8732.595,0,-3622.6,1.5,87.905612255,0.00599,1,"s","","s","",0,1,"","",{},{},{},{},19541.16,0.01,19233.89,0,-7907.2,0,-4292.75,5.4,-14501.07,0.25,-12974.56,1.13,11112.87,0.01,10612.8,0.01,-15235.07,3.82,5536.18,0.2,-890.23,0.01,-794.89,2}
,{88,39,-84299.018,1.5,8682.539,0.017,-670.147,5.608,87.909501276,1.61,0,9212486.4,"",1814.4,"",4,-1,"","",{"B+"},{0},{"="},{0},21158.56,14.22,16129.97,1.51,-6964.97,2.66,-8125.43,58.83,-6990.2,1.5,-13023.2,4.41,9351.96,1.88,6707.92,1.5,-22617.7,149.05,10934.88,1.5,1668.32,3.19,3514.71,1.5}
,{88,40,-83628.871,5.403,8666.033,0.061,-7455.284,58.886,87.910220709,5.8,0,7205760,"",25920,"",0,1,"","",{"EC"},{0},{"="},{0},21802.49,6.47,13683.72,5.4,-5404.22,5.54,-10942.33,6.62,-6037.78,5.4,-17825.7,8.68,12353.05,6.81,7899.47,5.52,-29289,300,6365.02,15.14,-922.69,19.72,3120.81,6.09}
,{88,41,-76173.586,58.81,8572.424,0.668,-3487.042,58.933,87.918224287,63.134,0,870,"",6.6,"",8,1,"","",{"B+"},{0},{"="},{0},23182.17,59.07,11468.44,60.49,-4704.07,58.97,-14492.27,160.22,-444.18,58.82,-17360.1,58.88,10370.42,59.2,4115.42,58.96,-39313,404,12506.23,58.92,1865.66,59.16,7314.94,61.79}
,{88,42,-72686.544,3.819,8523.908,0.043,-11005.229,149.088,87.921967781,4.1,0,480,"",12,"",0,1,"","",{"B+"},{0},{"="},{0},24718.93,5.34,9295.47,5.22,-3689.77,6.69,-18347,300,-628.38,5.64,-23067.82,5.67,13873.05,4.77,6101.03,7.8,"","",7158.32,6.69,-1542.81,5.6,6135.05,7.48}
,{88,43,-61681.315,149.039,8389.958,1.694,-7342,335,87.933782381,160,0,6.4,"",0.8,"",5,1,"","",{"B+"},{0},{"="},{0},26254,335,7125.2,149.14,-2887.51,149.61,-24821,426,4904.2,149.19,-24232,426,12062.59,149.1,2085.48,149.07,"","",13139.74,149.09,692.49,149.88,10244.76,149.1}
,{88,44,-54340,300,8298,3,-17479,500,87.941664,322,0,1.3,"",0.3,"",0,1,"","",{"B+"},{0},{"="},{0},30712,500,4807,300,-2594,423,"","",5256,300,"","",16891,500,3939,300,"","",7941,424,-3626,500,8817,300}
,{88,45,-36860,400,8090,5,"","",87.960429,429,0,0.001,"","s","",0,0,"","",{},{},{},{},"","",-132,500,-1585,565,"","",13541,400,"","","","",-1371,565,"","",13621,565,-1046,640,14636,565}
,{89,32,-33729,400,8169,4,13069,499,88.96379,429,0,0.05,"",3e-07,">",1.5,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},5794,500,"","",-10924,640,25263,400,"","",8919,445,1663,565,"","",42806,400,6231,640,5214,565,"",""}
,{89,33,-46798,298,8307,3,12194,298,88.94976,320,0,0.2,"",1.5e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},7323,298,32126,582,-9374,422,21476,298,"","",9015,298,4150,357,13949,499,34914,298,7991,423,7466,530,-7072,499}
,{89,34,-58992.391,3.729,8435.279,0.042,9281.872,4.951,88.936669059,4.003,0,0.43,"",0.05,"",2.5,1,"","",{"B-","B-n"},{0,7.8,0},{"=","="},{0,7.8,0},8708.9,4.35,29492,300,-8293.89,5.27,17543.39,4.3,-26143,400,3652.25,4.89,3179.51,5.01,15562,196,27216.63,3.73,7336.32,4.77,4833.81,5.08,-3946.07,437.82}
,{89,35,-68274.263,3.264,8530.779,0.037,8261.522,3.904,88.926704559,3.504,0,4.357,"",0.022,"",1.5,-1,"","",{"B-","B-n"},{0,13.8,0},{"=","="},{0,13.8,0},10525.22,4.55,27234.3,4.42,-7510.03,4.48,13438.13,6.33,-24843,196,3345.71,4.18,5629.62,4.55,11679.04,4.68,19434.09,3.64,8862.67,3.95,7092.96,4.12,-3665.72,4.74}
,{89,36,-76535.785,2.142,8614.815,0.024,5176.604,5.834,88.91783545,2.3,0,189,"",2.4,"",0,0,"","",{"B-"},{0},{"="},{0},11968.9,2.16,24687.6,3.1,-6547.06,3.38,9673.23,2.14,-19940.56,3.98,-1998.11,2.15,4915.82,3.38,13108.8,3.83,8339.78,3.75,8066.7,3.83,3960.52,3.75,-386.22,3.31}
,{89,37,-81712.388,5.427,8664.189,0.061,4496.628,5.427,88.912278137,5.825,0,919.2,"",6,"",1.5,-1,"","",{"B-"},{0},{"="},{0},13257.23,5.43,22398.65,6.29,-5561.84,6.24,5995.96,5.66,-18285.4,6.29,-1862.09,5.43,7174.71,5.43,9310.07,6.02,-1087.18,24.25,9707.94,5.43,6417.33,5.43,-433.73,6.24}
,{89,38,-86209.017,0.092,8705.922,0.001,1499.336,1.615,88.907450808,0.098,0,4368643.2,"",2160,"",2.5,1,"","",{"B-"},{0},{"="},{0},17471.58,0.09,20077.44,0.26,-7153.6,2,-1333.46,3.08,-13806.7,2.61,-9981.32,1.5,6358.72,0.09,10888.99,0.18,-11194.08,3.91,9099.58,0.09,1402.03,0.22,2703.05,0.09}
,{89,39,-87708.352,1.612,8713.978,0.018,-2832.792,2.776,88.905841205,1.73,1,"s","","s","",0.5,-1,"","",{},{},{},{},20832.61,1.97,17688.5,1.61,-7965.94,1.61,-7083.14,23.67,-12388.33,1.62,-12150.8,5.64,11480.65,2.2,7075.71,1.61,-20313.5,4.15,7882.52,1.61,1678.79,1.61,685.04,1.62}
,{89,40,-84875.561,3.083,8673.359,0.035,-4250.351,23.743,88.908882332,3.31,0,282276,"",432,"",4.5,1,"","",{"B+"},{0},{"="},{0},21671.06,5.17,14573.44,3.08,-6197.2,4.17,-9860.63,4.98,-4242.91,3.08,-16773.29,58.89,9318.01,6.22,7865.51,3.43,-26615,298,8853.62,3.28,-728.42,14.47,5293.93,3.08}
,{89,41,-80625.209,23.631,8616.812,0.266,-5610.275,23.953,88.913445272,25.369,0,7308,"",252,"",4.5,1,"","",{"B+"},{0},{"="},{0},22893.36,24.59,12184.77,23.66,-5208,30.3,-13230.36,23.94,-3615.16,23.68,-16009.98,23.94,12522.94,63.38,4285.31,24.24,-34765,361,9432.73,23.99,2207.86,23.9,4304.28,27.54}
,{89,42,-75014.935,3.912,8544.984,0.044,-7620.087,5.467,88.91946815,4.2,0,126.6,"",6,"",4.5,1,"","",{"B+"},{0},{"="},{0},24272.76,4.84,10245.74,5.7,-4264.66,7.53,-16755,298,1324.97,6.67,-21404.94,149.09,10399.71,5.47,6130.32,58.94,"","",9570.36,7.85,-1016.83,6.75,8600.48,5.29}
,{89,43,-67394.848,3.819,8450.575,0.043,-9135,298,88.92764865,4.1,0,12.8,"",0.9,"",4.5,1,"","",{"B+"},{0},{"="},{0},25847.44,5.67,8098.3,7.8,-3540.09,5.6,-21534,361,1489.77,58.93,-21127,300,13784.85,149.09,1997.27,5.4,"","",10200.77,4.77,1579.45,5.34,7385.61,6.69}
,{89,44,-58260,298,8339,3,-12400,468,88.937455,320,0,1.5,"",0.2,"",4.5,1,"","",{"B+","B+p"},{0,3.1,0},{"=","="},{0,3.1,0},28883,499,5953,298,-3175,298,"","",7137,298,-29471,499,11992,423,3868,333,"","",10141,298,-1826,423,11496,298}
,{89,45,-45861,361,8191,4,"","",88.950767,387,0,0.01,"",1.5e-06,">",3.5,1,"","",{},{},{},{},"","",2749,361,-2436,538,"","",8532,390,"","",17072,538,-1190,200,"","",10370,538,-1226,538,11356,469}
,{90,32,-29221,500,8118,6,12109,640,89.96863,537,0,0.05,"",4e-07,">",0,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},5226,640,"","","","",26579,599,"","",9506,582,3563,640,"","",45738,500,"","",4893,707,"",""}
,{90,33,-41330,400,8244,4,14470,518,89.95563,429,0,0.08,"",3e-07,">",0,0,"","",{"B-n","B-2n"},{0,3,0},{"=","="},{0,3,0},6753,445,"","",-9676,565,22670,400,"","",9591,400,2603,499,14890,565,38034,400,9518,565,7612,500,-6434,640}
,{90,34,-55800.217,329.749,8395.766,3.664,8200.081,329.766,89.940096,354,0,0.21,"",0.08,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},8058.66,329.77,30240,518,-8825.21,548.09,19159.03,329.75,-29360,518,4402.73,329.77,4879.14,329.77,16291,445,30147.91,329.76,5630,383,4681.74,329.76,-6076,446}
,{90,35,-64000.298,3.357,8478.186,0.037,10958.952,3.84,89.93129285,3.604,0,1.91,"",0.01,"",0,0,"","",{"B-","B-n"},{0,25.2,0},{"=","="},{0,25.2,0},9426.97,4.61,27858,196,-7463.07,4.81,15364.11,7.3,-24491,298,4464.17,3.98,3797.35,4.68,12296.88,5.01,22493.76,3.72,10594.7,4.74,7289.88,4.03,-2735.99,4.49}
,{90,36,-74959.25,1.863,8591.259,0.021,4405.154,6.746,89.91952793,2,0,32.32,"",0.09,"",0,1,"","",{"B-"},{0},{"="},{0},11410.6,3.21,25653,3.84,-6881,3.13,10988.88,2.83,-23255.83,4.17,-1318.18,5.74,6494.78,2.84,13973.96,3.76,13813.29,1.87,6467.51,3.68,3796.48,3.68,-2886.72,2.91}
,{90,37,-79364.404,6.484,8631.512,0.072,6583.723,6.544,89.914798803,6.96,0,158,"",5,"",0,-1,"","",{"B-"},{0},{"="},{0},12898.04,6.49,23226.39,7.22,-6157.07,7.18,7129.66,6.52,-18379.11,7.26,-1226.7,6.48,5723.33,8.46,10117.59,6.83,3297.12,7.28,11037.69,6.99,6209.17,6.49,173.67,7.22}
,{90,38,-85948.127,2.124,8695.972,0.024,545.934,1.406,89.907730885,2.28,0,908523899.54,"",1893415.56,"",0,1,"","",{"B-"},{0},{"="},{0},14169.14,2.12,20834.78,3.36,-5107.38,2.12,2824.41,2.12,-16701.31,3.02,-6311.09,1.41,7810.43,2.13,11524.71,5.83,-5775.62,4.06,7371.67,2.13,3513.72,2.12,407.8,2.14}
,{90,39,-86494.062,1.611,8693.345,0.018,2278.474,1.609,89.9071448,1.729,0,230400,"",756,"",2,-1,"","",{"B-"},{0},{"="},{0},18337.68,2.2,18463.01,1.62,-6171.98,1.62,-3832.54,3.69,-12070.64,5.66,-9689.82,2.78,6857.03,0.1,7574.02,1.61,-15769.37,1.91,12138.36,1.61,3250.06,1.61,3750.13,1.61}
,{90,40,-88772.535,0.118,8709.969,0.001,-6111.016,3.316,89.904698758,0.126,1,"s","","s","",0,1,"","",{},{},{},{},21286.3,5.4,15428.86,0.12,-6674.36,0.12,-8600.03,3.46,-9852.49,0.15,-16218.64,23.63,11968.29,3.08,8353.15,1.61,-23888.74,3.73,6237.29,1.5,-890.1,1.13,1753.93,0.12}
,{90,41,-82661.519,3.317,8633.376,0.037,-2489.016,3.316,89.911259204,3.561,0,52560,"",180,"",8,1,"","",{"B+"},{0},{"="},{0},22630.57,58.9,12940.44,3.64,-5803.35,14.53,-11936.83,3.47,-2242.14,3.69,-15717.9,5.13,10107.63,23.86,5074.93,4.53,-30962,300,11678.16,6.34,1549.67,5.31,6003.26,3.5}
,{90,42,-80172.503,3.463,8597.028,0.038,-9447.816,3.611,89.913931272,3.717,0,20016,"",324,"",0,1,"","",{"B+"},{0},{"="},{0},23628.59,5.16,11121.57,6.42,-4628.4,4.97,-15288.71,5.09,-2585.91,4.64,-20848.97,5.16,13228.89,5.22,6836.26,23.88,-40463,400,6711.89,58.91,-1433.96,7.63,4821.04,5.4}
,{90,43,-70724.687,1.025,8483.359,0.011,-5840.895,3.869,89.924073921,1.1,0,49.2,"",0.4,"",8,1,"","",{"B+"},{0},{"="},{0},25186.01,149.04,9129.04,58.82,-4015.55,5.59,-19025,300,2611.55,23.65,-20536,298,11401.16,3.95,2998.72,4.04,"","",12672.66,3.95,1024.18,3.04,8796.2,6.88}
,{90,44,-64883.792,3.73,8409.768,0.041,-13184,300,89.930344379,4.004,0,11,"",3,"",0,1,"","",{"B+"},{0},{"="},{0},26687,300,6775.19,5.34,-3198.46,5.27,-25174,400,2842.17,5.41,-27094,361,14695,298,4777.92,5.34,"","",7508.33,149.09,-2329.69,5.61,7647.42,4.7}
,{90,45,-51700,300,8255,3,-11990,500,89.944498,322,0,0.015,"",0.007,"",0,1,"","",{"B+"},{0},{"="},{0},30982,500,4596,335,-2554,424,"","",8406,300,"","",13910,469,728,423,"","",13351,424,-1315,500,11637,300}
,{90,46,-39710,400,8113,4,"","",89.95737,429,0,0.01,"",4e-07,">",0,1,"","",{},{},{},{},"","",-52,500,-2364,565,"","",11262,499,"","","","",1138,538,"","",7861,565,"","",11457,565}
,{91,33,-36896,400,8193,4,13684,589,90.96039,429,0,0.05,"",3e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,3,0},{"=","="},{0,3,0},6241,499,"","",-10072,640,24211,400,"","",10832,518,3637,565,14964,640,40849,400,7544,565,8106,565,"",""}
,{91,34,-50580.124,433.145,8334.837,4.76,10527.169,433.159,90.9457,465,0,0.27,"",0.05,"",0.5,1,"","",{"B-","B-n","B-2n"},{0,21,"","",""},{"=","=",""},{0,21,"","",""},7730.37,433.16,31429,589,-8927,527,20393.84,433.15,-28648,662,5348.86,433.16,2851.22,544.38,16539,589,33071.8,433.18,6929,526,5004,475,-4796,589}
,{91,35,-61107.294,3.544,8441.923,0.039,9866.671,4.19,90.934398618,3.804,0,0.543,"",0.004,"",2.5,-1,"","",{"B-","B-n"},{0,19.5,0},{"=","="},{0,19.5,0},8975.66,4.81,28887,298,-7914.3,4.63,16637.74,8.57,-27066,400,5780.64,4,5178.31,4.88,12596.05,329.77,25244,3.99,8595.9,5.14,7640.96,4.88,-4741,196}
,{91,36,-70973.965,2.236,8541.751,0.025,6771.072,8.115,90.92380631,2.4,0,8.57,"",0.04,"",0,0,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},10580.81,3.1,26559.51,4.35,-6972.76,3.17,12677.96,5.89,-22462.72,329.76,319.12,6.86,4086.03,2.91,14262.64,4.03,16921.6,2.24,8011.1,3.96,4606.05,3.88,-1443.37,4.03}
,{91,37,-77745.037,7.801,8607.561,0.086,5906.89,8.873,90.916537265,8.375,0,58.2,"",0.3,"",0,0,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},12175.28,9.32,24048.71,8.46,-6278.28,8.42,8606.26,7.95,-21033.71,8.49,131.77,8.09,6451.95,10.14,10074.76,8.02,8892.96,8.33,9501.55,8.09,6810.3,8.23,-1382.68,8.42}
,{91,38,-83651.927,5.453,8663.875,0.06,2699.369,5.247,90.910195958,5.853,0,34740,"",216,"",2.5,1,"","",{"B-"},{0},{"="},{0},13585.54,5.45,21694.08,5.86,-5367.32,5.46,4243.64,5.45,-15981.65,5.76,-5229.18,5.69,5775.12,5.85,11576.49,8.47,-1443.11,8.29,8771.27,7.67,3821.12,5.46,1685.76,6.04}
,{91,39,-86351.295,1.843,8684.941,0.02,1544.271,1.84,90.907298066,1.978,0,5055264,"",5184,"",0.5,-1,"","",{"B-"},{0},{"="},{0},14785.58,2.45,19216.85,5.73,-4178.42,1.84,286.71,3.46,-14275.86,6.74,-5650.08,1.85,7928.55,2.45,7692.14,2.81,-10364.65,3,10568.53,1.85,6434.38,1.84,1904.1,1.85}
,{91,40,-87895.566,0.105,8693.314,0.001,-1257.565,2.924,90.905640223,0.112,1,"s","","s","",2.5,1,"","",{},{},{},{},19162.64,3.08,16264.49,0.14,-5440.42,0.1,-5686.74,6.24,-9236.41,2.13,-13305.36,3.32,7194.35,0.15,8690.47,1.61,-19655.74,2.22,10523.59,1.62,1267.51,1.5,5672.45,0.1}
,{91,41,-86638.001,2.926,8670.897,0.032,-4429.18,6.744,90.906990274,3.141,0,21458709680,"",4102400380,"",4.5,1,"","",{"EC","e+"},{0,0.0138,0},{"~","="},{0,0.0138,0},22155.43,23.81,13507.59,3.34,-6044.54,3.14,-10651.35,3.76,-7432.91,3.34,-14536.82,4.53,12047.8,4.42,5154.44,2.93,-28068,298,8948.37,4.25,1854.92,6.14,3307.42,3.29}
,{91,42,-82208.821,6.238,8613.628,0.069,-6222.175,6.671,90.911745195,6.696,0,929.4,"",0.6,"",4.5,1,"","",{"B+"},{0},{"="},{0},23336.52,7.36,11911.2,6.96,-5286.6,7.49,-13969,6.62,-725.26,6.24,-19555.45,6.32,10107.64,7.13,6836.27,7.07,-36279,401,9127.19,24.44,-1171.18,59.14,7066.45,8.25}
,{91,43,-75986.646,2.363,8536.655,0.026,-7746.824,3.242,90.918424975,2.536,0,188.4,"",1.2,"",0,0,"","",{"B+"},{0},{"="},{0},24734.43,4.49,9939.38,23.75,-4537.08,7.2,-17417,298,-614.1,4.07,-19174.17,4.42,13333.28,2.58,3103.11,4.19,"","",9739.09,4.57,1563.95,4.49,5833.34,58.86}
,{91,44,-68239.823,2.221,8442.928,0.024,-9670,298,90.926741532,2.384,0,8,"",0.4,"",4.5,1,"","",{"B+"},{0},{"="},{0},26122,298,7802.83,4.5,-3779.93,3.62,-22310,401,4643.71,4.11,-24611,300,11427.35,4.34,4804.11,2.45,"","",9865.83,4.42,-1694.45,149.06,10093.12,4.42}
,{91,45,-58570,298,8328,3,-12639,499,90.937123,320,0,1.6,"",0.15,"",3.5,1,"","",{"B+","B+p"},{0,1.3,0},{"=","="},{0,1.3,0},28852,468,5753,298,-3304,298,"","",4866,298,-26931,499,14941,423,975,298,"","",10402,422,634,423,8758,333}
,{91,46,-45930,401,8181,4,"","",90.950692,430,0,0.01,"",1.5e-06,">",3.5,1,"","",{},{},{},{},"","",2248,499,-2835,566,"","",11665,401,"","",14292,566,1519,500,"","",10641,539,-4206,566,14056,500}
,{92,33,-30981,500,8127,5,15742,640,91.96674,537,0,0.03,"",3e-07,">",0,0,"","",{"B-n","B-2n"},{0,40,0},{"=","="},{0,40,0},5794,640,"","","","",25251,500,"","",11527,662,2156,640,"","",43791,500,8950,707,7612,640,"",""}
,{92,34,-46724,400,8290,4,9509,400,91.94984,429,0,0.1,"",3e-07,">",0,1,"","",{"B-n","B-2n"},{0,0,0},{"=","="},{0,0,0},7066,518,32081,640,-9011,565,22046,400,"","",6312,400,4215,589,17116,565,36144,400,5317,565,4939,499,-7348,565}
,{92,35,-56232.805,6.709,8384.911,0.073,12536.514,7.232,91.939631597,7.202,0,0.314,"",0.016,"",2,-1,"","",{"B-","B-n","B-2n"},{0,33.1,0,"",""},{"=","=",""},{0,33.1,0,"",""},8375.14,7.5,29480,400,-7938,196,18539.63,9.08,-26625,400,6669.84,7.07,3196.83,7.58,12941.65,433.2,28583.69,11.33,10278.22,329.82,7623.64,7.67,-3788,298}
,{92,36,-68769.32,2.701,8512.674,0.029,6003.118,6.692,91.926173094,2.9,0,1.84,"",0.008,"",0,1,"","",{"B-","B-n"},{0,0.0332,0},{"=","="},{0,0.0332,0},9952.7,3.28,27547.04,329.76,-7310.04,4.31,14098.04,4.36,-25478.17,433.15,904.4,8.26,5866.67,3.51,14951,4.46,19689.71,2.7,5941.78,4.31,4369,4.24,-4130.53,4.61}
,{92,37,-74772.438,6.123,8569.422,0.067,8094.923,6.419,91.919728481,6.573,0,4.48,"",0.03,"",0,-1,"","",{"B-","B-n"},{0,0.0107,0},{"=","="},{0,0.0107,0},11550.67,8.92,25350.08,6.98,-6481.39,6.9,10044.05,10.88,-20954.11,7.07,808.17,7.58,5098.72,9.82,11087.44,6.52,11680.85,6.38,10897.62,6.4,6627.4,6.49,-851.77,6.94}
,{92,38,-82867.361,3.423,8648.906,0.037,1949.132,9.384,91.911038224,3.675,0,9399.6,"",61.2,"",0,1,"","",{"B-"},{0},{"="},{0},13061.87,4.03,22486.05,3.9,-5600.99,4.3,5591.67,3.42,-19182.37,4.09,-4587.38,3.88,7286.75,6.36,12411.29,8.51,3941.22,3.43,7207.85,7.33,3709.08,6.42,-685.17,4.04}
,{92,39,-84816.492,9.127,8661.589,0.099,3642.535,9.127,91.908945745,9.798,0,12744,"",36,"",2,-1,"","",{"B-"},{0},{"="},{0},14465.06,9.27,20030.03,11.2,-4632.41,9.13,1636.8,9.3,-14360.43,12,-4992.24,9.13,6536.51,9.31,8453.54,10.62,-5890.8,9.64,11842.44,9.37,6256.58,9.13,2542.3,10.62}
,{92,40,-88459.028,0.102,8692.678,0.001,-2005.736,1.782,91.905035322,0.109,1,"s","","s","",0,1,"","",{},{},{},{},15829.13,0.15,17088.84,2.13,-2962.33,0.1,-1650.45,0.19,-12096.07,5.45,-9892.34,2.93,8634.78,0.09,9396.7,1.84,-14157.83,2.72,8745.84,1.61,4113.38,1.62,3396.39,0.14}
,{92,41,-86453.292,1.785,8662.372,0.019,355.284,1.791,91.907188568,1.915,0,1.0950253322e+15,"",75736622400000,"",7,1,"","",{"B+"},{0},{"="},{0},19934.41,3.77,14537.17,2.4,-4579.19,2.33,-7527.6,3.58,-7390.97,2.56,-12315.79,6.49,7886.61,3.43,5846.7,1.78,-23454.2,4.73,13030.05,1.79,3286.32,3.56,6901.46,2.4}
,{92,42,-86808.576,0.157,8657.73,0.002,-7882.884,3.106,91.906807155,0.168,1,"s","","s","",0,1,"","",{},{},{},{},22778.71,3.47,12613.98,0.2,-5604.62,5.41,-12507.38,2.72,-6201.98,0.19,-18893.25,2.37,12671.07,6.24,7459.55,2.93,-32229,300,6563.75,3.32,-1319.31,23.63,3713.39,3.09}
,{92,43,-78925.693,3.102,8563.543,0.034,-4624.492,4.125,91.915269779,3.33,0,255,"",9,"",0,0,"","",{"B+"},{0},{"="},{0},24343.64,3.27,10842.11,4.54,-5177.02,58.89,-15926.61,5.37,423.34,4.26,-18757.19,3.82,11010.36,3.9,4005.84,6.97,-41795,500,11957.62,4.65,953.3,4.99,7345.92,23.83}
,{92,44,-74301.201,2.718,8504.773,0.03,-11302.114,5.153,91.920234375,2.917,0,219,"",3,"",0,1,"","",{"B+"},{0},{"="},{0},25560.04,4.62,8706.64,4.4,-4039.57,4.69,-19721,300,618.65,6.8,-23803,298,14132.7,3.51,5603.53,3.6,"","",7134.29,2.9,-2042.3,4.69,6360.14,4.76}
,{92,45,-62999.087,4.378,8373.42,0.048,-8419,300,91.932367694,4.7,0,4.66,"",0.25,"",6,1,"","",{"B+","B+p"},{0,1.9,0},{"=","="},{0,1.9,0},27442,300,6852.34,4.5,-3742.69,149.1,-25869,500,5698.59,4.97,-25140,401,12501,298,2048.23,4.91,"","",12595.51,5.75,125,298,10042.16,5.81}
,{92,46,-54580,300,8273,3,-17450,583,91.941406,322,0,1.1,"",0.3,"",0,1,"","",{"B+"},{0},{"="},{0},31013,500,4274,300,-2665,424,"","",6371,300,"","",16721,500,3299,423,"","",7831,424,-3855,469,9327,423}
,{92,47,-37130,500,8075,5,"","",91.960139,537,0,0.001,"",4e-07,">",0,0,"","",{},{},{},{},"","",8,583,-2695,640,"","",14150,582,"","","","",-1511,641,"","",13290,640,"","",14377,617}
,{93,34,-40716,400,8223,4,12175,588,92.95629,429,0,0.05,"",3e-07,">",0.5,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},6278,589,"","",-9411,565,23420,400,"","",7446,400,2063,565,17023,640,39370,400,6892,565,5479,565,-5848,640}
,{93,35,-52890.23,430.816,8345.598,4.632,11245.765,430.823,92.94322,462.5,0,0.152,"",0.008,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,55,"","",""},{"=","=",""},{0,55,"","",""},7925.57,430.83,30572,588,-8517,524,19729.67,430.89,-29198,660,7807.77,430.82,4728.74,430.87,13455,588,31336.93,430.94,8400.7,610.91,7774.04,542.53,-5913,588}
,{93,36,-64135.994,2.515,8458.108,0.027,8483.907,8.224,92.931147174,2.7,0,1.286,"",0.01,"",0.5,1,"","",{"B-","B-n"},{0,1.95,0},{"=","="},{0,1.95,0},9304.66,3.37,28133.81,433.15,-7568.52,4.5,15949.84,7.96,-24701,400,2565.13,6.62,3437.99,3.69,15192.16,7.16,22986.04,2.56,7682.11,4.35,4728.36,4.19,-2689.38,329.76}
,{93,37,-72619.901,7.83,8540.92,0.084,7465.938,8.876,92.922039325,8.406,0,5.84,"",0.02,"",2.5,-1,"","",{"B-","B-n"},{0,1.39,0},{"=","="},{0,1.39,0},11017.5,10.73,26090.55,8.59,-6770.55,8.48,11607.26,12.68,-23676.07,10.31,2176.14,8.55,5918.78,9.93,11139.55,8.28,14592.94,7.97,9064.87,8.14,7203.4,8.05,-2973.2,8.52}
,{93,38,-80085.838,7.554,8612.787,0.081,4141.319,11.697,92.914024311,8.109,0,445.8,"",1.8,"",2.5,1,"","",{"B-"},{0},{"="},{0},12576.55,9.3,23689.81,7.88,-5974.97,7.85,7036.19,7.57,-18605.49,8.02,-3340.66,11.85,5289.79,8.29,12602.37,9.72,6721.23,7.56,8370,10.75,4142.62,9.96,519.81,7.78}
,{93,39,-84227.157,10.488,8648.905,0.113,2894.875,10.483,92.909578422,11.259,0,36648,"",288,"",0.5,-1,"","",{"B-"},{0},{"="},{0},14018.5,10.65,21060.06,13.05,-4939.68,11.81,2985.68,10.59,-16743.69,12.14,-3839.45,10.49,7481.98,13.9,8648.77,11.03,-621.05,10.54,10135.58,11.82,6585.03,10.7,783.65,12.33}
,{93,40,-87122.032,0.457,8671.62,0.005,90.806,1.484,92.906470646,0.49,0,50806650860000,"",1577846300000,"",2.5,1,"","",{"B-"},{0},{"="},{0},15369.1,0.46,18048.05,5.47,-3337.93,0.47,-314.96,0.49,-11543.64,3.45,-8740.06,1.82,6734.32,0.45,9594.51,9.14,-9905.32,2.11,9940.07,1.9,4236.08,1.67,4472.5,2.17}
,{93,41,-87212.838,1.491,8664.184,0.016,-405.769,1.501,92.906373161,1.6,1,"s","","s","",4.5,1,"","",{},{},{},{},16717.47,3.28,15439.48,2.37,-1929.4,2.2,-3606.73,1.8,-9685.32,9.25,-8475.58,1.5,8830.86,1.99,6042.78,1.49,-18201.04,3.02,11393.53,1.49,6423.75,1.5,4927.62,2.19}
,{93,42,-86807.069,0.181,8651.409,0.002,-3200.963,1.004,92.906808773,0.193,0,126227704000,"",25245540800,"",2.5,1,"","",{"EC"},{0},{"="},{0},20740.88,6.24,13489.44,0.21,-4356.42,3.09,-9590.36,2.07,-5637.01,0.21,-15952.69,3.11,8069.81,0.09,7642.75,1.79,-27806,300,10541.74,2.93,718.51,3.32,7611.87,0.22}
,{93,43,-83606.106,1.012,8608.577,0.011,-6389.393,2.299,92.910245149,1.086,0,9900,"",180,"",4.5,1,"","",{"B+"},{0},{"="},{0},23762.09,2.57,11546.05,3.1,-5405.81,23.65,-14594.31,2.82,-4441.78,2.05,-17376.22,2.9,12751.73,3.26,4086.5,1,-37339,401,9313.52,6.32,1430.45,3.61,4701.82,3.47}
,{93,44,-77216.713,2.065,8531.462,0.022,-8204.913,3.343,92.917104444,2.216,0,59.7,"",0.6,"",0,0,"","",{"B+"},{0},{"="},{0},25119.52,3.03,9585.83,6.57,-4626.69,4.42,-18216,300,2302.89,2.07,-22288.94,4.84,10986.83,3.41,5579.99,3.73,"","",9480.74,3.14,-1627.97,2.3,8602.19,4.03}
,{93,45,-69011.8,2.629,8434.825,0.028,-10011,301,92.925912781,2.821,0,13.9,"",1.6,"",4.5,1,"","",{"B+"},{0},{"="},{0},26585,298,7603.09,3.53,-4041.87,4.64,-22744,401,2624.92,4.07,-22503,300,14084.03,5.11,1999.57,3.78,"","",9938.83,3.44,736.05,4.56,7359.29,2.82}
,{93,46,-59001,300,8319,3,-12734,501,92.93666,323,0,1.15,"",0.05,"",4.5,1,"","",{"B+","B+p"},{0,7.5,0},{"=","="},{0,7.5,0},29213,501,5339,300,-3166,423,"","",8011,301,-29942,584,12492,425,3291,301,"","",10279,423,-2437,425,11529,301}
,{93,47,-46267,401,8173,4,"","",92.95033,430,0,0.02,"",1.5e-06,">",4.5,1,"","",{},{},{},{},"","",2276,499,-2832,539,"","",9443,401,"","",17208,641,-1024,500,"","",10374,566,-1694,566,11079,500}
,{94,34,-36803,500,8180,5,10597,583,93.96049,537,0,0.02,"",3e-07,">",0,1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},6222,640,"","",-10007,707,24544,500,"","",8016,660,4159,640,"","",42042,500,4889,707,4957,640,"",""}
,{94,35,-47400,300,8284,3,13948,300,93.949114,322,0,0.07,"",0.02,"",2,-1,"","",{"B-","B-n","B-2n"},{0,68,"",3,0},{"=","=","="},{0,68,"",3,0},7310,300,30996,583,-8495,500,21163,300,"","",8665,300,2581,525,13973,500,34951,300,10035,500,8044,527,-4857,500}
,{94,36,-61347.772,12.109,8424.331,0.129,7215.013,12.278,93.934140454,13,0,0.212,"",0.005,"",0,1,"","",{"B-","B-n"},{0,1.11,0},{"=","="},{0,1.11,0},8721.09,12.41,29202,400,-7972.47,329.97,17497.94,12.22,-27921,400,3200.81,14.42,5283.09,12.37,15746.51,430.99,25921.55,12.11,5595.84,13.84,4623.58,12.62,-5121.25,433.31}
,{94,37,-68562.785,2.029,8492.764,0.022,10282.926,2.623,93.926394818,2.177,0,2.702,"",0.005,"",0,0,"","",{"B-","B-n"},{0,10.5,0},{"=","="},{0,10.5,0},9932.98,6.44,26907.92,7.01,-6987.4,3.92,13788.68,6.69,-22961.53,430.82,3451.74,7.82,4014.2,8.09,11715.76,3.23,17806.28,2.52,10917.34,3.38,7275.23,3.02,-1809.09,4.08}
,{94,38,-78845.711,1.663,8593.834,0.018,3505.752,6.422,93.915355643,1.785,0,75.3,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},12120.98,3.81,24654.33,3.17,-6311.38,2.5,8423.61,1.67,-21998.69,3.02,-2689.87,10.62,6831.19,7.73,13514.78,8,9568.35,1.67,6637.53,6.34,3763.38,7.98,-2225.34,2.79}
,{94,39,-82351.463,6.38,8622.806,0.068,4917.859,6.38,93.911592063,6.849,0,1122,"",6,"",2,-1,"","",{"B-"},{0},{"="},{0},13677.6,11.14,22156.97,8.84,-5411.97,9.1,4017.6,6.55,-17020.53,10.1,-3300.75,6.4,6195.62,12.28,9554.59,9.89,1806.85,7.57,11226.7,7.24,6164.52,8.39,1039.98,10.08}
,{94,40,-87269.322,0.164,8666.801,0.002,-900.26,1.5,93.906312524,0.175,1,"s","","s","",0,1,"","",{},{},{},{},14952.93,0.19,18979.9,3.43,-3746.11,2.13,1144.74,0.22,-14472.45,7.56,-8127.8,1.5,8218.61,0.49,10331.14,10.49,-4685.73,3.15,8257.98,9.13,3946.03,1.85,2029.01,5.46}
,{94,41,-86369.062,1.491,8648.901,0.016,2045.002,1.494,93.907278992,1.601,0,643761290400,"",12622770400,"",6,1,"","",{"B-"},{0},{"="},{0},16058.4,1.99,16130.51,9.25,-2299.92,2.2,-2210.75,4.33,-9430.88,10.59,-7633.31,1.5,7227.54,0.08,6536,1.48,-13461.45,3.69,12800.77,1.49,6390.56,1.49,5628.63,2.37}
,{94,42,-88414.065,0.141,8662.333,0.002,-4255.748,4.069,93.905083592,0.151,1,"s","","s","",0,1,"","",{},{},{},{},17748.12,0.21,14532.98,0.17,-2066.45,0.18,-5830.47,3.15,-8581,0.48,-12879.28,1.02,9678.31,0.23,8490.2,1.49,-22311.8,4.28,8750.03,1.79,3087.99,2.93,5127.9,0.18}
,{94,43,-84158.317,4.071,8608.736,0.043,-1574.726,5.143,93.909652325,4.37,0,17580,"",60,"",7,1,"","",{"B+"},{0},{"="},{0},21375.26,5.12,12282.97,4.44,-3921.71,5.25,-11250.7,5.29,-4234.45,4.33,-15012.92,4.56,8623.53,4.2,4640.22,4.08,-31749,400,13361.07,4.07,2914.56,7.45,8126.09,5.01}
,{94,44,-82583.591,3.143,8583.661,0.033,-9675.978,4.615,93.911342863,3.374,0,3108,"",36,"",0,1,"","",{"B+"},{0},{"="},{0},24425.02,4.16,10352.96,3.15,-4836,4.68,-16481.32,5.32,-3065.49,3.15,-21643.11,4.1,13438.2,3.76,6266.46,3.3,-42444,500,7052.91,4.42,-1732.89,3.93,5271.63,6.99}
,{94,45,-72907.613,3.379,8472.402,0.036,-6805.345,5.459,93.921730453,3.627,0,70.6,"",0.6,"",4,1,"","",{"B+","B+p"},{0,1.8,0},{"=","="},{0,1.8,0},26051.16,5.53,8559.86,4.59,-4607.84,3.53,-20498,400,3409.52,3.53,-21978,301,11967.13,4.28,2979.87,3.96,"","",12104.39,4.34,196.26,4.04,8725.43,4.12}
,{94,46,-66102.268,4.287,8391.682,0.046,-13693,400,93.929036292,4.602,0,9,"",0.5,"",0,1,"","",{"B+"},{0},{"="},{0},27665,300,6379.01,5.08,-3643.39,5.68,-25962,500,3825.47,4.76,-27906,401,15173,300,4379.44,5.03,"","",7607.62,6.13,-2669,298,7783.96,4.83}
,{94,47,-52410,400,8238,4,-12270,640,93.943736,429,0,0.037,"",0.018,"",0,1,"","",{"B+"},{0},{"="},{0},31422,640,3988,400,-3135,500,"","",9313,400,"","",14214,566,698,500,"","",12881,500,-1615,566,11806,499}
,{94,48,-40140,500,8099,5,"","",93.956908,537,0,0.08,"",4e-07,">",0,1,"","",{},{},{},{},"","",138,583,-2855,640,"","",11572,584,"","","","",1162,641,"","",7701,707,"","",11437,641}
,{95,34,-30460,500,8112,5,13311,582,94.9673,537,0,0.01,"",4e-07,">",1.5,1,"","",{"B-n","B-2n"},{0,3,0},{"=","="},{0,3,0},5887,640,"","","","",25699,501,"","",8869,583,1728,707,"","",44660,500,"","",5386,707,"",""}
,{95,35,-43771,298,8244,3,12388,299,94.95301,320,0,0.05,"",3e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},7023,524,"","",-9299,499,22121,299,"","",9506,298,4442,423,14257,582,37438,298,7656,499,7817,499,-7143,582}
,{95,36,-56158.913,18.63,8365.995,0.196,9732.58,27.513,94.939710923,20,0,0.114,"",0.003,"",0,0,"","",{"B-","B-n","B-2n"},{0,2.87,0,0,0},{"=","=","="},{0,2.87,0,0,0},8165.55,18.8,30021,400,-8003.7,433.55,18960.64,19.52,-26645,501,4332.55,18.74,2882.46,22.22,16048,301,29501.03,18.65,7442.12,431.22,4937.95,19.8,-3789,400}
,{95,37,-65891.493,20.245,8460.208,0.213,9228.058,20.204,94.929262568,21.734,0,0.3777,"",0.0008,"",2.5,-1,"","",{"B-","B-n"},{0,8.7,0},{"=","="},{0,8.7,0},9414.23,21.55,27579.2,431.29,-7209.11,20.55,15317.35,21.01,-25780,301,4882.9,20.31,5400.03,20.31,11832.69,23.59,20894.76,20.25,8955.31,20.4,7741.88,20.42,-4012.29,21.33}
,{95,38,-75119.551,5.812,8549.111,0.061,6089.296,7.24,94.91935584,6.239,0,23.9,"",0.14,"",0.5,1,"","",{"B-"},{0},{"="},{0},11176.35,9.53,25561.5,6.33,-6570.5,6.23,10540.39,5.85,-21060.75,13.43,-839.41,8.63,4345.16,6.04,13845.74,6.15,12592.31,5.81,8211.16,9.74,4516.94,8.44,-703.83,6.41}
,{95,39,-81208.848,6.779,8604.973,0.071,4451.092,6.772,94.912818711,7.277,0,618,"",6,"",0.5,-1,"","",{"B-"},{0},{"="},{0},13124.32,12.49,23166.89,10.35,-5888.73,10.33,5577.41,6.8,-19935.03,7.07,-2010.84,6.78,6928.7,9.31,9652.11,6.98,4812.49,8.47,9587.8,10.15,6522.57,7.59,-790.01,9.14}
,{95,40,-85659.94,0.869,8643.592,0.009,1126.318,0.985,94.908040267,0.933,0,5532364.8,"",518.4,"",2.5,1,"","",{"B-"},{0},{"="},{0},14680.54,0.98,20152.04,7.6,-4432.93,5.52,2051.92,0.88,-14103.2,1.88,-7362.19,1.73,6461.93,0.86,10597.45,6.44,-2202.19,9.54,9278.02,10.52,4020.61,9.17,2853.82,3.53}
,{95,41,-86786.258,0.508,8647.212,0.005,925.601,0.494,94.906831115,0.545,0,3023222.4,"",518.4,"",4.5,1,"","",{"B-"},{0},{"="},{0},15716.05,1.57,17137.04,10.5,-2859.88,1.91,-764.92,5.1,-11723.77,6.4,-6443.51,0.5,8488.51,1.57,6805.91,0.53,-8445.65,3.92,11046.58,0.68,6536.82,0.52,3676.64,9.14}
,{95,42,-87711.858,0.123,8648.72,0.001,-1690.518,5.078,94.905837442,0.132,1,"s","","s","",2.5,1,"","",{},{},{},{},17047.42,0.22,15167.77,0.47,-2241.21,0.16,-4254.11,9.5,-7731.51,0.2,-11624.86,4.07,7369.11,0.09,8631.77,1.49,-17745.96,3.03,10211.79,1.49,3605.49,1.79,6393.57,0.16}
,{95,43,-86021.341,5.08,8622.69,0.053,-2563.596,10.531,94.907652287,5.453,0,72000,"",360,"",4.5,1,"","",{"B+"},{0},{"="},{0},18557.87,5.18,13386.44,5.29,-1808.25,5.86,-7680.73,6.4,-6941.25,5.29,-11509.07,5.97,9934.34,6.51,4896.25,5.08,-26424,298,11496.53,5.08,5651.29,5.08,6078.35,5.38}
,{95,44,-83457.745,9.502,8587.47,0.1,-5117.138,10.266,94.91040442,10.2,0,5914.8,"",46.8,"",2.5,1,"","",{"B+"},{0},{"="},{0},22383.67,9.72,11228.62,9.5,-3673.84,11.37,-13491.84,9.97,-2332.65,9.5,-18621.45,10.08,8945.47,10.01,6588.4,10.34,-36827,401,10859.17,9.56,332,10,8997.23,9.5}
,{95,45,-78340.606,3.886,8525.37,0.041,-8374.706,4.928,94.915897895,4.171,0,301.2,"",6,"",0,0,"","",{"B+"},{0},{"="},{0},25471.44,4.69,9312.44,4.02,-4778.88,4.55,-18744,298,-1471.26,5.63,-20309.66,5.79,13504.31,5.15,3045.99,5,"","",9586.91,4.4,824.65,4.74,6231.49,4.97}
,{95,46,-69965.9,3.031,8428.98,0.032,-10369,298,94.924888512,3.253,0,7.5,"",0.5,"",4.5,1,"","",{"B+"},{0},{"="},{0},27108,301,7327.13,3.67,-4150.99,3.76,-23335,401,5328.72,4.37,-25628,400,11934.95,5.25,4347.26,4.54,"","",9756.71,4.01,-2102.76,5.32,9981.7,4.07}
,{95,47,-59597,298,8312,3,-12966,499,94.93602,320,0,1.76,"",0.09,"",4.5,1,"","",{"B+","B+p"},{0,2.5,0},{"=","="},{0,2.5,0},29472,499,5163,298,-3452,422,"","",6022,298,-27528,582,15259,499,784,298,"","",10115,423,-153,423,9049,298}
,{95,48,-46631,401,8167,4,"","",94.94994,430,0,0.09,"",0.04,"",4.5,1,"","",{},{},{},{},"","",2208,501,-3125,566,"","",12183,401,"","",14562,641,1510,566,"","",10348,566,-4636,641,13596,500}
,{96,35,-38163,298,8184,3,14916,299,95.95903,320,0,0.02,"",3e-07,">",0,0,"","",{"B-n","B-2n"},{0,6,0},{"=","="},{0,6,0},6906,423,"","",-9607,582,23191,298,"","",9924,299,2464,422,14992,582,40173,298,9351,582,7416,499,"",""}
,{96,36,-53079.678,20.493,8330.851,0.213,8274.671,20.765,95.943016618,22,0,0.08,"",0.008,"",0,1,"","",{"B-","B-n"},{0,3.7,0},{"=","="},{0,3.7,0},7874.54,23.8,30854,501,-8781,400,19844.48,22.18,-29909,501,4740.5,28.81,4992.08,27.7,16598,299,32359.17,20.49,5031,301,4674.61,431.3,-6718,400}
,{96,37,-61354.349,3.353,8408.896,0.035,11569.808,9.115,95.934133393,3.599,0,0.201,"",0.001,"",2,-1,"","",{"B-","B-n","B-2n"},{0,13.3,0,"",""},{"=","=",""},{0,13.3,0,"",""},8934.2,3.92,28532,300,-7546.46,7.5,16981.55,6.95,-24872,298,5693.88,6.7,3534.17,20.42,12484.41,18.93,24248.47,3.36,10704.23,12.57,7645.7,4.19,-2817.72,430.83}
,{96,38,-72924.157,8.475,8521.265,0.088,5411.738,9.726,95.921712692,9.098,0,1.07,"",0.01,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},10221.08,8.64,26154.33,14.78,-6579.75,8.9,12514.69,8.47,-24054.21,20.47,213.37,10.85,5875.92,10.27,14321.63,21.95,15870.72,8.47,6349.43,8.71,4559.8,11.54,-3141.76,8.84}
,{96,39,-78335.895,6.088,8569.488,0.063,7102.951,6.087,95.915902953,6.535,0,5.34,"",0.05,"",0,-1,"","",{"B-"},{0},{"="},{0},12127.07,8.82,24351.05,6.42,-5988.37,8.63,7266.92,6.09,-19733.37,21.14,-747.27,6.15,5198.36,9.11,10505.31,8.41,7485.74,7.97,11220.62,6.31,6614,9.7,-69.59,9.92}
,{96,40,-85438.846,0.114,8635.327,0.001,163.971,0.1,95.908277621,0.122,0,7.25809298e+26,"",6.3113852e+25,"",0,1,"","",{"2B-"},{0},{"="},{0},14312.16,0.2,21171.08,1.67,-4996.4,3.43,3356.03,0.07,-17608.26,5.81,-6723.91,0.5,7850.22,0.88,11518.97,6.78,641.53,0.14,7623.42,6.38,3652.37,10.49,293.39,7.56}
,{96,41,-85602.816,0.147,8628.886,0.002,3192.059,0.107,95.908101591,0.157,0,84060,"",180,"",6,1,"","",{"B-"},{0},{"="},{0},15376.39,1.5,17829.3,6.38,-3211.24,9.13,218.82,5.15,-11682.94,6.78,-5962.28,0.12,6887.88,0.51,7231.85,0.88,-5915.1,10,12377.31,0.22,6383.27,0.48,4270.74,10.49}
,{96,42,-88794.876,0.12,8653.987,0.001,-2973.242,5.145,95.904674774,0.128,1,"s","","s","",0,1,"","",{},{},{},{},16523.45,0.1,16103.49,0.2,-2760.76,0.16,-2714.5,0.12,-10423.91,0.88,-10844.85,5.08,9154.33,0.05,9297.59,0.5,-12611.47,4.19,8284.99,1.49,3282.02,1.49,3973.56,0.47}
,{96,43,-85821.634,5.146,8614.866,0.054,258.738,5.146,95.907866681,5.524,0,369792,"",6048,"",7,1,"","",{"B+"},{0},{"="},{0},17805.95,6.56,14030.51,5.36,-1793.26,5.45,-6133.92,11.25,-6324.35,5.17,-10435.21,10.8,7871.61,7.23,5398.75,5.15,-21310,90.23,13303.24,5.15,5849.49,5.15,7037.61,5.36}
,{96,44,-86080.372,0.17,8609.412,0.002,-6392.654,10,95.907588914,0.182,1,"s","","s","",0,1,"","",{},{},{},{},19639.41,3.15,12244.25,0.16,-1696.71,0.23,-9896.97,4.19,-5657.48,0.13,-15811.08,3.89,10693.94,9.5,7348,5.08,-30507,401,8788.75,4.07,2389.79,1.03,6373.1,0.25}
,{96,45,-79687.718,10.001,8534.673,0.104,-3504.312,10.844,95.91445171,10.737,0,594,"",6,"",6,1,"","",{"B+"},{0},{"="},{0},22922.74,10.56,10107.34,10.8,-3186.94,10.47,-15176.08,90.64,-955.35,11.22,-17793.14,10.45,9418.43,10.73,3518.94,13.79,-41797,500,13606.68,10.48,2393.05,10.21,9564.79,10.05}
,{96,46,-76183.406,4.194,8490.02,0.044,-11671.771,90.181,95.918213744,4.502,0,122,"",2,"",0,1,"","",{"B+"},{0},{"="},{0},26223.77,5.99,8177.76,5.24,-4307.12,5,-20610,401,-14.63,10.39,-24658,298,14288.82,5.17,5131.77,5.72,"","",7435.01,5.39,-2307.55,4.95,6679.71,4.67}
,{96,47,-64511.636,90.084,8360.29,0.938,-8939,411,95.930743906,96.708,0,4.44,"",0.04,"",0,0,"","",{"B+","B+p"},{0,6.9,0},{"=","="},{0,6.9,0},28245,410,6181.96,90.15,-3937.46,90.19,-26621,508,6540,90,-25952,411,12986,311,1834.71,90.13,"","",12301.44,90.19,-647,314,10146.57,90.12}
,{96,48,-55573,401,8259,4,-17683,641,95.94034,430,0,0.88,"",0.09,"",0,1,"","",{"B+","B+p"},{0,5.5,0},{"=","="},{0,5.5,0},31576,641,4049,401,-3418,500,"","",7104,401,"","",17014,566,3265,499,"","",7547,566,-4442,566,9074,501}
,{96,49,-37890,500,8067,5,"","",95.959323,537,0,0.001,"",4e-07,">",0,0,"","",{},{},{},{},"","",59,640,-3185,707,"","",14418,582,"","","","",-1451,641,"","",12960,707,"","",14023,641}
,{97,35,-34055,401,8140,4,13368,421,96.96344,430,0,0.01,"",3e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,5,0},{"=","="},{0,5,0},6427,499,"","","","",24464,401,"","",10953,401,3963,499,"","",42066,401,7115,641,7612,641,"",""}
,{97,36,-47423.492,130.409,8269.864,1.344,11095.645,130.423,96.949088784,140,0,0.0622,"",0.0032,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,6.7,0,"",""},{"=","=",""},{0,6.7,0,"",""},7407.21,131.73,31542,517,-9133,420,21157.96,130.45,"","",5859.54,130.45,2415.13,132.01,16549,325,35519.17,130.41,7058,325,4841,327,-4974,517}
,{97,37,-58519.137,1.912,8376.186,0.02,10062.317,3.888,96.937177118,2.052,0,0.1691,"",0.0006,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,25.5,0,0,0},{"=","=","="},{0,25.5,0,0,0},8770.28,20.33,29326,298,-8053.82,430.82,17602.29,6.99,-27645,298,6333.7,8.69,5236.11,3.86,12728.43,20.58,27086.64,4.66,8350.58,18.73,7692.69,12.26,-5473,300}
,{97,38,-68581.454,3.385,8471.856,0.035,7539.969,7.521,96.926374776,3.633,0,0.429,"",0.005,"",0.5,1,"","",{"B-","B-n"},{0,0.05,0},{"=","<"},{0,0.05,0},9604.54,6.72,27000.48,18.93,-6870.38,4.22,14361.21,3.4,-22790.75,20.77,1683.12,6.96,3728.61,9.12,14516.08,4.76,18963.24,3.39,8020.84,20.53,4845.39,3.95,-1587.28,12.57}
,{97,39,-76121.424,6.719,8541.522,0.069,6821.237,6.707,96.918280286,7.213,0,3.75,"",0.03,"",0.5,-1,"","",{"B-","B-n"},{0,0.055,0},{"=","="},{0,0.055,0},11055.21,9.54,24807.87,21.33,-5926.44,10.32,9484.35,7.94,-22056.04,7.51,1246.11,6.72,5856.85,9.05,10486.24,10.8,11103,7.88,9708.93,8.88,7588.34,6.92,-1912.24,7.02}
,{97,40,-82942.661,0.414,8603.779,0.004,2663.115,4.248,96.910957386,0.444,0,60296.4,"",28.8,"",0.5,1,"","",{"B-"},{0},{"="},{0},13425.36,0.96,22401.05,5.82,-5281.74,7.57,4602.03,0.43,-17307.47,8.47,-5411.16,0.41,5575.13,0.4,11895.74,6.07,3177.89,2.79,8976.99,6.79,4272.86,6.39,1549.45,1.71}
,{97,41,-85605.776,4.249,8623.168,0.044,1938.915,4.248,96.908098414,4.561,0,4326,"",42,"",4.5,1,"","",{"B-"},{0},{"="},{0},14962.15,4.28,18974.87,8,-3803.53,11.32,1618.65,5.91,-14558.85,7.41,-4882.22,4.25,8074.28,4.25,7455.9,4.25,-3008.22,35.72,10764.97,4.34,6527.6,4.25,2392.09,7.67}
,{97,42,-87544.691,0.165,8635.092,0.002,-320.266,4.117,96.906016903,0.176,1,"s","","s","",2.5,1,"","",{},{},{},{},15975.47,0.17,16462.69,0.88,-2847.57,0.49,-1424.14,2.76,-9394.82,0.17,-9794.37,5.15,6821.13,0.16,9230.85,0.19,-9738.85,4.85,9952.37,0.52,3688.43,1.5,5371.03,0.23}
,{97,43,-87224.424,4.118,8623.725,0.042,-1103.873,4.956,96.906360723,4.42,0,1.3285465846e+14,"",5049108160000,"",4.5,1,"","",{"EC"},{0},{"="},{0},17345.72,6.54,15016.11,4.15,-2436.5,4.38,-4626.87,35.7,-8910.58,4.12,-9215.37,4.12,9474.11,6.59,5718.52,4.12,-16398.58,110.18,11198.24,4.12,6053.7,4.12,4791.04,4.38}
,{97,44,-86120.552,2.763,8604.279,0.028,-3523,35.355,96.907545779,2.965,0,245116.8,"",120.96,"",2.5,1,"","",{"B+"},{0},{"="},{0},18805.44,9.89,12986.63,2.76,-1738.4,2.77,-8314.71,5.58,-4614.65,2.76,-14504.15,10.37,8111.5,2.76,7587.89,5.84,-25667,298,10611.6,5.78,2901.82,4.92,7939.91,2.76}
,{97,45,-82597.552,35.463,8559.894,0.366,-4791.709,35.792,96.911327876,38.071,0,1842,"",36,"",4.5,1,"","",{"B+"},{0},{"="},{0},20399.58,35.68,11154.15,35.82,-1416.36,35.48,-11771.71,115.68,-4064.89,35.83,-14485.46,35.71,10981.15,36.85,3806.15,35.46,-35408,402,11571,36.71,4850.09,35.6,7207.17,35.7}
,{97,46,-77805.843,4.844,8502.43,0.05,-6980,110,96.916471987,5.2,0,186,"",5.4,"",2.5,1,"","",{"B+"},{0},{"="},{0},23982.58,5.71,8926.04,10.67,-3014.05,5.27,-17352,298,985.56,4.85,-21365.52,90.21,9693.75,6.41,5407.09,11.11,"","",11245.57,6.21,-34.17,5.91,10424.15,5.77}
,{97,47,-70825.843,110.107,8422.405,1.135,-10372,318,96.923965326,118.204,0,25.5,"",0.3,"",0,0,"","",{"B+"},{0},{"="},{0},27371,318,7063.18,110.18,-4238.96,110.14,-23636,415,1572.91,110.56,-23324,415,14385.52,142.26,1931.41,110.19,"","",9850.86,110.15,140.48,110.19,7728.17,110.16}
,{97,48,-60454,298,8307,3,-13264,499,96.9351,320,0,1.1,"",0.08,"",4.5,1,"","",{"B+","B+p"},{0,11.8,0},{"=","="},{0,11.8,0},29966,499,5066,298,-3878,423,"","",8440,298,-30635,582,12952,499,3231,311,"","",9854,422,-3180,499,11295,298}
,{97,49,-47189,401,8163,4,"","",96.94934,430,0,0.05,"",0.03,"",4.5,1,"","",{"B+"},{0},{"="},{0},"","",2170,499,-3347,566,"","",10033,411,"","",17370,641,-1094,566,"","",10152,566,-2185,641,10866,566}
,{98,35,-28250,400,8080,4,16061,499,97.969672,429,0,0.005,"",4e-07,">",0,0,"","",{"B-n","B-2n"},{0,20,0},{"=","="},{0,20,0},6230,499,"","","","",26119,400,"","",11102,420,2266,566,"","",44044,400,"","",7074,640,"",""}
,{98,36,-44311,298,8236,3,10058,299,97.95243,320,0,0.0428,"",0.0036,"",0,1,"","",{"B-","B-n","B-2n"},{0,7,0,0,0},{"=","=","="},{0,7,0,0,0},7374,299,"","",-9933,582,22112,298,"","",6137,298,4959,325,17545,499,36976,298,4563,422,4324,422,-8205,582}
,{98,37,-54369.146,16.083,8330.729,0.164,12053.958,16.403,97.941632317,17.265,0,0.114,"",0.005,"",0,0,"","",{"B-","B-n","B-2n"},{0,13.8,0,0.051,0},{"=","=","="},{0,13.8,0,0.051,0},9157.43,16.43,30784,299,-9394,300,17925.63,17.93,-27603,401,6140.99,16.43,3921.33,16.2,14234.62,131.4,29155.45,16.84,9421.34,26.05,6653.82,24.61,-4952,299}
,{98,38,-66423.104,3.226,8445.745,0.033,5871.673,8.558,97.92869186,3.463,0,0.653,"",0.002,"",0,1,"","",{"B-","B-n"},{0,0.25,0},{"=","="},{0,0.25,0},9641.58,9.07,27921.37,20.75,-7500.25,12.53,14863.6,9.04,-26288.58,130.45,1627,7.45,5912.97,4.68,15192.94,3.75,21692.87,3.23,5642.05,4.65,4332.44,20.5,-4617.79,18.91}
,{98,39,-72294.777,7.929,8497.677,0.081,8991.932,11.576,97.92238836,8.511,0,0.548,"",0.002,"",0,0,"","",{"B-","B-n"},{0,0.331,0},{"=","="},{0,0.331,0},10101.52,9.98,25518.37,8.61,-6156.91,8.18,11229.82,9.37,-21064.61,8.16,2576.57,7.92,4244.67,10.38,11002.29,8.62,14137.43,8.62,11340.19,11.59,7688.83,9.82,-756.88,21.74}
,{98,40,-81286.709,8.451,8581.448,0.086,2237.89,9.819,97.912735124,9.072,0,30.7,"",0.4,"",0,1,"","",{"B-"},{0},{"="},{0},11990.5,8.45,22940.49,11.96,-4865.91,8.61,6829.26,8.45,-19994.22,9.1,-3752.25,9.45,6415.36,8.44,12454.26,10.78,6938.15,10.64,7759.99,10.4,4786.19,10.83,-520.76,10.25}
,{98,41,-83524.598,5.001,8596.301,0.051,4591.373,5.003,97.91033265,5.369,0,2.86,"",0.06,"",1,1,"","",{"B-"},{0},{"="},{0},14064.42,5,19766.64,7.88,-3598.05,8.11,2907.61,6.04,-14692.15,8.37,-4051.22,5,5990.14,6.56,7870.91,5.02,-349.39,12.91,12625.05,5,6999.4,5.08,3330.65,8.42}
,{98,42,-88115.972,0.174,8635.168,0.002,-1683.766,3.377,97.905403608,0.186,1,"s","","s","",0,1,"","",{},{},{},{},15463.73,0.17,17255.07,0.18,-3271.57,0.24,108.89,6.46,-12462.28,0.44,-8962.86,4.12,8642.6,0.06,9799.17,4.25,-6795,4.75,8197.65,0.2,3534.34,0.52,3190.37,0.89}
,{98,43,-86432.205,3.38,8610.004,0.034,1792.653,7.157,97.907211205,3.628,0,1.325390892e+14,"",9467077800000,"",0,0,"","",{"B-","B+"},{0,0,0},{"=","="},{0,0,0},16753.21,6.16,15407.33,3.38,-2488.06,3.69,-3257,12.3,-8115.4,5.43,-8382.97,4.36,7279.1,5.32,6176.49,3.38,-13365.79,33.08,13073.48,3.38,6143.71,3.38,6000.45,3.42}
,{98,44,-88224.858,6.463,8620.313,0.066,-5049.653,10,97.905286713,6.937,1,"s","","s","",0,1,"","",{},{},{},{},18287.12,6.46,14007.92,6.46,-2235.71,6.46,-6903.88,8.02,-7969.14,6.46,-13698.62,36.05,10175.62,7.03,8289.4,7.66,-20588.44,52.2,8307.58,8.26,2660.54,8.22,5133.4,6.46}
,{98,45,-83175.205,11.906,8560.803,0.121,-1854.229,12.816,97.91070774,12.782,0,523.2,"",7.2,"",0,0,"","",{"B+"},{0},{"="},{0},19630.12,15.55,11931.51,12.97,-1441.8,12.58,-10108.79,35,-3239.75,12.6,-13440.68,12.85,8648.97,37.41,4343.62,12.22,-29279,298,13615.97,11.91,5146.6,15.23,8492.54,12.94}
,{98,46,-81320.975,4.742,8533.899,0.048,-8254.56,33.098,97.912698337,5.09,0,1062,"",18,"",0,1,"","",{"B+"},{0},{"="},{0},21280.2,6.33,9818.54,4.75,-1162.3,5.69,-13684.56,51.92,-2489.39,5.49,-18566.45,110.21,11586.45,6.78,6012.39,35.78,"","",9077.55,11.07,1883.69,6.13,7783.17,10.62}
,{98,47,-73066.415,32.907,8441.686,0.336,-5430,40,97.921559972,35.327,0,47.5,"",0.3,"",0,0,"","",{"B+","B+p"},{0,0.0012,0},{"=","="},{0,0.0012,0},24697.41,95.91,7956.64,34.39,-2583.72,33.08,-19170,300,2242.17,48.38,-20684,300,10311.89,114.92,2549.54,33.26,"","",13827.8,33.17,1763.54,33.05,10920.59,33.14}
,{98,48,-67636.415,51.797,8378.295,0.529,-13740,303,97.927389317,55.605,0,9.2,"",0.3,"",0,1,"","",{"B+","B+p"},{0,0.025,0},{"=","<"},{0,0.025,0},28206,404,6030.95,51.97,-3959.06,51.97,"","",2880.46,52.02,-28518,404,15254,303,4099.54,121.68,"","",7586.03,103.91,-3175,303,7975.89,51.89}
,{98,49,-53896,298,8230,3,"","",97.94214,320,0,0.037,"",0.005,"",0,1,"","",{"B+","B+p"},{0,5.6,0},{"=","="},{0,5.6,0},32148,582,3963,311,-3912,499,"","",9641,318,"","",14778,499,731,422,"","",12387,499,-2402,499,11347,422}
,{99,36,-38759,401,8178,4,12362,401,98.95839,430,0,0.04,"",0.011,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,11,0,2,0},{"=","=","="},{0,11,0,2,0},7479,421,"","",-10725,641,23762,401,"","",7538,401,2520,499,17798,566,38861,401,6007,566,4268,499,"",""}
,{99,37,-51121.143,4.031,8295.3,0.041,11400.258,6.223,98.945119192,4.327,0,0.0564,"",0.0012,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,15.8,0,"",""},{"=","=",""},{0,15.8,0,"",""},8744.64,4.46,31644,401,-9775,298,19528.68,7.76,-30160,400,7230.64,5.16,4823.31,16.58,14099,298,31214.2,12.66,7013.16,130.47,6822.59,20.89,-7311,298}
,{99,38,-62521.401,4.741,8402.552,0.048,8128.424,8.138,98.932880511,5.089,0,0.269,"",0.001,"",1.5,1,"","",{"B-","B-n"},{0,0.1,0},{"=","="},{0,0.1,0},10082.58,5.82,29675.85,130.5,-8787.4,19.22,15099.22,11.52,-25499,298,1702.06,9.23,4169.61,5.73,15441.23,16.77,23448.7,4.75,6708.54,5.11,3697,5.81,-3795.32,21.03}
,{99,39,-70649.825,6.627,8476.755,0.067,6970.792,12.409,98.924154288,7.114,0,1.484,"",0.007,"",2.5,1,"","",{"B-","B-n"},{0,1.7,0},{"=","="},{0,1.7,0},10671.04,9.42,26708.63,6.9,-7183.25,21.3,11685.52,13.71,-23569.65,17.39,2565.57,10.73,6426.37,10.32,11515.69,7.37,16678.04,6.69,8642.44,7.44,7138.39,10.74,-3649.07,7.43}
,{99,40,-77620.617,10.502,8539.264,0.106,4714.724,15.95,98.916670835,11.274,0,2.1,"",0.1,"",0.5,1,"","",{"B-"},{0},{"="},{0},10820.59,10.5,23617.1,11.03,-4925.98,12,8349.48,10.5,-18486.48,10.99,-2167.34,11.63,4405.23,13.47,12614.81,13.15,10004.76,10.51,9211.61,12.46,5579.33,12.13,949.94,13.49}
,{99,41,-82335.341,12.004,8578.985,0.121,3634.758,12.006,98.911609371,12.886,0,15,"",0.2,"",4.5,1,"","",{"B-"},{0},{"="},{0},12872.2,12.73,20791.86,13.76,-3551.41,13.79,4992.52,12.04,-17329.53,14.39,-2290.69,12.01,6882.06,13,8337.6,14.68,3245.96,13.74,11318.13,12.01,7967.56,12,1646.96,13.46}
,{99,42,-85970.098,0.229,8607.797,0.002,1357.764,0.89,98.907707298,0.245,0,237513.6,"",86.4,"",0.5,1,"","",{"B-"},{0},{"="},{0},14568.04,0.16,17605.38,0.46,-2735.07,0.9,1655.28,0.41,-11972.36,8.45,-7609.21,3.38,5925.44,0.15,9734.47,5.01,-3787.45,4.99,10346.48,4.25,4496.77,0.25,5115.15,0.23}
,{99,43,-87327.862,0.908,8613.61,0.009,297.519,0.946,98.906249678,0.974,0,6661667078600,"",37868311200,"",4.5,1,"","",{"B-"},{0},{"="},{0},16246.07,4.21,16300.03,4.34,-2966.52,1.04,-1746.56,6.75,-11092.23,5.08,-7174.32,6.52,8966.97,3.36,6500.86,0.9,-10615.39,6.33,10927.63,0.9,6331.07,0.91,3921.36,0.91}
,{99,44,-87625.381,0.344,8608.712,0.003,-2044.081,6.69,98.905930278,0.369,1,"s","","s","",2.5,1,"","",{},{},{},{},17647.46,2.78,14658.63,0.38,-2338.44,0.36,-5442.73,4.99,-6798.38,0.38,-12521.49,11.91,7471.84,6.47,8482.15,3.39,-17694.26,1.62,10309.85,4.13,3060.31,5.16,6815.9,0.36}
,{99,45,-85581.3,6.697,8580.163,0.068,-3398.649,8.008,98.90812469,7.189,0,1391040,"",17280,"",0.5,-1,"","",{"B+"},{0},{"="},{0},19126.38,36.09,12934.82,7.86,-1984.88,8.41,-8868.83,9.17,-6438.07,7.5,-12331.64,8.21,10477.41,13.66,4645.41,9.31,-24205,298,11250.06,7.24,5363.13,6.7,5886.74,8.45}
,{99,46,-82182.651,4.981,8537.93,0.05,-5470.178,8.004,98.91177329,5.347,0,1284,"",12,"",0,0,"","",{"B+"},{0},{"="},{0},20519.44,6.95,10640.04,5.69,-1149.82,10.73,-12251.53,5.23,-1246.76,8.16,-17187.55,33.28,8932.99,6.88,6296.42,12.91,-34239,503,11125.71,35.81,2369.12,11.17,9544.12,4.98}
,{99,47,-76712.473,6.265,8474.774,0.063,-6781.35,6.462,98.917645768,6.725,0,124.2,"",3,"",0,0,"","",{"B+"},{0},{"="},{0},22029.26,110.28,8692.86,36.01,-796.78,7.37,-15336,298,-826.24,13.45,-17147.38,52.17,11717.38,33.5,2680.47,7.86,"","",11804.18,7.92,4334.99,7.54,8621.65,11.8}
,{99,48,-69931.123,1.584,8398.373,0.016,-8555,298,98.924925847,1.7,0,16,"",3,"",2.5,1,"","",{"B+","B+p","B+A"},{0,0.21,0,1,0},{"=","=","<"},{0,0.21,0,1,0},25620,298,6703.22,5.1,-2390.14,3.42,-21987,503,4100.88,5,-24106,298,10366.02,51.82,4153.68,32.95,"","",11605.53,110.12,-555.43,90.1,11898.68,4.48}
,{99,49,-61376,298,8304,3,-13432,585,98.93411,320,0,3.1,"",0.2,"",4.5,1,"","",{"B+","B+p"},{0,0.9,0},{"=","="},{0,0.9,0},30329,499,5128,318,-4204,422,"","",4401,300,"","",15551,422,1029,303,"","",9789,422,-939,499,8782,311}
,{99,50,-47944,503,8160,5,"","",98.94853,540,0,0.005,"",2e-07,">",4.5,1,"","",{},{},{},{},"","",2068,585,-3738,643,"","",12403,506,"","","","",1337,585,"","",9956,643,-5190,709,13275,643}
,{100,36,-35052,401,8140,4,11195,401,99.96237,430,0,0.012,"",0.008,"",0,1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},6884,499,"","","","",24769,401,"","",7998,401,4364,566,"","",41325,401,3909,566,3867,566,"",""}
,{100,37,-46247.064,19.561,8244.32,0.196,13573.838,20.831,99.950351731,21,0,0.048,"",0.003,"",3,1,"","",{"B-","B-n","B-2n"},{0,6,"",0.16,0},{"=","=","="},{0,6,"",0.16,0},8020.55,25.32,32575,400,-10509,299,21080.33,22.53,"","",8203.02,20.13,3197.24,19.97,14777,401,33550.34,21.13,8775,299,6040.48,131.87,-6545,401}
,{100,38,-59820.903,7.16,8372.234,0.072,7506.493,13.273,99.935779615,7.686,0,0.202,"",0.003,"",0,1,"","",{"B-","B-n"},{0,0.78,0},{"=","="},{0,0.78,0},9540.43,7.85,30088,298,-9166.14,21.71,16556.53,10.84,-28350,401,2757.61,9.75,5370.82,8.58,15988.73,8.22,26372.12,7.17,5259.05,17.6,3562.29,7.41,-6751.01,130.61}
,{100,39,-67327.396,11.186,8439.476,0.112,9050.041,13.83,99.927721063,12.008,0,0.735,"",0.007,"",1,-1,"","",{"B-","B-n"},{0,0.92,0},{"=","="},{0,0.92,0},11175.25,13.7,27536.19,19.59,-8397.96,11.68,12470,13.73,-23495.22,11.89,2221.9,15.34,4748.89,12.99,12094.97,12.14,18693.55,11.27,9806.51,11.64,6118.11,11.69,-3161.86,11.35}
,{100,40,-76377.437,8.149,8522.153,0.081,3419.963,11.398,99.918005444,8.748,0,7.1,"",0.4,"",0,1,"","",{"B-"},{0},{"="},{0},11233.36,11.73,24532.27,8.76,-5878.2,11.75,9815.59,8.15,-21145.01,9.42,-2113.41,14.51,6828.14,13.29,13016.58,10.49,12849.95,8.16,6628.15,11.36,4608.04,10.55,-2149.58,8.82}
,{100,41,-79797.399,7.986,8548.529,0.08,6395.626,7.992,99.914333963,8.573,0,1.5,"",0.2,"",1,1,"","",{"B-"},{0},{"="},{0},12415.44,9.42,22080.56,11.24,-3886.42,10.02,6223.55,8.1,-16436.54,10.36,-1898.62,7.99,5533.38,14.42,9465.75,13.19,5793.73,19.81,12200.12,11.62,8009.32,7.98,1970.43,10.42}
,{100,42,-86193.025,0.302,8604.662,0.003,-172.08,1.371,99.907467976,0.323,0,2.240541746e+26,"",1.26227704e+25,"",0,1,"","",{"2B-"},{0},{"="},{0},14219.69,0.35,19484.26,8.46,-3179.09,0.32,3034.36,0.17,-15861.38,10.51,-6936.48,0.94,8294.24,0.38,11146.65,12,-980.25,17.64,8042.38,5.01,4276.81,4.26,2396.04,0.51}
,{100,43,-86020.945,1.351,8595.118,0.014,3206.444,1.376,99.907652711,1.45,0,15.46,"",0.19,"",1,1,"","",{"B-","EC"},{0,0.0018,0},{"~","="},{0,0.0018,0},15731.37,3.5,17074.29,5.18,-2843.04,1.35,-429.82,18.17,-10974.58,12.08,-6466.88,1.38,6764.4,1,7339.82,1.34,-7882.99,5.18,12805.83,1.34,6387.8,1.34,5231.23,4.46}
,{100,44,-89227.389,0.343,8619.359,0.003,-3636.262,18.123,99.904210452,0.368,1,"s","","s","",0,1,"","",{},{},{},{},17145.16,6.47,15689.36,0.38,-2857.43,0.36,-4014.61,17.64,-10546.26,0.41,-11717.41,6.69,9673.32,0.03,9188.5,0.95,-15032.79,1.71,7915.62,3.39,2861.09,4.13,3963.7,0.38}
,{100,45,-85591.126,18.125,8575.172,0.181,-378.348,25.289,99.908114141,19.458,0,74880,"",360,"",1,-1,"","",{"EC","e+"},{0,4.9,0},{"=","="},{0,4.9,0},18558.56,21.69,13736.86,18.44,-2194.41,18.84,-7453.17,18.8,-5552.23,18.15,-11479.79,18.8,8081.14,19.32,5254.72,18.12,-21278.15,183.42,13344.54,19.24,5393.48,18.33,7279.7,18.59}
,{100,46,-85212.778,17.638,8563.566,0.176,-7074.819,18.333,99.908520315,18.935,0,313632,"",7776,"",0,1,"","",{"EC"},{0},{"="},{0},20034.44,18.26,11565.86,18.78,-1557.32,17.64,-11018.18,17.72,-4876.37,17.64,-16571.62,18.72,11101.44,18.33,6920.45,18.86,-27929.81,302.03,8673.23,21.28,2248.83,39.61,6554.18,17.85}
,{100,47,-78137.959,5,8484.994,0.05,-3943.363,5.273,99.916115445,5.367,0,120.6,"",5.4,"",0,0,"","",{"B+"},{0},{"="},{0},21214.18,33.28,9540.7,12.91,-875.16,11.18,-13824.99,182.59,154.37,8.36,-16278.15,5.24,9496.8,8.02,3244.28,7.06,"","",13893.82,6.89,4531.94,6.96,10105.99,35.81}
,{100,48,-74194.596,1.677,8437.737,0.017,-9881.624,182.517,99.92034882,1.799,0,49.1,"",0.5,"",0,1,"","",{"B+"},{0},{"="},{0},22700.82,51.82,7451.56,5.03,-436.11,4.52,-16911.62,301.52,699.08,5.26,-20890,298,12334.79,2.31,4771.09,6.49,"","",9582.62,32.95,1495.3,110.12,9257.65,5.13}
,{100,49,-64312.972,182.519,8331.097,1.825,-7030,240,99.93095718,195.942,0,5.83,"",0.17,"",6,1,"","",{"B+","B+p"},{0,1.64,0},{"=","="},{0,1.64,0},26559,350,5824.5,185.46,-2226.25,203.54,"","",5110.53,182.63,-24440,535,11008,350,1670.82,182.53,"","",14034.25,189.73,1005,350,12159.27,213.16}
,{100,50,-57282.972,301.518,8252.974,3.015,"","",99.938504196,323.693,0,1.16,"",0.16,"",0,1,"","",{"B+","B+p"},{0,17,0},{"=","<"},{0,17,0},"","",4224.5,305.93,-4135,501,"","",5359.18,301.52,"","",17410,586,3196,424,"","",7324,424,-5229,501,8817,424}
,{101,36,-29128,503,8081,5,13717,541,100.96873,540,0,0.005,"",4e-07,">",2.5,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},6511,643,"","","","",26197,503,"","",9048,503,2147,643,"","",44038,503,"","",3987,642,"",""}
,{101,37,-42845,200,8209,2,12480,200,100.954004,215,0,0.0318,"",0.0033,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,28,0,"",""},{"=","=",""},{0,28,0,"",""},7866,200,"","",-11214,448,22216,200,"","",8905,200,4669,201,15082,448,36047,200,6625,448,6330,359,-8948,447}
,{101,38,-55324.907,8.48,8324.74,0.084,9736.095,11.055,100.940606266,9.103,0,0.1138,"",0.0017,"",2.5,-1,"","",{"B-","B-n"},{0,2.37,0},{"=","="},{0,2.37,0},8946.14,9.72,31143,401,-10326.33,130.68,17841.05,11.89,-27562,401,3931.17,14.04,3575.32,11.1,16366.81,21.32,28195.04,8.49,6507.04,9.39,3908.29,18.18,-5367,298}
,{101,39,-65061.002,7.092,8413.391,0.07,8104.955,10.933,100.930154138,7.614,0,0.426,"",0.02,"",2.5,1,"","",{"B-","B-n"},{0,1.94,0},{"=","="},{0,1.94,0},10553.81,9.69,28517.8,8.16,-8966.78,7.35,13830.49,8.02,-26102.91,20.81,3245.12,10.79,5804.92,13.23,12529.07,10.07,21283.59,25.03,8171.21,8.52,6226.16,7.79,-5045.45,17.58}
,{101,40,-73165.957,8.339,8485.892,0.083,5725.534,9.143,100.92145311,8.951,0,2.3,"",0.1,"",1.5,1,"","",{"B-"},{0},{"="},{0},11687.97,13.4,25222.5,9.59,-7009.42,9,10353.99,8.34,-20634.02,10.98,-1439.87,11.53,4859.84,11.65,13127.53,13.94,14792.16,8.35,8194.67,10.64,3992.87,11.49,-1096.45,8.94}
,{101,41,-78891.491,3.749,8534.835,0.037,4628.458,3.738,100.915306496,4.024,0,7.1,"",0.3,"",0,0,"","",{"B-"},{0},{"="},{0},12698.78,12.57,22819.61,7.61,-5194.98,7.69,7453.1,24.29,-18853.07,11.8,-769.78,3.74,7165.41,8.82,9803.02,8.97,8520.93,6.94,9439.93,11.15,7259.27,9.25,-950.31,8.77}
,{101,42,-83519.949,0.309,8572.915,0.003,2824.645,24.002,100.910337641,0.331,0,876.6,"",1.8,"",0.5,1,"","",{"B-"},{0},{"="},{0},13692.48,0.38,20477.27,10.51,-3002.2,0.52,4438.16,0.3,-14431.48,8.16,-5570.32,1.37,5398.24,0.07,11011.52,7.99,1912.18,4.6,9526.2,12,4868.7,5.01,3413.16,8.46}
,{101,43,-86344.594,24.004,8593.136,0.238,1613.52,24,100.90730526,25.768,0,853.2,"",0.6,"",4.5,1,"","",{"B-"},{0},{"="},{0},15159.37,24.02,18587.19,26.83,-3163.73,24.38,1067.82,24.7,-13836.16,25.3,-5188.52,24,8394.97,24.04,7440.54,24,-5010.22,24.49,10336.31,24,6635.43,24,2826.41,24.52}
,{101,44,-87958.114,0.415,8601.365,0.004,-545.697,5.852,100.905573075,0.445,1,"s","","s","",2.5,1,"","",{},{},{},{},16475.37,0.24,16565.96,0.47,-2838.34,0.45,-2525.98,4.6,-9054.06,0.29,-10438.3,18.12,6802.04,0.24,9226.14,1.4,-12121.66,1.55,10080.55,0.97,3338.15,3.4,5804.26,0.45}
,{101,45,-87412.416,5.841,8588.216,0.058,-1980.284,3.903,100.906158905,6.27,0,104137855.8,"",9467077.8,"",0.5,-1,"","",{"EC"},{0},{"="},{0},17973.75,8.88,14662.5,5.91,-2612.91,7.14,-6078.04,7.58,-8680.44,5.99,-10270.96,18.58,9892.61,19.04,5474,5.85,-18799,196,10923.77,5.85,5676.5,8.71,4666.19,6.75}
,{101,46,-85432.132,4.588,8560.864,0.045,-4097.759,6.668,100.908284828,4.925,0,30492,"",216,"",2.5,1,"","",{"B+"},{0},{"="},{0},19392.12,6.77,12384.69,4.6,-1736.5,5.35,-9595.68,4.82,-3493.71,4.6,-15365.49,6.79,8290.67,18.22,7129.98,18.7,-25126.51,300.04,10859.97,8.12,2607.13,12.76,8439.13,7.93}
,{101,47,-81334.374,4.838,8512.546,0.048,-5497.918,5.063,100.912683953,5.193,0,666,"",18,"",4.5,1,"","",{"B+"},{0},{"="},{0},20764.54,7.92,10331.01,8.26,-1161.74,35.79,-12721,196,-3032.22,18.76,-15211.09,5.12,11267.73,6.96,3410.57,18.29,"","",11559.08,6.94,4850.66,6.77,7487.23,12.85}
,{101,48,-75836.456,1.49,8450.365,0.015,-7223,196,100.918586211,1.6,0,81.6,"",3,"",2.5,1,"","",{"B+"},{0},{"="},{0},22047.97,2.17,8231.75,5.2,-455.53,5.07,-15530.83,300.01,2087.35,17.7,-19594.8,182.53,9713.18,2.24,4987.47,5.22,"","",11586.82,6.44,2094.01,32.94,11130.92,4.97}
,{101,49,-68614,196,8371,2,-8308,358,100.92634,210,0,15.1,"",1.1,"",4.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23380,357,6479,196,-213,224,"","",2235,196,-19402,359,12372,268,1708,196,"","",12028,196,3887,202,10099,198}
,{101,50,-60305.626,300.005,8281.102,2.97,"","",100.935259244,322.068,0,1.97,"",0.16,"",3.5,1,"","",{"B+","B+p"},{0,21,0},{"=","="},{0,21,0},28504,586,4952.44,300.01,-2277,423,"","",6600,300,"","",11093.97,425.34,3281.62,351.16,"","",11781,423,-1545,423,12977.19,304.44}
,{102,37,-37707,298,8157,3,14452,306,101.95952,320,0,0.037,"",0.003,"",4,1,"","",{"B-","B-n","B-2n"},{0,65,"",2,0},{"=","=","="},{0,65,"",2,0},7602,299,"","",-11881,499,23466,298,"","",9547,298,2933,359,15868,585,38598,298,8056,499,5917,499,"",""}
,{102,38,-52159.304,67.068,8291.22,0.658,9013.873,67.191,101.94400468,72,0,0.069,"",0.006,"",0,1,"","",{"B-","B-n"},{0,5.5,0},{"=","="},{0,5.5,0},8481.04,67.45,31685,406,-10273,306,19428.4,67.64,-30320,507,4830.38,67.44,4905.71,67.6,16603,211,31406.76,67.58,4798.57,69.86,3825.89,67.19,-7753,406}
,{102,39,-61173.177,4.077,8371.922,0.04,10414.53,9.669,101.934327889,4.377,0,0.298,"",0.009,"",2,-1,"","",{"B-","B-n"},{0,4.9,0},{"=","="},{0,4.9,0},9988.42,11.91,29504.05,19.98,-9228.95,16.59,15131.37,4.81,-25617,200,3921.46,9.28,4183.49,8.18,13137.24,9.41,23399.7,10.03,9358.53,8.24,6212.28,6.25,-4405.63,5.73}
,{102,40,-71587.707,8.767,8466.355,0.086,4716.837,9.053,101.923147431,9.412,0,2.9,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},11352.9,11.96,26344.75,11.31,-7589.52,9.34,11978.35,12.07,-23551.77,12.2,-767.53,9.54,6493.07,12.09,13815.68,11.26,17518.73,8.78,6450.5,14.2,3926.17,10.97,-3419.9,9.96}
,{102,41,-76304.544,2.545,8504.928,0.025,7261.517,8.675,101.918083697,2.732,0,4.3,"",0.4,"",4,1,"","",{"B-"},{0},{"="},{0},12649.78,8.36,23555.09,11.46,-6434.68,8.31,8268.33,9.51,-18532.51,7.51,-855.91,2.56,5484.37,4.53,10427.56,8.7,10478.77,6.9,10783.7,8.52,6180.13,10.8,-8.32,7.07}
,{102,42,-83566.061,8.312,8568.45,0.081,1006.817,12.373,101.910288138,8.923,0,678,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},13515.67,8.32,21766.57,11.63,-4704.27,11.84,5540.38,8.32,-17689.08,11.76,-5292.78,25.4,8117.43,8.32,11963.54,9.12,4337.11,8.33,6942.14,11.51,3633.33,14.6,-299.04,13.39}
,{102,43,-84572.878,9.166,8570.65,0.09,4533.558,9.165,101.909207275,9.84,0,5.28,"",0.15,"",1,1,"","",{"B-"},{0},{"="},{0},14694.57,9.26,19353.42,12.16,-3473.2,10.44,2210.44,11.18,-12970.36,9.89,-4686.08,9.16,6299.6,25.69,8341.9,9.16,-2326.19,12.28,12330.95,9.16,6261.28,9.17,3408.86,15.1}
,{102,44,-89106.437,0.418,8607.427,0.004,-2323.119,6.396,101.9043403,0.448,1,"s","","s","",0,1,"","",{},{},{},{},16021.68,0.24,17491.35,0.29,-3415.38,0.45,-1203.27,0.36,-12875.46,0.3,-9765.34,5.85,9219.64,0.05,10050.81,24,-9446.75,1.71,7625.31,1.4,3085.48,0.98,2510.06,0.47}
,{102,45,-86783.318,6.41,8576.981,0.063,1119.853,6.406,101.90683427,6.881,0,17884800,"",129600,"",1,-1,"","",{"B+","B-"},{0,22,0},{"=","="},{0,22,0},17334.83,19.22,15340.31,6.55,-2776.03,7.24,-4536.63,10.38,-7727.69,24.84,-9422.5,7.88,7442.22,8.67,6114.17,6.4,-16088.43,7.87,13154.88,6.4,5706.12,6.4,6190.95,6.47}
,{102,46,-87903.171,0.554,8580.29,0.005,-5656.48,8.19,101.905632058,0.594,1,"s","","s","",0,1,"","",{},{},{},{},18833.03,17.64,13253.72,0.44,-2103.23,6.49,-8243.48,1.75,-7234.03,0.37,-14640.11,4.87,10542.36,4.62,7779.73,5.86,-22968.29,100.11,8398.76,18.13,2542.18,6.7,5368.61,0.44}
,{102,47,-82246.691,8.171,8517.164,0.08,-2587,8,101.91170454,8.771,0,774,"",18,"",0,0,"","",{"B+"},{0},{"="},{0},20251.37,9.58,11233.51,19.88,-1496.4,14.44,-11551.81,9.36,-2123.25,10.04,-14481.55,8.31,8983.63,9.5,4103.53,9.37,"","",13676.89,19.44,4800.01,9.57,8981.01,10.56}
,{102,48,-79659.691,1.662,8484.131,0.016,-8964.807,4.865,101.914481799,1.784,0,330,"",30,"",0,1,"","",{"B+"},{0},{"="},{0},21607.73,2.36,9024.85,17.72,-763.63,5.03,-14724.81,100.12,-1516.53,4.88,-19117,196,11894.55,2.23,5614.29,5.12,"","",9189.07,5.27,1916.84,6.48,8169.36,5.25}
,{102,49,-70694.884,4.573,8388.571,0.045,-5760,100,101.924105916,4.909,0,23.3,"",0.1,"",6,1,"","",{"B+","B+p"},{0,0.0093,0},{"=","="},{0,0.0093,0},22524.55,182.58,7134.87,6.78,-53.38,33.22,"","",3350.52,6.66,-18460.58,300.04,10152,196,2147.4,4.81,"","",14210.52,4.87,4100.29,4.84,11663.99,7.76}
,{102,50,-64934.884,100.105,8324.43,0.981,"","",101.93028953,107.466,0,3.8,"",0.2,"",0,1,"","",{"B+"},{0},{"="},{0},23794.55,317.7,5318.23,100.12,276.62,112.71,"","",3612.6,100.12,"","",12700.58,316.27,3610,220,"","",10088.89,208.17,1305,314,10642.64,100.12}
,{103,37,-33608,401,8117,4,13814,446,102.96392,430,0,0.026,"",0.011,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,50,0,2,0},{"=","=","="},{0,50,0,2,0},6906,448,"","","","",24849,401,"","",10480,406,3973,499,"","",41420,401,6230,643,6308,566,"",""}
,{103,38,-47422,196,8243,2,11035,196,102.94909,210,0,0.053,"",0.01,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,2,0,"",""},{"=","=",""},{0,2,0,"",""},8240,196,32872,540,-11088,446,20393,196,"","",5680,196,3334,207,17004,357,33538,196,6133,280,3689,197,-6724,446}
,{103,39,-58457.575,11.204,8342.638,0.109,9357.759,14.518,102.937243208,12.028,0,0.239,"",0.012,"",2.5,1,"","",{"B-","B-n"},{0,8,0},{"=","="},{0,8,0},9539.21,13.26,30191,200,-9761.35,11.91,16571.1,11.88,-28040,298,5058.82,14.23,5355.71,11.87,13587.24,68,26146.29,14.89,7578.14,14.05,6227.38,13.3,-6564.11,22.54}
,{103,40,-67815.334,9.232,8425.895,0.09,7213.337,10.036,102.92719724,9.911,0,1.38,"",0.07,"",2.5,-1,"","",{"B-","B-n"},{0,1,0},{"=","<"},{0,1,0},10792.01,12.43,27068.37,12.54,-7718.85,10.37,13145.34,13.04,-22945,67.7,417.89,9.56,4298.94,12.72,13931.13,10.09,19451.84,9.24,7956.47,11.63,4376.12,14.49,-2348.03,11.67}
,{103,41,-75028.671,3.935,8488.331,0.038,5931.999,10.036,102.919453403,4.224,0,1.5,"",0.2,"",2.5,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},12279.81,5.4,24545.61,8.11,-6803.76,7.71,9575.2,10.56,-21144.46,5.67,466.07,9.2,6795.44,4.69,10729.93,9.61,13003.04,4.52,8848.09,9.22,6212.82,9.05,-2054.87,11.86}
,{103,42,-80960.67,9.232,8538.328,0.09,3643.197,13.471,102.91308514,9.911,0,67.5,"",1.5,"",1.5,1,"","",{"B-"},{0},{"="},{0},13583.36,9.24,22372.65,12.43,-5764.97,13.97,6306.5,9.24,-16661.93,12.72,-4459.11,13.01,5465.93,12.41,11945.1,9.56,6496.52,9.28,8641.63,9.96,3700.78,12.19,1063.17,12.3}
,{103,43,-84603.867,9.81,8566.103,0.095,2663.304,9.808,102.909174008,10.531,0,54.2,"",0.8,"",2.5,1,"","",{"B-"},{0},{"="},{0},14401.91,25.93,20290.32,10.49,-4693.44,15.5,3427.84,10.07,-15588.29,10.13,-3568.75,9.81,8102.31,13.05,8326.78,12.86,198.82,10.63,9626.89,9.81,6453.21,9.81,839.93,12.65}
,{103,44,-87267.171,0.443,8584.365,0.004,764.538,2.26,102.906314833,0.475,0,3390940.8,"",1123.2,"",1.5,1,"","",{"B-"},{0},{"="},{0},15451.69,0.16,18325.16,0.33,-3721.99,0.5,190.02,0.87,-10990.08,8.32,-8555.17,6.4,6232.05,0.15,9983.26,9.16,-6615.55,1.86,9788.23,24,3617.83,1.4,4572.26,0.33}
,{103,45,-88031.708,2.301,8584.192,0.022,-574.519,2.42,102.905494068,2.47,1,"s","","s","",0.5,-1,"","",{},{},{},{},16761.93,6.18,16265.06,24.11,-3128.76,2.46,-3229.02,4.7,-10747.8,9.44,-8199.85,2.29,9319.71,6.79,6214.24,2.26,-13399.12,9.9,10637.21,2.26,6059.74,2.28,3635.64,2.66}
,{103,46,-87457.189,0.95,8571.019,0.009,-2654.498,4.207,102.90611084,1.019,0,1468022.4,"",1641.6,"",2.5,1,"","",{"EC"},{0},{"="},{0},18167.69,4.68,14077.02,0.85,-2256.72,0.89,-6805.57,2.04,-5639.72,0.85,-13281.82,8.23,7625.34,0.77,7962.84,6.45,-20484.6,70.66,10666.03,5.91,2997.99,18.14,7416.6,0.89}
,{103,47,-84802.692,4.099,8537.651,0.04,-4151.075,4.481,102.90896056,4.4,0,3942,"",42,"",3.5,1,"","",{"B+"},{0},{"="},{0},19610.95,6.34,11968.22,7.14,-1646.31,7.85,-10170.1,10.46,-5308.34,7.61,-13214.32,4.42,10627.32,9.14,4188.49,4.14,-28624,298,11340.25,6.15,5274.14,18.11,6434.84,18.58}
,{103,48,-80651.616,1.811,8489.754,0.018,-6019.026,9.754,102.913416923,1.943,0,438,"",6,"",2.5,1,"","",{"B+"},{0},{"="},{0},20957.79,2.35,9797.43,4.93,-893.88,5.3,-13679.03,70.68,-37.42,1.89,-18028.05,4.92,9063.24,2.46,5693.9,8.37,"","",11393.56,5.17,2350.4,5.32,10207.56,17.73}
,{103,49,-74632.591,9.625,8423.721,0.093,-7660,70,102.919878613,10.332,0,60,"",1,"",4.5,1,"","",{"B+"},{0},{"="},{0},22161,196,7876.16,10.77,-345.03,11.48,-18454,298,325.13,12.63,-17769.02,100.57,12009.02,10.66,2261.87,9.77,"","",11914.67,9.74,4426.06,9.77,9151.77,10.85}
,{103,50,-66972.591,70.659,8341.757,0.686,-10794,306,102.928101962,75.855,0,7,"",0.2,"",2.5,1,"","",{"B+","B+p"},{0,1.2,0},{"=","="},{0,1.2,0},22809.6,308.21,5714.08,70.67,533.62,70.68,"","",5398.13,70.68,"","",10109.02,122.53,3566.68,70.81,"","",12352,208,2204.44,195.72,12868.41,70.68}
,{103,51,-56178,298,8229,3,"","",102.93969,320,0,4.9e-08,"","s","",2.5,1,"","",{},{},{},{},"","",2142,357,2773,422,"","",7228,298,"","","","",-1468,314,"","",14838,423,5969,424,13781,350}
,{104,38,-44106,298,8210,3,9958,499,103.95265,320,0,0.0506,"",0.0042,"",0,1,"","",{"B-","B-n","B-2n"},{0,9,0,0,0},{"=","=","="},{0,9,0,0,0},8090,306,"","",-11479,499,21618,298,"","",6280,298,4755,357,17787,499,36244,298,4311,422,3603,359,-9332,585}
,{104,39,-54064,401,8298,4,11660,401,103.94196,430,0,0.197,"",0.004,"",0,0,"","",{"B-","B-n","B-2n"},{0,34,"",0,0},{"=","=","="},{0,34,"",0,0},9033,401,30935,499,-10242,401,17755,401,-27745,566,5680,401,3678,401,13931,446,28440,401,8806,406,6125,401,-5573,448}
,{104,40,-65724.06,9.325,8402.377,0.09,6094.952,9.699,103.929442315,10.011,0,0.92,"",0.028,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","<"},{0,1,0},10278.99,12.78,28142.7,67.71,-8328.07,11.75,14625.91,12.89,-25591,196,1233.29,10.12,5980.04,13.11,14555.46,14.58,22371.65,9.65,6159.92,10.18,4201,11.7,-4752.75,12.6}
,{104,41,-71819.012,2.737,8453.459,0.026,8530.957,9.311,103.922899115,2.938,0,4.9,"",0.3,"",1,1,"","",{"B-","B-n"},{0,0.06,0},{"=","="},{0,0.06,0},11657.1,3.69,25223.78,4.91,-6916.53,11.5,10684.43,25.03,-20650.41,11.53,1070.34,9.61,4861.66,4.79,11292.65,9.61,15140.34,3.58,10479.5,9.16,6211,8.76,-1111.61,7.58}
,{104,42,-80349.968,8.921,8527.965,0.086,2153.476,24.167,103.913740756,9.576,0,60,"",2,"",0,1,"","",{"B-"},{0},{"="},{0},12926.54,12.18,23340.2,12.49,-6397.45,12.07,7745.74,9.24,-19823.61,12.82,-3817.42,13.25,7460.62,12.82,12610.27,9.75,9045.14,9.02,6665.38,9.26,3405.58,9.68,-1537.61,12.2}
,{104,43,-82503.444,24.888,8541.149,0.239,5592.266,24.939,103.911428905,26.718,0,1098,"",18,"",3,1,"","",{"B-"},{0},{"="},{0},14073.2,26.47,20776.84,25.01,-5130.96,26.13,4455.9,24.99,-14763.74,25.2,-3307.59,24.89,5970.89,26.68,8831.74,26.54,2613.01,25.24,11773.42,26.24,5880.56,24.89,2034.45,25.17}
,{104,44,-88095.71,2.498,8587.399,0.024,-1136.362,3.364,103.90542536,2.681,1,"s","","s","",0,1,"","",{},{},{},{},15131.91,2.49,19107.59,8.68,-4327.6,2.49,1299.4,2.68,-14424.01,9.56,-8135.32,3.36,8899.86,2.49,10780.81,9.49,-4127.33,3.01,7187.97,8.96,3112.94,24.13,1070.64,2.5}
,{104,45,-86959.348,2.303,8568.949,0.022,2435.758,2.66,103.906645295,2.472,0,42.3,"",0.4,"",1,1,"","",{"B-","B+"},{0,0.45,0},{"~","="},{0,0.45,0},16318.66,6.79,16964.41,9.44,-3363.32,2.66,-1842.9,4.8,-9644.45,10.07,-7573.48,2.42,6998.96,0.08,6981.15,2.26,-10776.68,6.22,12857.9,2.27,5862.82,2.27,5031.65,24.11}
,{104,46,-89395.105,1.336,8584.848,0.013,-4278.654,4,103.904030401,1.434,1,"s","","s","",0,1,"","",{},{},{},{},17634.57,1.44,14866.61,1.4,-2592.63,1.38,-5426.73,2.14,-9416.91,1.4,-12663.73,4.31,10009.23,1.64,8652.37,2.66,-17768.06,5.9,8099.02,6.55,2881.37,5.99,4209.41,1.39}
,{104,47,-85116.452,4.217,8536.184,0.041,-1148.072,4.537,103.908623725,4.527,0,4152,"",60,"",5,1,"","",{"B+"},{0},{"="},{0},19012.4,9.2,12911.08,7.67,-1950.24,18.61,-8933.79,7.15,-4373.71,4.8,-12536.15,4.59,8385.08,5.88,4948.23,4.32,-25942.83,122.52,13497.53,4.25,5179.74,6.23,7942.37,7.2}
,{104,48,-83968.38,1.673,8517.622,0.016,-7785.716,6.013,103.90985623,1.795,0,3462,"",60,"",0,1,"","",{"B+"},{0},{"="},{0},20451.32,2.36,10643.15,1.76,-1180.52,17.72,-12341.33,5.98,-3800.16,1.92,-17407.11,9.77,11388.08,2.46,6454.66,4.43,"","",8989.12,8.34,2230.05,5.12,7110.15,4.88}
,{104,49,-76182.665,5.775,8435.237,0.056,-4555.617,8.146,103.91821454,6.2,0,108,"",1.8,"",5,1,"","",{"B+"},{0},{"="},{0},21630.41,7.37,8513.91,10.01,-469.62,7.64,-17009.04,122.58,1331.06,7.08,-17281.39,70.89,9621.39,11.22,2820.02,6.05,"","",14187.83,6.01,4517.85,5.96,10798.11,7.53}
,{104,50,-71627.047,5.745,8383.911,0.055,-12453.427,122.579,103.923105197,6.167,0,20.8,"",0.5,"",0,1,"","",{"B+"},{0},{"="},{0},22834.8,100.27,6545.3,5.98,142.63,5.98,"","",1735.6,6.02,-23520,298,12725.77,70.89,4283.43,11.21,"","",9778.64,7.34,1851,196,9855.81,5.94}
,{104,51,-59173.62,122.444,8256.644,1.177,"","",103.936474502,131.449,0,0.47,"",0.13,"",0,0,"","",{"B+","B+p","p"},{"",7,0,7,0},{"","<","<"},{"",7,0,7,0},"","",3056.68,122.53,2714.44,219.79,"","",8170,122.07,"","",11067,322,-510,100,"","",16472.07,158.16,5996.06,324.03,15087,231}
,{105,38,-38610,503,8156,5,12660,1428,104.95855,540,0,0.039,"",0.005,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,10,0,1,0},{"=","=","="},{0,10,0,1,0},7331,540,"","",-11908,711,22854,503,"","",7382,643,2576,585,"","",38727,503,5709,643,3961,585,"",""}
,{105,39,-51270.361,1336.694,8269.02,12.73,10194.373,1336.749,104.944959,1435,0,0.095,"",0.009,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,82,0,0,0},{"=","<","="},{0,82,0,0,0},8955.42,1336.74,32240,1395,-10850,1352,18645.19,1336.7,"","",6382.38,1336.73,5278,1395,14453,1370,31019.73,1337.16,6863,1351,5753,1338.38,-7917,1370}
,{105,40,-61464.734,12.118,8358.659,0.115,8450.817,12.77,104.93401489,13.008,0,0.67,"",0.028,"",2.5,1,"","",{"B-","B-n"},{0,2,0},{"=","<"},{0,2,0},9792.03,15.22,28620,196,-8564.74,14.79,15872.41,15.12,-24647,298,2282.96,12.41,3811.99,15.28,14690,401,24469.76,12.37,7703.65,16.5,4572.5,12.79,-3659.03,68.15}
,{105,41,-69915.551,4.028,8431.692,0.038,7421.59,9.92,104.924942564,4.324,0,2.95,"",0.06,"",2.5,1,"","",{"B-","B-n"},{0,1.7,0},{"=","="},{0,1.7,0},11029.51,5.6,26035.92,11.91,-7279.47,8.16,12374.54,35.49,-23141,401,2363.1,9.79,6167.86,4.87,11480.46,10.16,17935.69,4.73,8610.59,10.07,6536.21,9.65,-3095.97,5.73}
,{105,42,-77337.141,9.065,8494.923,0.086,4952.947,35.031,104.916975159,9.731,0,35.6,"",1.6,"",2.5,-1,"","",{"B-"},{0},{"="},{0},12519.1,12.92,24099.75,12.92,-6596.1,12.3,8597.35,9.39,-18902.05,12.99,-2905.01,26.48,5058.49,12.7,12807.1,9.45,11080.75,9.14,8402.34,9.88,3831.46,9.4,-103.03,12.6}
,{105,43,-82290.088,35.264,8534.643,0.336,3644.402,35.28,104.911657952,37.857,0,456,"",6,"",1.5,-1,"","",{"B-"},{0},{"="},{0},13828.86,36.53,21839.36,35.48,-5823.51,35.46,5561.15,35.33,-17760.05,35.37,-2265.7,35.28,7857.96,43.14,9229.09,36.37,4780.75,35.56,9381.39,36.45,6140.03,36.23,-339.14,35.35}
,{105,44,-85934.49,2.499,8561.9,0.024,1916.752,2.851,104.907745525,2.682,0,15984,"",72,"",1.5,1,"","",{"B-"},{0},{"="},{0},14809.95,2.49,19551.76,9.56,-4839.46,2.5,2483.4,2.59,-12873.49,9.25,-7046.46,3.36,5910.1,0.11,10720.02,24.94,-1600.65,2.86,9380.18,9.49,3502.44,8.96,3277.97,8.68}
,{105,45,-87851.243,2.502,8572.704,0.024,566.646,2.346,104.905687806,2.685,0,127285.2,"",133.2,"",3.5,1,"","",{"B-"},{0},{"="},{0},15962.17,3.39,17825.32,9.91,-3931.56,24.13,-780.41,5.18,-12636.77,24.99,-6527.45,2.45,8963.21,3.39,7044.5,2.85,-8210.67,10.55,10126.73,2.52,6119.25,2.52,2368.04,9.31}
,{105,46,-88417.888,1.138,8570.65,0.011,-1347.052,4.67,104.905079487,1.222,1,"s","","s","",2.5,1,"","",{},{},{},{},17103.33,1.48,15728.66,1.22,-2884.69,1.21,-4084.05,1.79,-7611.15,2.59,-11372.75,4.06,7094.1,0.7,8747.51,2.57,-15079.9,4.13,10324.63,2.56,3229.48,6.51,6334.95,1.21}
,{105,47,-87070.836,4.544,8550.37,0.043,-2736.997,4.362,104.906525607,4.877,0,3567456,"",6048,"",0.5,-1,"","",{"B+"},{0},{"="},{0},18410.78,6.12,13617.07,5.09,-2083.34,7.4,-7430.26,11.21,-7400.46,5.09,-11173.77,4.84,10025.7,6.19,4964.7,4.72,-23055.35,22.29,11097.16,4.64,5696.39,4.58,5358.88,7.86}
,{105,48,-84333.839,1.392,8516.852,0.013,-4693.267,10.341,104.909463895,1.494,0,3330,"",24,"",2.5,1,"","",{"B+"},{0},{"="},{0},19824.86,2.28,11454.59,1.69,-1326.62,4.79,-10995.85,4.21,-2227.7,1.93,-16222.49,5.94,8436.78,2.18,6506.36,4.44,-31522.33,300.02,11179.66,4.33,2776.91,8.29,9215.73,1.5}
,{105,49,-79640.572,10.246,8464.704,0.098,-6302.58,10.989,104.914502324,11,0,304.2,"",4.2,"",4.5,1,"","",{"B+"},{0},{"="},{0},21150.62,14.06,9415.82,11.04,-731.11,11.33,-15625.09,24.11,-1813.09,11.08,-16084.84,11.75,11529.22,11.76,2961.16,10.38,"","",11721.85,10.41,4883.17,10.38,8252.52,13.11}
,{105,50,-73337.992,3.971,8397.228,0.038,-9322.51,22.185,104.921268423,4.263,0,34,"",1,"",2.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22508.04,70.77,7264.32,4.36,73.55,4.24,-20526.48,300.05,3341.42,4.31,-22235.69,122.51,9782.26,6.98,4444.3,7.01,"","",12005.41,10.41,2220.95,6.06,11968.1,4.31}
,{105,51,-64015.482,21.827,8300.992,0.208,-11203.972,300.813,104.931276549,23.431,0,1.12,"",0.16,"",2.5,1,"","",{"p"},{0},{"<"},{0},23980,299,3960.83,23.85,2173,197,"","",4878.21,22.58,"","",12913.18,124.37,-322.59,22.47,"","",13667.91,73.95,5783.46,102.46,12325.8,22.3}
,{105,52,-52811.51,300.02,8186.836,2.857,"","",104.943304508,322.084,0,6.33e-07,"",6.6e-08,"",3.5,1,"","",{"A"},{0},{"~"},{0},"","",416.86,308.23,5069.2,3,"","",11526.57,300.07,"","","","",926.86,324.04,"","",14078,423,"","",17769.78,316.28}
,{106,38,-34790,600,8119,6,11263,783,105.962651,644,0,0.021,"",0.008,"",0,1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},6827,670,"","","","",23760,740,"","",8409,1465,4251,783,"","",41344,600,"","",3682,721,"",""}
,{106,39,-46053,503,8218,5,12497,664,105.95056,540,0,0.074,"",0.006,"",2,1,"","",{"B-","B-n","B-2n"},{0,20,0,"",""},{"=","=",""},{0,20,0,"",""},8132,643,"","",-10771,585,20150,503,"","",7340,503,2854,1428,14732,711,33723,503,8764,585,6233,540,-6798,643}
,{106,40,-58549.987,433.145,8328.45,4.086,7653.37,433.164,105.937144,465,0,0.1786,"",0.0058,"",0,1,"","",{"B-","B-n"},{0,7,0},{"=","<"},{0,7,0},8968.56,433.25,29022,526,-8815.6,438.31,17584.54,433.24,-27229,664,3294.25,433.16,5156.57,433.31,14568.6,1405.12,27773.24,433.18,6225,590,4771.64,433.29,-5481,475}
,{106,41,-66203.357,4.122,8393.271,0.039,9931.17,10.026,105.928927768,4.424,0,1.05,"",0.1,"",1,-1,"","",{"B-","B-n"},{0,4.5,0},{"=","="},{0,4.5,0},10526.98,4.95,26717,401,-7455.1,5.8,13572.87,12.92,-22221.97,1336.7,3062.47,9.96,4359.12,5.73,12027.59,12.8,20159.27,6.78,10231.51,10.2,6476.03,10.11,-2099.38,11.94}
,{106,42,-76134.528,9.14,8479.581,0.086,3641.695,15.284,105.918266218,9.812,0,8.73,"",0.12,"",0,1,"","",{"B-"},{0},{"="},{0},11927.19,12.76,24988.41,13.04,-6971.74,12.65,10188.69,10.61,-21958.76,15.16,-1915.76,36.43,6868.7,12.86,13507.95,9.99,13773,9.21,6395.29,9.52,3758.2,9.95,-2672.79,12.98}
,{106,43,-79776.223,12.25,8506.556,0.116,6547,11,105.914356697,13.15,0,35.6,"",0.6,"",0,0,"","",{"B-"},{0},{"="},{0},13415.41,27.71,22535.15,12.55,-5896.59,12.51,6586.4,11,-17149.64,12.89,-1913.05,12.29,5557.45,37.3,9728.05,15.24,7166.16,12.55,11284.55,15.15,6048.5,15.34,898.85,12.86}
,{106,44,-86323.223,5.391,8560.94,0.051,39.404,0.212,105.907328203,5.787,0,32123520,"",15552,"",0,1,"","",{"B-"},{0},{"="},{0},14370.15,5.48,20551.2,10.42,-5182.08,9.91,3584.3,5.34,-16275.05,10.54,-6543.3,5.7,8460.05,5.48,11322.11,35.64,808.92,5.34,6891.03,25.43,3144.7,10.95,283.85,10.69}
,{106,45,-86362.627,5.39,8553.931,0.051,3544.901,5.335,105.907285901,5.785,0,30.07,"",0.35,"",1,1,"","",{"B-"},{0},{"="},{0},15545.91,5.85,18437.12,25.43,-4214.66,10.43,579.76,6.03,-11361.51,35.64,-6016.06,5.34,6582.7,5.69,7717.11,5.48,-5754.49,13.29,12443.89,5.48,5768.6,5.4,3887.64,10.95}
,{106,46,-89907.527,1.106,8579.992,0.01,-2965.145,2.817,105.903480293,1.186,1,"s","","s","",0,1,"","",{},{},{},{},16655.06,0.75,16389.76,2.59,-3226.01,1.18,-2775.39,0.1,-11262.01,2.59,-10908.01,4.66,9560.96,0.28,9345.26,2.36,-12553.84,5.21,7762.63,2.55,2988.24,2.55,3006.04,1.19}
,{106,47,-86942.383,3.016,8544.639,0.028,189.755,2.819,105.906663507,3.237,0,1437.6,"",2.4,"",1,1,"","",{"B+","B-"},{"",0.5,0},{"","~"},{"",0.5,0},17968.57,4.95,14560.98,3.79,-2583.98,7.08,-6334.25,12.5,-6380.11,3.67,-10679.86,3.32,7942.86,5.44,5813.46,2.83,-20469.09,8.04,13163.53,2.91,5378.86,3.16,6735.73,3.79}
,{106,48,-87132.138,1.104,8539.048,0.01,-6524.004,12.176,105.906459797,1.184,1,"s","","s","",0,1,"","",{},{},{},{},19306.39,2,12314.97,0.76,-1653.88,1.23,-9778.45,5.21,-6003.22,0.3,-15562.88,10.31,10869.62,1.77,7350.27,4.66,-28912.39,100.55,8695.12,4.07,2534.61,4.24,5971.45,1.45}
,{106,49,-80608.134,12.226,8470.12,0.115,-3254.447,13.244,105.913463603,13.125,0,372,"",6,"",7,1,"","",{"B+"},{0},{"="},{0},20568.1,13.52,10069.62,12.84,-786.36,14.71,-14134.84,14.32,-826.27,13.04,-15341.46,12.86,9038.88,15.95,3563.27,12.3,"","",14071.05,12.34,4907.54,12.36,9840.96,12.9}
,{106,50,-77353.687,5.091,8432.038,0.048,-10880.396,9.025,105.916957396,5.465,0,115.2,"",4.8,"",0,1,"","",{"B+"},{0},{"="},{0},21869.27,7.68,7963.25,5.36,-118.91,5.36,-19133.94,100.67,-308.82,5.28,-21409.52,22.41,12087.01,6.46,5002.09,11.44,"","",9539.78,7.7,2142.96,10.89,8944.33,5.4}
,{106,51,-66473.292,7.452,8322.012,0.07,-8253.544,100.816,105.928637982,8,0,0.6,"",0.2,"",2,1,"","",{"B+"},{0},{"="},{0},23442.31,122.67,4868.57,9.43,1796.68,8.74,"","",5878.31,12.67,-21733.1,300.11,10529.13,23.06,424.27,8.44,"","",15864.56,9.41,5363.35,71.05,13805.7,12.17}
,{106,52,-58219.748,100.541,8236.767,0.948,"","",105.937498526,107.934,0,7.8e-05,"",1.1e-05,"",0,1,"","",{"A"},{0},{"="},{0},"","",1170.64,100.7,4290.22,9.35,"","",7829.27,100.62,"","",13479.55,316.42,1493.24,102.88,"","",11664.68,158.43,2823,315,14399.24,122.89}
,{107,38,-28900,700,8064,7,13465,862,106.968975,751,0,0.01,"",4e-07,">",0.5,1,"","",{"B-n","B-2n"},{0,3,0},{"=","="},{0,3,0},6432,862,"","","","",25480,1323,"","",9082,862,2181,922,"","",43652,700,"","","","","",""}
,{107,39,-42364,503,8182,5,12015,1230,106.95452,540,0,0.0335,"",0.0003,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,30,0,"",""},{"=","=",""},{0,30,0,"",""},7237,1428,"","",-11181,643,21359,503,"","",8114,664,4383,711,14863,783,36386,503,6957,711,6606,585,"",""}
,{107,40,-54379.688,1122.45,8287.073,10.49,9344.122,1122.479,106.941621,1205,0,0.1457,"",0.0024,"",2.5,1,"","",{"B-","B-n"},{0,23,0},{"=","<"},{0,23,0},9057.59,1122.52,30347,1230,-9382,1139,18171.87,1122.49,-26878,1273,3752.35,1122.46,3901.02,1203.12,15616,1230,29482.82,1122.48,7601.48,1745.46,4548,1192,-4627,1161}
,{107,41,-63723.81,8.023,8367.089,0.075,8827.75,12.232,106.931589672,8.612,0,0.289,"",0.009,"",2.5,1,"","",{"B-","B-n"},{0,7.4,0},{"=","="},{0,7.4,0},9950.89,8.96,27031.39,1336.72,-7691.15,13.78,15026.1,11.81,-24960,503,4339.4,12.16,5591.77,9,12462.79,433.22,23139.89,14.48,8451.73,14.53,6864.31,12.3,-4013,401}
,{107,42,-72551.56,9.233,8442.28,0.086,6198.355,12.667,106.922112692,9.912,0,3.5,"",0.5,"",2.5,1,"","",{"B-"},{0},{"="},{0},11357.05,12.92,25664.77,15.22,-7161.14,13.04,11310.95,12.67,-21290.54,433.24,-846.65,15.34,4488.35,12.98,13637.17,10.11,15821.08,9.31,8074.8,10.07,4131.51,9.61,-1181.1,13.11}
,{107,43,-78749.914,8.673,8492.897,0.081,5112.598,11.724,106.915458485,9.31,0,21.2,"",0.2,"",1.5,-1,"","",{"B-"},{0},{"="},{0},12602.46,36.24,23412.3,9.55,-6146.16,9.51,8113.79,14.85,-19835.53,9.59,-498.01,9.94,7045.01,14.83,9904.36,12.6,9656.76,8.97,9298.03,12.54,6464.11,12.43,-1284.5,9.09}
,{107,44,-83862.512,8.673,8533.366,0.081,3001.191,14.847,106.909969885,9.31,0,225,"",3,"",0,0,"","",{"B-"},{0},{"="},{0},14070.66,8.29,21103.31,12.54,-5326.76,12.67,4510.13,8.71,-15016.95,12.6,-5571.2,9.94,5610.61,9.94,11375.26,14.83,3127.75,8.83,9138.38,36.24,3504.99,26.28,2133.86,12.43}
,{107,45,-86863.703,12.051,8554.103,0.113,1508.936,12.111,106.906747974,12.937,0,1302,"",24,"",3.5,1,"","",{"B-"},{0},{"="},{0},15155.09,12.31,19151.56,37.27,-4684.75,15.54,1542.97,12.28,-14376.45,17.18,-5027.49,12.1,8572.39,13.2,7829.45,13.2,-3299.44,16.4,9781.59,12.31,6096.06,12.31,1286.14,27.65}
,{107,46,-88372.639,1.201,8560.894,0.011,34.031,2.318,106.905128064,1.289,0,2.05120019e+14,"",9467077800000,"",2.5,1,"","",{"B-"},{0},{"="},{0},16097.38,0.57,17016.09,2.63,-3530.38,1.27,-1382.38,1.98,-9338.39,5.36,-9501.57,2.86,6536.43,0.5,9298.98,5.36,-9860.41,5.44,10189.41,2.41,3450.76,2.59,5369.47,2.63}
,{107,47,-88406.67,2.382,8553.9,0.022,-1416.409,2.567,106.905091531,2.557,1,"s","","s","",0.5,-1,"","",{},{},{},{},17478.47,5.03,15133.37,3.28,-2799.88,3.31,-4842.41,11.3,-9333.01,5.8,-9345.85,2.33,9535.6,3.56,5788.11,2.33,-17753.43,4.78,10722.02,2.34,5852.49,2.45,4199.08,3.31}
,{107,48,-86990.261,1.665,8533.351,0.016,-3426,11,106.906612108,1.787,0,23400,"",72,"",2.5,1,"","",{"B+"},{0},{"="},{0},18799.06,2.17,13150.31,1.96,-1957.99,1.92,-8478.03,5.56,-4371.7,1.94,-14453.44,12.33,7929.44,1.94,7336.85,3.39,-26450.93,70.85,10791.38,4.82,2990.25,4.51,8051.25,2.08}
,{107,49,-83564.261,11.125,8494.021,0.104,-5052.033,12.327,106.910290071,11.943,0,1944,"",18,"",4.5,1,"","",{"B+"},{0},{"="},{0},20066.32,15.12,11071.37,12.01,-1186.48,11.86,-12911.02,11.87,-3910.85,11.51,-14281.89,12.23,11027.44,16.52,3721.09,11.17,-34135,300,11480.38,11.21,5268.17,11.25,7198.59,11.89}
,{107,50,-78512.228,5.31,8439.494,0.05,-7858.989,6.738,106.915713651,5.7,0,174,"",3,"",2.5,1,"","",{"B+"},{0},{"="},{0},21316.87,6.63,8756.33,5.49,-285.53,5.61,-17972.9,71.03,1330.94,5.42,-20110.25,9.15,9229.86,7.36,5193.06,13.33,"","",11839.15,11.54,2534.49,7.85,11102.55,5.57}
,{107,51,-70653.239,4.148,8358.734,0.039,-10113.913,70.952,106.924150624,4.452,0,4,"",0.2,"",2.5,1,"","",{"B+"},{0},{"="},{0},22780.39,22.22,5590.61,11.05,1554.44,10.48,-21224,300,2665.92,12.91,-20504.81,100.63,12251.26,8.53,588.52,6.57,"","",13395.56,5.74,5837.86,7.09,11175.83,7.11}
,{107,52,-60539.326,70.83,8256.899,0.662,-11110,308,106.935008356,76.039,0,0.0031,"",0.0001,"",2.5,1,"","",{"A"},{""},{"="},{""},23870.45,308.27,1779.28,70.94,4008.35,4.93,"","",9525.39,71.01,"","",10390.9,122.99,1355,71.22,"","",14186.96,74.12,3498.35,100.12,16734.12,71.06}
,{107,53,-49430,300,8146,3,"","",106.946935,322,0,2e-05,"","s","",2.5,1,"","",{},{},{},{},"","",-8,301,4324,423,"","",9755,300,"","","","",-1501,316,"","",14093,424,"","",15390,324}
,{108,39,-37297,596,8134,6,14056,718,107.95996,640,0,0.03,"",0.005,"",0,0,"","",{"B-","B-n","B-2n"},{0,30,0,2,0},{"=","=","="},{0,30,0,2,0},7387,780,"","","","",22249,596,"","",9011,1271,3004,780,15686,919,38626,596,8204,846,6177,780,"",""}
,{108,40,-51353,401,8257,4,8193,401,107.94487,430,0,0.0785,"",0.002,"",0,1,"","",{"B-","B-n"},{0,2,0},{"=","="},{0,2,0},8946,590,31141,721,-9672,499,19403,401,-29743,806,4299,401,5045,1192,16278,643,32308,401,5411,643,4781,1395,-7096,643}
,{108,41,-59545.765,8.237,8325.665,0.076,11210.177,12.373,107.936074988,8.842,0,0.198,"",0.006,"",2,1,"","",{"B-","B-n","B-2n"},{0,6.3,0,0,0},{"=","=","="},{0,6.3,0,0,0},9485.04,9.21,28071,503,-7907,401,16377.01,12.03,-24470,503,4934.48,12.37,3893.27,11.5,12455.05,1122.48,25485.96,16.2,9715.03,433.22,6783.02,14.65,-2629,1336.72}
,{108,42,-70755.942,9.233,8422.219,0.085,5166.835,12.734,107.924040367,9.912,0,1.105,"",0.01,"",0,1,"","",{"B-","B-n"},{0,0.5,0},{"=","<"},{0,0.5,0},10764.05,12.98,26783.9,433.24,-7456.8,13.11,12905.41,12.67,-23665.22,1122.49,-77.35,12.67,6275.7,13.04,14321.1,12.23,18768.26,9.3,6158.22,10.11,4023.66,10.07,-3644.81,15.22}
,{108,43,-75922.778,8.769,8462.816,0.081,7738.573,11.79,107.918493541,9.413,0,5.17,"",0.07,"",0,0,"","",{"B-"},{0},{"="},{0},12289.19,14.88,24297.36,9.68,-6528.68,9.19,9108.94,16.52,-19487.94,11.88,-131.58,11.79,5244.18,11.79,10660.19,12.73,11683.99,9.06,10922.56,12.67,6278.42,12.6,-360.83,9.64}
,{108,44,-83661.35,8.68,8527.225,0.08,1370.37,16.469,107.910185841,9.318,0,273,"",3,"",0,1,"","",{"B-"},{0},{"="},{0},13480.76,9.95,22104.76,12.6,-5736.3,12.43,5862.86,8.75,-18398.76,12.67,-4868.96,14.85,7870.16,11.72,12200.41,11.72,5591.06,8.75,6825.68,14.83,3492.79,36.24,-677.81,12.54}
,{108,45,-85031.721,13.996,8532.67,0.13,4492.486,14.039,107.908714688,15.024,0,16.8,"",0.5,"",1,1,"","",{"B-"},{0},{"="},{0},14811.73,15,19833.44,18.6,-4953.19,28.55,2575.04,14.2,-13570.78,16.46,-4730.4,14.05,6239.34,18.47,8458.18,16.46,-911.9,16.45,12002.31,15,5766.82,14.22,2904.77,37.94}
,{108,46,-89524.206,1.108,8567.023,0.01,-1917.444,2.633,107.903891805,1.189,1,"s","","s","",0,1,"","",{},{},{},{},15759.31,1.57,17778.93,5.5,-3853.41,2.73,-271.79,0.77,-12950.66,8.74,-9188.85,2.63,9222.88,1.63,9949.47,12,-7454.27,5.49,7549.23,5.5,3191.09,2.74,2056.69,2.73}
,{108,47,-87606.763,2.388,8542.025,0.022,1645.651,2.639,107.905950266,2.563,0,142.92,"",0.66,"",1,1,"","",{"B-","B+"},{0,2.85,0},{"=","="},{0,2.85,0},16807.01,3.56,15822.08,5.8,-3072.33,3.32,-3486.94,8.97,-8032.03,12.29,-8687.82,2.57,7271.41,0.17,6523.09,2.32,-15161.43,5.99,13011.57,2.33,5675.18,2.35,5890.88,3.28}
,{108,48,-89252.414,1.123,8550.019,0.01,-5132.595,8.584,107.904183587,1.205,1,"s","","s","",0,1,"","",{},{},{},{},18262.91,1.57,13922.83,1.58,-2282.22,1.75,-7182.48,5.49,-8168.75,1.64,-13759.47,11.18,10333.47,2.01,8134.71,2.63,-23470.75,5.53,8400.78,3.22,2682.48,4.68,4811.88,1.6}
,{108,49,-84119.819,8.641,8495.251,0.08,-2049.881,9.836,107.909693655,9.276,0,3480,"",72,"",7,1,"","",{"B+"},{0},{"="},{0},19654.32,14.97,11755.38,9.15,-1428.28,9.62,-11674.49,10.24,-3002.12,8.96,-13678.91,10.14,8626.88,14.09,4418.53,8.8,-31470.21,132.54,13723.13,8.71,5078.07,8.75,8597.42,9.76}
,{108,50,-82069.938,5.382,8469.027,0.05,-9624.607,7.692,107.911894292,5.778,0,618,"",4.8,"",0,1,"","",{"B+"},{0},{"="},{0},20858.88,7.41,9515.74,5.49,-526.47,5.64,-16288.27,7.63,-2368.65,5.63,-19488.02,6.8,11629.03,7.56,5794.65,12.36,"","",9249,13.36,2434.69,11.57,7910.3,5.56}
,{108,51,-72445.331,5.496,8372.666,0.051,-6663.664,7.712,107.922226734,5.9,0,7.4,"",0.3,"",4,1,"","",{"B+"},{0},{"="},{0},22114.67,9.26,6415.14,13.4,1312.42,7.97,-19795.73,132.37,3829.96,12.41,-19977.32,71.04,9863.41,6.89,1222.07,7.64,"","",15619.16,7.49,5756.72,6.78,12841.64,11.63}
,{108,52,-65781.667,5.411,8303.721,0.05,-13132.062,132.37,107.929380471,5.808,0,2.1,"",0.1,"",0,1,"","",{"B+","A","B+p","B+A"},{0,49,0,2.4,0,0.065,0},{"=","=","=","<"},{0,49,0,2.4,0,0.065,0},23704.55,100.69,3005.92,7.43,3420.46,7.6,"","",5441.59,7.58,-24423,300,13313.66,71.04,2417.4,6.82,"","",11402.43,9.21,3097.87,21.15,13202.73,6.71}
,{108,53,-52649.605,132.26,8174.884,1.225,"","",107.943478321,141.986,0,0.036,"",0.006,"",1,1,"","",{"A","B+","p"},{"",9,0,1,0},{"","=","<"},{"",9,0,1,0},"","",754.25,132.47,4099.1,50,"","",10714.66,132.32,"","",11291,328,-600.75,111.91,"","",16280.95,166.14,5025.96,327.88,17012.28,134.05}
,{109,39,-33200,700,8096,6,12992,862,108.964358,751,0,0.025,"",0.005,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,60,0,"",""},{"=","=",""},{0,60,0,"",""},6979,862,"","","","",23489,746,"","",10082,806,3975,919,"","",41082,700,6410,989,6454,922,"",""}
,{109,40,-46193,503,8208,5,10497,566,108.95041,540,0,0.056,"",0.003,"",0.5,1,"","",{"B-","B-n","B-2n"},{0,5,0,0,0},{"=","=","="},{0,5,0,0,0},7956,1230,31871,862,-10007,711,20473,503,"","",5282,503,2911,643,16185,780,34546,503,6882,711,4724,711,-5756,783}
,{109,41,-56689.794,258.49,8297.13,2.371,9976.202,258.732,108.939141,277.5,0,0.1069,"",0.0049,"",2.5,1,"","",{"B-","B-n"},{0,31,0},{"=","="},{0,31,0},9108.62,258.61,28903,566,-7844.35,1361.46,17592.98,258.67,-26682,650,5994.83,258.65,5215.35,258.62,12625,477,28309.66,258.52,8400.7,1151.83,6724.25,504.41,-4990,566}
,{109,42,-66665.996,11.188,8381.477,0.103,7616.78,14.787,108.928431106,12.01,0,0.7,"",0.014,"",2.5,1,"","",{"B-","B-n"},{0,1.3,0},{"=","="},{0,1.3,0},10257.07,14.49,26864.25,1122.51,-7626.18,16.48,14072.41,14.33,-22602,401,1185.46,14.21,3981.37,14.49,14409.2,13.89,20940.48,11.24,7768.62,13.77,4401.42,11.92,-2469.61,433.29}
,{109,43,-74282.775,9.669,8444.178,0.089,6455.626,12.657,108.920254156,10.38,0,1.14,"",0.03,"",2.5,1,"","",{"B-","B-n"},{0,0.08,0},{"=","="},{0,0.08,0},11675.5,12.47,25136.91,12.56,-6792.14,10.46,10716.68,10.48,-22025.98,12.7,1307.26,12.47,6431.31,12.53,10815.8,13.37,14436.65,9.75,8979.59,13.37,6715.81,13.31,-2433.02,10.5}
,{109,44,-80738.401,8.954,8496.227,0.082,4261.054,9.822,108.913323756,9.612,0,34.5,"",1,"",2.5,1,"","",{"B-"},{0},{"="},{0},13018.52,11.92,22764.78,12.86,-5826.18,12.73,6868.07,9.02,-17271.43,12.86,-3778,16.61,5148.37,11.92,12104.59,11.99,7765.92,9.08,8722.32,11.92,3901.88,14.99,1042.53,12.79}
,{109,45,-84999.455,4.039,8528.142,0.037,2607.021,4.187,108.908749326,4.336,0,80,"",2,"",3.5,1,"","",{"B-"},{0},{"="},{0},14278.39,12.71,20827.48,9.57,-5134.28,35.49,3719.97,4.23,-16365.65,9.65,-3546.57,4.19,8039.05,14.55,8627.08,9.57,1490.06,5.66,9573.86,9.57,6187.82,6.74,423.17,12.9}
,{109,46,-87606.476,1.114,8544.882,0.01,1112.95,1.402,108.905950574,1.195,0,49324.32,"",8.64,"",2.5,1,"","",{"B-"},{0},{"="},{0},15376.47,1.64,18321.9,8.74,-4096.9,2.74,897.84,1.82,-11234.1,8.75,-8071.03,2.64,6153.59,0.15,9863.73,14.04,-4976.29,8.03,9968.03,12,3620.21,5.5,4363.15,5.5}
,{109,47,-88719.426,1.287,8547.915,0.012,-215.105,1.78,108.904755773,1.381,1,"s","","s","",0.5,-1,"","",{},{},{},{},16455.39,2.71,16433.66,12.08,-3293.1,2.81,-2229.91,4.09,-10976.68,14.05,-7538.33,1.48,9183.98,2.71,6484.19,1.4,-12468.45,5.42,10364.02,1.76,6052.16,1.7,3289.6,5.54}
,{109,48,-88504.321,1.536,8538.764,0.014,-2014.809,4.066,108.904986698,1.649,0,39882240,"",34560,"",2.5,1,"","",{"EC"},{0},{"="},{0},17656.69,2.27,14709.62,1.95,-2511.35,1.91,-5874.14,8.1,-6269.08,1.82,-12455.82,8.76,7323.22,1.83,8186.53,2.84,-20788.93,4.64,10613.16,2.83,3302.12,3.38,7049.61,1.89}
,{109,49,-86489.511,3.969,8513.102,0.036,-3859.327,8.887,108.907149685,4.261,0,15001.2,"",64.8,"",4.5,1,"","",{"B+"},{0},{"="},{0},19067.88,11.81,12660.78,4.63,-1843.59,6.03,-10238.53,6.59,-6171.72,4.63,-12490.89,6.68,10441.01,9.42,4526.07,3.9,-28817.01,7.81,11211.56,4.3,5506.68,4.12,6099.27,4.98}
,{109,50,-82630.184,7.949,8470.518,0.073,-6379.206,8.807,108.911292843,8.533,0,1080,"",12,"",2.5,1,"","",{"B+"},{0},{"="},{0},20260.59,9.56,10217.86,8.12,-721.26,8.07,-14914.79,9.08,-666.74,8.03,-18256.17,9.66,8631.56,9.6,5799.34,11.74,-36460.64,300.21,11644.88,13.67,2842.01,14.58,10148.36,8.03}
,{109,51,-76250.977,5.265,8404.815,0.048,-8535.587,6.85,108.918141204,5.652,0,17,"",0.7,"",2.5,1,"","",{"B+"},{0},{"="},{0},21740.37,6.7,7264.66,12.31,964.68,11.52,-18578.48,8.54,579.87,10.12,-18540.63,7.55,11876.96,7.61,1470.01,7.53,"","",12972.06,7.48,5966.76,7.32,10003.56,13.31}
,{109,52,-67715.39,4.382,8319.33,0.04,-10042.894,8.03,108.927304534,4.704,0,4.6,"",0.3,"",2.5,1,"","",{"B+","A","B+p","B+A"},{0,3.9,0,9.4,0,0.005,0},{"=","=","=","<"},{0,3.9,0,9.4,0,0.005,0},23318.7,70.97,3781.1,6.88,3197.69,5.7,-21545.84,300.14,7065.58,6.94,-23137.1,132.33,10005.04,6.96,2559.03,7.03,"","",13648.65,6.03,3621.96,8.65,15284.7,6.72}
,{109,53,-57672.496,6.729,8220.016,0.062,-11502.948,300.183,108.938086025,7.223,0,0.000103,"",5e-06,"",0.5,1,"","",{"p","A"},{0,0.014,0},{"=","="},{0,0.014,0},24385,300,1597.2,7.9,3918.07,20.76,"","",7483.86,8.69,"","",13094.21,132.43,-820.2,4,"","",13577.64,71.15,5411.31,100.77,14447.2,10.04}
,{109,54,-46169.548,300.108,8107.306,2.753,"","",108.950434948,322.178,0,0.013,"",0.002,"",3.5,1,"","",{"A"},{0},{"~"},{0},"","",208.16,308.35,4217.05,7.27,"","",12323.15,300.16,"","","","",808.91,327.96,"","",13971,424,"","",17696.6,316.5}
,{110,40,-42886,596,8177,5,9424,1029,109.95396,640,0,0.0375,"",0.002,"",0,1,"","",{"B-","B-n","B-2n"},{0,7,0,0,0},{"=","=","="},{0,7,0,0,0},7675,718,"","",-10521,846,21657,597,"","",5732,650,4765,780,16975,919,37187,596,5122,843,4342,780,-8340,919}
,{110,41,-52309.909,838.345,8255.26,7.621,12232.677,838.694,109.943843,900,0,0.082,"",0.002,"",0,0,"","",{"B-","B-n","B-2n"},{0,40,0,"",""},{"=","=",""},{0,40,0,"",""},8906.78,838.39,29591,1029,-8682,978,18724.6,838.4,-26399,1092,6284.77,838.42,3691.43,877.29,13406,978,30518.78,838.53,9754,929,6933.83,1400.97,-4299,978}
,{110,42,-64542.585,24.223,8359.354,0.22,6491.925,26.018,109.93071068,26.004,0,0.292,"",0.007,"",0,1,"","",{"B-","B-n"},{0,2,0},{"=","="},{0,2,0},9929.28,25.92,27767,401,-8417.51,433.82,15529.99,25.81,-25639,504,1668.87,26.08,5947.91,26.67,15141.76,259.62,23788.32,24.23,5713.99,25.59,4045.28,25.52,-4516.5,1122.71}
,{110,43,-71034.51,9.497,8411.259,0.086,9038.066,12.509,109.923741312,10.195,0,0.9,"",0.013,"",2,1,"","",{"B-","B-n"},{0,0.04,0},{"=","="},{0,0.04,0},11254.37,12.39,26066.69,12.57,-7256.07,10.34,11794.18,20.14,-21633.69,258.66,1632.57,12.52,4823.05,13.04,11657.49,14.67,16422.79,9.58,10432.24,13.25,6381.1,13.25,-1664.3,12.42}
,{110,44,-80072.576,8.924,8486.311,0.081,2756.11,19.404,109.914038548,9.58,0,12.04,"",0.17,"",0,1,"","",{"B-"},{0},{"="},{0},12553.86,11.91,23894.58,12.84,-6362.96,12.77,8258.33,8.94,-20695.55,14.31,-3144.44,9.79,7405.49,12.11,13078.77,12.65,10275.39,8.93,6561.01,11.98,3541.39,11.91,-1874.62,12.84}
,{110,45,-82828.686,17.805,8504.254,0.162,5502.218,17.797,109.911079742,19.114,0,3.35,"",0.12,"",1,1,"","",{"B-"},{0},{"="},{0},13939.6,22.65,21483.85,19.81,-5477.38,21.6,4628.62,17.85,-15834.88,20.22,-3293.53,17.84,5900.55,18.25,9379.26,19.89,3641.28,21.22,11543.47,19.77,5897.88,19.76,1567.63,19.76}
,{110,46,-88330.905,0.612,8547.162,0.006,-873.603,1.378,109.905172868,0.657,1,"s","","s","",0,1,"","",{},{},{},{},14949.33,1.25,19247.5,8.7,-4432.6,5.43,2017.06,0.54,-14881.47,8.97,-7682.8,1.38,8795.75,1.26,10620.42,4.02,-2488.92,13.79,7411.62,14.01,3396.85,12.07,1178.01,8.69}
,{110,47,-87457.302,1.286,8532.108,0.012,2890.667,1.277,109.906110719,1.38,0,24.56,"",0.11,"",1,1,"","",{"B-","EC"},{0,0.3,0},{"~","="},{0,0.3,0},15993.17,2.71,17003.52,14.05,-3519.59,5.54,-987.33,11.62,-9746.82,4.23,-7024.3,1.78,6809.19,0.1,7139.8,1.4,-10007.57,6.1,12777.71,1.4,5779.39,1.76,5052.8,12.08}
,{110,48,-90347.969,0.38,8551.275,0.003,-3878,11.547,109.90300746,0.407,1,"s","","s","",0,1,"","",{},{},{},{},17238.19,1.17,15401.7,1.15,-2865.36,1.17,-4505.99,13.78,-10030.46,1.16,-11929.77,3.99,9914.97,1.57,8917.51,1.28,-18118.16,6.59,7969.6,2.42,2922.76,2.41,3671.07,1.26}
,{110,49,-86469.969,11.553,8508.908,0.105,-627.985,17.98,109.907170665,12.402,0,17712,"",288,"",7,1,"","",{"B+"},{0},{"="},{0},18492.78,14.43,13441.15,11.8,-1952.5,11.94,-9020.23,13,-5039.51,11.62,-11911.1,14.02,8051.77,12.22,5254.62,11.65,-26005.79,51.86,13493.25,11.61,5384.35,11.67,7583.1,11.8}
,{110,50,-85841.983,13.777,8496.087,0.125,-8392.25,15.012,109.907844835,14.79,0,14954.4,"",14.4,"",0,1,"","",{"EC"},{0},{"="},{0},19914.68,14.79,11167.51,13.82,-1134.76,13.82,-13612.17,15.27,-4626.63,13.86,-17662.32,14.75,11283.12,15.91,6641.44,14.34,-33919.36,101.92,8988.64,16.26,2586.33,17.71,6794.68,13.88}
,{110,51,-77449.734,5.962,8412.681,0.054,-5219.923,8.875,109.916854286,6.4,0,23.6,"",0.3,"",3,1,"","",{"B+"},{0},{"="},{0},21147.04,8.11,7907.86,10.5,733.48,13.6,-16985.56,50.9,1750.81,7.16,-17805.66,7.4,9270.07,7.95,2108.52,9.94,"","",15331.01,8.03,5926.55,7.98,11760.93,12.62}
,{110,52,-72229.811,6.575,8358.115,0.06,-11765.635,50.978,109.922458104,7.058,0,18.6,"",0.8,"",0,1,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},22590.78,8.52,4737.81,8.5,2698.96,7.75,-20307.19,101.2,3111.4,10.32,-22628.63,9.41,12585.74,7.9,3267.8,8.42,"","",10926.33,8.57,3287.48,7.77,11928.82,8.45}
,{110,53,-60464.176,50.552,8244.043,0.46,-8541.551,112.934,109.935089033,54.27,0,0.664,"",0.024,"",1,1,"","",{"B+","A","B+p","B+A"},{0,17,0,11,0,1.1,0},{"=","=","=","="},{0,17,0,11,0,1.1,0},23957.21,141.59,2596.79,50.85,3584.2,50,"","",8497.83,50.83,-22365.95,304.34,10863,51,37.76,50.74,"","",16028.3,50.84,4939.2,87.02,15835.46,50.72}
,{110,54,-51922.625,100.988,8159.28,0.918,"","",109.944258765,108.415,0,0.093,"",0.003,"",0,1,"","",{"A"},{""},{"="},{""},"","",718.9,101.13,3872.21,9.5,"","",8503.79,101.08,"","",13824.39,316.64,1539.1,101.21,"","",11437.79,166.41,2371,316,14263.1,123.35}
,{111,40,-37560,700,8128,6,11316,760,110.959678,751,0,0.024,"",0.0005,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,10,0,1,0},{"=","=","="},{0,10,0,1,0},7510,862,"","",-11085,989,22380,700,"","",6679,1092,2745,919,"","",39226,700,6351,989,4601,919,"",""}
,{111,41,-48875,298,8223,3,11064,298,110.94753,320,0,0.054,"",0.002,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,90,0,0,0},{"=","=","="},{0,90,0,0,0},8328,395,30253,760,-8936,585,20149,298,"","",7596,299,4637,890,13278,667,33429,298,8028,585,7342,499,-5932,667}
,{111,42,-59939.761,12.578,8315.292,0.113,9084.861,6.8,110.935652016,13.502,0,0.1936,"",0.0044,"",0.5,1,"","",{"B-","B-n"},{0,12,0},{"=","<"},{0,12,0},9416.4,16.83,28325,503,-7984.99,1122.52,16845.51,15.43,-24343,596,3023.43,15.32,3468.49,27.29,14918.82,838.44,26046.13,12.6,7460.84,258.8,4470.06,15.03,-2940,401}
,{111,43,-69024.622,10.581,8390.089,0.095,7760.649,13.848,110.925899016,11.359,0,0.35,"",0.011,"",2.5,1,"","",{"B-","B-n"},{0,0.85,0},{"=","="},{0,0.85,0},10884.48,13.85,26912.77,258.71,-7725.73,13.27,13279.83,12.61,-24003.68,838.41,2976.64,13.35,6061.43,13.72,11771.01,26.43,19190.83,10.68,8352.18,15.4,6595.38,14.04,-3832.46,13.41}
,{111,44,-76785.271,9.682,8452.957,0.087,5519.181,11.86,110.917567616,10.394,0,2.12,"",0.07,"",2.5,1,"","",{"B-"},{0},{"="},{0},12189.5,12.66,24697.22,14.8,-6658.63,13.38,9200.62,9.71,-19531.66,26.09,-2027.9,20.22,4784.01,12.65,13039.73,13.04,12466.98,9.69,8208.31,13.17,4001.56,12.53,-382.93,13.38}
,{111,45,-82304.452,6.85,8495.631,0.062,3681.435,6.887,110.911642531,7.354,0,11,"",1,"",3.5,1,"","",{"B-"},{0},{"="},{0},13447.63,7.92,22599.62,11.85,-5979.45,11.05,5911,7,-18558.91,11.71,-2044.86,6.88,7547.08,19.08,9520.85,11.25,6087.59,7.66,9144.76,11.27,6220.95,11.06,-735.27,11.13}
,{111,46,-85985.888,0.731,8521.749,0.007,2229.56,1.572,110.907690347,0.785,0,1404,"",12,"",2.5,1,"","",{"B-"},{0},{"="},{0},14522.05,1.32,19825.43,8.98,-4548.29,8.7,3266.36,0.69,-13202.28,8.95,-6599.9,1.43,5726.3,0.4,10446.17,17.8,-47.3,5.38,9724.37,4.04,3909.89,14.01,3321.86,8.71}
,{111,47,-88215.447,1.459,8534.787,0.013,1036.8,1.414,110.905296816,1.565,0,642211.2,"",864,"",0.5,-1,"","",{"B-"},{0},{"="},{0},15638.66,1.91,17793.93,4.28,-3776.66,12.14,176.6,3.7,-12675.73,17.86,-5938.8,1.42,8829.46,1.91,7173.51,1.52,-7378.71,8.97,10101.83,1.82,6172.81,1.82,2462.67,14.07}
,{111,48,-89252.247,0.357,8537.079,0.003,-860.204,3.417,110.904183766,0.383,1,"s","","s","",0.5,1,"","",{},{},{},{},16890.56,1.57,16223.71,1.15,-3304.52,1.25,-3313.66,5.34,-8210.31,0.56,-10853.6,11.55,6975.6,0.17,9083.92,1.28,-15664.77,6.44,10177.98,1.28,3218.57,2.41,5918.36,1.15}
,{111,49,-88392.043,3.424,8522.282,0.031,-2453.456,6.337,110.905107233,3.675,0,242464.32,"",60.48,"",4.5,1,"","",{"EC"},{0},{"="},{0},18045.17,2.7,14250.56,3.64,-2410.29,4.17,-7555.31,9.49,-8223.71,3.64,-10621.38,14.2,9993.39,12.04,5333.04,3.41,-23438.26,5.86,10823.08,3.63,5724.43,3.66,4861.12,4.17}
,{111,50,-85938.587,5.336,8493.13,0.048,-5101.851,10.334,110.907741126,5.728,0,2118,"",36,"",3.5,1,"","",{"B+"},{0},{"="},{0},19451.04,9.57,12012.21,5.55,-1373.24,5.59,-12351.11,8.35,-2879.59,5.34,-16560.17,8,8167.92,14.77,6757.59,12.72,-31543.05,86.86,11261.73,6.65,3045.29,10.16,8960.23,5.45}
,{111,51,-80836.736,8.849,8440.12,0.08,-7249.259,10.937,110.913218189,9.5,0,75,"",1,"",2.5,1,"","",{"B+"},{0},{"="},{0},20728.39,10.3,8925.17,9.7,302.61,14.22,-15882.95,10.05,-1655.74,14.55,-16678.24,11.02,11458.32,10.67,2283.72,16.37,-38016,196,12504.25,11.9,6097.26,10.36,8929.48,12.37}
,{111,52,-73587.477,6.427,8367.763,0.058,-8633.692,7.994,110.921000589,6.9,0,26.2,"",0.6,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22014.72,7.78,5535.23,10.22,2499.84,8.34,-19191.94,86.94,4965.54,15.2,-21194.62,50.96,9428.98,9.19,3426.71,8.77,"","",13374.31,8.31,3721.91,8.46,14128.86,8.38}
,{111,53,-64953.785,4.754,8282.934,0.043,-10558.252,86.83,110.930269239,5.103,0,2.5,"",0.2,"",2.5,1,"","",{"B+","A"},{0,0.1,0},{"~","~"},{0,0.1,0},23423.92,8.24,3280.75,7.09,3274.54,5.19,-22133,196,5206.98,7.62,-21102.48,101.1,12560.93,50.78,12.95,8.11,"","",13472.41,6.47,5691.94,7.2,13137.95,7.27}
,{111,54,-54395.534,86.7,8180.766,0.781,-11575,214,110.941603989,93.076,0,0.74,"",0.2,"",2.5,1,"","",{"A"},{0},{"="},{0},24368.62,312.38,1258.08,86.81,3718.88,50,"","",10545.31,86.95,"","",10544.23,133.1,1220.33,100.36,"","",13987.77,86.96,3118.13,122.57,17032.53,86.87}
,{111,55,-42821,196,8069,2,"","",110.95403,210,0,1e-06,"","s","",1.5,1,"","",{},{},{},{},"","",-274,196,4184,358,"","",10354,202,"","","","",-1813,220,"","",14060,358,"","",15475,236}
,{112,40,-33810,700,8094,6,10463,760,111.963703,751,0,0.043,"",0.021,"",0,1,"","",{"B-","B-n","B-2n"},{0,30,0,"",""},{"=","=",""},{0,30,0,"",""},7067,919,"","","","",23653,726,"","",6994,760,4322,989,"","",41820,700,"","",4254,989,"",""}
,{112,41,-44274,298,8180,3,13190,357,111.95247,320,0,0.038,"",0.002,"",2,1,"","",{"B-","B-n","B-2n"},{0,70,0,1,0},{"=","=","="},{0,70,0,1,0},8107,890,"","",-9402,667,20985,298,"","",7595,298,3470,422,14003,760,35458,301,9323,667,6783,585,-5427,760}
,{112,42,-57464,196,8291,2,7795,196,111.93831,210,0,0.125,"",0.005,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9064,197,29156,627,-8536,446,18167,196,-27193,726,3489,196,5595,196,15877,357,28858,196,5557,861,4090,324,-5625,540}
,{112,43,-65258.938,5.515,8353.621,0.049,10371.881,11.06,111.929941644,5.92,0,0.323,"",0.006,"",2,1,"","",{"B-","B-n"},{0,1.5,0},{"=","="},{0,1.5,0},10367.06,10.97,27526.97,838.36,-8138.09,9.91,14472.57,44.43,-23672,298,3455.02,11.13,4305.63,11.92,12608.15,13.73,21324.78,6.02,9994.45,24.84,6271.11,12.47,-2922.74,258.55}
,{112,44,-75630.818,9.599,8439.242,0.086,4100.685,45.118,111.918806972,10.305,0,1.75,"",0.07,"",0,1,"","",{"B-"},{0},{"="},{0},11700.88,12.58,25666.17,26.06,-7299.79,13.32,10690.74,11.62,-22980.03,15.37,-1397.68,11.79,6916.86,13.11,13895.17,13.79,14944.04,9.6,6114.5,12.98,3516.01,13.11,-3318.42,14.74}
,{112,45,-79731.503,44.085,8468.87,0.394,6590.059,43.927,111.914404705,47.327,0,3.4,"",0.4,"",1,1,"","",{"B-"},{0},{"="},{0},13045.45,47.54,23274.93,45.1,-6233.64,44.95,6852.21,44.15,-17995.85,45.34,-1816.93,44.09,5498.37,44.6,10235.2,45.14,8258.63,44.29,11051.88,44.98,5870.95,44.99,197.67,45.13}
,{112,46,-86321.562,6.544,8520.724,0.058,262.156,6.978,111.907329986,7.025,0,75744,"",612,"",0,1,"","",{"B-"},{0},{"="},{0},14133.29,6.56,20826.93,11.07,-5085.13,10.87,4253.3,6.55,-16825.26,11.69,-6177.43,6.7,8406.99,6.58,11306.08,9.41,2333.49,6.55,7217.93,18.97,3541.95,7.66,63.24,11.09}
,{112,47,-86583.718,2.422,8516.08,0.022,3991.141,2.435,111.90704855,2.6,0,11268,"",28.8,"",0,0,"","",{"B-"},{0},{"="},{0},15269.05,2.74,18332.97,17.97,-3976.91,14.2,1406.41,4.89,-11568.24,7.27,-5402.79,2.45,6439.59,2.83,7886.8,2.53,-4984.75,17.99,12457.99,2.5,5886.81,2.67,4062.14,4.71}
,{112,48,-90574.859,0.25,8544.73,0.002,-2584.728,4.243,111.902763883,0.268,1,"s","","s","",0,1,"","",{},{},{},{},16369.52,0.32,16821.9,0.6,-3475.57,1.13,-1919.8,0.16,-11877.94,0.72,-10254.13,3.43,9393.93,0.28,9648.38,1.44,-13007.35,8.39,7593.25,1.29,3008.62,1.29,2678.02,1.13}
,{112,49,-87990.131,4.251,8514.667,0.038,664.925,4.243,111.905538704,4.563,0,892.8,"",9,"",1,1,"","",{"B+","B-"},{0,42.6,0},{"=","="},{0,42.6,0},17662.8,12.31,15110.77,4.43,-2808.28,4.88,-6391.17,18.33,-7063.65,4.48,-10122.86,6.81,7669.4,5.45,6026.85,4.25,-20926.8,11.09,13068.64,4.26,5378.24,4.52,6375.7,4.43}
,{112,50,-88655.056,0.294,8513.618,0.003,-7056.091,17.832,111.904824877,0.315,1,"s","","s","",0,1,"","",{},{},{},{},18955.71,13.78,12885.03,0.35,-1827.56,1.15,-11087.55,8.39,-6691.78,0.32,-15889.64,8.85,10787.79,5.33,7551.98,3.43,-28628.72,8.29,8525.72,11.55,2698.51,3.98,5495.67,1.56}
,{112,51,-81598.965,17.829,8443.632,0.159,-4031.457,19.702,111.912399903,19.14,0,53.5,"",0.6,"",3,1,"","",{"B+"},{0},{"="},{0},20291.86,18.8,9706.94,21.25,95.94,19.81,-14535.63,20.56,-495.89,18.16,-16082.8,18.95,8833.55,19.9,2949.35,18.61,-35308.69,88.61,14953.83,22.53,5895.27,19.52,10536.95,18.27}
,{112,52,-77567.508,8.383,8400.652,0.075,-10504.178,13.239,111.91672785,9,0,120,"",12,"",0,1,"","",{"B+"},{0},{"="},{0},21480.33,10.65,6303.47,16.13,2077.51,9.96,-17541.17,11.78,1082.11,9.94,-20685.04,9.64,12051.35,10.56,4019.74,12.19,"","",10593.03,10.29,3547.52,9.9,10709.08,11.55}
,{112,53,-67063.33,10.246,8299.879,0.091,-7036.991,13.175,111.92800455,11,0,3.34,"",0.08,"",1,1,"","",{"B+","A","B+p","B+A"},{0,0.0012,0,0.88,0,0.104,0},{"~","=","=","="},{0,0.0012,0,0.88,0,0.104,0},22741.79,51.58,4191.54,11.85,2957.09,11.63,-20773.05,87.4,6484.44,13.54,-20739.11,87.3,10180.86,11.3,764.82,12.1,"","",15877.29,12.17,5516.12,11.14,14834.05,11.52}
,{112,54,-60026.338,8.283,8230.064,0.074,-13736.062,87.19,111.935559071,8.891,0,2.7,"",0.8,"",0,1,"","",{"B+","A"},{0,1.2,0},{"~","="},{0,1.2,0},24246.35,101.33,2374.47,10.58,3330.41,6.27,"","",6272.17,10.48,-25277,196,13702.12,87.09,2361.52,9.55,"","",11148.64,51.23,2510.21,7.44,13335.45,9.37}
,{112,55,-46290.277,86.796,8100.435,0.775,"","",111.950305341,93.178,0,0.00049,"",3e-05,"",1,1,"","",{"p","A"},{0,0.26,0},{"~","<"},{0,0.26,0},"","",404.04,100.44,3934.41,122.64,"","",11374.54,86.93,"","",11541,214,-816.29,4.07,"","",16343.15,133.16,4743.33,312.41,17028.62,87.06}
,{113,41,-40511,401,8146,4,11979,500,112.95651,430,0,0.032,"",0.004,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,90,0,2,0},{"=","=","="},{0,90,0,2,0},7778,499,"","",-9735,806,22301,401,"","",8882,446,4308,499,13989,806,38257,401,7760,806,7239,718,"",""}
,{113,42,-52490,300,8245,3,10322,300,112.94365,322,0,0.08,"",0.002,"",1.5,1,"","",{"B-","B-n"},{0,3,0},{"=","="},{0,3,0},8693,300,29508,761,-8722,586,19378,302,-25968,761,4698,300,3097,358,15505,423,31101,300,7097,423,4684,890,-3957,667}
,{113,43,-62811.541,3.353,8329.464,0.03,9056.578,37.028,112.932569033,3.6,0,0.152,"",0.008,"",2.5,1,"","",{"B-","B-n"},{0,2.1,0},{"=","="},{0,2.1,0},9929.55,11.1,28514,298,-8546.66,258.51,15956,7.88,-25827,298,4747.96,10.17,5623.92,6.45,12637,196,24215.28,16.98,7839.03,13.02,6595.1,24.45,-4855.23,838.35}
,{113,44,-71868.119,36.875,8402.688,0.326,6899.417,37.558,112.922846396,39.587,0,0.8,"",0.05,"",0.5,1,"","",{"B-"},{0},{"="},{0},11225.48,37.97,26506.3,38.81,-7627.04,38.54,11722.97,37.52,-21693,199,-207.93,57.47,4308.62,37.95,13898.15,37.28,17175.16,36.88,7867.31,38.21,4030.45,37.93,-1679.13,44.12}
,{113,45,-78767.536,7.13,8456.821,0.063,4823.555,9.881,112.915439567,7.653,0,2.8,"",0.12,"",3.5,1,"","",{"B-"},{0},{"="},{0},12605.72,9.82,24320.86,12.76,-6909.68,12.01,8259.29,18.11,-20797.57,9.01,-517.29,9.61,7107.35,44.65,10425.69,11.96,10599.58,7.13,8728.54,12.02,6169.1,11.42,-2086.62,11.88}
,{113,46,-83591.092,6.945,8492.584,0.061,3435.731,18.033,112.910261267,7.455,0,93,"",5,"",2.5,1,"","",{"B-"},{0},{"="},{0},13747.84,6.98,21383.76,11.92,-5277.61,11.33,5452.19,6.95,-15249.24,11.85,-5078.69,7.35,5340.85,9.48,11148.56,44.62,4737.04,7.12,9424.17,9.68,4101.65,19.11,2127.89,11.31}
,{113,47,-87026.822,16.643,8516.065,0.147,2016.462,16.641,112.906572858,17.866,0,19332,"",180,"",0.5,-1,"","",{"B-"},{0},{"="},{0},14954.01,16.7,19300.31,18,-4452.28,17.12,2340.29,16.64,-14584.29,47.12,-4523.28,16.64,8514.42,16.82,7994.23,17.88,-2609.85,23.93,9669.87,16.66,6168.14,16.65,1448.27,24.37}
,{113,48,-89043.284,0.244,8526.987,0.002,323.833,0.265,112.904408097,0.262,0,2.5371768504e+23,"",1.5778463e+21,"",0.5,1,"","",{"B-"},{0},{"="},{0},15933.67,0.35,17635.34,0.74,-3861.72,1.14,-715.15,1.58,-10010.69,6.55,-9124.47,4.25,6539.74,0.22,9748.54,2.43,-10696.25,27.95,9882.97,1.46,3278.07,1.29,4934.02,0.62}
,{113,49,-89367.117,0.188,8522.929,0.002,-1038.985,1.573,112.904060448,0.202,1,"s","","s","",4.5,1,"","",{},{},{},{},17117.71,3.42,15729.61,1.46,-3072.61,1.29,-4950.15,17.19,-10072.37,2.43,-8783.38,0.28,9448.3,4.25,6081.23,0.24,-18247.61,8.01,10595.94,0.36,5844.91,0.38,3736.59,1.29}
,{113,50,-88328.132,1.575,8506.811,0.014,-3911.164,17.121,112.905175845,1.69,0,9943776,"",2592,"",0.5,1,"","",{"B+"},{0},{"="},{0},18532.18,5.55,13653.83,1.59,-2248.73,2.2,-9981.1,27.99,-5042.24,1.56,-14800.48,17.9,7744.39,1.56,7626.97,4.52,-26124.51,7.02,10774.72,3.76,3005.89,11.66,7666.24,1.6}
,{113,51,-84416.968,17.193,8465.275,0.152,-6069.939,32.81,112.909374652,18.457,0,400.2,"",4.2,"",2.5,1,"","",{"B+"},{0},{"="},{0},19722.87,19.34,10602.87,17.53,-352.37,17.65,-13297.46,18.97,-3715.81,17.71,-14920.78,19.13,10889.32,24.77,3050.88,17.19,-32652.44,19.21,12232.43,18,6289.07,22.03,7699.4,20.71}
,{113,52,-78347.029,27.945,8404.636,0.247,-7227.522,29.07,112.915891,30,0,102,"",12,"",3.5,1,"","",{"B+"},{0},{"="},{0},20902.19,28.67,6986.38,28.45,1858.24,29.05,-16143.41,28.77,3019.06,27.95,-19355.02,29.76,8850.84,29.18,4037.04,33.15,-38563,299,13200.51,29.31,3966.76,28.57,13141.36,31.16}
,{113,53,-71119.507,8.011,8333.752,0.071,-8915.889,10.533,112.923650064,8.6,0,6.6,"",0.2,"",2.5,1,"","",{"B+","A"},{0,3.31,0},{"=","="},{0,3.31,0},22308.36,9.32,4860.71,11.94,2706.55,9.59,-19354.98,11.74,3190.49,19.55,-19164.49,11.52,12127.49,13.01,840.97,11.6,"","",13178.78,10.27,5974.36,10.36,11976.63,9.99}
,{113,54,-62203.618,6.84,8247.927,0.061,-10439.088,10.97,112.933221666,7.342,0,2.74,"",0.08,"",2.5,1,"","",{"B+","A","B+p","B+A"},{0,0.011,0,7,"",0.007,0},{"~","~","=","~"},{0,0.011,0,7,"",0.007,0},23950.72,86.97,3194.08,9.39,3086.86,7.66,-22420,298,8074.92,10.82,-23984.66,87.06,10248.6,10.74,2429.26,12.32,"","",13460.97,8.33,3124.61,51.01,15672.59,9.49}
,{113,55,-51764.53,8.577,8148.622,0.076,-11980,298,112.944428488,9.207,0,1.77e-05,"",4e-07,"",1.5,1,"","",{"p"},{0},{"="},{0},25086,196,1388.69,9.81,3483.05,7.76,"","",8009.83,13.36,"","",13545.57,87.22,-972.84,2.23,"","",13341.81,87.12,5022.15,101.35,14346.05,51.27}
,{113,56,-39784,298,8036,3,"","",112.95729,320,0,0.1,"","s","",2.5,1,"","",{},{},{},{},"","",-33,310,3961,423,"","",12953,298,"","","","",783,310,"","",13747,357,"","",17785,315}
,{114,41,-35387,503,8100,4,14420,585,113.96201,540,0,0.017,"",0.005,"",0,0,"","",{"B-","B-n","B-2n"},{0,50,0,6,0},{"=","=","="},{0,50,0,6,0},7256,585,"","","","",23213,664,"","",9031,586,2948,643,"","",40323,508,9134,862,7036,862,"",""}
,{114,42,-49807,298,8220,3,8793,526,113.94653,320,0,0.058,"",0.002,"",0,1,"","",{"B-","B-n"},{0,3,0},{"=","="},{0,3,0},8486,357,30574,760,-9346,667,20415,298,"","",4933,298,5389,423,16585,499,33684,298,5178,422,3933,422,-6601,760}
,{114,43,-58600.288,433.145,8290.259,3.8,11621.524,433.159,113.93709,465,0,0.09,"",0.02,"",1,1,"","",{"B-","B-n"},{0,6,0},{"=","="},{0,6,0},9483.98,433.18,28904,526,-8715.29,943.63,17110.34,439.02,-25379,590,5196.51,434.71,3860.06,433.16,13400,527,26330.51,433.17,9574,475,6203.53,433.33,-4078,526}
,{114,44,-70221.811,3.55,8385.34,0.031,5488.813,71.643,113.92461378,3.811,0,0.54,"",0.03,"",0,1,"","",{"B-","B-n","B-2n"},{0,0,0,0,0},{"=","=","="},{0,0,0,0,0},10733.63,10.23,27336,196,-8104.14,24.48,13269.13,7.71,-25021,300,474.41,7.87,6425.01,37.05,14699.24,4.88,19793.12,3.56,5747.93,6.56,3666.87,11.16,-4635.65,13.07}
,{114,45,-75710.625,71.561,8426.624,0.628,7780.319,71.891,113.918721296,76.824,0,1.85,"",0.05,"",1,1,"","",{"B-"},{0},{"="},{0},12121.76,84.05,25029.63,71.77,-7101.03,72.19,9220.17,71.71,-20188.05,71.64,-190.85,71.89,5014.41,71.91,11131.48,80.5,12859.18,71.56,10631,72.2,5938.7,72.21,-1039.6,72.34}
,{114,46,-83490.943,6.945,8488.01,0.061,1439.856,8.311,113.91036878,7.456,0,145.2,"",3.6,"",0,1,"","",{"B-"},{0},{"="},{0},13312.02,9.48,22438.07,11.85,-5843.28,11.31,6523.99,6.95,-18911.79,37.52,-4535.44,18.03,7971.17,9.75,12012.38,9.88,7068.78,6.95,6951.37,44.62,3677.56,9.68,-1059.27,11.92}
,{114,47,-84930.8,4.564,8493.778,0.04,5084.133,4.573,113.908823031,4.9,0,4.6,"",0.1,"",1,1,"","",{"B-"},{0},{"="},{0},14489.72,5.17,19777.24,44.32,-4527.03,18.38,3639,4.57,-13452.23,8.47,-3958.83,4.57,5975.29,17.26,8628.68,8.31,-434.23,22.31,12101.57,7.98,5919.14,4.62,3020.05,8.23}
,{114,48,-90014.932,0.276,8531.513,0.002,-1445.132,0.382,113.90336499,0.296,1,"s","","s","",0,1,"","",{},{},{},{},15582.71,0.25,18271.31,6.55,-4108.94,0.63,544.79,0.28,-13712.81,6.95,-8719.13,0.3,9042.97,0.14,10277.08,16.64,-8126.36,27.95,7279.59,2.44,3064.57,1.46,1617.36,0.75}
,{114,49,-88569.801,0.301,8511.973,0.003,1989.923,0.302,113.904916402,0.323,0,71.9,"",0.1,"",1,1,"","",{"B-","B+"},{0,0.5,0},{"=","="},{0,0.5,0},16722.3,4.26,16564.02,2.44,-3537.41,1.31,-4073.23,21.84,-8831.95,16.64,-8312.99,1.59,7274,0.25,6815.49,0.36,-15774,149,12715.86,0.34,5546.5,0.43,5292.05,1.48}
,{114,50,-90559.723,0.029,8522.566,0,-6063.149,21.838,113.902780132,0.031,1,"s","","s","",0,1,"","",{},{},{},{},18047.3,0.3,14562.81,0.25,-2636.67,0.38,-8671.15,27.94,-8805.41,0.25,-14214.07,17.19,10302.91,1.57,8481.58,0.19,-23473.83,11.18,8141.21,4.25,2696.37,3.42,4338.93,0.36}
,{114,51,-84496.574,21.838,8462.518,0.192,-2608.005,35.466,113.909289191,23.444,0,209.4,"",1.8,"",3,1,"","",{"B+"},{0},{"="},{0},19040.24,28.19,11084.38,22.25,-451.52,24.71,-11700,151,-2418.43,21.84,-14220.86,35.47,8150.92,27.79,3457.41,21.89,-29814.31,74.38,14869.29,21.84,6306.07,22.48,9541.87,22.1}
,{114,52,-81888.569,27.945,8432.778,0.245,-9092,152,113.912089,30,0,912,"",42,"",0,1,"","",{"B+"},{0},{"="},{0},20463.7,29.18,7811.45,27.95,1528.5,31.16,-14802.68,30.1,-849.41,27.99,-18840.38,29.07,11612.86,39.52,4760.57,32.81,-35983.14,106.41,10421.2,33.15,3812.22,29.31,9696.42,28.45}
,{114,53,-72796,149,8346,1,-5710,149,113.92185,160,0,2.1,"",0.2,"",1,1,"","",{"B+"},{0},{"="},{0},21876,149,5775,150,2229,149,-18114,165,4332,150,-18664,149,9748,149,1738,152,"","",15482,149,5655,149,13687,149}
,{114,54,-67085.89,11.178,8289.205,0.098,-12403.629,71.976,113.927980331,12,0,10,"",0.4,"",0,1,"","",{"B+"},{0},{"="},{0},23202.19,13.91,4096.32,13.97,2719.01,12.97,-21180.46,103.28,3972.17,30.1,-23392.68,14.09,12953.59,13.1,3255.35,13.75,"","",10688.25,15.16,2731.95,12.15,12147.99,12.89}
,{114,55,-54682.261,71.102,8173.538,0.624,-8776.835,124.892,113.941296175,76.331,0,0.57,"",0.02,"",1,1,"","",{"B+","A","B+p","B+A"},{0,0.018,0,8.7,0,0.19,0},{"~","=","=","="},{0,0.018,0,8.7,0,0.19,0},24534.62,112.2,2196.87,71.84,3357,50,"","",9148.28,71.55,-22969,306,10989.05,71.62,-232.39,71.43,"","",16054.88,71.58,4577.33,112.13,15917.93,71.26}
,{114,56,-45905.426,102.676,8089.686,0.901,"","",113.950718495,110.227,0,0.46,"",0.125,"",0,1,"","",{"B+","B+p","A","12C"},{0,20,"",0.9,0,0.0034,0},{"~","=","=","<"},{0,20,"",0.9,0,0.0034,0},"","",457.03,103.01,3592.28,18.54,"","",9009.22,102.9,"","",14193,315,1429.87,103.03,"","",11095.66,134.45,1779,221,14136.51,134.38}
,{115,41,-31354,503,8065,4,13395,643,114.96634,540,0,0.023,"",0.008,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,60,0,1,0},{"=","=","="},{0,60,0,1,0},6986,643,"","","","",24966,936,"","",10382,585,4038,711,"","",42876,503,"","",7320,862,"",""}
,{115,42,-44749,401,8175,3,11571,885,114.95196,430,0,0.0455,"",0.002,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,3,0,"",""},{"=","=",""},{0,3,0,"",""},8402,500,"","",-9614,806,21441,410,"","",5780,590,3013,499,16650,643,35677,401,6473,566,4389,499,-5292,806}
,{115,43,-56319.99,789.441,8268.527,6.865,9869.744,794.386,114.939538,847.5,0,0.078,"",0.002,"",2.5,1,"","",{"B-","B-n"},{0,20,0},{"=","="},{0,20,0},9651.08,789.45,30387,885,-9869,844,17909.84,789.48,-28222,936,5830.5,789.45,5791.02,900.46,13802,844,28662.66,789.65,6881,845,6008,813,-6400,844}
,{115,44,-66189.734,88.496,8347.547,0.77,8040.097,88.79,114.928942393,95.004,0,0.318,"",0.019,"",1.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10464.25,95.87,28278,313,-8674.89,89.39,14236.65,89.52,-23672,311,1449.57,113.81,4039.24,88.56,14878.42,442.09,21894.74,88.5,7332.61,88.56,3933.26,88.67,-3079,215}
,{115,45,-74229.831,7.316,8410.658,0.064,6196.554,15.35,114.920310993,7.854,0,0.99,"",0.05,"",3.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11604.93,10.14,25996.23,8.05,-7630.12,12.86,10752.82,19.67,-22918.51,433.21,1189.8,10.02,6590.52,71.93,11296.99,8.04,15306.51,7.32,8349.09,37.59,6265.04,12.07,-3324.49,9.16}
,{115,46,-80426.386,13.546,8457.738,0.118,4556.268,21.649,114.913658718,14.541,0,25,"",2,"",0,0,"","",{"B-"},{0},{"="},{0},12977.93,15.18,23136.21,39.28,-6066.03,16.65,7658.09,13.56,-17493.54,13.95,-3566.9,14.29,5006.76,15.18,12004.73,72.83,9607.45,13.55,9051.96,15.26,4169.17,46.11,850.83,16.6}
,{115,47,-84982.654,18.268,8490.555,0.159,3101.825,18.274,114.908767363,19.611,0,1200,"",30,"",0.5,-1,"","",{"B-"},{0},{"="},{0},14098.47,24.71,20793.06,19.61,-5103.12,19.51,4553.69,18.27,-16561,73.86,-3039.04,18.27,8123.17,18.83,8780.68,19.54,2020.75,24.3,9319.24,19.54,6202.96,19.4,395.25,47.72}
,{115,48,-88084.479,0.651,8510.724,0.006,1451.867,0.651,114.905437417,0.699,0,192456,"",180,"",0.5,1,"","",{"B-"},{0},{"="},{0},15183.83,0.61,19071.33,6.97,-4523.51,0.95,1949.36,0.65,-11882.51,6.97,-7586,0.7,6140.86,0.59,10442.65,4.61,-6021.72,27.95,9653.15,16.65,3363.29,2.51,3883.48,6.57}
,{115,49,-89536.346,0.012,8516.546,0,497.489,0.01,114.903878773,0.012,0,1.3916604366e+22,"",7.8892315e+20,"",4.5,1,"","",{"B-"},{0},{"="},{0},16311.86,0.19,17087.46,16.64,-3745.81,1.46,-2532.94,16.03,-11894.52,4.56,-7047.94,0.03,9037.86,0.3,6810.38,0.28,-13198.55,28.88,10217.74,0.24,5902.57,0.25,2693.77,2.42}
,{115,50,-90033.835,0.015,8514.069,0,-3030.432,16.025,114.903344697,0.016,1,"s","","s","",0.5,1,"","",{},{},{},{},17848.34,1.57,15568.49,0.24,-3206.5,0.36,-7971.08,27.94,-7307.87,0.28,-13608.58,21.84,7545.43,0.02,8753,0.3,-21377.09,12.11,10044.09,0.19,2820.35,4.25,6187.43,0.25}
,{115,51,-87003.403,16.025,8480.915,0.139,-4940.644,32.214,114.906598,17.203,0,1926,"",18,"",2.5,1,"","",{"B+"},{0},{"="},{0},18729.07,23.5,12214.23,16.03,-1036.28,16.39,-10665.61,33.03,-5722.57,16.03,-13186.15,32.21,10578.15,27.09,3732.65,16.03,-27304,104,12035.53,16.1,6515.71,16.03,6633.13,16.58}
,{115,52,-82062.759,27.945,8431.15,0.243,-5724.962,40.184,114.911902,30,0,348,"",12,"",3.5,1,"","",{"B+"},{0},{"="},{0},19858.36,39.52,8312.57,27.99,1450.91,28.45,-13406.01,30.46,1207.99,27.94,-17338,152,8245.51,39.52,4855.16,35.47,-33043,202,13065.02,32.81,4400.26,33.15,12238.7,27.95}
,{115,53,-76337.797,28.876,8374.564,0.251,-7681.049,31.313,114.918048,31,0,78,"",12,"",2.5,1,"","",{"B+"},{0},{"="},{0},21360.92,29.97,6498.77,33.61,2074.02,30.2,-16638,106,869.81,36.2,-17323.22,30.96,11613,152,1738.2,40.18,"","",12720.04,40.18,6093.77,30.07,10907.57,33.94}
,{115,54,-68656.748,12.109,8300.97,0.105,-8957,103,114.926293945,13,0,18,"",4,"",2.5,1,"","",{"B+","B+p","A"},{0,0.34,0,0.0003,0},{"=","=","="},{0,0.34,0,0.0003,0},22595.76,13.91,4887.66,30.46,2505.81,13.71,-19637,201,5942.85,30.46,-22045.8,72.13,9642.18,16.48,3149,150,"","",13173.57,14.52,3270.64,15.86,14557.16,14.73}
,{115,55,-59699,102,8216,1,-10680,225,114.93591,110,0,1.4,"",0.8,"",4.5,1,"","",{"B+","B+p"},{0,0.07,0},{"=","~"},{0,0.07,0},24078,103,3158,103,2829,103,"","",5808,181,-21865,145,13089,125,-97,103,"","",13215,103,5191,103,13010,103}
,{115,56,-49020,200,8117,2,"","",114.947375,215,0,0.45,"",0.05,"",2.5,1,"","",{"B+","B+p"},{0,15,0},{"=",">"},{0,15,0},25378,359,1394,200,2951,218,"","",10777,201,"","",11186,225,1627,213,"","",13455,200,2134,218,16653,200}
,{116,42,-41500,500,8146,4,9956,582,115.955448,537,0,0.032,"",0.004,"",0,1,"","",{"B-","B-n","B-2n"},{0,10,0,0,0},{"=","=","="},{0,10,0,0,0},7836,582,"","",-10114,860,22569,500,"","",6749,935,4822,641,17435,709,38332,500,4598,709,3875,641,"",""}
,{116,43,-51456,298,8225,3,12613,298,115.94476,320,0,0.057,"",0.003,"",2,1,"","",{"B-","B-n","B-2n"},{0,20,0,"",""},{"=","=",""},{0,20,0,"",""},8998,526,30646,585,-9607,422,19280,307,-27391,585,6663,311,3207,844,13996,499,31087,298,9062,422,5898,423,-5299,499}
,{116,44,-64068.909,3.726,8326.883,0.032,6667.213,73.926,115.931219193,4,0,0.204,"",0.006,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9989.73,5.15,28840,298,-9030,196,15762.73,8.05,-26609,401,2089.61,8.21,5950.49,88.57,15037.89,789.45,24643.57,3.73,5242.18,433.16,3606.69,5.01,-5933,300}
,{116,45,-70736.122,73.832,8377.615,0.636,9095.512,74.169,115.924061645,79.261,0,0.685,"",0.039,"",1,1,"","",{"B-","B-n"},{0,2.1,0},{"=","<"},{0,2.1,0},11168.13,102.82,26713.78,439.39,-7902.1,74.04,11806.53,73.9,-21705.1,792.89,1618.95,75.06,4577.61,74.19,11835.36,115.25,17513.63,73.83,10196.5,73.91,5996.05,82.53,-2278.18,73.91}
,{116,46,-79831.635,7.132,8449.28,0.061,2711.019,7.842,115.91429721,7.656,0,11.8,"",0.4,"",0,1,"","",{"B-"},{0},{"="},{0},12483.33,9.88,24187.76,7.87,-6625.73,11.96,8880.85,7.13,-20930.87,88.77,-2920.3,19.61,7476.57,15.26,12890.77,10.14,11694.33,7.13,6589.8,71.91,3799.96,10.01,-2317.11,37.56}
,{116,47,-82542.653,3.26,8465.907,0.028,6169.827,3.264,115.911386812,3.5,0,229.8,"",4.8,"",0,-1,"","",{"B-"},{0},{"="},{0},13754.49,5.61,21409.97,71.64,-5236.07,44.21,5707.1,3.27,-15601.79,8.01,-2529.49,3.32,5631.32,18.56,9405.24,13.93,4279.5,6.1,11659.1,7.67,5912.49,7.67,1871.28,7.84}
,{116,48,-88712.48,0.16,8512.35,0.001,-462.731,0.272,115.90476323,0.172,0,9.056837762e+26,"",4.10240038e+25,"",0,1,"","",{"2B-"},{0},{"="},{0},14840.18,0.31,19799.48,6.95,-4815.83,6.55,2813.49,0.13,-15575.06,13.55,-7247.45,0.16,8699.32,0.67,11018.8,18.27,-3443.52,27.95,6929.13,4.57,3178.4,16.64,525.01,6.95}
,{116,49,-88249.749,0.22,8501.617,0.002,3276.221,0.24,115.905259992,0.236,0,14.1,"",0.03,"",1,1,"","",{"B-","EC"},{0,0.0237,0},{"~","="},{0,0.0237,0},15822.58,0.37,17896.89,4.57,-4090.95,2.43,-1427.6,5.16,-10556.07,18.27,-6287.23,0.22,6784.72,0.22,7454.24,0.69,-10757.51,96.59,12475.99,0.35,5657.59,0.33,4423.48,16.64}
,{116,50,-91525.97,0.096,8523.116,0.001,-4703.82,5.16,115.901742824,0.103,1,"s","","s","",0,1,"","",{},{},{},{},17108.88,0.1,16088.98,0.29,-3376.03,0.27,-6257.01,27.94,-10730.46,0.66,-12593.88,16.03,9563.45,0.09,9278.59,0.1,-18479.25,13.04,7754.64,0.32,2705.2,0.21,3163.72,0.26}
,{116,51,-86822.15,5.16,8475.821,0.044,-1553.189,28.417,115.906792583,5.539,0,948,"",48,"",3,1,"","",{"B+"},{0},{"="},{0},18468.21,22.44,12830.29,5.17,-1256.93,6.69,-9329.91,96.73,-4574.77,5.16,-12830.71,28.42,7890.06,16.84,4077.29,5.16,-24780,100,14448.38,5.16,6370.04,5.4,8191.37,5.16}
,{116,52,-85268.961,27.945,8455.687,0.241,-7776.725,100.553,115.90846,30,0,8964,"",144,"",0,1,"","",{"B+"},{0},{"="},{0},19523.03,39.52,9287.18,27.94,961.18,27.95,-12222.24,30.84,-2524.1,27.94,-17002.48,40.18,11277.52,39.52,5554.53,32.21,-30689,202,9938.42,35.47,4012.06,32.81,8705.57,27.99}
,{116,53,-77492.236,96.592,8381.902,0.833,-4445.512,95.707,115.916808658,103.695,0,2.91,"",0.15,"",1,1,"","",{"B+"},{0},{"="},{0},20839,178,7573.6,99.03,1681.81,98.22,-15450,139,2222.2,97.91,-16906.81,97.35,9225.76,100.82,2718.45,100.55,-36847,327,15107.14,100.55,5718.85,100.55,12571.13,98.11}
,{116,54,-73046.724,13.041,8336.834,0.112,-11004,101,115.921581112,14,0,59,"",2,"",0,1,"","",{"B+"},{0},{"="},{0},22103.47,17.18,5736.1,30.84,2095.87,15.5,-18467,201,1727.06,30.84,-21419,103,12461.29,17.8,3997.9,31.68,"","",10460,150,2936.84,15.3,10946.71,30.84}
,{116,55,-62043,100,8235,1,-7463,224,115.933395,108,0,0.7,"",0.04,"",1,1,"","",{"B+","B+p","B+A"},{0,0.28,0,0.049,0},{"=","=","="},{0,0.28,0,0.049,0},23503,123,3824,180,2596,101,-21397,328,7006,104,-21094,224,10414,143,675,101,"","",15754,101,5025,101,14723,101}
,{116,56,-54580,200,8164,2,-13935,371,115.941406,215,0,1.3,"",0.2,"",0,1,"","",{"B+","B+p"},{0,3,""},{"=","="},{0,3,""},24817,225,2072,201,3021,200,"","",6788,201,"","",13631,283,2169,225,"","",10813,213,2049,200,13270,200}
,{116,57,-40645,312,8037,3,"","",115.956365,335,0,0.01,"","s","",0,0,"","",{},{},{},{},"","",541,320,3220,300,"","",11765,329,"","","","",-1086,371,"","",15971,329,4003,432,16766,312}
,{117,42,-36170,500,8100,4,12212,641,116.96117,537,0,0.022,"",0.005,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},7564,641,"","","","",23320,662,"","",7214,582,2741,707,"","",40255,500,5895,709,4082,709,"",""}
,{117,43,-48382,401,8197,3,11108,590,116.94806,430,0,0.0445,"",0.003,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,30,0,0,0},{"=","=","="},{0,30,0,0,0},8204,885,31606,643,-10296,566,20516,401,"","",7616,401,4997,499,14171,641,33800,401,7078,566,6289,499,-7348,643}
,{117,44,-59489.865,433.145,8285.562,3.702,9407.508,433.236,116.936135,465,0,0.151,"",0.003,"",1.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9442.76,442.09,29319,590,-9425,527,16934.61,433.21,-25279,662,3174.94,439.39,3492.27,433.16,15323,526,26928.52,433.15,7540.93,900.46,3974.48,612.56,-4036,526}
,{117,45,-68897.373,8.892,8359.281,0.076,7527.104,11.411,116.926035623,9.546,0,0.421,"",0.03,"",3.5,1,"","",{"B-","B-n"},{0,7.6,0},{"=","<"},{0,7.6,0},10810.18,11.45,27155.32,789.49,-8510.75,9.5,13284.64,16.22,-24731,298,2862.94,11.33,6232.57,74.36,12117.43,9.64,20045.67,10.14,8003.17,88.93,6188.49,9.5,-4650.68,433.24}
,{117,46,-76424.477,7.252,8416.929,0.062,5757.537,14.766,116.917954944,7.785,0,4.3,"",0.3,"",1.5,1,"","",{"B-"},{0},{"="},{0},12140.73,15.32,24812.68,88.78,-6981.27,37.58,9993.91,7.32,-19644.54,8.15,-1953.14,7.95,4664.16,10.1,12977.33,74.18,13973.27,7.26,8516.16,10.23,4150.2,71.92,-556.26,7.99}
,{117,47,-82182.014,13.572,8459.452,0.116,4236.375,13.61,116.911773974,14.57,0,73.6,"",1.4,"",0.5,-1,"","",{"B-"},{0},{"="},{0},13341.99,22.76,22530.12,15.41,-5839.39,15.32,6761.03,14.42,-18734.86,75.07,-1540.85,13.57,7710.68,13.96,9639.35,15.32,6457.53,15.98,8955.18,19.17,6172.98,15.24,-824.99,72.84}
,{117,48,-86418.389,1.013,8488.973,0.009,2524.653,4.983,116.907226038,1.087,0,8964,"",144,"",0.5,1,"","",{"B-"},{0},{"="},{0},14476.54,1.2,20569.94,13.58,-5252.21,7.02,3979.36,1.11,-13875.72,7.2,-6239.96,1.04,5777.23,1,11164.71,3.41,-1322.98,13.49,9275.07,18.3,3376.47,4.68,2718.96,7.02}
,{117,49,-88943.042,4.881,8503.865,0.042,1454.709,4.857,116.904515712,5.239,0,2592,"",18,"",4.5,1,"","",{"B-"},{0},{"="},{0},15549.33,4.88,18538.33,18.91,-4341.14,17.34,-303.5,9.74,-13689.36,5.87,-5488.39,4.88,8764.61,4.89,7519.53,4.88,-8506.96,26.65,9852.24,4.92,5935.95,4.89,1634.16,6.68}
,{117,50,-90397.751,0.483,8509.611,0.004,-1758.212,8.445,116.902954017,0.518,1,"s","","s","",0.5,1,"","",{},{},{},{},16506.55,0.48,16891.21,0.81,-3779.38,0.54,-5302.34,13.46,-8974.24,0.49,-11646.92,5.18,6943.1,0.47,9436.97,0.53,-16212.41,10.39,9849.4,0.48,3036.11,0.57,5263.58,0.55}
,{117,51,-88639.539,8.437,8487.897,0.072,-3544.128,13.079,116.904841535,9.057,0,10080,"",36,"",2.5,1,"","",{"B+"},{0},{"="},{0},17778.77,18.11,13681.13,8.44,-1697.34,8.44,-8203.46,27.34,-7678.76,8.44,-11441.89,29.19,9888.71,9.89,4402.54,8.44,-22146.45,62.98,12105.1,8.44,6784.24,8.44,5576.66,8.44}
,{117,52,-85095.411,13.456,8450.919,0.115,-4659.334,28.673,116.908646313,14.446,0,3720,"",120,"",0.5,1,"","",{"EC","e+"},{0,25,0},{"=","="},{0,25,0},19175.29,31.02,9639.52,13.46,807.81,13.55,-10910.07,16.99,-858.41,13.46,-15674.49,97.52,7897.77,31.02,5562.23,14.41,-27637.66,250.7,12618.8,20.93,4265.22,25.65,11110.71,13.46}
,{117,53,-80436.077,26.196,8404.409,0.224,-6250.74,28.177,116.913648314,28.123,0,133.2,"",2.4,"",0,0,"","",{"B+","e+"},{0,77,0},{"=","~"},{0,77,0},20240.91,38.99,8010.62,30.71,1555.98,31.33,-13942.99,67.69,-902.9,26.7,-15460.67,29.26,11015.16,100.08,2456.09,38.3,-33965,202,12337.49,38.3,6316.55,38.3,9706.9,34.11}
,{117,54,-74185.337,10.378,8344.297,0.089,-7692.245,63.267,116.92035876,11.141,0,61,"",2,"",0,0,"","",{"B+","B+p"},{0,0.0029,0},{"=","="},{0,0.0029,0},21671.22,15.95,6700.52,29.81,1736.78,29.81,-16727.58,250.55,3794.65,29.81,-20214,101,9209.93,16.67,3982.07,97.15,"","",12863.27,30.68,3475,149,13349.63,29.81}
,{117,55,-66493.092,62.41,8271.864,0.533,-9035.338,258.002,116.928616726,67,0,8.4,"",0.6,"",4.5,1,"","",{"B+"},{0},{"="},{0},22936,120,4733.24,68.77,2201.5,62.92,-20022,210,3710.17,115,-19984,210,12522,118,735.34,63.76,"","",12874.46,63.57,5456.85,63.4,11950,162}
,{117,56,-57457.753,250.34,8187.953,2.14,-10987,321,116.938316561,268.75,0,1.75,"",0.07,"",0,0,"","",{"B+","B+p","B+A"},{0,13,0,0.024,0},{"=","=","="},{0,13,0,0.024,0},24581,321,3378.95,250.63,2320.95,250.43,"","",8300,250,-24884,400,10949,321,2704,270,"","",12953,270,2088.56,260.24,15274.54,250.59}
,{117,57,-46471,200,8087,2,"","",116.950111,215,0,0.0217,"",0.0018,"",1.5,1,"","",{"p","B+"},{"","",""},{"",""},{"","",""},"","",1349,225,2869,200,"","",8283,224,"","",13897,371,-820.1,3,"","",13260,283,4299,225,13858,213}
,{118,42,-32630,500,8069,4,11159,641,117.96497,537,0,0.021,"",0.006,"",0,1,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},7273,707,"","","","",24630,539,"","",7680,641,4532,707,"","",42759,500,"","",3588,709,"",""}
,{118,43,-43790,401,8157,3,13470,448,117.95299,430,0,0.03,"",0.004,"",2,1,"","",{"B-","B-n","B-2n"},{0,30,0,"",""},{"=","=",""},{0,30,0,"",""},8476,499,"","",-10827,643,21098,401,"","",7629,590,3479,566,14909,641,35764,401,8421,641,5823,566,-6789,643}
,{118,44,-57260,200,8265,2,7628,202,117.938529,215,0,0.099,"",0.003,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},9334,200,30338,539,-9878,359,18129,200,-28379,539,3566,200,5841,477,16167,448,29442,201,4907,359,3924,814,-6864,448}
,{118,45,-64887.46,24.235,8322.858,0.205,10501.286,24.342,117.930340443,26.017,0,0.284,"",0.009,"",4,-1,"","",{"B-","B-n"},{0,3.1,0},{"=","="},{0,3.1,0},10293.97,77.7,28010,299,-8712.09,433.82,14666.33,24.37,-23795,401,3465.7,25.27,4061.4,25.78,12686.57,433.82,22340.75,25.44,9892.26,24.52,6166.33,91.75,-2921.07,789.81}
,{118,46,-75388.746,2.491,8405.222,0.021,4165.046,3.539,117.919066847,2.673,0,1.9,"",0.1,"",0,1,"","",{"B-"},{0},{"="},{0},11699.75,7.49,25897.78,4.48,-7591.85,4.23,11312.89,20.16,-23187.85,433.15,-1278.05,13.79,7035.59,7.61,13780.34,9.18,16264.11,2.53,6058.18,73.87,3705.14,7.67,-3552.61,88.53}
,{118,47,-79553.792,2.515,8433.889,0.021,7147.849,20.158,117.914595487,2.7,0,3.76,"",0.15,"",1,-1,"","",{"B-"},{0},{"="},{0},13153.77,4.12,23395.61,73.87,-6268.08,71.61,7674.42,8.15,-17945.39,9.24,-1206.72,2.71,5443.09,13.8,10418.28,7.68,8442.42,3.93,10988.65,7.56,5736.65,13.78,322.44,7.74}
,{118,48,-86701.641,20.001,8487.834,0.169,526.57,21.45,117.906921955,21.471,0,3018,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},14131.79,20,21447.95,21.23,-5635.61,21.17,4951.21,20.01,-17566.13,21.27,-5829.92,20.59,8354.57,20.02,11808.6,24.17,994.94,27.23,6551.82,20.26,3145.07,27.09,-628.85,24.16}
,{118,49,-87228.211,7.752,8485.667,0.066,4424.643,7.74,117.906356659,8.322,0,5,"",0.5,"",1,1,"","",{"B-"},{0},{"="},{0},15121.1,7.76,19263.5,8.41,-4722.33,9,768,8.29,-12335.17,15.63,-4901.78,7.74,6356.49,6.02,8098.79,7.82,-6257.16,21.23,12195.08,7.75,5720.32,7.78,3400.84,19.84}
,{118,50,-91652.853,0.499,8516.533,0.004,-3656.64,2.975,117.901606609,0.536,1,"s","","s","",0,1,"","",{},{},{},{},16269.52,0.49,17518.31,0.51,-4062.84,0.57,-3956.27,18.49,-12523.44,1.12,-11084.63,8.45,9326.42,0.13,9998.78,4.86,-13573.8,10.39,7307.7,0.55,2747.55,0.5,2078.03,0.82}
,{118,51,-87996.213,3.016,8478.915,0.026,-299.63,18.726,117.905532174,3.238,0,216,"",6,"",1,1,"","",{"B+"},{0},{"="},{0},17316.7,5.98,14324.41,3.02,-1851.33,3.03,-7025.17,19.99,-6342.14,5.7,-10972.12,13.79,7427.99,8.95,4887.43,2.98,-19586.85,13.1,14240.56,3.01,6901.68,3.02,7186.53,3.02}
,{118,52,-87696.584,18.481,8469.746,0.157,-6725.536,27.056,117.905853839,19.84,0,518400,"",1728,"",0,1,"","",{"EC"},{0},{"="},{0},18570.26,33.5,10748.56,18.48,438.22,18.48,-9617.53,21.2,-4587.8,18.49,-15331.82,32.06,10672.49,22.86,6346.02,20.32,-25342,196,9836.37,19.16,4170.87,24.46,7983.65,18.48}
,{118,53,-80971.048,19.76,8406.12,0.167,-2891.991,22.32,117.913074,21.213,0,822,"",30,"",2,-1,"","",{"B+"},{0},{"="},{0},19621.45,98.59,8726.84,20.42,1100.61,29.45,-12561.68,23.52,379.52,21.49,-14857.03,22.32,8606.29,32.81,3164.61,23.91,-31411,301,15008.72,34.23,5955.77,34.23,11678.76,25.44}
,{118,54,-78079.057,10.378,8374.981,0.088,-9669.689,16.442,117.91617868,11.141,0,228,"",54,"",0,1,"","",{"B+"},{0},{"="},{0},21174.97,16.67,7388.04,29.81,1384.6,29.81,-15725,196,-272.62,16.99,-19657.28,63.27,11965.04,14.68,4931.95,28.18,"","",10123.99,97.15,3122.79,30.68,9630.1,29.81}
,{118,55,-68409.367,12.753,8286.404,0.108,-6055,196,117.926559519,13.69,0,14,"",2,"",0,0,"","",{"B+","B+p","B+A"},{0,0.021,0,0.0012,0},{"=","=","="},{0,0.021,0,0.0012,0},22509,101,5495.07,97.43,1962,150,-18849,300,4737.74,29.14,-19022.93,250.66,9987.59,63.7,1513,16.44,"","",15348.16,18.24,5111.44,17.59,13574.83,31.57}
,{118,56,-62354,196,8228,2,-12794,358,117.93306,210,0,5.2,"",0.2,"",0,1,"","",{"B+"},{0},{"="},{0},23917,280,3885,196,2307,196,"","",4542,196,-23955,280,12968,318,3150,205,"","",10399,220,2209,221,11949,196}
,{118,57,-49560,300,8113,3,"","",117.946795,322,0,0.2,"","s","",0,0,"","",{},{},{},{},25057,433,2095,316,2697,308,"","",9644,306,"","",11161,361,-609,391,"","",15731,361,4324,361,15786,317}
,{119,43,-40371,503,8128,4,12193,585,118.95666,540,0,0.022,"",0.003,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,30,0,"",""},{"=","=",""},{0,30,0,"",""},8132,643,"","",-11442,711,22452,503,"","",8818,541,4653,643,15030,709,38275,503,6510,709,5993,709,"",""}
,{119,44,-52564,298,8224,3,10259,298,118.94357,320,0,0.0695,"",0.002,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,3,0,0,0},{"=","=","="},{0,3,0,0,0},9217,526,30972,582,-10240,499,18844,298,-27223,582,4252,299,3376,359,16064,499,31413,300,6528,499,3756,422,-5418,582}
,{119,45,-62822.794,9.315,8303.394,0.078,8585.108,12.44,118.932556952,10,0,0.19,"",0.006,"",3.5,1,"","",{"B-","B-n"},{0,6.4,0},{"=","="},{0,6.4,0},10068.06,12.88,29019,401,-8927.72,789.5,15822.97,17.4,-26322,401,4494.63,9.64,6006.65,25.96,12852,200,24876.49,11.84,7377.88,433.24,6110.17,10.03,-5721,298}
,{119,46,-71407.902,8.245,8368.964,0.069,7237.863,16.855,118.923340459,8.851,0,0.92,"",0.08,"",1.5,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},11126.06,10.91,26495.98,433.22,-7643.08,88.87,12569.17,38.58,-21437,200,74.57,8.62,4090.47,8.56,13809.41,25.57,18657.12,8.27,8200.28,12.06,4192.28,74.28,-1692.59,9.05}
,{119,47,-78645.765,14.703,8423.212,0.124,5331.303,35.926,118.915570293,15.783,0,6,"",0.5,"",0.5,-1,"","",{"B-"},{0},{"="},{0},12606.39,20.01,24326.33,17.18,-6840.85,16.42,9053.52,16.33,-21047.28,28.35,-15.44,24.82,7163.29,14.92,10545.99,14.91,10828.41,16.6,8489.52,16.39,6049.92,16.34,-2263.24,75.28}
,{119,48,-83977.068,37.695,8461.438,0.317,3722.212,38.088,118.909846903,40.467,0,161.4,"",1.2,"",0.5,1,"","",{"B-"},{0},{"="},{0},13701.31,37.71,22130.53,38.38,-5975.6,40.05,6087.95,37.7,-15877.29,37.77,-4820.18,38.36,5346.74,42.67,11712.25,37.78,3204.11,38.53,8915.75,40.06,3429.64,37.84,1500.97,38.36}
,{119,49,-87699.281,7.307,8486.143,0.061,2365.742,7.336,118.905850944,7.844,0,144,"",6,"",4.5,1,"","",{"B-"},{0},{"="},{0},14898.87,5.84,20095.21,15.41,-5141.54,19.67,1774.9,10.61,-15434.46,7.73,-4117.74,7.32,8542.39,8.38,8286.61,21.29,-3933.75,28.88,9429.91,7.38,5877.25,7.31,489.77,8}
,{119,50,-90065.022,0.725,8499.449,0.006,-590.843,7.689,118.903311216,0.778,1,"s","","s","",0.5,1,"","",{},{},{},{},15809.91,0.56,18224.57,1.24,-4405.46,0.97,-2883.84,7.94,-10652.35,20.01,-10140.13,3.02,6483.49,0.55,10125.78,7.72,-11270.61,10.4,9588.83,4.89,3048.78,0.76,4293.86,0.73}
,{119,51,-89474.18,7.701,8487.91,0.065,-2293,2,118.903945512,8.267,0,137484,"",792,"",2.5,1,"","",{"EC"},{0},{"="},{0},16977.27,11.42,15109.08,9.09,-2362.75,7.7,-5708.65,28.99,-9534.94,10.9,-9848.91,20.02,9549.28,8.24,5110.3,7.69,-17169.13,15.93,11634.38,7.69,6915.85,7.7,4421.97,7.7}
,{119,52,-87181.18,7.957,8462.066,0.067,-3415.65,29.055,118.906407148,8.541,0,57780,"",180,"",0.5,1,"","",{"EC","e+"},{0,2.06,0},{"=","="},{0,2.06,0},18228.4,15.63,11361.37,7.94,427.74,7.96,-8386.77,13.08,-2817.3,7.94,-14281.45,21.3,7555.91,20.12,6473.94,8.48,-22591.09,200.43,12169.17,11.59,4505.03,9.48,9991.19,7.96}
,{119,53,-83765.53,27.945,8426.789,0.235,-4971.117,29.81,118.910074,30,0,1146,"",24,"",2.5,1,"","",{"e+","EC"},{0,49,0},{"=","="},{0,49,0},19472.09,38.3,9703.93,29.19,812.96,32.21,-11460.48,31.23,-3058.29,28.11,-13757.79,29.81,10865.8,34.23,3357.92,33.5,-28976,301,12040.69,31.02,6367.49,39.52,8703.02,28.42}
,{119,54,-78794.413,10.378,8378.441,0.087,-6489.361,17.379,118.915410713,11.141,0,348,"",18,"",0,0,"","",{"e+","EC"},{0,21,0},{"=","="},{0,21,0},20751.71,14.68,8276.94,16.99,843.43,29.81,-14204.33,200.54,1613.2,21.2,-18456.36,16.44,8786.67,14.68,5112.34,22.32,-34854,500,12352.47,28.18,3561.88,97.15,12120.95,29.81}
,{119,55,-72305.051,13.94,8317.334,0.117,-7714.965,200.754,118.92237733,14.965,0,43,"",0.2,"",4.5,1,"","",{"B+","B+A"},{0,2,0},{"=","<"},{0,2,0},21954.59,63.95,6446.92,29.67,1607.83,32.06,-17516,300,1377.03,24.18,-18022,196,11967,18.89,1514.97,17.38,"","",12591.09,17.38,5605.73,19.09,10833.59,97.59}
,{119,56,-64590.086,200.269,8245.928,1.683,-9801,361,118.930659686,214.997,0,5.4,"",0.3,"",2.5,1,"","",{"B+","B+p"},{0,25,0},{"=","="},{0,25,0},23274.97,320.59,4982.69,200.54,1641.75,200.63,-20650,539,6200,200,-23101,361,10307,280,3469.69,200.67,"","",12613.81,209.77,2317,224,14103.04,200.69}
,{119,57,-54790,300,8157,3,-10849,583,118.941181,322,0,1,"","s","",5.5,-1,"","",{},{},{},{},24461,361,2874,306,2485,317,"","",6331,300,"","",13301,424,-276,358,"","",13379,391,4654,361,12899,316}
,{119,58,-43940,500,8059,4,"","",118.952828,537,0,0.2,"","s","",2.5,1,"","",{},{},{},{},"","",1061,559,2655,539,"","",11125,537,"","","","",1669,583,"","",13241,539,1569,590,16286,539}
,{120,43,-35518,503,8087,4,14494,643,119.96187,540,0,0.021,"",0.005,"",0,0,"","",{"B-","B-n","B-2n"},{0,30,0,2,0},{"=","=","="},{0,30,0,2,0},7871,643,"","","","",23297,540,"","",8975,585,3218,711,"","",40134,503,7823,709,5516,709,"",""}
,{120,44,-50012,401,8201,3,8803,446,119.94631,430,0,0.045,"",0.002,"",0,1,"","",{"B-","B-n"},{0,4,0},{"=","="},{0,4,0},8895,448,31960,641,-10937,641,20268,401,"","",4740,401,5519,499,16930,643,33945,401,4488,566,3234,566,-8196,641}
,{120,45,-58815,196,8268,2,11466,196,119.93686,210,0,0.1296,"",0.0042,"",0,0,"","",{"B-","B-n","B-2n"},{0,5.4,0,0,0},{"=","<","="},{0,5.4,0,0,0},10070,197,29603,446,-9784,357,16837,196,-25733,540,4522,196,4063,196,13539,357,26914,200,9156,280,5539,475,-4786,446}
,{120,46,-70280.05,2.291,8357.085,0.019,5371.451,5.024,119.924551258,2.459,0,0.492,"",0.033,"",0,1,"","",{"B-","B-n"},{0,0.7,0},{"=","<"},{0,0.7,0},11033.94,3.28,27598,200,-8636.06,4.37,13677.3,4.37,-25005,298,294.4,14.88,6943.47,8.49,14746.23,9.59,20818.32,2.22,5318.22,24.32,3481.38,9.12,-5143.78,433.15}
,{120,47,-75651.502,4.471,8395.327,0.037,8305.853,5.82,119.918784767,4.8,0,1.52,"",0.07,"",0,0,"","",{"B-","B-n"},{0,0.003,0},{"=","<"},{0,0.003,0},12240.34,5.13,25341.98,24.64,-7340.3,73.97,10076.87,40.26,-20117.68,10.33,254.25,37.96,5077.05,15.37,11532.57,9.38,12766.26,8.47,10448.05,5.12,5637.03,8.52,-1107.73,9.95}
,{120,48,-83957.354,3.726,8458.023,0.031,1771.015,40.183,119.909868067,4,0,50.8,"",0.21,"",0,1,"","",{"B-"},{0},{"="},{0},13398.35,20.34,23146.55,4.48,-6550.64,8.05,7141.01,3.83,-19838.42,9.05,-4329.39,8.2,8051.6,37.88,12600.56,15.17,5410.63,4.84,6307.24,4.5,3088.71,14.07,-1886.48,8.15}
,{120,49,-85728.369,40.01,8466.262,0.333,5370,40,119.907966805,42.952,0,3.08,"",0.08,"",1,1,"","",{"B-"},{0},{"="},{0},14642.79,40.75,20752.52,40.09,-5610.63,40.14,2689.39,40.63,-14371.57,42.63,-3734.66,40.01,6100.41,40.65,9040.27,54.97,-1975.38,42.84,11684.08,44.73,5554.07,40.02,2100.05,42.25}
,{120,50,-91098.369,0.896,8504.492,0.007,-2680.608,7.14,119.902201873,0.962,1,"s","","s","",0,1,"","",{},{},{},{},15588.15,1,18974.67,20.02,-4810.8,0.91,-1730.38,3.17,-14410.27,37.7,-9695.51,7.75,9104.66,1.09,10688.06,7.25,-8925.95,11.85,6840.65,7.8,2708.73,4.96,966.42,1.35}
,{120,51,-88417.761,7.196,8475.635,0.06,950.226,7.811,119.905079624,7.725,0,953.4,"",2.4,"",1,1,"","",{"B+"},{0},{"="},{0},16564.18,7.8,15767.49,10.57,-2592.93,7.2,-4664.77,16.91,-8007.45,10.18,-9307.9,10.72,7014.9,10.54,5641.71,7.22,-14529.12,12.3,13945.9,7.21,6844.04,7.21,6171.68,8.69}
,{120,52,-89367.987,3.085,8477.034,0.026,-5615,15,119.904059514,3.311,1,"s","","s","",0,1,"","",{},{},{},{},17814.04,18.22,12293.07,3.12,-266.93,3.09,-7195.56,12.21,-6591.94,3.17,-13673.77,28.11,10258.12,8.53,7182.78,8.3,-20479.35,300.18,9339.03,4.31,4135.61,8.98,6676.17,3.12}
,{120,53,-83752.987,15.314,8423.722,0.128,-1580.563,19.343,119.910087465,16.44,0,4900.2,"",10.8,"",2,-1,"","",{"B+"},{0},{"="},{0},18924.57,25,10334.71,15.61,644.25,16.13,-9864.35,18.27,-1567.78,17.14,-13029.89,18.5,8058.77,31.87,3860.78,17.26,-26183,300,14654.4,23.6,6206.48,20.39,10532.95,17.48}
,{120,54,-82172.423,11.817,8404.031,0.098,-8283.785,15.461,119.91178427,12.686,0,2760,"",36,"",0,1,"","",{"B+"},{0},{"="},{0},20236,15.73,9053.78,21.94,671.62,30.34,-13283.78,300.4,-2280.21,14.25,-17938.69,18.27,11449.33,15.73,5695.86,30.34,-32572,500,9509.43,23.02,3127.71,28.74,8569.39,17.91}
,{120,55,-73888.639,9.97,8328.48,0.083,-5000,300,119.920677279,10.702,0,60.4,"",0.6,"",0,0,"","",{"B+","B+A","B+p"},{0,2,0,7,0},{"=","<","<"},{0,2,0,7,0},21621.91,16.19,7495.53,22.13,1178.68,97.1,-16319,300,2587.92,29.67,-17369.87,200.52,9654.9,17.14,2383.2,14.39,"","",14901.22,14.39,5160.75,14.39,12193.84,28.03}
,{120,56,-68888.639,300.166,8280.294,2.501,-11319,424,119.926045,322.241,0,24,"",2,"",0,1,"","",{"B+"},{0},{"="},{0},22677,358,5387.52,300.34,1733.17,300.45,-19288,583,2616.8,300.34,-22170,424,12369.87,360.84,3872.56,300.49,"","",10231.53,300.44,2468.51,306.59,10943.1,300.34}
,{120,57,-57570,300,8179,2,-7970,583,119.938196,322,0,2.8,"",0.2,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},24153,424,3739,300,2048,316,"","",7446,300,-21701,583,10852,424,269,361,"","",15495,358,4752,391,14569,306}
,{120,58,-49600,500,8107,4,"","",119.946752,537,0,0.25,"","s","",0,1,"","",{},{},{},{},"","",1824,537,2555,539,"","",7701,539,"","",13731,707,2100,583,"","",10671,583,1735,539,13504,559}
,{121,43,-31780,500,8056,4,13267,641,120.965883,537,0,0.022,"",0.006,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,50,0,"",""},{"=","=",""},{0,50,0,"",""},7551,709,"","","","",24470,796,"","",10161,641,4333,709,"","",42623,500,"","",5715,707,"",""}
,{121,44,-45047,401,8159,3,11203,738,120.95164,430,0,0.029,"",0.002,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,6,0,0,0},{"=","=","="},{0,6,0,0,0},8625,499,"","",-11302,641,21135,401,"","",5696,446,3106,566,16818,643,36027,401,6035,643,3607,566,-6770,641}
,{121,45,-56250.128,619.444,8245.239,5.119,9932.201,619.453,120.939613,665,0,0.076,"",0.005,"",3.5,1,"","",{"B-","B-n"},{0,7,0},{"=","="},{0,7,0},9569.97,619.51,30457,798,-10293,738,18152.69,619.56,-28021,798,5958.6,619.45,5507,650,13527,738,29585.85,620.05,7025,687,5874,651,-6814,738}
,{121,46,-66182.329,3.353,8320.858,0.028,8220.492,12.565,120.928950343,3.6,0,0.29,"",0.001,"",1.5,1,"","",{"B-","B-n"},{0,0.8,0},{"=","<"},{0,0.8,0},10917.06,8.9,28196,298,-9117.38,433.16,14891.5,3.88,-23459,401,1397.86,5.59,3973.6,4.06,14657,196,23014.94,3.49,7351.27,9.9,3569.19,24.47,-3276,200}
,{121,47,-74402.821,12.109,8382.33,0.1,6671.005,12.264,120.920125282,13,0,0.78,"",0.02,"",3.5,1,"","",{"B-","B-n"},{0,0.08,0},{"=","="},{0,0.08,0},11899.69,19.05,26157.97,15.28,-7930.36,15.02,11433.15,29.97,-22877,196,1483.22,12.67,6822.64,12.91,11411.74,12.32,15197.5,12.38,7715.89,14.65,5849.98,12.36,-3868.96,27.09}
,{121,48,-81073.826,1.942,8430.996,0.016,4762.148,27.483,120.912963663,2.085,0,13.5,"",0.3,"",1.5,1,"","",{"B-"},{0},{"="},{0},13239.39,37.75,24243.87,8.47,-7074.26,7.51,8123.44,2.16,-18082.75,3,-3416.77,40.06,5187.79,4.2,12711.29,4.87,7471.68,25.92,8282.75,14.83,3344.02,3.18,-38.68,3.16}
,{121,49,-85835.974,27.414,8463.887,0.227,3361.291,27.408,120.907851286,29.43,0,23.1,"",0.6,"",4.5,1,"","",{"B-"},{0},{"="},{0},14279.33,28.35,21768.15,31.11,-6078.88,30.59,3764.35,27.52,-17473.44,27.78,-2808.92,27.41,8178.92,48.49,9167.59,27.67,415.48,27.92,8851.9,46.61,5729.72,33.93,-635.78,27.53}
,{121,50,-89197.265,0.955,8485.201,0.008,403.057,2.69,120.904242792,1.025,0,97308,"",144,"",1.5,1,"","",{"B-"},{0},{"="},{0},15274.88,1.14,19798.14,37.7,-5203.79,1.39,-651.76,25.86,-12528.88,3.85,-8850.82,7.15,6170.21,0.34,10757.87,40,-6716.28,10.29,9212.82,7.26,2895,7.8,3150.78,20.02}
,{121,51,-89600.321,2.582,8482.066,0.021,-1054.819,25.767,120.903810093,2.771,1,"s","","s","",2.5,1,"","",{},{},{},{},16268.78,8.12,16478.98,7.73,-3082.2,5.52,-3348.87,5.56,-11160.92,40.09,-8303.65,3.43,9253.88,7.62,5790.92,2.67,-12497.99,14.52,11175.51,2.68,6916.59,2.63,3274.29,8.17}
,{121,52,-88545.502,25.85,8466.883,0.214,-2294.053,26.047,120.904942488,27.751,0,1656288,"",3456,"",0.5,1,"","",{"B+"},{0},{"="},{0},17506.96,27.05,13058.42,25.86,-572.67,25.85,-6064.52,27.81,-4736.1,25.86,-12863.83,29.91,7248.83,25.87,7416.71,26.83,-17800.67,144.23,11639.48,26.97,4314.77,26.03,8753.75,25.86}
,{121,53,-86251.449,5.356,8441.458,0.044,-3770.463,11.558,120.907405255,5.749,0,7632,"",36,"",2.5,1,"","",{"B+"},{0},{"="},{0},18628.55,28.45,11355.21,9.38,-36.83,9.99,-9149.12,15.26,-5122.66,8.95,-12150.34,12.97,10569.78,15.63,4172.43,4.39,-24061,300,11640.54,9.59,6309.19,18.74,7391.17,6.15}
,{121,54,-82480.986,10.243,8403.832,0.085,-5378.654,13.979,120.911453014,10.995,0,2406,"",120,"",0,0,"","",{"B+"},{0},{"="},{0},19829.21,14.58,9877.75,12.97,189.51,16.91,-11736.15,141.87,-401.97,10.7,-16663.66,14.29,8379.88,15.64,6016.97,18.42,-29791,401,11995.35,29.76,3354.12,22.26,10862,21.13}
,{121,55,-77102.331,14.29,8352.914,0.118,-6357.495,141.176,120.917227238,15.34,0,155,"",4,"",0,0,"","",{"B+"},{0},{"="},{0},20939.91,19.96,7914.74,31.39,908.83,29.84,-14912,300,-638.32,20.95,-16285.01,300.51,11285.01,17.42,2218.88,18.54,-35681,501,12402.89,17.66,5840.78,17.66,9515.12,24.39}
,{121,56,-70744.837,141.898,8293.907,1.173,-8555,332,120.924052289,152.333,0,29.7,"",1.5,"",0,0,"","",{"B+","B+p"},{0,0.02,0},{"=","="},{0,0.02,0},22297.38,245.44,6528.37,142.28,1015.58,142.28,-18055,425,4138.62,142.39,-21246,332,9927.52,332.02,4145.17,142.25,"","",12271.02,142.58,2528.59,142.47,12980.62,142.28}
,{121,57,-62190,300,8217,2,-9500,500,120.933236,322,0,5.3,"",0.2,"",5.5,-1,"","",{"B+"},{0},{"="},{0},23543,424,4463,300,1878,306,-20769,583,4409,300,-20661,583,12692,424,591,424,"","",13111,361,5028,358,11866,300}
,{121,58,-52690,401,8132,3,-11268,641,120.943435,430,0,1.1,"",0.1,"",0,0,"","",{"B+","B+p"},{0,1,0},{"=","~"},{0,1,0},24892,641,2678,448,2343,472,"","",8910,501,"","",11161,641,2409,500,"","",12810,500,1734,500,15311,446}
,{121,59,-41422,500,8032,4,"","",120.955532,537,0,0.012,"",0.005,"",0,0,"","",{"p"},{0},{"~"},{0},"","",1210,583,2624,539,"","",8859,583,"","","","",-889.6,10,"","",13230,707,"","",13785,583}
,{122,44,-42150,500,8135,4,9930,583,121.95475,537,0,0.025,"",0.001,"",0,1,"","",{"B-","B-n","B-2n"},{0,7,0,0,0},{"=","=","="},{0,7,0,0,0},8281,641,"","",-11945,707,22466,501,"","",6029,796,5174,641,17659,707,38462,500,4079,709,3085,709,"",""}
,{122,45,-52080,300,8210,2,12536,301,121.94409,322,0,0.051,"",0.006,"",0,0,"","",{"B-","B-n","B-2n"},{0,10,0,"",""},{"=","=",""},{0,10,0,"",""},9408,358,31140,586,-10715,500,19026,302,-27589,583,6031,300,3901,688,14322,500,31493,304,8643,500,5348,423,-6062,586}
,{122,46,-64616.161,19.561,8305.975,0.16,6489.948,42.909,121.930631694,21,0,0.195,"",0.005,"",0,1,"","",{"B-","B-n"},{0,2.5,0},{"=","<"},{0,2.5,0},10478.74,19.7,29182,401,-9781,201,15996.21,19.7,-26858,401,1715.34,23.01,6505.15,19.85,15655,619.75,25325.17,19.71,4909,197,3070.69,21.67,-6406,299}
,{122,47,-71106.108,38.191,8352.758,0.313,9506.265,38.26,121.923664448,41,0,0.529,"",0.013,"",3,1,"","",{"B-","B-n"},{0,0.186,0},{"=","="},{0,0.186,0},11597.24,38.45,26870,199,-8643.56,45.23,12466.63,62.96,-22144.95,620.62,1896.4,38.24,4774.6,40.07,12212.75,38.34,17229.26,38.28,9884.75,38.26,5165.85,39.07,-2636.91,39.31}
,{122,48,-80612.374,2.299,8424.266,0.019,2960.368,50.11,121.913459052,2.468,0,5.24,"",0.03,"",0,1,"","",{"B-"},{0},{"="},{0},12797.65,4.38,24910.26,3.25,-7648.54,3.39,9328.96,3.32,-21719.02,4.07,-2847.72,27.51,7609.86,3.01,13498.52,12.33,9702.09,2.75,5749.93,5.03,2897.45,14.88,-3558.07,8.56}
,{122,49,-83572.741,50.057,8442.118,0.41,6368.592,50,121.910280966,53.738,0,1.5,"",0.3,"",1,1,"","",{"B-"},{0},{"="},{0},13987.01,64.07,22499.18,50.26,-6443.87,50.12,4762.63,50.11,-16458.89,51.5,-2446.79,50.05,5808.08,56.97,9787.89,50.09,2507.72,50.32,11095.42,50.2,5268.38,62.66,719.43,52.17}
,{122,50,-89941.333,2.395,8487.907,0.02,-1605.963,3.384,121.903444001,2.57,1,"s","","s","",0,1,"","",{},{},{},{},14985.6,2.33,20561.92,4.43,-5664.61,20.14,373.13,2.66,-16156.48,3.08,-8412.33,3.39,8815.39,2.33,11394.33,27.31,-4586.36,11.37,6497.84,40.07,2622,7.62,-317.86,37.77}
,{122,51,-88335.37,2.578,8468.331,0.021,1979.089,2.127,121.905168074,2.768,0,235336.32,"",17.28,"",2,-1,"","",{"B-","B+"},{0,2.41,0},{"=","="},{0,2.41,0},16060.24,7.62,17184.94,40.09,-3532.08,8.17,-2254.91,5.43,-9788.37,27.52,-7861.19,25.77,6806.37,0.13,6427.08,2.69,-10190.61,33.79,13473.8,2.67,6593.71,2.67,5010.31,7.73}
,{122,52,-90314.46,1.507,8478.14,0.012,-4234,5,121.903043434,1.617,1,"s","","s","",0,1,"","",{},{},{},{},17089.11,2.69,13794.03,1.67,-1086.52,1.58,-4959.48,11.21,-8406.17,1.7,-12134.33,5.14,9840.27,25.81,8003.11,2.13,-15705.52,27.99,8814.11,7.33,4023.77,7.85,5396.96,1.67}
,{122,53,-86080.46,5.222,8437.023,0.043,-725.483,12.277,121.90758882,5.606,0,217.8,"",3.6,"",1,1,"","",{"e+","EC"},{0,22,0},{"=","="},{0,22,0},18470.11,16.04,12240.64,8.87,-509.16,6.03,-7935.7,34.09,-3769.11,5.44,-11670.79,11.5,7900.33,7.17,4823.93,26.29,-21537,298,13998.33,5.68,5964.77,9.52,9040.12,9.3}
,{122,54,-85354.977,11.111,8424.664,0.091,-7210.218,35.472,121.908367658,11.928,0,72360,"",360,"",0,1,"","",{"EC"},{0},{"="},{0},19325.19,16.22,10564.93,11.53,-83.31,21.56,-10746.03,30.07,-4098.45,28.14,-16323.96,18.1,10945.31,15.11,6392.5,12.33,-27481,401,9108.82,18.92,3274.61,30.07,7472.6,13.67}
,{122,55,-78144.759,33.687,8359.151,0.276,-3535.815,43.769,121.916108145,36.164,0,21.18,"",0.19,"",1,1,"","",{"B+","B+A"},{0,2,0},{"=","<"},{0,2,0},20398.75,35.13,8969.71,37,401.37,39.05,-13602,300,817.72,34.11,-15471.24,145.84,9113.74,36.59,2952.74,35.21,-33365,501,14738.47,35.7,5513.71,35.25,11267.17,43.77}
,{122,56,-74608.944,27.945,8323.756,0.229,-10066,299,121.919904,30,0,117,"",9,"",0,1,"","",{"B+"},{0},{"="},{0},21862.94,301.46,7014.46,30.34,1045.2,29.81,-16735,402,583.07,29.76,-20490,301,11935.42,144.62,4795.58,31.39,"","",9990.5,29.67,2560.16,31.23,9831.87,29.81}
,{122,57,-64543,298,8235,2,-6669,499,121.93071,320,0,8.6,"",0.5,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23116,423,5233,298,1441,298,-19764,582,5270,298,-19925,499,10424,423,1087,330,"","",15056,423,4911,359,13408,298}
,{122,58,-57874,401,8174,3,-13094,641,121.93787,430,0,2,"","s","",0,1,"","",{},{},{},{},24416,641,3563,501,2056,446,"","",5582,425,-24523,641,13255,566,2972,500,"","",10407,500,1780,500,12363,448}
,{122,59,-44780,500,8060,4,"","",121.951927,537,0,0.5,"","s","",0,0,"","",{},{},{},{},"","",1788,583,2356,583,"","",10122,583,"","",11429,707,-621,641,"","",15531,707,4025,707,15656,583}
,{123,44,-37080,500,8093,4,12280,640,122.960193,537,0,0.019,"",0.002,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,20,0,"",""},{"=","=",""},{0,20,0,"",""},8176,641,"","","","",23350,935,"","",6929,583,3001,707,"","",40334,500,5411,707,3302,709,"",""}
,{123,45,-49360,400,8186,3,11070,885,122.94701,429,0,0.042,"",0.004,"",3.5,1,"","",{"B-","B-n","B-2n"},{0,20,0,0,0},{"=","=","="},{0,20,0,0,0},9252,737,32158,640,-11414,642,20188,401,"","",7185,400,5351,500,14499,640,34070,400,6398,566,5516,566,-8196,642}
,{123,46,-60429.742,789.441,8270.031,6.418,9118.336,790.039,122.935126,847.5,0,0.108,"",0.002,"",1.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10390.05,789.45,29961,885,-10290,844,16984.44,789.45,-25569,935,2605.05,790.36,3884.9,789.68,15639,845,27386.44,789.44,6531.19,1003.46,3249,813,-4771,885}
,{123,47,-69548.078,30.739,8337.803,0.25,7866.103,30.857,122.925337062,33,0,0.3,"",0.005,"",3.5,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},11287.89,33.04,27875.89,620.21,-9150.2,32.12,13882.27,36.58,-24757,302,2992.98,30.83,6513.29,49.03,12220.89,36.44,19675.99,30.78,7345.06,30.92,5596.03,30.82,-5087,198}
,{123,48,-77414.181,2.696,8395.395,0.022,6016.172,19.893,122.916892453,2.894,0,2.1,"",0.02,"",1.5,1,"","",{"B-"},{0},{"="},{0},12482.99,3.32,25809.79,4.3,-8431.19,8.67,10402,3.62,-20086.99,19.75,-1912.76,50.13,4873.12,3.54,13597.04,38.29,11757.98,3.09,7699.45,12.41,3101.38,5.22,-1487.73,3.54}
,{123,49,-83430.353,19.827,8437.946,0.161,4385.828,19.839,122.910433826,21.285,0,6.17,"",0.05,"",0,0,"","",{"B-"},{0},{"="},{0},13737.01,33.76,23605.47,23.23,-7209.5,24.68,5793.72,19.87,-19613.22,43.03,-1560.34,19.85,7928.93,53.8,10106.95,19.96,4513.37,20.16,8354.28,19.92,5391.06,20.17,-2132.45,20.33}
,{123,50,-87816.181,2.416,8467.243,0.02,1407.888,2.662,122.905725446,2.594,0,11162880,"",34560,"",5.5,-1,"","",{"B-"},{0},{"="},{0},14761.55,2.37,21320.3,3.1,-6264.03,37.77,1355.98,2.66,-14492.78,3.34,-7552.13,3.39,5946.16,1.15,11532.41,50.01,-2567.48,9.82,8730.6,27.33,2776.24,40.07,1787.57,4.44}
,{123,51,-89224.069,1.506,8472.328,0.012,-51.913,0.066,122.904214016,1.616,1,"s","","s","",3.5,1,"","",{},{},{},{},15766.38,2.13,17966.04,27.44,-3949.7,7.44,-1280.34,3.45,-12940.3,50.07,-6980.93,0.1,8960.02,2.13,6571.71,2.66,-8180.42,12.2,10684,1.7,6738.35,1.67,2150.7,40.03}
,{123,52,-89172.156,1.505,8465.546,0.012,-1228.429,3.445,122.904269747,1.615,1,"s","","s","",0.5,1,"","",{"EC"},{0},{"="},{0},16769.29,25.81,14552.83,1.7,-1532.05,1.66,-3923.46,9.57,-6519.79,2.66,-11163.01,5,6929.01,0.08,8125.76,2.13,-13517.2,12.2,11138.97,2.13,4109.66,7.33,7572.61,1.67}
,{123,53,-87943.727,3.74,8449.198,0.03,-2695.027,9.69,122.90558852,4.014,0,47604.6,"",6.84,"",2.5,1,"","",{"B+"},{0},{"="},{0},17834.91,6.19,12921.35,4.05,-894.46,8.56,-6900.08,12.67,-6897.33,4.05,-10660.07,11.72,9934.59,6.07,4918.24,3.44,-19293,196,11312.58,26.04,6288.31,4.37,6120.43,8.09}
,{123,54,-85248.701,9.537,8420.927,0.078,-4205.055,15.414,122.90848175,10.238,0,7488,"",72,"",0.5,1,"","",{"B+"},{0},{"="},{0},18910.35,14,11281.14,27.52,-492.44,12.42,-9593.75,15.41,-2223.21,9.57,-15175.26,35.01,7965.04,14.64,6457.21,10.79,-24962,298,11713.55,10.86,3368.34,17.99,9765.69,9.94}
,{123,55,-81043.646,12.109,8380.379,0.098,-5388.693,17.125,122.912996062,13,0,352.8,"",1.8,"",0.5,1,"","",{"B+"},{0},{"="},{0},20083.95,18.73,9370.14,13.24,296.97,30.46,-12393,196,-2252.16,13.19,-14506.02,30.46,10970.2,35.8,2977.64,16.43,-30814,400,12148.15,15.86,5992.83,16.92,8355.74,19.52}
,{123,56,-75654.953,12.109,8330.208,0.098,-7004,196,122.918781062,13,0,162,"",24,"",0,0,"","",{"B+"},{0},{"="},{0},21052.75,142.41,7751.91,15.86,714.54,15.95,-15369,298,2411.05,16.43,-19183,298,9117.33,30.46,4799.16,35.8,"","",12158.18,18.73,3097.74,15.69,12163.87,16.92}
,{123,57,-68651,196,8267,2,-8365,357,122.9263,210,0,17,"",3,"",5.5,-1,"","",{"B+"},{0},{"="},{0},22603,358,6127,196,1229,196,-18421,445,2205,198,-18849,446,12179,357,1331,198,"","",12805,242,5102,358,10884,196}
,{123,58,-60286,298,8193,2,-10056,499,122.93528,320,0,3.8,"",0.2,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23739,499,4119,330,1879,359,"","",7034,299,-23578,582,10484,499,3032,422,"","",12615,423,2148,423,14249,423}
,{123,59,-50230,400,8104,3,"","",122.946076,429,0,0.8,"","s","",1.5,1,"","",{},{},{},{},24951,640,2618,500,2135,500,"","",7024,499,"","",13521,640,-355,566,"","",13171,566,4234,640,12987,500}
,{124,44,-33960,600,8068,5,10929,721,123.963542,644,0,0.015,"",0.003,"",0,1,"","",{"B-","B-n","B-2n"},{0,10,0,0,0},{"=","=","="},{0,10,0,0,0},7953,781,"","","","",24429,670,"","",7328,721,4952,781,"","",42741,600,"","",2683,781,"",""}
,{124,45,-44890,400,8149,3,13500,499,123.951809,429,0,0.03,"",0.002,"",0,0,"","",{"B-","B-n","B-2n"},{0,20,0,"",""},{"=","=",""},{0,20,0,"",""},8952,500,"","",-11797,642,21311,472,"","",7469,885,3601,565,15099,640,35981,401,7971,640,5021,566,-7463,640}
,{124,46,-58390,298,8252,2,7810,390,123.937316,320,0,0.088,"",0.015,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9916,299,30818,582,-10803,499,18312,298,-28599,582,3087,300,6031,844,16319,499,29844,298,4401,423,2724,687,-7696,499}
,{124,47,-66200.134,251.503,8308.655,2.028,10501.538,251.521,123.928931229,270,0,0.1779,"",0.0026,"",2,-1,"","",{"B-","B-n"},{0,1.3,0},{"=","="},{0,1.3,0},11236.66,254.39,28698,391,-9811,319,14670.07,253.35,-24129,472,3142.73,251.52,4723.37,253.37,13059.36,828.54,21420.11,251.51,9126.83,252.26,4846.25,251.53,-4303.6,668.55}
,{124,48,-76701.672,2.995,8387.035,0.024,4168.529,30.539,123.917657363,3.215,0,1.25,"",0.02,"",0,1,"","",{"B-"},{0},{"="},{0},12231.93,3.78,26663.45,19.79,-8846.54,3.77,11532.52,3.16,-23560.9,789.45,-1342.64,20.05,7358.81,4.03,14442.56,30.88,13823.65,3.35,5115.24,38.31,2565.2,12.47,-4872.94,4.5}
,{124,49,-80870.201,30.572,8414.343,0.247,7363.992,30.576,123.913182263,32.82,0,3.12,"",0.09,"",3,1,"","",{"B-"},{0},{"="},{0},13440.09,58.65,24342.03,48.92,-7643.61,30.9,6750.05,30.6,-18611.09,43.35,-1125.34,30.66,5511.16,36.43,10744.99,30.69,6495.53,30.66,10452.98,30.66,5067.68,30.63,-820.98,32.88}
,{124,50,-88234.193,1.014,8467.421,0.008,-613.944,1.513,123.905276692,1.088,1,"s","","s","",0,1,"","",{},{},{},{},14435.49,2.39,22199.76,2.51,-6701.75,3.86,2291.13,1.51,-18108.98,2.88,-7081.44,1.51,8489.33,2.39,12092.81,19.83,-572.77,2.01,6049.35,50.06,2465.84,27.41,-1513.97,2.19}
,{124,51,-87620.248,1.507,8456.16,0.012,2905.073,0.132,123.905935789,1.618,0,5201280,"",2592,"",3,-1,"","",{"B-"},{0},{"="},{0},15427.51,2.13,18625.45,50.07,-4316.8,40.03,-254.51,1.86,-11478.87,19.87,-6519.41,0.09,6467.5,0.06,7093.04,2.66,-5888.91,8.44,13031.89,2.66,6441.07,1.7,3862.13,27.44}
,{124,52,-90525.321,1.502,8473.279,0.012,-3159.587,1.859,123.902817064,1.612,1,"s","","s","",0,1,"","",{},{},{},{},16353.5,0.12,15161.93,2.66,-1851.87,1.66,-2863.9,2.15,-9998.11,2.66,-10652.91,3.45,9424.48,0.09,8590.22,0.12,-11435.55,12.59,8520.86,2.13,3939.06,2.13,4318.34,1.69}
,{124,53,-87365.734,2.39,8441.489,0.019,295.686,2.846,123.906209021,2.566,0,360806.4,"",25.92,"",2,-1,"","",{"B+"},{0},{"="},{0},17427.91,5.34,13608.31,2.83,-1372.89,7.56,-5634.4,8.64,-5430.64,1.86,-10188.35,9.74,7493.32,3.92,5482.55,1.86,-17107.12,56.72,13659.53,1.86,6043.82,25.88,7880.99,2.83}
,{124,54,-87661.421,1.793,8437.565,0.014,-5930.086,8.495,123.905891588,1.924,1,"s","","s","",0,1,"","",{},{},{},{},18449.08,11.25,11924.9,2.16,-718.35,3.45,-8571.65,12.63,-5778.23,2.16,-14689.09,12.24,10484.04,9.69,7006.66,4.05,-22746,298,9129.85,5.45,3454.08,5.57,6530.48,25.9}
,{124,55,-81731.334,8.304,8383.432,0.067,-2641.559,15.004,123.912257798,8.914,0,30.9,"",0.4,"",1,1,"","",{"B+"},{0},{"="},{0},19729.21,34.7,10228.82,9.81,-403.26,17.42,-11472.72,57.27,-1076.58,9.11,-14147.7,14.68,8759.01,14.68,3771.6,12.65,-28580,401,14334.45,13.87,5613.71,13.19,10166.52,9.88}
,{124,56,-79089.775,12.497,8355.82,0.101,-8831.165,58.03,123.915093629,13.416,0,660,"",30,"",0,1,"","",{"B+"},{0},{"="},{0},20623.47,30.61,8312.74,16.72,657.73,17.2,-14174,298,-1130.05,15.72,-18510,196,11506.14,17.4,5335.1,17.4,-34564,503,9765.79,35.93,2876.61,18.98,9037.61,16.16}
,{124,57,-70258.61,56.669,8278.292,0.457,-5343,303,123.924574275,60.836,0,29.21,"",0.17,"",7,-1,"","",{"B+"},{0},{"="},{0},21858,303,6691.79,65.93,1205.11,57.54,-17108,405,3496.07,57.95,-18044,303,9679,204,1892.63,57.95,"","",15061.14,63.18,5350.28,152.8,12490.12,58.44}
,{124,58,-64916,298,8229,2,-11765,499,123.93031,320,0,9.1,"",1.2,"",0,1,"","",{"B+"},{0},{"="},{0},23185,499,4885,299,1548,423,-20390,585,3450,298,-22757,499,12701,422,3554,357,"","",10338,422,2139,423,11475,330}
,{124,59,-53151,401,8128,3,-8626,643,123.94294,430,0,1.2,"",0.2,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},24514,641,3186,499,1994,500,"","",8211,446,"","",10992,566,154,499,"","",15433,566,4403,566,14686,500}
,{124,60,-44525,503,8052,4,"","",123.9522,540,0,0.5,"","s","",0,1,"","",{},{},{},{},"","",1230,643,2650,709,"","",8472,585,"","","","",1585,642,"","",10965,709,1760,709,13811,643}
,{125,45,-42000,500,8126,4,12120,640,124.954911,537,0,0.0265,"",0.002,"",3.5,1,"","",{"B-","B-n","B-2n"},{0,20,0,"",""},{"=","=",""},{0,20,0,"",""},8783,640,"","",-12645,707,22520,662,"","",8318,582,5182,640,15329,781,38477,501,5791,707,5014,707,"",""}
,{125,46,-54120,400,8216,3,10400,589,124.9419,429,0,0.057,"",0.01,"",1.5,1,"","",{"B-","B-n"},{0,6,0},{"=","="},{0,6,0},9833,885,31618,640,-11498,566,19228,400,-27448,721,4009,472,3801,499,16519,565,31777,400,5951,565,2824,500,-6323,640}
,{125,47,-64519.932,433.145,8293.314,3.465,8828.163,433.154,124.930735,465,0,0.159,"",0.008,"",3.5,1,"","",{"B-","B-n"},{0,5,0},{"=","="},{0,5,0},11114.49,434.23,29738,589,-10694.72,755.86,15956.87,433.99,-26919,589,4110.42,433.16,6391.12,500.87,13419,526,23736.34,433.15,6620.62,900.46,4960.28,433.59,-6794,527}
,{125,48,-73348.095,2.885,8357.681,0.023,7128.71,27.119,124.921257577,3.097,0,0.68,"",0.04,"",1.5,1,"","",{"B-"},{0},{"="},{0},12076.55,3.95,27496.29,789.45,-9590.68,4.42,12548.28,3.06,-22247,298,-549.21,30.71,4717.74,4.16,14436.93,251.52,15674.88,3.25,6910.79,30.87,2622.07,38.3,-3085.53,19.77}
,{125,49,-80476.805,27.023,8408.452,0.216,5419.571,27.011,124.913604591,29.01,0,2.36,"",0.04,"",4.5,1,"","",{"B-"},{0},{"="},{0},13189.09,33.5,25506.67,40.93,-8498.9,29.61,7779.47,27.13,-21565.64,252.95,-313.93,27.01,7677.92,40.8,11064.1,27.19,8360.4,27.05,7648.18,27.16,4999.62,27.12,-3724.29,46.78}
,{125,50,-85896.376,1.033,8445.55,0.008,2359.899,2.61,124.907786442,1.109,0,832896,"",2592,"",5.5,-1,"","",{"B-"},{0},{"="},{0},14222.83,2.4,23060.14,2.89,-7247.47,2.2,3126.6,1.52,-16483.67,3.17,-6347.44,1.53,5733.5,0.2,12315.15,30.58,1297.01,2.06,8244.78,19.83,2540.42,50.06,362.4,2.52}
,{125,51,-88256.274,2.599,8458.17,0.021,766.7,2.121,124.905252987,2.79,0,87052936.0636,"",9467.0778,"",3.5,1,"","",{"B-"},{0},{"="},{0},15174.84,2.12,19403.86,19.98,-4845.22,27.52,580.93,2.12,-14675.04,30.68,-5802.27,2.12,8707.34,2.13,7311.05,2.6,-4168.32,8.15,10270.71,3.4,6549.11,3.4,962.87,50.12}
,{125,52,-89022.974,1.502,8458.045,0.012,-185.77,0.06,124.9044299,1.612,1,"s","","s","",0.5,1,"","",{},{},{},{},15993.45,0.1,15784.73,2.66,-2250.63,1.69,-1829.59,2.19,-8077.75,1.51,-9728.56,1.86,6568.97,0.03,8691.7,0.14,-9354.01,11.09,10911.9,0.12,4176.45,2.13,6564.76,2.66}
,{125,53,-88837.204,1.504,8450.3,0.012,-1643.824,2.192,124.904629333,1.614,0,5132764.8,"",864,"",2.5,1,"","",{"EC"},{0},{"="},{0},17036.11,3.45,14191.08,0.13,-1661.8,2.13,-4749.25,7.87,-8505.93,0.15,-9247.1,2.16,9542.79,1.86,5600.85,0.07,-15077.72,26.04,11045.76,0.12,6341.31,0.14,5144.57,2.13}
,{125,54,-87193.381,1.836,8430.89,0.015,-3105.43,7.831,124.90639405,1.971,0,60840,"",720,"",0,0,"","",{"B+"},{0},{"="},{0},18087.31,9.7,12599.17,2.19,-1072.79,25.9,-7524.42,11.14,-3957.03,2.19,-13533.36,8.5,7603.28,0.4,7116.62,2.87,-20536,196,11461.15,4.07,3751.13,5.46,8767.48,2.19}
,{125,55,-84087.95,7.744,8399.788,0.062,-4418.985,13.446,124.909727867,8.313,0,2802,"",6,"",0,0,"","",{"B+"},{0},{"="},{0},19186.94,14.37,10722.16,8.59,-261.42,9.4,-10328.47,27.13,-4011.19,8.09,-13069.49,14.7,10427.93,11.35,3715.5,7.83,-26148,300,11871.56,12.28,6131.08,13.54,7638.91,9.33}
,{125,56,-79668.965,10.992,8358.178,0.088,-5909.481,27.631,124.914471843,11.8,0,198,"",18,"",0,0,"","",{"B+"},{0},{"="},{0},20156.65,16.35,8998.21,14.55,387.1,15.02,-13011,196,703.48,11.14,-17481.67,57.73,8650.51,16.64,5226.6,13.78,-32070,401,12085.49,16.35,3339.85,35.43,11332.41,15.63}
,{125,57,-73759.484,25.997,8304.643,0.208,-7102,197,124.920815932,27.909,0,64.8,"",1.2,"",5.5,-1,"","",{"B+"},{0},{"="},{0},21251,197,7293.78,28.68,917.93,29.67,-15820,301,682.88,27.29,-16915,299,11572.19,62.35,1958.68,28.84,"","",12606.27,28.68,5713.51,38.17,10031.68,42.55}
,{125,58,-66658,196,8242,2,-8718,358,124.92844,210,0,9.7,"",0.3,"",3.5,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22514,357,5581,196,1662,242,-19058,446,5143,196,-21578,446,9813,357,3688,204,"","",12704,277,2750,357,13598,198}
,{125,59,-57940,300,8166,2,-10341,500,124.937799,322,0,3.3,"",0.7,"",1.5,1,"","",{"B+"},{0},{"="},{0},23853,500,3867,358,1825,424,"","",5030,305,-21486,586,12860,500,313,423,"","",13057,423,4798,500,12250,423}
,{125,60,-47599,401,8077,3,"","",124.9489,430,0,0.65,"",0.15,"",0,0,"","",{"B+","B+p"},{0,0,0},{"=",">"},{0,0,0},"","",1891,499,2666,566,"","",10028,499,"","",11145,643,1737,566,"","",13341,566,2044,641,15921,566}
,{126,45,-37300,500,8088,4,14560,640,125.959957,537,0,0.019,"",0.003,"",0,0,"","",{"B-","B-n","B-2n"},{0,30,0,"",""},{"=","=",""},{0,30,0,"",""},8553,640,"","","","",23380,539,"","",8749,640,3371,707,"","",40473,501,7371,781,4644,707,"",""}
,{126,46,-51860,400,8197,3,8820,447,125.944326,429,0,0.0486,"",0.0012,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9613,499,32478,721,-12135,640,20397,400,"","",4589,589,5812,565,17149,640,34155,400,3740,565,2364,565,-9134,640}
,{126,47,-60680,200,8261,2,11576,200,125.934857,215,0,0.0993,"",0.0046,"",2,1,"","",{"B-","B-n"},{0,6,0},{"=","="},{0,6,0},10623,322,30369,447,-11025,361,17093,202,-25969,539,4596,200,4232,477,13849,447,25713,203,8420,359,4613,814,-5674,447}
,{126,48,-72256.802,2.476,8346.747,0.02,5516.106,26.908,125.922429127,2.658,0,0.513,"",0.006,"",0,1,"","",{"B-"},{0},{"="},{0},11697.76,3.89,28445,298,-10065.56,19.72,13758.44,10.71,-25426,400,148.69,27.14,6980.02,3.8,15025.84,433.15,17808.55,2.9,4654.14,251.52,2155.33,30.84,-6180.66,789.45}
,{126,49,-77772.908,26.921,8384.317,0.214,8242.332,27.078,125.916507344,28.901,0,1.53,"",0.01,"",0,0,"","",{"B-"},{0},{"="},{0},13045.34,40.73,26150.72,252.94,-9091.72,46.73,8620.33,40.41,-20541.95,433.98,52.15,26.92,5367.42,38.14,11713.78,27.08,10138.41,27.18,9639.57,27.09,4505.33,27.06,-2578.43,40.86}
,{126,50,-86015.24,10.447,8443.523,0.083,378,30,125.907658836,11.215,0,7258092980000,"",441796964000,"",0,1,"","",{"B-"},{0},{"="},{0},13923.68,10.4,23891.51,10.87,-7827.78,10.7,4050.11,10.51,-19956.12,10.84,-5830.28,10.72,8190.18,10.4,12827.41,28.94,3131.72,11.02,5565.77,32.3,2279.17,22.39,-2954.66,10.79}
,{126,51,-86393.24,31.767,8440.314,0.252,3672.108,31.787,125.907253036,34.103,0,1067040,"",5184,"",8,-1,"","",{"B-"},{0},{"="},{0},14915.63,31.79,20100.98,44.08,-5245.41,59.28,1518.08,31.98,-13205.41,41.69,-5441.58,31.79,6208.28,31.86,7785.84,31.75,-2042.41,33.43,12551.76,31.75,6287,31.84,2683.51,37.43}
,{126,52,-90065.348,1.504,8463.248,0.012,-2154.031,3.677,125.903310866,1.614,1,"s","","s","",0,1,"","",{},{},{},{},15682.66,0.09,16409.1,1.51,-2548.93,2.66,-918.39,3.81,-11457.94,1.52,-9299.46,0.1,9113.69,0.08,9098.04,2.12,-7395.45,12.59,8265.71,0.16,4022.78,0.14,3397.23,2.66}
,{126,53,-87911.318,3.809,8439.944,0.03,1235.644,5.173,125.905623313,4.089,0,1117152,"",4320,"",2,-1,"","",{"B+","B-"},{0,47.3,0},{"=","="},{0,47.3,0},16688.22,4.12,14869.01,3.68,-2000.86,4.24,-3560.49,11.08,-6944.01,4.25,-8789.25,4.16,7145.43,3.68,6177.31,3.68,-12937.85,90.59,13324.81,3.68,6124.89,3.68,6959.15,3.68}
,{126,54,-89146.962,3.5,8443.541,0.028,-4796.133,10.671,125.904296794,3.757,1,"s","","s","",0,1,"","",{},{},{},{},17628.18,3.93,13199.58,3.81,-1257.42,3.81,-6477.06,12.98,-7412.96,3.81,-13130.33,8.5,10024.9,3.95,7598.73,3.81,-18326.4,28.16,8929.58,4.24,3660.82,5.12,5671.6,3.81}
,{126,55,-84350.829,10.401,8399.268,0.083,-1680.927,16.259,125.909445655,11.166,0,98.4,"",1.2,"",1,1,"","",{"B+"},{0},{"="},{0},18762.13,13.31,11563.04,10.67,-695.29,11.64,-9377.36,91.1,-2802.6,10.51,-12753.18,15.13,8334.2,12.97,4446.42,10.56,-24027,196,14021.4,10.55,5761.93,14.11,9239.3,11.05}
,{126,56,-82669.902,12.497,8379.718,0.099,-7696.435,91.366,125.911250204,13.416,0,6000,"",120,"",0,1,"","",{"B+"},{0},{"="},{0},19722.76,17.67,9586.42,12.63,260.16,16.72,-11849.34,30.61,-2765.49,12.63,-16981.74,28.84,11072.25,16.64,5870.92,14.7,-29677,298,9772.24,15,3237.8,17.4,8225.2,15.72}
,{126,57,-74973.468,90.508,8312.426,0.718,-4152.91,94.723,125.919512667,97.163,0,54,"",2,"",0,0,"","",{"B+"},{0},{"="},{0},20857.49,106.78,7820.07,90.89,746.38,96.57,-14650,216,1825.51,90.84,-16387,216,9285.3,94.17,2593.47,91.17,-35623,508,14827.11,91.37,5545.54,91.31,11716.58,91.31}
,{126,58,-70820.558,27.945,8273.257,0.222,-10497,198,125.923971,30,0,51,"",0.3,"",0,1,"","",{"B+"},{0},{"="},{0},22047,299,6308.72,30.61,1363.47,39.52,-17828,299,1559.44,30.03,-20952,301,12234,198,4350.04,38.17,"","",10148.86,63.18,2695,198,10480.8,30.46}
,{126,59,-60324,196,8184,2,-7331,357,125.93524,210,0,3.12,"",0.18,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23315,446,4643,204,1795,357,-20974,537,6147,197,-20796,446,10455,358,955,277,"","",15303,357,4827,357,13974,277}
,{126,60,-52993,298,8119,2,-13643,582,125.94311,320,0,1,"",2e-07,">",0,1,"","",{},{},{},{},24610,585,2655,422,2456,499,"","",6376,357,"","",13465,499,2342,423,"","",10869,499,2101,499,12940,422}
,{126,61,-39350,500,8005,4,"","",125.957756,537,0,0.5,"","s","",0,0,"","",{},{},{},{},"","",777,641,3005,707,"","",11301,583,"","","","",-960,641,"","",15886,709,"","",16526,640}
,{127,45,-34030,600,8062,5,13150,781,126.963467,644,0,0.028,"",0.014,"",3.5,1,"","",{"B-","B-n","B-2n"},{0,30,0,"",""},{"=","=",""},{0,30,0,"",""},8173,781,"","","","",24410,632,"","",9758,721,4802,781,"","",42866,600,"","",4794,848,"",""}
,{127,46,-47180,500,8159,4,11260,539,126.94935,537,0,0.038,"",0.002,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,10,0,0,0},{"=","=","="},{0,10,0,0,0},9203,640,"","",-12525,707,21567,500,"","",5429,539,3391,640,17169,707,36291,500,5531,707,2574,640,-7573,781}
,{127,47,-58440,200,8242,2,10307,201,126.937262,215,0,0.089,"",0.002,"",3.5,1,"","",{"B-","B-n"},{0,7,0},{"=","="},{0,7,0},10063,477,31018,539,-11505,447,18456,201,-28429,539,5745,200,5831,283,13869,447,28259,200,6391,447,4814,359,-7904,447}
,{127,48,-68747.402,12.109,8316.945,0.095,8148.782,24.378,126.926196624,13,0,0.33,"",0.02,"",1.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11541.94,12.45,29206,400,-10742.58,789.53,14723.4,15.74,-24176,400,954.19,29.52,4561.92,12.36,15356,201,19534.28,12.2,6483.34,433.31,2316.79,251.79,-4711,298}
,{127,49,-76896.184,21.157,8374.949,0.167,6574.619,19.098,126.917448546,22.713,0,1.09,"",0.01,"",4.5,1,"","",{"B-","B-n"},{0,0.03,0},{"=","<"},{0,0.03,0},12562.01,34.32,26954.19,433.66,-9773.02,37.32,9803.29,21.58,-23505,201,1047.74,23.59,7194.59,34.24,11928.35,21.3,12087.73,21.46,7162.72,21.35,4669.54,21.37,-5049.65,252.39}
,{127,50,-83470.803,10.057,8420.557,0.079,3228.674,10.875,126.910390401,10.796,0,7560,"",144,"",5.5,-1,"","",{"B-"},{0},{"="},{0},13717.06,10.1,24700.65,10.46,-8481.54,10.41,4810.87,10.13,-18502.97,10.36,-5148.88,33.32,5526.88,14.5,12986.87,28.74,4850.76,10.84,7716.81,28.83,2263.45,32.18,-1122.73,10.49}
,{127,51,-86699.477,5.126,8439.82,0.04,1582.201,4.913,126.906924277,5.502,0,332640,"",4320,"",3.5,1,"","",{"B-"},{0},{"="},{0},14585.84,5.35,20800.61,27.49,-5694.04,20.46,2284.43,6.07,-16215.54,27.4,-4705.45,4.92,8377.55,32.16,7973.21,11.6,-459.32,7.54,9907.7,5.13,6398.77,5.13,-182.87,30.99}
,{127,52,-88281.678,1.514,8446.118,0.012,702.231,3.575,126.905225714,1.625,0,33660,"",252,"",1.5,1,"","",{"B-"},{0},{"="},{0},15401.34,0.2,16963.24,1.53,-2890.41,2.67,39.88,4.05,-9555.41,10.51,-8441.68,3.68,6287.65,0.18,9177.41,31.79,-5463.73,11.46,10685.4,2.13,4202.63,0.24,5598.92,1.52}
,{127,53,-88983.909,3.647,8445.487,0.029,-662.349,2.044,126.904471838,3.915,1,"s","","s","",2.5,1,"","",{},{},{},{},16289.34,3.57,15305.58,4.16,-2184.76,3.58,-2743.76,6.26,-9879.64,31.97,-7908.26,5.05,9143.91,2.74,6207.53,3.57,-11087.8,26.25,10749.87,3.57,6405.47,3.57,4282.74,3.58}
,{127,54,-88321.56,4.11,8434.111,0.032,-2081.406,6.421,126.905182899,4.412,0,3140294.4,"",259.2,"",0.5,1,"","",{"EC"},{0},{"="},{0},17270.81,4.45,13876.53,4.05,-1574.32,4.05,-5503.62,12.08,-5545.18,4.05,-12042.05,11.18,7245.92,5.4,7699.21,3.4,-16342.22,29.17,11226.45,4.05,3908.23,4.46,7850.16,4.05}
,{127,55,-86240.154,5.578,8411.562,0.044,-3422.21,12.653,126.907417381,5.988,0,22500,"",360,"",0.5,1,"","",{"B+"},{0},{"="},{0},18294.84,9.54,11980.89,5.73,-721.34,6.68,-8344.05,26.59,-5617.81,6.45,-11641.57,13.69,9960.64,11.8,4382.16,6.59,-21697,196,11664.03,5.86,6285.32,5.85,6771.98,6.02}
,{127,56,-82817.944,11.357,8378.455,0.089,-4921.836,27.74,126.911091275,12.192,0,762,"",24,"",0.5,1,"","",{"B+"},{0},{"="},{0},19291.61,15.81,10202.5,11.5,5.84,14.83,-10838.61,31.03,-959.95,11.88,-15915.79,91.22,8219.36,16.89,5756.09,15.4,-27282,298,11980.81,13.75,3777.45,14.07,10489.88,11.5}
,{127,57,-77896.108,26,8333.54,0.205,-5916.772,38.857,126.916375084,27.912,0,306,"",6,"",5.5,-1,"","",{"B+"},{0},{"="},{0},20279.26,36.77,8386.1,27.13,722.62,28.68,-13353,197,-834.25,28,-15146.87,38.17,10993.96,94.17,2515.18,28.85,-33110,401,12483.66,28.23,6057.72,28.85,9481.63,27.29}
,{127,58,-71979.336,28.876,8280.791,0.227,-7436,198,126.922727,31,0,34,"",2,"",0.5,1,"","",{"B+"},{0},{"="},{0},21464,198,6888.31,30.9,1250.7,31.31,-16444,299,3401.6,31.46,-19727,198,9230.1,40.18,4294.84,95,"","",12490.95,38.85,3143.33,63.6,12756.84,31.46}
,{127,59,-64543,196,8216,2,-9008,357,126.93071,210,0,4.2,"",0.3,"",1.5,1,"","",{"B+"},{0},{"="},{0},22746,358,5362,197,1683,277,-19757,446,3141,216,-19622,357,12291,277,1012,198,"","",12825,277,5237,357,11362,204}
,{127,60,-55536,298,8139,2,-10749,499,126.94038,320,0,1.8,"",0.4,"",2.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},24079,499,3456,357,2326,422,"","",7996,299,-24257,582,10614,422,2501,357,"","",13115,423,2479,499,15027,422}
,{127,61,-44786,401,8048,3,"","",126.95192,430,0,1,"","s","",2.5,1,"","",{},{},{},{},"","",1424,500,3019,566,"","",8248,446,"","",13508,641,-917,499,"","",13524,566,4603,643,14011,566}
,{128,46,-44490,500,8138,4,10130,583,127.952238,537,0,0.035,"",0.003,"",0,1,"","",{"B-","B-n"},{0,20,0},{"=","="},{0,20,0},8773,640,"","",-12955,781,22752,500,"","",5879,539,5381,707,17749,781,38872,501,3521,707,2374,707,"",""}
,{128,47,-54620,300,8211,2,12622,300,127.941363,322,0,0.059,"",0.005,"",0,0,"","",{"B-","B-n","B-2n"},{0,8,0,"",""},{"=","=",""},{0,8,0,"",""},10082,361,31898,583,-12155,500,19526,337,-27879,671,6056,300,4251,361,14729,583,30010,301,7951,500,4364,500,-6973,583}
,{128,48,-67241.89,7.244,8303.264,0.057,6904.051,153.554,127.927812857,7.776,0,0.246,"",0.002,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},11127.72,7.66,29960,400,-11277,298,16120.12,19.08,-27351,500,1582.98,22.36,6565.81,14.11,16091,200,21751.83,7.3,4149,200,2142.1,433.21,-7476,400}
,{128,49,-74145.941,153.479,8351.09,1.199,9216.067,153.027,127.920401053,164.766,0,0.816,"",0.027,"",0,0,"","",{"B-","B-n"},{0,0.038,0},{"=","="},{0,0.038,0},12515.67,155.82,28044,252,-10370.72,294.63,10484.35,153.52,-22995,252,1253.54,153.81,5321.07,154.93,12687.51,153.96,13592.78,153.52,8821.67,153.5,4066.21,153.51,-3979.61,459.53}
,{128,50,-83362.008,17.66,8416.979,0.138,1268.278,13.796,127.910507197,18.958,0,3544.2,"",8.4,"",0,1,"","",{"B-"},{0},{"="},{0},13489.4,20.52,25683.15,17.83,-9085.25,17.91,5631.71,17.66,-21903.58,21.41,-4733.85,18.39,7962.52,20.32,13754.79,27.56,6498.29,17.68,5121.71,32.2,1978.85,32.28,-4367.51,17.89}
,{128,51,-84630.286,19.119,8420.775,0.149,4363.429,19.117,127.909145645,20.525,0,32580,"",144,"",8,-1,"","",{"B-"},{0},{"="},{0},14379.68,37.08,21435.32,33.02,-6185,36.06,3108.44,19.46,-15023.07,28.52,-4419.93,19.18,6002.13,19.79,8448.45,21.6,1301.29,19.87,12095.76,21.79,6130.14,19.15,1492.92,33.1}
,{128,52,-88993.716,0.866,8448.752,0.007,-1254.992,3.714,127.904461311,0.929,0,6.3113852e+31,"",9.4670778e+30,"",0,1,"","",{"2B-"},{0},{"="},{0},15071,1.68,17556.42,10.48,-3184.44,1.32,866.58,0.9,-12811.88,10.09,-8081.12,3.71,8783.35,1.69,9583.21,5.18,-3615.22,5.27,8110.33,31.78,4126.61,2.7,2549.06,1.33}
,{128,53,-87738.724,3.647,8432.836,0.028,2121.575,3.748,127.9058086,3.915,0,1499.4,"",1.2,"",1,1,"","",{"B-","B+"},{0,6.9,0},{"=","="},{0,6.9,0},15970.04,2.74,15923.42,31.97,-2543.39,3.58,-1807.14,6.53,-8328.22,6.07,-7488.48,2.04,6826.13,0.05,6746.02,3.58,-9113.29,54.57,13037.43,3.57,6148.31,3.57,6163.95,4.16}
,{128,54,-89860.298,1.061,8443.298,0.008,-3928.717,5.38,127.903530996,1.138,1,"s","","s","",0,1,"","",{},{},{},{},16855.97,3.66,14372.89,1.8,-1759.89,1.79,-4481.8,5.3,-8867.59,1.8,-11691.46,5.67,9610.06,4.2,8165.36,3.75,-14326.38,27.96,8761.83,3.91,3840.96,1.8,4809.08,1.79}
,{128,55,-85931.581,5.443,8406.493,0.043,-553.084,7.525,127.907748648,5.843,0,218.4,"",0.84,"",1,1,"","",{"B+"},{0},{"="},{0},17723.39,11.74,12598.2,6.62,-990.76,5.93,-7306.15,54.72,-4236.64,6.53,-11184.95,12.59,7762.74,7.79,4898.99,6.8,-19600.82,30.3,13926.19,6.47,6125.85,5.74,8552.03,5.64}
,{128,56,-85378.497,5.195,8396.06,0.041,-6753.066,54.695,127.908342408,5.577,0,209952,"",4320,"",0,1,"","",{"EC"},{0},{"="},{0},18851.23,13.53,10809.48,6.26,-141.99,5.5,-9844.58,28.42,-4345.91,6.62,-15553.71,26.51,10631.87,12.49,6427.31,7.62,-25064,196,9683.14,11.63,3573.51,9.33,7461.29,5.51}
,{128,57,-78625.431,54.448,8337.19,0.425,-3091.513,61.2,127.915592123,58.452,0,310.8,"",8.4,"",5,1,"","",{"B+"},{0},{"="},{0},19794.6,105.62,8852.54,55.43,680.99,55.08,-12294.67,62.07,325.75,54.73,-14717.41,61.63,8800.64,60.34,3096.46,55.62,-30840,303,14755.28,55.86,5907.59,55.55,11108.92,55}
,{128,58,-75533.917,27.945,8306.925,0.218,-9203.161,40.859,127.918911,30,0,235.8,"",1.2,"",0,1,"","",{"B+"},{0},{"="},{0},20855.99,39.52,7441.96,30.61,1130.94,30.61,-15220,198,-4.94,30.16,-19062,198,11625.9,40.18,4926.78,38.17,-36864,501,10150.36,94.72,3089.62,38.17,9781.45,30.03}
,{128,59,-66330.757,29.808,8228.913,0.233,-6017,198,127.928791,32,0,2.85,"",0.09,"",3,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22150,198,5935.23,95.29,1502.94,64.03,-18545,300,4276.38,39.55,-18866,300,9859,198,1640.39,41.5,"","",15200.61,40.86,5191,198,13075.13,39.55}
,{128,60,-60314,196,8176,2,-12529,357,127.93525,210,0,5,"","s","",0,1,"","",{},{},{},{},23464,357,4072,198,2177,357,-21644,537,4376,198,-23599,446,12850,357,3060,277,"","",10720,277,2490,358,11990,277}
,{128,61,-47786,298,8072,2,-9116,582,127.9487,320,0,1,"",0.3,"",0,0,"","",{"B+","p"},{0,0,0},{"~","="},{0,0,0},24578,582,2040,357,2940,499,"","",9469,357,"","",11071,499,-461,422,"","",15918,422,4678,499,15801,423}
,{128,62,-38670,500,7994,4,"","",127.958486,537,0,0.5,"","s","",0,1,"","",{},{},{},{},"","",255,582,3430,709,"","",9577,582,"","","","",1173,641,"","",11391,707,"","",14576,641}
,{129,46,-37610,600,8084,5,14370,721,128.959624,644,0,0.031,"",0.007,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,90,0,2,0},{"=","=","="},{0,90,0,2,0},6572,781,"","","","",25448,600,"","",8939,671,1191,781,"","",42981,600,7131,848,4554,781,"",""}
,{129,47,-51980,400,8189,3,11078,400,128.944197,429,0,0.0499,"",0.0035,"",3.5,1,"","",{"B-","B-n"},{0,10,0},{"=","="},{0,10,0},9683,447,32528,721,-12405,640,20858,400,"","",7190,400,5431,500,14779,640,32649,400,5911,640,4744,565,-9034,640}
,{129,48,-63058.046,16.767,8269.034,0.13,9779.674,16.982,128.932304399,18,0,0.1515,"",0.0057,"",1.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10453.28,20.68,30456,500,-11363,400,17532.86,24.08,-25857,500,3016.58,154.39,3887.47,18.26,15727,300,23946.76,16.79,6093,201,2486,201,-5552,400}
,{129,49,-72837.72,2.693,8338.78,0.021,7753.183,17.302,128.921805486,2.891,0,0.57,"",0.01,"",4.5,1,"","",{"B-","B-n"},{0,0.23,0},{"=","="},{0,0.23,0},12084.17,21.33,28976,200,-10742.7,433.15,11791.59,21.4,-25507,300,2452.97,17.86,6763.1,153.5,12884.8,7.73,15669.4,4.16,6620.49,12.41,4283.14,3.66,-6511,200}
,{129,50,-80590.903,17.277,8392.818,0.134,4038.404,27.372,128.913482102,18.547,0,133.8,"",2.4,"",1.5,1,"","",{"B-"},{0},{"="},{0},13262.73,19.99,26421.44,21.1,-9667.72,17.52,6413.9,17.3,-20637.98,18.73,-4031.93,25.77,5300.21,24.71,13733.93,154.45,8105.16,17.28,7016.09,27.32,2046.06,31.99,-2687.7,17.45}
,{129,51,-84629.307,21.231,8418.058,0.165,2375.5,21.213,128.909146696,22.792,0,15717.6,"",93.6,"",3.5,1,"","",{"B-"},{0},{"="},{0},14072.46,21.84,22311.06,29.97,-6577.42,34.37,3877.82,21.44,-17772.34,154.94,-3706.91,21.21,8070.34,28.56,8556.27,27.6,2869.94,21.71,9552.3,23.49,6249.99,23.66,-1210,34.29}
,{129,52,-87004.807,0.869,8430.409,0.007,1502.318,3.142,128.906596492,0.933,0,4176,"",18,"",1.5,1,"","",{"B-"},{0},{"="},{0},14865.76,1.69,18111.95,10.09,-3533.35,1.33,1691.25,0.87,-10931.77,17.66,-7337.4,3.72,6082.41,0.08,9663.49,19.12,-1941.61,10.61,10405.48,5.18,4252.49,31.78,4656.83,10.48}
,{129,53,-88507.125,3.168,8435.99,0.025,188.934,3.168,128.904983687,3.401,0,4.954437382e+14,"",12622770400000,"",3.5,1,"","",{"B-"},{0},{"="},{0},15665.85,4.81,16385.59,6.02,-2675.77,4.08,-1007.88,5.55,-11165.81,19.37,-6718.14,3.24,8839.72,4.82,6802.38,3.14,-7182.55,21.58,10485.36,3.49,6422.28,3.49,3532.52,31.92}
,{129,54,-88696.05896,0.00537,8431.39,0,-1196.813,4.555,128.904780858,0.00576,1,"s","","s","",0.5,1,"","",{},{},{},{},16517.13,4.11,14992.32,1.51,-2098,1.5,-3632.86,10.58,-6991.31,0.87,-10835.8,5.44,6907.08,1.06,8246.31,3.65,-12408.56,27.94,10998.66,3.65,4079.31,3.81,7015.69,1.5}
,{129,55,-87499.246,4.555,8416.047,0.035,-2436.048,10.623,128.90606569,4.889,0,115416,"",216,"",0.5,1,"","",{"B+"},{0},{"="},{0},17401.73,7.2,13093.28,5.83,-1086.96,4.8,-6174.67,21.63,-7049.49,5.84,-10192.07,6.83,9638.98,7.1,4927.92,4.68,-17725.69,30.15,11533.12,6.14,6511.77,5.74,6058.47,5.94}
,{129,56,-85063.198,10.577,8391.098,0.082,-3738.625,21.639,128.908680896,11.354,0,8028,"",396,"",0.5,1,"","",{"B+"},{0},{"="},{0},18387.89,15.52,11319.58,11.35,-294.73,10.74,-8775.7,29.88,-2491.87,10.63,-14509.08,55.47,7756.02,11.24,6420.59,11.9,-22748,202,11887.76,11.96,4151.69,14.83,9730.17,11.14}
,{129,57,-81324.573,21.351,8356.052,0.166,-5037.077,35.168,128.912694475,22.92,0,696,"",12,"",1.5,1,"","",{"B+"},{0},{"="},{0},19571.1,33.64,9662.36,22.07,338.46,22.71,-11551.01,36.67,-2681.96,22.03,-13861.97,35.17,10770.46,58.48,3235.05,21.85,-28444,299,12204.18,24.18,6209.38,24.74,8672.66,23.75}
,{129,58,-76287.496,27.945,8310.94,0.217,-6513.938,40.859,128.918102,30,0,210,"",18,"",2.5,1,"","",{"B+"},{0},{"="},{0},20450.79,40.18,8047.49,30.16,956.55,30.03,-13973,204,1802.03,28.42,-18028.06,40.86,8824.9,39.52,4951.04,61.2,-34287,501,12319.42,38.17,3550.03,94.72,12028.81,30.61}
,{129,59,-69773.558,29.808,8254.38,0.231,-7459,204,128.925095,32,0,30,"",4,"",1.5,1,"","",{"B+"},{0},{"="},{0},21373,198,6455.39,39.55,1561.01,39.55,-16893,300,1562.9,62.07,-17531,198,11514.12,42.15,1528.61,40.86,"","",12916.58,41.5,5911.05,40.86,10846.31,95.29}
,{129,60,-62315,202,8190,2,-9434,360,128.933102,217,0,6.8,"",0.6,"",2.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22922,360,4914,204,1918,281,-20315,539,5930,200,-22601,360,10072,281,3273,204,"","",12939,281,2873,281,14152,204}
,{129,61,-52881,298,8111,2,-10881,582,128.94323,320,0,2.4,"",0.9,"",2.5,-1,"","",{"B+"},{0},{"="},{0},24237,499,2916,357,2634,423,"","",6161,300,-22282,582,13167,422,-144,357,"","",13366,422,4976,422,13089,357}
,{129,62,-42000,500,8021,4,"","",128.954911,537,0,0.55,"",0.1,"",1.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},"","",1042,582,3174,641,"","",11025,537,"","",11401,707,1503,582,"","",13497,641,2214,707,16639,582}
,{130,47,-45697,500,8140,4,15420,500,129.950942,537,0,0.0406,"",0.0045,"",0,0,"","",{"B-","B-n","B-2n"},{0,90,0,2,0},{"=","=","="},{0,90,0,2,0},7220,400,"","",-10822,707,24186,501,"","",9289,500,1789,640,15376,781,36588,500,9503,707,6347,707,-6021,781}
,{130,48,-61117.589,22.356,8252.586,0.172,8765.617,44.128,129.934387566,24,0,0.1268,"",0.0018,"",0,1,"","",{"B-","B-n"},{0,3.5,0},{"=","="},{0,3.5,0},10018.33,23.5,31206,501,-11683,400,19014.62,22.43,-30797,600,3648.81,22.52,6130.86,27.94,16426,400,26235.36,22.36,4213,301,2187,202,-8291,501}
,{130,49,-69883.206,38.046,8313.996,0.293,10249,38,129.924977288,40.844,0,0.284,"",0.01,"",0,0,"","",{"B-","B-n"},{0,0.93,0},{"=","="},{0,0.93,0},11879.9,158.12,29841,302,-11628,204,12402.47,40.54,-25192,401,2636.38,41.79,5116.8,38.14,14114.13,41.58,17052.93,38.18,8069.49,38.73,3728.25,39.93,-5797,204}
,{130,50,-80132.206,1.873,8386.816,0.014,2153.47,14.113,129.913974533,2.01,0,223.2,"",4.2,"",0,1,"","",{"B-"},{0},{"="},{0},12912.83,17.76,27468.26,7.48,-10300.32,3.1,7220.74,1.87,-24363.13,16.87,-3574.22,21.31,7612.62,17.38,14583.46,3.28,9748.26,1.87,4724.54,153.49,1628.03,21.24,-5738.4,12.25}
,{130,51,-82285.676,14.212,8397.363,0.109,5067.273,14.212,129.911662688,15.257,0,2370,"",48,"",8,-1,"","",{"B-"},{0},{"="},{0},13798.02,23.82,22717.68,154.14,-6937.68,30.44,4650.46,14.56,-16736.93,14.47,-3352.19,14.24,5727.69,25.55,8983.74,22.37,4614.07,16.49,11787.14,22.67,6049.18,17.41,256.91,25.49}
,{130,52,-87352.949,0.011,8430.324,0,-416.811,3.168,129.906222747,0.012,0,2.177427894e+28,"",4.10240038e+27,"",0,1,"","",{"2B-"},{0},{"="},{0},14501.87,0.87,18568.88,17.66,-3762.62,10.45,2527.51,0.01,-14051.02,17.28,-6917.14,3.17,8419.46,0.87,10012.61,21.23,-91.4,2.55,7988.14,19.12,4210.58,5.13,1764.26,10.06}
,{130,53,-86936.138,3.168,8421.1,0.024,2944.325,3.168,129.906670211,3.401,0,44496,"",36,"",5,1,"","",{"B-"},{0},{"="},{0},15340.05,4.82,16883.79,19.37,-2967.81,31.92,-36.39,8.94,-9595.8,21.44,-6311.4,3.17,6500.33,0.04,7220.3,3.14,-5308.77,26.14,12768.38,3.14,6209.6,3.49,5409.74,6.02}
,{130,54,-89880.463,0.009,8437.731,0,-2980.72,8.357,129.903509349,0.01,1,"s","","s","",0,1,"","",{},{},{},{},16162.8,1.06,15464.69,0.87,-2240.03,1.5,-2618.92,2.55,-10164.63,0.87,-10452.53,4.55,9255.72,0.01,8662.31,3.17,-10457.56,27.94,8569.07,3.65,3967.5,3.65,4047.62,1.51}
,{130,55,-86899.743,8.357,8408.784,0.064,361.801,8.738,129.906709283,8.971,0,1752.6,"",2.4,"",1,1,"","",{"B+","B-"},{0,1.6,0},{"=","="},{0,1.6,0},17110.8,9.97,13738.96,9.12,-1413.34,9.18,-5272.38,27.26,-5681.59,8.94,-9907.86,13.48,7471.81,9.52,5492.65,8.36,-15724.29,64.81,13671.36,8.42,6285.87,9.31,7730.57,9.12}
,{130,56,-87261.544,2.553,8405.549,0.02,-5634.178,26.071,129.906320874,2.741,1,"s","","s","",0,1,"","",{},{},{},{},18025.68,2.85,11979.19,2.76,-539.5,4.33,-7838.64,28.06,-5854.46,2.55,-14008.29,21.44,10269.66,10.58,7051.27,5.17,-20665.31,28.06,9380.84,6.01,3842.67,6.13,6706.42,4.84}
,{130,57,-81627.366,25.946,8356.191,0.2,-2204.461,38.133,129.912369413,27.854,0,522,"",6,"",0,0,"","",{"B+"},{0},{"="},{0},19144.57,60.31,10273.73,26.51,298.55,27.95,-10451.91,69.31,-1417.09,26.34,-13411.19,38.13,8374.11,33.6,3853.14,28.02,-26231,197,14461.94,26.46,6054.63,28.32,10259.19,26.54}
,{130,58,-79422.905,27.945,8333.216,0.215,-8247.448,70.085,129.914736,30,0,1374,"",30,"",0,1,"","",{"B+"},{0},{"="},{0},20031.62,39.52,8622.35,28.42,822.08,30.61,-12826.67,39.52,-1648.68,29.88,-17720.66,40.86,11206.73,39.52,5387.3,35.17,-31917,402,9913.33,61.2,3337.26,38.17,9041.44,30.16}
,{130,59,-71175.457,64.273,8263.756,0.494,-4579.225,70.085,129.92359,69,0,40,"",0.4,"",0,0,"","",{"B+"},{0},{"="},{0},20987.33,70.85,7127.97,84.24,1373.1,111.01,-15780,206,2860.15,67.73,-16932,212,9473.22,70.85,2176.93,70.09,-37492,505,15069.27,70.09,5667.93,70.46,12367.05,69.33}
,{130,60,-66596.232,27.945,8222.513,0.215,-11200,198,129.928506,30,0,21,"",3,"",0,1,"","",{"B+"},{0},{"="},{0},22425,198,5640.26,39.52,1799.41,39.52,-19090,402,2402.29,39.52,-21787,299,12353,204,4111.64,40.86,"","",10445.33,40.86,2811,198,11029.51,40.18}
,{130,61,-55396,196,8130,2,-7890,446,129.94053,210,0,2.6,"",0.2,"",5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23753,357,3643,198,2503,277,-21713,537,7089,198,-21467,537,10586,357,370,281,"","",15629,277,5004,357,14794,277}
,{130,62,-47506,401,8064,3,-13823,641,129.949,430,0,1,"","s","",0,1,"","",{},{},{},{},24979,641,1770,446,3062,499,"","",7520,449,"","",13577,641,1914,499,"","",10990,499,2144,566,13676,499}
,{130,63,-33683,500,7951,4,"","",129.96384,537,0,0.001,"",0.0004,"",1,1,"","",{"p","B+"},{0,1,0},{"~","="},{0,1,0},"","",475,582,3242,708,"","",11909,582,"","","","",-1028,15,"","",15698,708,"","",16749,641}
,{131,47,-40380,500,8099,4,14839,511,130.95665,537,0,0.035,"",0.008,"",3.5,1,"","",{"B-","B-n","B-2n"},{0,90,0,10,0},{"=","=","="},{0,90,0,10,0},4543,640,"","",-8775,781,27645,500,"","",12666,501,2754,707,"","",41601,500,7941,781,8974,707,"",""}
,{131,48,-55218.965,102.464,8206.175,0.782,12806.066,102.5,130.94072,110,0,0.098,"",0.002,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,3.5,0,0,0},{"=","=","="},{0,3.5,0,0,0},8303.55,103.83,32187,609,-10464,511,22045.61,102.53,"","",6592.92,109.3,2172.69,104.87,16811,510,29992.05,102.46,7472,413,4265,317,-5083,511}
,{131,49,-68025.03,2.701,8297.959,0.021,9239.541,4.518,130.926972122,2.9,0,0.261,"",0.003,"",4.5,1,"","",{"B-","B-n"},{0,2.2,0},{"=","="},{0,2.2,0},11329.94,3.81,30623,400,-12010,200,13956.37,3.41,-29617,500,4035.86,3.29,6213.14,38.14,14196.41,22.52,19417.68,2.77,5743.82,16.98,4080.92,7.73,-7759,300}
,{131,50,-77264.571,3.621,8362.517,0.028,4716.83,3.962,130.917053066,3.887,0,56,"",0.5,"",1.5,1,"","",{"B-"},{0},{"="},{0},12816.3,17.65,28784.47,17.15,-10942.09,12.64,7946.44,3.62,-23435.95,22.65,-3050.21,14.67,5203.68,4.08,14670.34,38.22,11148.99,3.62,6283.96,4.51,1745.43,153.52,-4376.28,8.1}
,{131,51,-81981.401,2.084,8392.552,0.016,3229.611,2.085,130.911989341,2.236,0,1381.8,"",2.4,"",3.5,1,"","",{"B-"},{0},{"="},{0},13494.73,21.33,23721.62,3.41,-7510.13,21.26,5461.31,2.17,-19387.17,38.1,-2699.77,2.08,7767.04,14.36,9138.17,2.8,6077.38,5.39,9320.31,17.4,6244.66,17.78,-2189.06,153.49}
,{131,52,-85211.012,0.061,8411.233,0.001,2231.699,0.608,130.908522211,0.065,0,1500,"",6,"",1.5,1,"","",{"B-"},{0},{"="},{0},14348.84,0.87,19198.05,17.28,-4165.12,10.06,3202.55,0.06,-12367.78,1.87,-6346.19,3.17,5929.38,0.06,10214.31,14.21,1472.72,2.57,10129.1,21.23,4283.33,19.12,3797.4,17.66}
,{131,53,-87442.71,0.605,8422.297,0.005,970.848,0.605,130.906126384,0.649,0,693377.28,"",51.84,"",3.5,1,"","",{"B-"},{0},{"="},{0},15078.22,3.23,17391.34,21.24,-3168.15,5.16,616.08,5.01,-12446,14.23,-5633.56,0.6,8577.89,3.23,7378.73,0.6,-3673.45,27.95,10272.9,1.06,6415.06,1.06,2833.98,19.13}
,{131,54,-88413.558,0.009,8423.736,0,-354.772,4.974,130.905084136,0.009,1,"s","","s","",1.5,1,"","",{},{},{},{},15860.13,0.01,15986.69,0.87,-2556.8,1.51,-1729.83,2.57,-8349.58,0.01,-9585.13,8.36,6604.41,0.01,8766.39,3.17,-8705.12,32.8,10804.37,3.17,4189.22,3.65,6226.56,0.87}
,{131,55,-88058.786,4.974,8415.056,0.038,-1375.055,5.279,130.905464999,5.34,0,837129.6,"",1382.4,"",2.5,1,"","",{"EC"},{0},{"="},{0},16702.17,6.73,14129.6,5.9,-1499.79,6.17,-4289.53,28.38,-8411.62,5.9,-8868.56,5.28,9230.36,9.73,5467.29,4.97,-13758.13,47.26,11348.08,4.97,6665.57,5.09,5326.34,6.17}
,{131,56,-86683.731,2.569,8398.587,0.02,-2914.475,28.063,130.906941181,2.757,0,995328,"",864,"",0.5,1,"","",{"B+"},{0},{"="},{0},17763.17,10.59,12565.61,2.57,-787.09,4.85,-6975.29,32.9,-4092.24,2.57,-13127.68,26.07,7493.5,0.3,7072.96,8.74,-18915.7,27.64,11526.32,5.17,4111.9,6.02,8822.97,2.78}
,{131,57,-83769.256,27.945,8370.367,0.213,-4060.816,43.092,130.91007,30,0,3540,"",120,"",1.5,1,"","",{"B+"},{0},{"="},{0},18587.32,35.17,10847.95,28.31,45.98,28.5,-9468.6,54.68,-4158.48,29.17,-12417.67,39.52,10213.21,38.13,3796.68,28.06,-24109,202,12004.75,29.88,6473.3,28.42,7808.73,28.47}
,{131,58,-79708.44,32.802,8333.396,0.25,-5407.784,55.446,130.914429465,35.214,0,618,"",18,"",3.5,1,"","",{"B+"},{0},{"="},{0},19563.58,43.09,9223.18,34.47,684.59,34.71,-11940.41,42.73,264.13,32.9,-16604.3,72.16,8356.85,43.09,5370.04,41.82,-29575,402,12326.94,39.14,3781.05,63.57,11316.46,33.21}
,{131,59,-74300.656,46.995,8286.143,0.359,-6532.623,53.081,130.92023496,50.451,0,90,"",1.8,"",1.5,1,"","",{"B+"},{0},{"="},{0},20669.73,55.65,7554.02,51.62,1170.54,53.71,-14640,206,37.74,53.68,-15775.74,54.68,11196.52,79.62,2166.72,54.68,-35031,403,12697.65,54.68,6097.32,54.68,9971.18,71.92}
,{131,60,-67768.033,27.517,8230.304,0.21,-8108,202,130.92724802,29.541,0,25.4,"",0.9,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},21596,204,6058.48,39.22,1786.39,39.89,-17635,401,4365.9,39.22,-20443,198,9243.12,39.22,3881.55,69.92,"","",12716.33,40.57,3426.78,40.57,13412.29,39.22}
,{131,61,-59660,200,8162,2,-9527,448,130.935952,215,0,6.3,"",0.8,"",5.5,-1,"","",{"B+"},{0},{"="},{0},22922,359,4465,202,2458,280,-20390,448,4226,210,-20225,448,12336,280,353,202,"","",13365,284,5518,280,12317,202}
,{131,62,-50133,401,8084,3,-10863,566,130.94618,430,0,1.2,"",0.2,"",2.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},24276,641,2396,449,2978,499,"","",9174,402,-24521,641,10698,566,2026,446,"","",13459,499,2517,499,15828,446}
,{131,63,-39270,401,7995,3,"","",130.957842,430,0,0.0178,"",0.0019,"",1.5,1,"","",{"p"},{0},{"="},{0},"","",967,499,3091,566,"","",8837,446,"","",13658,641,-947.09,5.27,"","",13441,641,4264,641,14162,499}
,{132,47,-33790,500,8049,4,16473,537,131.963725,537,0,0.03,"",0.014,"",0,0,"","",{"B-","B-n","B-2n"},{0,0,0,90,0},{"=","=","="},{0,0,0,90,0},4235,707,"","","","",28622,504,"","",13358,511,1481,707,"","",45845,500,"","",8684,781,"",""}
,{132,48,-50263,196,8168,1,12148,205,131.94604,210,0,0.082,"",0.004,"",0,1,"","",{"B-","B-n","B-2n"},{0,60,"","",""},{"=","=",""},{0,60,"","",""},5288,197,"","",-8198,537,26283,196,"","",9690,196,3116,221,17172,537,34925,196,6145,537,6581,445,-7007,631}
,{132,49,-62411.542,60.033,8253.715,0.455,14135,60,131.932998449,64.447,0,0.198,"",0.002,"",7,-1,"","",{"B-","B-n","B-2n"},{0,6.3,0,0,0},{"=","=","="},{0,6.3,0,0,0},8670.97,71.07,31292,504,-10216,306,17223.73,60.08,-29320,504,6781.71,60.14,2457.83,60.09,14481.55,118.76,23291.95,60.17,9416.85,64.06,5510.56,62.33,-4785,404}
,{132,50,-76546.542,1.976,8354.872,0.015,3088.729,3.161,131.917823902,2.121,0,39.7,"",0.8,"",0,1,"","",{"B-"},{0},{"="},{0},12556.97,2.72,30006.89,22.44,-11729.57,7.51,8641.64,4.01,-28616.55,102.48,-2636.46,2.87,7353.29,4.12,15810.48,3.35,12732.42,1.98,4047.47,38.1,1155.23,3.34,-7842.09,16.88}
,{132,51,-79635.271,2.467,8372.344,0.019,5552.915,4.271,131.914508015,2.648,0,167.4,"",4.2,"",0,0,"","",{"B-"},{0},{"="},{0},13492.23,14.42,24330.01,38.13,-7914.25,153.5,6068.22,4.76,-18899.21,3.66,-2495.58,2.47,5725.19,3.23,9659.67,4.38,7517.41,2.68,11207.74,3.1,5819.69,17.45,-1151.15,3.65}
,{132,52,-85188.186,3.486,8408.485,0.026,515.304,3.483,131.908546716,3.742,0,276825.6,"",1123.2,"",0,1,"","",{"B-"},{0},{"="},{0},13977.87,3.49,19633.92,3.96,-4251.09,18,4090.78,3.49,-15212.58,5.03,-5816.79,3.54,8048.49,3.49,10495.76,4.06,3246.83,3.64,7808.3,14.63,4305.18,21.52,1049.12,17.63}
,{132,53,-85703.49,4.065,8406.462,0.031,3575.472,4.065,131.907993514,4.364,0,8262,"",46.8,"",4,1,"","",{"B-"},{0},{"="},{0},14909.99,5.15,17995.75,14.78,-3498.12,19.55,1449.19,4.2,-11011.06,4.57,-5361.25,4.07,6332.1,4.11,7781.45,4.07,-1979.84,36.59,12360.27,4.07,6165.37,4.16,4572.22,21.62}
,{132,54,-89278.96179,0.00515,8427.622,0,-2126.28,1.036,131.904155086,0.00553,1,"s","","s","",0,1,"","",{},{},{},{},15541.13,0.01,16503.95,0.01,-2710.16,0.87,-843.94,1.05,-11356.92,0.06,-9291.49,4.97,8936.72,0.01,9125.22,0.6,-6808.07,20.44,8367.98,3.17,4092.22,3.17,3372.25,0.87}
,{132,55,-87152.681,1.036,8405.587,0.008,1282.336,1.478,131.906437743,1.112,0,559872,"",518.4,"",2,1,"","",{"B+","B-"},{0,1.87,0},{"=","="},{0,1.87,0},16395.57,8.42,14794.48,3.33,-1838.87,3.79,-3429.03,36.37,-6998.94,1.2,-8540.27,2.77,7165.21,5.08,6028.09,1.04,-11925.23,28.89,13438.59,1.04,6407.43,1.04,7000.85,3.33}
,{132,56,-88435.017,1.054,8409.375,0.008,-4711.367,36.354,131.905061098,1.131,1,"s","","s","",0,1,"","",{},{},{},{},17316.11,2.69,13132.5,1.05,-999.63,1.5,-5964.12,20.49,-7310.43,1.05,-12737.08,27.96,9822.6,2.7,7665.2,5.07,-17009.21,24.23,9175.53,8.42,3928.28,4.67,5907.44,1.05}
,{132,57,-83723.65,36.359,8367.756,0.275,-1252.754,41.718,131.910118959,39.032,0,17280,"",720,"",2,-1,"","",{"B+"},{0},{"="},{0},18238.92,44.67,11401.85,37.31,-216.98,36.76,-8496.19,46.43,-2953.83,36.7,-12086.53,48.97,8025.71,45.86,4328.89,36.45,-22096,153,14248.7,36.44,6203.6,37.86,9422,36.64}
,{132,58,-82470.896,20.442,8352.338,0.155,-7243.44,35.38,131.911463846,21.945,0,12636,"",396,"",0,1,"","",{"B+"},{0},{"="},{0},19190.63,34.62,9787.29,20.45,482.69,20.78,-11045.09,31.68,-3076.14,20.46,-16241.56,51.25,10833.77,38.65,5990.61,34.62,-27392,299,9867.28,33.03,3717.73,29.54,8238.7,22.95}
,{132,59,-75227.456,28.876,8291.537,0.219,-3801.648,37.679,131.91924,31,0,89.4,"",6.6,"",2,1,"","",{"B+"},{0},{"="},{0},20194.63,70.46,8178.03,38.82,973.06,61.63,-13600,152,1252.83,40.18,-15530.74,39.89,8998.12,55.16,2807.99,43.7,-33027,401,14906.26,40.18,5924.1,40.18,11743.52,35.91}
,{132,60,-71425.807,24.205,8256.81,0.183,-9798,151,131.923321237,25.985,0,93.6,"",6,"",0,1,"","",{"B+"},{0},{"="},{0},20972.21,36.97,6580.84,36.97,1683.19,36.97,-16347,299,993.66,40.77,-19837,202,11729.09,36.65,4414.12,52.86,"","",10460.46,68.68,3211.81,38.4,10508.09,36.97}
,{132,61,-61628,149,8177,1,-6548,333,131.93384,160,0,6.2,"",0.6,"",3,1,"","",{"B+","B+p"},{0,5,0},{"=","~"},{0,5,0},22374,246,5030,162,2278,152,-19427,426,5384,156,-19566,427,10039,250,1149,152,"","",15679,152,5551,251,13792,152}
,{132,62,-55079,298,8121,2,-12879,499,131.94087,320,0,4,"",0.3,"",0,1,"","",{"B+"},{0},{"="},{0},23716,499,3061,299,2810,357,"","",5400,299,-23880,499,13018,499,2708,359,"","",11028,357,2666,422,12882,360}
,{132,63,-42200,400,8018,3,"","",131.954696,429,0,0.1,"","s","",0,0,"","",{"p"},{0},{"="},{0},24660,640,1382,445,3160,499,"","",10171,447,"","",11002,566,-644,566,"","",16017,566,4664,640,16327,499}
,{133,48,-43920,298,8119,2,13544,357,132.95285,320,0,0.061,"",0.006,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,"","",90,0},{"=","","="},{0,"","",90,0},4844,315,"","",-8735,670,26954,298,"","",10420,304,1728,357,17419,582,39017,298,7171,582,6641,582,"",""}
,{133,49,-57464,196,8215,1,13410,196,132.93831,210,0,0.165,"",0.003,"",4.5,1,"","",{"B-","B-n","B-2n"},{0,85,"","",""},{"=","=",""},{0,85,"","",""},5581,196,31662,537,-7909,445,21460,196,-30963,537,11011,196,3124,205,14489,277,28394,196,8466,221,8518,197,-6120,537}
,{133,50,-70873.88,1.904,8310.088,0.014,8049.623,3.662,132.923913756,2.044,0,1.46,"",0.03,"",3.5,-1,"","",{"B-","B-n"},{0,0.0294,0},{"=","="},{0,0.0294,0},9751.94,4.09,30232.86,102.48,-10240.75,16.87,12063.24,2.81,-27899,196,690.07,3.12,2398.65,2.74,15751.31,60.06,16769.69,3.06,7861.96,3.3,3873.38,38.09,-4109.89,22.44}
,{133,51,-78923.503,3.128,8364.729,0.024,4013.619,3.518,132.91527213,3.357,0,140.4,"",3,"",3.5,1,"","",{"B-"},{0},{"="},{0},13084.74,3.76,25476.41,4.13,-8510.7,4.13,6934.76,7.15,-23800.93,60.11,-1806.63,4.68,7359.55,3.98,9665.93,3.7,9147.43,3.13,9051.87,4.78,6072.76,3.65,-3393.89,38.17}
,{133,52,-82937.122,2.066,8389.025,0.016,2921.139,6.751,132.910963332,2.218,0,750,"",18,"",1.5,1,"","",{"B-"},{0},{"="},{0},13868.74,2.07,20250.49,4.17,-4771.13,17.4,4706.45,3.17,-13679.55,2.86,-5304.95,4.56,5820.25,4.05,10590.82,3.22,4616.49,2.29,9755.09,2.93,4212.61,14.36,2841.49,2.79}
,{133,53,-85858.26,6.427,8405.106,0.048,1785.311,6.861,132.907827361,6.9,0,74988,"",288,"",3.5,1,"","",{"B-"},{0},{"="},{0},14558.18,6.46,18454.8,6.76,-3653.87,22.18,2212.67,6.43,-13511.96,6.88,-4650.62,6.43,8226.09,7.61,7959.05,7.31,-363.88,28.67,10063.56,6.43,6358.74,6.43,2073.82,15.6}
,{133,54,-87643.571,2.4,8412.647,0.018,427.36,2.4,132.90591075,2.576,0,453384,"",43.2,"",1.5,1,"","",{"B-"},{0},{"="},{0},15372.65,2.4,17010.5,2.4,-3063.68,2.55,-89.96,2.6,-9744.36,4.23,-8562.21,2.61,6435.93,2.4,9229.05,4.72,-5225.36,16.53,10509.95,2.48,4156.62,3.97,5355.78,2.4}
,{133,55,-88070.931,0.008,8409.978,0,-517.319,0.992,132.905451961,0.008,1,"s","","s","",3.5,1,"","",{},{},{},{},16154.78,4.97,15206.16,0.6,-1988.72,3.17,-2576.55,27.94,-9656.41,4.07,-7707.23,1.05,8989.57,1.04,6080.94,0.01,-10133.35,12.5,11053.43,0.01,6673.59,0.01,4511.61,3.17}
,{133,56,-87553.613,0.992,8400.206,0.007,-2059.23,27.962,132.906007325,1.065,0,332957126.226,"",347126.186,"",0.5,1,"","",{"EC"},{0},{"="},{0},17012.52,2.69,13718,0.99,-1282.47,0.99,-5135.4,16.38,-5563.62,0.99,-11901.28,36.35,7189.91,0.36,7689.9,1.43,-15221.24,46.59,11215.98,5.06,4210.19,8.42,7973.25,0.99}
,{133,57,-85494.383,27.945,8378.841,0.21,-3076.168,32.379,132.908218,30,0,14083.2,"",28.8,"",2.5,1,"","",{"B+"},{0},{"="},{0},17867.76,39.52,12013.54,28.38,-420.05,28.31,-7556.8,30.61,-5630.67,27.96,-11094.8,34.62,9842.05,45.86,4348.34,27.96,-20086.74,57.54,11900.15,28.06,6631.22,28.06,7051.76,29.17}
,{133,58,-82418.214,16.354,8349.829,0.123,-4480.634,20.583,132.911520402,17.557,0,5820,"",240,"",0.5,1,"","",{"B+"},{0},{"="},{0},18852.41,36.65,10312.42,16.55,220.07,19.48,-10085.84,49.36,-1272.17,16.39,-15262.08,33.19,8018.64,26.18,5983.54,39.87,-25187,299,12061.85,32.38,4073.21,30.67,10489.73,16.55}
,{133,59,-77937.581,12.497,8310.258,0.094,-5605.208,48.222,132.916330561,13.416,0,390,"",18,"",1.5,1,"","",{"B+"},{0},{"="},{0},19779.56,48.63,8746.27,30.61,962.08,24.74,-12529.93,51.83,-1502.9,38.45,-14583.09,27.24,10781.44,31.46,2755.66,23.96,-30702,298,12481.67,35.1,6349.38,30.61,9336.19,28.8}
,{133,60,-72332.372,46.575,8262.231,0.35,-6924.726,68.552,132.922348,50,0,70,"",10,"",3.5,1,"","",{"B+"},{0},{"="},{0},20706.97,54.1,7201.87,56.97,1530.21,54.31,-15101,302,2849.55,50.86,-18776,156,8977.88,52.49,4393.89,54.8,-36473,502,12679.09,66.16,3707.14,79.37,12736.93,54.31}
,{133,61,-65407.646,50.301,8204.283,0.378,-8177,302,132.929782,54,0,13.5,"",2.1,"",1.5,1,"","",{"B+"},{0},{"="},{0},21890,206,5684.93,68.84,1941,58.47,-18172,302,2530.84,58,-18400,302,11851,157,1270.81,55.82,"","",13071.19,57.34,6052.64,57.54,11414.21,81.62}
,{133,62,-57231,298,8137,2,-9995,422,132.93856,320,0,2.89,"",0.16,"",2.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23241,499,4041,299,2659,360,-21371,582,6906,299,-23102,499,10223,422,2892,333,"","",13140,359,3029,357,15012,299}
,{133,63,-47236,298,8056,2,-11376,582,132.94929,320,0,0.2,"","s","",5.5,-1,"","",{},{},{},{},24109,499,2154,359,3220,422,"","",7103,333,"","",13107,499,-554,422,"","",13608,499,5134,499,13806,357}
,{133,64,-35860,500,7964,4,"","",132.961503,537,0,0.01,"","s","",2.5,1,"","",{},{},{},{},"","",305,641,3715,707,"","",11931,582,"","","","",948,640,"","",14121,641,2687,708,17293,641}
,{134,48,-38920,400,8082,3,12741,499,133.958218,429,0,0.065,"",0.015,"",0,1,"","",{"B-","B-n","B-2n"},{0,"","",90,0},{"=","","="},{0,"","",90,0},4799,445,"","","","",27514,400,"","",10473,445,3071,499,"","",43614,400,5581,640,6325,640,"",""}
,{134,49,-51661,298,8171,2,14773,298,133.94454,320,0,0.14,"",0.004,"",0,0,"","",{"B-","B-n","B-2n"},{0,65,0,4,0},{"=","=","<"},{0,65,0,4,0},5392,304,32449,582,-8388,582,22360,298,"","",11142,298,2268,357,15030,422,32383,298,9314,357,8422,315,-5634,582}
,{134,50,-66433.748,3.167,8275.171,0.024,7586.794,3.597,133.928680433,3.4,0,0.89,"",0.02,"",0,1,"","",{"B-","B-n"},{0,17,""},{"=","="},{0,17,""},6029.84,3.73,30748,196,-7741.07,22.58,16099.99,4.19,-29803,298,4418.44,4.45,3631.19,3.7,16259,196,21692.07,3.17,6688.6,60.12,6455.34,4.16,-5568.38,102.51}
,{134,51,-74020.542,1.705,8325.95,0.013,8513.2,3.233,133.920535675,1.83,0,0.78,"",0.06,"",0,-1,"","",{"B-","B-n"},{0,5,0},{"=","="},{0,5,0},10527.9,3,26186.94,60.06,-6562.25,38.08,10022.89,5.15,-23846,196,845.26,2.68,3168.36,3.56,10435.63,2.56,12870.61,1.71,13236.81,2.61,8108.08,4,-349.11,3.19}
,{134,52,-82533.741,2.746,8383.643,0.02,1509.687,4.933,133.911396379,2.948,0,2508,"",48,"",0,1,"","",{"B-"},{0},{"="},{0},13488.19,4.44,20565.14,3.38,-4826.45,3.32,5592.08,2.75,-18948.83,3.34,-4746.8,6.99,7667.94,3.44,10899.21,4.16,6416.11,2.76,7812.34,3.69,4311.71,3.45,377.23,4.54}
,{134,53,-84043.429,4.857,8389.071,0.036,4082.393,4.857,133.909775663,5.213,0,3150,"",12,"",0,0,"","",{"B-"},{0},{"="},{0},14482.57,6.33,18986.1,5.45,-4182.67,15.02,2847.73,4.86,-12408.9,5.78,-4471.17,5.42,6256.49,8.06,8395.28,5.28,1175.22,20.51,11855.56,5.98,6031.64,4.86,3584.37,5.28}
,{134,54,-88125.822,0.009,8413.699,0,-1234.667,0.018,133.905393033,0.01,1,"s","","s","",0,1,"","",{},{},{},{},14989.49,0.01,17515.58,3.49,-3197.79,0.01,824.03,0.3,-12477.67,2.07,-8126.21,0.01,8553.57,2.4,9556.53,6.43,-3292.93,20.39,8288.47,4.07,4180.94,0.6,2731.59,0.06}
,{134,55,-86891.154,0.016,8398.646,0,2058.699,0.304,133.906718503,0.017,0,65171363.5752,"",12622.7704,"",4,1,"","",{"B-","EC"},{0,0.0003,0},{"=","="},{0,0.0003,0},15881.11,1.04,15765.61,4.07,-2379.93,3.17,-1672.5,19.93,-8321.86,6.43,-7408.86,0.99,6891.54,0.01,6536.55,2.4,-8363.16,20.32,13098.61,0.02,6386.46,0.02,6197.96,0.6}
,{134,56,-88949.853,0.304,8408.171,0.002,-3731.204,19.932,133.904508399,0.326,1,"s","","s","",0,1,"","",{},{},{},{},16657.47,1.1,14248.83,0.3,-1494.31,0.3,-4116.96,20.39,-8595.25,2.42,-11526.79,27.95,9467.56,1.04,8167.89,0.3,-13303.42,11.82,8913.63,1.08,3972.99,4.98,5110.11,0.3}
,{134,57,-85218.65,19.93,8374.488,0.149,-385.76,28.51,133.908514011,21.395,0,387,"",9.6,"",1,1,"","",{"B+"},{0},{"="},{0},17637.63,41.46,12643.91,19.96,-743.82,21.61,-6690.66,28.46,-4436.69,19.93,-10871.75,25.78,7795.58,34.32,4954.01,19.95,-18479.9,61.09,13927.17,19.96,6329.14,20.09,8486.54,20.54}
,{134,58,-84832.889,20.387,8365.771,0.152,-6304.898,28.781,133.908928142,21.886,0,273024,"",3456,"",0,1,"","",{"EC"},{0},{"="},{0},18504.63,28.87,10975.81,20.41,3.74,20.55,-9186.46,23.56,-4568.25,20.41,-14966.63,23.91,10485.99,26.14,6627.48,34.59,-23457,197,9601.57,41.68,3800.42,34.59,7497.24,20.55}
,{134,59,-78527.991,20.316,8312.881,0.152,-2881.559,23.503,133.915696729,21.81,0,1020,"",120,"",2,-1,"","",{"B+"},{0},{"="},{0},19443.17,35.31,9382.28,41.65,674.46,32.95,-11789.24,61.22,-322.58,34.55,-14266.94,50.81,8661.73,23.85,3398.75,26.08,-28600,299,14653.71,28.82,6044.5,38.58,10887.67,34.55}
,{134,60,-75646.432,11.817,8285.538,0.088,-8907.681,58.949,133.91879021,12.686,0,510,"",90,"",0,1,"","",{"B+"},{0},{"="},{0},20363.26,26.94,7753.48,23.61,1351.56,30.34,-14270,196,-517.19,20.18,-18310.1,51.67,11385.38,48.05,4997.82,17.2,-34344,401,10291.83,31.2,3518.28,48.46,9708.41,34.87}
,{134,61,-66738.751,57.753,8213.225,0.431,-5363,204,133.928353,62,0,22,"",1,"",5,1,"","",{"B+"},{0},{"="},{0},21254,160,6089.24,64.57,2011.79,86.41,-16811,304,3909.86,59.09,-17579,304,9402.42,76.59,1695.35,74.19,"","",15397.86,62.62,5893.34,63.97,13208.31,74.46}
,{134,62,-61376,196,8167,1,-11448,357,133.93411,210,0,9.5,"",0.8,"",0,1,"","",{"B+"},{0},{"="},{0},22440,357,4528,197,2795,198,-20074,446,3667,201,-22211,357,12216,357,3257,202,"","",10962,246,3148,280,12038,198}
,{134,63,-49928,298,8076,2,-8626,499,133.9464,320,0,0.5,"",0.2,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23870,499,2878,333,3043,357,"","",8191,302,-22140,582,10763,422,-14,422,"","",15862,422,5069,499,15379,359}
,{134,64,-41302,401,8006,3,"","",133.95566,430,0,0.4,"","s","",0,1,"","",{},{},{},{},"","",801,499,3779,566,"","",8640,499,"","",13514,641,1355,499,"","",11609,566,2832,566,14477,566}
,{135,49,-46528,401,8132,3,14104,401,134.95005,430,0,0.101,"",0.004,"",4.5,1,"","",{"B-n","B-2n"},{0,8,0},{"=","="},{0,8,0},5207,446,"","",-8573,641,23162,401,"","",11834,401,2939,499,14897,566,37251,401,8103,499,8599,446,-7092,641}
,{135,50,-60632.244,3.074,8230.687,0.023,9058.079,4.052,134.934908605,3.3,0,0.515,"",0.005,"",3.5,-1,"","",{"B-","B-n","B-2n"},{0,21,0,6,0},{"=","=","="},{0,21,0,6,0},5901,3.62,31290,298,-7838.19,102.51,17096.54,3.52,-29002,400,5316.98,3.52,2269.81,4.41,16261,298,25780.91,4.83,7542,196,6643.35,60.11,-4722,196}
,{135,51,-69690.323,2.64,8291.989,0.02,8038.457,3.152,134.925184357,2.834,0,1.679,"",0.015,"",3.5,1,"","",{"B-","B-n"},{0,22,0},{"=","="},{0,22,0},6909.45,4.09,26804,196,-4090.21,3.78,14088.82,3.35,-25319,298,4772.1,3.81,3741.1,3.14,10545.55,4.12,17891.32,2.82,11894.36,3.26,11720.27,3.3,-1632.38,60.09}
,{135,52,-77728.78,1.722,8345.738,0.013,6050.366,2.686,134.916554718,1.848,0,19,"",0.2,"",3.5,-1,"","",{"B-"},{0},{"="},{0},10934.29,2.69,21432.84,2.57,-2889.12,4.01,8684.37,4.1,-18584,3.61,-1756.67,5.15,3266.36,3.24,10997.21,2.42,10121.72,1.75,11905.53,3.57,6770.55,3.01,4464.16,2.62}
,{135,53,-83779.145,2.061,8384.76,0.015,2634.005,3.868,134.910059382,2.212,0,23688,"",108,"",3.5,1,"","",{"B-"},{0},{"="},{0},14063.52,6.75,19433.58,3.75,-4222.66,2.93,3802.5,2.25,-17047.57,2.67,-3724.64,2.06,7807.03,5.28,8534.37,3.43,2864.17,9.66,9868.78,2.92,6273.1,4.05,1502.53,3.21}
,{135,54,-86413.151,3.72,8398.476,0.028,1168.492,3.675,134.907231661,3.993,0,32904,"",72,"",1.5,1,"","",{"B-"},{0},{"="},{0},14912.21,4.43,18053.97,4.26,-3627.05,3.72,1437.35,3.73,-11168.38,4.62,-7593.31,3.72,6358.65,3.72,9658.69,6.12,-1796.98,10.92,10155.92,7.43,4154.39,5.51,4421.44,5.1}
,{135,55,-87581.643,0.992,8401.336,0.007,268.855,1.038,134.905977234,1.064,0,41970711580000,"",5995815940000,"",3.5,1,"","",{"B-"},{0},{"="},{0},15653.35,0.99,16301.32,6.5,-2563.85,1.16,-938.33,9.49,-10827.18,4.96,-6703.11,1.04,8761.81,0.99,6744.79,0.99,-6645.78,11.86,10772.73,2.6,6561.37,0.99,3768.25,4.18}
,{135,56,-87850.498,0.306,8397.533,0.002,-1207.181,9.43,134.905688606,0.328,1,"s","","s","",1.5,1,"","",{},{},{},{},16439.52,1.04,14784.87,2.42,-1861.86,0.31,-3234.33,10.26,-7013.65,0.31,-10703.17,19.93,6971.96,0.1,8248.31,0.31,-11636.89,19.13,10931.24,0.31,4166.24,1.08,7074.87,0.31}
,{135,57,-86643.317,9.434,8382.795,0.07,-2027.146,4.61,134.906984568,10.127,0,70200,"",720,"",2.5,1,"","",{"B+"},{0},{"="},{0},17291.57,29.49,13150.33,9.43,-1009.45,10.66,-5707.46,15.12,-7041.13,9.43,-9881.74,22.46,9495.98,22.05,4982.43,9.43,-16591.24,76.04,11621.1,9.49,6655.76,9.49,6155.77,9.49}
,{135,58,-84616.171,10.267,8361.984,0.076,-3680.31,15.655,134.909160799,11.022,0,63720,"",1080,"",0,0,"","",{"B+"},{0},{"="},{0},18340.59,19.31,11640.5,10.32,-357.36,10.58,-8402.56,21.71,-2955.29,10.26,-14159.5,22.76,7854.6,22.83,6686.49,22.42,-21758.96,154.97,11589.02,29.77,3971.53,37.78,9465.25,10.32}
,{135,59,-80935.861,11.817,8328.928,0.088,-4722.252,22.484,134.913111774,12.686,0,1440,"",60,"",0,0,"","",{"B+"},{0},{"="},{0},19140.91,17.2,10019.42,30.34,408.48,30.34,-10883.79,76.37,-3006.18,23.17,-13360.75,16.71,10479.19,23.5,3391.94,23.56,-26788,196,12193.16,20.18,6399.09,23.61,8434.19,38.23}
,{135,60,-76213.609,19.128,8288.153,0.142,-6161.534,77.838,134.91818132,20.534,0,744,"",36,"",0,0,"","",{"B+"},{0},{"="},{0},20023.87,50.35,8373.34,25.17,1069.91,37.97,-13356.39,155.81,1330.31,27.96,-17546.18,60.84,8638.49,22.48,4974.59,27.9,-31823,400,12434.78,22.85,3877.9,34.64,11903.69,28}
,{135,61,-70052.075,75.451,8236.717,0.559,-7194.86,172.054,134.924796,81,0,49,"",3,"",2.5,1,"","",{"B+"},{0},{"="},{0},20787.06,90.68,6692.44,76.48,1823.67,88.89,-15904,210,1186.95,78.14,-16747,210,11384.64,95.02,1694.61,76.37,-37227,408,12991.1,88.67,6237.79,79.24,10821.78,80.79}
,{135,62,-62857.215,154.628,8177.626,1.145,-8709,249,134.93252,166,0,10.3,"",0.5,"",3.5,1,"","",{"B+","B+p"},{0,0.02,0},{"=","="},{0,0.02,0},21769,336,5102.78,161.49,2485.9,157.06,-18467,428,5500.25,155.08,-21000,336,9552,249,3407.44,165.06,"","",13261.24,162.6,3634,215,14214.99,156.51}
,{135,63,-54148,196,8107,1,-9757,445,134.94187,210,0,1.5,"",0.2,"",5.5,-1,"","",{"B+"},{0},{"="},{0},23054,357,3318,202,3088,280,-21322,446,5302,204,-20917,446,12291,357,61,277,"","",13794,357,5796,357,13126,246}
,{135,64,-44390,400,8029,3,-11565,566,134.952345,429,0,1.1,"",0.2,"",2.5,1,"","",{"B+","B+p"},{0,18,0},{"=","="},{0,18,0},24673,640,1737,499,3318,566,"","",9697,445,"","",11159,566,1751,499,"","",13557,499,2674,565,16335,499}
,{135,65,-32825,401,7938,3,"","",134.96476,430,0,0.00101,"",0.00028,"",3.5,-1,"","",{"p"},{0},{"~"},{0},"","",167,499,4020,567,"","",9814,499,"","","","",-1188,7,"","",13745,641,"","",15021,566}
,{136,49,-40510,400,8087,3,15389,499,135.956511,429,0,0.086,"",0.009,"",0,0,"","",{"B-","B-n","B-2n"},{0,0,0,90,0},{"=","=","="},{0,0,0,90,0},4992,499,"","",-9145,640,23997,400,"","",12051,400,2053,566,"","",39035,400,9121,565,8274,499,"",""}
,{136,50,-55899,298,8195,2,8608,298,135.93999,320,0,0.35,"",0.005,"",0,1,"","",{"B-","B-n","B-2n"},{0,28,0,2,0},{"=","=","="},{0,28,0,2,0},5608,298,31557,499,-8060,357,18526,298,"","",5720,298,3338,298,16660,499,30530,298,6473,422,6429,357,-6333,422}
,{136,51,-64506.88,5.83,8252.252,0.043,9918.389,6.26,135.930749011,6.258,0,0.923,"",0.014,"",1,-1,"","",{"B-","B-n","B-2n"},{0,16.3,0,10,0},{"=","=","="},{0,16.3,0,10,0},6628.97,6.07,27424,298,-4520.25,60.31,15038.33,15.34,-25268,401,5150.58,6.08,2887.87,6.4,11163.61,6.59,21831.82,6.13,12637.67,6.63,11231.05,6.13,-1397,196}
,{136,52,-74425.269,2.281,8319.429,0.017,5119.945,14.188,135.920101182,2.448,0,17.63,"",0.08,"",0,1,"","",{"B-","B-n"},{0,1.31,0},{"=","="},{0,1.31,0},8034.16,3.57,22569.46,3.9,-303.64,3.02,12003.89,2.28,-21082,3.83,1282.56,3.07,4767.81,2.86,12023.92,3.49,14461.65,2.3,10306.08,2.85,9362.29,3.87,2095.01,2.97}
,{136,53,-79545.214,14.188,8351.323,0.104,6883.945,14.188,135.914604695,15.231,0,83.4,"",1,"",1,-1,"","",{"B-"},{0},{"="},{0},11644.42,15,20102.61,14.29,-2334.86,14.4,6793.48,14.31,-17143.86,14.43,-1203.38,14.67,3837.39,14.34,9105.4,14.29,6492.26,55.03,13699.33,14.45,8255.96,14.34,5024.69,14.53}
,{136,54,-86429.159,0.007,8396.188,0,-90.462,1.882,135.907214476,0.007,0,6.910966794e+28,"",1.89341556e+27,"",0,1,"","",{"2B-"},{0},{"="},{0},14445.97,0.01,18473.36,2.75,-3665.89,3.49,2457.76,0.31,-15989.35,1.72,-6918.83,0.99,8087.33,3.72,9938.98,2.06,79.21,0.41,8325.08,4.86,4293.16,6.43,2154.36,2.07}
,{136,55,-86338.697,1.882,8389.77,0.014,2548.224,1.857,135.90731159,2.02,0,1137024,"",2592,"",5,1,"","",{"B-"},{0},{"="},{0},15590.18,1.88,16873.21,5.21,-3060.12,4.48,-301.22,53.2,-9848.52,2.79,-6559.52,1.86,6828.37,2.13,7214.52,4.17,-4998.34,11.61,12497.93,1.88,6168.93,3.05,5165.96,6.7}
,{136,56,-88886.921,0.306,8402.755,0.002,-2849.443,53.172,135.904575959,0.328,1,"s","","s","",0,1,"","",{},{},{},{},16079.7,0.11,15339.04,0.31,-2032.88,0.31,-2378.55,0.27,-9762.74,3.73,-10314.92,9.43,9107.74,0.04,8594.25,1.04,-9687.63,11.82,8715.04,0.31,4048.06,0.31,4403.05,2.42}
,{136,57,-86037.479,53.171,8376.05,0.391,470.893,53.173,135.907634962,57.081,0,592.2,"",1.8,"",1,1,"","",{"B+"},{0},{"="},{0},16961.46,56.78,13724.27,53.17,-1309.71,53.18,-4697.12,54.39,-5744.81,53.18,-9492.63,54.15,7465.48,54,5475.95,53.17,-14867.56,87.17,13623.18,53.17,6380.19,53.18,7679.85,53.17}
,{136,58,-86508.372,0.408,8373.76,0.003,-5168.017,11.457,135.907129438,0.438,1,"s","","s","",0,1,"","",{},{},{},{},17818.12,20.39,12136.46,0.29,-498.27,1.13,-7309.09,11.82,-5946.84,0.27,-13643.83,11.82,9963.52,10.27,7154.03,9.43,-19697.48,12.5,9421.08,19.93,3850.07,27.95,6691.64,1.07}
,{136,59,-81340.355,11.455,8330.008,0.084,-2141.068,16.458,135.912677532,12.297,0,786,"",6,"",2,1,"","",{"B+"},{0},{"="},{0},18955,23.32,10699.65,22.99,-41.62,38.12,-10170.44,70.02,-1986.01,14.84,-13198.06,22.3,8475.81,16.46,4013.15,15.38,-25097,196,14203.34,23.38,5941.91,19.97,9800.43,30.2}
,{136,60,-79199.287,11.817,8308.512,0.087,-8029.371,70.076,135.914976064,12.686,0,3042,"",18,"",0,1,"","",{"B+"},{0},{"="},{0},19695.49,16.71,8944.34,23.56,846.69,23.61,-12388.4,17.2,-1872.09,15.65,-17218.53,76.37,11056.99,22.48,5552.4,16.71,-30110,298,10039.51,23.5,3602.35,17.2,8865.33,20.18}
,{136,61,-71169.915,69.073,8243.72,0.508,-4359.026,70.194,135.923595949,74.152,0,107,"",6,"",0,0,"","",{"B+"},{0},{"="},{0},20573.8,90.04,7219.87,72,1632.62,74.87,-14926,207,2476.98,70.08,-16384.02,169.35,9189.16,102.29,2245.28,71.67,-35040,505,15187.32,70.08,6026.51,83.31,12414.07,70.19}
,{136,62,-66810.89,12.497,8205.916,0.092,-10567,196,135.928275555,13.416,0,47,"",2,"",0,1,"","",{"B+"},{0},{"="},{0},21577,196,5742.4,17.2,2190,27.24,-17721,298,2113.75,22.85,-20734,196,12024.99,155.13,4047.79,76.48,"","",10638.67,59.09,3460.81,51.83,11167.88,48.22}
,{136,63,-56244,196,8122,1,-7154,357,135.93962,210,0,3.3,"",0.3,"",7,1,"","",{"B+","B+p"},{0,0.09,0},{"=","="},{0,0.09,0},22458,357,4083,204,2959,246,-20114,537,6519,210,-19925,445,10167,277,675,249,"","",15843,277,5851,357,14810,202}
,{136,64,-49090,298,8064,2,-12960,582,135.9473,320,0,1,"",2e-07,">",0,1,"","",{},{},{},{},23930,499,2292,357,3565,422,"","",6479,336,-24336,499,12771,499,2231,357,"","",11549,422,3010,422,13788,422}
,{136,65,-36130,500,7963,4,"","",135.961213,537,0,0.2,"","s","",0,0,"","",{},{},{},{},"","",780,582,3646,640,"","",10729,537,"","",11376,641,-972,640,"","",15883,641,4594,707,16753,582}
,{137,49,-35040,500,8047,4,14748,641,136.962383,537,0,0.07,"",0.04,"",4.5,1,"","",{"B-","B-n","B-2n"},{0,0,0,90,0},{"=","=","="},{0,0,0,90,0},4655,641,"","","","",25020,503,"","",12788,582,2602,640,"","",41316,500,"","",8744,640,"",""}
,{137,50,-49788,401,8149,3,10272,404,136.94655,430,0,0.273,"",0.007,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,50,0,40,0},{"=","=","="},{0,50,0,40,0},5299,401,"","",-8293,499,19515,401,"","",6647,401,1961,499,16568,566,32595,401,7451,566,6736,499,-5222,566}
,{137,51,-60060.384,52.164,8218.476,0.381,9243.369,52.206,136.935522522,56,0,0.484,"",0.022,"",3.5,1,"","",{"B-","B-n","B-2n"},{0,49,0,"",""},{"=","=",""},{0,49,0,"",""},6512.7,52.23,28110,404,-5021,202,16295.87,52.83,-26840,403,6293.57,52.21,3624.82,52.49,11450,303,26485.22,52.16,11282.67,52.25,11237.42,52.26,-2753,303}
,{137,52,-69303.753,2.1,8280.235,0.015,7052.506,8.643,136.925599357,2.254,0,2.49,"",0.05,"",1.5,-1,"","",{"B-","B-n"},{0,2.99,0},{"=","="},{0,2.99,0},7717.61,2.72,23249.45,3.72,-854.79,2.83,13079.65,2.1,-20694,298,2170.14,14.34,2949.8,3.1,12085.84,6.2,18417.48,2.12,11097.38,3.37,9580.84,2.71,2776.4,3.8}
,{137,53,-76356.258,8.383,8326.002,0.061,6027.145,8.384,136.91802818,9,0,24.13,"",0.12,"",3.5,1,"","",{"B-","B-n"},{0,7.76,0},{"=","="},{0,7.76,0},8719.75,8.63,21243.88,8.79,142.33,8.95,10189.35,8.39,-19138.35,10.21,2001.58,8.38,4882.36,16.48,9219.96,8.69,10784.43,8.55,12083.33,8.56,11041.54,8.82,3310.68,8.56}
,{137,54,-82383.404,0.103,8364.286,0.001,4162.203,0.373,136.911557773,0.111,0,229.08,"",0.78,"",3.5,-1,"","",{"B-"},{0},{"="},{0},12112.89,3.72,19232.57,1.73,-1871.2,2.07,5337.83,0.33,-15247.11,2.28,-4116.02,1.88,4025.56,0.1,10127.16,14.19,3535.18,0.45,12106.55,2.06,6524.08,4.86,5796.74,2.75}
,{137,55,-86545.606,0.358,8388.956,0.003,1175.629,0.172,136.907089464,0.384,0,949232334.08,"",2840123.34,"",3.5,1,"","",{"B-"},{0},{"="},{0},15106.6,1.05,17344.4,2.09,-3112.26,6.44,595.08,1.64,-14289.36,14.19,-5730,0.19,8278.23,1.87,7405.42,0.36,-3343.91,8.14,10578.35,3.74,6444.27,0.36,3144.22,4.87}
,{137,56,-87721.235,0.314,8391.827,0.002,-580.547,1.632,136.905827375,0.337,1,"s","","s","",1.5,1,"","",{},{},{},{},16013.37,0.08,15886.03,3.73,-2502.58,2.42,-1802.65,0.32,-8581.05,0.31,-9755.07,53.17,6905.63,0.07,8671.51,1.86,-8136.67,11.74,10571.21,1.04,4033.97,0.31,6050.99,0.31}
,{137,57,-87140.688,1.659,8381.879,0.012,-1222.1,1.6,136.906450618,1.78,0,1893415560000,"",631138520000,"",3.5,1,"","",{"EC"},{0},{"="},{0},16640.01,9.57,14136.99,1.93,-1494.67,1.66,-3939,8.29,-8090.96,2.47,-8703.63,1.61,9174.53,53.2,5542.74,1.63,-13067.84,13.15,11420.62,1.63,6673.22,1.63,5396.87,1.66}
,{137,58,-85918.588,0.437,8367.248,0.003,-2716.895,8.133,136.907762596,0.469,0,32400,"",1080,"",1.5,1,"","",{"B+"},{0},{"="},{0},17445.05,10.27,12646.03,0.31,-789.89,1.08,-6334.02,11.75,-4320.64,0.31,-12649.55,11.46,7481.53,0.16,7170.08,53.17,-17892.06,42.4,11435.54,9.44,4164.12,19.93,8677.67,0.33}
,{137,59,-83201.693,8.137,8341.706,0.059,-3617.126,14.282,136.910679304,8.735,0,4608,"",108,"",2.5,1,"","",{"B+"},{0},{"="},{0},18408.47,14.35,11136.32,12.45,-132.23,29.11,-9128.84,15.37,-4453.18,53.79,-12073.72,14.35,9932.65,14.05,3982.29,8.13,-23055.8,9.24,12125.28,13.1,6495.25,21.95,7663.36,21.53}
,{137,60,-79584.567,11.737,8309.593,0.086,-5511.719,17.545,136.914562448,12.6,0,2310,"",90,"",0.5,1,"","",{"B+"},{0},{"="},{0},19513.59,22.44,9546.34,15.59,408.73,20.13,-11558.04,43.27,-365.17,11.74,-16485.97,70.06,8456.6,16.66,5533.18,16.4,-28371,298,12062.1,16.66,3807.48,23.46,10894.72,23.52}
,{137,61,-74072.848,13.041,8263.651,0.095,-6046.323,44.355,136.920479522,14,0,120,"","s","",2.5,1,"","",{},{},{},{},20163.41,76.57,7714.93,17.6,1439.82,18.06,-13926.95,13.76,-21.46,17.36,-15333.28,18.06,10974.25,70.29,2162.53,17.6,-33106,401,12851.57,23.15,6437.64,17.6,10101.54,24.14}
,{137,62,-68026.525,42.395,8213.806,0.309,-7880.63,42.62,136.926970517,45.512,0,45,"",1,"",4.5,-1,"","",{"B+"},{0},{"="},{0},21311.94,160.33,6390.86,46.51,1880.93,62.98,-16813,301,3883.79,44.01,-19854,200,9286.95,44.2,4145.58,81.05,"","",12736.36,86.55,3576.28,71.64,13266.31,44.01}
,{137,63,-60145.895,4.378,8150.573,0.032,-8932,298,136.935430722,4.7,0,8.4,"",0.5,"",5.5,-1,"","",{"B+"},{0},{"="},{0},22141,196,4671.76,75.58,2836.84,50.49,-19179,401,3735.05,69.21,-19127,298,11974,196,623.98,13.24,"","",13422.13,154.69,6094,196,12239.26,57.92}
,{137,64,-51214,298,8080,2,-10246,499,136.94502,320,0,2.2,"",0.2,"",0,0,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22966,499,2934,336,3593,422,"","",8308,298,-23155,582,10195,422,2259,357,"","",13645,357,3579,422,15809,357}
,{137,65,-40967,401,7999,3,"","",136.95602,430,0,0.6,"","s","",5.5,-1,"","",{},{},{},{},24284,566,1397,446,3844,499,"","",7988,446,"","",12909,641,-834,499,"","",14134,566,5199,566,14607,499}
,{138,50,-44861,503,8113,4,9360,1177,137.95184,540,0,0.15,"",0.03,"",0,1,"","",{"B-","B-n","B-2n"},{0,36,0,5,0},{"=","~","="},{0,36,0,5,0},5104,585,"","",-8366,642,20835,503,"","",7128,506,3144,643,17110,709,35111,503,6360,642,6531,643,"",""}
,{138,51,-54220.403,1064.232,8175.091,7.712,11475.582,1064.239,137.941792,1142.5,0,0.348,"",0.015,"",0,-1,"","",{"B-","B-n","B-2n"},{0,72,0,2,0},{"=","=","="},{0,72,0,2,0},5856.16,1064.25,28289,1137,-4985,1105,17759.5,1064.25,-26469,1176,7012.03,1064.23,2231.34,1065.51,11721,1137,28666.53,1064.27,12389,1105,11275.9,1064.24,-2046,1137}
,{138,52,-65695.985,3.787,8252.578,0.027,6283.914,7.063,137.929472454,4.065,0,1.4,"",0.4,"",0,1,"","",{"B-","B-n"},{0,6.3,0},{"=","="},{0,6.3,0},7413.35,4.42,24375,298,-1687.15,4.94,14276.25,4.71,-23197,401,2588.96,9.2,4463.55,4.33,12924.57,52.3,22565.65,3.8,9521.7,6.95,8858.39,4.62,582.66,4.88}
,{138,53,-71979.9,5.962,8292.444,0.043,7992.334,6.588,137.922726394,6.4,0,6.23,"",0.03,"",1,-1,"","",{"B-","B-n"},{0,5.46,0},{"=","="},{0,5.46,0},8577.32,15.39,22050.96,8.34,-384.27,6.2,10907.04,10.93,-19208.49,52.5,2332.19,5.96,3694.96,10.29,9965.12,6.32,14539.28,6.76,13156.18,6.38,10612.93,6.21,3356.82,6.52}
,{138,54,-79972.233,2.804,8344.69,0.02,2914.704,9.579,137.914146271,3.01,0,848.4,"",3,"",0,1,"","",{"B-"},{0},{"="},{0},9685.71,2.8,20124.91,3.61,136.59,3.92,8289.4,2.82,-17957.45,3.5,-1497.94,2.83,5660.15,2.81,10904.95,8.84,7598.69,5.67,10283.79,14.46,8670.97,3.48,3402.95,3.29}
,{138,55,-82886.937,9.159,8360.142,0.066,5374.7,9.159,137.911017207,9.832,0,2004.6,"",10.8,"",3,-1,"","",{"B-"},{0},{"="},{0},12690.87,9.35,17919.66,16.89,-1268.42,10.37,3632.24,9.7,-13819.65,12.42,-3237.02,9.16,4412.65,9.16,7792.5,9.16,246.98,14.43,14253.03,9.16,8390.27,9.89,6538.61,9.39}
,{138,56,-88261.638,0.317,8393.42,0.002,-1742.458,3.191,137.905247229,0.339,1,"s","","s","",0,1,"","",{},{},{},{},15517.35,0.08,16410.42,0.32,-2560.73,0.32,-690.72,4.93,-13167.2,0.33,-9192.27,1.63,8611.72,0.04,9005,0.18,-6243.33,11.61,8787.87,1.86,4184.06,1.04,3797.91,3.73}
,{138,57,-86519.18,3.188,8375.125,0.023,1051.742,4.038,137.907117834,3.422,0,3.218806452e+18,"",3.1556926e+16,"",5,1,"","",{"B+","B-"},{0,34.4,0},{"=","="},{0,34.4,0},16624.34,53.27,14758.42,3.69,-2052.94,3.19,-3385.26,10.78,-7262.54,3.2,-8671.91,3.21,7449.81,3.58,6086.92,3.19,-11578.7,27.92,13078.55,3.19,6195.37,3.19,6708.86,3.34}
,{138,58,-87570.922,4.931,8377.077,0.036,-4437,10,137.905988743,5.293,1,"s","","s","",0,1,"","",{},{},{},{},17205.18,4.94,13261.94,4.93,-1045.98,4.93,-5552.61,12.61,-7138.66,4.93,-12440.55,9.51,9723.65,4.94,7719.2,5.2,-16073.16,12.8,9177.36,53.4,3936.45,10.64,5925.98,4.93}
,{138,59,-83133.922,11.15,8339.255,0.081,-1115.612,16.09,137.910752059,11.969,0,87,"",3,"",1,1,"","",{"B+"},{0},{"="},{0},17936.2,15.98,11674.38,54.33,-340.19,22.84,-8193.44,29.9,-3282.2,11.27,-11620.67,16.19,8003.55,13.8,4504.3,11.16,-21384.25,30.09,14085.26,11.15,6346.3,15.16,9155.8,14.6}
,{138,60,-82018.31,11.601,8325.502,0.084,-7077.827,28.756,137.911949717,12.454,0,18144,"",324,"",0,1,"","",{"B+"},{0},{"="},{0},18961.66,16.56,10087.88,11.61,389.66,23.46,-10520.55,16.56,-3388.69,11.61,-16016.78,17.45,10505.06,16.5,6105.59,14.17,-26218,196,10032.85,16.3,3781.61,16.56,8244.26,15.49}
,{138,61,-74940.483,27.739,8268.544,0.201,-3442.721,30.151,137.919548077,29.778,0,10,"",2,"",1,1,"","",{"B+"},{0},{"="},{0},19913.2,74.43,8178.07,30.01,1162.59,34.38,-13190.81,39.37,972.24,28.91,-14985.28,50.66,8938.95,30.65,2644.89,30.12,-31272,299,14969.61,30.15,6137.18,33.69,11641.78,30.15}
,{138,62,-71497.762,11.817,8237.928,0.086,-9748.093,30.341,137.92324399,12.686,0,186,"",12,"",0,1,"","",{"B+"},{0},{"="},{0},20829.51,17.2,6876.42,16.71,1723.75,16.71,-15698,196,797.83,16.66,-19423.18,12.6,11542.55,44.01,4713.89,17.6,-36567,503,10382.96,70.08,3418.37,76.37,10362.25,22.48}
,{138,63,-61749.669,27.945,8161.62,0.202,-5949,198,137.933709,30,0,12.1,"",0.6,"",6,-1,"","",{"B+"},{0},{"="},{0},21649,198,5157.7,74.51,2564.17,64.16,-18081,299,5034.21,30.84,-18607,299,9675.09,28.29,1012.11,50.78,"","",15772.03,30.61,5971.6,157.13,13948.81,80.46}
,{138,64,-55800,196,8113,1,-12132,357,137.940096,210,0,4.7,"",0.9,"",0,1,"","",{"B+"},{0},{"="},{0},22853,357,3567,196,3151,277,-20869,540,4937,200,-22904,446,12658,357,2943,196,"","",11154,277,3212,277,12703,249}
,{138,65,-43668,298,8019,2,-8737,585,137.95312,320,0,0.8,"",2e-07,">",0,0,"","",{"p"},{0},{"="},{0},23681,582,2003,357,3835,422,"","",9188,298,"","",10773,499,-256,422,"","",16132,422,5586,499,16126,357}
,{138,66,-34931,503,7950,4,"","",137.9625,540,0,0.2,"","s","",0,1,"","",{},{},{},{},"","",419,585,3947,643,"","",8994,585,"","","","",1253,643,"","",11910,709,2759,643,15106,642}
,{139,50,-38440,500,8066,4,11348,641,138.958733,537,0,0.13,"",0.06,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,80,0,20,0},{"=","=","="},{0,80,0,20,0},4794,641,"","","","",21765,500,"","",7709,1176,1651,709,"","",37205,500,7311,707,6934,640,"",""}
,{139,51,-49788,401,8142,3,10417,401,138.94655,430,0,0.093,"",0.013,"",3.5,1,"","",{"B-","B-n","B-2n"},{0,90,"",3,0},{"=","=","="},{0,90,"",3,0},5871,404,29326,641,-5685,566,18683,401,"","",7836,401,3639,1137,12217,643,30913,401,10711,566,10975,499,-3632,566}
,{139,52,-60205.072,3.54,8211.771,0.025,8265.882,5.345,138.935367193,3.8,0,0.5,"",1.5e-07,">",2.5,-1,"","",{"B-n"},{0},{"="},{0},7043.95,4.12,24995,401,-1997.74,4.69,15439.5,4.14,-22633,503,3703.51,6.93,2580.4,5.18,13273.64,1064.24,24708.68,3.55,10566.12,52.28,9165.86,6.82,1340,298}
,{139,53,-68470.954,4.005,8265.609,0.029,7173.622,4.542,138.926493403,4.3,0,2.282,"",0.01,"",3.5,1,"","",{"B-","B-n"},{0,10,0},{"=","="},{0,10,0},8257.33,9.29,22988.51,52.32,-1205.55,4.8,12229.97,5.09,-21539.52,1064.24,3429.96,4.89,4562.37,7.18,10063.94,5.51,18755.26,4.48,11543.6,4.52,10818.37,4.61,1682.33,7.07}
,{139,54,-75644.576,2.142,8311.59,0.015,5056.346,3.801,138.918792203,2.3,0,39.68,"",0.14,"",1.5,-1,"","",{"B-"},{0},{"="},{0},9403.81,2.14,20918.76,3,-340.71,2.75,9269.18,2.17,-17237.56,4.35,-828.96,9.41,3743.66,3.53,10953.65,6.33,11303.29,7.54,11422.49,8.65,8764.69,14.35,4427.09,3.13}
,{139,55,-80700.921,3.14,8342.338,0.023,4212.829,3.123,138.913363992,3.37,0,556.2,"",3,"",3.5,1,"","",{"B-"},{0},{"="},{0},10297.95,3.13,18922.6,8.95,653.31,3.76,6525.29,3.72,-16009.99,6.74,-510.6,3.12,5885.3,9.68,8017.66,4.21,4117.88,8.41,12393.29,3.14,10592.29,3.14,4490.69,14.53}
,{139,56,-84913.751,0.319,8367.017,0.002,2312.461,2.013,138.908841334,0.342,0,4987.8,"",3.6,"",3.5,-1,"","",{"B-"},{0},{"="},{0},13335.15,0.06,17108.29,0.34,-925.52,3.73,2034.11,7.23,-12230.49,2.82,-6465.89,3.19,4723.43,0.04,9315.78,9.16,-2899.81,27.6,12342.66,0.18,6289,1.86,7161.81,0.32}
,{139,57,-87226.212,2.009,8378.025,0.014,-278.35,6.953,138.906358804,2.156,1,"s","","s","",3.5,1,"","",{},{},{},{},16228.16,2.59,15258.55,2.02,-2069.49,2.24,-2407.41,7.55,-11628.25,9.37,-7726.61,4.59,8778.35,2.52,6253.54,2.01,-9725.73,13.73,11205.83,2.01,6524.76,2.01,4758.89,2.74}
,{139,58,-86947.862,7.23,8370.395,0.052,-2129.064,2.996,138.906657625,7.761,0,11892182.4,"",1728,"",1.5,1,"","",{"EC"},{0},{"="},{0},17171.91,7.24,13804.57,7.23,-1522.28,7.23,-4933.92,27.97,-5975.19,7.23,-11885.26,13.02,7448.26,8.33,7717.65,7.39,-14567.64,13.07,10903.63,7.41,3953.67,53.66,7585.46,7.23}
,{139,59,-84818.798,7.809,8349.449,0.056,-2804.856,28.033,138.90894327,8.383,0,15876,"",144,"",2.5,1,"","",{"B+"},{0},{"="},{0},17759.74,11.28,12256.05,7.98,-600.4,12.24,-7318.32,15.46,-5588.59,7.96,-10871.81,13.98,9756.19,13.35,4536.85,8.84,-19420.76,15.29,11810.6,7.82,6553.63,7.81,6865.08,53.74}
,{139,60,-82013.942,27.6,8323.642,0.199,-4513.46,25.927,138.911954407,29.63,0,1782,"",30,"",1.5,1,"","",{"B+"},{0},{"="},{0},18572.01,29.99,10673.29,27.6,177.31,29.45,-9633.72,29.67,-1731.99,28,-15144.78,39.13,8066.95,29.94,6168.99,29.73,-24382,198,11898.56,28.77,4190.47,29.88,10140.83,27.6}
,{139,61,-77500.481,13.593,8285.543,0.098,-5120.263,17.414,138.916799806,14.592,0,249,"",3,"",0,0,"","",{"B+"},{0},{"="},{0},19570.27,18.84,8876.73,15.84,1010.46,18.01,-12102.44,18.91,-1655.53,17.57,-14074.04,18.01,10631.32,30.89,2771.14,17.87,-29370,298,12794.89,17.96,6562.86,18.01,9486.27,17.78}
,{139,62,-72380.219,10.884,8243.078,0.078,-6982.177,17.071,138.922296634,11.684,0,154.2,"",6,"",0.5,1,"","",{"B+"},{0},{"="},{0},20496.33,43.77,7373.59,16.01,1408.47,22.01,-14749,196,2349.12,15.91,-18701.87,29.99,8953.77,16.07,4728.71,29.8,-34739,503,12403.44,16.99,3653.75,69.93,12465.47,16.07}
,{139,63,-65398.042,13.151,8187.218,0.095,-7767,196,138.92979231,14.117,0,17.9,"",0.6,"",0,0,"","",{"B+"},{0},{"="},{0},21394.78,13.86,5903.14,18.52,2229.12,76.59,-17268,298,2253.47,30.7,-17669,196,11719.69,30.88,1189.25,17.68,"","",13339.29,44.39,6276.9,18.14,11418.27,70.31}
,{139,64,-57632,196,8126,1,-9501,357,138.93813,210,0,5.7,"",0.3,"",4.5,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22561,357,4183,200,2801,249,-19990,540,6577,196,-22034,357,9903,277,3171,198,"","",13225,196,3476,277,14826,196}
,{139,65,-48130,298,8052,2,-10489,585,138.94833,320,0,1.6,"",0.2,"",5.5,-1,"","",{"B+"},{0},{"="},{0},23306,499,2562,298,3593,357,"","",6330,299,-21271,585,12533,422,-381,357,"","",13794,422,5823,422,13760,357}
,{139,66,-37642,503,7971,4,"","",138.95959,540,0,0.6,"",0.2,"",3.5,1,"","",{"B+"},{0},{"="},{0},"","",1006,585,4324,642,"","",10870,540,"","",10782,711,1262,585,"","",14036,643,3352,709,17094,585}
,{140,51,-43939,596,8100,4,12638,599,139.95283,640,0,0.1,"",4e-07,">",4,-1,"","",{"B-n","B-2n"},{0,20,0},{"=","="},{0,20,0},5861,1220,"","",-5854,718,19668,596,"","",8195,596,2222,718,12788,778,33112,596,11633,780,10714,718,-3252,778}
,{140,52,-56576.228,62.41,8184.847,0.446,7029.985,63.574,139.939262917,67,0,0.3,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},7022.88,62.52,26293,507,-3102,305,16410.22,62.45,-25425,504,3823.41,62.54,4442.47,62.51,14077,405,26693.13,62.91,8354.98,1066.06,8348.21,81.34,-1141,405}
,{140,53,-63606.213,12.109,8229.473,0.086,9380.238,12.331,139.931715917,13,0,0.86,"",0.04,"",4,-1,"","",{"B-","B-n","B-2n"},{0,9.3,0,0,0},{"=","=","="},{0,9.3,0,0,0},7768.95,13.5,23963.75,1064.3,-1524.25,13.44,13443.89,14.63,-21107,401,3967.05,12.3,3206.58,12.75,10690.11,12.62,20709.66,12.27,12800.58,12.69,10561.59,12.29,2100.57,53.55}
,{140,54,-72986.451,2.329,8290.887,0.017,4063.654,8.525,139.921645817,2.5,0,13.6,"",0.1,"",0,1,"","",{"B-"},{0},{"="},{0},9156.85,3.64,21868.41,4.45,-986.1,3.26,10282.9,8.27,-20070.35,4.24,-356.85,3.91,5413.19,3.16,11804.47,4.63,15089.64,2.82,9704.25,6.4,8233.86,8.7,1963.7,3.14}
,{140,55,-77050.105,8.201,8314.325,0.059,6219.249,9.882,139.917283305,8.804,0,63.7,"",0.3,"",1,-1,"","",{"B-"},{0},{"="},{0},10305.8,12.29,19648.15,10.14,70.19,16.39,7265.77,8.4,-15868.12,9.13,-207.67,8.21,4420.5,8.78,8694.5,8.48,7637.98,10.27,13632.93,8.67,10197.35,8.2,4952.55,11.73}
,{140,56,-83269.354,7.933,8353.16,0.057,1046.517,7.993,139.910606666,8.516,0,1101833.28,"",198.72,"",0,1,"","",{"B-"},{0},{"="},{0},11150.35,7.94,17875.06,8.41,734.89,7.93,4806.74,8.01,-14913.75,8.22,-4114.46,7.99,6426.92,7.94,9857.4,8.53,989.56,8.65,10328.39,12.12,8140.31,7.94,4760.45,7.93}
,{140,57,-84315.871,2.009,8355.047,0.014,3760.218,1.727,139.909483184,2.156,0,145026,"",10.8,"",3,-1,"","",{"B-"},{0},{"="},{0},13939.33,2.52,16006.87,9.37,-402.09,2.74,372.22,6.24,-10903.92,3.72,-5439.33,6.95,5160.98,0.04,6691.09,2.01,-6102.16,24.33,14656.57,2.01,8269.42,2.01,7876.14,2.02}
,{140,58,-88076.089,1.596,8376.317,0.011,-3388,6,139.905446424,1.713,1,"s","","s","",0,1,"","",{},{},{},{},16647.8,4.81,14392.39,1.62,-1614.08,1.61,-3817.18,3.8,-10451.31,1.62,-11328.61,7.75,9199.54,7.16,8138.85,1.73,-12620.15,12.6,9153.9,3.01,3928.65,2.29,5291.55,1.62}
,{140,59,-84688.089,6.209,8346.529,0.044,-429.177,7.101,139.909083592,6.665,0,203.4,"",0.6,"",1,1,"","",{"e+","EC"},{0,48.7,0},{"=","="},{0,48.7,0},17696.8,12.61,12746.85,6.71,-1075.53,53.53,-6474.38,25.03,-4750.85,6.24,-10745.46,28.27,7940.61,9.8,5029.2,9.34,-17702.15,51.91,13593.64,7.69,6094.55,6.22,8099,6.42}
,{140,60,-84258.912,3.447,8337.875,0.025,-6045.2,24,139.909544332,3.7,0,291168,"",1728,"",0,1,"","",{"EC"},{0},{"="},{0},18383.24,12.1,11265.93,6.02,-175.46,3.47,-8802.98,12.96,-4600.02,8.01,-14829.75,14.02,10316.29,27.81,6729.08,8.54,-22476.64,28.16,9585.82,11.67,3806.84,8.84,7306.08,3.47}
,{140,61,-78213.712,24.246,8289.107,0.173,-2757.777,27.277,139.916034122,26.029,0,9.2,"",0.2,"",1,1,"","",{"B+"},{0},{"="},{0},19415.86,36.84,9657.73,26.69,701.73,26.82,-11227.78,56.96,-683.88,25.47,-13904.81,26.58,8784.55,27.8,3488.74,36.74,-27731.44,800.86,14515.4,26.88,6234.91,26.94,10634.38,25.58}
,{140,62,-75455.935,12.497,8263.82,0.089,-8470,50,139.918994717,13.416,0,889.2,"",7.2,"",0,1,"","",{"B+"},{0},{"="},{0},20100.81,17.2,8015.57,17.05,1318.44,17.2,-13673.66,30.61,-730.96,30.3,-18129.21,18.14,11147.03,16.57,5244.42,18.47,-32626,401,10195.35,30.42,3480.97,18.06,9775.03,17.14}
,{140,63,-66985.935,51.538,8197.732,0.368,-5203.664,58.627,139.928087637,55.328,0,1.51,"",0.02,"",1,1,"","",{"B+"},{0},{"="},{0},21378.9,58.63,6623.39,58.53,1759.06,86.18,-16503.66,802.15,3225.58,53.3,-17426,202,9659.21,53.19,1894.69,52.67,-37727,506,15222.63,52.88,5904.65,66.73,12733.31,53.16}
,{140,64,-61782.271,27.945,8154.975,0.2,-11300,800,139.933674,30,0,15.8,"",0.4,"",0,1,"","",{"B+"},{0},{"="},{0},22125,198,4862.45,30.34,2603.7,30.61,-18952,402,3308.98,29.99,-21723,299,12222,198,3673.2,30.88,"","",10678.2,39.52,3227.68,28.29,11890.66,50.78}
,{140,65,-50482.271,800.488,8068.672,5.718,-7652,895,139.945805049,859.359,0,2.32,"",0.16,"",7,1,"","",{"B+","B+p"},{0,0.26,0},{"=","="},{0,0.26,0},22956,854,3310.54,800.98,3336,824,-21223,945,7626.8,800.6,-20912,945,10423,854,140,824,"","",16029,824,5595,854,15310.02,800.5}
,{140,66,-42830,401,8008,3,-13571,643,139.95402,430,0,0.7,"","s","",0,1,"","",{},{},{},{},24042,643,1608,446,3835,499,"","",7512,446,"","",13260,643,1989,499,"","",11549,499,3001,566,14030,499}
,{140,67,-29259,503,7906,4,"","",139.968589,540,0,0.006,"",0.003,"",8,1,"","",{"p","B+"},{"",1,0},{"","="},{"",1,0},"","",168,585,4446,709,"","",11583,585,"","","","",-1093.9,10,"","",16383,711,"","",17355,643}
,{141,51,-39110,500,8066,4,11377,641,140.958014,537,0,0.1,"","s","",3.5,1,"","",{"B-n","B-2n"},{0,3,0},{"=","="},{0,3,0},5464,641,"","",-6495,707,20817,500,"","",9395,504,3242,778,"","",35368,500,10041,707,10615,709,"",""}
,{141,52,-50487,401,8141,3,9440,401,140.9458,430,0,0.15,"",1.5e-07,">",2.5,-1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},6425,401,26625,641,-3124,566,17710,401,"","",5048,401,1982,405,13837,718,29246,401,10012,566,8597,1137,20,643}
,{141,53,-59926.657,15.835,8202.255,0.112,8270.642,16.097,140.935666084,17,0,0.43,"",0.02,"",3.5,1,"","",{"B-","B-n"},{0,21,0},{"=","="},{0,21,0},7598.34,16.33,24716,401,-2291.19,54.51,14550.87,18.31,-23277,596,4988.48,16.01,4391.76,19.93,10639.4,64.39,23004.98,16.39,10989.22,16.23,10633.38,16.28,-59.85,1064.35}
,{141,54,-68197.299,2.888,8255.364,0.02,6280.224,9.638,140.926787184,3.1,0,1.73,"",0.01,"",0,0,"","",{"B-","B-n"},{0,0.044,0},{"=","="},{0,0.044,0},8695.36,3.6,22570.17,4.57,-1318.46,3.57,11535.33,6.05,-18910.04,62.48,781.49,8.69,3282.16,3.71,11880.06,12.45,17235.62,3.3,10984.46,4.94,8646.66,6.62,3145.09,4.76}
,{141,55,-74477.523,9.195,8294.356,0.065,5255.103,9.617,140.920045086,9.871,0,24.84,"",0.16,"",3.5,1,"","",{"B-","B-n"},{0,0.035,0},{"=","="},{0,0.035,0},9919.24,9.72,20584.51,10.03,-546.18,12.44,8454.11,10.07,-18160.28,15.21,720.51,11.65,5498.74,12.2,8780.04,9.49,11538.12,9.33,11877.86,9.44,10358.77,9.61,3148.78,10.96}
,{141,56,-79732.626,5.319,8326.078,0.038,3199.01,6.6,140.9144035,5.71,0,1096.2,"",4.2,"",1.5,-1,"","",{"B-"},{0},{"="},{0},10961.51,5.33,18665.99,5.73,225.86,5.32,5700.29,5.52,-14035.15,5.81,-3488.07,5.66,4534.59,9.47,9971.49,9.75,4460,6.22,11679.1,6.18,8018.37,10.59,5886.01,6.01}
,{141,57,-82931.636,4.219,8343.217,0.03,2501.28,3.928,140.910969222,4.528,0,14112,"",108,"",3.5,1,"","",{"B-"},{0},{"="},{0},11848.06,4.29,16808.66,5.26,1189.06,4.23,3084.01,4.1,-13170.5,9.2,-2926.86,3.93,6687.08,4.29,6951.25,8.91,-2408.71,14.6,12692.92,4.23,10194.06,4.23,5601.7,10.08}
,{141,58,-85432.916,1.597,8355.408,0.011,582.728,1.202,140.908283987,1.714,0,2808950.4,"",1123.2,"",3.5,-1,"","",{"B-"},{0},{"="},{0},14627.69,7.16,15097.11,1.62,-136.6,1.62,-1240.29,3.06,-9452.53,8.01,-8816.14,6,5428.14,0.1,8406.02,1.73,-9499.01,8.63,12504.1,1.73,5950.32,3.01,8475.12,1.62}
,{141,59,-86015.644,1.665,8353.992,0.012,-1823.014,2.809,140.907658403,1.787,1,"s","","s","",2.5,1,"","",{},{},{},{},17339.48,7.81,13367.37,2.02,-1299.87,2.34,-5492.72,14.07,-8988.74,2.02,-9828.05,3.83,9398.87,6.12,5228.53,1.2,-16090.01,12.74,11643.02,7.23,6419.33,4.92,6149.94,3.19}
,{141,60,-84192.63,3.265,8335.515,0.023,-3669.709,14.349,140.909615488,3.505,0,8964,"",108,"",1.5,1,"","",{"B+"},{0},{"="},{0},18321.32,27.78,11822.71,7.76,-698.96,3.29,-8258.72,9.07,-3405.51,3.06,-14050.24,24.47,8005.04,4.75,6793.51,6.73,-20968.41,20.03,11336.97,8.3,3805.35,11.49,9024.69,5.67}
,{141,61,-80522.921,13.972,8303.94,0.099,-4589.012,16.375,140.913555084,15,0,1254,"",3,"",2.5,1,"","",{"B+"},{0},{"="},{0},19165.07,19.49,10282.06,16.01,253.86,16.17,-10597.29,18.84,-3123.8,15.29,-13138.3,18.75,10380.53,27.98,3552.98,14.39,-25982.08,106.18,12201.83,30.94,6359.44,18.16,8257.4,17.88}
,{141,62,-75933.909,8.539,8265.845,0.061,-6008.28,14.285,140.918481591,9.167,0,612,"",12,"",0.5,1,"","",{"B+"},{0},{"="},{0},19696.32,13.83,8497.91,28.89,1225.74,14.51,-12709.69,21.53,1036.03,9.21,-17019.29,52.24,8549.29,15.14,5009.17,25.71,-30552,298,12277.38,16.05,3870.63,29.02,11730.8,14.41}
,{141,63,-69925.629,12.639,8217.684,0.09,-6701.405,23.456,140.924931745,13.568,0,40.7,"",0.7,"",2.5,1,"","",{"B+"},{0},{"="},{0},20670.22,18.24,7003.09,18.56,1722.3,18.16,-15384.79,106.01,999.11,27.34,-16214.67,30.67,11011.01,53.07,1758.66,17.77,-35561,401,13165.4,16.68,6436.19,17.3,10661.26,30.48}
,{141,64,-63224.224,19.76,8164.608,0.14,-8683.387,107.098,140.932126,21.213,0,14,"",4,"",0.5,1,"","",{"B+","B+p"},{0,0.03,0},{"=","="},{0,0.03,0},21735,197,5421.95,22.56,2377.39,46.77,-17842,299,4942.74,23.38,-20813.27,800.73,9513.27,34.23,3527.26,55.2,"","",12884.62,23.74,3389.5,34.23,13919.94,23.02}
,{141,65,-54540.837,105.259,8097.475,0.747,-9158,316,140.941448,113,0,3.5,"",0.2,"",2.5,-1,"","",{"B+"},{0},{"="},{0},22553,316,3720.74,106.08,3180.14,105.35,-20176,414,5156.13,117.2,-19782,414,12129.88,807.38,47.54,108.91,"","",13802,222,6123,222,12855.23,108.91}
,{141,66,-45382,298,8027,2,-11018,499,140.95128,320,0,0.9,"",0.14,"",4.5,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23883,585,2329,357,3406,422,"","",9111,299,-24195,585,10624,499,2189,854,"","",13459,422,3150,422,16064,357}
,{141,67,-34364,401,7943,3,"","",140.963108,430,0,0.0041,"",0.0001,"",3.5,-1,"","",{"p","B+"},{"",1,0},{"","="},{"",1,0},"","",812,499,4178,567,"","",8829,895,"","",13177,643,-1176.78,7.43,"","",13988,643,5431,643,14950,499}
,{142,52,-46370,503,8111,4,8400,627,141.95022,540,0,0.1,"",1.5e-07,">",0,1,"","",{"B-n","B-2n"},{0,0,0},{"=","="},{0,0,0},5936,507,"","",-3934,711,18860,503,"","",5486,503,3954,643,14549,709,31472,503,8280,780,8283,643,-2283,709}
,{142,53,-54769.984,374.461,8165.019,2.637,10459.655,374.47,141.941202,402,0,0.222,"",0.012,"",2,-1,"","",{"B-","B-n","B-2n"},{0,20,0,1,0},{"=","=","="},{0,20,0,1,0},7306.41,374.66,25409,704,-2974.5,1128.19,15744.57,374.53,-22949,625,5356,374.47,2914.64,374.8,11572,548,25254.24,374.51,12517.05,379.63,10299.14,374.48,665,548}
,{142,54,-65229.639,2.701,8233.169,0.019,5284.911,7.565,141.929973098,2.9,0,1.23,"",0.02,"",0,1,"","",{"B-","B-n"},{0,0.21,0},{"=","="},{0,0.21,0},8385.82,3.57,23231.35,62.47,-1958.57,4.65,12612.62,6.51,-22032,401,1176.57,9.58,5103.66,3.95,12591.95,16.06,19303.55,3.69,9087.38,12.41,8105.37,4.83,621.83,4.45}
,{142,55,-70514.55,7.067,8264.877,0.05,7327.714,8.363,141.924299512,7.586,0,1.684,"",0.014,"",0,-1,"","",{"B-","B-n"},{0,0.09,0},{"=","="},{0,0.09,0},9607.08,10.83,21486.28,14.02,-959.57,9.25,9509.68,9.42,-17876.86,17.34,1146.76,8.84,4108.34,11.6,9606.22,7.63,13272.93,7.26,13182.71,7.44,9994.08,7.38,3602.81,8.12}
,{142,56,-77842.264,5.92,8310.971,0.042,2181.963,8.391,141.916432888,6.355,0,636,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},10715.54,9.9,19433.75,6.36,-294.95,6.55,6690.92,6.38,-16933.94,6.59,-2981.95,7.26,6180.95,7.96,10653.71,10.94,8107.72,6.06,9918.65,10.11,7722.71,6.7,3448.71,6.3}
,{142,57,-80024.227,6.309,8320.828,0.044,4508.961,5.845,141.914090454,6.773,0,5466,"",30,"",2,-1,"","",{"B-"},{0},{"="},{0},11850.99,6.49,17552.06,10.34,437.79,11.12,3763.25,6.32,-12835.67,11.15,-2662.63,6.32,5163.91,7.44,7580.57,8.24,1117.82,24.42,13955.93,10.1,9753.58,6.32,6323.1,7.05}
,{142,58,-84533.188,2.509,8347.071,0.018,-745.712,2.5,141.909249884,2.693,1,"s","","s","",0,1,"","",{},{},{},{},12599.73,2.52,15841.78,8.28,1303.53,2.53,1416.79,2.2,-12089.53,5.87,-6588.86,2.5,7171.59,2.52,8890.52,4.66,-5546.72,3.57,10493.49,2.93,7557.08,2.93,6026.96,2.53}
,{142,59,-83787.476,1.665,8336.31,0.012,2162.505,1.416,141.91005044,1.786,0,68832,"",144,"",2,-1,"","",{"B-","EC"},{0,0.0164,0},{"~","="},{0,0.0164,0},15242.02,6.12,14049.55,2.02,306.79,3.19,-2645.43,23.65,-8144.81,4.1,-7666.16,2.81,5843.15,0.08,5643.53,1.2,-12474.01,30.16,14999.42,1.21,8024.44,7.24,9085.14,2.02}
,{142,60,-85949.98,1.368,8346.03,0.01,-4807.936,23.629,141.907728895,1.468,1,"s","","s","",0,1,"","",{},{},{},{},17833.7,3.71,12451.83,1.58,-803.97,4.98,-6963.51,2.81,-7806.03,1.58,-13498.38,14.04,9828.67,3.15,7223.31,1.42,-18990.47,27.98,9448.91,6.2,3732.87,7.84,6644.28,7.27}
,{142,61,-81142.044,23.597,8306.662,0.166,-2155.574,23.752,141.912890428,25.332,0,40.5,"",0.5,"",1,1,"","",{"e+","EC"},{0,22.9,0},{"=","="},{0,22.9,0},19070.97,33.83,11031.9,24.4,-433.04,26.1,-9828.57,38.26,-2415.37,23.65,-13279.45,25.09,8690.44,27.42,4238.38,23.82,-24582.53,700.95,13827.67,23.85,5735.95,36.31,9323.16,24.85}
,{142,62,-78986.47,3.079,8285.972,0.022,-7673,30,141.915204532,3.305,0,4349.4,"",3,"",0,1,"","",{"B+"},{0},{"="},{0},19673.17,12.87,9305.5,4.62,606.92,12,-12026.95,28.11,-2082.81,4.21,-17132.16,12.99,11123.88,8.95,5752.52,14.31,-28867,729,9938.05,24.44,3378.07,13.94,8673.87,27.76}
,{142,63,-71313.47,30.158,8226.427,0.212,-4353.955,41.114,141.923441836,32.375,0,2.36,"",0.1,"",1,1,"","",{"B+"},{0},{"="},{0},20470.17,59.71,7677.7,38.7,1202.1,40.97,-14753.95,701.21,1920.48,33.24,-16160.56,36.05,9459.16,32.69,2668.53,31.31,-34063,402,14853.27,32.64,5930.8,32.06,11833.41,33.08}
,{142,64,-66959.515,27.945,8190.256,0.197,-10400,700,141.928116,30,0,70.2,"",0.6,"",0,1,"","",{"EC"},{0},{"="},{0},21319.88,39.52,6081.52,30.61,2113.33,30.34,-16840,728,1685.42,29.22,-20490,108.91,11806.61,34.23,4322.86,30.67,-38930,501,10737.23,58.63,3302.58,30.88,11067.11,29.99}
,{142,65,-56559.515,700.558,8111.507,4.934,-6440,200,141.939280859,752.079,0,0.597,"",0.017,"",1,1,"","",{"B+","B+p"},{0,0.0022,0},{"=","="},{0,0.0022,0},22219.88,1063.75,4151.52,702.45,2765.24,701.11,-19309,807,6077.14,700.67,-19248,761,10090,708.42,624.26,700.84,"","",15933.56,701.11,5936,727,14484.93,700.68}
,{142,66,-50120,729,8061,5,-12869,831,141.946194,782,0,2.3,"",0.3,"",0,1,"","",{"B+","B+p"},{0,0.06,0},{"=","="},{0,0.06,0},23432,831,2915,729,3256,754,-22090,884,5816,729,-23826,831,12808,787,2868,736,"","",11074,1082,2875,787,13158,754}
,{142,67,-37250,401,7965,3,-9221,641,141.96001,430,0,0.4,"",0.1,"",7,-1,"","",{"B+","B+p","p"},{0,"","",0,0},{"~","","~"},{0,"","",0,0},24134,643,1346,895,3993,499,"","",10001,414,"","",10957,567,-843,499,"","",16290,566,5255,643,16526,499}
,{142,68,-28030,500,7894,4,"","",141.969909,537,0,1e-05,"","s","",0,1,"","",{},{},{},{},"","",-223,641,4477,709,"","",10064,582,"","","","",954,641,"","",11940,709,"","",15258,709}
,{143,52,-40278,503,8068,4,10353,541,142.95676,540,0,0.1,"",4e-07,">",3.5,1,"","",{"B-n","B-2n"},{0,2,0},{"=","="},{0,2,0},5933,643,"","",-4263,709,19925,503,"","",6421,627,1979,711,"","",33659,503,9543,709,8525,780,"",""}
,{143,53,-50630,200,8135,1,9572,200,142.945646,215,0,0.13,"",0.045,"",3.5,1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},6846,201,26099,539,-3267,448,17045,200,"","",6528,200,3932,425,11550,541,27541,200,10567,448,10810,210,-1045,629}
,{143,54,-60202.873,4.657,8196.885,0.033,7472.636,8.891,142.935369553,5,0,0.511,"",0.006,"",2.5,-1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},8148.21,5.48,24294,401,-2422.72,5.85,13734.32,8.21,-21122,503,2240.36,8.46,3044.55,5.38,12721.86,374.49,21403.8,5.29,10434.59,16.51,8267.4,12.97,2019.76,62.58}
,{143,55,-67675.509,7.573,8243.67,0.053,6261.688,9.73,142.927347348,8.13,0,1.791,"",0.007,"",1.5,1,"","",{"B-","B-n"},{0,1.64,0},{"=","="},{0,1.64,0},9340.62,11.91,22326.79,17.55,-1629.47,8.57,10496.01,10.54,-20194.5,374.54,2095.44,9.61,5232.28,10.36,9734.84,8.04,15392.74,7.81,11232.6,8.11,10175,7.92,1577.11,14.28}
,{143,56,-73937.197,6.756,8281.987,0.047,4234.318,9.969,142.92062515,7.253,0,14.5,"",0.3,"",2.5,-1,"","",{"B-"},{0},{"="},{0},10347.2,8.6,20317.84,7.35,-717.54,7.09,7669.47,7.21,-15996.53,7.28,-1984.29,9.24,4166.25,8.98,10711.62,9.78,10065.04,6.89,11251.13,11.41,7976.96,10.63,4695.66,7.15}
,{143,57,-78171.515,7.33,8306.127,0.051,3435.156,7.595,142.916079422,7.869,0,852,"",6,"",0,0,"","",{"B-"},{0},{"="},{0},11382.51,8.43,18271.93,11.76,104.49,7.97,4896.73,7.49,-14945.94,10.18,-1709.64,7.6,6218.61,9.56,7618.22,9.42,4789.14,7.88,12271.92,9.05,9961.89,10.8,4524.99,11}
,{143,58,-81606.671,2.508,8324.678,0.018,1461.575,1.866,142.91239163,2.692,0,118940.4,"",21.6,"",1.5,-1,"","",{"B-"},{0},{"="},{0},12316.39,2.52,16451.99,5.87,882.16,2.52,2395.56,2.2,-11053.38,6.38,-5890.51,2.5,5144.8,0.09,8871.41,5.85,-2089.52,3.3,12035.77,4.66,7573.26,2.93,7309.08,8.28}
,{143,59,-83068.246,1.897,8329.428,0.013,933.988,1.368,142.910822564,2.037,0,1172448,"",1728,"",3.5,1,"","",{"B-"},{0},{"="},{0},13195.24,1.92,14714.55,4.4,1733.05,2.48,-107.6,3.01,-10332.99,6.11,-5189.58,1.37,7352.09,1.92,5824.03,1.87,-8826.95,11.15,13075.48,2.01,9871.9,2.01,6894.03,2.48}
,{143,60,-84002.234,1.367,8330.488,0.01,-1041.583,2.682,142.909819887,1.467,1,"s","","s","",3.5,-1,"","",{},{},{},{},15952.24,3.15,13147.26,1.58,520.71,7.27,-4485.08,2.47,-6758.02,2.2,-10931.51,23.63,6123.57,0.07,7503.73,1.42,-15770.93,200.31,12724.22,1.42,5549.91,6.2,9720.26,1.58}
,{143,61,-82960.651,2.996,8317.733,0.021,-3443.499,3.56,142.910938073,3.216,0,22896000,"",604800,"",2.5,1,"","",{"EC","e+"},{0,5.7,0},{"=","<"},{0,5.7,0},18580.36,14.29,11522.95,3.03,-566.77,8.29,-8719.35,11.39,-6462.15,3.03,-12045.5,3.82,9889.92,23.78,4299.64,2.68,-22541.47,51.32,11942.79,4.13,6162.32,4.57,7373.84,6.76}
,{143,62,-79517.152,2.804,8288.182,0.02,-5275.851,11.338,142.914634821,3.01,0,525,"",3.6,"",1.5,1,"","",{"B+"},{0},{"="},{0},19725.88,8.85,9902.46,3.99,71.87,27.74,-11285.85,200.32,-856.14,2.47,-16275,30.21,8602,3.58,5664.08,23.75,-27348.21,13.34,11716.58,14.25,3560.62,24.41,10388.16,4.44}
,{143,63,-74241.3,10.986,8245.817,0.077,-6010,200,142.920298681,11.793,0,155.4,"",1.2,"",2.5,1,"","",{"B+"},{0},{"="},{0},20458.31,16.75,8296.32,17.77,834.27,17.48,-13822.12,52.4,-388.23,26.03,-15353.1,30.03,10999.15,32.1,2543.8,11.41,-32194,298,12403.41,13.91,6078.69,16.64,9618.81,26.62}
,{143,64,-68231.3,200.301,8198.318,1.401,-7812.117,206.75,142.926750682,215.032,0,39,"",2,"",0,0,"","",{"B+","B+p","B+A"},{0,"","","",""},{"=","",""},{0,"","","",""},21149.71,201.27,6875.33,200.48,1724,200.6,-16062.36,200.73,3466.2,200.33,-19743.1,728.63,9343.1,202.24,4206.8,202.56,-36971,447,12405.13,200.7,3618.69,206.83,12871.04,200.69}
,{143,65,-60419.183,51.232,8138.217,0.358,-8250.242,52.866,142.935137335,55,0,12,"",1,"",5.5,-1,"","",{"B+"},{0},{"="},{0},22020.98,117.06,5071.5,52.77,2553.94,52.89,-18372,302,3605.32,59.45,-18371,730,11930.99,702.43,748.64,58.36,"","",13515.85,54.91,6227.14,58.36,12213.15,72.67}
,{143,66,-52168.941,13.041,8075.052,0.091,-10121,298,142.943994335,14,0,5.6,"",1,"",0.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22929,298,3522.66,23.68,3038,196,-20909,400,7501.6,30.84,-22990,401,10121,729,2898.4,700.68,"","",13082.7,106.06,3177.39,800.59,15259.73,30.84}
,{143,67,-42048,298,7999,2,-10788,499,142.95486,320,0,0.3,"",2e-07,">",5.5,-1,"","",{},{},{},{},23826,499,2085,316,3658,422,"","",7223,761,-22089,582,12869,499,-783,787,"","",14046,422,5647,499,14081,854}
,{143,68,-31260,400,7918,3,"","",142.966441,429,0,0.2,"","s","",4.5,-1,"","",{},{},{},{},"","",456,499,3957,642,"","",11571,831,"","",11302,640,1299,566,"","",13815,566,2863,642,17216,566}
,{144,53,-45280,401,8098,3,11592,401,143.95139,430,0,0.1,"",1.5e-07,">",1,-1,"","",{"B-n","B-2n"},{0,1,0},{"=","="},{0,1,0},6653,548,"","",-3766,718,17991,401,"","",6852,401,2721,448,12291,643,29570,401,11801,643,10071,566,-524,641}
,{144,54,-56872.293,5.31,8172.884,0.037,6399.06,20.82,143.938945079,5.7,0,0.388,"",0.007,"",0,1,"","",{"B-","B-n"},{0,3,0},{"=","="},{0,3,0},7785.29,5.96,25080,503,-2720.98,62.64,14894.83,8.89,-23883,503,2731.9,9.25,4740.74,7.06,13531,200,23559.58,6.04,8608.5,374.5,7918.42,16.7,-739,401}
,{144,55,-63271.353,20.132,8211.889,0.14,8495.768,20.416,143.932075404,21.612,0,0.994,"",0.006,"",0,0,"","",{"B-","B-n"},{0,3.03,0},{"=","="},{0,3.03,0},8899.44,21.18,23079.31,375,-2090.06,23.49,11578.3,23.93,-19930,201,2594.53,21.24,3667.16,21.51,10357.45,20.66,17479.16,20.32,12669.09,20.31,9790,20.34,2301.71,25.61}
,{144,56,-71767.121,7.136,8265.454,0.05,3082.53,14.774,143.922954821,7.661,0,11.5,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},10067.49,9.27,21115.42,7.63,-1205.59,7.51,8664.75,7.7,-18853.22,8.52,-1666.92,10.23,5901.24,9.83,11380.58,10.41,11980.84,7.27,9458.23,10.03,7574.46,11.64,2076.58,7.7}
,{144,57,-74849.652,12.937,8281.428,0.09,5582.219,13.254,143.919645589,13.888,0,40.8,"",0.4,"",3,-1,"","",{"B-"},{0},{"="},{0},10968.06,14.39,18913.04,14.74,-224.46,15.32,5900.86,13.23,-14463.11,14.99,-1314.3,13.18,4749.45,14.87,8201.43,14.59,6566.44,13.27,13703.42,14.23,9747.03,13.99,5274.27,15.87}
,{144,58,-80431.87,2.885,8314.76,0.02,318.646,0.832,143.91365283,3.096,0,24616224,"",4320,"",0,1,"","",{"B-"},{0},{"="},{0},12041.32,3.36,17167.55,6.57,412.57,8.41,3316.09,2.54,-13783.64,7.35,-5434.94,2.89,6896.52,3.36,9549.33,7.84,1533.66,2.66,10303.16,6.71,7363.82,4.93,4947.16,6.04}
,{144,59,-80750.517,2.762,8311.54,0.019,2997.44,2.4,143.91331075,2.965,0,1036.8,"",3,"",0,-1,"","",{"B-"},{0},{"="},{0},13105.68,2.79,15304.23,6.65,1140.44,3.21,665.58,3.57,-9867.97,7.79,-4819.6,2.4,5753.59,2.76,6432.82,3.26,-5131.38,11.07,14493.48,3.26,9546.45,2.87,7827.52,4.85}
,{144,60,-83747.957,1.367,8326.922,0.009,-2331.863,2.646,143.910092865,1.467,0,7.226536054e+22,"",5.04910816e+21,"",0,1,"","",{"A"},{0},{"="},{0},13940.61,0.09,13792.71,2.2,1903.22,1.58,-1782.42,0.79,-9430.26,2.2,-8858.62,2.68,7817.04,0.05,7968.68,1.37,-11988.45,27.98,10750.33,1.42,7131.74,1.42,7331.36,1.58}
,{144,61,-81416.093,2.964,8305.296,0.021,549.442,2.668,143.912596224,3.181,0,31363200,"",1209600,"",5,-1,"","",{"EC","e+"},{0,8,0},{"=","<"},{0,8,0},16416.68,23.77,12206.56,3,847.08,6.74,-5796.96,11.12,-5636.82,2.98,-9970.26,3.53,6526.76,1.53,4702.83,2.65,-19047.91,28.1,15244.69,2.65,7640.59,4.11,10245.95,3}
,{144,62,-81965.535,1.554,8303.679,0.011,-6346.402,10.814,143.912006373,1.668,1,"s","","s","",0,1,"","",{},{},{},{},19121.7,2.71,10593.5,0.8,-131.54,3.78,-10206.03,27.99,-5252.27,0.79,-15795.55,11.09,10519.7,2.35,6293.86,2.71,-25395.45,7.34,9887.31,23.64,3421.44,14.06,7873.5,3.24}
,{144,63,-75619.133,10.789,8254.173,0.075,-3859.63,29.955,143.918819517,11.582,0,10.2,"",0.1,"",1,1,"","",{"B+"},{0},{"="},{0},20448.3,32,9055.03,25.94,169.66,26.54,-13250.95,29.96,52.55,11.13,-15459.15,200.59,9449.15,15.4,3390.95,11.06,-31009.62,13.72,14078.14,11.14,5178.83,13.73,10550.19,17.65}
,{144,64,-71759.504,27.945,8221.937,0.194,-9391.323,39.52,143.922963,30,0,268.2,"",3.6,"",0,1,"","",{"B+"},{0},{"="},{0},20942.62,39.52,7350.98,28.11,1271.52,30.61,-15189.42,28.85,468.68,28.09,-19411.64,58.36,11599.52,202.24,4807.17,30.03,-35152,198,10264.77,41.11,3030.18,30.67,9820.81,29.22}
,{144,65,-62368.181,27.945,8151.287,0.194,-5798.098,28.851,143.933045,30,0,1,"","s","",1,1,"","",{"B+"},{0},{"="},{0},21951.3,701.11,5632.65,41.11,2192.84,58.63,-17758.67,29.2,4584.15,30.03,-18270.56,30.84,10020.31,58.36,1425.85,202.24,-40109,401,15302.14,39.52,5720.1,34.23,13203.85,30.67}
,{144,66,-56570.083,7.173,8105.589,0.05,-11960.569,11.104,143.939269514,7.7,0,9.1,"",0.4,"",0,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22593,729,4188.51,28.85,2787.27,28.85,-19962,196,4372.25,200.43,-22594,298,12472.46,14.88,3439.87,51.73,"","",10700.24,700.59,2834.81,105.5,12300.54,21.02}
,{144,67,-44609.513,8.477,8017.097,0.059,-8002,196,143.952109714,9.1,0,0.7,"",0.1,"",5,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23502,401,2627.94,700.61,3447.84,800.53,-22350,400,8520.7,51.93,-21421,400,10633,298,-270.46,15.55,"","",16221,729,5637,298,15577.73,105.6}
,{144,68,-36608,196,7956,1,-14349,445,143.9607,210,0,0.4,"",2e-07,">",0,1,"","",{},{},{},{},24721,537,1066,754,3797,446,"","",8272,196,"","",13419,445,1849,357,"","",11354,446,2621,446,14421,357}
,{144,69,-22259,400,7851,3,"","",143.976104,429,0,2.3e-06,"",9e-07,"",10,1,"","",{"p","B+"},{"",0,0},{"","="},{"",0,0},"","",-413,566,4575,643,"","",12500,499,"","","","",-1712,16,"","",16481,640,"","",17752,566}
,{145,53,-40939,503,8068,3,10554,503,144.95605,540,0,0.1,"",4e-07,">",3.5,1,"","",{"B-n","B-2n"},{0,"",""},{"=",""},{0,"",""},6451,541,"","",-4254,709,19115,503,"","",7862,503,3731,643,"","",31896,503,10049,711,10295,711,"",""}
,{145,54,-51493.329,11.178,8135.087,0.077,8561.086,14.393,144.944719634,12,0,0.188,"",0.004,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,5,0,0,0},{"=","=","="},{0,5,0,0,0},7433.09,12.11,25793,503,-3431,401,16022.85,14.03,"","",3706.71,23.03,2692.35,12.37,13502,401,25573.69,35.7,9848,201,8140.71,374.63,523,503}
,{145,55,-60054.415,9.067,8188.733,0.063,7461.761,12.412,144.93552893,9.733,0,0.582,"",0.006,"",1.5,1,"","",{"B-","B-n"},{0,14.7,0},{"=","="},{0,14.7,0},8521.54,11.81,24002,200,-2552.67,18.25,12780.9,15.26,-22063,401,3641.39,11.49,4854.38,21.58,10471.09,10.51,19571.52,11.56,10859.26,10.19,10039.28,9.46,361.97,374.57}
,{145,56,-67516.176,8.477,8234.798,0.058,5319.141,14.912,144.9275184,9.1,0,4.31,"",0.16,"",2.5,-1,"","",{"B-"},{0},{"="},{0},9721.61,10.84,21891.24,9.67,-1743.79,8.95,9550.85,34.95,-17932.85,10,-737.84,15.47,3820.37,11.08,11533.79,21.84,13915.78,8.59,10870.14,11.37,7862.43,11.04,3359.86,8.9}
,{145,57,-72835.317,12.269,8266.087,0.085,4231.705,35.3,144.921808066,13.17,0,24.8,"",2,"",2.5,1,"","",{"B-"},{0},{"="},{0},10806.44,14.29,19737.75,14.42,-782.71,15.33,6790.62,14.15,-16852.93,23.58,-474.76,12.6,6056.98,17.83,8357.17,14.19,8432.16,12.59,11812.69,14.01,9871,13.62,3325.63,14.16}
,{145,58,-77067.022,33.902,8289.875,0.234,2558.918,33.635,144.917265144,36.395,0,180.6,"",3.6,"",2.5,-1,"","",{"B-"},{0},{"="},{0},11602.98,33.96,17707.77,34.57,240.69,34.32,4364.93,33.89,-12588.87,34.65,-4387.82,33.98,4706.47,33.99,9506.34,36.29,3584.3,33.9,11815.3,34.68,7821.26,34.45,6421.64,34.41}
,{145,59,-79625.94,7.169,8302.127,0.049,1806.012,7.037,144.914518033,7.696,0,21542.4,"",36,"",3.5,1,"","",{"B-"},{0},{"="},{0},12700.33,7.17,16032.37,10.22,880.78,8.21,1641.53,7.48,-12065.26,14.79,-3949.3,7.04,6946.74,7.44,6483.04,7.48,-1634.43,7.58,12691.54,7.38,9771.3,7.38,6044.69,9.39}
,{145,60,-81431.951,1.384,8309.187,0.01,-164.478,2.536,144.912579199,1.485,1,"s","","s","",3.5,-1,"","",{},{},{},{},13572.35,0.24,14403.22,2.21,1576.05,1.59,-780.63,0.87,-8289.05,2.55,-8087.18,2.66,5755.31,0.23,7970.41,2.41,-8505.63,19.76,12347.1,1.39,7219.58,1.44,8747.64,2.21}
,{145,61,-81267.474,2.859,8302.657,0.02,-616.156,2.539,144.912755773,3.068,0,558557590.2,"",12622770.4,"",2.5,1,"","",{"EC","A"},{0,2.8,0},{"=","="},{0,2.8,0},14449.46,2.05,12777.17,2.87,2323.25,2.89,-3275.97,3.71,-7805.93,3.48,-7373.26,2.54,7922.7,1.53,4808.49,2.53,-14879.06,109.21,13445.57,2.53,9546.56,2.53,8166.4,2.89}
,{145,62,-80651.318,1.578,8293.013,0.011,-2659.81,2.723,144.913417244,1.694,0,29376000,"",259200,"",3.5,-1,"","",{"EC"},{0},{"="},{0},17276.8,2.37,11227.02,0.84,1116.4,3.25,-7725,19.77,-4192.33,0.84,-13103.5,10.82,6757.1,0.3,6524.2,2.67,-22408.72,6.71,13020.14,2.72,5354.78,23.64,10945.06,0.85}
,{145,63,-77991.507,3.106,8269.274,0.021,-5065.187,19.953,144.916272668,3.334,0,512352,"",3456,"",2.5,1,"","",{"B+"},{0},{"="},{0},19892.84,11.42,9608.8,3.83,106.5,14.31,-11603.1,109.22,-3864.38,3.8,-14303.32,28.12,10443.69,11.15,3314.94,2.71,-28871.4,8.07,12236.45,3.58,5859.02,3.8,8796.94,23.79}
,{145,64,-72926.32,19.709,8228.946,0.136,-6537.909,108.066,144.92171037,21.158,0,1380,"",24,"",0.5,1,"","",{"B+"},{0},{"="},{0},20837.65,201.27,7987.11,19.91,582.67,21.48,-14683.72,20.76,1750.24,19.77,-18629.46,34.2,9238.13,34.2,4596.16,22.47,-33686,201,12025.79,22.56,3251.2,36.03,11706.55,19.95}
,{145,65,-66388.411,109.174,8178.461,0.753,-8145.812,109.369,144.928729105,117.203,0,30.9,"",0.6,"",5.5,-1,"","",{"B+"},{0},{"="},{0},22111.86,120.6,6725.05,109.73,1112.3,109.9,-17268.31,109.43,1941.75,109.71,-17889.65,109.41,12091.55,112.69,1917.88,112.69,-38806,224,12553.7,228.12,5435.16,112.69,10571.46,113.26}
,{145,66,-58242.599,6.52,8116.888,0.045,-9122.493,9.902,144.937473994,7,0,9.5,"",1,"",0.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22216.29,14.58,4589.24,200.41,2556.71,20.81,-19002,200,6227.93,28.7,-21704.4,10.69,9743.83,9.69,3163.39,28.7,"","",12887.39,51.65,3180.97,700.59,14363.32,28.7}
,{145,67,-49120.105,7.452,8048.578,0.051,-9880,200,144.947267394,8,0,2.4,"",0.1,"",5.5,-1,"","",{"B+"},{0},{"="},{0},23215,298,3278.86,51.77,2995.82,105.52,-21537,196,5959.11,28.92,-20584,196,12581.91,11.29,-161.01,10.34,"","",13759.64,15.02,5863,729,13085.81,700.6}
,{145,68,-39240,200,7975,1,-11657,280,144.957874,215,0,0.9,"",0.3,"",0.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},24123,447,1649,201,3717,359,"","",10041,200,-25052,447,10704,280,1920,200,"","",13518,359,2874,448,16526,756}
,{145,69,-27583,196,7889,1,"","",144.970389,210,0,3.17e-06,"",2e-07,"",5.5,-1,"","",{"p"},{0},{"="},{0},"","",113,357,4357,446,"","",9738,196,"","",13395,445,-1736.1,7.07,"","",14388,445,5311,537,15314,446}
,{146,54,-47954.943,24.219,8110.415,0.166,7355.429,24.391,145.948518248,26,0,0.146,"",0.006,"",0,1,"","",{"B-","B-n"},{0,6.9,0},{"=","="},{0,6.9,0},7225.28,24.79,"","",-4010,504,16992.14,31.97,"","",4028.15,25.86,4532.93,26.67,14305,504,27680.45,29.2,8036,401,7540,202,-2031,504}
,{146,55,-55310.372,2.893,8155.436,0.02,9636.714,21.063,145.94062187,3.106,0,0.323,"",0.006,"",1,-1,"","",{"B-","B-n","B-2n"},{0,14.2,0,0,0},{"=","=","="},{0,14.2,0,0,0},8181.65,20.34,24608,401,-2965.3,374.47,13739.91,33.74,-21660,503,4134.49,8.96,3327.27,9.52,11106.01,11.55,21370.63,34.94,12272.73,6.05,9756.56,5.48,966,200}
,{146,56,-64947.086,20.863,8216.082,0.143,4103.197,33.503,145.930276431,22.397,0,2.22,"",0.07,"",0,1,"","",{"B-"},{0},{"="},{0},9322.6,22.05,22652.73,21.53,-2142.36,21.04,10688.3,25.7,-20742.73,23.67,-183.09,24.2,5502.23,22.52,12181.64,22.75,15978.78,20.91,9035.07,28.99,7592.48,22.19,902.19,21.38}
,{146,57,-69050.283,33.616,8238.828,0.23,6585.107,34.456,145.925871468,36.088,0,6.27,"",0.1,"",2,-1,"","",{"B-"},{0},{"="},{0},10343.27,36.02,20356.87,39.18,-960.65,34.35,7630.72,46.66,-16284.84,34.82,-54.58,47.74,4286.28,35.78,8823.08,34.67,10404.03,33.89,13427.64,34.37,9750.97,34.29,4271.63,34.46}
,{146,58,-75635.389,16.306,8278.573,0.112,1045.616,32.519,145.918802065,17.504,0,811.2,"",7.8,"",0,1,"","",{"B-"},{0},{"="},{0},11346.15,16.55,18446.21,17.8,-218.04,17.35,5290.48,16.36,-15408.18,18.38,-4080.77,17.81,6639.68,37.62,10089.04,20.41,5360.92,16.59,9925.07,20.81,7400.18,17.88,3948.21,17.65}
,{146,59,-76681.006,34.816,8280.376,0.238,4244.861,34.83,145.917679549,37.376,0,1449,"",10.8,"",0,0,"","",{"B-"},{0},{"="},{0},12073.12,34.91,16409.3,37.14,918.31,35.37,2773.3,35.07,-11134.66,36.91,-3320.37,34.83,5126.38,35.53,6902.95,48.59,436.54,35.32,14461.67,34.92,9789.72,34.89,7136.91,35.58}
,{146,60,-80925.867,1.386,8304.092,0.009,-1471.558,4.119,145.913122503,1.488,1,"s","","s","",0,1,"","",{},{},{},{},13320.54,0.24,15071.94,2.55,1182.41,2.21,70.44,2.82,-11147.82,33.89,-7729.71,2.54,7565.23,0.09,8588.9,7.04,-4840.08,3.92,10535.46,2.41,7006.43,1.39,6327.21,2.21}
,{146,61,-79454.309,4.308,8288.654,0.03,1542,3,145.914702286,4.624,0,174509800.78,"",1577846.3,"",3,-1,"","",{"EC","B-"},{0,34,0},{"=","="},{0,34,0},14180.85,4.87,13281.73,4.76,1908.25,4.34,-2336.77,6.59,-7117.34,8.15,-6874.31,4.14,6258.15,4.8,5311.33,4.12,-11690.7,45.04,15004.45,4.11,9411.98,4.11,9260.34,4.33}
,{146,62,-80996.309,3.092,8293.857,0.021,-3878.768,5.869,145.913046881,3.319,0,2.145870968e+15,"",2.20898482e+14,"",0,1,"","",{"A"},{0},{"="},{0},15173.41,2.85,11826.29,2.81,2528.76,2.81,-4910.53,4.78,-6853.33,2.82,-11076.12,3.92,8416.31,2.85,7017.81,3.75,-18441.39,7.37,11130.59,3.83,6828.4,3.86,8652.33,2.81}
,{146,63,-77117.541,6.026,8261.932,0.041,-1031.758,7.076,145.917210909,6.468,0,398304,"",2592,"",4,-1,"","",{"B+"},{0},{"="},{0},17641.04,12.31,10279.39,6.49,1599.59,24.35,-9353.93,45.24,-3139.04,6.44,-12262.54,20.61,7197.35,6.53,3755.19,5.95,-25879.32,8.93,15558.8,5.95,7263.67,6.39,11489.51,6.5}
,{146,64,-76085.783,4.108,8249.506,0.028,-8322.173,44.749,145.918318548,4.409,0,4170528,"",8640,"",0,1,"","",{"EC"},{0},{"="},{0},20468.91,28.25,8698.19,3.84,475.77,4.65,-13530.86,7.85,-2723.44,3.85,-17768.69,109.25,11230.78,20.13,5383.25,4.7,-31763.77,7.86,10244.16,11.47,3019.57,11.73,9077.77,4.5}
,{146,65,-67763.61,44.862,8187.146,0.307,-5208.691,45.16,145.927252768,48.161,0,8,"",4,"",1,1,"","",{"B+"},{0},{"="},{0},21538.06,52.85,6722.42,46.13,1124.94,54.02,-16525.39,45.34,2938.93,44.93,-17592.33,45.33,9446.52,118.03,2126.26,49,-36708,205,14706.7,52.85,5331.75,205.26,12124.09,46.19}
,{146,66,-62554.918,6.695,8146.112,0.046,-11316.699,9.392,145.932844529,7.187,0,33.2,"",0.7,"",0,1,"","",{"B+"},{0},{"="},{0},22127.47,9.81,5373.36,28.74,1979.68,28.74,-18232.91,9.47,3082.43,20.82,-21506.13,10.02,12383.64,9.35,3455.48,109.38,"","",10524.07,28.74,2728.32,51.67,11322.78,200.41}
,{146,67,-51238.219,6.587,8063.242,0.045,-6916.206,9.399,145.944993506,7.071,0,2.8,"",0.5,"",6,-1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},22771.34,10.73,3447.98,28.71,2896.38,700.59,-20183,200,7861.22,109.37,-20069,200,10189.43,9.95,284.59,9.27,"","",16042.67,9.74,5794.78,14.61,14827.37,51.65}
,{146,68,-44322.012,6.705,8010.512,0.046,-13267,200,145.952418359,7.197,0,1.7,"",0.6,"",0,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23857,196,2329.87,9.82,3373,729,"","",6631.62,9.35,-24811,196,13153,200,2490.88,10.02,"","",10998.31,10.81,2590,298,13493.33,14.66}
,{146,69,-31055,200,7914,1,"","",145.966661,215,0,0.155,"",0.02,"",1,1,"","",{"p"},{0},{"~"},{0},24939,447,1024,201,3770,448,"","",10776,200,"","",11544,280,-895.7,5.66,"","",16263,280,5069,447,16639,359}
,{147,54,-42360,200,8072,1,9560,200,146.954525,215,0,0.13,"",0.08,"",1.5,-1,"","",{"B-","B-n","B-2n"},{0,4,0,"",""},{"=","=",""},{0,4,0,"",""},7009,201,"","",-4507,541,17904,201,"","",4879,200,2476,202,"","",29654,200,9290,541,7784,448,"",""}
,{147,55,-51920.064,8.383,8131.8,0.057,8343.965,21.454,146.944261515,9,0,0.23,"",0.001,"",1.5,1,"","",{"B-","B-n"},{0,28.5,0},{"=","="},{0,28.5,0},8008.28,12.35,25559,503,-3715,200,14758.33,13.6,"","",4955.7,22.48,4681.01,8.87,11254.09,25.63,23524,17.94,10284.07,13.97,9816.28,9.92,-994,401}
,{147,56,-60264.029,19.748,8183.24,0.134,6414.361,22.466,146.9353039,21.2,0,0.894,"",0.01,"",2.5,-1,"","",{"B-","B-n"},{0,0.06,0},{"=","="},{0,0.06,0},8890.49,21.49,23348.64,22.69,-2486.07,20.29,11749.86,21.53,-19598.06,31.25,714.94,38.99,3388.26,28.73,12242.63,19.96,17882.72,19.8,10501.19,21.73,7871.38,28.2,2254.67,20.45}
,{147,57,-66678.39,10.712,8221.553,0.073,5335.501,13.725,146.9284178,11.5,0,4.06,"",0.04,"",2.5,1,"","",{"B-","B-n"},{0,0.041,0},{"=","="},{0,0.041,0},9985.71,16.29,21201.92,14.03,-1427.8,13.12,8765.68,19.14,-18656.99,11.1,885.68,19.51,5699.42,35.28,9020.27,23.45,12363.87,10.8,11548.59,13.66,9952.79,12.87,2239.36,22.8}
,{147,58,-72013.891,8.58,8252.527,0.058,3430.176,15.533,146.922689903,9.211,0,56.4,"",1,"",2.5,-1,"","",{"B-"},{0},{"="},{0},11089.5,34.97,19075.66,12.06,-501.61,10.92,6132.86,8.67,-14355.78,22.56,-3404.2,35.86,4449.82,18.42,10252.58,34.69,7252.46,8.67,11532.23,14.97,7699.82,15.52,5399.63,11.16}
,{147,59,-75444.067,15.857,8270.539,0.108,2702.681,15.86,146.919007458,17.023,0,804,"",18,"",1.5,1,"","",{"B-"},{0},{"="},{0},11960.76,17.35,17186.69,20.05,302.53,17.46,3598.19,15.86,-13682.75,37.17,-2589.52,15.86,6834.38,38.25,7097.65,22.74,2100.69,16.02,12333.76,37.41,9851.86,16.06,5051.99,20.46}
,{147,60,-78146.748,1.388,8283.603,0.009,895.512,0.482,146.91610601,1.49,0,948672,"",864,"",2.5,-1,"","",{"B-"},{0},{"="},{0},12857.43,0.12,15657.67,33.89,1035.01,2.22,1119.61,0.42,-9800.33,16.36,-6763.76,4.12,5292.2,0.09,8754.71,34.83,-2789.8,1.46,12190,7.04,7467.82,2.41,7931.52,2.55}
,{147,61,-79042.26,1.399,8284.372,0.01,224.094,0.293,146.915144638,1.501,0,82786439.6684,"",6311.3852,"",3.5,1,"","",{"B-"},{0},{"="},{0},13917.42,2.56,13994.26,7.05,1601.07,1.43,-1497.5,2.3,-9650.23,34.83,-6117.27,2.84,7659.27,4.13,5405.36,0.48,-8299.59,8.12,13100.5,0.47,9569.75,0.44,7354.66,2.44}
,{147,62,-79266.354,1.372,8280.575,0.009,-1721.598,2.281,146.914904064,1.473,0,3.3639683116e+18,"",2.20898482e+16,"",3.5,-1,"","",{"A"},{0},{"="},{0},14757.67,0.91,12412.34,0.41,2310.96,0.35,-3909.41,1.46,-5629.46,0.41,-10220.13,5.95,6341.36,2.83,7101.02,4.12,-15070.32,8.95,12711.93,2.54,7013.79,2.66,10128,0.35}
,{147,63,-77544.756,2.63,8263.541,0.018,-2187.811,2.524,146.916752276,2.823,0,2082240,"",51840,"",2.5,1,"","",{"B+","A"},{0,0.0022,0},{"~","="},{0,0.0022,0},15695.88,3.58,10855.22,3.12,2990.98,3.11,-6802.09,8.4,-5379.42,4.69,-9530.29,4.5,8498.53,6.35,3837.42,3.61,-21787.66,5.65,13817.37,2.37,9284.83,2.36,9517.74,3.15}
,{147,64,-75356.945,1.965,8243.336,0.013,-4614.28,8.147,146.919100987,2.109,0,137016,"",432,"",3.5,-1,"","",{"B+"},{0},{"="},{0},18573.26,19.81,9283.57,1.26,1735.29,2,-11160.91,9.06,-1649.61,3.1,-15664.65,44.86,7342.48,4.03,5528.37,6.07,-28749.14,38.24,13345.37,2.97,5126.24,10.88,12254.99,1.23}
,{147,65,-70742.665,8.1,8206.624,0.055,-6546.628,11.997,146.92405462,8.695,0,5904,"",108,"",0.5,1,"","",{"B+"},{0},{"="},{0},20496.89,109.47,7329.1,8.55,1073.72,13.65,-14985.57,9.52,-914.09,10.02,-16259.06,10.51,11050.37,45.52,1945.85,8.63,-34768.26,10.6,12894.46,21.31,5880.89,29.1,10522.87,13.46}
,{147,66,-64196.038,8.849,8156.767,0.06,-8438.945,10.164,146.931082715,9.5,0,67,"",7,"",0.5,1,"","",{"B+","B+p"},{0,0.05,0},{"=","~"},{0,0.05,0},22096.07,10.99,5847.66,21.6,1610.35,200.5,-17588.23,39.2,4600.77,9.76,-21029.14,11.03,9712.44,11.1,3721.4,45.73,"","",12903.18,109.53,3036.2,29.31,13209.87,29.31}
,{147,67,-55757.092,5.001,8094.037,0.034,-9149.286,38.517,146.940142295,5.368,0,5.8,"",0.4,"",5.5,-1,"","",{"B+"},{0},{"="},{0},22779.62,8.97,3946.62,109.29,2237.18,51.48,-19782.69,8.47,4717.55,45.14,-19506.4,8.36,12590.19,8.27,491.14,8.36,"","",13196.31,8.22,5677.05,8.74,12257.49,28.39}
,{147,68,-46607.807,38.191,8026.475,0.26,-10633.406,38.799,146.949964458,41,0,3.2,"",1.2,"",0.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},23510,204,2943.15,38.74,3136.22,40.36,"","",8658.14,38.77,-23624,204,10357.11,38.78,2658.56,38.76,"","",13223.1,38.91,2865.76,39.12,15608.68,38.86}
,{147,69,-35974.4,6.839,7948.817,0.047,"","",146.96137989,7.341,0,0.58,"",0.03,"",5.5,-1,"","",{"B+","p"},{0,15,0},{"=","="},{0,15,0},24534,196,1432.24,10.11,3648,298,"","",7974.85,9.49,"","",12990,200,-1058.64,3.2,"","",13977,200,5497,196,14281.51,10.89}
,{148,54,-38600,300,8047,2,8311,300,147.958561,322,0,0.1,"",4e-07,">",0,1,"","",{"B-n","B-2n"},{0,0,0},{"=","="},{0,0,0},6788,301,"","","","",18994,307,"","",5249,300,4312,361,"","",31798,300,"","",7203,586,"",""}
,{148,55,-46910.942,13.041,8097.546,0.088,10682.793,64.413,147.949639029,14,0,0.145,"",0.004,"",0,0,"","",{"B-","B-n","B-2n"},{0,25.1,0,0,0},{"=","=","="},{0,25.1,0,0,0},7743.2,13.36,"","",-4056,401,15797.79,23.43,"","",5281.77,23.67,3062.19,15.5,11840,201,25624.48,19.91,11754.81,27.51,9446.44,17.18,-325,503}
,{148,56,-57593.735,63.079,8164.441,0.426,5115,60,147.938170578,67.718,0,0.62,"",0.005,"",0,1,"","",{"B-","B-n"},{0,0.4,0},{"=","="},{0,0.4,0},8789.28,66.44,24216.73,67.57,-3146.36,63.3,12804.67,64.07,-22523,210,1013.34,63.98,5401.02,66.1,12962.64,63.63,19814.26,63.12,8427.44,63.15,7324.73,63.73,-454,64.06}
,{148,57,-62708.735,19.468,8193.716,0.132,7689.672,22.457,147.9326794,20.9,0,1.35,"",0.04,"",2,-1,"","",{"B-","B-n"},{0,0.15,0},{"=","="},{0,0.15,0},9801.09,38.85,21976.3,19.68,-1862.3,28.01,9826.69,24.6,-18077.64,21.2,1233.84,21.28,4101.66,22.22,9733.68,27.73,14156.98,20.29,12949.16,28.54,9671.5,21.23,2992.08,21.48}
,{148,58,-70398.408,11.195,8240.387,0.076,2137.016,12.567,147.924424196,12.018,0,56.8,"",0.3,"",0,1,"","",{"B-"},{0},{"="},{0},10905.65,19.78,20029.26,23.68,-1056.2,13.28,7009.59,11.34,-17423.35,22.7,-3025.66,19.4,6455.83,14.1,11008.99,15.49,8937.86,11.26,9362.68,35.43,7300.96,16.61,2764.17,14.04}
,{148,59,-72535.424,15.043,8249.54,0.102,4872.572,15.09,147.922130015,16.148,0,137.4,"",1.2,"",1,-1,"","",{"B-"},{0},{"="},{0},11997.05,37.92,18063.08,36.83,-110.69,19.84,4330.29,16.06,-13146,18.47,-2459.99,15.06,5162.67,21.84,7810.5,17.31,3763.91,18.05,13810.77,22.18,9395.65,37.08,5946.29,19.41}
,{148,60,-77407.996,2.127,8277.177,0.014,-542.28,5.874,147.916899093,2.283,1,"s","","s","",0,1,"","",{},{},{},{},12624.76,1.65,16350.55,16.44,598.96,3.04,1928.27,1.7,-12683.08,8.82,-6437.05,1.71,7332.56,1.66,9252.9,15.94,-1138.67,1.84,9983.82,34.87,7082,7.23,5305.43,33.93}
,{148,61,-76865.716,5.723,8268.226,0.039,2470.548,5.642,147.917481255,6.143,0,463795.2,"",604.8,"",1,-1,"","",{"B-"},{0},{"="},{0},13554.04,6.98,14762.65,35.27,1459.89,6.14,-566.38,11.48,-8710.62,16.82,-5670.68,5.64,5894.77,5.65,6007.94,5.65,-6328.63,13.7,14770.96,5.65,9430.29,5.65,8406.63,9.03}
,{148,62,-79336.264,1.367,8279.633,0.009,-3036.933,10.019,147.914829012,1.467,0,1.988086338e+23,"",4.10240038e+22,"",0,1,"","",{"A"},{0},{"="},{0},14482.59,2.83,12988.34,0.42,1986.78,0.36,-3066.94,0.86,-8478.49,0.43,-9862.83,2.29,8141.23,0.26,7582.97,0.38,-11476.71,8.81,10828.85,4.12,6795.26,2.55,7742.09,0.42}
,{148,63,-76299.331,10.013,8253.827,0.068,-30.003,10.019,147.918089294,10.748,0,4708800,"",43200,"",5,-1,"","",{"B+","A"},{0,9.4,0},{"=","="},{0,9.4,0},15324.42,11.62,11422.96,10.81,2691.85,10.28,-5762.25,15.97,-4546.04,10.02,-9013.7,10.09,6825.89,10.25,4321.95,10.02,-18308.17,84.43,15407.78,10.39,9216.04,10.02,10614.54,10.26}
,{148,64,-76269.329,1.554,8248.338,0.011,-5732.246,12.529,147.918121503,1.668,0,2237386053.4,"",31556926,"",0,1,"","",{"A"},{0},{"="},{0},16326.18,3.84,9850.96,2.85,3271.29,0.03,-8409.78,8.83,-4291.95,0.86,-13597.98,8.11,8983.7,1.23,6013.54,2.36,-24790.34,10.36,11559.02,5.95,6586.23,2.71,10028.39,0.3}
,{148,65,-70537.082,12.464,8204.321,0.084,-2677.532,9.596,147.924275323,13.38,0,3600,"",60,"",2,-1,"","",{"B+"},{0},{"="},{0},18916.11,46.55,7997.48,13.82,2657.14,16.48,-12545.92,84.76,-281.3,12.71,-14412.36,15.29,7865.73,14.85,2469.11,12.59,-31772.05,16.13,16259.51,13.09,7253.29,23.32,13100.83,12.79}
,{148,66,-67859.55,8.724,8180.943,0.059,-9868.393,84.287,147.927149772,9.366,0,198,"",12,"",0,1,"","",{"B+"},{0},{"="},{0},21447.27,11,6351.71,9.62,1475.04,29.28,-16380.56,13.46,208.42,8.91,-20173.78,10.06,11734.83,12.43,4405.86,11.89,-37529,400,10614.87,45.7,3392.92,109.52,10713.17,21.55}
,{148,67,-57991.158,83.834,8108.979,0.566,-6512.169,84.458,147.937743928,90,0,2.2,"",1.1,"",1,1,"","",{"B+"},{0},{"="},{0},22895.57,84.09,4805.49,95.08,1952.11,88.37,-19226.13,84.46,5462.54,84.22,-19454.67,92.12,10305.38,83.98,1084.09,84.3,"","",15274.57,84.1,5115.5,84.09,14043.65,137.65}
,{148,68,-51478.989,10.246,8059.692,0.069,-12713.962,14.491,147.944735029,11,0,4.6,"",0.2,"",0,1,"","",{"B+","B+p"},{0,0.15,0},{"=","~"},{0,0.15,0},23299.61,12.25,3502.01,12.24,2666.18,12.51,-21149,400,5428.08,13.54,-23575.91,12.32,12942.5,39.54,3010.87,11.4,"","",10470.04,12.18,2505.17,12.67,12410.01,12.15}
,{148,69,-38765.027,10.246,7968.5,0.069,-8435,400,147.958384029,11,0,0.7,"",0.2,"",10,1,"","",{"B+"},{0},{"="},{0},23852,201,2104.75,12.18,3419.57,13.3,"","",9703.09,11.4,"","",10861.94,12.32,-553.81,39.54,"","",16267.79,12.25,5339,201,16001.48,12.67}
,{148,70,-30330,400,7906,3,"","",147.967439,429,0,0.25,"","s","",0,1,"","",{},{},{},{},"","",586,400,3852,445,"","",8988,401,"","","","",1645,400,"","",11436,447,2116,445,14556,447}
,{149,55,-43250,400,8073,3,9870,593,148.953569,429,0,0.113,"",0.008,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,60,0,0,0},{"=","=","="},{0,60,0,0,0},7473,400,"","",-4736,642,16970,447,"","",6272,405,4411,400,11939,500,27789,400,9820,447,9569,400,"",""}
,{149,56,-53120.309,437.802,8133.793,2.938,7099.605,481.431,148.942973,470,0,0.348,"",0.004,"",1.5,-1,"","",{"B-","B-n"},{0,0.43,0},{"=","="},{0,0.43,0},8998.91,438.25,25339,481,-4051.9,437.94,13549.6,437.92,-21809,531,1517.11,438.23,3597.89,442.32,13498.34,438,21255.16,437.81,9510.56,437.88,7054.12,437.81,481.04,438.47}
,{149,57,-60219.913,200.262,8176.191,1.344,6450,200,148.93535126,214.99,0,1.07,"",0.02,"",1.5,-1,"","",{"B-","B-n"},{0,1.43,0},{"=","="},{0,1.43,0},9684.16,200.55,22877.79,200.44,-2590.41,200.47,10819.45,200.51,-20597.94,200.69,2107.18,200.57,5582.5,201.21,9915.15,209.96,15844.34,200.28,10754.92,201.23,9591.23,201.35,736.86,200.28}
,{149,58,-66669.913,10.246,8214.229,0.069,4369.452,14.23,148.9284269,11,0,4.94,"",0.04,"",1.5,-1,"","",{"B-"},{0},{"="},{0},10798.66,13.36,20983.83,22.25,-1578.65,13.3,7705.55,10.47,-16365.15,63.91,-2205.81,18.2,4342.82,15.18,11250.15,22,10465.82,10.33,10719.28,14.82,7244.42,35.14,3923.57,23.24}
,{149,59,-71039.366,9.874,8238.303,0.066,3336.1,10.101,148.9237361,10.6,0,135.6,"",4.2,"",2.5,1,"","",{"B-"},{0},{"="},{0},11737.93,18.68,18938.92,14.57,-628.96,15.75,5024.89,10.13,-15619.6,21.83,-1702.69,10.1,6575.26,17.99,7929.93,14.93,5401.75,10.63,11685.33,13.08,9460.08,19.06,3657.32,35.04}
,{149,60,-74375.466,2.128,8255.442,0.014,1688.79,2.455,148.920154648,2.284,0,6220.8,"",3.6,"",2.5,-1,"","",{"B-"},{0},{"="},{0},12371.35,1.66,16939.52,8.82,266.64,33.93,2760.27,1.86,-11266.03,11.34,-5581.07,5.87,5038.79,0.07,9129.01,15.09,751.55,3.57,11779.41,15.94,7169.59,34.87,6906.33,16.44}
,{149,61,-76064.256,2.267,8261.526,0.015,1071.481,1.875,148.918341658,2.434,0,191088,"",180,"",3.5,1,"","",{"B-"},{0},{"="},{0},13164.63,2.05,15198.13,15.98,1136.77,7.33,376.86,4.22,-10817.8,15.17,-4799.31,2.03,7269.86,5.88,5945.23,2.45,-4575.59,3.98,12793.3,2.05,9725.67,2.05,6263.15,34.88}
,{149,62,-77135.737,1.311,8263.466,0.009,-694.625,3.788,148.917191375,1.407,1,"s","","s","",3.5,-1,"","",{},{},{},{},14012.02,0.91,13566.93,0.96,1871.3,0.96,-2008.73,3.2,-7016.71,1.86,-8907.72,10.03,5870.79,0.89,7558.99,5.57,-9439.83,9.19,12617.33,0.95,7182.63,4.2,9436.53,0.96}
,{149,63,-76441.112,3.951,8253.554,0.027,-1314.101,4.136,148.917937086,4.241,0,8043840,"",34560,"",2.5,1,"","",{"EC"},{0},{"="},{0},15038.99,4.43,11976.79,3.84,2401.45,4.57,-4952.44,5.03,-6864.37,6.74,-8243.1,3.87,8213.1,10.7,4393.82,3.83,-14794.53,12.58,13536.05,3.83,9419.25,4.73,8659.6,5.6}
,{149,64,-75127.011,3.36,8239.484,0.023,-3638.343,4.339,148.919347831,3.607,0,801792,"",8640,"",3.5,-1,"","",{"B+","A"},{0,4.3,0},{"=","="},{0,4.3,0},15912.7,3.36,10438.6,3.17,3099.39,3.13,-7431.1,9.6,-3079.72,3.17,-12661.25,12.88,6929,3.13,6116.65,10.47,-21385.4,28.15,13128.55,3.86,6854.58,6.69,11515.7,4.19}
,{149,65,-71488.669,3.667,8209.815,0.025,-3792.76,9.162,148.923253753,3.936,0,14824.8,"",90,"",0.5,1,"","",{"B+","A"},{0,16.7,0},{"=","="},{0,16.7,0},16888.64,8.77,8521.85,4.08,4077.92,2.17,-9842.09,12.31,-2478.31,10.55,-11700.44,9.39,9022.9,12.93,2508.31,3.35,-27606,196,14579.08,3.56,9461.17,5.09,11275.27,6.82}
,{149,66,-67695.909,9.221,8179.109,0.062,-6049.33,12.803,148.927325448,9.898,0,252,"",8.4,"",0,0,"","",{"B+"},{0},{"="},{0},19642.51,12.78,6916.91,9.22,2805.5,21.76,-13954.29,29.43,1284.45,9.14,-17776.07,84.34,7907.68,12.09,4447.8,15.05,-34497,300,13757.56,12.2,4931.76,45.77,14036.28,9.9}
,{149,67,-61646.578,11.99,8133.259,0.08,-7904.963,30.408,148.933819672,12.871,0,21.1,"",0.2,"",5.5,-1,"","",{"B+"},{0},{"="},{0},22032.12,12.99,5481.85,14.44,2316.92,109.83,-17764,196,1601.53,15.47,-18238.91,15.77,11726.74,84.69,1076,12.43,"","",13260.27,14.9,5772.39,13.73,11763.43,46.42}
,{149,68,-53741.615,27.945,8074.955,0.188,-9859,198,148.942306,30,0,4,"",2,"",0.5,1,"","",{"B+","B+p"},{0,7,""},{"=","="},{0,7,""},23276.44,47.32,4123.52,29.31,2076.07,28.7,-20543,301,6828.96,29.28,-23047.91,29.76,10333.94,29.76,3039.43,88.37,"","",12726.28,28.39,2360.66,28.71,14459.7,28.74}
,{149,69,-43883,196,8004,1,-10684,358,148.95289,210,0,0.9,"",0.2,"",5.5,-1,"","",{"B+","B+p"},{0,0.26,0},{"=","="},{0,0.26,0},24051,196,2704,196,2813,196,"","",6820,213,-21624,445,13189,196,-307,196,"","",13436,199,5303,196,13002,196}
,{149,70,-33198,300,7927,2,"","",148.96436,322,0,0.7,"",0.2,"",0.5,1,"","",{"B+","B+p"},{0,100,0},{"=","~"},{0,100,0},"","",1169,302,3617,361,"","",10992,300,"","",10939,500,1722,300,"","",13487,300,2721,361,16770,300}
,{150,55,-38170,400,8039,3,11730,500,149.959023,429,0,0.0844,"",0.0082,"",0,0,"","",{"B-","B-n","B-2n"},{0,80,0,2,0},{"=","=","="},{0,80,0,2,0},7402,400,"","","","",17960,591,"","",6879,593,2991,565,"","",30131,400,11141,500,9054,447,"",""}
,{150,56,-49900,300,8112,2,6230,529,149.94643,322,0,0.259,"",0.005,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},8449,307,25878,424,-4370,301,14947,300,"","",2248,361,4851,531,13939,500,23780,300,7722,300,6884,300,-1894,361}
,{150,57,-56129.966,435.473,8148.225,2.903,8716.888,435.631,149.939742,467.5,0,0.504,"",0.015,"",3,1,"","",{"B-","B-n"},{0,2.7,0},{"=","="},{0,2.7,0},9563.86,435.91,23796.96,435.67,-3244.51,435.48,12170.51,435.57,-20169,591,2468.63,435.59,3981.37,479.31,10298.63,617.5,17467.17,435.93,12174.58,440.02,8998.12,435.92,1436.5,435.55}
,{150,58,-64846.854,11.697,8201.122,0.078,3453.625,14.291,149.930384035,12.556,0,6.05,"",0.07,"",0,1,"","",{"B-"},{0},{"="},{0},10591.08,16.19,21831.06,64.15,-2324.68,23.92,8832.9,11.77,-19015.52,437.96,-1878.81,15.31,6248.26,15.55,11915.91,200.6,12204.28,11.76,8572.69,22.71,6695.59,15.86,1063.58,22.95}
,{150,59,-68300.479,9.015,8218.931,0.06,5379.276,9.085,149.926676415,9.678,0,6.19,"",0.16,"",1,-1,"","",{"B-"},{0},{"="},{0},11907.69,17.53,20169.68,21.45,-1675.11,34.8,5296.66,21.97,-15369.54,200.47,-1996.33,9.25,5332.43,13.37,8919.54,13.65,6491.75,10.96,12808.73,14.37,8577.47,12.44,4024.31,14}
,{150,60,-73679.755,1.289,8249.577,0.009,-82.616,20.001,149.920901525,1.384,0,2.587667932e+26,"",2.84012334e+25,"",0,1,"","",{"2B-"},{0},{"="},{0},12414.39,1.87,17859.29,11.25,-469.28,16.35,3371.38,0.2,-14298.81,10.33,-5686.82,1.92,7375.61,1.87,9929.36,9.96,2084.18,6.01,9566.48,15.07,6628.37,15.87,3980.54,8.66}
,{150,61,-73597.139,20.041,8243.81,0.134,3454,20,149.920990217,21.514,0,9712.8,"",54,"",1,-1,"","",{"B-"},{0},{"="},{0},12874.06,20.76,15639.66,25.04,658.95,40.16,1195.1,20.93,-9846.74,22.34,-4532.72,20,5604.2,20.09,6510.64,20.09,-2491.42,21.31,14521.66,20.09,9413.66,20.02,7493.33,25.53}
,{150,62,-77051.139,1.274,8261.621,0.009,-2258.905,6.181,149.917282195,1.368,1,"s","","s","",0,1,"","",{},{},{},{},13857.51,0.89,14221.08,1.86,1449.81,0.96,-1287.2,6.01,-9964.64,1.86,-8681.34,3.78,7986.72,0.38,8275.85,1.91,-7741.54,4.26,10525.38,5.58,6855.18,0.95,6742.01,0.96}
,{150,63,-74792.234,6.253,8241.346,0.042,971.7,3.543,149.919707229,6.712,0,1164450569.4,"",28401233.4,"",0,0,"","",{"B+"},{0},{"="},{0},14635.54,11.75,12504.46,8.33,2237.16,6.96,-3686.51,8.67,-6016.95,6.46,-7736.54,6.91,6422.44,7.21,4945.47,6.19,-12846.35,15.46,15254.84,6.19,9338.17,6.19,9896.43,6.19}
,{150,64,-75763.934,6.076,8242.609,0.041,-4658.213,8.379,149.918664066,6.523,0,56486897540000,"",2524554080000,"",0,1,"","",{"A"},{0},{"="},{0},15637.24,6.04,11005.61,6.01,2807.46,6.02,-6454.33,7.29,-5917.17,6.02,-12346.58,6.89,8708.24,6.75,6611.79,7.07,-17932.62,18.22,11246.2,11.65,6644.88,6.41,9148.82,6.01}
,{150,65,-71105.721,7.384,8206.338,0.049,-1796.122,8.389,149.923664864,7.927,0,12528,"",576,"",0,0,"","",{"B+","A"},{0,0.05,0},{"~","<"},{0,0.05,0},16711.27,14.47,9384.33,12.38,3586.9,4.93,-9159.84,15.95,-1953.58,8.23,-11481.13,11.7,7688.37,8.05,3267.68,7.94,-24615,196,15874.41,7.33,9115.28,7.43,12085.44,7.65}
,{150,66,-69309.6,4.348,8189.149,0.029,-7363.719,14.468,149.92559308,4.667,0,430.2,"",3,"",0,1,"","",{"B+","A"},{0,36,0},{"=","="},{0,36,0},17592.68,9.72,7618.21,4.1,4351.27,1.54,-11478.29,17.51,-1471.56,5.16,-15734.34,12.69,9685.01,10,5109.9,5.29,-30671,300,11938.29,13.17,6297.12,8.75,11693.75,4.28}
,{150,67,-61945.881,14.168,8134.842,0.094,-4114.568,13.591,149.933498358,15.21,0,76.8,"",1.8,"",0,0,"","",{"B+"},{0},{"="},{0},20097.36,85.02,5986.74,18.86,3392.81,46.97,-15455,196,2253.82,14.59,-16275.58,31.33,8370.62,18.55,1538.94,16.87,-37306,300,16624.48,16.63,7114.21,16.7,14443.19,16.25}
,{150,68,-57831.313,17.195,8102.195,0.115,-11340,196,149.937915528,18.459,0,18.5,"",0.7,"",0,1,"","",{"B+"},{0},{"="},{0},22494.96,20.02,4549.7,19.28,2298.69,18.45,-19193,300,2575.63,19.49,-22020,196,12161.01,32.81,3473.7,20.95,"","",10870.65,85.58,2789.83,17.91,12011.13,19.34}
,{150,69,-46491,196,8021,1,-7852,358,149.95009,210,0,3,"","s","",1,1,"","",{"B+"},{0},{"="},{0},23868,196,3078,213,2322,196,-21851,358,7867,196,-21364,358,10680,277,38,198,"","",15699,196,4981,199,14913,196}
,{150,70,-38638,300,7964,2,-13998,424,149.95852,322,0,0.7,"",2e-07,">",0,1,"","",{},{},{},{},24451,500,1737,300,3259,300,"","",7814,301,"","",13511,424,2045,358,"","",10837,300,2200,300,13616,302}
,{150,71,-24640,300,7865,2,"","",149.973548,322,0,0.045,"",0.003,"",5,-1,"","",{"p","B+"},{"",29,0},{"","="},{"",29,0},"","",453,300,3991,361,"","",11954,358,"","","","",-1269.6,2.31,"","",16401,500,"","",16981,300}
,{151,55,-34230,500,8013,3,10710,640,150.963253,537,0,0.069,"",0.026,"",1.5,1,"","",{"B-","B-n","B-2n"},{0,90,0,"",""},{"=","=",""},{0,90,0,"",""},7122,640,"","","","",19081,663,"","",7599,583,4131,640,"","",32550,500,"","",9235,583,"",""}
,{151,56,-44940,400,8079,3,8370,591,150.951755,429,0,0.167,"",0.005,"",1.5,-1,"","",{"B-","B-n"},{0,7,0},{"=","="},{0,7,0},7962,593,"","",-5005,447,16285,400,"","",3119,591,3111,500,14059,565,26003,400,9021,565,6835,400,-693,500}
,{151,57,-53310.333,435.473,8129.043,2.884,7914.718,435.833,150.942769,467.5,0,0.465,"",0.024,"",2.5,1,"","",{"B-","B-n"},{0,6,0},{"=","="},{0,6,0},9233.05,479.31,24638,591,-3815.18,435.55,13469.3,435.63,-22429,591,3465.2,435.63,5251.68,615.85,10699,529,20075.73,435.5,10520.78,617.5,9147.46,440.02,-752.99,435.67}
,{151,58,-61225.052,17.698,8176.277,0.117,5554.578,21.189,150.9342722,19,0,1.76,"",0.06,"",1.5,-1,"","",{"B-"},{0},{"="},{0},10697.77,20.45,22682.68,438.16,-3385.94,26.52,9717.94,17.75,-18614,300,-995.89,19.86,4449.51,21.21,12384.06,435.83,13351.23,17.74,9705.67,201.04,6347.74,26.31,2015.09,65.52}
,{151,59,-66779.63,11.651,8207.881,0.077,4163.358,11.689,150.928309114,12.507,0,18.9,"",0.07,"",1.5,-1,"","",{"B-"},{0},{"="},{0},11882.9,15.27,21137.66,200.6,-2526.16,15.83,6606.43,12.51,-17938.63,435.63,-1171.19,11.69,6550.47,14.73,9221.75,16.51,7873.22,11.69,10601.09,15.52,8482.83,16.15,1575.51,22.69}
,{151,60,-70942.988,1.293,8230.272,0.009,2443.075,4.473,150.923839565,1.387,0,746.4,"",4.2,"",1.5,1,"","",{"B-"},{0},{"="},{0},12710.16,1.88,18851.02,10.33,-1354.01,8.67,3633.29,0.24,-13385.1,11.77,-5417.17,20,5334.55,0.1,9931.48,9.09,3245.75,2.83,10807.18,9.96,6456.49,15.07,5101.82,11.25}
,{151,61,-73386.063,4.653,8241.27,0.031,1190.217,4.476,150.921216817,4.994,0,102240,"",144,"",2.5,1,"","",{"B-"},{0},{"="},{0},13464.44,4.86,16924.64,10.92,-366.91,16.49,1266.79,4.51,-12374.55,10.13,-4406.24,4.47,7860.24,20.49,6995.28,4.47,-1762.56,5.99,11700.21,4.85,8885.99,4.85,4795.76,15.72}
,{151,62,-74576.279,1.273,8243.971,0.008,76.574,0.538,150.919939066,1.367,0,2840123340,"",252455408,"",2.5,-1,"","",{"B-"},{0},{"="},{0},13583.18,0.39,14778.75,1.87,1145.55,0.96,-387.54,2.82,-8185.5,0.22,-7855.36,6.18,5596.46,0.11,8268.11,20,-5823.87,3.15,12198.78,1.91,7153.49,5.58,8478.12,1.87}
,{151,63,-74652.854,1.325,8239.297,0.009,-464.116,2.779,150.91985686,1.422,0,1.451618596e+26,"",3.78683112e+25,"",2.5,1,"","",{"A"},{0},{"="},{0},14354.38,3.77,13166.54,1.98,1964.49,1.07,-3029.35,3.98,-8344.69,20.01,-6960.24,6.01,7931.94,6.18,4890.69,0.55,-11030.12,8.34,13193.69,0.66,9547.47,1.02,7859.26,5.61}
,{151,64,-74188.737,3.056,8231.043,0.02,-2565.233,3.762,150.920355109,3.28,0,10704960,"",86400,"",3.5,-1,"","",{"EC","A"},{0,1,0},{"=","="},{0,1,0},15204.36,4.22,11630.94,2.84,2652.7,2.91,-5436.33,4.17,-4426.57,2.82,-11154.33,7.85,6496.12,6.61,6685.47,6.76,-15922.45,16.75,12963.18,4.67,6974.65,10.4,10793.93,2.91}
,{151,65,-71623.504,4.137,8208.873,0.027,-2871.099,4.944,150.923109001,4.441,0,63392.4,"",3.6,"",0,0,"","",{"B+","A"},{0,0.0095,0},{"~","="},{0,0.0095,0},16277.47,5.24,9760.33,5.45,3496.34,3.93,-8000.77,9.19,-4120.24,7.32,-10385.22,5.75,8589.1,8.31,3148.54,7.17,-20850.75,19.84,14214.31,5.04,9509.88,4.04,10322.23,10.76}
,{151,66,-68752.405,3.293,8184.678,0.022,-5129.667,8.756,150.926191253,3.535,0,1074,"",18,"",0,0,"","",{"B+","A"},{"",5.6,0},{"","="},{"",5.6,0},17199.13,9.59,8203.34,4.28,4179.62,2.64,-10486.12,16.8,-277.44,6.7,-14877.84,14.5,7514.12,5.03,4935.65,7.88,-27210.06,300.51,13447.07,4.44,6648.73,12.86,13163.32,2.91}
,{151,67,-63622.738,8.302,8145.526,0.055,-5356.454,18.444,150.931698177,8.912,0,35.2,"",0.1,"",0,0,"","",{"B+","A"},{"",22,0},{"","="},{"",22,0},18118.79,14.56,6712.01,8.95,4695.01,1.82,-12849.98,21.08,194.01,11.04,-13862.74,19.05,9748.17,16.36,1602.11,8.94,-33514,300,14783.98,12.33,9100.87,12.03,12560.75,14.96}
,{151,68,-58266.284,16.47,8104.872,0.109,-7493.528,25.46,150.937448567,17.681,0,23.5,"",2,"",3.5,-1,"","",{"B+"},{0},{"="},{0},20667.3,32.44,5148.32,18.88,3504.84,18.7,-16723.94,300.94,3754.35,17.03,-19847,196,8506.29,23.81,3609.37,21.73,"","",14091.1,20.37,4588.93,85.44,15239.67,18.64}
,{151,69,-50772.756,19.416,8050.064,0.129,-9230.414,300.136,150.945493201,20.843,0,4.17,"",0.11,"",5.5,-1,"","",{"B+"},{0},{"="},{0},23033,197,3704.12,22.81,2559.42,20.05,-20664,301,3884.15,16.31,-20206,301,12353,197,230.41,9.02,"","",13679.67,34.03,5570.29,21.95,12864.8,86.05}
,{151,70,-41542.342,300.492,7983.755,1.99,-11434,425,150.955402458,322.591,0,1.6,"",0.5,"",0.5,1,"","",{"B+","B+p"},{0,"",""},{"=",""},{0,"",""},24487,425,2378.67,301.79,2640.55,302.91,"","",9000,300,-24974,425,10975,425,2340,359,"","",13051,359,2086.74,300.67,15583.05,300.67}
,{151,71,-30108,300,7903,2,"","",150.967677,322,0,0.0784,"",0.0009,"",5.5,-1,"","",{"p","B+"},{"",37,0},{"","="},{"",37,0},"","",804,358,3441,300,"","",9093,358,"","",13540,424,-1240.97,1.82,"","",13801,424,5086,500,14303,300}
,{152,55,-28930,500,7979,3,12780,640,151.968942,537,0,0.03,"","s","",0,0,"","",{},{},{},{},6903,640,"","","","",20360,583,"","",7938,640,2772,707,"","",34828,501,"","","","","",""}
,{152,56,-41710,400,8057,3,7580,500,151.955222,429,0,0.139,"",0.008,"",0,1,"","",{"B-","B-n"},{0,5,0},{"=","="},{0,5,0},7953,500,"","",-5535,500,17270,447,"","",3529,591,4842,565,14770,640,28439,400,7170,565,6404,565,"",""}
,{152,57,-49290,300,8102,2,9690,361,151.947085,322,0,0.287,"",0.016,"",0,0,"","",{"B-","B-n"},{0,50,0},{"=","="},{0,50,0},9303,529,25698,500,-4804,300,14468,301,-22349,583,3864,300,4051,529,11639,500,21964,301,11321,424,8694,531,-393,500}
,{152,58,-58980,200,8161,1,4778,201,151.936682,215,0,1.42,"",0.02,"",0,1,"","",{"B-"},{0},{"="},{0},10276,201,23658,361,-3812,210,11169,202,-21329,447,-272,201,5827,201,12959,479,15782,200,7860,479,6104,283,-214,481}
,{152,59,-63758.063,18.537,8187.104,0.122,6391.344,30.71,151.9315529,19.9,0,3.57,"",0.11,"",4,1,"","",{"B-"},{0},{"="},{0},11600.22,20.61,22206.04,435.87,-3474.24,26.88,7496.12,31.86,-17736.7,435.87,-886.39,18.58,5049.75,21.89,9821.98,25.63,9130.19,18.58,11799.6,21.92,7775.91,21.18,2108.25,201.12}
,{152,60,-70149.407,24.485,8224.005,0.161,1104.778,18.501,151.924691509,26.285,0,684,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},12612.29,24.45,19880.49,27.13,-2175.92,26.92,4613.2,24.46,-16213.33,30.21,-4834.66,24.86,7277.74,24.46,10658.75,27.1,4557.51,24.46,8861.88,26.08,5754.01,26.4,2166.91,26.54}
,{152,61,-71254.186,25.912,8226.127,0.17,3508.417,25.886,151.923505481,27.817,0,247.2,"",4.8,"",1,1,"","",{"B-"},{0},{"="},{0},13799.68,32.71,17531.65,27.43,-1143.68,29.95,1634.07,25.89,-11763.53,28.4,-4749.22,25.89,5939.44,26.27,7600.17,25.89,-537.27,47.65,13136.38,25.89,7985.34,25.95,5431.58,27.73}
,{152,62,-74762.603,1.212,8244.061,0.008,-1874.348,0.687,151.91973904,1.301,1,"s","","s","",0,1,"","",{},{},{},{},13854.1,0.61,15660.79,0.65,220.48,1.94,-55.69,0.18,-11108.59,0.65,-8181.07,0.69,8257.64,0.61,8665.51,4.52,-4644.73,4.55,9545.34,20.01,6165.71,2,5259.26,1.94}
,{152,63,-72888.255,1.326,8226.583,0.009,1818.661,0.702,151.921751235,1.423,0,426554968.742,"",284012.334,"",3,-1,"","",{"B+","B-"},{0,27.92,0},{"=","="},{0,27.92,0},14238.66,6.18,13869.06,20.01,1552.55,5.61,-2171.34,40.01,-6791.16,4.51,-6770.83,2.78,6306.72,0.1,5600.95,0.54,-9283.48,12.58,14873.69,0.55,9111.54,0.67,8822.4,1.98}
,{152,64,-74706.916,1.206,8233.401,0.008,-3990,40,151.919798822,1.294,0,3.408148008e+21,"",2.52455408e+20,"",0,1,"","",{"A"},{0},{"="},{0},15085.62,6.03,12233.72,0.63,2204.43,1.04,-4589.04,4.55,-7419.61,0.63,-11154.73,4.01,8589.5,2.85,7343.03,0.7,-14206.54,8.9,10796.12,6.2,6598.25,3.8,8075.22,0.73}
,{152,65,-70716.916,40.018,8202.004,0.263,-599.044,40.258,151.924082263,42.961,0,63000,"",360,"",2,-1,"","",{"B+","A"},{0,7,0},{"=","<"},{0,7,0},15753.83,40.67,10502.62,40.48,3157.5,41.24,-7112.15,41.93,-3353.03,40.01,-10035.83,40.13,7164.73,40.2,3817.15,40.1,-18996.64,67.23,15757.82,40.45,9274.15,40.13,11370.6,40.18}
,{152,66,-70117.873,4.624,8192.916,0.03,-6513.102,13.325,151.924725363,4.963,0,8568,"",72,"",0,1,"","",{"EC","A"},{0,0.1,0},{"~","="},{0,0.1,0},16950.91,5.98,8931.88,7.44,3726.54,4.35,-9617.5,9.94,-3218.11,5.29,-14566.45,9.38,9436.78,5.24,5783.34,5.94,-23847.49,149.78,11698.65,8.52,6234.85,5.49,10655.54,5.37}
,{152,67,-63604.771,12.529,8144.919,0.082,-3104.394,9.815,151.931717465,13.45,0,161.8,"",0.3,"",2,-1,"","",{"B+","A"},{0,12,0},{"=","="},{0,12,0},17801.52,18.91,7076.99,14.52,4507.4,1.34,-11884.5,55.46,729.76,13.17,-13409.8,20.69,8053.35,15.02,2141.34,12.92,-30183,196,16415.63,13.23,8955.19,15.1,13530.3,12.99}
,{152,68,-60500.377,8.83,8119.349,0.058,-8780.104,54.743,151.935050169,9.479,0,10.3,"",0.1,"",0,1,"","",{"A","B+"},{0,10,0},{"=","="},{0,10,0},18811.7,19.33,5768.72,9.82,4934.26,1.62,-14230,149.97,963.06,9.39,-17798.94,21.33,10305.41,18.69,4166.61,12.11,"","",12156.31,16.69,6010.26,12.43,12841.93,12.15}
,{152,69,-51720.273,54.027,8056.438,0.355,-5449.892,139.62,151.944476,58,0,8,"",1,"",0,0,"","",{"B+"},{0},{"="},{0},21372,203,4352.33,55.85,3845.97,99.74,-18298,203,4613.49,54.66,-18249.25,305.31,9018.83,57.41,742.96,56.48,"","",16821.85,56.7,6885.4,60.83,15572.71,55.34}
,{152,70,-46270.381,149.708,8015.436,0.985,-12848,246,151.9503267,160.718,0,3.03,"",0.06,"",0,1,"","",{"B+"},{0},{"="},{0},23775,335,3017.01,150.69,2783.69,150.06,"","",4706.93,150.61,-24233,335,12799.36,335.72,2786.6,150.96,"","",10931,246,2476,246,13117.64,152.29}
,{152,71,-33422,196,7926,1,"","",151.96412,210,0,0.65,"",0.07,"",4,-1,"","",{"B+","B+p"},{0,15,0},{"=","="},{0,15,0},24925,358,1509,277,2918,196,"","",10062,197,"","",11385,358,-831,359,"","",15927,358,4640,358,16107,277}
,{153,56,-36470,400,8023,3,9590,500,152.960848,429,0,0.116,"",0.052,"",2.5,-1,"","",{"B-","B-n","B-2n"},{0,3,0,0,0},{"=","=","="},{0,3,0,0,0},7673,565,"","","","",18440,447,"","",4749,500,2831,565,14828,640,30860,400,8471,640,6564,565,"",""}
,{153,57,-46060,300,8081,2,8850,361,152.950553,322,0,0.245,"",0.018,"",2.5,1,"","",{"B-","B-n"},{0,50,0},{"=","="},{0,50,0},8892,529,26408,583,-5234,500,15509,300,-24418,583,4849,361,4841,424,11638,500,24588,300,9591,500,8705,424,-2243,500}
,{153,58,-54910,200,8134,1,6659,201,152.941052,215,0,0.865,"",0.025,"",1.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9827,201,24548,447,-4214,481,12421,200,-20488,447,777,201,4001,283,12909,361,17650,200,9111,479,6084,479,637,361}
,{153,59,-61568.463,11.882,8172.036,0.078,5761.834,12.19,152.933903532,12.755,0,4.28,"",0.11,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10931.47,16.64,22836.07,435.64,-3773.47,200.61,9079.36,14.94,-19567,300,509.63,27.22,5881.72,22.02,9877,201,11798.76,11.96,10367.39,21.32,8142.45,16.67,207.9,435.64}
,{153,60,-67330.297,2.747,8204.582,0.018,3317.527,9.355,152.927717949,2.948,0,31.6,"",1,"",0,0,"","",{"B-"},{0},{"="},{0},12529.94,3.03,20683.19,17.91,-3085.3,10.61,5229.39,3,-15639,200,-4147.43,26.06,5252.21,24.64,10861.2,18.74,5552.25,3,10160.14,11.97,5834.24,9.42,3162.96,12.01}
,{153,61,-70647.824,9.066,8221.152,0.059,1911.862,9.093,152.924156436,9.732,0,315,"",1.2,"",2.5,-1,"","",{"B-"},{0},{"="},{0},13404.4,10.15,18446.14,14.76,-2033.37,13.4,2719.4,9.11,-14178.73,20.63,-3956.54,9.09,7464.96,27.43,7787.39,26.09,665.51,9.86,11005.97,9.11,7895.99,9.11,3299.06,12.78}
,{153,62,-72559.686,1.219,8228.534,0.008,807.536,0.708,152.922103969,1.309,0,166622.4,"",14.4,"",1.5,1,"","",{"B-"},{0},{"="},{0},14126.04,0.62,16194.64,0.67,-609.14,1.94,322.87,0.25,-9699.25,24.46,-7742.75,0.7,5868.4,0.13,8594.47,25.89,-3416.74,3.91,11537.18,4.52,5901.51,20.01,6766.47,0.66}
,{153,63,-73367.222,1.33,8228.699,0.009,-484.671,0.717,152.921237043,1.428,1,"s","","s","",2.5,1,"","",{},{},{},{},14857,0.16,14559.1,4.51,272.12,1.99,-2053.88,3.88,-9402.01,25.89,-6731.62,0.71,8550.28,0.12,5893.59,0.69,-8355.12,5.02,11919.86,0.55,8547.97,0.56,5876.32,20.01}
,{153,64,-72882.551,1.203,8220.418,0.008,-1569.213,3.845,152.921757359,1.291,0,20770560,"",86400,"",1.5,-1,"","",{"EC"},{0},{"="},{0},14836.45,2.86,12884.21,0.64,1828.27,0.74,-3739.61,3.91,-5408.92,0.22,-10236.95,40,6246.95,0.13,7283.27,0.71,-12413.95,9.3,12481.11,0.71,6773.74,6.2,9814.99,0.64}
,{153,65,-71313.338,3.995,8205.048,0.026,-2170.394,1.933,152.923441978,4.289,0,202176,"",864,"",2.5,1,"","",{"B+"},{0},{"="},{0},15832.47,5.51,11238.43,3.88,2702.86,5.02,-6301.23,6.15,-5714.05,3.88,-9266.78,5.86,8667.74,40.18,3895.39,3.85,-17340.01,12.58,13586.21,4.75,9314.65,7.11,9125.3,7.25}
,{153,66,-69142.943,4.048,8185.749,0.026,-4130.84,6.157,152.925771992,4.346,0,23040,"",360,"",0,0,"","",{"B+","A"},{0,0.0094,0},{"~","="},{0,0.0094,0},16533.17,4.91,9532.15,4.8,3559.15,3.62,-8674.34,10,-1725,3.91,-13609.49,13.14,7096.39,5.88,5715,40.19,-21935,196,13191.37,5.54,6826.83,8.28,12267.39,7.13}
,{153,67,-65012.103,5.094,8153.637,0.033,-4543.499,9.916,152.930206632,5.468,0,120.6,"",1.8,"",5.5,-1,"","",{"B+","A"},{0,0.051,0},{"~","="},{0,0.051,0},17532,9.63,7966.54,6.32,4051.65,3.54,-11038.77,12.81,-1584.16,40.31,-12583.04,10.12,9478.65,13.47,2183.2,6.53,-26639.26,150.12,14451.11,5.67,9161.55,6.36,11740.02,8.79}
,{153,68,-60468.604,9.321,8118.827,0.061,-6495.276,12.891,152.935084279,10.006,0,37.1,"",0.2,"",0,0,"","",{"A","B+"},{0,47,0},{"=","="},{0,47,0},18344.95,18.92,6294.14,9.69,4802.39,1.4,-13260,196,2360.3,10.21,-16819.65,54.82,8039.54,12.23,4152.8,15.17,-33168,300,13864.94,12.41,6341.33,16.93,14487.4,10.1}
,{153,69,-53973.329,11.983,8071.261,0.078,-6765,196,152.942057244,12.864,0,1.48,"",0.01,"",5.5,-1,"","",{"A","B+"},{0,9,""},{"=","="},{0,9,""},19343.21,22.81,4928.53,14.55,5248.33,1.45,-15600.48,150.51,2342.47,15.5,-15774.27,150.19,10324.37,55.34,761.92,12.4,"","",15003.76,20.37,8722.04,20.95,13618.95,18.55}
,{153,70,-47208,196,8022,1,-8835,247,152.94932,210,0,4.2,"",0.2,"",3.5,-1,"","",{"B+","A","B+p"},{"",50,0,0.008,0},{"","=","="},{"",50,0,0.008,0},21808,359,3520,196,4109,198,-19908,358,6003,196,-21857,277,9009,246,2777,203,"","",14275,197,4147,277,16270,196}
,{153,71,-38372.844,150.034,7959.07,0.981,-11073,335,152.958805054,161.068,0,0.9,"",0.2,"",5.5,-1,"","",{"A","p"},{"",0,0},{"","="},{"",0,0},24407,335,2178.03,151.29,3085,247,"","",6058.46,139.97,"","",13022,247,-608.57,9.88,"","",13880.3,335.87,5130,335,13764,247}
,{153,72,-27300,300,7882,2,"","",152.970692,322,0,0.4,"",2e-07,">",0.5,1,"","",{},{},{},{},"","",336,425,3473,424,"","",11681,335,"","","","",1167,358,"","",13519,424,2204,424,16985,424}
,{154,56,-32820,500,8000,3,8709,583,153.964766,537,0,0.053,"",0.048,"",0,1,"","",{"B-"},{0},{"="},{0},7252,640,"","","","",19399,539,"","",5168,583,4422,640,"","",33005,503,6821,707,6273,707,"",""}
,{154,57,-41530,300,8051,2,10690,361,153.955416,322,0,0.161,"",0.015,"",0,0,"","",{"B-","B-n","B-2n"},{0,20,0,"",""},{"=","=",""},{0,20,0,"",""},8382,424,27177,583,-5785,500,16575,321,"","",5309,361,3541,424,12349,500,26982,303,10892,500,8274,500,-1654,583}
,{154,58,-52220,200,8116,1,5885,230,153.94394,215,0,0.722,"",0.014,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9382,283,25087,447,-4744,361,13605,207,-23039,447,1278,201,5381,283,13449,361,20236,200,7781,361,5955,479,-1633,447}
,{154,59,-58104.976,113.009,8148.892,0.734,7720,100,153.937621738,121.32,0,2.3,"",0.1,"",3,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10489.55,114.52,23393,321,-4399.93,449.9,10407,103.08,-19334,321,1154,113.04,4607.83,113.63,10484,230,13633.14,113.01,11586,230,7984.13,114.39,851.76,449.9}
,{154,60,-65824.976,52.642,8193.942,0.342,2687,25,153.929333977,56.513,0,25.9,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},11818.2,58.03,21423,207,-3403.04,53.93,6630.2,52.62,-18204,207,-3248.47,53.4,6566,52.71,11545.48,53.97,7880.98,52.63,8643.89,55.81,5818.71,53.91,1046.48,55.54}
,{154,61,-68511.976,46.326,8206.31,0.301,3943.2,46.303,153.926449364,49.733,0,160.8,"",4.2,"",4,1,"","",{"B-"},{0},{"="},{0},13400.42,53.05,19331.85,49.9,-2636.41,47.19,3226.14,46.32,-14232.48,47.83,-4023.61,46.31,5935.47,47.19,8470.65,46.41,1644.33,64.78,12348.24,52.37,7295.07,46.32,3914.06,47.76}
,{154,62,-72455.176,1.462,8226.835,0.009,-717.056,1.103,153.922216164,1.569,1,"s","","s","",0,1,"","",{},{},{},{},13835.21,0.84,16883.71,24.47,-1200.34,1.05,1250.78,0.86,-12413.85,3.11,-7159.27,1.08,7966.81,0.85,9096.32,9.1,-2061.27,7.46,9509.82,25.9,5794.94,4.59,4134.21,1.06}
,{154,63,-71738.121,1.346,8217.098,0.009,1967.834,0.755,153.922985955,1.444,0,271421120.526,"",315569.26,"",3,-1,"","",{"B-","EC"},{0,0.018,0},{"~","="},{0,0.018,0},14992.5,0.27,15061.88,25.89,-565.9,20.01,-1581.82,45.3,-8379.27,9.11,-6926.89,0.74,6442.22,0.24,6467.41,0.74,-7098.81,8.21,13735.29,0.72,7702.21,0.6,7294.34,4.52}
,{154,64,-73705.954,1.197,8224.796,0.008,-3549.651,45.298,153.920873398,1.285,1,"s","","s","",0,1,"","",{},{},{},{},15141.67,0.21,13521.29,0.27,920.27,0.66,-3312.05,7.42,-8435.24,0.3,-10463.93,3.85,8894.72,0.17,7627.7,0.73,-11100.93,4.93,9893.11,0.72,5810.95,0.72,6516.73,0.65}
,{154,65,-70156.303,45.314,8196.666,0.294,237.604,45.901,153.924684106,48.646,0,77400,"",1440,"",0,0,"","",{"B+","B-"},{0,0.1,0},{"~","<"},{0,0.1,0},15582.02,60.43,11845.99,45.3,2211.02,45.72,-5516.99,46.04,-4078.05,45.3,-9084.68,45.47,6914.28,45.46,4562.72,45.3,-15729.17,47.55,15261.42,45.3,8896.49,45.39,10142.95,45.3}
,{154,66,-70393.907,7.445,8193.129,0.048,-5754.596,10.178,153.924429028,7.992,0,94670778000000,"",47335389000000,"",0,1,"","",{"A"},{0},{"="},{0},16418.67,8.61,10264.93,7.41,2945.11,4.95,-7788.89,8.82,-4800.33,7.42,-13453.12,8.87,9322.28,8.34,6369.54,8.32,-20461.82,18.8,11033.82,40.68,6093.65,8.37,9441.23,7.9}
,{154,67,-64639.311,8.228,8150.681,0.053,-2034.291,9.463,153.930606841,8.833,0,705.6,"",11.4,"",2,-1,"","",{"B+","A"},{0,0.019,0},{"~","="},{0,0.019,0},17177.17,14.97,8500.34,40.83,4041.49,3.63,-10212.18,16.57,-614.94,9.02,-12242.02,12.33,7698.53,9.51,2785.34,9.04,-24924,196,16189.37,9.26,8977.15,8.68,12630.59,9.07}
,{154,68,-62605.02,4.986,8132.392,0.032,-8177.888,14.916,153.932790743,5.353,0,223.8,"",5.4,"",0,1,"","",{"B+","A"},{0,0.47,0},{"~","="},{0,0.47,0},18247.28,10.11,7065.09,6.46,4279.66,2.61,-12672.94,17.77,-751.05,6.19,-16703.01,12.92,10207.73,10.39,4881.89,6.82,-29935,300,11710.56,13.46,5881.77,9.28,11793.79,5.59}
,{154,69,-54427.131,14.412,8074.208,0.094,-4495.048,13.953,153.941570067,15.472,0,8.1,"",0.3,"",2,-1,"","",{"A","B+"},{0,46,0},{"=","="},{0,46,0},18849.49,55.92,5400.3,19.09,5093.83,2.64,-14712,197,3296,15.25,-15290,196,8525.12,18.73,1247.5,17.13,"","",16784.05,16.9,8703.21,21.89,14842.01,16.57}
,{154,70,-49932.083,17.281,8039.939,0.112,-10217,197,153.946395701,18.552,0,0.409,"",0.002,"",0,1,"","",{"A","B+"},{0,7.4,0},{"=","="},{0,7.4,0},19804.34,150.7,4009.65,19.4,5474.31,1.73,-17262,300,3247.55,19.61,-19630.56,151.03,10795,196,3247.72,21.02,"","",12499,56.72,5704.73,8.85,13980.6,23.87}
,{154,71,-39715,196,7969,1,-7045,358,153.957364,211,0,1,"","s","",2,-1,"","",{},{},{},{},22436,277,2573,203,4351,277,"","",6969,196,-20486,358,9414,247,-204.06,13.96,"","",17266,247,6691,359,16704,197}
,{154,72,-32670,300,7918,2,"","",153.964927,322,0,2,"",1,"",0,1,"","",{"B+","A"},{0,0,0},{"~","~"},{0,0,0},"","",978,335,3543,424,"","",7249,358,"","",13441,424,1586,335,"","",11463,358,2302,424,14518,425}
,{155,57,-37930,400,8028,3,9850,500,154.95928,429,0,0.101,"",0.028,"",2.5,1,"","",{"B-","B-n","B-2n"},{0,60,0,0,0},{"=","=","="},{0,60,0,0,0},8013,500,"","",-6126,640,17485,400,"","",6218,447,4472,500,12399,640,29009,400,9250,565,8644,565,-3354,640}
,{155,58,-47780,300,8087,2,7635,300,154.948706,322,0,0.313,"",0.007,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9013,361,25888,500,-5265,500,14504,300,-22249,583,2254,321,3632,361,13539,424,22411,300,8990,424,6374,424,-423,500}
,{155,59,-55415.268,17.198,8131.039,0.111,6868.456,19.472,154.940509259,18.462,0,1.47,"",0.3,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9989.44,20.9,23934,300,-4529.85,435.81,11524.66,17.82,-21175,300,2338.39,55.38,5381.61,114.31,10485,201,16402.82,17.25,10205,201,8429,201,-479,300}
,{155,60,-62283.724,9.153,8170.304,0.059,4656.207,10.278,154.933135668,9.826,0,8.9,"",0.2,"",1.5,-1,"","",{"B-"},{0},{"="},{0},11096.06,9.53,21952,200,-3483.59,19.93,7907.1,9.27,-17353,200,-1843.06,47.22,4530.06,53.43,11467.72,113.38,9786.16,9.23,9995.55,14.99,6338.39,20.67,2343,200}
,{155,61,-66939.931,4.718,8195.296,0.03,3250.888,4.946,154.928137024,5.065,0,41.5,"",0.2,"",2.5,-1,"","",{"B-"},{0},{"="},{0},12434.74,10.21,19949.41,12.78,-2585.22,12.57,4878.16,4.92,-16123.93,113.11,-2556.07,4.94,6499.27,46.57,8403.93,52.85,4310.12,10.92,11101.17,5.42,8073.53,24.94,2464.53,19.13}
,{155,62,-70190.819,1.487,8211.223,0.01,1627.273,1.202,154.924647051,1.595,0,1338,"",12,"",1.5,-1,"","",{"B-"},{0},{"="},{0},13773.77,0.89,17438.46,3.12,-1672.75,1.09,1879.06,0.92,-11654.81,52.62,-6524.02,1.13,5806.96,0.27,8967.81,46.3,-1035.27,9.65,11167.81,9.11,5927.42,25.9,5604.99,24.47}
,{155,63,-71818.092,1.401,8216.674,0.009,251.788,0.87,154.922900102,1.504,0,149611386.166,"",284012.334,"",2.5,1,"","",{"B-"},{0},{"="},{0},14593.5,0.47,15748.21,9.12,-856.94,4.53,-568.04,9.83,-10595.09,46.32,-6183.45,0.85,8151.29,0.4,6651.89,1.17,-5778.55,17.48,11452.4,0.84,7808.57,0.83,5082.5,25.89}
,{155,64,-72069.88,1.191,8213.251,0.008,-819.83,9.789,154.922629796,1.278,1,"s","","s","",1.5,-1,"","",{},{},{},{},15329.96,0.25,14088.14,0.35,81.48,0.67,-2914.33,9.6,-6903.67,0.88,-9984.89,45.3,6435.24,0.18,7620.73,0.77,-9860.69,6.04,12008.15,0.75,5682.43,0.74,8339.12,0.32}
,{155,65,-71250.05,9.849,8202.914,0.064,-2094.5,1.897,154.923509921,10.573,0,459648,"",5184,"",1.5,1,"","",{"EC"},{0},{"="},{0},16079.35,10.52,12460.77,9.82,977.89,9.82,-5210.51,16.7,-6800.9,9.82,-8927.46,12.28,9165.06,46.34,4833.07,9.79,-14624.14,13.95,12343.31,9.79,8320.92,9.79,7284.61,9.82}
,{155,66,-69155.55,9.665,8184.354,0.062,-3116.011,16.59,154.925758459,10.375,0,35640,"",720,"",1.5,-1,"","",{"B+"},{0},{"="},{0},16155.24,10.37,10850.94,9.61,2608.27,10.02,-6946.36,11.34,-2738.57,9.6,-12587.56,12.63,6832.96,12.13,6288.22,46.31,-18652.94,19.21,12868.59,10.35,6425.42,41.14,11197.77,9.61}
,{155,67,-66039.539,17.474,8159.203,0.113,-3830.35,18.474,154.929103634,18.759,0,2880,"",60,"",2.5,1,"","",{"B+"},{0},{"="},{0},17170.07,18.17,9304.14,17.88,3159.05,17.92,-9413.63,20.08,-3172.21,48.55,-11505.84,18.14,9471.54,19.29,2934.6,18.96,-23494.49,25.99,13814.21,17.89,8942.39,18.04,10323.78,43.65}
,{155,68,-62209.189,6.098,8129.444,0.039,-5583.276,11.515,154.933215684,6.546,0,318,"",18,"",3.5,-1,"","",{"B+","A"},{0,0.022,0},{"~","="},{0,0.022,0},17883.22,10.96,7644.19,7.1,4118.3,5.13,-11706.58,17.68,895.75,9.48,-15853.38,15.61,7675.49,7.59,4858.85,10.08,-28039,298,13513.72,7.65,6259.64,13.91,13555.09,7.33}
,{155,69,-56625.913,9.925,8088.375,0.064,-6123.305,19.341,154.939209578,10.654,0,21.6,"",0.2,"",5.5,-1,"","",{"B+","A"},{0,0.89,0},{"=","="},{0,0.89,0},18795.22,15.54,6191.75,11.06,4571.91,5.44,-14080.87,21.62,724.43,12.83,-14765.15,19.89,10270.1,17.44,1309.86,10.75,-32698,300,14553.5,13.55,8738.52,13.27,12625.26,15.97}
,{155,70,-50502.608,16.6,8043.823,0.107,-7957.561,25.416,154.945783217,17.82,0,1.793,"",0.019,"",3.5,-1,"","",{"A","B+"},{0,11,0},{"=","="},{0,11,0},19437,196,4611.94,19.04,5338.76,2.07,-16333,299,4813.44,17.33,-18859,197,8641.84,23.96,3364.45,21.98,"","",14181.53,20.47,6081.72,56.52,15644.17,18.8}
,{155,71,-42545.047,19.246,7987.436,0.124,-8375,299,154.954326011,20.661,0,0.0686,"",0.0016,"",5.5,-1,"","",{"A"},{0},{"="},{0},20314.84,151.26,3149.66,22.66,5802.79,2.57,-18617,301,4593.11,16.32,-17946,301,10901,197,-98.07,8.47,"","",15374,197,8589.39,150.94,14821.63,57.35}
,{155,72,-34170,298,7928,2,-10242,423,154.963317,320,0,0.84,"",0.03,"",3.5,-1,"","",{"B+"},{0},{"~"},{0},23012,423,1540,357,4947,423,"","",8473,299,"","",9571,423,1744,357,"","",14914,334,4116,357,17747,334}
,{155,73,-23928,300,7857,2,"","",154.974312,322,0,0.0032,"",0.0013,"",5.5,-1,"","",{"p"},{0},{"="},{0},"","",133,336,3755,424,"","",8498,359,"","","","",-1453,15,"","",14083,424,"","",15140,358}
,{156,57,-33050,400,7997,3,11769,500,155.964519,429,0,0.084,"",0.078,"",0,0,"","",{"B-"},{0},{"="},{0},7663,500,"","",-6545,640,18517,447,"","",6658,500,3191,565,"","",31113,400,10481,640,8284,565,"",""}
,{156,58,-44820,300,8068,2,6748,361,155.951884,322,0,0.233,"",0.009,"",0,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},8743,361,26577,583,-5534,500,15654,361,"","",2524,300,5111,424,14178,500,24541,300,7421,424,6104,424,-2704,500}
,{156,59,-51568,200,8106,1,8906,283,155.94464,215,0,0.444,"",0.006,"",0,0,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9605,230,24616,361,-4702,361,12596,200,-20926,447,2645,200,4224,201,11076,361,18515,200,11363,283,8206,283,138,361}
,{156,60,-60473.644,200.033,8158.066,1.282,3690,200,155.935078868,214.744,0,5.06,"",0.13,"",0,1,"","",{"B-"},{0},{"="},{0},10791.3,206.84,22832,283,-3918,283,8886.79,200.22,-19983,361,-1605.03,200.09,6261.24,200.24,12347.35,200.77,12061.27,200.04,8342.14,229.75,5958.87,200.39,82,283}
,{156,61,-64163.644,3.631,8176.705,0.023,5196.786,9.285,155.93111749,3.897,0,27.2,"",0.5,"",4,1,"","",{"B-"},{0},{"="},{0},11794.3,46.47,20636.61,113.07,-2830.5,18.89,5918.9,5.1,-16037.35,17.57,-2044.14,3.92,5295.03,5.92,9168.89,9.82,5927.15,5.27,12372.14,52.77,8030.71,4.5,3051.22,12.42}
,{156,62,-69360.43,8.546,8205.003,0.055,722.118,7.902,155.925538511,9.174,0,33840,"",720,"",0,1,"","",{"B-"},{0},{"="},{0},13047.89,8.5,18113.4,53.3,-1635.94,25.88,3174.48,8.47,-14365.68,12.52,-5613.66,8.47,7240.93,8.5,9709.47,9.76,1168.53,8.47,9862.35,47.08,6151.45,12.42,3616.27,8.98}
,{156,63,-70082.548,3.59,8204.617,0.023,2452.366,3.409,155.924763285,3.853,0,1312416,"",6912,"",0,1,"","",{"B-"},{0},{"="},{0},14487.06,3.37,16148.51,46.44,-1253.28,26.11,8.25,5.01,-10431.59,5.93,-6083.99,3.41,6335.77,3.39,7180.7,3.51,-4603.58,60.1,13083.43,3.5,7341.19,3.41,6211.68,9.7}
,{156,64,-72534.914,1.19,8215.322,0.008,-2444.117,3.679,155.922130562,1.277,1,"s","","s","",0,1,"","",{},{},{},{},14971.59,0.19,14657.68,0.88,-197.23,0.33,-2005.95,0.1,-9633.07,0.92,-9356.18,9.79,8536.35,0.07,8005.79,0.87,-8323.2,24.66,9914.01,0.78,5696.36,0.75,5671.17,0.36}
,{156,65,-70090.797,3.814,8194.639,0.024,438.167,3.681,155.92475443,4.094,0,462240,"",8640,"",3,-1,"","",{"B+"},{0},{"~"},{0},16077.13,45.45,12930.62,3.76,372.54,3.75,-4611.83,60.11,-5561.68,3.78,-9006.56,10.28,6912.06,10.46,5309.89,3.68,-13256.25,14.77,14325.96,3.68,7655.81,3.69,8922.83,3.75}
,{156,66,-70528.964,1.194,8192.433,0.008,-5050,60,155.924284038,1.281,1,"s","","s","",0,1,"","",{},{},{},{},16277.69,7.42,11400.95,0.22,1753.04,0.3,-6317.26,24.66,-5748.05,0.12,-12560.74,17.47,9444.73,9.6,6567.89,9.79,-17263.24,9.37,10338.14,45.3,5648.43,3.85,7999.99,0.27}
,{156,67,-65478.964,60.012,8155.046,0.385,-1267.255,64.869,155.929705436,64.425,0,3360,"",60,"",4,-1,"","",{"B+"},{0},{"="},{0},16982.29,60.56,9900.6,75.18,2813.04,72.11,-8644.41,61.68,-1517.89,60.79,-11341.09,60.3,7510.74,62.49,3612.39,60.76,-21779.42,80.81,15625.75,60.46,8528.03,60.13,11480.77,60.12}
,{156,68,-64211.709,24.629,8141.908,0.158,-7377.159,26.71,155.93106589,26.44,0,1170,"",60,"",0,1,"","",{"B+","A"},{0,17,0},{"=","="},{0,17,0},17749.32,25.13,8395.74,25.73,3481.25,25.06,-10945.99,25.72,-2345.13,26.46,-15657.11,26.55,10073.84,25.37,5461.14,30.2,-26394.81,151.77,11138.41,25.96,5664.45,25.14,10577.64,24.96}
,{156,69,-56834.55,14.279,8089.603,0.092,-3568.83,12.548,155.938985597,15.328,0,83.8,"",1.8,"",2,-1,"","",{"B+","A"},{0,0.064,0},{"~","="},{0,0.064,0},18550.05,20.28,6773.18,16.46,4345.31,7.2,-13135.01,55.97,1916.02,22.56,-14403.26,21.9,8279.95,17.38,1914.33,15.5,-30973,298,16481.28,15.1,8498.11,16.65,13823.95,15.11}
,{156,70,-53265.721,9.308,8061.711,0.06,-9566.176,54.916,155.942816893,9.992,0,26.1,"",0.7,"",0,1,"","",{"B+","A"},{0,10,0},{"=","="},{0,10,0},19476.27,19.63,5238.64,10.53,4809.74,3.54,-15448.82,150.05,1654.5,11.1,-18791.99,21.38,10834.43,19.03,3928.78,13.6,"","",11872.22,17.15,5571.66,12.37,12849.29,12.5}
,{156,71,-43699.544,54.122,7995.374,0.347,-5882.648,139.709,155.953086606,58.102,0,0.494,"",0.012,"",0,0,"","",{"A","B+"},{"",5,0},{"","="},{"",5,0},20127,203,3850.35,56.01,5595.81,3.21,-17838,303,5637.4,55.02,-17601,303,9225.81,57.44,485.91,56.61,"","",16943.34,56.81,8373,203,15920.19,55.43}
,{156,72,-37816.896,149.757,7952.65,0.96,-11956,334,155.959401889,160.77,0,0.023,"",0.001,"",0,1,"","",{"A"},{0},{"="},{0},21289,335,2462.75,150.75,6028.57,3.81,"","",5396.74,150.67,-21960,336,11718,334,2560.82,150.99,"","",12609,247,5420,9.12,15038,246}
,{156,73,-25861,298,7871,2,"","",155.972237,320,0,0.106,"",0.004,"",2,-1,"","",{"p","B+"},{0,29,0},{"=","="},{0,29,0},"","",724,357,5136,357,"","",9395,299,"","",10004,423,-1019.8,4.27,"","",17520,423,6303,423,18158,334}
,{157,58,-39930,400,8037,3,8610,500,156.957133,429,0,0.175,"",0.041,"",3.5,1,"","",{"B-","B-n"},{0,2,0},{"=","="},{0,2,0},8293,500,"","",-5885,565,16531,400,"","",3566,447,3182,500,14169,565,26747,400,8711,565,6463,500,-1464,640}
,{157,59,-48540,300,8086,2,7921,301,156.94789,322,0,0.307,"",0.021,"",2.5,-1,"","",{"B-","B-n"},{0,6,0},{"=","="},{0,6,0},9268,300,25188,500,-4905,424,13757,300,-22779,500,3862,361,5044,361,11009,424,20919,300,9951,424,8543,361,-1364,424}
,{157,60,-56461.543,24.918,8131.959,0.159,5835.5,25.877,156.939386037,26.75,0,1.15,"",0.03,"",2.5,-1,"","",{"B-"},{0},{"="},{0},10320.45,26.54,23259,301,-3977,202,10216.03,25.3,-18931,301,-369.22,25.17,4059.22,201.58,12183,202,14361.93,24.95,9664.53,30.27,6507.49,115.72,1404,202}
,{157,61,-62297.043,7.006,8164.145,0.045,4380.534,8.265,156.93312137,7.521,0,10.56,"",0.1,"",2.5,-1,"","",{"B-"},{0},{"="},{0},11499.75,8.42,21459.72,18.56,-3153.5,13.79,7161.86,8.19,-18019,200,-1007.93,11.05,6204.72,7.86,9112.37,200.15,8466.39,7.11,10697.49,11.51,8391.99,53.11,1454.34,113.23}
,{157,62,-66677.577,4.433,8187.063,0.028,2781.331,6.136,156.928418673,4.759,0,481.8,"",4.2,"",1.5,-1,"","",{"B-"},{0},{"="},{0},12629.39,4.68,18971.79,10.15,-1772.2,5.17,4145.9,4.59,-13492.9,200.08,-4666.35,5.7,5388.46,9.63,9802.9,5.69,2746.98,6.82,10973.16,6.44,6698.45,46.54,4793.8,52.83}
,{157,63,-69458.908,4.259,8199.795,0.027,1364.565,4.203,156.925432791,4.572,0,54648,"",108,"",2.5,1,"","",{"B-"},{0},{"="},{0},13783.45,4.16,17096.92,6.35,-1236,9.98,1304.52,4.21,-12584.23,5.58,-4995.31,4.21,7447.68,5.35,7387.45,9.43,-2626.08,23.85,11442.72,4.29,7860.32,4.28,4699.47,46.5}
,{157,64,-70823.473,1.189,8203.504,0.008,-60.043,0.297,156.92396787,1.276,1,"s","","s","",1.5,-1,"","",{},{},{},{},14896.23,0.16,15210.59,0.93,-688.7,0.39,-1398.92,5.13,-8752.01,8.47,-8803.99,3.68,6359.88,0.15,8029.9,3.41,-7409.83,26.53,11705.43,0.88,5778.7,0.79,7278.1,0.89}
,{157,65,-70763.43,1.222,8198.138,0.008,-1338.872,5.134,156.924032328,1.311,0,2240541746,"",220898482,"",1.5,1,"","",{"EC"},{0},{"="},{0},15656.01,9.79,13523.28,0.93,178.88,0.82,-3930.6,23.49,-7969.85,3.42,-8305.78,0.35,8743.95,3.69,5517.49,0.33,-12054.16,27.97,12017.26,0.34,7806.58,0.38,6621.09,0.84}
,{157,66,-69424.558,5.177,8184.627,0.033,-2591.725,23.787,156.925469667,5.557,0,29304,"",144,"",1.5,-1,"","",{"B+"},{0},{"="},{0},16411.64,10.88,11932.62,5.13,1033.08,5.13,-6010.92,26.98,-4178.61,5.13,-12016.91,60.22,6966.91,5.13,6622.73,6.29,-16002.66,12.04,12536.3,11.05,5595.8,45.59,9927.8,5.13}
,{157,67,-66832.832,23.469,8163.136,0.149,-3419.194,33.668,156.928251999,25.195,0,756,"",12,"",3.5,-1,"","",{"B+"},{0},{"="},{0},16935.93,29.26,10160.72,25.44,2055.59,23.8,-8123.56,36.49,-4031.01,23.77,-10692.44,34.02,9425.19,64.43,3592.84,23.49,-20392.31,26.39,13033.52,25.37,8425.13,24.62,8969.87,51.03}
,{157,68,-63413.639,26.505,8136.375,0.169,-4704.366,38.515,156.931922655,28.454,0,1119,"",6,"",1.5,-1,"","",{"B+"},{0},{"="},{0},17347.08,27.2,8836.03,28.21,3304.39,26.81,-9991.74,28.67,-173.64,26.53,-14650.41,30.11,7273.25,36.18,5223.64,65.6,-24510,197,13336.71,31.75,6089.73,27.75,12626.67,27.53}
,{157,69,-58709.273,27.945,8101.428,0.178,-5287.374,30.003,156.936973,30,0,217.8,"",5.4,"",0.5,1,"","",{"B+"},{0},{"="},{0},18225.99,29.65,7247.67,32.96,3877.91,28.41,-12268.75,30.44,-519.28,66.2,-13514.87,29.45,9946.04,31.38,1786.53,37.25,-29115.94,152.65,14210.72,28.6,8759.8,28.39,11576.44,29.13}
,{157,70,-53421.898,10.92,8062.767,0.07,-6981.376,14.241,156.94264923,11.723,0,38.6,"",1,"",3.5,-1,"","",{"B+","A"},{0,0.5,0},{"=","="},{0,0.5,0},19061.92,19.87,5790.65,12.35,4621.79,5.85,-14519,196,3500.84,26.88,-17793.67,55.21,8227.49,13.74,3876.32,17.6,-33952,400,13914.82,14.69,5869.29,18.05,14829.52,11.84}
,{157,71,-46440.523,12.078,8013.317,0.077,-7537,196,156.950144045,12.965,0,6.8,"",1.8,"",0.5,1,"","",{"A"},{""},{""},{""},20038.11,22.71,4392.55,15.61,5107.89,2.85,-16847.19,150.55,3105.06,17.03,-16694.94,150.24,10812.3,55.45,463.77,12.44,"","",14772.89,20.53,8355.62,21.08,13633.01,18.79}
,{157,72,-38903,196,7960,1,-9310,247,156.958236,210,0,0.115,"",0.001,"",3.5,-1,"","",{"A","B+"},{0,14,0},{"=","="},{0,14,0},20876,357,2979,196,5880.01,3.06,-19433,445,7074,196,-21113,357,9158,246,2493,203,"","",14353,197,5675.95,13.62,16675,196}
,{157,73,-29593.33,150.069,7896.043,0.956,-10123,427,156.968230251,161.105,0,0.0101,"",0.0004,"",0.5,1,"","",{"A","p","B+"},{"",3.4,0,1,0},{"","=","="},{"",3.4,0,1,0},21808,336,1626.22,151.3,6354.6,6.29,"","",6817.24,140.04,"","",11803,334,-934.6,9.67,"","",15287,334,7941,335,15768,247}
,{157,74,-19470,400,7827,3,"","",156.979098,429,0,0.275,"",0.04,"",3.5,-1,"","",{"B+","A"},{0,0,0},{"=","="},{0,0,0},"","",-122,499,5405,500,"","",11058,427,"","","","",898,499,"","",15169,500,"","",18847,500}
,{158,58,-36660,400,8016,3,7670,500,157.960644,429,0,0.099,"",0.093,"",0,1,"","",{"B-"},{0},{"="},{0},7983,500,"","",-6265,640,17395,447,"","",3809,500,4801,565,"","",28590,400,7101,565,6135,565,"",""}
,{158,59,-44330,300,8060,2,9725,361,157.95241,322,0,0.181,"",0.014,"",0,0,"","",{"B-","B-n"},{0,10,0},{"=","="},{0,10,0},8905,361,25857,500,-5225,424,14759,300,"","",4060,301,3861,424,11688,500,22925,300,11201,424,8314,424,-753,500}
,{158,60,-54055,200,8116,1,5035,201,157.94197,215,0,0.81,"",0.03,"",0,1,"","",{"B-"},{0},{"="},{0},9724,283,23813,361,-4260,283,11196,200,-21413,447,171,200,5664,202,12803,361,16635,200,8224,283,6225,201,-628,361}
,{158,61,-59089.209,13.453,8143.254,0.085,6161.034,14.299,157.936565121,14.442,0,4.8,"",0.5,"",0,0,"","",{"B-"},{0},{"="},{0},11068.2,13.92,22100,201,-3409.15,113.81,8165.98,16.9,-17838,300,-482.95,14.15,4863.48,15.15,9916.64,28.31,10381.46,13.53,12095.24,200.48,8058.57,16.26,1972.46,21.83}
,{158,62,-65250.243,4.892,8177.297,0.031,2004.945,10.369,157.929950979,5.251,0,318,"",1.8,"",0,1,"","",{"B-"},{0},{"="},{0},12032.45,9.85,19354.54,200.09,-1850.18,52.87,5439.3,5.03,-16077.67,25.39,-3862.65,6.47,6643.98,6.57,10242.17,8.52,5157.11,5.43,9624.21,6.05,6553.74,6.76,2679.88,10.36}
,{158,63,-67255.188,10.255,8185.035,0.065,3434.358,10.323,157.927798581,11.008,0,2754,"",12,"",1,-1,"","",{"B-"},{0},{"="},{0},13315.27,10.86,17669.48,10.86,-1168.13,47.45,2215.48,10.35,-12247.12,12.4,-4503.03,10.32,5867.6,11.1,7866.58,11.15,-1067.59,28.98,12816.05,13.35,7799.69,10.36,5331.14,11.27}
,{158,64,-70689.546,1.189,8201.819,0.008,-1218.878,0.987,157.924111646,1.276,1,"s","","s","",0,1,"","",{},{},{},{},14297.27,0.16,15907.06,8.47,-659.29,0.9,-282.2,2.43,-11300.94,4.59,-7997.43,0.3,7937.39,0.06,8519.61,4.2,-5385.74,25.25,10103.81,3.41,5992.6,0.89,5147.67,0.94}
,{158,65,-69470.668,1.401,8189.153,0.009,936.681,2.495,157.925420166,1.503,0,5680246680,"",347126186,"",3,-1,"","",{"B+","B-"},{0,16.6,0},{"=","="},{0,16.6,0},15522.51,3.66,13966.06,3.55,-157.46,1.25,-3283.07,27.12,-7300.73,4.3,-8117.43,5.19,6778.55,1.02,5936.17,0.99,-10767.47,25.26,13775.05,1,7463.27,1,7993.83,1.31}
,{158,66,-70407.349,2.365,8190.13,0.015,-4219.755,27.005,157.924414597,2.538,1,"s","","s","",0,1,"","",{},{},{},{},16021.02,2.44,12450.38,2.43,873.69,2.44,-5103.54,25.33,-6872.85,2.43,-11645.83,23.56,9054.11,5.13,6932.89,2.45,-14397.11,8.3,10394.25,4.35,5706.76,10.08,7308.93,2.43}
,{158,67,-66187.593,27.108,8158.471,0.172,-883.785,37.025,157.928944692,29.101,0,678,"",24,"",5,1,"","",{"B+"},{0},{"~"},{0},16851.26,65.84,10674.74,27.35,1543.79,52.79,-7484.4,37.03,-2713.13,27.12,-10845.27,37.91,7426.08,35.84,4052.01,27.49,-18975.4,31.04,15052.18,27.11,7832.01,28.76,10708.86,28.82}
,{158,68,-65303.808,25.219,8147.926,0.16,-6600.615,31.341,157.929893474,27.074,0,8244,"",216,"",0,1,"","",{"EC"},{0},{"="},{0},17234.73,35.25,9352.79,25.25,2665.18,26.3,-9293.57,26.46,-3168.22,25.75,-14665.85,37.64,9961.49,36.59,5759.95,34.45,-23201.42,30.69,10885.96,65.1,5599.79,30.68,9498.14,27.01}
,{158,69,-58703.194,25.219,8101.199,0.16,-2692.957,26.456,157.936979525,27.074,0,238.8,"",3.6,"",2,-1,"","",{"B+"},{0},{"="},{0},18011.28,28.98,7802.17,65.1,3511.2,26.53,-11491,29.41,840.67,34.45,-13352.61,27.48,8065.24,37.64,2578.53,36.59,-27537,198,16219.32,35.25,8370.05,25.95,12982.75,30.68}
,{158,70,-56010.237,7.994,8079.203,0.051,-8798.047,16.872,157.939870534,8.582,0,89.4,"",7.8,"",0,1,"","",{"B+","A"},{0,0.0021,0},{"~","~"},{0,0.0021,0},18887.15,12.25,6376.47,25.89,4169.87,7.04,-13907.85,19.07,114.43,27.68,-17641.03,14.43,10659.66,13.38,4589.94,29.07,-32378,300,11535.12,16.34,5479.73,12.49,11845.35,9.85}
,{158,71,-47212.19,15.125,8018.568,0.096,-5109.8,14.937,157.949315626,16.237,0,10.6,"",0.3,"",2,-1,"","",{"B+","A"},{0,0.91,0},{"=","="},{0,0.91,0},19655.28,56.2,4955.58,20.8,4790.03,4.59,-16046,197,4208.11,31.78,-16380,196,8842.98,19.35,1079.26,18.63,"","",16764.34,17.76,8154.47,22.46,15060.13,18.03}
,{158,72,-42102.39,17.494,7981.276,0.111,-10936,197,157.954801222,18.78,0,0.99,"",0.03,"",0,1,"","",{"B+","A"},{0,44.3,0},{"=","="},{0,44.3,0},20428.13,150.78,3414.61,19.81,5404.78,2.72,-18470,300,4030.54,20.6,-20580.38,151.09,11271,196,2950.84,21.25,"","",12307.96,56.88,5306.71,8.02,14046.62,24.12}
,{158,73,-31167,196,7907,1,-7534,358,157.966541,210,0,0.049,"",0.008,"",2,-1,"","",{"A"},{0},{"="},{0},21448,357,2045,203,6123.6,4.35,"","",7985,196,-19768,445,9645,247,-447.65,12.9,"","",17361,247,7867,357,17025,197}
,{158,74,-23633,300,7854,2,"","",157.974629,322,0,0.00125,"",0.00021,"",0,1,"","",{"A"},{0},{"="},{0},"","",394,335,6612.73,3.08,"","",7982,358,"","",12234,500,1328,335,"","",12939,423,5159.73,15.31,16184,423}
,{159,59,-41088,400,8039,3,8719,500,158.95589,429,0,0.134,"",0.043,"",2.5,-1,"","",{"B-","B-n"},{0,30,0},{"=","="},{0,30,0},8691,500,"","",-5583,565,15466,400,"","",4895,447,4830,500,11717,565,24955,400,9553,565,8596,500,-2391,565}
,{159,60,-49807,300,8089,2,6747,300,158.94653,322,0,0.5,"",0.03,"",3.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9488,301,24455,500,-4452,424,12401,300,-20436,500,1211,300,3824,361,12766,424,18754,300,9444,424,6625,361,659,424}
,{159,61,-56554.28,10.039,8126.859,0.063,5653.495,11.644,158.939286479,10.777,0,1.49,"",0.13,"",2.5,-1,"","",{"B-"},{0},{"="},{0},10399.87,12.23,22592,300,-3563.93,19.9,9489.01,10.92,-19513,300,624.65,11.15,5536.39,16.77,9789,201,12978.08,10.12,10618.07,26.86,8783.42,200.28,660,201}
,{159,62,-62207.775,5.934,8157.495,0.037,3835.51,7.324,158.933217202,6.369,0,11.37,"",0.15,"",2.5,-1,"","",{"B-"},{0},{"="},{0},11672.83,7.38,20324.17,25.61,-2348.97,10.89,6353.66,6.05,-15442,200,-3023.9,11.83,5028.85,7.66,10407.54,14.69,6959.36,6.13,10800.07,9.16,6819.92,6.92,3912.27,200.12}
,{159,63,-66043.285,4.325,8176.697,0.027,2518.15,4.391,158.929099612,4.643,0,1086,"",6,"",2.5,1,"","",{"B-"},{0},{"="},{0},12727.01,4.2,18324.18,8.22,-1528.27,6.38,3489.08,4.42,-14243.05,14.12,-3425.06,4.39,6859.41,11.12,8082.01,6.51,1286.25,5.26,11345.1,6.17,8181.2,9.52,3766.76,5.62}
,{159,64,-68561.436,1.192,8187.614,0.007,970.927,0.759,158.926396267,1.279,0,66524.4,"",14.4,"",1.5,-1,"","",{"B-"},{0},{"="},{0},13880.6,0.11,16461.8,4.59,-795.53,0.94,605.7,1.32,-10600.16,5.03,-7162.09,0.99,5943.21,0.08,8595.22,10.32,-4000.4,3.6,11608.28,4.2,6385.17,3.41,6445.4,8.47}
,{159,65,-69532.363,1.256,8188.8,0.008,-365.229,1.162,158.925353933,1.348,1,"s","","s","",1.5,1,"","",{},{},{},{},14911.57,0.8,14651.4,4.26,-139.19,1.15,-2202.83,2.92,-9566.15,10.33,-7196.33,2.44,8133.01,0.64,6131.79,0.76,-8961.97,27.97,12001.92,0.76,7866.61,0.77,6196.59,3.49}
,{159,66,-69167.134,1.528,8181.583,0.01,-1837.6,2.683,158.925746023,1.64,0,12476160,"",17280,"",1.5,-1,"","",{"EC"},{0},{"="},{0},15885.21,5.25,12921.6,1.32,477.83,1.33,-4606.1,3.35,-5766.56,1.32,-11050.86,27.13,6831.1,2.6,6985.44,1.32,-13328.53,17.82,12307.1,1.35,5787.72,3.79,9014.18,1.33}
,{159,67,-67329.534,3.088,8165.105,0.019,-2768.5,2,158.927718768,3.314,0,1983,"",6.6,"",3.5,-1,"","",{"B+"},{0},{"="},{0},16639.34,23.66,11144.05,3,1495.6,10.23,-6759.14,28.11,-5147.84,2.99,-10097.04,25.41,9213.26,27.26,4211.16,3.73,-17620.93,37.79,12805.83,5.9,8063.49,3,8407.66,4.64}
,{159,68,-64561.034,3.679,8142.773,0.023,-3990.637,28.186,158.930690875,3.949,0,2160,"",60,"",1.5,-1,"","",{"B+"},{0},{"="},{0},17290.03,26.76,9714.42,6.23,2169.6,10.25,-8722.43,18.13,-1442.66,4.24,-13929.16,25.49,7328.54,25.49,5662.41,27.33,-21708.43,17.21,12982.6,23.75,5781.99,60.11,11614.33,3.6}
,{159,69,-60570.398,27.945,8112.754,0.176,-4731.792,33.129,158.934975,30,0,547.8,"",9.6,"",2.5,1,"","",{"B+"},{0},{"="},{0},18003.76,39.52,8315.51,36.49,3044.23,32.96,-10861.79,46.9,-1671.77,38.93,-12631.48,29.07,9938.52,37.64,2555.56,37.64,-26131.25,34.18,13554.05,38.52,8505.37,37.25,10554.97,66.2}
,{159,70,-55838.606,17.794,8078.074,0.112,-6130.002,41.655,158.940054787,19.102,0,100.2,"",5.4,"",0,0,"","",{"B+"},{0},{"="},{0},18559.34,20.63,7002.91,31.92,3945.67,18.68,-12986.01,24.48,2176.23,30.87,-16697.73,23.32,7899.69,19.33,4424.38,30.87,-30544,299,13581.47,33.13,5860,22.79,14019.51,30.38}
,{159,71,-49708.604,37.663,8034.6,0.237,-6856.004,41.246,158.946635615,40.433,0,12.1,"",1,"",0.5,1,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},19410.72,39.55,5577.27,46.9,4492.39,38.95,-15269.46,42.5,1705.62,45.33,-15677.53,41.53,10567.73,40.59,987.34,38.5,-34964,307,14424.1,39.21,8421.17,38.8,12772.35,40.28}
,{159,72,-42852.6,16.813,7986.56,0.106,-8413.452,25.891,158.953995838,18.049,0,5.2,"",0.1,"",3.5,-1,"","",{"B+","A"},{0,35,0},{"=","="},{0,35,0},20092,196,4008.64,20.05,5225.09,2.67,-17558,299,5868.67,18.62,-19757,197,8821.53,24.26,2929.38,22.62,"","",14298.73,20.7,5711,56.67,16059.52,19.22}
,{159,73,-34439.148,19.689,7928.725,0.124,-9145,299,158.963028052,21.137,0,1.04,"",0.09,"",0.5,1,"","",{"A"},{0},{"="},{0},20988.45,151.36,2576.57,23.09,5680.98,6.07,-19694,305,5484.07,17.46,-18878,301,11344,197,-374.27,9.04,"","",15175,197,8241.8,151.05,14906.8,57.59}
,{159,74,-25295,298,7866,2,-10550,426,158.972845,320,0,0.0082,"",0.0007,"",3.5,-1,"","",{"A"},{""},{"="},{""},21967,499,969,357,6450.48,3.94,"","",9519,299,"","",9733,423,1417,357,"","",15010,334,5430.69,5.81,18169,334}
,{159,75,-14745,305,7795,2,"","",158.984171,327,0,4e-05,"","s","",0.5,1,"","",{},{},{},{},"","",-271,340,6759,55,"","",9133,362,"","","","",-1599,53,"","",15436,502,"","",16763,426}
,{160,59,-36520,400,8011,2,10613,500,159.960794,429,0,0.17,"",0.14,"",0,0,"","",{"B-"},{0},{"="},{0},8333,500,"","",-5895,565,16482,447,"","",5216,500,3503,565,"","",26960,400,10851,565,8274,565,"",""}
,{160,60,-47134,300,8073,2,5868,361,159.9494,322,0,0.439,"",0.037,"",0,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9222,361,25052,500,-4739,424,13101,300,"","",1349,300,5398,424,13334,500,20808,300,7907,424,6271,424,-1557,500}
,{160,61,-53002,200,8104,1,7233,200,159.9431,215,0,0.725,"",0.057,"",0,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10055,201,23250,361,-3859,283,10478,200,-19203,447,1134,200,4519,201,10484,361,14834,200,11763,283,8324,202,1185,361}
,{160,62,-60234.793,5.934,8144.625,0.037,3245.67,11.183,159.935335286,6.37,0,9.6,"",0.3,"",0,1,"","",{"B-"},{0},{"="},{0},11127.18,7.66,20758,200,-2186.06,200.12,7706.95,6.07,-17717,300,-2262.82,7.32,6098.33,8.37,10969.48,11.64,9437.94,5.98,9565.22,14.69,6926.31,9.16,1873.15,25.61}
,{160,63,-63480.463,9.501,8160.021,0.059,4461.278,9.586,159.931850916,10.199,0,42.4,"",0.2,"",5,-1,"","",{"B-"},{0},{"="},{0},12367.91,13.96,18969.19,16.46,-1741.73,10.15,4355.79,9.58,-14215.15,13.81,-2990.34,9.58,5508.49,10.43,8561.66,11.18,2902.27,17.77,12480.59,10.67,8061.17,10.46,4462.98,11.79}
,{160,64,-67941.741,1.278,8183.014,0.008,-105.483,1.022,159.927061537,1.371,1,"s","","s","",0,1,"","",{},{},{},{},13394.83,0.73,17269.44,5.05,-1006.23,8.5,1730.99,1.19,-13022.94,6.07,-6480.69,1.02,7451.62,0.74,9187.43,4.38,-1877.51,24.29,10024.25,10.33,6381.22,4.29,4382.24,4.61}
,{160,65,-67836.257,1.262,8177.465,0.008,1836.472,1.172,159.927174778,1.354,0,6246720,"",17280,"",3,-1,"","",{"B-"},{0},{"="},{0},14508.22,0.65,15159.01,10.33,-178.62,3.49,-1453.53,15.05,-9081.94,4.42,-6740.44,1.17,6375.21,0.13,6563.79,0.77,-7534.23,34.29,13564.1,0.77,7851.27,0.77,7269.05,4.26}
,{160,66,-69672.73,0.772,8184.054,0.005,-3290,15,159.925203244,0.828,1,"s","","s","",0,1,"","",{},{},{},{},15408.02,2.25,13561.12,1.12,437.27,1.12,-3608.5,24.27,-8400.26,1.12,-10414.51,3.04,8576.91,1.42,7429.34,1.17,-11510.02,7.27,10508.74,1.32,5954.76,1.15,6797.14,1.12}
,{160,67,-66382.73,15.02,8158.602,0.094,-318.502,28.528,159.928735204,16.124,0,1536,"",18,"",5,1,"","",{"B+"},{0},{"="},{0},16337.77,30.97,11490,15.06,1283.15,15.47,-6080.7,37.41,-4139.34,15.05,-9893.01,15.43,7124.51,15.3,4504.57,15.07,-16112.79,58.77,14735.43,15.17,7905.88,15.86,10027.1,15.04}
,{160,68,-66064.228,24.254,8151.721,0.152,-5762.2,40.311,159.92907713,26.037,0,102888,"",324,"",0,1,"","",{"EC"},{0},{"="},{0},16903.05,34.99,10234.82,24.37,2039.82,24.28,-7901.52,25.31,-4186.06,24.3,-13565.15,37,9574.51,24.53,6023.66,24.45,-20125.28,26.06,10834.17,36.37,5632.66,33.75,9006.73,24.8}
,{160,69,-60302.028,34.262,8110.818,0.214,-2139.322,35.017,159.935263106,36.781,0,564,"",18,"",1,-1,"","",{"B+"},{0},{"="},{0},17741.47,42.54,8692.38,43.69,2752.02,69.1,-10032.09,66.35,-261.46,34.4,-12534.74,38.61,7802.95,44.21,3029.96,34.46,-24478.33,64.22,15712.59,42.54,7975.67,43.32,12177.21,41.53}
,{160,70,-58162.706,7.233,8092.557,0.045,-7892.769,57.28,159.937559763,7.764,0,288,"",12,"",0,1,"","",{"B+"},{0},{"="},{0},18295.1,10.73,7436.84,26.24,3624.09,25.67,-12223.76,11.96,-890.64,8.1,-16525.42,38.35,10395.42,19.11,4881.28,28.87,-28836.25,150,11251.29,26.24,5410.62,28.87,10897.33,27.47}
,{160,71,-50269.937,56.821,8038.338,0.355,-4330.994,57.617,159.946033,61,0,36.1,"",0.3,"",2,-1,"","",{"B+","A"},{0,1,0},{"=","<"},{0,1,0},19200.38,58.8,6144.68,62.17,4139.7,58.59,-14446.24,78.61,3011.49,63.32,-15488.65,59.26,8632.65,68.17,1720.3,59.54,-33531,304,16451.11,57.38,8016.02,57.86,14085.74,63.32}
,{160,72,-45938.943,9.541,8006.38,0.06,-10115.249,55.147,159.950682513,10.242,0,13.6,"",0.2,"",0,1,"","",{"B+","A"},{0,0.7,0},{"=","="},{0,0.7,0},19979.19,19.92,4506.65,12.42,4901.86,2.59,-16612.49,150.13,2610.69,20.16,-19571.11,21.88,11157.66,19.33,3519.31,38.85,"","",11984.05,17.88,5365.63,12.41,13129.36,13.85}
,{160,73,-35823.695,54.316,7938.27,0.339,-6497.24,139.859,159.961541679,58.31,0,1.7,"",0.2,"",2,-1,"","",{"A"},{""},{""},{""},20800,203,3189.45,56.38,5450.93,4.59,-19085,303,6595.94,66.1,-18600,303,9455.86,57.77,260.06,56.86,"","",16989.5,57.06,7944,203,16263.23,55.64}
,{160,74,-29326.455,149.827,7892.772,0.936,-12588,334,159.968516753,160.846,0,0.09,"",0.005,"",0,1,"","",{"A"},{0},{"="},{0},21836,335,1802.01,150.85,6065.53,4.59,"","",6237.17,150.77,-22653,339,12103,334,2176.28,151.12,"","",12551,247,5130.93,8.52,15223,246}
,{160,75,-16739,298,7809,2,"","",159.98203,320,0,0.000611,"",7e-06,"",4,-1,"","",{"p","A"},{0,11,0},{"=","="},{0,11,0},"","",150,357,6697.75,4.1,"","",10412,299,"","",10065,426,-1267.07,7.11,"","",17605,423,7596,499,18501,334}
,{161,60,-42588,400,8044,2,7648,499,160.95428,429,0,0.215,"",0.076,"",0.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},8924,500,"","",-5082,565,14084,400,"","",2343,447,3526,500,13357,565,22918,400,9211,565,6606,500,-282,565}
,{161,61,-50235,298,8087,2,6436,298,160.94607,320,0,1.05,"",0.15,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9824,298,23725,499,-4120,423,11556,298,-21004,499,1928,298,5305,359,10391,423,17226,298,10282,423,8683,359,-259,423}
,{161,62,-56671.962,6.817,8122.041,0.042,5119.562,12.415,160.939160143,7.318,0,4.8,"",0.4,"",3.5,1,"","",{"B-"},{0},{"="},{0},10606.82,9.01,21443,300,-2635.33,25.82,8833.86,7.01,-16827,300,-1262.82,11.67,4508.49,9.01,10959,200,11383.84,6.86,10593.12,12.12,7281.3,15.07,3029,200}
,{161,63,-61791.524,10.399,8148.98,0.065,3714.299,10.525,160.933664066,11.164,0,26.2,"",2.3,"",2.5,1,"","",{"B-"},{0},{"="},{0},11890.87,11.25,19815.19,14.44,-1919.4,12.52,5670.06,10.49,-16078,201,-1921.1,10.48,6382.38,14.07,8845.7,11.95,5405.75,10.64,11127.06,11.95,8322.77,11.47,2944.09,16.99}
,{161,64,-65505.824,1.622,8167.191,0.01,1955.765,1.442,160.929676602,1.741,0,218.76,"",0.18,"",2.5,-1,"","",{"B-"},{0},{"="},{0},13087.02,1.24,17875.99,6.15,-1253.16,4.72,2549.98,1.55,-12560,6.15,-5740.88,1.43,5635.4,1,9314.33,9.64,-304.22,8.88,11248.27,4.5,6613.42,10.38,5390.82,5.15}
,{161,65,-67461.589,1.35,8174.479,0.008,594.212,1.26,160.927577001,1.449,0,595296,"",1728,"",1.5,1,"","",{"B-"},{0},{"="},{0},14071.86,0.56,15996.24,4.44,-427.6,4.3,-264.32,2.47,-11270.1,9.6,-5860.18,1.26,7696.65,0.55,6808.82,1.04,-5562.88,27.98,11810.65,0.95,8092.01,0.95,5440,10.34}
,{161,66,-68055.801,0.768,8173.31,0.005,-858.53,2.166,160.926939088,0.824,1,"s","","s","",2.5,1,"","",{},{},{},{},15031.3,1.42,14072.31,1.12,342.76,1.12,-2854.19,8.75,-7403.03,1.19,-9744.39,15,6454.39,0.08,7508.51,1.17,-10216.4,15.35,12187.37,1.17,6278.92,1.32,8280.15,1.12}
,{161,67,-67197.27,2.242,8163.119,0.014,-1995.663,9.011,160.927860759,2.406,0,8928,"",180,"",3.5,-1,"","",{"EC"},{0},{"="},{0},16010.37,3.71,12242.85,2.42,1141.24,2.44,-5298.56,28.03,-6649.98,2.43,-9204.36,24.36,8885.86,15.16,4813.51,2.16,-14634.93,28.03,12680.67,2.57,8074.13,3.12,7919.8,2.5}
,{161,68,-65201.608,8.78,8145.864,0.055,-3302.9,29.292,160.930003191,9.425,0,11556,"",108,"",1.5,-1,"","",{"B+"},{0},{"="},{0},16783.21,9.47,10612.41,8.86,1798.03,10.15,-7362.21,17.67,-2817.85,8.75,-12970.9,35.37,7208.7,25.79,6107.85,17.36,-18886.94,24.2,12838.73,9.26,5850.04,28.48,10852.14,9.03}
,{161,69,-61898.708,27.945,8120.49,0.174,-4059.308,31.885,160.933549,30,0,1812,"",48,"",3.5,1,"","",{"B+"},{0},{"="},{0},17470.94,39.52,9147.12,28.11,2509.21,36.49,-9336.36,39.52,-2804.95,31.73,-11807.32,28.87,9668,44.21,3123.45,37,-23119.71,37.09,13373.13,28.19,8269.16,37.64,9935.29,38.93}
,{161,70,-57839.4,15.354,8090.417,0.095,-5277.056,31.885,160.937906846,16.483,0,252,"",12,"",1.5,-1,"","",{"B+"},{0},{"="},{0},18143.43,22.98,7856.31,15.74,3149.32,30.63,-11524.73,27.24,935.86,28.71,-15640.78,58.86,7748.01,16.87,4826.34,37.54,-27284,196,13441.8,31.89,5727.85,29.53,13110.81,29.53}
,{161,71,-52562.344,27.945,8052.781,0.174,-6247.672,35.909,160.943572,30,0,77,"",2,"",0.5,1,"","",{"B+"},{0},{"="},{0},18996.37,46.9,6569.89,39.52,3722.01,39.52,-13783.35,37.09,450.71,44.21,-14694.72,29.53,10363.72,63.32,1688.61,28.87,-31722.14,152.5,13987.07,33.13,8311.95,29.07,11787.25,37.64}
,{161,72,-46314.672,22.551,8009.117,0.14,-7535.674,33.097,160.950279151,24.209,0,18.4,"",0.4,"",3.5,-1,"","",{"B+","A"},{0,0.13,0},{"~","<"},{0,0.13,0},19604.71,28.13,5054.01,28.69,4682.31,24.08,-15759,197,4559.06,23.68,-18562.29,58.81,8447.05,24.41,3333.71,61.13,-36335,400,14104.74,43.9,5761.57,27.15,15341.97,23.91}
,{161,73,-38778.997,24.382,7957.452,0.151,-8224,197,160.958369031,26.175,0,3,"","s","",0.5,1,"","",{},{},{},{},20482.48,31.34,3648.33,44.87,5236.61,23.84,-17938.79,151.89,4201.97,61.83,-17523.86,151.8,11026.62,59.54,129.02,23.39,"","",14784.41,29.62,8187.45,30.01,14079.59,28.69}
,{161,74,-30555,196,7902,1,-9715,247,160.967197,210,0,0.409,"",0.016,"",3.5,-1,"","",{"A","B+"},{0,27,0},{"=","="},{0,27,0},21403,357,2281,196,5922.88,3.63,-20576,445,8095,196,-21888,357,9300,246,2021,203,"","",14595,197,5475.23,12.38,17193,196}
,{161,75,-20840.203,149.922,7836.312,0.931,-10861,427,160.977627121,160.948,0,0.00044,"",1e-06,"",0.5,1,"","",{"p","A"},{0,1.4,0},{"~","<"},{0,1.4,0},22238,339,979,151.21,6328.21,6.69,"","",7694.52,139.96,"","",12173,334,-1197.28,5.34,"","",15165,334,7656,335,15973,247}
,{161,76,-9979,400,7764,2,"","",160.989287,429,0,0.00064,"",6e-05,"",3.5,-1,"","",{"A"},{0},{"~"},{0},"","",-737,499,7065.87,12.31,"","",12058,427,"","","","",530,499,"","",15476,503,"","",19300,500}
,{162,60,-39550,400,8026,2,6819,500,161.957541,429,0,0.31,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},8559,500,"","",-5315,565,14979,445,"","",2614,499,5034,565,"","",24730,400,7681,565,6402,565,"",""}
,{162,61,-46370,300,8063,2,8160,358,161.95022,322,0,0.63,"",0.18,"",6,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9510,361,24428,500,-4465,424,12334,302,"","",2231,300,4206,423,11071,500,19306,302,11475,424,8301,424,365,500}
,{162,62,-54530,196,8109,1,4174,199,161.94146,210,0,2.7,"",0.3,"",0,1,"","",{"B-"},{0},{"="},{0},10438,196,21974,358,-2900,280,9751,196,-19231,445,-809,196,5929,196,11583,357,13652,196,9183,280,6889,196,924,358}
,{162,63,-58703.401,35.229,8129.438,0.217,5577,35,161.936979303,37.819,0,11,"","s","",1,1,"","",{"B-"},{0},{"="},{0},11365.57,36.49,20279,203,-2039.11,37.71,6972.56,50.63,-15757,300,-1268.89,35.22,4983.19,36.73,9320.41,35.88,7338.14,35.36,12242.2,35.72,8368.43,35.72,3497.28,36.63}
,{162,64,-64280.401,4.009,8159.035,0.025,1395.556,36.581,161.930992146,4.303,0,504,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},12481.29,3.8,18623.55,7.16,-1455.07,6.32,3901.08,3.98,-14897.41,7.91,-4890.13,3.94,6845.89,3.93,9777.85,11.14,2054.12,3.99,9910.87,10.31,6626.94,5.8,3573.78,7.16}
,{162,65,-65675.958,36.372,8162.82,0.225,2505.521,36.364,161.929493955,39.046,0,456,"",9,"",1,-1,"","",{"B-"},{0},{"="},{0},13982.33,36.38,16773.44,37.59,-845.69,37.79,365.58,36.5,-11173.4,37.83,-5691.47,36.36,6285.69,36.39,7459.1,36.4,-4198.17,44.73,12976.59,36.38,7749.53,36.38,6013.73,36.62}
,{162,66,-68181.478,0.767,8173.457,0.005,-2139.937,3.113,161.926804168,0.822,1,"s","","s","",0,1,"","",{},{},{},{},14651.38,0.1,14817.68,1.19,83.15,1.12,-1846.96,0.3,-9964.63,1.55,-9055.52,2.17,8196.99,0.06,8008.86,1.26,-8355.13,15.36,10365.59,1.17,6214.94,1.17,6026.36,1.12}
,{162,67,-66041.541,3.166,8155.418,0.02,292.978,3.127,161.929101485,3.398,0,900,"",60,"",1,1,"","",{"B+"},{0},{"="},{0},15801.45,15.32,12783.23,3.3,1004.21,3.35,-4563.75,26.23,-5868.92,3.33,-8911.25,9.28,6915.59,3.61,5274.71,3.11,-13209.79,75.1,14341.99,3.11,7989.65,3.4,9137.22,3.3}
,{162,68,-66334.519,0.822,8152.397,0.005,-4856.728,26.047,161.92878696,0.882,1,"s","","s","",0,1,"","",{},{},{},{},16412.93,24.27,11239.73,0.31,1647.91,2.27,-6508.17,15.36,-5567.69,0.3,-12507.13,27.96,9204.23,8.74,6426.22,2.19,-17165.51,8.98,10759.02,15,5859.07,3.05,8479.02,1.45}
,{162,69,-61477.791,26.06,8117.588,0.161,-1651.444,30.24,161.934000872,27.977,0,1302,"",11.4,"",1,-1,"","",{"B+"},{0},{"="},{0},17318.4,43.05,9673,30.06,2284.89,37.59,-8646.04,79.43,-1569.49,26.14,-11709.71,30.24,7650.4,38.21,3565.15,27.48,-21697.6,58.38,15297.24,35.6,7947.3,26.3,11498.14,26.23}
,{162,70,-59826.347,15.359,8102.565,0.095,-6994.593,76.592,161.935773771,16.488,0,1132.2,"",11.4,"",0,1,"","",{"B+"},{0},{"="},{0},17806.28,16.87,8340.06,28.71,3052.55,29.53,-10657.34,17.6,-1913.71,17.67,-15335.32,31.89,10058.26,21.15,5216.61,31.89,-25827.14,23.38,11186.49,37.55,5608.11,31.89,10381.09,15.74}
,{162,71,-52831.753,75.036,8054.559,0.463,-3662.746,75.57,161.943282776,80.554,0,82.2,"",1.2,"",0,0,"","",{"B+"},{0},{"="},{0},18704.45,94.12,7107.67,82.49,3446.52,79.16,-13051.56,91.43,1777.98,80.07,-14588.4,78.35,8340.73,80.07,2281.32,76.59,-30330,210,16041.76,75.38,7870.91,77.12,13385.05,80.07}
,{162,72,-49169.008,8.968,8027.12,0.055,-9388.814,52.931,161.947214896,9.627,0,39.4,"",0.9,"",0,1,"","",{"B+","A"},{0,0.008,0},{"~","="},{0,0.008,0},19372.7,13.07,5584.24,11.48,4416.31,4.86,-15169.8,19.66,1381.42,17.59,-18461.33,25.96,10925.65,24.25,3895.63,29.35,-34729,300,11811.74,57.52,5403.65,38.72,12316,19.76}
,{162,73,-39780.194,52.238,7964.335,0.322,-5780.987,52.239,161.957294202,56.079,0,3.57,"",0.12,"",7,1,"","",{"B+","A"},{0,0.074,0},{"~","="},{0,0.074,0},20099.13,75.36,4088.2,77.18,5007.08,50,-17279,203,5493.18,59.24,-17296,203,9072.51,57.65,754.49,56.9,"","",16869.56,53.1,7936.46,54.88,15574.81,64.4}
,{162,74,-33999.207,17.658,7923.821,0.109,-11498,197,161.963500347,18.956,0,1.19,"",0.12,"",0,1,"","",{"A"},{0},{"="},{0},20815.39,150.86,2638.21,20.07,5678.27,2.4,-19559,300,5026.49,28.64,-21230.32,150.96,11515,196,2509.18,30.1,"","",12535.29,57.11,5304,8.71,14499.79,24.38}
,{162,75,-22501,196,7848,1,-8061,358,161.975844,210,0,0.107,"",0.013,"",2,-1,"","",{"A"},{0},{"="},{0},21905,357,1256,203,6240.37,5.13,"","",8989,198,-20593,445,9732,247,-765.14,11.27,"","",17536,247,7657,357,17584,197}
,{162,76,-14440,300,7793,2,"","",161.984498,322,0,0.0021,"",0.0001,"",0,1,"","",{"A"},{0},{"="},{0},"","",-308,335,6767.4,3.08,"","",8826,358,"","",12532,500,889,335,"","",13009,423,5169,53,16501,423}
,{163,61,-43249,400,8044,2,7471,499,162.95357,429,0,0.43,"",0.35,"",2.5,-1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},9156,499,"","",-4586,565,13236,405,"","",3209,445,4951,500,10988,565,21347,400,10049,565,8748,500,-1083,565}
,{163,62,-50720,298,8085,2,5765,305,162.94555,320,0,1.3,"",0.5,"",0.5,-1,"","",{"B-"},{0},{"="},{0},10191,298,22710,499,-3338,423,10594,298,-18459,499,-88,300,4262,357,11639,423,15661,298,10226,422,7146,359,2060,423}
,{163,63,-56484.886,65.544,8115.471,0.402,4829,65,162.939360977,70.364,0,7.7,"",0.4,"",2.5,1,"","",{"B-"},{0},{"="},{0},10836,66.36,20827,305,-2355.52,66.31,8111.19,65.67,-17404,307,-275.8,65.67,5852.8,74.41,9244,206,9893.45,65.55,10897.88,65.89,8613.96,65.81,2164,211}
,{163,64,-61313.886,8.426,8140.297,0.052,3282.185,9.358,162.934176832,9.045,0,68,"",3,"",3.5,1,"","",{"B-"},{0},{"="},{0},11950.7,8.58,19219.87,10.82,-1531.03,10.29,5067.28,8.46,-14073,196,-3709.25,37.33,5104.8,9.33,9899.46,36.22,3853.84,9.62,11188.44,13.37,7030.63,12.68,4567.31,10.29}
,{163,65,-64596.071,4.073,8155.633,0.025,1785.099,4.001,162.930653261,4.372,0,1170,"",18,"",1.5,1,"","",{"B-"},{0},{"="},{0},13277.12,4.19,17382.49,11.17,-977.7,5.92,1782.26,4,-13181.64,35.45,-4485.91,4,6991.43,36.58,7604.64,5.64,-1867.35,6.78,11620.56,4.29,8209.72,4.17,4530.79,10.34}
,{163,66,-66381.17,0.765,8161.785,0.005,-2.834,0.019,162.928736879,0.821,1,"s","","s","",2.5,-1,"","",{},{},{},{},14468,0.08,15453.29,1.55,-244.65,1.12,-1213.45,4.58,-9389.74,3.98,-8410.95,3.11,6271.01,0.05,7994.18,36.36,-7082.08,15.36,11791.23,1.26,6319.14,1.17,7206.97,1.19}
,{163,67,-66378.335,0.765,8156.968,0.005,-1210.612,4.575,162.928739921,0.821,0,144215151820,"",788923150,"",3.5,-1,"","",{"EC"},{0},{"="},{0},15323.7,2.17,13494.69,1.26,729.11,1.17,-3649.61,5.47,-7991.35,36.36,-8115.13,0.3,8408.11,3.11,5485.83,0.05,-11586.93,27.96,12388.27,0.08,8158.45,0.11,7104.32,1.17}
,{163,68,-65167.723,4.639,8144.741,0.028,-2439,3,162.930039567,4.98,0,4500,"",24,"",2.5,-1,"","",{"B+"},{0},{"="},{0},16108.75,9.87,11689.86,4.58,1574.5,4.79,-5868.63,16.03,-4275.22,4.58,-11761.25,26.45,6904.52,4.58,6415.15,5.53,-15904.04,25.21,12740.35,5.06,6079.06,15.68,10151.41,4.58}
,{163,69,-62728.723,5.524,8124.979,0.034,-3429.629,16.309,162.932657941,5.93,0,6516,"",18,"",0.5,1,"","",{"B+"},{0},{"="},{0},16972.65,28.49,10109.39,5.88,2175.9,6.26,-7937.31,28.49,-3976.15,6.29,-10973.69,16.3,9322.25,26.62,3683.17,5.48,-20194.09,38.46,13183.69,10.32,8199.56,24.87,9300.41,15.97}
,{163,70,-59299.094,15.364,8099.138,0.094,-4507.685,31.89,162.9363398,16.493,0,663,"",21,"",1.5,-1,"","",{"B+"},{0},{"="},{0},17602.33,21.15,8675.43,17.68,2837.02,15.75,-10035.41,29.15,-253.55,15.37,-14538.66,76.59,7544.06,21.15,5110.27,30.24,-24390.9,54.94,13310.42,31.89,5866.99,37.55,12411.54,28.71}
,{163,71,-54791.409,27.945,8066.684,0.171,-5527.726,37.348,162.941179,30,0,238.2,"",7.8,"",0,0,"","",{"B+"},{0},{"="},{0},18371.7,39.52,7470.64,39.52,3354.07,39.52,-12256.78,47.22,-602.59,38.21,-13693.72,29.35,10030.97,80.07,2254.03,31.89,-28789.16,33.53,13758.8,31.89,8235.35,28.87,11157.02,44.21}
,{163,72,-49263.682,24.778,8027.972,0.152,-6729.054,45.416,162.947113258,26.599,0,40,"",0.6,"",2.5,-1,"","",{"B+","A"},{0,0.0001,0},{"=","<"},{0,0.0001,0},19091.64,33.5,6002.22,29.15,4150.01,30.51,-14355.49,58.28,3273.69,29.15,-17554.81,57.82,8165.99,26.35,3720.9,79.02,-33071,299,14009.47,37.35,5870.31,61.99,14545.43,25.81}
,{163,73,-42534.629,38.061,7981.89,0.234,-7626.436,65.049,162.954337195,40.86,0,10.6,"",1.8,"",0.5,1,"","",{"B+","A"},{0,0.2,0},{"~","~"},{0,0.2,0},19898.27,45.2,4550.23,47.22,4749.06,5.49,-16532.38,42.33,3008.15,84.14,-16606.74,41.96,10825.75,64.63,654.59,39.1,"","",14490.85,44.24,8268.37,39.24,13381.71,68.39}
,{163,74,-34908.193,52.751,7930.302,0.324,-8905.949,55.912,162.962524511,56.63,0,2.63,"",0.09,"",3.5,-1,"","",{"A"},{0},{"="},{0},20495,203,3171.46,57.37,5519.49,50,-18716,303,6971.84,53.51,-20478,203,8980.3,55.63,2416.97,74.24,"","",14581.61,58.11,5779.56,75.72,16677.15,53.61}
,{163,75,-26002.244,18.534,7870.865,0.114,-9810,299,162.972085441,19.897,0,0.39,"",0.07,"",0.5,1,"","",{"A"},{0},{"="},{0},21304.68,151.06,1801.19,30.62,6011.99,7.77,"","",6488.98,52.54,-19633,301,11572,197,-707.99,5.63,"","",15264,197,8188.27,150.97,15467.85,57.39}
,{163,76,-16192,298,7806,2,"","",162.982617,320,0,0.0055,"",0.0006,"",3.5,-1,"","",{"A"},{0},{"~"},{0},22356,499,215,357,6677.2,8.37,"","",10518,299,"","",9823,423,980,357,"","",15359,334,5410.13,10.99,18780,334}
,{164,61,-38870,400,8017,2,9232,499,163.958271,429,0,0.2,"","s","",0,0,"","",{},{},{},{},8643,500,"","",-4775,565,14511,416,"","",3778,499,3692,565,"","",23208,412,11391,565,8582,565,"",""}
,{164,62,-48102,298,8069,2,5279,319,163.94836,320,0,1.43,"",0.24,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},9715,357,23130,499,-3394,423,11672,315,"","",311,305,5454,422,12142,499,17866,298,8978,423,6997,422,132,499}
,{164,63,-53381,114,8096,1,6393,50,163.942693,122,0,4.15,"",0.19,"",0,-1,"","",{"B-"},{0},{"="},{0},10820,119,21589,321,-2804,230,8697,152,-17421,416,-138,114,4967,132,9950,319,11601,114,11859,226,8155,114,2501,319}
,{164,64,-59774,102,8130,1,2304,143,163.93583,110,0,45,"",3,"",0,1,"","",{"B-"},{0},{"="},{0},11636,103,19822,221,-1964,103,6194,102,-16343,315,-3249,103,6531,103,10578,122,6169,102,9640,108,6882,103,2544,103}
,{164,65,-62077.965,100.003,8139.765,0.61,3890,100,163.933356559,107.357,0,180,"",6,"",5,1,"","",{"B-"},{0},{"="},{0},12544.64,106.41,17952.51,106.02,-1022.42,100.45,2903.54,100.01,-12882.05,119.57,-3768.11,100,5553.21,100.08,8053.05,100.36,-173.93,102.93,12913.24,100.08,8291.91,100.01,5359.96,100.54}
,{164,66,-65967.965,0.767,8158.714,0.005,-986.463,1.415,163.929180472,0.823,1,"s","","s","",0,1,"","",{},{},{},{},13929.12,0.08,16265.51,3.98,-451.14,1.19,-25.08,0.11,-11943.05,8.46,-7660.95,0.07,7658.11,0.07,8660.86,4,-4950.55,15.37,10418.8,36.36,6357.68,1.26,5184.26,1.55}
,{164,67,-64981.503,1.528,8147.929,0.009,961.387,1.42,163.930239483,1.639,0,1740,"",60,"",1,1,"","",{"EC","B-"},{0,40,0},{"=","="},{0,40,0},15082.6,3.21,13883.49,36.39,429.84,1.79,-3077.47,24.44,-7674.4,4.24,-7885.1,4.79,6674.48,1.41,5889.3,1.41,-10339.13,27.99,13910.78,1.42,7938.35,1.42,8126.49,1.85}
,{164,68,-65942.89,0.775,8149.02,0.005,-4038.855,24.401,163.929207392,0.832,1,"s","","s","",0,1,"","",{},{},{},{},15751,0.33,12339.35,0.14,1304.92,0.17,-4925.47,15.37,-6850.69,0.13,-11285.48,5.47,8846.48,4.58,6853.52,0.13,-14124.39,15.84,10809.46,3.12,6118.44,2.17,7759.31,0.15}
,{164,69,-61904.035,24.394,8119.623,0.149,-886.617,28.829,163.933543281,26.188,0,120,"",6,"",1,1,"","",{"EC","e+"},{0,39,0},{"=","="},{0,39,0},16568.88,35.69,10440.43,24.59,2053.78,28.64,-7261.66,37.09,-2814.67,24.4,-10676.26,28.83,7246.63,25.01,4025.28,24.83,-18621.23,37.09,15141.29,24.4,8161.63,25.92,10939.64,24.49}
,{164,70,-61017.418,15.369,8109.446,0.094,-6375.048,31.892,163.934495103,16.499,0,4548,"",102,"",0,1,"","",{"EC"},{0},{"="},{0},17333.71,21.15,9260.84,15.37,2621.89,28.71,-9198.91,22.06,-3138.67,16.04,-14297.33,31.89,9789.64,21.15,5577.67,16.31,-22781.66,18.12,11171.18,30.24,5745.35,31.89,9830.59,17.68}
,{164,71,-54642.37,27.945,8065.804,0.17,-2823.865,32.112,163.941339,30,0,188.4,"",1.8,"",0,0,"","",{"B+"},{0},{"="},{0},17953.25,80.07,7742.52,38.21,3234.74,44.21,-11359.57,39.52,797.38,28.49,-13450,37.35,7922.28,39.52,2632.25,31.89,-27169.93,61.3,15894.78,31.89,8061.09,31.89,12902.74,39.52}
,{164,72,-51818.505,15.82,8043.814,0.096,-8535.704,32.112,163.944370544,16.983,0,111,"",8,"",0,1,"","",{"B+"},{0},{"="},{0},18792.13,18.18,6570.1,22.05,3919.29,17.39,-13582.75,18.54,191.62,22.05,-17355.19,41.22,10626.14,29.4,4316.07,32.11,-31396.4,150.75,11724.06,76.69,5607.89,32.11,11667.3,22.05}
,{164,73,-43282.8,27.945,7986.997,0.17,-5047.041,29.572,163.953534,30,0,14.2,"",0.3,"",3,1,"","",{"B+"},{0},{"="},{0},19645.24,59.24,5028.99,80.07,4562.22,63.32,-15810.36,61.3,4219.64,39.52,-16445.92,59.7,8819.49,47.22,1308.09,37.35,-35939,316,16597.01,29.35,7895.93,35.91,14925.94,39.52}
,{164,74,-38235.759,9.674,7951.452,0.059,-10763.323,55.406,163.958952222,10.385,0,6.3,"",0.2,"",0,1,"","",{"B+","A"},{0,3.8,0},{"=","="},{0,3.8,0},20379.19,20.13,3644.69,13.17,5278.27,2.01,-17813.65,150.23,3738.95,26.6,-20304.83,20.9,11398.88,53.63,2990.1,39.27,"","",12255.24,53.12,5407.29,23.33,13725.31,24.46}
,{164,75,-27472.436,54.555,7881.052,0.333,-7050.331,140.051,163.970507124,58.566,0,0.719,"",0.161,"",2,-1,"","",{"A","B+"},{"",42,0},{"","="},{"",42,0},21114,203,2270.18,75.53,5926.34,5.1,-20129,319,7773.22,66.52,-19351,303,9541.51,57.62,-146.79,75.89,"","",17237.58,57.34,7947,203,16952.96,59.76}
,{164,76,-20422.106,149.919,7833.291,0.914,-13078,348,163.978075966,160.945,0,0.021,"",0.001,"",0,1,"","",{"A","B+"},{"",2,0},{"","="},{"",2,0},22124,335,1000.84,150.96,6479.43,5.26,"","",7197.12,158.93,"","",12301,334,1708.83,151.06,"","",12790,247,5282.15,6.46,15780,247}
,{164,77,-7344,314,7749,2,"","",163.992116,338,0,0.001,"","s","",2,-1,"","",{},{},{},{},"","",-580,371,6970,100,"","",11370,315,"","","","",-1560,101,"","",17807,435,7500,509,19143,348}
,{165,62,-43808,401,8043,2,6916,424,164.95297,430,0,0.98,"",0.21,"",2.5,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9231,499,"","",-3645,566,12645,419,"","",1501,416,3777,499,12227,566,19804,401,10152,566,7426,500,1389,566}
,{165,63,-50724,138,8080,1,5729,65,164.945546,148,0,2.53,"",0.25,"",2.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10381,152,22052,423,-2913,328,9842,91.92,-19142,423,979,172,5414,179,9910,328,14175,138,10707,328,8670,239,1292,330}
,{165,64,-56453,121,8110,1,4113,65,164.939395,130,0,11,"",0.9,"",0.5,-1,"","",{"B-"},{0},{"="},{0},11281,122,20311,322,-2206,122,7160,121,-15639,322,-2446,157,4750,159,10361,167,8069,121,10743,138,7115,126,3723,230}
,{165,65,-60566,102,8130,1,3047,102,164.93498,110,0,126.6,"",6,"",1.5,1,"","",{"B-"},{0},{"="},{0},12112,103,18659,122,-1199,103,4333,102,-14474,153,-2669,102,6559,143,8081,145,2364,102,11459,103,8579,103,3784,108}
,{165,66,-63612.606,0.769,8143.909,0.005,1286.4,0.829,164.931709054,0.825,0,8402.4,"",3.6,"",3.5,1,"","",{"B-"},{0},{"="},{0},13374.07,0.09,16876.66,8.46,-531.7,1.55,909,0.6,-11128,102,-6702.42,1.42,5715.96,0.05,8823.61,100,-3317.22,26.55,11694.27,4,6927.41,36.36,6314.2,3.98}
,{165,67,-64899.006,1.01,8146.964,0.006,-377.396,1.033,164.930328047,1.084,1,"s","","s","",3.5,-1,"","",{},{},{},{},14663.3,0.83,14880.88,4.08,137.67,1.45,-1969.39,1.84,-10110.01,100,-7027.43,0.83,7988.82,1.15,6220.01,0.83,-8456.76,26.56,12192.97,0.83,8146.53,0.83,6423.35,36.37}
,{165,68,-64521.61,0.964,8139.936,0.006,-1591.99,1.538,164.930733198,1.034,0,37296,"",144,"",2.5,-1,"","",{"EC"},{0},{"="},{0},15496.52,4.61,12718.38,0.6,1109.27,0.61,-4226.23,26.56,-5842.62,0.6,-10688.89,24.41,6650.04,0.59,6829.08,1.54,-12886.1,27.96,12567.53,0.6,6383.99,3.17,9306.27,0.61}
,{165,69,-62929.621,1.671,8125.546,0.01,-2634.239,26.592,164.932442269,1.793,0,108216,"",108,"",0.5,1,"","",{"B+"},{0},{"="},{0},16343.53,5.69,11129.23,1.56,1842.73,2.72,-6487.38,26.59,-5237.09,2.17,-9983.52,15.44,9096.9,24.45,4275.7,1.55,-17081.77,13.96,12948.91,4.83,8268.95,1.59,8758.32,3.52}
,{165,70,-60295.382,26.539,8104.839,0.161,-3853.14,35.432,164.935270241,28.49,0,594,"",18,"",2.5,-1,"","",{"B+"},{0},{"="},{0},17138.92,30.67,9705.6,26.94,2481.31,27.95,-8659.87,38.54,-1641.46,26.55,-13724.33,38.54,7349.28,30.67,5680.32,36.05,-21434.36,36.44,13144.15,27.11,6046.46,37.19,11685.54,26.55}
,{165,71,-56442.242,26.539,8076.745,0.161,-4806.734,38.539,164.939406758,28.49,0,644.4,"",6,"",0.5,1,"","",{"B+"},{0},{"="},{0},17793.47,38.54,8291.46,27.11,3031.55,38.54,-10594.39,29.94,-1827.18,36.05,-12695.05,30.9,9871.19,38.54,2713.79,30.67,-25782.47,35.51,13567.66,30.67,8248.16,30.66,10681.95,37.19}
,{165,72,-51635.507,27.945,8042.872,0.169,-5787.655,31.195,164.944567,30,0,76,"",4,"",2.5,-1,"","",{"B+"},{0},{"="},{0},18514.46,37.35,6914.35,31.89,3778.98,31.89,-12774.48,37.48,2092.94,31.89,-16424.02,39.52,7888.32,32.11,4282.11,39.52,-29841,198,13866.71,39.52,6060.3,80.07,13837.24,31.89}
,{165,73,-45847.853,13.863,8003.054,0.084,-6986.83,28.566,164.950780303,14.882,0,31,"",1.5,"",0.5,1,"","",{"B+"},{0},{"="},{0},19455.86,40.51,5634.38,31.19,4289.58,31.19,-15188.08,27.37,1505.55,31.19,-15683.41,16.9,10636.37,31.19,1318.32,20.23,-34255,159,14126.64,28.39,8185.21,16.51,12630.3,76.31}
,{165,74,-38861.022,24.977,7955.968,0.151,-8201.246,34.332,164.958280974,26.813,0,5.1,"",0.5,"",2.5,-1,"","",{"B+","A"},{0,0.2,0},{"~","<"},{0,0.2,0},20095.46,58.37,4175.28,35.18,5028.73,29.84,-17066,197,5668.51,29.57,-19459.9,60,8696.58,26.77,2867.19,37.48,"","",14384.41,45.53,5783.23,57.9,15954.39,26.53}
,{165,75,-30659.776,23.594,7901.522,0.143,-8865,197,164.967085375,25.329,0,2.62,"",0.14,"",0.5,1,"","",{"A"},{0},{"="},{0},20800.17,30,2703.09,44.78,5694.31,6.15,-19067,160,5334.05,36.57,-18308.99,151.76,11258.66,59.44,-287.01,22.51,"","",14959.22,57.79,8203.49,29.47,14766.82,57.32}
,{165,76,-21795,196,7843,1,-10202,252,164.976602,210,0,0.071,"",0.003,"",3.5,-1,"","",{"A"},{0},{"="},{0},21745,357,1465,203,6335.49,5.65,"","",9152,196,-22523,370,9444,247,1612,203,"","",14918,197,5570.35,9.76,17851,197}
,{165,77,-11593,158,7776,1,"","",164.987555,170,0,5e-08,"",1e-06,"<",0.5,1,"","",{},{},{},{},"","",168,159,6823,50,"","",8591,149,"","",12320,352,-1541,50,"","",15311,338,7712,339,16555,252}
,{166,62,-40730,400,8024,2,6478,537,165.956275,429,0,0.8,"",0.63,"",0,1,"","",{"B-"},{0},{"="},{0},8770,499,"","",-3604,565,13800,445,"","",1923,423,4993,566,"","",21855,400,8852,565,7384,565,"",""}
,{166,63,-47208,358,8059,2,7322,300,165.94932,384,0,1.24,"",0.12,"",6,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},9969,376,22915,537,-3263,467,10677,365,"","",1174,378,4555,384,10688,537,15864,358,11605,466,8376,466,1688,537}
,{166,64,-54530,196,8098,1,3355,208,165.94146,210,0,5.1,"",0.8,"",0,1,"","",{"B-"},{0},{"="},{0},10898,221,21005,357,-2425,277,8055,196,-18010,446,-2035,221,6148,230,11095,239,10396,196,9562,226,6819,206,1837,357}
,{166,65,-57884.789,70.005,8113.68,0.422,4700,70,165.937858119,75.153,0,27.1,"",1.5,"",2,-1,"","",{"B-"},{0},{"="},{0},11949.46,122.07,19082,134,-1606.3,78.36,5186.54,70.01,-14450,154,-2343.5,70,5390,124,8721,140,4003.59,70.96,12600,124,8293.15,70.51,4246.5,95.9}
,{166,66,-62584.789,0.867,8137.28,0.005,486.54,0.921,165.932812461,0.93,0,293760,"",360,"",0,1,"","",{"B-"},{0},{"="},{0},12759.46,0.4,17389,102,-729.3,4,2341.25,1.19,-13421,121,-5757.1,0.92,7043.5,0.4,9308,102,-989.05,7.11,10203.98,100,6875.34,4.02,4375.5,8.47}
,{166,67,-63071.329,1.01,8135.499,0.006,1854.713,0.922,165.932290139,1.084,0,96566.4,"",43.2,"",0,-1,"","",{"B-"},{0},{"="},{0},14232.46,1.15,15571.3,100,179.71,36.37,-1182.95,11.58,-9795,102,-6621.04,1.03,6243.64,0.02,6747.69,0.83,-7050.35,29.82,13607.44,0.83,8173.9,0.83,7171.14,4.08}
,{166,68,-64926.042,1.165,8141.959,0.007,-3037.667,11.547,165.930299023,1.251,1,"s","","s","",0,1,"","",{},{},{},{},15125.79,1.13,13536.02,1.12,830.52,1.12,-3330.3,7.01,-8602.41,1.12,-10067.74,2.11,8475.75,1.29,7316.01,0.92,-11067.06,27.97,10766.27,1.47,6316.35,1.12,7101.53,1.12}
,{166,69,-61888.375,11.606,8118.946,0.07,-292.635,13.507,165.933560092,12.459,0,27720,"",108,"",2,1,"","",{"B+"},{0},{"="},{0},16126.97,27.01,11484.81,11.64,1728.25,11.97,-5867.39,31.99,-4278.34,11.58,-9664.31,28.97,7030.07,11.74,4655.74,11.62,-15790.6,30.26,14765.32,11.6,8143.4,12.47,10136.36,11.6}
,{166,70,-61595.74,7.101,8112.471,0.043,-5574.759,30.642,165.933874249,7.623,0,204120,"",360,"",0,1,"","",{"EC"},{0},{"="},{0},16720.96,16.92,10230.79,7.1,2313.86,7.1,-7736.76,28.83,-4363.1,7.12,-13224.82,27.47,9371.68,27.47,5955.09,7.32,-19707.71,11.83,11019.1,25.4,5997.04,8.96,9218.38,8.44}
,{166,71,-56020.981,29.808,8074.175,0.18,-2161.998,40.859,165.939859,32,0,159,"",6,"",6,-1,"","",{"B+"},{0},{"="},{0},17521.25,40.86,8694.89,38.52,3031.89,39.59,-9923.21,40.86,-380.33,29.85,-12456.79,40.86,7650.06,39.91,3014.57,39.91,-24127.5,78.21,15707.24,33.54,8142.17,33.53,12354.14,30.32}
,{166,72,-53858.983,27.945,8056.438,0.168,-7761.208,39.52,165.94218,30,0,406.2,"",18,"",0,1,"","",{"B+"},{0},{"="},{0},18183.11,32.11,7419.51,31.89,3542.45,31.89,-11970.95,29.51,-852.57,38.54,-16082.45,31.19,10294.79,39.52,4705.71,38.54,-28427.47,33.22,11494.19,39.52,5796.48,39.52,11086.51,31.89}
,{166,73,-46097.775,27.945,8004.971,0.168,-4209.744,29.508,165.950512,30,0,34.4,"",0.5,"",0,0,"","",{"B+"},{0},{"="},{0},18957.61,39.52,6033.35,39.52,4309.06,80.07,-14204.3,77.52,3055.5,38.54,-15308.07,37.48,8321.24,31.19,1751.24,39.52,-32744,198,16431.54,32.11,8029.96,37.35,14340.04,39.52}
,{166,74,-41888.031,9.478,7974.898,0.057,-9994.553,72.879,165.955031346,10.174,0,19.2,"",0.6,"",0,1,"","",{"B+","A"},{0,0.035,0},{"~","="},{0,0.035,0},19794.91,13.52,4647.47,18.44,4856.06,3.94,-16456.51,20.17,2458.51,29.51,-19299.57,25.41,11098.33,26.71,3329.15,16.79,-37159,301,12105.58,29.51,5510.65,39.22,13022.05,26.53}
,{166,75,-31893.478,72.31,7909.977,0.436,-6461.961,72.387,165.96576094,77.628,0,2.25,"",0.21,"",7,1,"","",{"B+","A"},{"",5,""},{"","="},{"",5,""},20563.68,90.58,3188.62,77.52,5461.8,50,-18539,209,6665.4,73.63,-18170,209,9305.02,76.06,321.43,76.5,"","",17053.09,72.95,7878.77,89.51,16287.55,81.72}
,{166,76,-25431.517,17.966,7866.336,0.108,-12078,197,165.972698141,19.287,0,0.213,"",0.005,"",0,1,"","",{"A","B+"},{"",28,""},{"=","="},{"",28,""},21152.05,150.99,1773.7,20.4,6142.77,3.32,-20702,301,6140.53,30.77,-21910,159,11708,197,2060.71,29.65,"","",12751.73,57.44,5434.78,4.55,15123.08,55.73}
,{166,77,-13354,196,7789,1,-8624,359,165.985664,210,0,0.0105,"",0.0022,"",2,-1,"","",{"A","p"},{0,7,""},{"=","="},{0,7,""},22153,370,460,203,6722.35,5.58,"","",10017,197,"","",9833,252,-1152,8,"","",17779,247,7703,357,18295,197}
,{166,78,-4730,300,7732,2,"","",165.994923,322,0,0.0003,"",0.0001,"",0,1,"","",{"A"},{0},{"="},{0},"","",-1115,336,7285.88,15.37,"","",9776,359,"","","","",426,339,"","",13325,435,"","",17109,423}
,{167,63,-44010,400,8040,2,6803,499,166.952753,429,0,1.33,"",0.51,"",2.5,1,"","",{"B-","B-n"},{0,3,0},{"=","="},{0,3,0},9429,423,"","",-3186,565,11917,445,"","",2448,445,4874,537,10570,565,18270,400,10509,566,8956,499,506,565}
,{167,64,-50813,298,8076,2,5114,357,166.94545,320,0,4.2,"",0.3,"",2.5,-1,"","",{"B-"},{0},{"="},{0},10503,322,21583,499,-2518,422,9118,304,-17372,499,-1000,306,4355,357,10894,466,12478,298,10622,328,7432,319,2936,422}
,{167,65,-55927,196,8102,1,4004,205,166.93996,210,0,18.9,"",1.6,"",1.5,1,"","",{"B-"},{0},{"="},{0},11504,221,19781,239,-1867,206,6354,196,-16008,408,-1413,196,6113,208,8686,277,6617,196,11237,230,8711,221,3100,226}
,{167,66,-59930.626,60.228,8120.992,0.361,2350,60,166.935661823,64.657,0,372,"",4.8,"",0.5,-1,"","",{"B-"},{0},{"="},{0},12460.65,60.23,18056,135,-1041.66,60.81,3360.55,60.23,-12690,205,-4930.61,60.23,5417.15,60.23,9334.81,92.35,659.95,60.36,11346,119,7011.39,116.74,5490,119}
,{167,67,-62280.626,5.234,8130.379,0.031,1010.554,5.208,166.933138994,5.618,0,11160,"",360,"",3.5,-1,"","",{"B-"},{0},{"="},{0},13524.25,5.25,16293,103,-109.47,6.6,263.01,5.42,-11684.81,70.2,-5425.9,5.21,7280.61,5.25,6984.81,5.27,-4779.5,32.1,12042.79,5.25,8551.39,5.25,5443.74,100.14}
,{167,68,-63291.18,1.166,8131.746,0.007,-747.539,1.501,166.932054119,1.252,1,"s","","s","",3.5,1,"","",{},{},{},{},14912.2,1.3,14256.52,1.13,665.07,1.12,-2700.6,4.03,-7995.36,1.19,-9474.12,11.55,6436.46,0.18,7508.82,0.93,-9823.42,27.97,12318.63,0.93,6554.38,1.48,8323.19,1.12}
,{167,69,-62543.641,1.298,8122.585,0.008,-1953.065,3.798,166.932856635,1.393,0,799200,"",1728,"",0.5,1,"","",{"EC"},{0},{"="},{0},15756.65,1.98,12222.58,1.46,1409.78,1.42,-5042.52,31.7,-6761.28,1.46,-9019.22,7.17,8726.58,11.64,4906.57,1.48,-14192.58,27.97,12688.78,1.53,8263.3,1.42,8084.26,1.86}
,{167,70,-60590.576,3.981,8106.205,0.024,-3089.451,31.92,166.934953337,4.273,0,1050,"",12,"",2.5,-1,"","",{"B+"},{0},{"="},{0},16437.83,26.84,10646.91,4.06,2152.23,6.09,-7122.82,28.23,-2953.5,4.02,-12640.91,30.07,7066.15,8.08,5991.17,12.23,-18492.52,18.69,13049.85,4.26,6177.51,24.72,10998.72,4.02}
,{167,71,-57501.125,31.671,8083.021,0.19,-4033.369,42.237,166.93827,34,0,3090,"",60,"",3.5,1,"","",{"B+"},{0},{"="},{0},17201.52,41.32,9149.45,31.71,2802.68,32.15,-9150.07,42.24,-2901.72,33.73,-11713.46,42.24,9551.46,43.49,3194.36,32.46,-22670,51,13505.06,41.32,8380.35,35.2,10049.31,39.98}
,{167,72,-53467.756,27.945,8054.184,0.167,-5116.697,39.52,166.9426,30,0,123,"",3,"",0,0,"","",{"B+"},{0},{"="},{0},17974.88,39.52,7750.32,38.54,3406.42,31.89,-11369.7,33.38,839.01,28.83,-15441.3,39.52,7680.09,39.52,4735.75,40.86,-26965.76,77.87,13685.29,38.54,6038.67,39.52,13196.06,31.89}
,{167,73,-48351.059,27.945,8018.861,0.167,-6253.001,33.382,166.948093,30,0,79.8,"",4.2,"",1.5,1,"","",{"B+"},{0},{"="},{0},18645.84,31.19,6486.76,38.54,4015.43,39.52,-13520,49,380.95,40.86,-14534.35,29.51,10324.6,39.52,1781.05,39.52,-31278.62,33.43,13995.25,39.52,8331.5,32.11,11937.71,39.52}
,{167,74,-42098.058,18.261,7976.733,0.109,-7267,44,166.954805873,19.603,0,19.9,"",0.5,"",1.5,-1,"","",{"B+","A"},{0,0.04,0},{"=","="},{0,0.04,0},19379.67,30.94,5040.49,33.38,4740.71,28.08,-15596.06,74.94,4471.95,33.38,-18275.9,74.58,8281.34,20.57,3289.25,33.38,-35486,303,14460.6,22.93,6048.8,33.38,15366.85,24.16}
,{167,75,-34831,40,7929,0,-8329,83,166.962607,43,0,3.4,"",0.4,"",4.5,-1,"","",{"A"},{0},{"~"},{0},20314,47,3561,43,5279,14,-17759,44,3978,49,-17471,44,11009,83,232,42,"","",14741,48,8269,42,14098,49}
,{167,76,-26501.993,72.682,7873.974,0.435,-9429.554,74.962,166.971548938,78.027,0,0.839,"",0.005,"",3.5,-1,"","",{"A"},{0},{"="},{0},20850,209,2218.91,76.85,5981.28,50,-19890,311,8097.07,73.3,-21219,209,9141.79,74.87,1897.49,102.53,"","",14868.59,76.42,5834.5,90.88,17380.17,73.32}
,{167,77,-17072.44,18.346,7812.825,0.11,-10460,303,166.981671981,19.695,0,0.0293,"",0.0006,"",0.5,1,"","",{"A","p"},{0,39.3,0},{"=","="},{0,39.3,0},21622,159,990.61,29.88,6504.89,2.64,"","",7532.07,72.48,-20414,301,11790,197,-1070.11,3.71,"","",15433,197,8213.72,151.04,16046.4,57.56}
,{167,78,-6612,302,7746,2,"","",166.992901,325,0,0.0008,"",0.00016,"",3.5,-1,"","",{"A"},{0},{"="},{0},"","",-605,360,7155.2,50,"","",11530,303,"","",9954,426,547,360,"","",15691,341,5595,112,19456,338}
,{168,63,-39740,500,8014,3,8623,641,167.957337,537,0,0.2,"",0.1,"",2,1,"","",{"B-","B-n"},{0,10,0},{"=","="},{0,10,0},8675,615,"","",-3295,640,12982,582,"","",3001,582,3801,640,"","",20321,501,11700,640,8932,641,"",""}
,{168,64,-48363,401,8061,2,4359,499,167.94808,430,0,3.03,"",0.16,"",0,1,"","",{"B-"},{0},{"="},{0},9976,446,22212,566,-2686,499,10196,424,"","",-508,446,5621,499,11642,566,14628,401,9555,537,7225,424,1091,566}
,{168,65,-52723,298,8082,2,5837,329,167.9434,320,0,9.4,"",0.4,"",4,-1,"","",{"B-"},{0},{"="},{0},10980,306,20093,466,-1767,319,7339,300,-16001,499,-863,304,4867,357,9199,422,8590,298,12518,357,8594,322,3648,328}
,{168,66,-58559.566,140.009,8112.536,0.833,1501.605,143.186,167.937133716,150.305,0,522,"",18,"",0,1,"","",{"B-"},{0},{"="},{0},12117.41,140.01,18608,241,-1211,173,4431.61,140.01,-15036,329,-4350.26,140.09,6700.26,152.4,9922,241,3022.33,140.01,10036.03,156.53,6870,173,3540,185}
,{168,67,-60061.171,30.023,8116.817,0.179,2930,30,167.935521676,32.23,0,179.4,"",4.2,"",3,1,"","",{"B-"},{0},{"="},{0},13132.48,30.01,16754.32,76.17,-408.12,104.41,1251.75,30.06,-11423,198,-4841.31,30,5851.86,30.45,7419.52,67.28,-2993.32,49.4,13234.42,30.02,8415.49,30.02,6151,107}
,{168,68,-62991.171,1.168,8129.601,0.007,-1678.25,1.87,167.932376192,1.254,1,"s","","s","",0,1,"","",{},{},{},{},14207.76,0.21,14984.32,1.2,551.88,1.13,-1409.27,0.25,-10349.52,60.23,-8518.85,1.51,7771.31,0.12,7999.52,5.21,-7630.62,27.97,10790.96,0.94,6771.89,0.94,6267.84,1.13}
,{168,69,-61312.921,1.709,8114.954,0.01,268.98,1.887,167.934177868,1.834,0,8043840,"",17280,"",3,1,"","",{"B+","B-"},{0,0.01,0},{"~","="},{0,0.01,0},15567.18,11.7,12819.53,1.84,1243.67,2.17,-4245.07,39.29,-6321.27,5.53,-8793.66,4.18,6840.6,1.81,5310.71,1.86,-12919.01,28,14323.93,1.86,8072.74,1.89,9232.49,1.84}
,{168,70,-61581.901,1.195,8111.898,0.007,-4514.051,39.248,167.933889106,1.282,1,"s","","s","",0,1,"","",{},{},{},{},16128.79,7,11233.8,0.33,1936.07,1.16,-6221.35,27.97,-5579.69,0.28,-12152.09,31.69,9062.64,4.04,6327.23,1.53,-16688.79,13.32,11017.28,11.55,6211.77,2.13,8586.11,1.33}
,{168,71,-57067.85,39.266,8080.372,0.234,-1707.299,48.195,167.938735139,42.153,0,330,"",6,"",0,0,"","",{"B+"},{0},{"="},{0},17189.5,49.3,9757.42,40.91,2411.27,46.22,-8673.94,48.19,-1813.18,39.28,-11671.41,48.19,7638.04,50.45,3766.25,39.45,-21272.97,49.92,15238.7,39.87,8091.59,47.39,11508.17,39.31}
,{168,72,-55360.552,27.945,8065.553,0.166,-6966.644,39.52,167.940568,30,0,1557,"",12,"",0,1,"","",{"EC","e+"},{0,2,0},{"~","~"},{0,2,0},17644.2,39.52,8342.75,28.83,3231.95,31.89,-10467.44,30.94,-2058.95,28.23,-15080.81,39.52,9964.11,39.52,5148.4,42.24,-25365.34,29.65,11371.24,40.86,5945.74,38.54,10581.23,38.54}
,{168,73,-48393.908,27.945,8019.428,0.166,-3500.799,30.936,167.948047,30,0,120,"",6,"",2,-1,"","",{"B+"},{0},{"="},{0},18438.77,39.52,6950.87,40.86,3823.55,39.52,-12599.02,41.6,1818.25,42.24,-14367.17,33.38,8114.17,39.52,2215.12,39.52,-29727.68,61.89,16175.88,39.52,8105.65,39.52,13694.74,38.54}
,{168,74,-44893.109,13.271,7993.933,0.079,-9098.224,33.556,167.951805262,14.247,0,50.9,"",1.9,"",0,1,"","",{"B+","A"},{0,0.0032,0},{"~","="},{0,0.0032,0},19147.71,16.31,5612.07,30.94,4500.48,11.46,-14897.9,16.56,1285.68,30.94,-18133,43,10866.37,22.57,3831.02,30.94,-33885.65,150.54,11915.47,30.94,5818.8,18.13,12388.8,30.94}
,{168,75,-35794.885,30.821,7935.12,0.183,-5799.672,32.373,167.961572608,33.087,0,4.4,"",0.1,"",7,1,"","",{"B+","A"},{0,0.005,0},{"~","~"},{0,0.005,0},20044.04,78.6,4275.05,41.6,5063,13,-17128.66,63.24,5267.2,41.6,-17364.21,78.95,9035,51,985.8,35.82,"","",16803.95,32.24,7930.19,39.67,15699.37,33.8}
,{168,76,-29995.213,9.904,7895.941,0.059,-11328.987,56.098,167.967798812,10.632,0,2.1,"",0.1,"",0,1,"","",{"B+","A"},{0,43,0},{"=","="},{0,43,0},20706.33,20.51,2685.12,13.69,5815.63,2.7,-18987.75,150.28,4813.87,20.77,-20994.09,20.85,11564.54,73.35,2453,42,"","",12609.07,72.98,5528.62,22.41,14512.21,26.85}
,{168,77,-18666.226,55.216,7823.85,0.329,-7658.765,140.344,167.979960981,59.277,0,0.23,"",0.05,"",2,-1,"","",{"A"},{0},{"~"},{0},21455,204,1350.69,90.98,6381.3,8.52,"","",8876,68,-20125,307,9665.1,58.18,-546.8,91.28,"","",17476.1,58.07,7993,203,17639.95,60.05}
,{168,78,-11007.46,149.951,7773.605,0.893,"","",167.988183004,160.978,0,0.00202,"",0.0001,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},22421,336,153.88,151.02,6989.73,3.07,"","",8205.56,166.64,"","",12466,338,1223.99,151.07,"","",13057,247,5449,50,16434,247}
,{169,64,-44153,503,8036,3,6176,585,168.9526,540,0,0.75,"",0.21,"",3.5,-1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},9482,585,"","",-2770,643,11444,586,"","",498,585,3861,643,11701,709,16770,503,10568,642,7919,617,2223,642}
,{169,65,-50329,298,8068,2,5269,423,168.94597,320,0,5.13,"",0.32,"",1.5,1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10544,357,20896,499,-2030,328,8469,299,-17877,582,160,329,5677,422,9254,499,10947,298,11195,422,9065,357,2525,466}
,{169,66,-55597.177,300.67,8094.763,1.779,3200,300,168.940313971,322.782,0,39,"",8,"",0,0,"","",{"B-"},{0},{"="},{0},11809.19,306.63,19362,423,-1569,324,5325.93,300.67,-14523,501,-3607.32,302.16,5108.93,331.66,10164,423,4780.39,300.67,11041,359,7151.67,308.71,4579,359}
,{169,67,-58797.177,20.06,8109.068,0.119,2125.927,20.053,168.93687863,21.534,0,283.2,"",6,"",3.5,-1,"","",{"B-"},{0},{"="},{0},12659.19,20.62,17448,197,-656,104,2478.04,20.08,-13364,299,-3877.32,20.05,6807.32,36.08,7526.58,141.42,-712.61,20.28,11844.25,63.44,8651.67,20.07,4734.01,72.82}
,{169,68,-60923.104,1.179,8117.019,0.007,352.108,1.114,168.934596353,1.265,0,811468.8,"",1555.2,"",0.5,-1,"","",{"B-"},{0},{"="},{0},13774.56,0.19,15570.42,60.23,264.59,1.14,-545.54,0.33,-9652.51,140.01,-7681.5,1.88,6003.25,0.15,8150.9,30,-6206.21,27.97,12068.33,5.21,7012.28,0.95,7308.09,1.21}
,{169,69,-61275.212,0.812,8114.473,0.005,-897.65,1.141,168.93421835,0.871,1,"s","","s","",0.5,1,"","",{},{},{},{},14874.21,1.02,13572.53,5.32,1198.88,1.06,-3190.65,3.21,-8503.01,30.02,-7764.63,1.13,8033.61,1.5,5573.01,1.1,-10984.78,27.96,12726.77,1.1,8514.88,1.1,7442.52,1.06}
,{169,70,-60377.563,1.205,8104.532,0.007,-2293,3,168.935182016,1.293,0,2766355.2,"",432,"",3.5,1,"","",{"EC"},{0},{"="},{0},15929.62,4.04,11664.32,0.32,1719.13,1.33,-5660.67,27.97,-4675.36,0.29,-11381.03,39.25,6866.98,0.15,6353.61,1.89,-15459.69,15.48,12876.88,1.54,6374.87,11.55,10194.88,0.36}
,{169,71,-58084.563,3.233,8086.335,0.019,-3367.673,28.131,168.937643653,3.47,0,122616,"",180,"",3.5,1,"","",{"B+"},{0},{"="},{0},16726.07,31.84,10118.86,3.37,2420.14,3.68,-7794.13,28.13,-4060.61,3.55,-10795.33,28.13,9088.03,39.36,3791.63,3,-19675.33,11.82,13216.82,5.03,8375.23,7.62,9450.21,11.94}
,{169,72,-54716.889,27.945,8061.778,0.165,-4426.46,39.52,168.941259,30,0,194.4,"",2.4,"",2.5,-1,"","",{"B+"},{0},{"="},{0},17391.77,39.52,8704.25,28.23,3153.58,38.54,-9799.02,31.92,-423.96,27.97,-14394.3,39.52,7427.65,39.52,4938.01,48.19,-23994.2,37.61,13495.04,42.24,6168.15,40.86,12525.25,28.83}
,{169,73,-50290.43,27.945,8030.957,0.165,-5372.557,31.925,168.946011,30,0,294,"",24,"",2.5,1,"","",{"B+"},{0},{"="},{0},18082,39.52,7367.25,42.24,3726.9,38.54,-11881.2,30.17,-511.55,48.19,-13468.64,30.94,9967.84,39.52,2218.85,39.52,-28196.59,36.39,13888.13,39.52,8432.61,39.52,11376.95,40.86}
,{169,74,-44917.873,15.436,7994.537,0.091,-6508.641,19.173,168.951778677,16.571,0,74,"",6,"",2.5,-1,"","",{"B+"},{0},{"="},{0},18962.45,23.91,6028.06,31.92,4292.72,31.92,-14195.18,29.52,3153.71,31.92,-17194.31,34.47,8096.08,20.35,3812.94,31.92,-32405,196,14143.99,31.92,6043.96,31.92,14587.51,31.92}
,{169,75,-38409.232,11.374,7951.395,0.067,-7686.541,27.618,168.958765991,12.21,0,8.1,"",0.5,"",4.5,-1,"","",{"B+","A"},{"",0.005,0},{"","="},{"",0.005,0},19721,42,4636.11,30.17,5013.7,13.58,-16315.39,25.93,2695.71,30.17,-16485.34,15.08,10685.66,32.85,805.09,16.04,-36621,298,14399.63,21.51,8342.85,14.81,13334.94,30.17}
,{169,76,-30722.691,25.167,7901.284,0.149,-8628.852,34.276,168.967017833,27.017,0,3.46,"",0.11,"",2.5,-1,"","",{"B+","A"},{0,13.7,0},{"=","="},{0,13.7,0},20363.33,76.92,3202.57,31.09,5713.42,3.09,-18210,197,6881.45,28.45,-20127.78,60.68,8798.79,27.03,2216.78,39.79,"","",14819,48,6034.84,76.56,16811.74,26.89}
,{169,77,-22093.839,23.308,7845.596,0.138,-9581,197,168.976281287,25.021,0,0.353,"",0.004,"",0.5,1,"","",{"A"},{0},{"="},{0},21164.03,29.66,1841,47,6141.02,3.66,-20305,299,6412.08,38.64,-19157.7,151.75,11498.93,59.93,-612.4,22.1,"","",15118.96,76.33,8201.73,29.42,15446.04,75.97}
,{169,78,-12512,196,7784,1,-10724,357,168.986567,210,0,0.00699,"",9e-05,"",3.5,-1,"","",{"A","B+"},{"",1,0},{"","="},{"",1,0},22043,360,588,209,6857.61,5.12,"","",10194,196,"","",9576,247,1135,203,"","",15271,197,5705.61,9.5,18565,197}
,{169,79,-1788,298,7716,2,"","",168.99808,320,0,0.00015,"","s","",0.5,1,"","",{},{},{},{},"","",-706,299,7379,337,"","",9589,303,"","","","",-1930,334,"","",15535,425,7805,423,17212,357}
,{170,64,-41380,596,8020,4,5344,718,169.955577,640,0,0.42,"",0.13,"",0,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},9159,718,"","",-3075,718,12284,627,"","",878,667,5298,780,"","",18729,596,9071,778,7495,718,"",""}
,{170,65,-46724,401,8047,2,6940,446,169.94984,430,0,0.96,"",0.068,"",2,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},10144,499,21561,641,-1941,537,9515,404,"","",802,501,4466,499,9860,643,13072,401,12350,566,8953,499,2933,566}
,{170,66,-53663,196,8083,1,2575,202,169.94239,210,0,54.9,"",8,"",0,1,"","",{"B-"},{0},{"="},{0},11246,241,19878,446,-1559,277,6445,196,-16800,540,-2938,197,6138,359,10624,357,7101,196,9770,357,7128,277,2796,357}
,{170,67,-56238.681,50.024,8093.796,0.294,3870,50,169.939625289,53.702,0,165.6,"",3,"",6,1,"","",{"B-"},{0},{"="},{0},12320.14,58.33,18094,302,-778.81,86.04,3557.17,50.03,-13199,302,-3386.89,50.02,5512.82,53.85,7930.47,304.8,1067.54,52.78,13031.69,148.66,8556,78.26,5335,202}
,{170,68,-60108.681,1.546,8111.959,0.009,-312.828,1.821,169.935470673,1.659,1,"s","","s","",0,1,"","",{},{},{},{},13260.14,1.45,16127.06,140,51.19,1.66,655.24,1.55,-11800.47,300.67,-6904.79,1.83,7256.89,1.46,8600.47,20,-3854.83,27.99,10663.3,30.04,7036,5,5468.35,60.21}
,{170,69,-59795.853,0.801,8105.517,0.005,968.066,0.801,169.935806507,0.859,0,11111040,"",25920,"",1,-1,"","",{"B-","EC"},{0,0.131,0},{"~","="},{0,0.131,0},14625.57,1.51,14312.62,30.02,850.56,1.07,-2489.63,16.86,-8287.65,20.08,-7489.61,1.15,6591.96,0.17,6161.72,1.12,-9658.19,27.96,13906.12,1.11,8359.38,1.11,8131.17,5.32}
,{170,70,-60763.919,0.01,8106.609,0,-3457.695,16.843,169.934767245,0.011,1,"s","","s","",0,1,"","",{},{},{},{},15324.65,1.19,12350.69,1.17,1737.21,1.17,-4510.06,27.94,-7129.79,1.18,-10750.67,3.23,8457.67,1.2,6777.68,0.81,-13473.09,13.2,11259.81,1.71,6643.78,1.3,8173.66,1.17}
,{170,71,-57306.224,16.843,8081.668,0.099,-1052.37,32.628,169.938479234,18.081,0,173836.8,"",1728,"",0,1,"","",{"B+"},{0},{"="},{0},16381.01,42.73,10571.24,16.93,2157.24,20.45,-7168.56,32.63,-3319.98,16.86,-10660.65,32.63,7292.98,17.15,4217.63,16.89,-18393.03,28.6,14986.48,16.89,8148.41,17.31,10883.82,16.89}
,{170,72,-56253.854,27.945,8070.875,0.164,-6116.19,39.52,169.939609,30,0,57636,"",468,"",0,1,"","",{"EC"},{0},{"="},{0},17035.94,39.52,9249.89,27.97,2916.97,28.83,-8963.02,30.9,-3165.26,27.97,-14034.74,39.52,9608.28,39.52,5458.26,28.13,-22327.61,29.6,11524.8,48.19,6111.33,42.24,9983.12,28.23}
,{170,73,-50137.665,27.945,8030.296,0.164,-2846.832,30.904,169.946175,30,0,405.6,"",3.6,"",0,0,"","",{"B+"},{0},{"="},{0},17886.39,39.52,7647.76,48.19,3458.4,40.86,-11224.47,36.26,657.93,28.13,-13291.11,31.92,7918.55,39.52,2709.75,39.52,-26778,93,15933.69,39.52,8194.15,39.52,13009.86,42.24}
,{170,74,-47290.832,13.195,8008.948,0.078,-8377.639,26.611,169.9492312,14.165,0,145.2,"",2.4,"",0,1,"","",{"B+","A"},{0,1,0},{"~","<"},{0,1,0},18540.36,18.71,6508.22,30.9,4143.24,30.9,-13364.59,16.42,137.09,30.9,-16952.92,17.42,10444.28,20.3,4289.37,30.9,-30991.64,22.52,11813.88,30.9,5924.28,30.9,11823.33,30.9}
,{170,75,-38913.193,23.109,7955.065,0.136,-4986.946,25.091,169.958224966,24.808,0,9.2,"",0.2,"",5,1,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},19260.94,38.52,5097.23,36.26,4759.67,36.26,-15554,92,4088.27,36.26,-16261.82,34.17,8575.28,25.76,1284.29,27.79,-35161,198,16690.72,26.65,8048.92,29.45,15084.27,36.26}
,{170,76,-33926.247,9.773,7921.128,0.057,-10567,89,169.963578673,10.491,0,7.37,"",0.18,"",0,1,"","",{"B+","A"},{"",9.5,0},{"","="},{"",9.5,0},20073.67,13.89,3611.08,16.48,5536.87,2.69,-17627.05,20.56,3702.66,18.27,-19903.73,25.25,11274.87,26.99,2805.99,15,"","",12579.44,32.33,5769,42,13818.21,20.71}
,{170,77,-23360,89,7854,1,-7060,89,169.974922,95,0,0.91,"",0.15,"",3,-1,"","",{"A"},{0},{"="},{0},20836,104,2143,94,6109,51,-19608,215,7761,89,-18918,215,9337,92,-74,92,"","",17346,89,8006,115,17118,97}
,{170,78,-16299.193,18.247,7808.236,0.107,-12547,197,169.982502095,19.588,0,0.01393,"",0.00016,"",0,1,"","",{"A","B+"},{"",2,0},{"","="},{"",2,0},21434.37,151.06,881.92,20.76,6707.41,3.19,"","",7134.53,31.08,-22582,299,11858,197,1494.33,29.6,"","",13077.84,58.15,5637.3,4.28,15849.2,74.94}
,{170,79,-3752,196,7730,1,"","",169.995972,211,0,0.00029,"",5e-05,"",2,-1,"","",{"p","A"},{"",11,""},{"=","="},{"",11,""},"","",-336,204,7177.31,15.3,"","",11053,198,"","",10035,357,-1471.7,12,"","",17966,247,7725,360,18967,197}
,{171,65,-44032,503,8031,3,6157,585,170.95273,540,0,1.23,"",0.1,"",1.5,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},9846,585,"","",-2446,642,10487,783,"","",1560,540,5379,643,9941,780,15179,503,10832,711,9196,643,1355,709}
,{171,66,-50189,298,8063,2,4330,670,170.94612,320,0,4.07,"",0.4,"",3.5,-1,"","",{"B-"},{0},{"="},{0},10734,423,20614,585,-1801,422,7530,298,-16098,667,-2022,302,4597,357,10754,499,9118,298,10851,422,7398,422,3821,499}
,{171,67,-54518.956,600.002,8083.608,3.509,3200,600,170.94147149,644.128,0,53,"",2,"",3.5,-1,"","",{"B-"},{0},{"="},{0},11864.41,600.33,18768,670,-1017,631,4691.34,600,-15084,721,-2481.59,600,6351.59,602.08,8145,631,3309.44,600,11789.03,671.12,8904.67,616.12,3850,670}
,{171,68,-57718.956,1.557,8097.746,0.009,1491.342,1.256,170.938036148,1.67,0,27057.6,"",7.2,"",2.5,-1,"","",{"B-"},{0},{"="},{0},12938.49,1.49,16699.72,300.67,-213.25,60.21,1587.85,1.56,-11345,196,-5994.42,1.83,5681.59,0.35,8769.25,50,-2287.61,28.92,11789.03,20,7206.27,30.04,6487.01,140}
,{171,69,-59210.298,0.972,8101.893,0.006,96.512,0.972,170.936435126,1.043,0,60589297.92,"",315569.26,"",0.5,1,"","",{"B-"},{0},{"="},{0},14077.72,1.24,14991.06,20.04,645.41,5.15,-1381.9,2.1,-10260.59,50.02,-6517.7,0.97,7485.76,1.23,6390.59,1.24,-7490.03,27.96,12423.61,1.51,8644.93,1.5,6497.27,30.04}
,{171,70,-59306.81,0.013,8097.882,0,-1478.414,1.862,170.936331517,0.014,1,"s","","s","",0.5,-1,"","",{},{},{},{},15071.88,1.2,12961.65,1.18,1559.45,1.17,-3875.46,28.88,-6487.1,1.55,-10071.9,16.84,6614.21,0.01,6799.93,0.8,-12220.72,27.94,12679.21,0.81,6870.17,1.71,9330.76,1.17}
,{171,71,-57828.395,1.862,8084.661,0.011,-2397.05,28.936,170.93791866,1.998,0,711936,"",2592,"",3.5,1,"","",{"B+"},{0},{"="},{0},15886.47,3.73,11131.12,2.03,2290.33,2.27,-6108.12,28.01,-5321.51,2.02,-9645.86,28.01,8593.49,16.95,4353.45,1.86,-16578.12,28.01,13259.97,2.21,8617.56,2.21,9130.93,2.53}
,{171,72,-55431.345,28.876,8066.068,0.169,-3711.072,40.184,170.940492,31,0,43560,"",1440,"",3.5,1,"","",{"B+"},{0},{"="},{0},16857.09,40.18,9631.72,28.9,2734.32,29.15,-8345.25,40.18,-1956.4,28.88,-13365,40.18,7248.81,40.18,5414.09,33.43,-21129.4,33.93,13364.02,29.06,6500.56,48.74,11796.96,28.9}
,{171,73,-51720.273,27.945,8039.791,0.163,-4634.183,39.52,170.944476,30,0,1398,"",18,"",2.5,-1,"","",{"B+"},{0},{"="},{0},17572.48,39.52,8213.65,28.13,3355.94,42.24,-10469.99,39.52,-1703.02,32.63,-12500.76,30.9,9653.93,39.52,2755.39,39.52,-25308.25,47.55,13707.42,39.52,8504.33,39.52,10993.98,48.19}
,{171,74,-47086.09,27.945,8008.115,0.163,-5835.81,39.52,170.949451,30,0,142.8,"",2.4,"",2.5,-1,"","",{"B+"},{0},{"="},{0},18310.85,31.92,6947.14,39.52,3956.75,39.52,-12784.15,33.14,1878.79,39.52,-16244.21,36.26,7866.58,30.9,4237.4,39.52,-29616.39,77.93,13915.15,39.52,6171.87,39.52,13920.86,39.52}
,{171,75,-41250.28,27.945,7969.412,0.163,-6948.339,33.145,170.955716,30,0,15.2,"",0.4,"",4.5,-1,"","",{"B+"},{0},{"="},{0},18983.68,30.17,5537.79,39.52,4675.86,39.52,-14838.26,47.55,1598.41,39.52,-15395.35,29.6,10408.4,36.26,1248.42,30.9,-33687.99,34.78,14378.4,31.92,8506.88,30.94,12790.03,39.52}
,{171,76,-34301.942,17.823,7924.204,0.104,-7889.916,42.395,170.963175348,19.133,0,8.3,"",0.2,"",2.5,-1,"","",{"A"},{0},{"="},{0},19721.89,30.84,3962.01,23.58,5371.2,4.43,-16832.24,74.9,5699.92,22.17,-19014,90,8447.01,20.33,2677.72,29.18,-37782,303,14818.1,21.14,6357,35.6,16237.57,22.22}
,{171,77,-26412.025,38.466,7873.489,0.225,-8942.323,82.291,170.971645522,41.295,0,3.1,"",0.3,"",0.5,1,"","",{"A"},{0},{"="},{0},20460.82,44.98,2580.73,40.11,5994,13,-18849.73,43.69,5212.2,44.87,-18184.15,42.57,11124,97,-225.25,39.69,"","",15021.47,45.97,8447.24,39.72,15029.26,49.29}
,{171,78,-17469.702,72.747,7816.619,0.425,-9907.407,75.639,170.981245502,78.097,0,0.0455,"",0.0025,"",3.5,-1,"","",{"A"},{0},{"="},{0},21100,209,1324.95,76.98,6607.38,3.08,-20950,311,9167.57,73.4,-21789,209,9241.83,75,1399,115,"","",15334.94,76.39,6060.58,91.33,18171.91,73.42}
,{171,79,-7562.295,20.713,7754.106,0.121,-11043,303,170.991881542,22.236,0,2.23e-05,"",2.4e-06,"",0.5,1,"","",{"p"},{0},{"~"},{0},21916,299,46.4,31.18,7085.23,10.7,"","",8508,89,"","",11882,197,-1447.93,9.8,"","",15661,197,8309.22,151.37,16750.33,58.97}
,{171,80,3480,303,7685,2,"","",171.003736,325,0,7e-05,"",3e-05,"",1.5,-1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},"","",-1415,361,7667.69,15.36,"","",12490,303,"","","","",57,361,"","",15980,425,"","",20134,338}
,{172,65,-39850,503,8007,3,8159,585,171.957219,540,0,0.76,"",0.19,"",6,1,"","",{"B-","B-n"},{0,1,0},{"=","="},{0,1,0},9269,643,"","",-2535,709,11633,540,"","",2267,585,3890,711,"","",17524,503,12240,780,9167,711,"",""}
,{172,66,-48009,298,8050,2,3474,357,171.94846,320,0,3.4,"",0.2,"",0,1,"","",{"B-"},{0},{"="},{0},10488,357,21207,667,-2071,499,8474,298,"","",-1562,670,5892,422,11266,585,11246,298,9425,499,7183,422,1790,585}
,{172,67,-51484,196,8066,1,5000,196,171.94473,210,0,25,"",3,"",0,1,"","",{"B-"},{0},{"="},{0},11388,202,19338,446,-1186,357,5891,196,-14741,540,-1836,196,5036,631,8584,357,5252,196,12891,277,8978,359,4491,357}
,{172,68,-56483.612,4.008,8090.41,0.023,890.767,4.543,171.939362344,4.302,0,177480,"",1800,"",0,1,"","",{"B-"},{0},{"="},{0},12517.57,3.77,17398,196,-348.96,140.05,2771.83,4.01,-13584,298,-5344.63,3.93,6835.97,3.79,9253.63,600.01,-81.39,24.75,10465.87,50.14,7177.62,20.35,4759.97,300.69}
,{172,69,-57374.379,5.503,8091.041,0.032,1881.067,5.503,171.938406067,5.907,0,228960,"",1080,"",2,-1,"","",{"B-"},{0},{"="},{0},13721.16,5.58,15713.64,50.29,261.88,30.5,-638.4,5.98,-10144.39,600.02,-6138.89,5.5,6235.4,5.47,6944.39,5.42,-6044.4,28.48,13445.11,5.41,8412.78,5.52,7069.2,20.72}
,{172,70,-59255.446,0.014,8097.429,0,-2519.466,2.336,171.936386658,0.014,1,"s","","s","",0,1,"","",{},{},{},{},14634.16,0.01,13724.71,1.55,1310.81,1.17,-2853.22,24.43,-8825.46,1.56,-9498.37,1.86,8019.95,0.02,7334.12,0.97,-10158.26,27.94,11251.21,0.8,6883.82,0.81,7314.06,1.18}
,{172,71,-56735.98,2.336,8078.232,0.014,-333.754,24.54,171.939091417,2.507,0,578880,"",2592,"",4,-1,"","",{"B+"},{0},{"="},{0},15572.39,17,11518.07,2.47,2152.03,2.89,-5406,28.04,-4814.65,2.53,-9375.95,28.97,6978.9,2.63,4718.14,2.34,-15198.87,39.06,14738.75,2.34,8505.64,2.62,10185.63,2.47}
,{172,72,-56402.226,24.428,8071.743,0.142,-5072.248,37.117,171.939449716,26.224,0,59011451.62,"",946707.78,"",0,1,"","",{"EC"},{0},{"="},{0},16291.01,37.12,10216.25,24.43,2754.76,24.46,-7305.04,37.12,-4384.39,24.43,-12753.27,37.12,9042.2,37.82,5862.8,24.5,-19158.38,27.57,11614.8,29.67,6546.39,24.64,9621.74,24.46}
,{172,73,-51329.977,27.945,8037.705,0.162,-2232.791,39.52,171.944895,30,0,2208,"",18,"",3,1,"","",{"B+"},{0},{"="},{0},17334.95,39.52,8601.69,32.63,3312.96,48.19,-9792.87,47.97,-790.55,28.01,-12315.2,39.52,7681.02,39.52,3187.6,40.18,-23950.61,42.79,15634.68,39.52,8250.97,39.52,12400.99,28.13}
,{172,74,-49097.186,27.945,8020.175,0.162,-7560.08,47.974,171.947292,30,0,396,"",54,"",0,1,"","",{"B+"},{0},{"="},{0},17948.99,30.9,7421.27,39.52,3838.45,39.52,-11853.34,30.73,-954.81,40.18,-15918.22,39.52,10082.41,39.52,4665.88,39.52,-27990.27,29.81,11751.28,39.52,6057.3,39.52,11266.1,39.52}
,{172,75,-41537.106,38.995,7971.672,0.227,-4293.264,41.036,171.955408079,41.862,0,15,"",3,"",5,1,"","",{"B+"},{0},{"="},{0},18766.55,45.33,5977.38,47.97,4431.89,47.97,-14157.74,50.7,2894.2,47.97,-15306.48,42.87,8358.14,47.97,1739.99,47.97,-32219.1,68.37,16464.53,41.17,8244.82,41.94,14399.73,47.97}
,{172,76,-37243.842,12.782,7942.163,0.074,-9864.473,34.832,171.960017088,13.721,0,19.2,"",0.9,"",0,1,"","",{"B+","A"},{"",1.1,0},{"","="},{"",1.1,0},19460.23,16.09,4530.95,18.36,5224.35,6.97,-16136.92,16.46,2553.28,30.73,-18903.13,40.53,11013.22,21.93,3282.53,30.73,-36185.1,150.62,12380.16,26.41,6029.44,15.45,13320.43,20.04}
,{172,77,-27379.369,32.402,7880.263,0.188,-6272.449,34.023,171.970607036,34.785,0,4.4,"",0.3,"",3,-1,"","",{"A"},{0},{"="},{0},20162,94,3044.12,39.8,5990.6,10,-18061.36,64.84,6581.94,42.79,-17980.98,79.64,9038.66,50.29,366.4,36.98,"","",17257.68,33.84,8207.38,41.03,16676.26,34.34}
,{172,78,-21106.92,10.377,7839.247,0.06,-11788.914,57.108,171.977340788,11.139,0,0.0976,"",0.0013,"",0,1,"","",{"A"},{0},{"="},{0},20950.36,20.99,1758.61,14.23,6463.38,4.04,-20048.18,150.44,5906.05,20.62,-21615.94,23.16,11708.53,73.48,1983.87,39.84,"","",12963,89,5850.97,21.85,15262.17,27.2}
,{172,79,-9318.006,56.158,7766.158,0.326,-8259.262,140.853,171.989996708,60.287,0,0.028,"",0.004,"",2,-1,"","",{"A","p"},{"",2,0},{"","<"},{"",2,0},21709,204,536,105,6923.3,10.24,"","",9805.05,68.07,-20870,308,9827.03,59.86,-862.73,91.9,"","",17691.99,59.05,8059,204,18422.23,60.8}
,{172,80,-1058.744,150.079,7713.591,0.873,"","",171.998863391,161.116,0,0.000231,"",9e-06,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},"","",-662.51,151.18,7523.8,6.19,"","",9121.99,166.78,"","",12610,338,785.42,151.5,"","",13404,247,5594,334,17100,247}
,{173,66,-43939,401,8027,2,5412,499,172.95283,430,0,1.43,"",0.2,"",4.5,1,"","",{"B-"},{0},{"="},{0},9892,499,"","",-2211,643,9715,446,"","",-526,446,4001,499,11377,643,13613,401,10804,643,7649,566,3088,718}
,{173,67,-49351,298,8054,2,4304,357,172.94702,320,0,6.9,"",0.48,"",3.5,-1,"","",{"B-"},{0},{"="},{0},10974,670,19897,585,-1447,422,6906,298,-16789,585,-938,298,5938,357,8630,422,7530,298,11549,422,9177,357,3020,499}
,{173,68,-53654,196,8074,1,2602,196,172.9424,210,0,86.04,"",1.02,"",3.5,-1,"","",{"B-"},{0},{"="},{0},12078,196,18043,357,-482,359,3897,196,-12934,357,-4351,196,5242,196,9459,277,1758,198,11576,631,7449,202,5656,277}
,{173,69,-56256.059,4.4,8084.463,0.025,1295.166,4.4,172.939606632,4.723,0,29664,"",288,"",0.5,1,"","",{"B-"},{0},{"="},{0},13188.4,4.51,16315.04,600.02,116.2,20.54,624.86,4.67,-12061,196,-5071.93,4.4,6953,7.05,7061.42,5.95,-3859.52,28.29,12173.7,4.67,8716.68,4.66,5629.02,50.22}
,{173,70,-57551.225,0.011,8087.427,0,-670.31,1.567,172.938216215,0.012,1,"s","","s","",2.5,-1,"","",{},{},{},{},14387.05,0.01,14410.21,1.56,946.96,1.18,-2139.44,27.94,-8356.58,4.01,-8886.56,2.34,6367.1,0.02,7465.82,5.5,-8823.84,27.94,12369.88,0.97,7108.68,0.8,8203.86,1.55}
,{173,71,-56880.916,1.567,8079.03,0.009,-1469.132,27.989,172.938935822,1.682,0,43232988.62,"",315569.26,"",3.5,1,"","",{"EC"},{0},{"="},{0},15195.15,1.98,12248.56,1.84,1969.38,1.76,-4484.38,27.99,-6795.51,5.72,-8550.01,24.48,8216.25,2.24,4914.44,1.57,-13327.05,27.99,13136.7,1.57,8747.06,1.57,8561.34,1.76}
,{173,72,-55411.784,27.945,8066.016,0.162,-3015.246,39.52,172.940513,30,0,84960,"",360,"",0.5,-1,"","",{"B+"},{0},{"="},{0},16123.07,40.18,10682.92,27.94,2540.86,27.97,-6684.4,39.52,-3445.31,27.94,-12153.12,39.52,7080.88,37.12,5964.77,28.04,-17973.53,31.7,13127.42,28.01,6758.5,32.63,10998.54,27.94}
,{173,73,-52396.538,27.945,8044.064,0.162,-3669.155,39.52,172.94375,30,0,11304,"",468,"",2.5,-1,"","",{"B+"},{0},{"="},{0},16818.9,39.52,9146.08,28.01,3263.11,28.13,-8842.67,39.52,-2949.53,28.04,-11370.67,39.52,9137.88,39.52,3283.28,37.12,-22128.1,30.04,13745.61,40.18,8721.37,39.52,10556.09,32.63}
,{173,74,-48727.383,27.945,8018.333,0.162,-5173.518,39.52,172.947689,30,0,456,"",12,"",2.5,-1,"","",{"B+"},{0},{"="},{0},17783.93,39.52,7873.98,40.18,3564.59,39.52,-11289.13,31.7,385.87,37.12,-15261.59,47.97,7701.51,39.52,4686.38,39.52,-26784.47,62.56,13703.7,39.52,6274.34,39.52,13172.87,39.52}
,{173,75,-43553.865,27.945,7983.906,0.162,-6115.608,31.697,172.953243,30,0,120,"",18,"",2.5,-1,"","",{"B+"},{0},{"="},{0},18446.22,39.52,6411.53,39.52,4311.65,39.52,-13285.43,30.04,487.14,39.52,-14381.34,30.73,10088.08,47.97,1745.65,39.52,-30721.43,36.06,14243.03,39.52,8601.02,30.9,12230.2,39.52}
,{173,76,-37438.257,14.959,7944.033,0.086,-7169.822,18.583,172.959808375,16.059,0,22.4,"",0.9,"",2.5,-1,"","",{"B+","A"},{0,0.4,0},{"~","="},{0,0.4,0},19278.95,23.27,4930.11,31.7,5054.7,5.78,-15495.35,57.94,4369.96,31.7,-18130.21,35.69,8265.73,19.67,3190.12,41.77,-34729,196,14522.83,31.7,6338.99,27.53,15498.98,19.94}
,{173,77,-30268.435,11.026,7898.067,0.064,-8325.524,57.052,172.967505496,11.837,0,9,"",0.8,"",0.5,1,"","",{"B+","A"},{0,7,0},{">","<"},{0,7,0},19999.04,40.02,3596.1,30.04,5715.88,9.68,-17436,25.31,3979.7,40.52,-17232.83,15.14,10960.38,34.23,313.56,15.29,"","",14744.31,20.96,8521.87,14.73,14291.16,25.6}
,{173,78,-21942.911,55.977,7845.42,0.324,-9110.471,60.421,172.976443315,60.093,0,0.382,"",0.002,"",2.5,-1,"","",{"A"},{0},{"="},{0},20615.84,91.79,2218.91,58.75,6354.86,50,-19233,204,8011.96,57.42,-20696.22,79.29,8907.31,56.92,1852.51,64.68,"","",15179.92,67.92,6281,105,17629.74,56.82}
,{173,79,-12832.44,22.784,7788.237,0.132,-10123,197,172.986223808,24.459,0,0.0255,"",0.0008,"",0.5,1,"","",{"A","B+"},{"",6,0},{"=","="},{"",6,0},21412.78,30.79,998.36,44.71,6836.48,4.91,"","",7257.96,39.61,-19845.01,151.8,11585.75,60.6,-985.51,21.29,"","",15348.07,76.23,8330.81,29.19,16174,91}
,{173,80,-2710,196,7725,1,"","",172.997091,210,0,0.0008,"",8e-05,"",1.5,-1,"","",{"A"},{0},{"="},{0},22332,361,-182,209,7378.02,4.46,"","",11108,196,"","",9722,247,680,204,"","",15564,197,5906.32,12.8,19236,197}
,{174,66,-41370,503,8012,3,4319,585,173.955587,540,0,1,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},9504,585,"","",-2416,780,10579,585,"","",-91,585,5503,643,"","",15574,503,9191,711,7525,711,"",""}
,{174,67,-45690,298,8033,2,6260,422,173.95095,320,0,3.2,"",1.1,"",8,-1,"","",{"B-"},{0},{"="},{0},10349,357,20417,585,-1391,499,8175,301,"","",-107,357,4411,422,9040,499,9880,298,13030,422,9363,422,3988,585}
,{174,68,-51949,298,8064,2,1915,301,173.94423,320,0,192,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},11608,298,18518,422,-711,357,4995,298,-15300,499,-3765,298,6367,357,9888,422,3895,298,10245,357,7434,670,3886,422}
,{174,69,-53864.512,44.721,8070.642,0.257,3080,44.721,173.942174064,48.01,0,324,"",6,"",0,0,"","",{"B-"},{0},{"="},{0},12632.77,45.06,16959,201,-50.75,67.1,1705.68,44.75,-11803,301,-4384.6,44.72,5679.77,44.94,7499,201,-2123.75,52.73,13329.91,44.9,8718.5,44.75,6300.85,601.67}
,{174,70,-56944.512,0.011,8083.847,0,-1374.317,1.567,173.938867548,0.011,1,"s","","s","",0,1,"","",{},{},{},{},13831.7,0.02,15038.84,4.01,739.25,1.55,-1100.03,2.26,-10579,196,-8134.91,1.57,7464.6,0.01,7977.42,4.4,-6717.42,27.94,11140.67,5.5,7129.84,0.97,6420.85,1.56}
,{174,71,-55570.195,1.567,8071.453,0.009,274.286,2.169,173.940342938,1.682,0,104453425.06,"",1577846.3,"",1,-1,"","",{"B+"},{0},{"="},{0},14976.85,2.24,12773.76,5.72,1800.74,1.76,-3829.43,27.99,-6603.11,4.67,-8229.73,27.99,6760.6,1.41,5307.94,1.57,-11897.1,27.99,14396.06,1.57,8600.67,1.57,9286.5,1.84}
,{174,72,-55844.481,2.259,8068.533,0.013,-4103.715,28.036,173.94004848,2.424,0,6.3113852e+22,"",1.26227704e+22,"",0,1,"","",{"A"},{0},{"="},{0},15584.89,24.53,11166.98,2.26,2494.52,2.26,-5617.39,28.04,-5582.23,2.26,-11519.26,28.04,8504.01,28.04,6252.54,2.17,-15849.07,10.5,11602.3,2.78,6847.97,2.57,9108.73,2.26}
,{174,73,-51740.766,27.945,8040.452,0.161,-1513.678,39.52,173.944454,30,0,4104,"",288,"",3,1,"","",{"B+"},{0},{"="},{0},16553.42,39.52,9582.73,28.04,3140.54,32.63,-8067.67,39.52,-2148.82,27.99,-11084.7,39.52,7415.55,39.52,3617.95,39.52,-20877.27,37.05,15372.27,37.12,8554.63,40.18,11734.03,28.01}
,{174,74,-50227.088,27.945,8027.256,0.161,-6553.992,39.52,173.946079,30,0,1992,"",126,"",0,1,"","",{"B+"},{0},{"="},{0},17272.54,39.52,8402.8,37.12,3601.85,39.52,-10231.67,29.77,-2104.27,39.52,-14744.54,39.52,9571.02,39.52,5119.52,39.52,-24908.93,29.8,11813.7,39.52,6357.24,39.52,10850.66,40.18}
,{174,75,-43673.096,27.945,7985.094,0.161,-3677.681,29.767,173.953115,30,0,144,"",2.4,"",3,1,"","",{"B+"},{0},{"="},{0},18278.62,47.97,6921.06,39.52,4039.65,39.52,-12809.6,37.05,1434.47,39.52,-14306.16,31.7,8190.55,39.52,2234.68,39.52,-29438,93,16134.9,39.52,8277.05,39.52,13693.58,39.52}
,{174,76,-39995.416,10.254,7959.461,0.059,-9131.924,26.395,173.957063152,11.008,0,44,"",4,"",0,1,"","",{"B+","A"},{0,0.024,0},{"~","="},{0,0.024,0},18894.21,16.38,5476.17,29.77,4870.5,9.69,-14677.25,14.57,1443,29.77,-17798.3,15.06,10628.48,18.13,3730.52,29.77,-33354.41,21.78,12252.5,40.32,6118.92,29.77,12737.08,29.77}
,{174,77,-30863.492,24.322,7902.483,0.14,-5545.329,26.433,173.966866676,26.111,0,7.9,"",0.6,"",3,1,"","",{"B+","A"},{0,0.5,0},{"=","="},{0,0.5,0},19626.76,40.52,3904.33,45.96,5624.79,9.85,-16628,92,5401.4,37.05,-16991.9,61.03,8666.37,26.71,714.21,28.55,"","",17091.16,27.48,8302.5,30.15,16033.19,37.05}
,{174,78,-25318.163,10.351,7866.117,0.059,-11083,89,173.972819832,11.112,0,0.889,"",0.017,"",0,1,"","",{"A"},{0},{"="},{0},20353.88,14.63,2652.26,16.45,6183.17,3.41,-18677.15,21.69,4831.12,18.19,-20557.04,25.01,11446.57,56.92,2338.7,15.12,"","",12772.01,34.02,5957.92,39.83,14630.18,20.61}
,{174,79,-14235,89,7798,1,-7594,89,173.984718,95,0,0.139,"",0.003,"",0,0,"","",{"A"},{0},{"="},{0},21060,105,1434,95,6699.29,7.24,"","",8744,90,-19597,215,9474,92,-419,105,"","",17582,90,8098,115,17823,97}
,{174,80,-6641.009,19.211,7749.784,0.11,"","",173.992870583,20.624,0,0.002,"",0.0004,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},21724.9,151.3,112.03,21.83,7233.27,6.01,"","",8012.93,59.18,"","",12003,197,1097.54,29.8,"","",13387.8,59.35,5785.34,11.5,16475.1,75.24}
,{175,67,-43203,401,8019,2,5449,566,174.95362,430,0,1.88,"",0.55,"",3.5,-1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},9995,499,"","",-1596,643,9108,404,"","",675,499,5584,499,9121,643,11963,401,11447,566,9671,499,2294,643}
,{175,68,-48652,401,8045,2,3659,404,174.94777,430,0,72,"",18,"",4.5,1,"","",{"B-"},{0},{"="},{0},11141,446,19291,566,-888,499,6044,401,-14570,643,-2859,403,4774,499,10251,499,5830,401,11409,499,7696,446,5004,499}
,{175,69,-52310.549,50,8061.766,0.286,2385,50,174.943842313,53.677,0,912,"",30,"",0.5,1,"","",{"B-"},{0},{"="},{0},12197.12,50.19,17538,302,-216.51,602.08,2855.03,50.01,-13910,302,-3437.35,50,6517.35,67.08,7650,302,98.1,57.28,12054,202,9037.12,50.16,4820,202}
,{175,70,-54695.549,0.071,8070.925,0,470.033,1.206,174.94128191,0.076,0,361584,"",86.4,"",3.5,-1,"","",{"B-"},{0},{"="},{0},13286.96,0.07,15619,196,598.49,1.56,-213.89,2.28,-10035,298,-7196.67,1.57,5822.35,0.07,8120.01,44.72,-5062.75,27.94,12271.32,4.4,7542.89,5.5,7434.47,4.01}
,{175,71,-55165.582,1.207,8069.14,0.007,-683.92,1.952,174.940777308,1.295,1,"s","","s","",3.5,1,"","",{},{},{},{},14427.3,1,13487.46,4.56,1619.8,1.55,-2756.93,27.97,-8590.04,44.74,-7392.42,1.92,7666.7,1,5510.04,1.21,-9877.27,27.97,13096.45,1.21,8953.92,1.21,7855.2,5.63}
,{175,72,-54481.662,2.282,8060.761,0.013,-2073.015,28.038,174.941511527,2.449,0,6104160,"",16416,"",0,0,"","",{"EC"},{0},{"="},{0},15212.51,28.04,11508.38,2.28,2400.23,2.28,-4848.87,28.04,-4826.12,2.28,-10812.21,28.04,6708.5,0.38,6200.44,2.19,-14376.29,11.99,13110.06,2.19,7118.37,2.79,10420.19,2.28}
,{175,73,-52408.647,27.945,8044.445,0.16,-2775.852,39.52,174.943737,30,0,37800,"",720,"",3.5,1,"","",{"B+"},{0},{"="},{0},16154.74,39.52,10105.67,27.99,2994.83,28.01,-7120.34,39.52,-4127.42,27.99,-10252.88,39.52,8739.2,39.52,3853.14,28.04,-19014.14,30.57,13713.94,39.52,8857.63,37.12,9973.73,28.04}
,{175,74,-49632.795,27.945,8024.112,0.16,-4344.488,39.52,174.946717,30,0,2112,"",36,"",0.5,-1,"","",{"B+"},{0},{"="},{0},17048.05,39.52,8798.95,39.52,3373.63,40.18,-9527.42,30.32,-1077.28,28.04,-14031.02,39.52,7477.02,39.52,5181,39.52,-23919.33,33.34,13474.55,39.52,6561.24,39.52,12415.83,37.12}
,{175,75,-45288.307,27.945,7994.816,0.16,-5182.931,30.324,174.951381,30,0,353.4,"",3,"",2.5,-1,"","",{"B+"},{0},{"="},{0},17877.08,39.52,7469.71,39.52,4007.05,39.52,-11893.8,30.57,-836.51,39.52,-13364.21,29.77,9686.53,39.52,2350.19,39.52,-27884.35,47.69,14149.88,39.52,8672.93,39.52,11688.07,39.52}
,{175,76,-40105.376,11.775,7960.729,0.067,-6710.87,17.089,174.956945105,12.64,0,84,"",6,"",2.5,-1,"","",{"B+"},{0},{"="},{0},18809.75,19.04,5955.93,30.32,4555.8,30.32,-14391.91,21.66,2832.74,30.32,-17313.2,27.02,8181.28,15.6,3721.25,30.32,-32132.8,73.84,14159.3,30.32,6295.79,40.73,14638.21,30.32}
,{175,77,-33394.506,12.384,7917.91,0.071,-7681.04,22.001,174.964149521,13.295,0,9,"",2,"",2.5,-1,"","",{"B+","A"},{0,0.85,0},{"=","="},{0,0.85,0},19268.71,16.58,4418.58,30.57,5430.86,30.57,-15990.55,40.58,2989.62,30.57,-16147.66,16.14,10602.33,27.29,688.06,16.08,"","",14754.56,19.42,8713.39,17.8,13789,40.91}
,{175,78,-25713.466,18.185,7869.548,0.104,-8309.511,42.705,174.972395457,19.522,0,2.43,"",0.04,"",3.5,-1,"","",{"A"},{0},{"="},{0},19913.19,58.86,2853.15,23.55,6163.56,3.99,-17740.89,75.13,6992.98,20.87,-19549,91,8466.62,20.92,2138.94,30.37,"","",15265.78,21.27,6529.96,37.16,17176.78,22.23}
,{175,79,-17403.955,38.64,7817.595,0.221,-9431.379,82.504,174.981316085,41.481,0,0.202,"",0.006,"",0.5,1,"","",{"A"},{0},{"="},{0},20714.15,44.86,1713.46,40.18,6583.15,3.66,"","",6170.57,45.66,-18834.26,43.15,11240,97,-625.24,40,"","",15249.76,68.02,8567.02,40.01,15621.82,50.43}
,{175,80,-7972.576,72.896,7759.231,0.417,"","",174.991441086,78.257,0,0.0106,"",0.0004,"",3.5,-1,"","",{"A","B+"},{"",1,0},{"","="},{"",1,0},21406,209,607.61,91.91,7072.21,4.66,"","",10056.62,73.63,"","",9402.88,75.39,1026,115,"","",15570.67,76.37,6209.48,92.02,18780.75,73.63}
,{176,67,-39290,503,7997,3,7340,643,175.95782,540,0,2,"",3e-07,">",0,0,"","",{"B-n"},{""},{""},{""},9743,585,"","",-1865,711,10081,513,"","",1290,643,4159,643,"","",14092,503,12791,711,9512,643,"",""}
,{176,68,-46631,401,8034,2,2741,413,175.94994,430,0,20,"",3e-07,">",0,1,"","",{},{},{},{},10824,499,19838,643,-1046,499,6861,401,"","",-2391,404,6050,566,10717,566,7946,401,9770,499,7584,499,2954,566}
,{176,69,-49371.314,100,8045.121,0.568,4120,100,175.946997711,107.354,0,111,"",1.8,"",4,1,"","",{"B-"},{0},{"="},{0},11649.44,109.54,18259,314,-313,220,4010.92,100.01,-13458,413,-2747.08,100,5132.08,111.8,8008,413,1994.06,104.62,13289,314,9147,220,5626,314}
,{176,70,-53491.314,0.015,8064.085,0,-109.078,1.212,175.942574708,0.015,1,"s","","s","",0,1,"","",{},{},{},{},12689.44,0.02,16120,298,567.38,4.01,1085.01,1.48,-12128,401,-6397.05,1.21,6867.08,0.07,8469.74,50,-2849.71,27.94,11084,44.72,7628.8,4.4,5809,196}
,{176,71,-53382.236,1.212,8059.02,0.007,1194.085,0.874,175.942691809,1.301,0,1.16255715384e+18,"",5.68024668e+15,"",7,-1,"","",{"B-"},{0},{"="},{0},13954.68,1.01,14095.67,44.74,1567.23,5.63,-2016.86,30.76,-8360.66,50.01,-6971.89,1.95,6287.97,0.15,5975.66,1.21,-8319.35,27.97,14273.08,1.21,9033.04,1.21,8520.22,4.56}
,{176,72,-54576.321,1.481,8061.359,0.008,-3210.948,30.775,175.941409905,1.59,1,"s","","s","",0,1,"","",{},{},{},{},14874.47,1.75,12209.75,1.48,2254.21,1.48,-3934.72,27.98,-7169.74,1.48,-10238.99,27.98,8165.98,1.78,6699.71,0.89,-12478.38,27.98,11704.68,1.34,7168.65,1.34,8621.31,1.48}
,{176,73,-51365.374,30.739,8038.67,0.175,-723.771,41.543,175.944857,33,0,29124,"",180,"",0,0,"","",{"B+"},{0},{"="},{0},15767.24,41.54,10373.12,30.78,2945.69,30.83,-6302.49,41.54,-3488.76,30.76,-9803.9,41.54,7028.04,41.54,4172.68,30.82,-17487.05,35.01,15189.91,30.82,8910.46,41.54,11161.94,30.78}
,{176,74,-50641.603,27.945,8030.112,0.159,-5578.718,39.52,175.945634,30,0,9000,"",360,"",0,1,"","",{"EC"},{0},{"="},{0},16557.15,39.52,9375.06,28.04,3335.71,37.12,-8543.66,39.52,-3448.91,28.04,-13424.61,39.52,9080.13,39.52,5521.93,39.52,-21707.74,30.71,11809.97,39.52,6618.99,39.52,10416.58,39.52}
,{176,75,-45062.885,27.945,7993.97,0.159,-2964.945,39.52,175.951623,30,0,318,"",18,"",3,1,"","",{"B+"},{0},{"="},{0},17532.42,39.52,7900.06,39.52,3842.18,39.52,-11184.56,32.58,56.79,39.52,-13028.83,30.32,7845.9,39.52,2719.06,39.52,-26541.92,43.38,15875.01,39.52,8528.55,39.52,12980.05,39.52}
,{176,76,-42097.94,27.945,7972.679,0.159,-8219.614,32.58,175.954806,30,0,216,"",30,"",0,1,"","",{"B+"},{0},{"="},{0},18245.16,29.77,6448.79,39.52,4574.33,39.52,-13164.07,30.71,245.88,39.52,-16774.75,30.57,10063.88,30.32,4098.6,39.52,-30312.99,30.08,12285.96,39.52,6319.98,39.52,12275.84,39.52}
,{176,77,-33878.326,16.75,7921.531,0.095,-4944.459,21.035,175.963630119,17.981,0,8.7,"",0.5,"",0,0,"","",{"B+","A"},{0,3.1,0},{"=","="},{0,3.1,0},19157.47,29.53,4783.17,32.58,5233.86,38.48,-15357.36,37.17,4121.01,32.58,-16236.18,24.72,8555.14,20.83,1061.92,20.47,-34459.92,76.93,16827.9,19.64,8423.99,22.46,15321.94,32.58}
,{176,78,-28933.867,12.724,7888.992,0.072,-10412.904,35.541,175.968938214,13.66,0,6.33,"",0.15,"",0,1,"","",{"A"},{0},{"="},{0},19758.34,16.4,3516.39,16.33,5885.06,2.13,-17148.92,16.9,3882.54,17.33,-19601.23,40.68,11291.72,22.19,2828.33,17.76,"","",12640.43,27.45,6198.62,15.23,14150.79,19.64}
,{176,79,-18520.963,33.185,7825.383,0.189,-6736.013,34.998,175.980116927,35.625,0,1.05,"",0.01,"",3,-1,"","",{"A"},{0},{"="},{0},20428,95,2235.41,41.14,6433.49,7.16,-19102.56,82.09,7584.57,35.42,-18619.7,80.09,9188.33,50.93,96.47,37.84,"","",17508.01,34.76,8286,65.07,17393.87,34.97}
,{176,80,-11784.95,11.119,7782.665,0.063,-12366.544,75.904,175.987348335,11.937,0,0.0203,"",0.0014,"",0,1,"","",{"A"},{0},{"="},{0},21286.58,22.19,1044.73,15.17,6897.05,5.55,"","",6639.55,21.32,"","",11883.69,73.74,1669.97,40.21,"","",13161,90,5911.54,20.7,15804.36,57.06}
,{176,81,581.594,75.086,7707.955,0.427,"","",176.000624367,80.607,0,0.0062,"",0.0023,"",3,-1,"","",{"p"},{0},{"~"},{0},"","",-239,116,7474.68,93.76,"","",10696.58,84.44,"","","","",-1265.2,18,"","",17933.41,77.5,8155,210,19060.44,78.47}
,{177,68,-42858,503,8013,3,4611,585,176.95399,540,0,3,"",3e-07,">",0.5,-1,"","",{},{},{},{},10349,643,"","",-1344,643,8128,503,"","",-1558,513,4299,643,10857,711,10023,503,11055,643,7696,585,4159,711}
,{177,69,-47469,298,8035,2,3517,298,176.94904,320,0,90,"",6,"",3.5,-1,"","",{"B-"},{0},{"="},{0},11301,302,18844,499,-543,422,4915,298,-15467,585,-2049,298,6169,314,8127,499,4246,298,11894,499,9345,422,3867,422}
,{177,70,-50986.397,0.22,8049.973,0.001,1397.409,1.24,176.945263848,0.236,0,6879.6,"",10.8,"",4.5,1,"","",{"B-"},{0},{"="},{0},12433.48,0.23,16912,401,243,196,1894.22,1.42,-11645,401,-5675.48,1.23,5566.4,0.22,8904.05,100,-1284.67,27.95,12034.96,50,7742.17,44.72,6609,298}
,{177,71,-52383.806,1.22,8053.448,0.007,496.81,0.791,176.943763668,1.31,0,574188.48,"",224.64,"",3.5,1,"","",{"B-"},{0},{"="},{0},13360.86,0.22,14651.2,50.01,1447.34,4.57,-669.19,3.1,-10301.46,100.01,-5878.8,0.88,7072.89,0.16,6181.46,1.22,-6114.64,27.97,13022.55,1.22,9424.76,1.22,7127.11,44.74}
,{177,72,-52880.616,1.408,8051.835,0.008,-1166,3,176.94323032,1.511,1,"s","","s","",3.5,-1,"","",{},{},{},{},14541.59,1.99,12763.01,1.41,2245.69,1.41,-3178.89,27.98,-6678.27,1.41,-9586.56,30.77,6375.61,1.02,6787.35,0.8,-10924.15,14.68,12995.77,0.81,7553.63,1.29,9710.3,1.41}
,{177,73,-51714.616,3.314,8040.827,0.019,-2012.89,28.141,176.944482073,3.557,0,203616,"",216,"",3.5,1,"","",{"B+"},{0},{"="},{0},15448.6,28.14,11126.98,3.11,2741.38,3.27,-5445.45,28.14,-5621.35,3.1,-9144.33,28.14,8420.56,30.92,4427.26,3.17,-15667.19,20.04,13477.85,3.6,8993.92,3.58,9501.98,3.27}
,{177,74,-49701.726,27.945,8025.035,0.158,-3432.555,39.52,176.946643,30,0,7920,"",120,"",0.5,-1,"","",{"B+"},{0},{"="},{0},16211.56,39.52,9798.01,28.04,3285.14,39.52,-7745.26,31.53,-2414.37,27.98,-12710.16,39.52,7131.44,39.52,5625.32,41.54,-20331.28,31.71,13417.73,39.52,6903.1,39.52,11789.16,28.04}
,{177,75,-46269.17,27.945,8001.222,0.158,-4312.708,31.535,176.950328,30,0,840,"",60,"",2.5,-1,"","",{"B+"},{0},{"="},{0},17123.5,39.52,8438.46,39.52,3702.45,39.52,-10221.75,34.23,-2192.77,41.54,-12242.55,39.52,9277.6,39.52,2916.54,39.52,-24724.07,29.85,14074.43,39.52,8821.97,39.52,11118,39.52}
,{177,76,-41956.462,14.613,7972.436,0.083,-5909.041,24.576,176.954957882,15.687,0,180,"",12,"",0.5,-1,"","",{"B+"},{0},{"="},{0},17993.72,18.76,6901.61,31.53,4346.01,31.53,-12586.02,20.93,1396.17,31.53,-16149.45,22.23,7929.84,31.53,4182.55,31.53,-29173.92,76.47,14042.65,31.53,6580.69,31.53,13917.03,31.53}
,{177,77,-36047.421,19.76,7934.632,0.112,-6676.976,24.801,176.9613015,21.213,0,30,"",2,"",2.5,-1,"","",{"B+","A"},{0,0.06,0},{"~","="},{0,0.06,0},18795.55,23.32,5337.05,34.23,5081.53,34.23,-14502.32,22.37,1726.49,34.23,-15184.87,23.5,10240.41,25.9,1238.45,34.23,-32706.89,29.3,14768.76,23,8812.05,22.26,13272.08,34.23}
,{177,78,-29370.444,14.988,7892.489,0.085,-7825.341,18.297,176.968469529,16.09,0,10.6,"",0.4,"",2.5,-1,"","",{"B+","A"},{0,5.7,0},{"=","="},{0,5.7,0},19799.61,23.56,3843.01,19.06,5642.9,2.73,-16587.9,76.54,5438.53,31.71,-18920.8,36.41,8507.89,19.66,2781.09,22.48,"","",14734.87,19.44,6357.1,28.57,16271.37,18.16}
,{177,79,-21545.103,10.496,7843.858,0.059,-8762.561,75.786,176.976870379,11.268,0,1.46,"",0.03,"",0.5,1,"","",{"A"},{0},{"="},{0},20283.78,40.04,2728.54,16.23,6298.42,3.89,-18204.58,24.04,5044.25,19.77,-17831.47,15.29,11095.46,34.81,-99.79,14.82,"","",14879.17,21,8637.12,14.74,14964.79,26.49}
,{177,80,-12782.542,75.056,7789.932,0.424,-9442.016,78.098,176.986277376,80.575,0,0.1273,"",0.0018,"",3.5,-1,"","",{"A","B+"},{0,15,0},{"=","="},{0,15,0},20952.6,104.63,1647.02,77.23,6735.45,50,"","",8862.35,76.13,-21435.45,106.17,9068.91,75.87,1550.55,82.06,"","",15332.22,84.42,6317,116,18182.02,75.77}
,{177,81,-3340.526,21.629,7732.167,0.122,"","",176.996413797,23.219,0,0.018,"",0.005,"",0.5,1,"","",{"A","p"},{"",27,""},{"=","="},{"",27,""},"","",514.51,44.28,7067,7.16,"","",7891.47,39.61,"","",11993.44,78.14,-1155.45,19.42,"","",15342.86,76.04,8164.54,28.93,16541,91}
,{178,68,-40260,596,7999,3,3855,718,177.956779,640,0,1,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},9772,718,"","",-1315,780,9435,596,"","",-862,667,5473,780,"","",12175,596,9741,780,7807,718,"",""}
,{178,69,-44116,401,8016,2,5580,401,177.95264,430,0,30,"",3e-07,">",0,0,"","",{},{},{},{},10887,413,19403,643,-851,499,6222,401,"","",-1200,401,4718,499,8546,643,6483,404,13226,566,9400,566,4734,566}
,{178,70,-49695.475,10,8042.841,0.056,642.309,10.25,177.94664971,10.735,0,4440,"",180,"",0,1,"","",{"B-"},{0},{"="},{0},12346.79,10,17643,401,-171,298,2739.76,10.1,-14126,503,-5382.99,10.07,6780.39,10,9516,298,711.46,18.19,10386.65,100.5,7479.13,50.99,4603,401}
,{178,71,-50337.784,2.251,8042.054,0.013,2097.451,2.057,177.945960162,2.416,0,1704,"",12,"",0,0,"","",{"B-"},{0},{"="},{0},13098.18,1.9,15544.41,100.03,1101.81,44.78,260,52,-10158,298,-5528.49,2.05,6025.3,1.89,6640.36,2.26,-4684.33,28.04,13864.34,2.25,9221.82,2.25,7619.17,50.05}
,{178,72,-52435.236,1.412,8049.442,0.008,-1837,52,177.943708456,1.516,1,"s","","s","",0,1,"","",{},{},{},{},14001.55,1.02,13521.86,1.41,2084.36,1.41,-2028.3,15.13,-8737.81,1.43,-8791.94,3.01,7625.94,0.18,7340.4,0.8,-8890.97,13.7,11657.81,0.81,7594.4,0.82,7906.71,1.41}
,{178,73,-50598,52,8035,0,-191,50,177.945681,56,0,8496,"",288,"",7,-1,"","",{"B+"},{0},{"="},{0},15375,61,11794,52,2547,52,-4945,59,-5503,52,-8968,59,6955,52,5007,52,-14346,56,14689,52,8747,52,10214,52}
,{178,74,-50406.936,15.199,8029.257,0.085,-4753.483,31.81,177.945885925,16.316,0,1866240,"",25920,"",0,1,"","",{"EC"},{0},{"="},{0},15907.97,31.81,10408.56,15.17,3012.63,15.26,-6862.67,20.42,-4815.29,15.13,-12209.08,31.81,8776.53,31.81,5981.29,15.43,-18409.42,18.27,11669.24,34.29,6865.77,31.81,9721.13,15.26}
,{178,75,-45653.453,27.945,7998.157,0.157,-2109.183,31.093,177.950989,30,0,792,"",12,"",3,1,"","",{"B+"},{0},{"="},{0},16733.2,39.52,8866.02,41.54,3662.4,39.52,-9401.57,34.23,-1227.81,28.14,-11768.31,31.53,7455.6,39.52,3240.7,39.52,-23349.71,29.71,15698.96,39.52,8843.4,39.52,12401.6,39.52}
,{178,76,-43544.27,13.632,7981.912,0.077,-7292.386,24.006,177.9532533,14.634,0,300,"",24,"",0,1,"","",{"B+"},{0},{"="},{0},17588.96,31.09,7480.61,31.09,4257.9,31.09,-11546.75,16.97,-1131.52,31.09,-15568.17,24.01,9659.13,19.98,4564.07,31.09,-27228.37,17.37,12229.42,31.09,6608.09,31.09,11734.93,31.09}
,{178,77,-36251.884,19.76,7936.549,0.111,-4254.365,22.207,177.961082,21.213,0,12,"",2,"",0,0,"","",{"B+"},{0},{"="},{0},18516.19,25.9,5766.94,34.23,4996.3,34.23,-13948.14,22.19,2728.32,34.23,-14952.76,24.8,8275.78,27.94,1584.39,24.58,-31462,92,16556.86,34.23,8717.55,23,14682.82,34.23}
,{178,78,-31997.519,10.133,7908.252,0.057,-9693.776,14.297,177.965649248,10.878,0,20.7,"",0.7,"",0,1,"","",{"B+","A"},{0,7.7,0},{"=","="},{0,7.7,0},19206.29,16.25,4477.52,29.73,5572.98,2.2,-15681.62,14.79,2669.97,17.78,-18523.73,14.59,10698.39,18.09,3239.07,22.21,-35571.81,26.02,12591.61,19.58,6261.04,16,13754.26,15.53}
,{178,79,-22303.743,10.086,7849.398,0.057,-5987.841,14.755,177.976055945,10.827,0,2.6,"",0.5,"",0,0,"","",{"B+","A"},{0,40,0},{"<",">"},{0,40,0},19925.41,34.68,3003.36,19.55,6134.83,25.41,-17513,90,6454.71,22.19,-17592.52,75.73,8829.96,14.56,222.27,18.07,"","",17340.93,16.24,8273.78,20.79,16737.16,15.97}
,{178,80,-16315.901,10.77,7811.363,0.061,-11526,90,177.982484158,11.562,0,0.2665,"",0.0024,"",0,1,"","",{"A"},{0},{"="},{0},20673.59,15.46,1959.98,16.67,6577.35,2.98,-19890.2,26.16,5765.57,18.46,-21046.69,24.14,11604.68,75.82,2059.77,15.04,"","",12915.87,34.89,5952.11,40.11,15043.97,21.14}
,{178,81,-4790,89,7742,1,-8365,91,177.994857,96,0,0.255,"",0.009,"",4,-1,"","",{"A","B+","B+SF"},{0,38,0,0.15,0},{"=","=","="},{0,38,0,0.15,0},21515,117,847,95,7020.04,10.23,"","",9466,90,"","",9521,92,-703,117,"","",17705,90,8046,115,18260,97}
,{178,82,3574.294,23.963,7690.83,0.135,"","",178.003837163,25.724,0,0.00023,"",0.00015,"",0,1,"","",{"A"},{0},{"~"},{0},"","",-781.3,26.41,7790.39,14.32,"","",9067.87,78.79,"","","","",374.15,32.28,"","",13703.51,78.82,"","",17193.27,76.73}
,{179,69,-41601,503,8002,3,4937,540,178.95534,540,0,20,"",3e-07,">",0.5,1,"","",{"B-n"},{0},{"="},{0},10274,585,"","",-823,643,7458,503,"","",24,503,5556,643,8629,780,8757,503,11968,711,9894,643,3336,711}
,{179,70,-46537,196,8025,1,2521,196,178.95004,210,0,480,"",24,"",0.5,-1,"","",{"B-"},{0},{"="},{0},11694,196,18257,540,-310,446,3925,196,-13566,627,-4271,196,4913,196,9711,446,2758,196,11642,357,7698,220,5740,446}
,{179,71,-49058.918,5.15,8035.073,0.029,1403.989,5.067,178.947333082,5.528,0,16524,"",216,"",3.5,1,"","",{"B-"},{0},{"="},{0},12817.75,5,16168,298,826.72,50.26,1298.4,5.08,-12232,401,-4695,5.07,6792.45,5.35,6652.41,11.25,-2474.64,25.16,12638.29,5.15,9296.45,5.15,5958.8,100.13}
,{179,72,-50462.907,1.413,8038.546,0.008,-105.584,0.409,178.945825838,1.517,1,"s","","s","",4.5,1,"","",{},{},{},{},13724.93,0.19,14054.45,1.43,1807.73,1.41,-1167.78,14.51,-8056.4,10.1,-7936,52,6098.99,0.08,7414.09,2.05,-7443.41,16.56,12631.71,0.81,7783.38,0.81,8674.81,1.41}
,{179,73,-50357.323,1.463,8033.585,0.008,-1062.195,14.52,178.945939187,1.571,0,57433605.32,"",946707.78,"",3.5,1,"","",{"EC"},{0},{"="},{0},14785.34,3.03,12551.46,0.9,2383.34,0.92,-3773.04,24.66,-7308.51,2.09,-8021.7,15.14,7830,52,5211.06,0.42,-12275.61,9.88,13234.1,0.45,9083.05,1.1,8671.32,0.91}
,{179,74,-49295.127,14.573,8023.281,0.081,-2710.847,26.802,178.947079501,15.644,0,2223,"",9.6,"",3.5,-1,"","",{"B+"},{0},{"="},{0},15736.04,31.52,10992.45,14.52,2761.62,14.65,-6275.63,22.02,-4148.86,14.51,-11712.99,31.52,6959.51,20.97,5986,54,-17026.98,16.61,13130.29,14.82,6934.3,34.02,10927.6,14.55}
,{179,75,-46584.28,24.639,8003.766,0.138,-3564.785,29.656,178.949989715,26.45,0,1170,"",6,"",2.5,1,"","",{"B+"},{0},{"="},{0},16457.74,37.26,9447.61,24.84,3399.45,37.26,-8502.57,26.51,-3275,58,-11111.33,28.16,9002.14,37.26,3466.31,28.93,-21595.71,27.27,13828.25,37.26,8921.38,37.26,10427.5,39.4}
,{179,76,-43019.495,16.504,7979.48,0.092,-4937.781,19.18,178.953816669,17.718,0,390,"",18,"",0.5,-1,"","",{"B+"},{0},{"="},{0},17205.67,22.04,7895.71,32.45,4188.38,32.45,-10751.35,18.33,98.47,22.44,-14838.93,25.75,7546.54,21.4,4655.01,32.45,-26091.36,31.87,13960.48,32.45,6907.45,32.45,13268.51,32.45}
,{179,77,-38081.714,9.771,7947.524,0.055,-5813.569,12.613,178.959117596,10.489,0,79,"",1,"",0,0,"","",{"B+"},{0},{"="},{0},18176.93,22.04,6390.49,29.6,4781.68,29.6,-13093.15,15.24,282.77,29.6,-14155.51,14.08,9901.15,22.04,1826.41,16.77,-29813.22,40.01,14585.55,17.58,8880.28,29.6,12627.57,29.6}
,{179,78,-32268.145,7.977,7910.675,0.045,-7279.578,14.157,178.965358719,8.563,0,21.2,"",0.4,"",0.5,-1,"","",{"B+","A"},{0,0.24,0},{"~","="},{0,0.24,0},19040.34,16.98,4889.62,16.64,5412.31,9.46,-15340.01,28.4,3987.15,15.79,-18035.72,12.86,8341.94,12.88,3305.23,21.31,-34318.78,76.01,14490.08,21.31,6474.24,18.55,15476.2,29.06}
,{179,79,-24988.567,11.696,7865.637,0.065,-8060.433,29.669,178.973173668,12.555,0,7.1,"",0.3,"",0.5,1,"","",{"B+","A"},{0,22,0},{"=","="},{0,22,0},19586.1,15.71,3519.09,22.96,5981.02,5.05,-16720.07,40.52,3974.35,22.96,-16743.98,15.9,10756.14,15.44,280.02,15.47,"","",15092.68,19.01,8809.35,17.28,14536.16,20.43}
,{179,80,-16928.134,27.267,7816.236,0.152,-8659.639,47.417,178.981826899,29.272,0,1.05,"",0.03,"",3.5,-1,"","",{"A","B+p"},{0,0.15,0},{"=","~"},{0,0.15,0},20288.23,79.86,2135.63,31.11,6360.42,29.74,-18978.77,80.36,7780.41,29.08,-20209,94,8683.55,29.32,1913.36,29.07,"","",15327.78,29.22,6456.88,42.95,17652.13,30.08}
,{179,81,-8268.495,38.793,7763.487,0.217,-10319.134,84.963,178.991123405,41.646,0,0.265,"",0.01,"",0.5,1,"","",{"A"},{0},{"="},{0},21070.6,44.42,1301.33,40.19,6710.54,3.45,"","",6746.28,40.08,-19914.11,45.6,11549,98,-758.44,40.26,"","",15224.85,84.49,8380.51,40.36,15898.87,51.05}
,{179,82,2050.639,75.59,7701.468,0.422,"","",179.002201452,81.149,0,0.0039,"",0.0011,"",4.5,-1,"","",{"A"},{0},{"="},{0},"","",-255.24,106.52,7598.3,20,"","",11077.57,76.35,"","",9594.97,79.3,448,117,"","",16101.97,78.62,6333.1,26.91,19481.99,76.4}
,{180,69,-37920,503,7982,3,6680,585,179.959291,540,0,5,"",3e-07,">",0,0,"","",{"B-n"},{0},{"="},{0},9947,643,"","",-1055,711,8756,508,"","",546,540,4391,711,"","",11013,503,13051,780,9802,711,"",""}
,{180,70,-44600,298,8015,2,2076,306,179.95212,320,0,144,"",30,"",0,1,"","",{"B-"},{0},{"="},{0},11047,298,18918,667,-394,499,5179,298,"","",-3612,298,6134,357,10288,585,5036,298,10226,499,7733,422,3905,585}
,{180,71,-46676.348,70.725,8022.038,0.393,3103,70.711,179.949890876,75.926,0,342,"",6,"",5,1,"","",{"B-"},{0},{"="},{0},12481.2,70.74,17139,407,270.05,122.48,2256.53,70.75,-12365,508,-4284.76,70.71,5688.75,70.89,7428,208,-838.99,73.89,13729.93,71.43,9174.1,70.73,6439,306}
,{180,72,-49779.348,1.419,8034.93,0.008,-846.471,2.269,179.946559669,1.522,1,"s","","s","",0,1,"","",{},{},{},{},13486.75,0.17,14661.81,10.1,1287.05,1.42,-143.23,0.28,-10531,196,-7493.34,0.44,7387.76,0.15,8009.4,5.06,-5421.54,16.45,11269.24,2.06,7468.51,0.81,6853.45,1.44}
,{180,73,-48932.877,1.939,8025.881,0.011,703.238,2.281,179.947468392,2.081,0,29354.4,"",21.6,"",1,1,"","",{"EC","B-"},{0,15,0},{"=","="},{0,15,0},14477,52,13173.03,2.9,2024.44,2.19,-3095.52,21.48,-7162.93,5.46,-7709.07,14.68,6646.87,2.29,5758.94,2.27,-10955.35,21.79,14213.16,2.26,8811.79,2.26,9097.33,2.19}
,{180,74,-49636.115,1.436,8025.442,0.008,-3798.757,21.44,179.946713435,1.542,0,5.68024668e+25,"",6.3113852e+24,"",0,1,"","",{"A"},{0},{"~"},{0},15371.81,15.14,11778.82,0.32,2515.29,1.03,-5278.31,16.45,-6462.18,0.31,-11123.15,24.66,8412.31,14.51,6567.76,0.52,-15200.24,11.07,11673,52,6942.56,3.02,8890.9,0.37}
,{180,75,-45837.359,21.392,7999.991,0.119,-1479.549,26.95,179.950791568,22.965,0,147.6,"",1.8,"",0,0,"","",{"B+"},{0},{"="},{0},16326.54,35.19,9817,56,3103.1,37.45,-7859.83,30.48,-2769.01,21.44,-10889.18,27.02,7324.4,32.63,3831.2,25.88,-20211.85,21.92,15280.38,26.24,8728.42,35.19,11523.66,21.65}
,{180,76,-44357.81,16.391,7987.425,0.091,-6380.284,27.2,179.95237993,17.596,0,1290,"",24,"",0,1,"","",{"B+"},{0},{"="},{0},16956.17,21.31,8528.82,22.35,3858.88,32.4,-9921.93,19.72,-2351.65,21.93,-14347.41,19.08,9409.63,23.26,5062.5,29.59,-24107.36,20.7,12006.45,32.4,6775.42,32.4,10990.32,32.4}
,{180,77,-37977.526,21.706,7947.633,0.121,-3541.649,24.323,179.959229446,23.302,0,90,"",6,"",5,1,"","",{"B+"},{0},{"="},{0},17868.28,29.35,6902.01,35.38,4660.44,35.38,-12352.02,22.23,1317.78,32.84,-13780.7,23.13,7967.13,23.8,2247,27.27,-28590.88,63.82,16277.55,25.63,8842.99,26.17,13938.05,35.38}
,{180,78,-34435.877,10.974,7923.611,0.061,-8810.368,11.973,179.963031563,11.781,0,56,"",3,"",0,1,"","",{"B+","A"},{0,0.3,0},{"~","~"},{0,0.3,0},18580.99,14.92,5469.55,17.48,5237.15,30.02,-14185.43,16.73,1294.65,19.81,-17518.63,16.04,10239.05,13.55,3643.13,14.69,-32494.5,16.56,12526.81,22.6,6475.6,22.6,13166.99,18.27}
,{180,79,-25625.509,4.786,7870.318,0.027,-5375.062,13.524,179.972489883,5.137,0,8.4,"",0.6,"",0,0,"","",{"B+","A"},{0,1.8,0},{"<",">"},{0,1.8,0},19464.4,11.16,3951.57,20.33,5827.9,16.61,-16238.86,60.2,5167.23,10.88,-16768.69,27.68,8708.26,12.64,646.33,9.3,"","",17082.82,11.21,8608.99,15.73,16068.31,20.33}
,{180,80,-20250.447,12.649,7836.11,0.07,-10863.8,61.329,179.978260249,13.579,0,2.59,"",0.01,"",0,1,"","",{"B+","A"},{0,48,0},{"=","="},{0,48,0},20077.18,16.61,2830.87,16.2,6258.5,2.37,-18309.07,17.71,4728.73,14.95,-20053.27,40.8,11393.63,30.05,2550.85,17.23,"","",12764.1,16.18,6158.71,14.73,14766.4,19.61}
,{180,81,-9386.647,60.01,7771.409,0.333,-7445.267,61.277,179.989923019,64.423,0,1.09,"",0.01,"",0,0,"","",{"B+","A","B+SF"},{0,6,"",0.0032,0},{"=","=","="},{0,6,"",0.0032,0},20739,108,1660.85,60.85,6709.4,50,"","",8312.95,61.14,-19508.6,96.51,9189.47,71.46,-252.52,65.91,"","",17640.06,60.97,8259.95,96.1,17804.86,60.92}
,{180,82,-1941.38,12.396,7725.7,0.069,"","",179.997915842,13.307,0,0.0041,"",0.0003,"",0,1,"","",{"A"},{0},{"="},{0},21658.31,26.98,203.42,16.4,7418.65,5.48,"","",7697.78,29.95,"","",12063.34,76.6,961.86,40.73,"","",13560,90,6263.2,20.18,16487.56,76.06}
,{181,69,-35170,596,7967,3,5918,667,180.962243,640,0,5,"",3e-07,">",0.5,1,"","",{"B-n"},{""},{""},{""},9713,780,"","","","",9627,609,"","",1358,667,5322,780,"","",13268,596,"","",9954,843,"",""}
,{181,70,-41088,298,7996,2,3709,324,180.95589,320,0,60,"",3e-07,">",1.5,-1,"","",{},{},{},{},10693,357,"","",-655,585,6315,298,"","",-2483,306,4560,422,10457,585,7146,298,11223,585,7891,499,4818,667}
,{181,71,-44797.41,125.752,8011.929,0.695,2605.421,125.76,180.951908,135,0,210,"",18,"",3.5,1,"","",{"B-"},{0},{"="},{0},11881.13,125.86,17775,518,247,324,3640.9,125.76,-14166,518,-3089.38,125.76,6192.38,144.28,7486,324,1719.98,126.38,12451,233,9762.12,126.15,4965,420}
,{181,72,-47402.831,1.42,8022.002,0.008,1035.48,1.834,180.949110965,1.524,0,3662496,"",5184,"",0.5,-1,"","",{"B-"},{0},{"="},{0},13082.56,0.17,15443,196,1158.65,1.44,830.99,0.33,-10092,298,-6541.27,2.27,5694.8,0.07,8015.45,70.71,-3852.87,25.38,12366.89,5.06,7799.01,2.06,7939.05,10.1}
,{181,73,-48438.311,1.403,8023.4,0.008,-204.493,1.854,180.947999331,1.506,1,"s","","s","",3.5,1,"","",{},{},{},{},14223.62,1.86,13957.33,5.3,1520.58,1.74,-1920.92,12.61,-9050.93,70.73,-6873.51,1.85,7576.75,1.34,5947.93,1.83,-8975.28,5.43,12735.4,1.83,8860.98,1.83,7545.88,2.57}
,{181,74,-48233.818,1.445,8017.948,0.008,-1716.427,12.629,180.948218863,1.551,0,10471680,"",17280,"",4.5,1,"","",{"EC"},{0},{"="},{0},15081.33,14.51,12348.85,0.35,2221.88,0.4,-4683.85,25.38,-5743.44,0.32,-10467.78,21.44,6669.02,0.16,6589.91,2.29,-13852.31,13.76,12834.31,0.54,7228,52,9847.82,0.36}
,{181,75,-46517.391,12.549,8004.143,0.069,-2967.428,28.275,180.950061523,13.471,0,71640,"",2520,"",2.5,1,"","",{"B+"},{0},{"="},{0},16075.75,27.65,10738.01,12.63,2772.31,12.98,-7054.36,13.6,-4873.48,12.68,-10230.9,20.64,8751.35,24.8,4170.25,12.63,-18646.26,23.59,13488.54,19.23,8753.6,19.71,9727,54}
,{181,76,-43549.963,25.338,7983.426,0.14,-4086.935,25.876,180.953247188,27.201,0,6300,"",180,"",0.5,-1,"","",{"B+"},{0},{"="},{0},16673.1,30.24,8832.78,29.23,3726.85,37.72,-9168.45,28.8,-1202.82,25.38,-13643.75,33.36,7263.47,30.18,5001.58,33.16,-22888.83,29.64,13745.12,35.34,6967.54,37.72,12503.37,29.55}
,{181,77,-39463.028,5.245,7956.523,0.029,-5081.517,14.66,180.957634694,5.631,0,294,"",9,"",2.5,-1,"","",{"B+"},{0},{"="},{0},17523.95,11.09,7456.69,25.19,4381.23,28.43,-11591.89,20.65,-914.64,22.03,-13098.47,12.16,9556.82,22.33,2394.19,17.21,-26664.29,10.51,14267.27,17.32,8945.3,14.61,11836.83,28.43}
,{181,78,-34381.511,13.689,7924.126,0.076,-6510.375,24.216,180.963089927,14.695,0,52,"",2.2,"",0.5,-1,"","",{"B+","A"},{0,0.074,0},{"~","="},{0,0.074,0},18256,15.84,5939.96,21.44,5150.03,5.11,-13720.38,20.59,2687.33,21.35,-16827.32,14.5,8016.95,17.54,3692.96,25.66,-31264.16,76.64,14411.01,16.82,6734.43,24.04,14809.16,19.31}
,{181,79,-27871.136,19.976,7883.835,0.11,-7210,25.212,180.970079103,21.445,0,13.7,"",1.4,"",1.5,-1,"","",{"B+","A"},{"",2.7,0},{"","="},{"",2.7,0},19025.2,23.15,4367.36,22.24,5751.37,2.93,-15072.4,21.95,2817.42,29.5,-15692.01,23.64,10316.94,20.54,724.23,22.79,"","",15107.82,21.51,8990.44,22.4,14027.15,28.1}
,{181,80,-20661.136,15.382,7839.679,0.085,-7862.401,17.876,180.977819357,16.513,0,3.6,"",0.1,"",0,0,"","",{"B+","A","B+p","B+A"},{0,27,0,0.013,0,9,0},{"=","=","=","="},{0,27,0,0.013,0,9,0},19875.64,31.3,2970.93,17.32,6284.39,4.21,-17543.79,76.96,6485.77,18.89,-19345.81,61.95,8482.01,19.91,2324.6,16.11,"","",15038.24,19.32,6506.66,18.39,16982.78,18.42}
,{181,81,-12798.735,9.108,7791.918,0.05,-9681.385,75.959,180.986259992,9.778,0,3.2,"",0.3,"",0.5,1,"","",{"A"},{0},{"<"},{0},20672.87,39.85,2388.11,14.82,6321.45,5.77,"","",5537.8,10.29,-18928.67,15.38,11483.4,60.7,-162.74,13.71,"","",14840.21,28.75,8381.22,14.11,15151.41,13.59}
,{181,82,-3117.35,75.411,7734.107,0.417,"","",180.996653386,80.957,0,0.039,"",0.0008,"",4.5,-1,"","",{"A","B+"},{"",2,0},{"","="},{"",2,0},21310.62,106.77,767.16,80.19,7240.28,7.31,"","",9844.13,76.46,"","",9247.29,76.41,1019.67,96.37,"","",15861.95,84.8,6537,117,18844.95,76.18}
,{182,70,-38820,401,7984,2,3060,446,181.958325,430,0,10,"",3e-07,">",0,1,"","",{},{},{},{},10363,499,"","",-985,718,7229,401,"","",-2094,420,5803,499,10939,718,9426,401,9811,643,7645,643,"",""}
,{182,71,-41880,196,7996,1,4170,196,181.95504,210,0,120,"",12,"",1,-1,"","",{"B-"},{0},{"="},{0},11346,208,18538,540,-189,446,4550,196,-13999,627,-2548,196,5154,233,8081,357,3566,221,13431,357,9522,277,5367,540}
,{182,72,-46049.508,6.165,8014.837,0.034,380.425,6.274,181.950563816,6.618,0,2.808566414e+14,"",2840123340000,"",0,1,"","",{"B-"},{0},{"="},{0},12412.79,6,16028,298,1221.05,11.75,2196.55,6.2,-12250,298,-5682.51,6.27,6717.99,6,8541.07,125.9,-1440.4,22.6,11337.65,70.96,7873.46,7.85,6134,196}
,{182,73,-46429.934,1.405,8012.628,0.008,1816.126,1.399,181.950155413,1.508,0,9913536,"",10368,"",3,-1,"","",{"B-"},{0},{"="},{0},13639.69,1.34,14331.53,70.73,1482.94,2.57,-983.87,101.99,-8921.49,125.76,-6267.43,1.86,6062.94,0.11,6316.07,1.84,-7378.26,21.01,14060.22,1.83,8897.03,1.83,8275.39,5.3}
,{182,74,-48246.06,0.738,8018.308,0.004,-2800,101.98,181.948205721,0.791,1,"s","","s","",0,1,"","",{},{},{},{},14752.58,1.59,13044.65,1.57,1764.26,1.56,-3636.96,21.76,-8132.2,1.57,-9799.99,12.54,8083.56,1.6,7096.72,1.4,-12077.61,13.11,11397.62,1.93,6975.32,1.61,7863.25,1.57}
,{182,75,-45446.06,101.983,7998.625,0.56,-836.955,104.276,181.951211645,109.483,0,231120,"",1800,"",7,1,"","",{"B+"},{0},{"="},{0},15751.34,104.2,11091.12,102,2727,115,-6394.38,104.12,-4296.72,101.99,-9967.41,105.08,6999.99,102.75,4501.21,101.99,-17145.29,103.98,14900.86,101.99,8713.12,103.02,10557.66,101.99}
,{182,76,-44609.104,21.745,7989.728,0.119,-5557.426,30.207,181.952110153,23.344,0,78624,"",720,"",0,1,"","",{"EC"},{0},{"="},{0},16393.93,27.23,9550.93,21.79,3372.92,26.53,-8440.66,25.38,-3664.26,21.79,-13217.39,22.37,9130.46,33.39,5380.68,25.11,-21032.18,23.85,11939.06,30.5,6839.23,32.86,10332.42,26.18}
,{182,77,-39051.679,20.967,7954.894,0.115,-2883.23,24.72,181.958076296,22.509,0,900,"",60,"",3,1,"","",{"B+"},{0},{"="},{0},17216.79,30.18,7792.26,29.95,4176.86,34.94,-10750.91,29.16,176.74,24.44,-12741.48,25.04,7659.97,21.61,2790.69,32.89,-25723.75,24.08,16016.94,26.61,8831.87,26.68,13179,32.35}
,{182,78,-36168.449,13.095,7934.754,0.072,-7867.68,24.123,181.961171571,14.057,0,160.2,"",7.2,"",0,1,"","",{"B+","A"},{0,0.038,0},{"~","="},{0,0.038,0},17875.21,17.07,6388.58,20.97,4950.91,5.05,-12591.53,16.33,92.54,28.52,-16368.63,23.89,9858.25,18.94,3994.39,14.11,-29343.34,17.83,12519.88,25.35,6777.32,16.34,12497.45,21.06}
,{182,79,-28300.768,20.26,7887.226,0.111,-4723.846,22.501,181.969617874,21.749,0,15.5,"",0.4,"",2,1,"","",{"B+","A"},{0,0.13,0},{"~","="},{0,0.13,0},18817.89,20.82,4901.18,29.69,5526.2,4.47,-14972.84,23.47,3873.29,20.93,-15710.95,25.44,8500.95,28.45,1208.23,24.45,"","",16845.91,23.04,8831.43,21.77,15427.35,22.49}
,{182,80,-23576.922,9.79,7856.972,0.054,-10248.994,15.363,181.974689132,10.51,0,10.83,"",0.06,"",0,1,"","",{"B+","A","B+p"},{0,13.8,0,1,0},{"=","=","<"},{0,13.8,0,1,0},19469.11,15.98,3718.99,14.68,5995.68,4.65,-16751.81,15.56,3515.62,16.82,-18849.5,13.37,10987.1,18.23,2994.76,22.25,"","",12759.39,10.9,6275.7,15.25,14337.63,12.61}
,{182,81,-13327.927,11.839,7796.36,0.065,-6502.815,16.927,181.98569188,12.709,0,1.9,"",0.1,"",2,-1,"","",{"B+","A","B+SF"},{0,0.49,0,3.4,0},{"~","<","<"},{0,0.49,0,3.4,0},20083.91,61.17,2280.36,12.77,6550.9,6.2,"","",7254.24,23.22,-18281.89,76.33,8600.51,14.94,-44.24,19.41,"","",17633.33,17.33,8464.26,29.73,17307.04,16.64}
,{182,82,-6825.112,12.098,7756.332,0.066,"","",181.99267294,12.987,0,0.055,"",0.005,"",0,1,"","",{"A","B+"},{"",2,0},{"","="},{"",2,0},21026.37,17.3,1152.61,17.5,7065.87,5.51,"","",6547.05,19.57,"","",11779.08,76.37,1315.35,15.14,"","",13272.34,61.22,6307.44,40.64,15749.42,29.83}
,{183,70,-35100,401,7964,2,4616,408,182.962319,430,0,3,"",3e-07,">",1.5,-1,"","",{},{},{},{},10154,499,"","","","",8183,402,"","",-1291,446,4351,566,"","",11266,401,10782,718,7685,643,"",""}
,{183,71,-39716.11,80.108,7984.812,0.438,3566.687,85.553,182.957363,86,0,58,"",4,"",3.5,1,"","",{"B-"},{0},{"="},{0},11061.33,149.1,19124,602,-541,509,5576.69,80.12,"","",-1737.92,80.35,5907,211,8185,408,6093.47,80.51,12083,309,9748,309,3850,509}
,{183,72,-43282.796,30.034,8000.027,0.164,2010,30,182.953534004,32.242,0,3664.8,"",7.2,"",1.5,-1,"","",{"B-"},{0},{"="},{0},12022.6,30.06,16773,300,830,198,3082.78,30.03,-11752,402,-4924.18,30,5304.61,30.65,8692,198,381.25,58.12,12225.42,129.29,8257.61,76.83,6964,300}
,{183,73,-45292.796,1.419,8006.735,0.008,1072.783,1.413,182.95137618,1.523,0,440640,"",8640,"",3.5,1,"","",{"B-"},{0},{"="},{0},12997.12,0.23,15073.33,125.76,1341.21,5.3,516.78,8.12,-10702,196,-5118.05,1.41,6934.18,0.2,6532.26,6.28,-5089.49,24.44,12820.84,1.85,9350.61,1.84,7029.95,70.73}
,{183,74,-46365.58,0.737,8008.322,0.004,-556,8,182.9502245,0.79,1,"s","","s","",0.5,-1,"","",{},{},{},{},14274.4,1.59,13540.69,1.57,1672.41,1.57,-2701.54,49.77,-7605.04,6.2,-8990.84,101.98,6190.84,0.04,7224.62,1.4,-10593.09,15.55,12783.54,1.4,7431.35,1.93,9060.17,1.57}
,{183,75,-45809.58,8.034,8001.009,0.044,-2145.537,50.405,182.95082139,8.624,0,6048000,"",120960,"",2.5,1,"","",{"EC"},{0},{"="},{0},15434.82,14.87,11949.21,8.12,2122.83,8.16,-5606.27,25.69,-6668.62,8.12,-9271.79,23.18,8434.84,102.29,4852.49,8,-15618.1,12.38,13135.04,8.16,8690.59,8.16,8769.7,8.23}
,{183,76,-43664.043,49.76,7985.01,0.272,-3460.732,52.733,182.953124719,53.42,0,46800,"",1800,"",4.5,1,"","",{"B+"},{0},{"="},{0},16256.71,55.84,10008.17,49.78,3206.17,51.85,-7891.56,52.13,-2706.95,49.77,-12683.68,54,7126.26,54.3,5506.95,113.48,-19859.37,50.26,13564.15,51.32,7037.37,54.16,11618.47,49.78}
,{183,77,-40203.311,24.398,7961.823,0.133,-4430.824,28.923,182.956839968,26.191,0,3480,"",300,"",2.5,-1,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},16882.92,24.96,8263.86,27.44,3956.05,34.67,-10011.83,26.15,-2046.22,104.86,-12106.18,27.69,9222.95,32.17,2883.18,32.68,-23616.05,26.12,14057.46,35.18,9018.55,29.39,11280.45,32.45}
,{183,78,-35772.487,15.533,7933.336,0.085,-5581.004,18.168,182.961596653,16.675,0,390,"",60,"",0.5,-1,"","",{"B+","A"},{0,0.0096,0},{"~","="},{0,0.0096,0},17533.61,20.7,6800.46,29.72,4822.09,8.82,-11967.81,17.07,1547.65,26.72,-15543.04,25.53,7675.36,20.31,4009.78,26.09,-28197.27,32.14,14401.35,16.39,7069.09,26.69,14231.72,22.58}
,{183,79,-30191.483,9.423,7898.564,0.051,-6386.809,11.789,182.967588108,10.116,0,42.8,"",1,"",2.5,-1,"","",{"B+","A"},{0,0.55,0},{"~","="},{0,0.55,0},18462.98,22.09,5306.4,10.78,5465.32,2.94,-13604.23,13.26,1571.23,22.99,-14685.88,13.59,9962.03,22.34,1312,16.13,"","",14900.83,16.62,9108.45,14.47,13432.44,23.66}
,{183,80,-23804.674,7.084,7859.388,0.039,-7217.417,11.716,182.974444629,7.604,0,9.4,"",0.7,"",0.5,-1,"","",{"B+","A","B+p"},{0,11.7,0,2.6,0},{"=","=","="},{0,11.7,0,2.6,0},19286.17,16.93,4001.1,15.41,6038.56,3.9,-16229.46,29.02,5074.8,14.88,-18548.06,13.8,8299.07,12.07,2792.88,21.46,"","",14777.27,21.19,6684.89,8.55,16277.6,13.05}
,{183,81,-16587.257,9.331,7815.673,0.051,-9012.038,29.657,182.982192846,10.017,0,6.9,"",0.7,"",0,0,"","",{"B+","A"},{"",2,0},{"","="},{"",2,0},19931.16,13.04,3294.06,22.05,5976.39,9.16,"","",4424.54,22.31,-17833.46,15.28,11330.65,15.07,299.31,13.53,"","",14784.69,17.99,8527.25,15.72,14684.65,10.49}
,{183,82,-7575.218,28.151,7762.152,0.154,"","",182.991867668,30.221,0,0.535,"",0.03,"",1.5,-1,"","",{"A","B+"},{"",10,0},{"","="},{"",10,0},20600.5,80.49,1492.02,32.08,6928,7,"","",8712.73,29.79,"","",8821.42,30.64,1536.26,30.54,"","",15934.32,29.59,6675.48,66.29,18321.63,30.85}
,{184,70,-32540,503,7951,3,3872,585,183.965067,540,0,1,"",3e-07,">",0,1,"","",{},{},{},{},9863,643,"","","","",8959,505,"","",-895,509,5512,643,"","",13165,503,"","",7495,780,"",""}
,{184,71,-36412,298,7967,2,5087,301,183.96091,320,0,20,"",3,"",3,1,"","",{"B-"},{0},{"="},{0},10675,357,"","",-917,585,6427,299,"","",-1201,300,4767,309,8601,499,7808,298,13119,499,9540,422,4405,667}
,{184,72,-41499.373,39.706,7990.722,0.216,1340,30,183.955448587,42.625,0,14832,"",180,"",0,1,"","",{"B-"},{0},{"="},{0},11592.5,40.18,17257,403,676,301,4206,39.7,-13689,403,-4277.89,39.72,6287.89,49.78,9072.23,89.41,2753.16,39.7,11091,200,8162.09,131.87,5235,301}
,{184,73,-42839.373,26.01,7993.752,0.141,2866,26,183.954010038,27.923,0,31320,"",360,"",5,-1,"","",{"B-"},{0},{"="},{0},12552.07,26.04,15537,197,1412.06,75.36,1380.26,26.34,-10412.23,84.23,-4545.11,26,5617.89,26.04,6845.55,39.72,-3228.52,38.18,13920.94,26.73,9427.51,26.05,7604.44,128.41}
,{184,74,-45705.373,0.731,8005.077,0.004,-1485.739,4.198,183.95093326,0.785,1,"s","","s","",0,1,"","",{},{},{},{},13601.95,0.14,14233.81,6.2,1649.06,1.57,-1452.84,0.67,-9711.55,30.03,-7967.11,8,7411.11,0.13,7701.55,1.41,-8371.13,15.6,11435.37,1.4,7596.99,1.4,7343.86,1.57}
,{184,75,-44219.634,4.275,7992.75,0.023,32.898,4.14,183.952528267,4.589,0,3058560,"",60480,"",0,0,"","",{"B+"},{0},{"="},{0},14916.21,102.07,12367.64,4.43,2288.33,4.63,-4608.78,28.27,-6215.81,4.44,-8626.91,49.94,6481.37,9.04,5143.03,4.2,-13900.92,22.68,14737.23,4.2,8878.24,4.5,9865.08,4.43}
,{184,76,-44252.533,0.827,7988.677,0.005,-4641.682,27.957,183.952492949,0.887,1,"s","","s","",0,1,"","",{},{},{},{},15786.06,21.76,10584.41,0.68,2958.67,1.64,-6918.29,15.61,-5175.92,0.68,-12120.54,24.41,8659.81,49.77,5731.92,8.03,-17903.57,10.09,11904.33,101.98,7128.91,12.53,9627.69,1.65}
,{184,77,-39610.851,27.945,7959.198,0.152,-2276.608,31.997,183.957476,30,0,11124,"",108,"",5,-1,"","",{"B+"},{0},{"="},{0},16701.81,34.94,8742.73,105.74,3801.59,35.19,-9292.14,35.74,-1090.24,29.08,-11909.68,31.97,7478.86,37.1,3235.78,57.07,-22727.61,29.69,15709.06,35.41,8803.17,37.72,12552.94,30.63}
,{184,78,-37334.243,15.584,7942.574,0.085,-7015.533,27.185,183.959920039,16.73,0,1038,"",12,"",0,1,"","",{"B+","A"},{0,0.0017,0},{"~","="},{0,0.0017,0},17308.43,20.35,7303.08,26.75,4598.65,8.1,-10985.28,18.54,-959.17,52.14,-15214.08,18.21,9633.07,22,4419.9,28.95,-26282.72,20.17,12428.24,26.12,6992.84,16.44,11862.12,29.75}
,{184,79,-30318.71,22.275,7900.194,0.121,-3969.745,24.442,183.967451524,23.912,0,20.6,"",0.9,"",5,1,"","",{"B+","A"},{0,0.016,0},{"~","<"},{0,0.016,0},18160.58,30.11,5844.97,30.59,5233.9,5,-13435.47,24.42,2595.63,33.04,-14585.35,23.37,8198.54,24.19,1835.19,27.16,-31381.78,81.22,16560.54,25.84,8926.86,26.14,14790.72,22.88}
,{184,80,-26348.965,10.062,7874.367,0.055,-9465.723,14.2,183.971713221,10.802,0,30.87,"",0.26,"",0,1,"","",{"B+","A"},{0,1.11,0},{"=","="},{0,1.11,0},18914.68,14.01,4758.46,16.5,5662,4.38,-15297.44,16.27,2134.55,18.5,-17833.03,13.72,10615.61,12.29,3446.45,13.79,"","",12662.61,22.62,6386.23,22.37,13678.95,16.98}
,{184,81,-16883.242,10.02,7818.671,0.054,-5831.72,16.26,183.981875093,10.757,0,9.5,"",0.2,"",2,-1,"","",{"B+","A"},{0,1.22,0},{"=","="},{0,1.22,0},19697.95,15.51,3160.42,22.6,6317.35,9.27,-17946.31,78.75,6019.27,13.76,-17379.34,29.88,8367.3,13.69,367.54,12.27,"","",17404.49,14.01,8641.95,18.36,16634.3,22.35}
,{184,82,-11051.522,12.806,7782.725,0.07,-12114.59,79.153,183.988135702,13.748,0,0.49,"",0.025,"",0,1,"","",{"A"},{""},{"="},{""},20369.04,17.62,2052.54,16.11,6774.01,3.13,"","",5464.18,14.63,"","",11547.62,30.92,1753.24,15.85,"","",12987.21,17.44,6611.27,13.76,15256.02,20.01}
,{184,83,1063.068,78.11,7712.633,0.425,"","",184.00114125,83.854,0,0.0066,"",0.0015,"",3,1,"","",{"A"},{""},{""},{""},"","",186.95,79,8024.8,50,"","",10361.35,78.67,"","","","",-1349.32,83.03,"","",18598.99,79.04,9044.47,108.57,19508.2,78.64}
,{185,70,-28500,503,7929,3,5388,585,184.969404,540,0,0.3,"",3e-07,">",1.5,-1,"","",{},{},{},{},9543,643,"","","","",9820,507,"","",-159,585,4031,711,"","",14888,503,"","","","","",""}
,{185,71,-33888,298,7954,2,4432,305,184.96362,320,0,6,"",3e-07,">",3.5,1,"","",{},{},{},{},10314,309,"","",-1142,667,7507,298,"","",-460,301,5547,422,8637,585,9931,298,11923,499,9796,499,"",""}
,{185,72,-38319.8,64.273,7973.97,0.347,3074.492,65.815,184.958862,69,0,210,"",36,"",1.5,-1,"","",{"B-"},{0},{"="},{0},11179.64,70.94,17798,406,343,305,5067.99,64.28,-13069,507,-3551.74,69.34,4891.74,75.55,9197,305,4486.08,64.28,12107.12,102.71,8424,206,6147,406}
,{185,73,-41394.293,14.161,7986.36,0.077,1993.5,14.142,184.955561396,15.202,0,2964,"",90,"",3.5,1,"","",{"B-"},{0},{"="},{0},12244.13,14.21,16256.12,81.35,978.2,126.55,2424.73,14.16,-12271,298,-3760.24,14.14,6626.24,29.6,7183.89,42.14,-1058.74,31.33,12599.31,33.2,9519.27,15.44,6132,196}
,{185,74,-43387.793,0.733,7992.907,0.004,431.234,0.661,184.953421286,0.786,0,6488640,"",25920,"",1.5,-1,"","",{"B-"},{0},{"="},{0},13164.85,0.14,14682.94,30.03,1590.12,1.57,-581.91,0.67,-9177.39,39.7,-7239.48,4.2,5753.74,0.05,7837.39,26,-6699.65,25.84,12615.81,1.42,7906.2,1.4,8308.12,6.2}
,{185,75,-43819.027,0.818,7991.009,0.004,-1013.147,0.419,184.952958337,0.877,1,"s","","s","",2.5,1,"","",{},{},{},{},14152.08,8.03,13104.17,1.51,2194.37,1.5,-3483.47,27.96,-8268.62,26.01,-7637.81,0.48,7670.71,4.09,5402.62,0.66,-11960.88,2.73,13257.36,0.67,9291.09,0.67,8257.31,1.5}
,{185,76,-42805.88,0.83,7981.304,0.004,-2470.326,27.957,184.954045995,0.891,0,8030880,"",7776,"",0.5,-1,"","",{"EC"},{0},{"="},{0},15284.47,49.77,11018.24,0.68,3003.02,1.65,-6117.74,25.85,-4389.48,0.67,-11266.35,27.96,6624.66,0.27,5875.22,4.13,-16622.21,13.66,13714.51,8.03,7504.24,101.98,11086.58,0.68}
,{185,77,-40335.553,27.945,7963.722,0.151,-3647.414,38.055,184.956698,30,0,51840,"",360,"",2.5,-1,"","",{"B+"},{0},{"="},{0},16274.88,37.1,9103.91,29.08,3756.92,30.63,-8477.41,28.07,-3404.89,28.27,-11072.63,32,8796.02,39.52,3371.99,27.96,-20577.81,34.76,14039.3,57.07,9137.61,35.41,10756.91,105.74}
,{185,78,-36688.14,25.832,7939.777,0.14,-4829.997,25.963,184.960613659,27.731,0,4254,"",144,"",4.5,1,"","",{"B+","A"},{0,0.005,0},{"~","="},{0,0.005,0},17058.29,30.14,7602.04,56.07,4436.91,10.01,-10504.47,29.21,275.42,25.85,-14440.75,34.11,7425.21,30.17,4366.26,38.06,-25146.92,30.48,14225.98,35.53,7227.59,33.27,13567.37,33.77}
,{185,79,-31858.143,2.608,7909.44,0.014,-5674.477,13.886,184.965798874,2.8,0,255,"",3.6,"",2.5,-1,"","",{"B+","A"},{0,0.26,0},{"~","="},{0,0.26,0},17809.29,9.78,6232.77,24.54,5179.97,4.55,-12100.4,20.84,463.74,28.07,-13580.5,10.39,9610.75,22.43,1812.87,15.8,-29622,81,14625.15,15.75,9174.36,13.35,12839.94,21.13}
,{185,80,-26183.666,13.639,7874.538,0.074,-6425.925,24.767,184.971890676,14.641,0,49.1,"",1,"",0.5,-1,"","",{"B+","A"},{0,6,""},{"=","="},{0,6,""},18521.63,15.36,4989.12,20.67,5772.93,4.46,-14642.45,21.16,3861.61,20.71,-17371.74,16.92,7906.02,16.94,3153.93,26.12,"","",14718.62,16.58,6981.16,24.42,15631.18,18.9}
,{185,81,-19757.741,20.674,7835.575,0.112,-8216.521,26.249,184.978789191,22.194,0,19.5,"",0.5,"",0,0,"","",{"B+"},{""},{""},{""},19313.12,22.68,4144.2,22.72,5688.48,5.33,-17522,84,3272,30.39,-16777.54,24.32,10945.82,22.97,697.75,22.99,"","",14757.74,21.85,8683.24,22.87,14189.43,28.95}
,{185,82,-11541.22,16.175,7786.932,0.087,-9305,83,184.987609989,17.364,0,6.3,"",0.4,"",1.5,-1,"","",{"A"},{""},{"="},{""},20108.64,32.46,2314.49,17.65,6695,5,"","",7518.77,19.04,-20675.61,79.77,8561.02,20.63,1946.95,19.03,"","",15756.84,18.67,6650.76,20.04,17682.1,18.9}
,{185,83,-2236,81,7732,0,"","",184.9976,87,0,0.002,"","s","",4.5,-1,"","",{},{},{},{},"","",226,82,8138,81,"","",7358,82,"","",11370,113,-1527,81,"","",16050,86,9453,82,16739,82}
,{186,71,-30210,401,7935,2,6214,404,185.967568,430,0,2,"",3e-07,">",0,0,"","",{},{},{},{},9941,499,"","","","",8397,405,"","",38,406,4394,499,8999,643,11717,401,13040,643,9753,566,"",""}
,{186,72,-36424.21,51.232,7964.302,0.275,2183.318,78.906,185.960897,55,0,156,"",72,"",0,1,"","",{"B-"},{0},{"="},{0},11067.47,64.82,18462,506,-29,404,6084.32,51.25,-15213,506,-3101.23,53.15,6175.73,82.19,9825,302,6575.73,51.24,10699,302,8155.95,95.09,4322,404}
,{186,73,-38607.528,60.012,7971.835,0.323,3901,60,185.958553111,64.425,0,630,"",18,"",2,-1,"","",{"B-"},{0},{"="},{0},11910.79,65.4,16773,304,848,205,3319.56,60.01,-12009,304,-3291.05,60.01,5284.55,61.66,7576.7,87.93,564.82,62.25,13602.65,71.95,9539.32,67.11,6754.98,100.09}
,{186,74,-42508.528,1.212,7988.601,0.007,-581.442,1.244,185.954365215,1.3,1,"s","","s","",0,1,"","",{},{},{},{},12945.79,1.16,15587.1,39.72,1116.07,6.28,491.41,1.19,-11477.7,64.28,-6760.82,1.24,7192.05,1.16,8403.21,14.19,-4644.08,21.78,11041.65,26.03,7648.32,1.77,6420.67,30.05}
,{186,75,-41927.086,0.826,7981.269,0.004,1072.857,0.837,185.954989419,0.886,0,321261.12,"",95.04,"",1,-1,"","",{"B-","EC"},{0,7.47,0},{"=","="},{0,7.47,0},13850.09,4.09,13665.65,26.01,2077.93,1.51,-2754.74,16.55,-7821.76,14.16,-7192.52,0.45,6179.38,0.17,5828.26,0.68,-10212.23,20.98,14489.09,0.68,9302.55,0.69,9012.11,1.52}
,{186,76,-42999.943,0.761,7982.831,0.004,-3827.596,16.543,185.95383766,0.816,0,6.3113852e+22,"",3.47126186e+22,"",0,1,"","",{"A"},{0},{"="},{0},14890.04,0.89,11872.51,0.87,2821.2,0.87,-5135.5,21.76,-6901.12,0.87,-10735.71,27.96,8265.38,0.88,6469.89,0.84,-14460.85,11.67,11930.5,4.31,7673.69,8.05,9012.04,0.87}
,{186,77,-39172.346,16.526,7958.047,0.089,-1307.903,27.312,185.957946754,17.74,0,59904,"",108,"",5,1,"","",{"B+"},{0},{"="},{0},15704.13,32.47,9530.65,17.07,3848.8,103.31,-7457.49,26.7,-2642.29,16.55,-10555.52,30.67,6908.11,32.47,3655.44,16.55,-19285.73,27.8,15790.99,16.55,9355.75,52.43,12283.64,18.37}
,{186,78,-37864.443,21.745,7946.809,0.117,-6149.591,30.207,185.959350846,23.344,0,7488,"",180,"",0,1,"","",{"B+","A"},{0,1.4,0},{"=","~"},{0,1.4,0},16672.83,26.75,8189.85,21.76,4319.75,18.16,-9325.35,24.67,-2347.53,21.76,-14077.62,21.9,9247.62,33.77,4817.86,35.41,-23182.42,24.54,12457.21,35.41,7202.92,32.68,11446,54.3}
,{186,79,-31714.852,20.967,7909.54,0.113,-3175.756,23.987,185.965952703,22.509,0,642,"",30,"",3,-1,"","",{"B+","A"},{0,0.0008,0},{"=","="},{0,0.0008,0},17538.78,30.59,6681.94,34.94,4911.91,14.02,-11828.24,30.65,1331.73,34.94,-13602.5,25.01,7928.03,21.13,2315.68,33.27,-28568.64,26.9,16330.2,26.12,8921.69,26.09,14134.86,32.17}
,{186,80,-28539.097,11.65,7888.26,0.063,-8652.484,25.209,185.969362017,12.507,0,82.8,"",3.6,"",0,1,"","",{"B+","A"},{0,0.016,0},{"~","="},{0,0.016,0},18332.77,15.37,5782.8,19.45,5204.44,9.89,-13857.07,16.25,860.07,28.34,-16852.67,23.73,10426.75,17.93,3969.92,11.94,-32640.07,21.68,12490.42,25.14,6516.44,14.98,12879.79,19.41}
,{186,81,-19886.613,22.356,7837.535,0.12,-5204.588,25.078,185.978650841,24,0,40,"","s","",2,-1,"","",{},{},{},{},19146.01,24.5,4145.84,31.56,5989.24,30.17,-16740.4,28,4682.56,22.51,-16416.71,27.59,8200.19,30.45,991.92,26.19,"","",17173.16,24.52,8782.12,23.45,15951.27,24.26}
,{186,82,-14682.026,11.363,7805.347,0.061,-11535.814,20.329,185.984238196,12.199,0,4.82,"",0.03,"",0,1,"","",{"A"},{0},{"="},{0},19773.14,17.11,2911,15.16,6469.98,5.77,-18783,21.53,4212.67,17.74,-20518,82,11212.12,19.76,2213.26,23.59,"","",12912.02,15.15,6769.29,14.7,14769.05,13.38}
,{186,83,-3146.212,16.857,7739.121,0.091,-7247.186,24.87,185.996622402,18.096,0,0.0148,"",0.0007,"",3,1,"","",{"A","B+","B+SF"},{0,"","",0.011,0},{"~","","="},{0,"","",0.011,0},20351.91,79.91,840.91,19.61,7756.8,12,"","",9322.56,26.68,"","",8982,83,-1106.04,23.36,"","",18616.12,21.17,9293.06,32.81,19087.45,19.27}
,{186,84,4100.974,18.286,7695.951,0.098,"","",186.004402577,19.63,0,3.4e-05,"",1.2e-05,"",0,1,"","",{"A"},{0},{"~"},{0},"","",-574.55,22.32,8501.17,13.71,"","",8353.22,24.41,"","","","",952,83,"","",13748.71,80.22,"","",17322.59,33.57}
,{187,71,-27580,401,7922,2,5237,499,186.970392,430,0,1,"",3e-07,">",3.5,1,"","",{},{},{},{},9835,499,"","","","",9316,404,"","",773,404,5441,566,"","",13637,401,11631,643,9824,643,"",""}
,{187,72,-32817,298,7946,2,4079,303,186.96477,320,0,30,"",3e-07,">",1.5,-1,"","",{},{},{},{},10639,305,18894,585,-142,499,7087,298,"","",-2280,304,4464,302,9895,499,8402,298,11782,422,8460,422,5370,585}
,{187,73,-36895.546,55.89,7963.212,0.299,3008.424,55.903,186.960391,60,0,138,"",360,"",3.5,1,"","",{},{},{},{},11643.89,57.66,17586,303,395.65,97.68,4320.93,55.89,-13974,404,-2458.34,55.9,6359.34,82.01,7760.31,75.82,2653.83,62.49,12135.06,85.17,9467.88,68.56,5163,303}
,{187,74,-39903.97,1.212,7975.116,0.006,1312.508,1.122,186.957161323,1.3,0,86400,"",14.4,"",1.5,-1,"","",{"B-"},{0},{"="},{0},12658.81,1.16,16162.11,64.28,953.91,30.05,1314.97,1.12,-10768.73,51.25,-6048.2,1.24,5466.76,0.04,8585.41,60,-3218.92,24.08,12201.13,14.19,7799.46,26.03,7241.8,39.72}
,{187,75,-41216.478,0.736,7977.951,0.004,2.467,0.002,186.955752288,0.79,0,1.3664148958e+18,"",2.20898482e+15,"",2.5,1,"","",{"B-","A"},{0,0.0001,0},{"=","<"},{0,0.0001,0},13540.09,0.86,14400.13,14.17,1651.4,1.54,-1667.11,27.95,-9897.92,60.01,-6287.85,0.52,7360.71,0.87,5996.92,1.12,-8188.64,22.32,12882.12,0.86,9352.95,0.86,7269.3,26.01}
,{187,76,-41218.945,0.736,7973.78,0.004,-1669.572,27.955,186.95574964,0.79,1,"s","","s","",0.5,-1,"","",{},{},{},{},14555.7,0.9,12409.09,0.86,2721.72,0.87,-4533.89,24.06,-5999.39,1.12,-10117.92,16.54,6290.32,0.52,6580.83,0.87,-13101.01,13.92,13310.89,0.86,7864.74,4.35,10132.83,0.86}
,{187,77,-39549.372,27.945,7960.668,0.149,-2864.323,36.868,186.957542,30,0,37800,"",1080,"",1.5,1,"","",{"B+"},{0},{"="},{0},15356.45,39.52,10308.29,27.96,3835.29,29.08,-6521.53,35.76,-4911.26,27.96,-9756.25,35.41,8448.34,32.47,3838.4,27.96,-17104.79,29.08,13967.31,27.96,9567.22,27.96,10316.66,28.27}
,{187,78,-36685.05,24.048,7941.168,0.129,-3657.212,27.377,186.960616976,25.816,0,8460,"",108,"",1.5,-1,"","",{"B+"},{0},{"="},{0},16139.54,35.29,8457.11,24.06,4554.08,55.1,-8567.12,27.78,-974.08,24.06,-13041.51,31.91,6891.92,32.42,4801.67,29.18,-21698.09,24.58,14361.31,36.87,7789.86,36.87,13213.88,24.06}
,{187,79,-33027.838,22.308,7917.427,0.119,-4909.908,26.287,186.964543155,23.948,0,498,"",12,"",0,0,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},17312.33,22.46,7270.23,35.76,4750.56,29.43,-10583.25,23.72,-1144.46,27.76,-12560.06,25.17,9384.3,30.61,2452.37,31.15,-26644.57,24.45,14371.11,34.13,9170.46,27.21,12229.41,35.76}
,{187,80,-28117.93,13.905,7886.987,0.074,-5673.343,16.067,186.969814158,14.928,0,114,"",18,"",0,0,"","",{"B+","A"},{0,1.2,0},{"=",">"},{0,1.2,0},18076.9,19.47,6007.73,29.34,5229.64,13.99,-13130.97,14.8,2457.54,25.81,-16302.63,26.33,7650.15,18.12,3692.05,25.16,-30946.53,34.79,14451.02,14.15,7064.84,26.26,14862.71,20.88}
,{187,81,-22444.587,8.048,7852.464,0.043,-7457.628,9.525,186.975904743,8.64,0,51,"","s","",0.5,1,"","",{"B+","A"},{0,"",""},{"<",""},{0,"",""},18829.48,22.19,5164.39,8.46,5321.98,7.14,-16061.32,12.84,1981.29,22.46,-15833.88,13.92,10629.29,23.76,1194.46,14.16,"","",14449.89,15.84,8768.43,12.88,13520.52,23.68}
,{187,82,-14986.959,5.094,7808.4,0.027,-8603.688,11.227,186.983910836,5.468,0,15.2,"",0.3,"",1.5,-1,"","",{"A"},{0},{"="},{0},19588.37,16.96,3381.23,14.56,6392.8,6.19,-17815.56,32.3,6263.17,12.71,-19912.06,17.61,8376.25,12.45,2389.32,22.93,"","",15481.59,21.29,6760.34,11.24,17008.41,11.27}
,{187,83,-6383.271,10.005,7758.208,0.054,-9211.868,33.43,186.993147276,10.74,0,0.037,"",0.002,"",4.5,-1,"","",{"A"},{0},{"="},{0},20290,82,1203.47,22.97,7779.07,3.62,"","",6214.37,24.49,-18555.56,20.84,11308.38,19.6,-1009.78,15.14,"","",15868.76,19.02,9532.31,16.25,16146.37,14.16}
,{187,84,2828.597,31.898,7704.763,0.171,"","",187.003036624,34.243,0,0.0014,"",0.00025,"",0.5,-1,"","",{"A"},{0},{"~"},{0},"","",208.12,35.76,7978.9,15,"","",10221.65,33.85,"","",9343.69,36.77,1314.16,36.08,"","",15775,87,6629.58,84.37,19526.52,34.36}
,{188,71,-23790,503,7902,3,7089,585,187.97446,540,0,0.3,"",3e-07,">",0,0,"","",{},{},{},{},9723,643,"","","","",9822,506,"","",955,585,4282,643,"","",15226,503,"","",9574,711,"",""}
,{188,72,-30879,298,7936,2,2733,303,187.96685,320,0,20,"",3e-07,">",0,1,"","",{},{},{},{},10597,302,"","",-764,585,7789,298,"","",-2055,303,6134,422,10588,499,10258,298,10042,499,7873,422,3267,585}
,{188,73,-33612.03,54.958,7946.321,0.292,5055.781,55.045,187.963916,59,0,19.6,"",2,"",0,0,"","",{"B-"},{0},{"="},{0},11147.14,81.37,17980,404,375,303,5404.78,54.96,-13321,404,-1779.38,54.97,4787.8,78.38,8084,303,4732.88,55.76,13522.99,75.13,9571.83,84.57,5922,303}
,{188,74,-38667.811,3.089,7969.052,0.016,349,3,187.958488395,3.316,0,6028992,"",4320,"",0,1,"","",{"B-"},{0},{"="},{0},12301.92,3.2,16821.54,51.33,406.65,39.82,2469.42,3,-13140,298,-5522.65,3,6835.16,3.2,9061.24,55.97,-846.88,6.1,10650.52,60.09,7590.54,14.48,5298.39,64.35}
,{188,75,-39016.811,0.738,7966.747,0.004,2120.422,0.152,187.958113728,0.791,0,61214.4,"",7.92,"",1,-1,"","",{"B-"},{0},{"="},{0},13232.36,0.87,14987.22,60.01,1397.65,26.01,-671.9,9.42,-9410.24,55.89,-5869.18,0.04,5871.65,0.04,6401.81,1.12,-6645.5,2.8,14202.52,1.12,9235.04,0.86,8023.88,14.17}
,{188,76,-41137.233,0.734,7973.864,0.004,-2792.326,9.416,187.955837361,0.787,1,"s","","s","",0,1,"","",{},{},{},{},14279.92,0.53,13206.65,1.13,2143.22,0.86,-3316.3,5.31,-8522.23,1.13,-9659.18,27.95,7989.61,0.15,7209.73,0.15,-10935.32,12.3,11500.66,0.87,7545.85,0.87,7896.96,0.86}
,{188,77,-38344.907,9.423,7954.85,0.05,-523.979,8.686,187.958835046,10.116,0,149400,"",1800,"",1,-1,"","",{"B+"},{0},{"="},{0},15315.2,19.02,10995.76,9.42,3449.81,10.31,-5973.6,9.8,-4417.4,9.42,-9731.17,25.83,6866.85,29.49,4414.93,9.42,-16008.51,31.35,15365.84,9.42,9325.03,9.42,11120.52,9.42}
,{188,78,-37820.929,5.304,7947.902,0.028,-5449.621,5.953,187.95939756,5.694,0,881280,"",25920,"",0,1,"","",{"EC","A"},{0,2.6,0},{"=","="},{0,2.6,0},16099.12,22.38,9398.93,5.31,4006.69,5.27,-7619.01,13.37,-3890.95,5.31,-12864.41,22.93,9207.2,24.63,5560.53,28.44,-20005.73,11.87,12062.22,17.36,7378.68,28.44,10631.35,5.28}
,{188,79,-32371.308,2.701,7914.753,0.014,-2169.394,12.569,187.965247969,2.9,0,530.4,"",3.6,"",0,0,"","",{"B+"},{0},{"="},{0},16799.09,21.14,7776.9,16.74,4814.63,28.08,-10034.91,30.03,-110.91,28.08,-12324.69,14.17,7414.79,22.47,2975.23,24.2,-25176.62,11.51,16203.94,21.91,9180.89,25.97,13610.65,28.08}
,{188,80,-30201.914,12.275,7899.052,0.065,-7865.513,32.325,187.96757691,13.178,0,195,"",9,"",0,1,"","",{"B+","A"},{0,3.7,0},{"=","="},{0,3.7,0},17805.45,16.9,6915.41,24.97,4707.41,15.65,-12386.71,16.21,-805.83,27,-15828.64,14.68,10155.3,18.53,4463.05,25.46,-29657.6,23.43,12223.74,24.3,6520.28,12.55,12132.63,28.6}
,{188,81,-22336.4,29.904,7853.053,0.159,-4521.198,31.734,187.976020886,32.103,0,71,"",2,"",2,-1,"","",{"B+"},{0},{"="},{0},18592.42,37.34,5199.49,36.52,5557.39,37.29,-15141.71,31.93,3402.47,37.31,-15420.76,30.33,7963.13,30.97,1507.44,32.98,"","",16913.5,32.09,8711.32,32.87,15168.14,30.02}
,{188,82,-17815.202,10.622,7824.843,0.057,-10620.515,15.427,187.980874592,11.403,0,25.1,"",0.1,"",0,1,"","",{"B+","A"},{"",9.3,0},{"","="},{"",9.3,0},19275.81,15.53,3854.05,15.74,6108.85,3.4,-17270.89,22.61,3013.76,17.48,-19503.25,14.59,10899.56,11.77,2659.59,13.33,"","",12782.22,24.75,6806.59,23.24,14014.87,17.28}
,{188,83,-7194.687,11.187,7764.189,0.06,-6650.374,22.892,187.992276184,12.009,0,0.06,"",0.003,"",3,1,"","",{"A","B+","B+SF"},{"","","",0.0016,0},{"","","="},{"","","",0.0016,0},20191.11,20.23,1886.02,25,7263.64,4.97,"","",7960.93,13.78,-18094.6,33.8,8882.73,15.01,-503.3,12.29,"","",18198.14,15.95,9210.59,19.67,18209.46,23.51}
,{188,84,-544.313,19.973,7724.653,0.106,"","",187.999415655,21.441,0,0.000275,"",3e-05,"",0,1,"","",{"A"},{""},{""},{""},20787.92,27.08,440.23,22.97,8082.29,15.33,"","",7153.68,20.61,"","",11444.23,37.63,1450.01,22.34,"","",13312.7,26.14,6556,83,16643.31,25.7}
,{189,72,-27162,298,7917,2,4667,357,188.97084,320,0,2,"",3e-07,">",1.5,-1,"","",{},{},{},{},10488,422,"","",-1087,585,8455,301,"","",-1622,303,4355,422,10661,585,11824,298,11128,499,7912,499,"",""}
,{189,73,-31829,196,7938,1,3788,200,188.96583,210,0,3,"",3e-07,">",3.5,1,"","",{},{},{},{},11076,203,18827,446,-366,357,6150,196,-15328,540,-1233,196,6288,203,8239,357,6620,196,11698,357,9459,202,4027,446}
,{189,74,-35617.536,40.054,7953.454,0.212,2361.507,40.883,188.961763,43,0,642,"",30,"",1.5,-1,"","",{"B-"},{0},{"="},{0},11856.2,40.07,17379,301,277.35,75.73,3369.21,40.06,-12027,301,-4672.04,40.06,5021.04,40.17,9294.48,68.01,851.81,41.31,11988.82,68.76,7854.05,72.15,6453.08,65.03}
,{189,75,-37979.043,8.191,7961.809,0.043,1007.702,8.167,188.959227817,8.793,0,87480,"",1440,"",2.5,1,"","",{"B-"},{0},{"="},{0},12905.2,8.18,15661.44,56.49,990.33,16.35,470.54,14.98,-11655.98,55.57,-4913.13,8.18,7033.55,8.18,6600.2,8.71,-4397.09,21.69,12635.73,8.25,9393.54,8.25,6274.89,60.56}
,{189,76,-38986.745,0.666,7963.002,0.004,-537.159,12.563,188.958146005,0.715,1,"s","","s","",1.5,-1,"","",{},{},{},{},13910.43,0.46,13660.72,1.17,1976.13,0.85,-2517.4,10.08,-7607.9,3.04,-8713.15,9.42,5920.83,0.45,7258.9,0.46,-9360.34,31.56,12940.54,0.46,7804.4,0.87,9168.18,1.17}
,{189,77,-38449.586,12.576,7956.02,0.067,-1980.238,13.636,188.958722669,13.5,0,1140480,"",8640,"",1.5,1,"","",{"EC"},{0},{"="},{0},15042.85,30.64,11811.05,12.57,2944.53,12.59,-4867.63,23.69,-6721.75,12.57,-8699.97,13.63,8176,15.7,4601.32,12.57,-13833.49,15.11,13480.16,12.57,9414.41,12.57,9123.9,12.59}
,{189,78,-36469.348,10.09,7941.403,0.053,-2887.394,22.474,188.960848542,10.832,0,39132,"",432,"",1.5,-1,"","",{"B+"},{0},{"="},{0},15926.93,26.08,9828.34,10.08,3911.62,10.11,-6842.95,33.13,-2621.09,10.08,-12169.36,10.45,6719.74,11.38,5413.41,13.79,-18625.31,17.31,13790.83,29.71,7567.05,19.36,12177,10.09}
,{189,79,-33581.955,20.081,7921.987,0.106,-3955.554,37.401,188.963948286,21.558,0,1722,"",18,"",0.5,1,"","",{"B+","A"},{0,3,0},{"=","<"},{0,3,0},16696.75,30.02,8610.52,34.41,4328.68,34.41,-8965.85,21.75,-2526.02,22.18,-11451.36,23.54,9281.96,20.26,3050,20.77,-23517.29,28.95,13813.9,31.33,9146.54,29.6,11236.79,26.01}
,{189,80,-29626.401,31.553,7896.919,0.167,-5010.3,32.643,188.968194748,33.873,0,456,"",6,"",1.5,-1,"","",{"B+","A"},{0,3,0},{"=","<"},{0,3,0},17651.11,34.47,7519.29,39.67,4636.82,40.78,-11782.37,34.54,905.56,32,-15361.32,43.47,7495.8,33.85,4544.06,31.67,-28204.4,38.5,14112.24,38.64,6952.51,37.88,13884.44,38.32}
,{189,81,-24616.1,8.368,7866.27,0.044,-6772.066,16.364,188.973573527,8.983,0,138,"",12,"",0.5,1,"","",{"B+"},{0},{"="},{0},18314.15,11.61,6166.2,23.83,4817.13,8.76,-14551.44,22.47,466.24,8.79,-14872.22,13.52,10351.02,31.05,1703.16,14.86,"","",14212.64,16.23,8787.05,14.34,12745.15,22.58}
,{189,82,-17844.035,14.062,7826.299,0.074,-7779.374,25.15,188.980843639,15.096,0,39,"",8,"",1.5,-1,"","",{"B+","A"},{0,0.4,0},{"~","~"},{0,0.4,0},18999.71,14.95,4304.05,19.77,5914.72,4.31,-16422.03,26.16,5068.91,18.66,-18720.66,17.97,8100.15,17.61,2796.6,33.05,"","",15311.36,16.2,6906.63,26.41,16341.46,18.25}
,{189,83,-10064.66,20.851,7780.999,0.11,-8642.656,30.354,188.989195141,22.384,0,0.658,"",0.047,"",4.5,-1,"","",{"A"},{0},{"~"},{0},19824.02,23.13,2198.01,22.35,7268.17,2.71,"","",4982.77,36.46,-17591.66,28.87,10941.29,23.66,-461.57,23.4,"","",15633.1,21.46,9481.42,23.75,15468.35,30.57}
,{189,84,-1422.005,22.059,7731.131,0.117,"","",188.998473415,23.681,0,0.0038,"",0.0004,"",2.5,-1,"","",{"A"},{0},{"~"},{0},20393.24,38.78,1012.99,22.64,7694.3,15,"","",9104.23,24.48,"","",8949.01,29.76,1516.29,24.73,"","",15672.07,24.22,6588.26,27.76,18906.42,24.81}
,{190,72,-25030,401,7907,2,3483,446,189.973129,430,0,2,"",3e-07,">",0,1,"","",{},{},{},{},10294,499,"","","","",9352,403,"","",-1272,446,5939,499,"","",13678,401,9471,643,7414,566,"",""}
,{190,73,-28513,196,7921,1,5869,200,189.96939,210,0,5.3,"",0.7,"",0,0,"","",{"B-"},{0},{"="},{0},11044,203,19301,540,-728,446,7123,208,"","",-967,200,4755,277,8640,357,8241,196,13077,357,9168,357,4713,446}
,{190,74,-34382.313,39.726,7947.573,0.209,1253.517,63.522,189.963089066,42.647,0,1800,"",90,"",0,1,"","",{"B-"},{0},{"="},{0},11857.14,39.85,18081,301,-383.02,64.83,4325.46,39.73,-14509,301,-4474.59,40.56,6836.09,56.41,9842,200,2924.14,39.73,9940.52,67.81,7377.29,68.57,4081,301}
,{190,75,-35635.83,70.852,7950.053,0.373,3071.941,70.854,189.96174336,76.063,0,186,"",18,"",0,0,"","",{"B-"},{0},{"="},{0},12761.65,70.85,16601.74,89.67,546.78,92.85,1117.71,70.86,-11096,208,-4720.4,70.85,5728.1,71.32,7307.26,81.39,-2802.3,70.94,13742.79,70.92,9132.2,70.86,6906.12,90.24}
,{190,76,-38707.771,0.65,7962.104,0.003,-1954.227,1.213,189.958445496,0.697,1,"s","","s","",0,1,"","",{},{},{},{},13713.17,0.47,14617.9,3.04,1375.84,1.17,-1401.32,0.43,-10379.21,40.06,-8329.5,12.56,7792.34,0.19,8017.7,8.16,-7337.07,15.92,11019.85,0.48,7372.76,0.48,6842.6,1.17}
,{190,77,-36753.544,1.37,7947.701,0.007,552.906,1.282,189.960543445,1.47,0,1017792,"",8640,"",4,-1,"","",{"B+","e+"},{0,0.002,0},{"=","<"},{0,0.002,0},14551.27,9.5,12314.67,1.3,2748.63,1.49,-3920.01,3.71,-6063.47,8.25,-8355.51,10.13,6375.27,12.55,5055.77,1.23,-12381.52,8.07,15094.5,1.3,9329.46,1.3,10109.34,1.3}
,{190,78,-37306.45,0.657,7946.493,0.003,-4472.917,3.509,189.959949876,0.704,0,2.05120019e+19,"",9.4670778e+17,"",0,1,"","",{"A"},{0},{"="},{0},15628.16,5.3,10747.16,0.57,3268.58,0.59,-5935.75,15.92,-5608.68,0.46,-11795.81,20.09,8908.42,10.07,6145.83,12.56,-16889.81,12.53,11749.26,9.42,7106.98,27.95,9558.9,0.57}
,{190,79,-32833.533,3.447,7918.834,0.018,-1462.836,16.276,189.96475175,3.7,0,2568,"",60,"",1,-1,"","",{"B+","A"},{0,1,0},{"=","<"},{0,1,0},16604.86,4.38,9066.57,10.03,3913.9,16.88,-8461.51,8.66,-1672.92,13.04,-11278.45,31.74,7322.9,20.37,3653.16,10.66,-22233.95,22.82,15698.2,6.33,8715.57,24.29,12362.24,28.16}
,{190,80,-31370.697,15.907,7907.017,0.084,-6998.67,17.782,189.966322169,17.076,0,1200,"",30,"",0,1,"","",{"EC","e+","A"},{0,1,0,3.4,0},{"~","<","<"},{0,1,0,3.4,0},17311.42,20.06,8127.71,16.77,4068.83,26.94,-10954.05,20.21,-2190.32,18.84,-14825.91,17.97,9815.61,35.32,5077.71,25.62,-26806.86,20.81,11711.42,16.13,6521.2,27.4,10960.75,28.83}
,{190,81,-24372.027,7.948,7866.064,0.042,-3955.382,14.825,189.973835551,8.532,0,156,"",18,"",0,0,"","",{"B+"},{0},{"="},{0},18178.26,30.94,6578.66,8.39,4917.91,22.42,-13772.45,23.92,1920.96,21.6,-14599.31,16.15,7827.24,11.54,2034.6,32.54,"","",16540.69,14.62,8609.96,16.02,14302.21,23.68}
,{190,82,-20416.645,12.514,7841.129,0.066,-9817.066,25.8,189.978081828,13.434,0,71,"",1,"",0,1,"","",{"A"},{0},{"="},{0},18744.08,16.39,4792.67,17.51,5697.54,4.57,-15852.81,18.36,1920.79,33.94,-18423.3,24.32,10643.93,18.82,3089.52,15.05,"","",12630.56,32.42,6892,14.88,13347.69,18.69}
,{190,83,-10599.579,22.562,7785.342,0.119,-6035.742,26.275,189.988620883,24.221,0,6.3,"",0.1,"",3,1,"","",{"A","B+"},{"","",""},{"=",""},{"","",""},19547.53,25.18,2841.12,37.46,6862.12,3.05,"","",6727.55,24.06,-17248.89,31.55,8606.24,30.72,44.52,26.59,"","",17926.43,24.94,9251.44,23.13,17491.41,23.95}
,{190,84,-4563.837,13.465,7749.458,0.071,"","",189.995100519,14.455,0,0.00246,"",5e-05,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},20162.16,24.08,1326.58,17.13,7693.27,7.22,"","",5991.23,19.46,"","",11213.15,25.84,1788.15,24.82,"","",13341.66,17.51,6683.49,16.78,16069.52,14.39}
,{191,73,-26492,298,7911,2,4684,301,190.97156,320,0,3,"",3e-07,">",3.5,1,"","",{},{},{},{},10805,357,"","",-1337,499,7859,298,"","",-181,301,6050,357,8750,499,10217,298,11381,422,9251,422,2945,585}
,{191,74,-31176.173,41.917,7931.435,0.219,3174.124,43.156,190.966531,45,0,45,"",3e-07,">",1.5,-1,"","",{},{},{},{},11701.27,57.98,18592,301,-785,301,5219.01,41.92,-13435,403,-3611.66,82.32,4865.18,57.75,9952,200,4522.06,42.12,11364,200,7299.91,69.12,5349,301}
,{191,75,-34350.296,10.265,7943.957,0.054,2044.889,10.244,190.963123437,11.019,0,588,"",30,"",1.5,1,"","",{"B-"},{0},{"="},{0},12513.89,13.1,17099,196,120.33,56.82,2358.46,10.28,-13126,196,-3713.84,10.24,6785.78,71.59,7256.95,41.03,-552.39,11.39,11978.05,41.35,9181.57,10.69,4908.13,55.91}
,{191,76,-36395.185,0.659,7950.568,0.003,313.57,1.141,190.960928159,0.707,0,1295136,"",1728,"",4.5,-1,"","",{"B-"},{0},{"="},{0},13551.07,0.22,15355.59,40.06,1083.87,1.18,-696.95,4.04,-9301.84,39.73,-7712.96,1.21,5758.73,0.11,8048.33,70.85,-5803.29,22.29,12294.66,8.17,7485.68,0.5,7919.03,3.04}
,{191,77,-36708.756,1.311,7948.113,0.007,-1010.518,3.636,190.960591527,1.406,1,"s","","s","",1.5,1,"","",{},{},{},{},14401.8,12.54,13307.65,8.24,2082.81,1.24,-2910.85,5.1,-8361.9,70.86,-7473.62,1.22,8026.53,0.4,5289.96,1.15,-10425.81,7.46,12988.8,1.16,9292.53,1.24,7954.46,1.24}
,{191,78,-35698.237,4.127,7938.727,0.022,-1900.333,6.426,190.961676363,4.43,0,244512,"",1728,"",1.5,-1,"","",{"EC"},{0},{"="},{0},15371.52,10.83,11289.43,4.05,3095.79,4.08,-5106.34,22.66,-4279.44,4.04,-10936.02,5.38,6463.1,4.07,6233.66,3.66,-15467.12,37.49,13462.16,13.08,7510.73,10.25,11085.4,4.07}
,{191,79,-33797.904,4.926,7924.681,0.026,-3206.008,22.71,190.963716455,5.288,0,11448,"",288,"",1.5,1,"","",{"B+"},{0},{"="},{0},16358.58,20.68,9926.26,13.51,3326.55,28.38,-7514.96,8.85,-4333.33,5.11,-10498.52,16.65,9035.69,6.01,3780.42,4.97,-20558.56,8.96,13382.25,11.23,8887.08,7.24,10193.41,10.63}
,{191,80,-30591.896,22.28,7903.8,0.117,-4308.951,23.461,190.967158247,23.918,0,2940,"",600,"",0,0,"","",{"B+","A"},{0,5,0},{"=","<"},{0,5,0},17108.13,38.62,8700.49,24.46,3668.24,32.78,-10360.78,43.41,-574.42,22.29,-14291.19,23.66,7292.52,27.35,5047.33,22.55,-25523.16,23.38,13700.86,29.99,6643.47,22.44,12875.43,22.9}
,{191,81,-26282.945,7.349,7877.144,0.038,-6051.827,37.978,190.971784096,7.889,0,1200,"","s","",0,0,"","",{},{},{},{},17809.48,11.14,7278.93,21.38,4319.98,23.49,-13043.6,10.49,-738.38,8.12,-13937.62,14.51,9982.24,10.82,2201.22,17.52,-30146.86,17.7,14054.26,32.4,8783.02,14.31,11734.76,7.83}
,{191,82,-20231.118,37.26,7841.363,0.195,-6991.772,38.005,190.978281,40,0,79.8,"",4.8,"",1.5,-1,"","",{"B+","A"},{0,0.51,0},{"~","="},{0,0.51,0},18529.72,39.83,5182.66,48.82,5461.9,39.77,-15162.38,37.93,3850.61,40.51,-17702.86,43.56,7885.79,39.31,3148.06,38.1,"","",15095.79,38.19,6969.34,47.78,15617.2,39.23}
,{191,83,-13239.347,7.487,7800.661,0.039,-8170.612,10.32,190.985786975,8.037,0,11.7,"",0.4,"",4.5,-1,"","",{"A"},{""},{"="},{""},19317.32,22.15,3201.19,11.23,6780.32,3.04,-17103.26,17.76,3843.71,10.92,-16746.83,15.41,10711.08,23.77,111.67,14.58,"","",15315.49,15.93,9439.91,13,14743.46,30.83}
,{191,84,-5068.735,7.103,7753.786,0.037,-8932.653,17.6,190.994558488,7.624,0,0.022,"",0.001,"",1.5,-1,"","",{"A","B+"},{"",1,0},{"","="},{"",1,0},19789.36,23.17,1802.64,15.75,7493.31,4.95,"","",8058.94,14.38,"","",8576.22,15.22,1758.13,23.65,"","",15706.73,22.03,6990.01,13.25,18392.87,12.77}
,{191,85,3863.917,16.103,7702.923,0.084,"","",191.004148086,17.287,0,0.0021,"",0.0008,"",0.5,1,"","",{"A"},{0},{"~"},{0},"","",649.36,26.35,7822.27,13.61,"","",7174.53,27.72,"","","","",-1138.78,20.99,"","",15996.73,27.31,9272.29,25.66,16705.01,19.61}
,{192,73,-23064,401,7894,2,6586,446,191.97524,430,0,2.2,"",0.7,"",0,0,"","",{"B-"},{0},{"="},{0},10693,446,"","",-1698,643,8525,407,"","",41,403,4643,499,"","",11772,401,12677,566,8963,499,"",""}
,{192,74,-29649,196,7924,1,1939,208,191.96817,210,0,60,"",3e-07,">",0,1,"","",{},{},{},{},11410,200,19197,446,-1195,357,6233,196,"","",-3370,196,6545,200,10447,357,6639,196,9574,277,7044,277,3159,357}
,{192,75,-31588.825,70.794,7930.238,0.369,4293.366,70.831,191.966088,76,0,16,"",0.9,"",0,0,"","",{"B-"},{0},{"="},{0},12095.63,100.16,17654,208,-401.71,89.62,3246.74,70.81,-12386,306,-3264.96,70.8,5309.85,71.53,7701.62,82.27,1183.29,72.54,13504.29,81.18,8892.77,81.34,5887,208}
,{192,76,-35882.191,2.315,7948.525,0.012,-1046.63,2.397,191.961478881,2.485,1,"s","","s","",0,1,"","",{},{},{},{},13317.05,2.22,16077.82,39.79,360.7,3.77,406.27,3.27,-11994.99,41.98,-7244.75,2.4,7558.32,2.22,8820.86,10,-3870.64,15.71,10464.45,70.89,6960.91,8.46,5381.75,40.12}
,{192,77,-34835.561,1.314,7938.999,0.007,1452.896,2.274,191.962602485,1.41,0,6378912,"",1296,"",4,1,"","",{"B-","EC"},{0,4.76,0},{"=","="},{0,4.76,0},14224.65,0.41,13777.67,70.86,1756.33,1.25,-2063.45,15.78,-7774.24,10.28,-7208.64,3.63,6198.12,0.11,5729.35,1.15,-8963.31,31.7,14583.02,1.15,9015.24,1.16,8789.88,8.25}
,{192,78,-36288.457,2.57,7942.491,0.013,-3516.341,15.617,191.961042736,2.758,1,"s","","s","",0,1,"","",{},{},{},{},15124.64,2.52,12158.63,2.49,2423.86,2.53,-4276.9,15.75,-7182.24,2.49,-10561.87,5.56,8661.54,2.87,6868.67,2.28,-13732.44,13.54,11175.89,2.31,7025.18,12.74,8344.69,2.5}
,{192,79,-32772.116,15.827,7920.102,0.082,-760.563,22.178,191.964817684,16.991,0,17784,"",324,"",1,-1,"","",{"B+"},{0},{"="},{0},16081.22,16.2,10596.51,15.79,3147.88,18.41,-6899.87,35.41,-3352.33,15.78,-10251.54,27.33,7045.53,16.58,4362.85,15.88,-19237.58,34.02,15245.14,15.82,8561.29,18.74,11323.87,20.16}
,{192,80,-32011.553,15.537,7912.066,0.081,-6139.307,35.277,191.965634182,16.679,0,17460,"",720,"",0,1,"","",{"EC","A"},{0,4,0},{"=","<"},{0,4,0},16783.49,22.19,9283.04,15.55,3384.46,16.42,-9455.53,20.42,-3602.29,16.07,-13799.92,17.19,9490.97,27.13,5502.62,16.3,-23940.89,19.07,11532.79,15.91,6434.46,25.39,10104.2,18.52}
,{192,81,-25872.246,31.671,7876.016,0.165,-3316.226,34.348,191.972225,34,0,576,"",24,"",0,0,"","",{"B+"},{0},{"="},{0},17642.85,32.65,7616.65,31.86,4074.15,31.79,-12337.71,43.7,636.69,32.05,-13712.44,48.9,7660.62,32.51,2569.32,38.72,-28798.1,42.19,16209.26,35.44,8618.21,44.71,13356.11,37.5}
,{192,82,-22556.02,13.295,7854.669,0.069,-9021.485,32.917,191.975785115,14.273,0,210,"",6,"",0,1,"","",{"B+","A"},{0,0.0059,0},{"~","="},{0,0.0059,0},18282.01,18.24,5763.26,20.7,5220.98,5.11,-14485.36,17.3,746.91,25.93,-17387.99,15.26,10396.22,39.56,3562.04,15.19,"","",12526.81,15.49,6924.14,15.71,12716.78,34.23}
,{192,83,-13534.535,30.112,7803.608,0.157,-5463.873,32.096,191.985470078,32.326,0,34.6,"",0.9,"",3,1,"","",{"B+","A"},{0,12,0},{"=","="},{0,12,0},19077.59,37.63,3740.45,31.14,6376.95,3.54,-16460.39,41.03,5459.44,31,-16537.12,30.94,8366.51,31.03,592.39,47.91,"","",17592.92,32.61,9173.55,33.23,16727.97,31.25}
,{192,84,-8070.661,11.11,7771.075,0.058,-10996.516,30.008,191.991335788,11.926,0,0.0322,"",0.0003,"",0,1,"","",{"A","B+"},{"","",""},{"",""},{"","",""},19649.46,17.44,2231.96,16.71,7319.63,3.25,"","",4871.49,38.88,-20005.9,19.56,11073.24,13.18,2120.29,13.4,"","",13239.72,25.15,6858.05,23.63,15419.77,17.91}
,{192,85,2925.854,27.876,7709.727,0.145,"","",192.003141034,29.926,0,0.0115,"",0.0006,"",3,1,"","",{"A","B+","B+SF"},{0,"","",0.21,0},{"=","","="},{0,"","",0.21,0},"","",1052.51,35.86,7695.63,25.53,"","",8876.23,28.86,"","",9009.38,32.19,-705.62,28.77,"","",18200.5,30.96,9211.91,35.55,18636.92,34.81}
,{193,73,-20870,401,7884,2,5417,446,192.977595,430,0,0.5,"",3e-07,">",3.5,1,"","",{"B-n"},{""},{""},{""},10521,499,"","","","",9362,402,"","",708,446,5878,566,"","",13666,401,"","",9024,566,"",""}
,{193,74,-26287,196,7908,1,3945,199,192.97178,210,0,3,"",3e-07,">",1.5,-1,"","",{},{},{},{},11253,200,"","",-1549,357,7108,196,"","",-2769,208,4709,277,10512,446,8193,196,10916,357,7090,277,4390,446}
,{193,75,-30231.638,39.123,7923.937,0.203,3162.652,39.192,192.967545,42,0,20,"",3e-07,">",2.5,1,"","",{},{},{},{},12023.98,40.45,18318,301,-827,199,4304.6,39.15,-14457,402,-2420.76,39.19,6714.13,80.88,7871,199,3173.18,40.07,11655.34,57.34,9014.73,55.76,3928,199}
,{193,76,-33394.289,2.321,7936.27,0.012,1141.946,2.4,192.964149753,2.491,0,107388,"",64.8,"",1.5,-1,"","",{"B-"},{0},{"="},{0},13141.74,2.23,16796.06,41.98,-201.67,40.12,1085.32,2.42,-11034,196,-6630.05,2.4,5583.42,0.2,9094.44,70.83,-2332.11,15.67,11666.81,10,7105.6,70.89,6634.43,39.79}
,{193,77,-34536.235,1.328,7938.133,0.007,-56.628,0.3,192.962923824,1.425,1,"s","","s","",1.5,1,"","",{},{},{},{},13970.11,0.23,14763.88,10.28,1017.89,8.25,-1131.41,8.76,-10236.38,70.81,-6319.1,2.28,7771.99,0.2,5943.02,2.4,-7059.02,6.84,12569.76,1.16,9035.59,1.17,6746,70.86}
,{193,78,-34479.608,1.359,7933.786,0.007,-1074.787,8.768,192.962984616,1.458,0,1577846300,"",189341556,"",0.5,-1,"","",{"EC"},{0},{"="},{0},14924,3.62,12662.36,1.2,2082.22,1.22,-3417.43,15.56,-5886.39,2.41,-9778.81,15.79,6262.47,2.3,6933.02,0.36,-12285.12,49.6,12939.95,0.38,7137.99,0.55,9874.56,1.2}
,{193,79,-33404.821,8.674,7924.164,0.045,-2342.642,14.37,192.964138447,9.311,0,63540,"",540,"",1.5,1,"","",{"B+","A"},{0,1,0},{"=","<"},{0,1,0},15749.55,9.98,11274.01,8.76,2619.85,15.27,-5927.61,10.96,-5858.23,8.76,-9464.59,17.79,8704.02,18.04,4405.33,9.03,-17520.26,11.52,13004.22,9.6,8765.68,8.69,8995.12,8.77}
,{193,80,-31062.179,15.505,7907.972,0.08,-3584.967,16.894,192.966653377,16.645,0,13680,"",540,"",0,0,"","",{"B+"},{0},{"="},{0},16612.92,27.13,9941.88,16.04,2982.25,18.49,-8867.69,51.94,-2062.69,15.71,-13261.25,35.26,7121.94,21.93,5579.03,22.15,-22736.86,21.25,13446.53,16.27,6635.41,15.88,11890.67,15.51}
,{193,81,-27477.212,6.707,7885.344,0.035,-5282.723,50.028,192.970501997,7.2,0,1296,"",48,"",0,0,"","",{"B+"},{0},{"="},{0},17336.9,9.95,8257.25,8.32,3679.83,21.17,-11592.65,10.12,-1994.07,17.19,-12992.51,14.89,9676.28,32.37,2754.63,16.92,-27409.89,22.65,13825.49,23.27,8757.54,17.26,11002.72,7.54}
,{193,82,-22194.49,49.577,7853.919,0.257,-6309.931,50.152,192.976173234,53.222,0,300,"","s","",1.5,-1,"","",{},{},{},{},18106.01,62.02,6180.53,54.35,5007,58.77,-13869.17,51.66,2528.09,51.95,-16731.27,58.01,7709.79,51.33,3611.21,58.83,-31237.4,55.57,14799.26,50.12,7041.59,50.21,14822.61,52.07}
,{193,83,-15884.559,7.576,7817.171,0.039,-7559.241,16.387,192.982947223,8.132,0,63.6,"",3,"",4.5,-1,"","",{"A"},{0},{"="},{0},18787.85,10.65,4179.55,10.55,6306.63,4.9,-15817.24,22.92,2698.72,32.56,-15885.21,13.45,10421.34,31.05,617.51,15.3,"","",15057.37,38.02,9396.14,14.63,14133.87,10.98}
,{193,84,-8325.318,14.531,7773.95,0.075,-8257.998,26.059,192.991062403,15.599,0,0.388,"",0.04,"",1.5,-1,"","",{"A","B+"},{"",5,0},{"","="},{"",5,0},19399.22,16.17,2672.14,39.99,7093.8,3.66,-17368.23,29.01,6941.73,19.69,-19322.49,31.44,8325.97,18.28,2079.75,33.43,"","",15624.84,16.35,7138.32,26.84,17737.73,19.17}
,{193,85,-67.32,21.632,7727.109,0.112,-9110.231,33.144,192.999927728,23.222,0,0.029,"",0.005,"",0.5,1,"","",{"A"},{0},{"~"},{0},20073.87,26.97,1405.91,22.89,7572.42,6.92,"","",6178.24,37.08,"","",11064.49,35.28,-714.37,24.32,"","",15712.22,22.77,9360.57,25.48,16178.66,31.26}
,{193,86,9042.911,25.112,7675.852,0.13,"","",193.009707964,26.958,0,0.00115,"",0.00027,"",1.5,-1,"","",{"A"},{0},{"~"},{0},"","",466.3,26.1,8040,12,"","",9824.6,27.46,"","","","",1171.91,37.52,"","",15889.8,29.83,"","",19253.15,28.49}
,{194,73,-17300,503,7866,3,7227,585,193.981428,540,0,0.3,"",3e-07,">",0,0,"","",{"B-n"},{""},{""},{""},10379,643,"","","","",9937,540,"","",916,540,4501,643,"","",15232,503,"","","","","",""}
,{194,74,-24526,298,7899,2,2711,357,193.97367,320,0,5,"",3e-07,">",0,1,"","",{},{},{},{},11019,357,"","",-1921,499,7909,298,"","",-2366,301,6311,357,10945,499,10234,298,9248,499,6830,422,"",""}
,{194,75,-27237,196,7909,1,5198,196,193.97076,210,0,5,"",1,"",0,1,"","",{"B-"},{0},{"="},{0},11791,208,18751,446,-1149,277,5295,196,-13656,446,-1914,196,5077,199,8239,277,4975,196,13123,277,8803,200,4901,357}
,{194,76,-32435.108,2.403,7932.022,0.012,96.6,2,193.965179477,2.579,0,189341556,"",6311385.2,"",0,1,"","",{"B-"},{0},{"="},{0},12695.55,3.12,17364,196,-477.71,39.8,2324.96,2.36,-13437,196,-5970.19,2,7112.14,3.13,9492.44,39.2,-251.16,3.76,9864.52,70.83,6779.24,10.48,4387.47,41.99}
,{194,77,-32531.708,1.332,7928.487,0.007,2228.362,1.257,193.965075773,1.43,0,69408,"",468,"",1,-1,"","",{"B-"},{0},{"="},{0},13838.78,0.23,15520.82,70.81,679.21,70.86,-319.77,2.46,-9589.04,39.15,-6123.42,0.32,6066.79,0.11,6426.39,2.4,-5594.22,14.04,14061.29,2.4,8727.53,1.17,7464.99,10.28}
,{194,78,-34760.07,0.496,7935.941,0.003,-2548.134,2.117,193.962683527,0.532,1,"s","","s","",0,1,"","",{},{},{},{},14614.25,2.53,13455.82,2.27,1522.78,0.48,-2576.13,2.93,-8654.75,2.28,-9426.57,8.67,8351.78,1.29,7512.81,1.25,-10552.13,17.44,10786.3,1.24,6812.74,1.23,7281.52,0.49}
,{194,79,-32211.936,2.118,7918.774,0.011,-27.991,3.581,193.965419062,2.273,0,136872,"",360,"",1,-1,"","",{"B+"},{0},{"="},{0},15582.45,15.96,11954.32,2.45,2116.69,2.48,-5274.44,14.13,-4964.67,2.45,-9221.07,15.64,6878.43,8.9,5021.3,2.47,-16183.12,6.53,14787.33,3.3,8350.36,4.62,10143.22,2.45}
,{194,80,-32183.945,2.888,7914.597,0.015,-5246.454,14.268,193.965449111,3.1,0,14105945922,"",883593928,"",0,1,"","",{"EC"},{0},{"="},{0},16315.03,15.8,10473.43,3.87,2697.59,2.96,-7976.01,17.67,-4993.31,3.19,-12778.05,7.3,9193.08,15.77,6068.09,9.14,-21179.29,13.23,11298.98,16.09,6478.01,5.71,9160.69,5.04}
,{194,81,-26937.491,13.972,7883.52,0.072,-2729.552,22.343,193.971081411,15,0,1980,"",30,"",2,-1,"","",{"B+","A"},{0,1,0},{"=","<"},{0,1,0},17207.88,34.62,8743.32,21.11,3471.13,14.39,-10908.68,15.28,-821.64,16.45,-12814.32,51.51,7531.6,15.5,3164.28,20.87,-26217.33,28.58,15784.87,20.9,8518.46,26.3,12506.81,14.82}
,{194,82,-24207.94,17.435,7865.418,0.09,-8179.128,18.498,193.974011706,18.717,0,642,"",36,"",0,1,"","",{"B+","A"},{0,7.3,0},{"=","="},{0,7.3,0},17794.55,21.89,6774.33,23.3,4737.84,16.72,-13203.28,21.67,-434.73,23.32,-16394.7,19.01,10084.77,52.55,4019.7,18.68,-29931.43,24.26,12375.11,36.15,6939.06,18.92,12030.36,28.26}
,{194,83,-16028.811,6.178,7819.225,0.032,-5024.156,14.313,193.982792362,6.632,0,95,"",3,"",3,1,"","",{"B+","A"},{0,0.46,0},{"~","="},{0,0.46,0},18636.91,30.74,4734.51,32.27,5918.3,5,-15308.65,25.69,4159.43,9.12,-15774.81,15.79,8215.57,9.78,1123.29,49.96,"","",17238.01,14.66,9066.36,37.77,15900.54,9.6}
,{194,84,-11004.655,12.911,7789.294,0.067,-10284.492,28.076,193.988186015,13.86,0,0.392,"",0.004,"",0,1,"","",{"A"},{0},{"~"},{0},19076.63,17.01,3026.58,18.51,6987.07,3.18,-16728.15,21.25,3900.86,51.23,-19008.65,25.19,10750.65,19.43,2409.07,14.97,"","",13240.69,32.76,7098.75,14.92,14872.86,39.43}
,{194,85,-720.163,24.931,7732.249,0.129,-6443.658,30.119,193.999226872,26.764,0,0.286,"",0.007,"",4,-1,"","",{"A","B+","B+SF"},{0,"","",0.032,0},{"~","","="},{0,"","",0.032,0},19788.65,37.4,1763.57,39.09,7454.5,10.61,"","",7875.42,26.06,-17834.39,35.39,8724.16,33.01,-316.18,28.86,"","",18061.3,27.29,9212.63,25.92,18165.58,26.03}
,{194,86,5723.495,16.899,7695.001,0.087,"","",194.006144424,18.141,0,0.00078,"",0.00016,"",0,1,"","",{"A"},{0},{"~"},{0},"","",783.78,20.21,7862.42,10.21,"","",6759.84,22.28,"","",11390.73,30.27,1498.16,27.45,"","",13508.45,32.6,6723.63,23.34,16438.63,18.33}
,{195,74,-21010,298,7882,2,4569,422,194.977445,320,0,3,"",3e-07,">",2.5,-1,"","",{},{},{},{},10866,357,"","","","",8502,303,"","",-1844,357,4555,422,10999,585,11784,298,10571,499,6918,499,"",""}
,{195,75,-25579,298,7902,2,3933,303,194.97254,320,0,6,"",1,"",2.5,1,"","",{"B-"},{0},{"="},{0},11490,301,19287,499,-1512,422,6113,298,-15568,585,-1215,298,6413,357,8342,422,6988,298,11419,357,8935,357,3131,499}
,{195,76,-29511.593,55.89,7917.744,0.287,2180.658,55.906,194.968318,60,0,390,"",66,"",1.5,-1,"","",{},{},{},{},12259.94,55.94,17803,203,-760.34,69.86,3282.26,55.89,-12274,303,-5051.2,55.91,5147.8,55.94,9564,203,1501.8,60.49,11430.85,68.22,6941.29,90.2,5784,203}
,{195,77,-31692.251,1.333,7924.915,0.007,1101.598,1.264,194.965976967,1.431,0,8244,"",612,"",1.5,1,"","",{"B-"},{0},{"="},{0},13298.65,0.13,16038.55,39.15,233.13,10.28,874.78,1.61,-11744,196,-5003.5,1.26,7231.86,0.06,6546.11,2,-3537,11.17,12412.84,2.4,9053.99,2.4,5542.98,70.81}
,{195,78,-32793.849,0.503,7926.552,0.003,-226.817,1,194.964794353,0.539,1,"s","","s","",0.5,-1,"","",{},{},{},{},14456.88,1.29,13977.5,2.28,1176.42,0.5,-1780.46,23.14,-7647.71,2.37,-8653.23,2.12,6105.1,0.12,7551.11,1.26,-9086.16,17.97,12453.19,1.26,6905.77,1.24,8734.74,2.28}
,{195,79,-32567.031,1.119,7921.377,0.006,-1553.638,23.156,194.965037851,1.201,0,16071264,"",5184,"",1.5,1,"","",{"EC"},{0},{"="},{0},15304.84,8.73,12608.74,1.61,1716.81,1.59,-4411.78,11.15,-7324.29,1.61,-8454.4,3.1,8426.41,2.34,5095.93,1.01,-14541.47,5.4,12623.38,1.63,8585.48,2.72,7914.93,1.6}
,{195,80,-31013.393,23.142,7909.397,0.119,-2858.145,25.657,194.966705751,24.843,0,38484,"",576,"",0.5,-1,"","",{"B+"},{0},{"="},{0},16093.85,27.84,11111.73,23.18,2259.93,23.5,-7305.7,29.28,-3542.29,23.14,-12147.22,27.03,6900.76,23.32,6090.43,23.24,-19957.13,43.95,13102.23,24.71,6622.78,28.03,10921.47,23.28}
,{195,81,-28155.248,11.093,7890.728,0.057,-4447.555,21.106,194.969774096,11.909,0,4176,"",180,"",0.5,1,"","",{"B+"},{0},{"="},{0},16820.67,12.96,9328.37,14.08,3217.74,12.14,-10129.69,12.29,-3232.28,11.29,-12018.63,20.66,9289.07,17.84,3260.27,11.46,-24684.95,14.65,13617.74,19.06,8720.36,19.08,10263.27,19.33}
,{195,82,-23707.693,17.96,7863.908,0.092,-5682.132,18.722,194.974548743,19.28,0,900,"","s","",1.5,-1,"","",{"B+"},{0},{"="},{0},17655.84,52.73,7223.46,23.72,4459.29,28.61,-12651.43,41.46,1187.28,18.19,-15750.2,18.99,7571.07,25.01,4059.17,22.75,-28757.97,53.6,14480.33,19.17,7028.61,36.41,13950.26,23.73}
,{195,83,-18025.561,5.287,7830.757,0.027,-6969.303,37.737,194.980648762,5.675,0,183,"",4,"",0,0,"","",{"B+","A"},{0,0.03,0},{"~","="},{0,0.03,0},18283.64,9.24,5126.29,8.54,5832.47,5.1,-14555.27,10.94,1622.96,14.94,-15092.22,13.95,10068.07,8.13,1106.59,18.22,"","",14879.73,49.86,9394.51,14.31,13493.09,32.11}
,{195,84,-11056.259,37.364,7791.005,0.192,-7585.964,38.571,194.988130617,40.112,0,4.64,"",0.09,"",1.5,-1,"","",{"A"},{0},{"="},{0},18873.58,40.09,3439.71,62.08,6749.94,2.8,-16106.54,62.82,5862.71,41.23,-18407.41,44.92,8122.92,39.53,2316.42,37.87,"","",15539.11,38.12,7342.33,47.99,17146.16,39.66}
,{195,85,-3470.295,9.573,7748.091,0.049,-8520.575,51.401,194.996274485,10.276,0,0.29,"",0.02,"",0.5,1,"","",{"A"},{0},{"~"},{0},19545.61,23.66,2163.68,12.21,7344.14,6.01,"","",5269.55,11.39,-17265.11,19.42,10821.45,26.71,-245.39,16.07,"","",15565.83,17.4,9464.42,14.66,15710.64,31.6}
,{195,86,5050.281,50.502,7700.383,0.259,"","",195.005421699,54.216,0,0.007,"",0.003,"",1.5,-1,"","",{"A"},{0},{"~"},{0},20135.26,56.4,1202.34,52.55,7694.1,50,"","",8765.97,52.12,"","",8744.53,53.25,1518.53,56.32,"","",15828.41,54.94,6988.48,57.68,18767.34,51.71}
,{196,74,-18880,401,7872,2,3662,499,195.979731,430,0,3,"",3e-07,">",0,1,"","",{},{},{},{},10497,499,"","","","",9397,403,"","",-1373,499,5942,499,"","",13764,401,9130,643,6854,566,"",""}
,{196,75,-22542,298,7887,2,5735,301,195.9758,320,0,2.4,"",1.5,"",0,0,"","",{},{},{},{},11448,357,19820,585,-1903,499,6893,301,"","",-1102,303,5035,422,8821,422,8597,298,12695,422,8609,357,3974,499}
,{196,76,-28277.105,40.055,7912.229,0.204,1158.388,55.495,195.969643277,43,0,2094,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},11984.63,40.12,18329,301,-1053,200,4367.4,40.05,-14556,301,-4656.17,40.07,6836.83,68.76,9987,301,3548.84,40.16,9671,200,6818.59,55.99,3656,200}
,{196,77,-29435.493,38.414,7914.148,0.196,3209.016,38.411,195.968399696,41.239,0,52,"",1,"",0,-1,"","",{"B-"},{0},{"="},{0},13046.42,38.43,16777,199,-271.58,80.54,1703.21,38.52,-11146,301,-4712.96,38.41,5814.56,38.43,7212.87,67.82,-1938.9,40.28,13710.42,38.48,8822.85,38.48,6442.55,54.83}
,{196,78,-32644.51,0.51,7926.529,0.003,-1505.803,2.96,195.964954675,0.547,1,"s","","s","",0,1,"","",{},{},{},{},14027.07,0.17,14787.34,2.37,812.77,2.28,-818.57,2.96,-10421.89,55.89,-8148.8,1.01,7921.98,0.13,8241.23,1.27,-7296.2,7.72,10598,1.27,6755.78,1.26,6396.18,2.28}
,{196,79,-31138.706,2.962,7914.855,0.015,687.235,3.118,195.966571221,3.179,0,532820.16,"",51.84,"",2,-1,"","",{"B+","B-"},{0,7.2,0},{"=","="},{0,7.2,0},15069.4,3.58,13184.94,3.21,1271.94,3.21,-3642.11,12.47,-6735.43,3.21,-8196.63,23.33,6642.99,3.13,5633.83,2.96,-13129.68,24.61,14332.17,2.96,8204.96,3.22,9043.93,3.21}
,{196,80,-31825.941,2.946,7914.369,0.015,-4329.349,12.463,195.965833444,3.163,1,"s","","s","",0,1,"","",{},{},{},{},15784.63,4.13,11643.81,2.96,2037.6,3.89,-6477.63,8.25,-6321.06,2.96,-11742.01,11.48,8883.87,23.33,6547.88,3.12,-18352.9,13.83,11096.8,3.58,6442.93,9.14,8300.07,3.22}
,{196,81,-27496.592,12.109,7888.289,0.062,-2148.28,14.356,195.970481192,13,0,6624,"",108,"",2,-1,"","",{"B+"},{0},{"="},{0},16701.73,18.49,9862.6,12.29,2850.61,19.93,-9487.56,27.26,-2218.53,12.16,-11860.22,21.66,7412.66,16.42,3772.17,26.12,-23581.92,32.62,15398.16,12.45,8429.64,19.67,11554.63,14.9}
,{196,82,-25348.312,7.71,7873.337,0.039,-7339.281,25.616,195.972787466,8.277,0,2220,"",180,"",0,1,"","",{"B+","A"},{0,3,0},{"=","<"},{0,3,0},17283.01,19,7742.31,8.23,4238.33,17.28,-11875.27,15.51,-1623.89,24.35,-15394.07,9.35,9711.94,19.52,4482.03,13.49,-27319.3,16.31,12299.99,15.96,6992.96,10.22,11360.27,17.29}
,{196,83,-18009.031,24.428,7831.9,0.125,-4535.989,27.916,195.980666509,26.224,0,306,"",12,"",3,1,"","",{"B+","A"},{0,0.00115,0},{"~","="},{0,0.00115,0},18122.85,25.2,5649.48,28.14,5438.3,40,-14094.35,38.91,2857.25,26.83,-15024.09,44.64,8054.79,24.99,1590.31,30.32,"","",16909.72,30.01,9049.51,55.27,15114.58,25.33}
,{196,84,-13473.042,13.512,7804.766,0.069,-9558.365,33.162,195.985536094,14.506,0,5.56,"",0.09,"",0,1,"","",{"A","B+"},{0,2,0},{"~","~"},{0,2,0},18611.02,18.67,3843.04,22.03,6658.06,2.41,-15444.03,19.74,2945.68,22.46,-18074.06,16.56,10488.1,39.73,2736.45,14.51,"","",13266.58,14.86,7275.57,15.49,14367.85,51.39}
,{196,85,-3914.677,30.284,7752.007,0.155,-5885.668,33.54,195.995797421,32.511,0,0.388,"",0.007,"",3,1,"","",{"A","B+","B+SF"},{"",5,0,0.088,0},{"","=","="},{"",5,0,0.088,0},19337.15,39.23,2463.81,30.91,7194.94,3.22,"","",6821.91,30.74,-17036.27,58.89,8515.7,31.76,147.39,48.1,"","",17800.78,32.92,9274.7,33.59,17616.28,31.22}
,{196,86,1970.991,14.417,7717.987,0.074,"","",196.002115945,15.476,0,0.0047,"",0.0011,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},19895.14,22.2,1602.3,19.33,7616.74,9.19,"","",5738.28,40.05,"","",11150.61,52.52,1847.69,17.31,"","",13401.96,28.8,6902.37,26,15942.71,20.46}
,{197,74,-15140,401,7854,2,5363,499,196.983747,430,0,1,"",3e-07,">",2.5,-1,"","",{},{},{},{},10272,499,"","","","",10169,446,"","",-669,499,4330,566,"","",15280,401,"","",7024,643,"",""}
,{197,75,-20502,298,7878,2,4807,357,196.97799,320,0,0.3,"",3e-07,">",2.5,1,"","",{},{},{},{},11066,422,"","",-2057,499,7762,299,"","",-296,301,6031,422,8911,499,10638,298,11218,422,8888,422,2444,585}
,{197,76,-25309,196,7898,1,2955,197,196.97283,210,0,168,"",36,"",2.5,-1,"","",{"B-"},{0},{"="},{0},11940,203,18877,357,-1447,277,5111,196,-13717,446,-3945,199,5103,200,10056,357,5232,196,10981,357,6792,277,4864,357}
,{197,77,-28264.105,20.11,7908.999,0.102,2155.645,20.106,196.969657233,21.588,0,348,"",30,"",1.5,1,"","",{"B-"},{0},{"="},{0},12714.49,20.15,17263,299,-457.38,43.99,2875.63,20.11,-13011,299,-3690.91,20.11,6899.93,43.36,7275.97,44.72,77.54,25.9,11958.29,59.4,9035.06,20.25,4619,197}
,{197,78,-30419.75,0.536,7915.971,0.003,719.988,0.502,196.967343053,0.575,0,71609.4,"",6.84,"",0.5,-1,"","",{"B-"},{0},{"="},{0},13768.54,0.29,15486.1,55.89,549.62,2.3,120.48,3.22,-9431.62,40.05,-7352.36,2.96,5846.56,0.26,8273.23,38.41,-5674.35,4.83,11983.31,1.29,6976.01,1.29,7661.76,2.38}
,{197,79,-31139.738,0.542,7915.654,0.003,-599.509,3.202,196.966570114,0.581,1,"s","","s","",1.5,1,"","",{},{},{},{},14715.34,1.13,14025.43,1.36,971.58,1.35,-2798.09,16.33,-8993.22,38.41,-7385.11,2.94,8072.35,2.94,5784.2,0.53,-11452.55,8.35,12364.92,0.53,8484.39,0.54,7038.37,1.36}
,{197,80,-30540.229,3.207,7908.64,0.016,-2198.58,16.637,196.967213713,3.442,0,233784,"",252,"",0.5,-1,"","",{"EC"},{0},{"="},{0},15669.47,23.36,12324.32,3.22,1514.46,3.46,-5794.83,5.77,-5184.69,3.22,-11114.95,12.53,6785.61,1.48,6690.49,3.4,-17182.24,49.78,12737.61,3.37,6535.76,3.8,9866.24,3.22}
,{197,81,-28341.649,16.325,7893.508,0.083,-3596.247,17.014,196.969573986,17.526,0,10224,"",144,"",0.5,1,"","",{"B+"},{0},{"="},{0},16329.04,19.74,10352.56,16.36,2638.26,18.49,-8654.46,18.33,-4491.91,16.59,-11064.65,18.04,8916.37,20.33,3804.68,16.59,-21986.4,18.17,13382.55,28.31,8706.35,16.58,9516.69,16.46}
,{197,82,-24745.401,4.804,7871.282,0.024,-5058.21,9.619,196.973434717,5.157,0,486,"",102,"",1.5,-1,"","",{"B+"},{0},{"="},{0},17180.34,18.58,8309.95,23.62,3891.86,16.23,-11387.41,49.91,-208.43,5.63,-14807.69,24.9,7468.41,9.05,4537.78,13.03,-26255.75,16.89,14120.65,12.08,7056.15,14.78,13084.95,5.61}
,{197,83,-19687.191,8.333,7841.634,0.042,-6329.202,50.373,196.978864929,8.946,0,559.8,"",30,"",4.5,-1,"","",{"B+","A"},{0,1,0},{"=","="},{0,1,0},17804.26,9.87,6109.88,13.87,5365.11,10.7,-13331.94,11.54,520.43,14.7,-14285.47,15.88,9749.48,25.81,1627.85,11.35,-29941.16,55.04,14731.31,19.8,9384.8,19.32,12896.7,16.27}
,{197,84,-13357.99,49.679,7805.535,0.252,-7002.739,50.317,196.985659607,53.332,0,53.6,"",0.9,"",1.5,-1,"","",{"A"},{0},{"="},{0},18444.37,62.16,4228.24,52.83,6411.58,3.19,-14868.34,52.25,4701.35,50.27,-17514.63,58.18,7956.27,51.48,2637.93,55.36,"","",15378.38,49.96,7534.88,50.06,16496.35,52.65}
,{197,85,-6355.25,7.983,7766.017,0.041,-7865.603,18.054,196.993177357,8.57,0,0.3882,"",0.0056,"",4.5,-1,"","",{"A","B+"},{0,3.9,0},{"=","="},{0,3.9,0},19027.59,12.46,2907.63,9.57,7104.39,3.07,-16609.22,54.99,4364.81,25.7,-16397.56,16.48,10511.89,31.32,171.18,15.69,"","",15411.81,38.21,9513.46,15.18,15319.96,10.09}
,{197,86,1510.353,16.193,7722.118,0.082,-8743.618,56.762,197.00162143,17.383,0,0.054,"",0.006,"",1.5,-1,"","",{"A"},{0},{"~"},{0},19682.56,53.03,2011.33,40.72,7410.75,7.15,"","",7694.42,21.08,"","",8531.96,21.67,1863.94,34.34,"","",15691.45,18.81,7094.57,29.73,18161.41,20.7}
,{197,87,10253.971,54.404,7673.763,0.276,"","",197.01100809,58.404,0,0.00233,"",0.00188,"",3.5,-1,"","",{"A"},{0},{"~"},{0},"","",853.68,55.24,7896.38,50.72,"","",6879.68,62.26,"","","","",-994.01,56.28,"","",15914.5,74.23,9394.53,56.97,16620.54,59.84}
,{198,75,-17139,401,7862,2,6697,446,197.9816,430,0,0.3,"",3e-07,">",0,0,"","",{"B-n"},{0},{"="},{0},10740,499,"","",-2265,643,8682,446,"","",98,446,4709,499,9289,566,12441,401,12452,566,8734,499,"",""}
,{198,76,-23837,196,7891,1,1984,277,197.97441,210,0,60,"",3e-07,">",0,1,"","",{},{},{},{},11702,200,19534,446,-1736,357,6067,196,-15986,446,-3644,197,6600,277,10624,357,7117,196,9416,357,6606,357,2819,357}
,{198,77,-25821,196,7897,1,4083,196,197.97228,210,0,8,"",1,"",0,0,"","",{"B-"},{0},{"="},{0},12528,199,17857,357,-1009,277,3760,196,-12608,357,-3473,196,5628,197,7801,277,1708,196,13167,200,8555,203,5404,357}
,{198,78,-29903.999,2.1,7914.15,0.011,-323.219,2.059,197.967896734,2.254,1,"s","","s","",0,1,"","",{},{},{},{},13402.12,2.07,16204.84,40,106.19,3.14,1050.31,2.1,-11884,196,-6835.58,2.06,7555.57,2.06,8928.86,20,-3836.51,9,10242.3,38.47,6652.31,2.43,5254,55.93}
,{198,79,-29580.781,0.54,7908.567,0.003,1373.53,0.49,197.968243724,0.579,0,232770.24,"",17.28,"",2,-1,"","",{"B-"},{0},{"="},{0},14584.71,2.94,14723.23,38.41,526.01,1.36,-2052.03,7.56,-8605.65,20.11,-7111.87,3.2,6512.36,0.09,6450,0.51,-10211.29,27.95,13774.54,0.53,8077.12,0.54,7757.87,1.36}
,{198,80,-30954.31,0.458,7911.552,0.002,-3425.564,7.559,197.966769179,0.491,1,"s","","s","",0,1,"","",{},{},{},{},15271,2.93,12887.74,0.59,1380.84,0.59,-4886.82,8.76,-7823.53,0.59,-10683.98,16.33,8485.4,3.19,7103.54,0.5,-15480.96,17.43,10895.2,2.95,6476.78,1.16,7485.94,0.59}
,{198,81,-27528.746,7.545,7890.3,0.038,-1461.257,11.554,197.970446673,8.1,0,19080,"",1800,"",2,-1,"","",{"B+"},{0},{"="},{0},16174.79,14.27,10967.98,8.11,2258.27,7.84,-8159.26,28.95,-3677.98,7.56,-10854.66,8.94,7258.41,17.98,4277.49,8.2,-20814.23,9.56,15008,8.1,8348.7,24.34,10684.69,7.63}
,{198,82,-26067.489,8.75,7878.969,0.044,-6698.003,29.283,197.972015397,9.393,0,8640,"",360,"",0,1,"","",{"B+"},{0},{"="},{0},16861.81,11.59,8819.49,9.23,3691.54,9.21,-10594.14,19.46,-2816.23,9.32,-14451.62,12.08,9393.41,9.96,5014.81,18.51,-24837.13,15.99,12139.91,14.94,6951.81,14.12,10592.3,24.72}
,{198,83,-19369.486,27.945,7841.189,0.141,-3896.134,32.932,197.979206,30,0,618,"",18,"",0,0,"","",{"B+"},{0},{"="},{0},17503.09,37.12,6450.84,30.46,5143.09,31.24,-12654.97,28.55,1683.19,32.36,-14082.81,57,7753.61,29.16,1913.06,28.35,-28943.51,42.65,16689.63,28.99,9202.26,33.22,14432.16,30.07}
,{198,84,-15473.352,17.424,7817.561,0.088,-8758.839,18.386,197.983388672,18.705,0,105.6,"",1.44,"",0,1,"","",{"A","B+"},{0,43,0},{"=","="},{0,43,0},18142.94,22.02,4702.98,18.99,6309.67,1.37,-14242.99,21.96,1983.08,18.06,-17189.42,19.17,10186.68,52.65,3075.13,19.31,"","",13246.48,30.01,7416.26,18.21,13880.74,25}
,{198,85,-6714.513,5.868,7769.373,0.03,-5484.155,14.647,197.992791673,6.3,0,3,"",0.1,"",3,1,"","",{"A"},{0},{">"},{0},18942.47,30.85,3283.42,25.12,6889.38,1.93,-16288.54,32.75,5683.71,10.19,-16296.18,17.22,8430.58,9.91,645.49,50.02,"","",17469.33,14.73,9205.8,37.82,16957.45,7.9}
,{198,86,-1230.358,13.42,7737.724,0.068,-10804.382,34.905,197.998679156,14.406,0,0.065,"",0.003,"",0,1,"","",{"A","B+"},{"",1,0},{"","="},{"",1,0},19343.98,19.68,2335.26,19.02,7349.38,3.66,"","",4838.66,51.46,-19555.65,56.03,10812.03,21.02,2164.08,15.61,"","",13395.12,33.12,7103.99,16.48,15472.3,39.7}
,{198,87,9574.024,32.222,7679.205,0.163,"","",198.010278138,34.591,0,0.015,"",0.003,"",0,0,"","",{"A"},{0},{"~"},{0},"","",1089.24,44.22,7869.27,20.41,"","",8640.3,33.2,"","",8751.26,63.23,-774.7,36.06,"","",18313.84,35.3,9387.8,59.91,18690.72,33.61}
,{199,75,-14860,401,7851,2,5623,446,198.984047,430,0,0.1,"",3e-07,">",2.5,1,"","",{},{},{},{},10501,499,"","","","",9538,403,"","",905,446,5792,566,"","",14234,401,10990,566,8884,566,"",""}
,{199,76,-20484,196,7875,1,3915,200,198.97801,210,0,6,"",3,"",2.5,-1,"","",{"B-"},{0},{"="},{0},11317,277,19922,446,-1899,357,6905,196,"","",-2734,277,4718,277,10633,446,9063,196,10729,357,6923,357,4043,446}
,{199,77,-24398.515,41.054,7891.206,0.206,2990.167,41.003,198.973807115,44.073,0,7,"",5,"",1.5,1,"","",{},{},{},{},12277.04,45.62,18474,301,-1245,301,4695.23,41.05,-14548,403,-2565.83,41,6649,200,7851,200,3660.88,49.66,11621,200,8742.65,57.28,3790,301}
,{199,78,-27388.682,2.159,7902.3,0.011,1705.059,2.12,198.970597038,2.317,0,1848,"",12.6,"",2.5,-1,"","",{"B-"},{0},{"="},{0},13111.57,2.12,16658,196,-302,55.93,2157.39,2.19,-10841,196,-5879.22,2.12,5556,0.5,8857,196,-2156.88,10.23,11586.23,20.01,6910.87,38.47,6534.82,40}
,{199,79,-29093.741,0.542,7906.937,0.003,452.327,0.613,198.968766582,0.581,0,271209.6,"",604.8,"",1.5,1,"","",{"B-"},{0},{"="},{0},14096.64,0.11,15407.58,20.11,173.59,1.36,-1034.35,27.95,-10562,196,-6210.75,0.49,7584.28,0.06,6478.71,2.06,-8296.18,10.58,12036.81,0.51,8414.82,0.53,5988.15,38.41}
,{199,80,-29546.068,0.526,7905.279,0.003,-1486.674,27.95,198.968280989,0.564,1,"s","","s","",0.5,-1,"","",{},{},{},{},15148.47,3.22,13704.26,0.67,822.87,0.66,-4314.26,10.01,-6931.04,2.13,-10088.64,7.56,6663.07,0.58,7254.26,0.61,-14337.59,18.06,12304.48,0.62,6456.69,2.98,8744.84,0.66}
,{199,81,-28059.394,27.945,7893.877,0.14,-2827.589,29.679,198.969877,30,0,26712,"",288,"",0.5,1,"","",{"B+"},{0},{"="},{0},15860.38,32.36,11497.6,27.95,2082.72,27.97,-7261.83,29.88,-5767.58,27.95,-10063.22,29.28,8601.96,28.95,4394.05,27.95,-19236.02,28.46,13191.64,28.13,8630.6,28.1,8725.71,28.1}
,{199,82,-25231.804,9.996,7875.736,0.05,-4434.239,14.547,198.972912542,10.73,0,5400,"",600,"",1.5,-1,"","",{"B+"},{0},{"="},{0},16629.04,11.09,9269.52,10.5,3356.67,25.21,-10023.32,20.64,-1566.46,10.01,-13933.64,29.68,7235.63,13.28,4992.03,12.52,-23732.35,38.89,13820.65,19.14,7128.84,15.7,12240.54,10.42}
,{199,83,-20797.566,10.568,7849.522,0.053,-5589.083,20.919,198.977672893,11.345,0,1620,"",60,"",4.5,-1,"","",{"B+"},{0},{"="},{0},17253.01,13.46,7033.86,19.44,4932.77,6.71,-11974.19,11.86,-557.79,12.99,-13395.53,20.37,9499.4,29.88,2019.05,13.71,-27568.96,17.32,14658.64,11.6,9414.8,13.06,12345.43,16.07}
,{199,84,-15208.483,18.06,7817.505,0.091,-6385.111,18.845,198.983673021,19.387,0,328.2,"",9,"",1.5,-1,"","",{"B+","A"},{0,7.5,0},{"=","="},{0,7.5,0},17993.13,52.86,5041.02,18.68,6074.29,1.9,-13709.03,41.7,3570.04,20.05,-16565.29,18.99,7806.45,25.08,3127.97,33.27,"","",15189.51,19.89,7664.6,30.38,15786.23,19.61}
,{199,85,-8823.372,5.384,7781.488,0.027,-7323.921,37.972,198.990527719,5.78,0,7.02,"",0.12,"",0,0,"","",{"A"},{0},{"="},{0},18610.76,9.63,3714.12,9.92,6777.27,1.15,-15594.77,14.74,3257.14,28.46,-15664.33,14.46,10180.18,7.96,638.99,18.24,"","",15245.42,49.97,9513.72,14.55,14832.06,25.01}
,{199,86,-1499.451,37.588,7740.753,0.189,-8270.844,40.015,198.998390273,40.352,0,0.59,"",0.03,"",1.5,-1,"","",{"A","B+"},{"",6,0},{"","="},{"",6,0},19152.44,40.93,2719.4,62.3,7131.89,4.09,"","",6684.93,41.43,-19144.79,49.51,8340.41,39.91,2073.91,38.04,"","",15566.61,38.43,7279.28,48.27,17619.99,39.94}
,{199,87,6771.393,13.726,7695.259,0.069,"","",199.007269389,14.734,0,0.0066,"",0.0022,"",0.5,1,"","",{"A"},{0},{"~"},{0},19625.21,56.11,1451.3,15.88,7816.77,9.84,"","",6196.93,14.93,"","",10873.95,35.02,-712.78,19.2,"","",15971.85,21.23,9664.46,19.91,16332.47,33.25}
,{200,76,-18779,298,7868,1,2832,357,199.97984,320,0,7,"",4,"",0,1,"","",{"B-"},{0},{"="},{0},11085,357,"","",-2323,499,7820,299,"","",-2452,301,6367,357,11208,499,10724,298,9071,499,6587,422,2007,499}
,{200,77,-21611,196,7878,1,4988,197,199.9768,210,0,43,"",6,"",2,-1,"","",{"B-"},{0},{"="},{0},11932,277,19049,446,-1493,357,5629,197,-14040,446,-2293,196,5283,200,8416,277,5437,196,12937,277,8562,277,4538,357}
,{200,78,-26599.16,20.11,7899.198,0.101,640.932,33.439,199.971444625,21.588,0,45360,"",1080,"",0,1,"","",{"B-"},{0},{"="},{0},12837.79,20,17340,197,-746.97,44.72,2904.11,20.11,-13405,197,-5576.74,20.11,7281.79,20.01,9489.62,45.62,-348.11,22.89,9933,197,6529,28.28,4356,197}
,{200,79,-27240.092,26.717,7898.491,0.134,2263.178,26.719,199.970756556,28.681,0,2904,"",18,"",0,0,"","",{"B-"},{0},{"="},{0},13801.95,26.72,15997,197,-229.51,46.79,-192.86,27.33,-10130.55,48.98,-5765.34,26.72,6217.67,26.72,7140.38,26.8,-6869.34,34.81,13374.71,26.8,8043.71,26.72,6670.41,33.44}
,{200,80,-29503.27,0.529,7905.895,0.003,-2456.04,5.735,199.968326934,0.568,1,"s","","s","",0,1,"","",{},{},{},{},14691.59,0.59,14177.21,2.13,716.32,0.67,-3252.22,10.93,-9403.56,2.19,-9515.19,27.95,8028.52,0.11,7698.5,0.62,-12561.51,7.58,10788.32,0.62,6500.52,0.62,6562.88,0.67}
,{200,81,-27047.23,5.759,7889.703,0.029,-796.176,12.34,199.970963602,6.182,0,93960,"",360,"",2,-1,"","",{"B+"},{0},{"="},{0},15661.12,9.49,12044.39,5.77,1666.56,6.46,-6676.48,23.05,-5242.46,5.77,-9886.74,11.54,7059.15,28.53,4790.13,5.74,-18059.34,25.13,14617.89,5.76,8357.05,6.57,9738.91,5.77}
,{200,82,-26251.054,10.927,7881.81,0.055,-5880.299,24.852,199.971818332,11.73,0,77400,"",1440,"",0,1,"","",{"EC"},{0},{"="},{0},16326.2,13.94,9874.69,10.93,3149.97,11.31,-9309.29,13.2,-3993.96,10.93,-13524.81,15.18,9090.57,14.81,5480.63,30.01,-22246.29,17.47,11988.5,13.28,6954.65,19.63,9935.58,11.38}
,{200,83,-20370.755,22.321,7848.497,0.112,-3428.994,23.573,199.978131093,23.962,0,2184,"",30,"",7,1,"","",{"B+"},{0},{"="},{0},17143.9,35.77,7419.95,23.56,4700.92,25.39,-11382.86,33.12,399.67,35.77,-13233.59,28.71,7644.51,24.7,2427.92,24.46,-26503.25,37.88,16407.54,23.97,9238.7,22.83,13617.3,27.65}
,{200,84,-16941.761,7.579,7827.44,0.038,-7953.869,25.612,199.98181227,8.135,0,690.6,"",4.8,"",0,1,"","",{"B+","A"},{0,11.1,0},{"=","="},{0,11.1,0},17611.04,18.94,5452.21,11.51,5981.64,1.85,-12937,15.59,1001.07,12.54,-16189.71,9.3,9804.6,19.56,3433.17,12.98,"","",13138.53,28.95,7609.49,11.26,13450.04,8.94}
,{200,85,-8987.892,24.465,7783.759,0.122,-4983.127,28.03,199.9903511,26.264,0,43.2,"",0.9,"",3,1,"","",{"A","B+"},{0,48,0},{"=","="},{0,48,0},18416.01,25.16,4196.35,37.14,6596.22,1.34,-15120.39,39.19,4520.7,26.65,-15559.76,44.85,8235.84,25.05,1068.38,30.41,"","",17196.27,30.04,9234.15,55.38,16345.7,25.85}
,{200,86,-4004.765,13.681,7754.932,0.068,-10137.263,33.529,199.995700707,14.686,0,1.09,"",0.16,"",0,1,"","",{"A"},{0},{"="},{0},18917.04,19.14,3109.35,22.12,7043.36,2.14,"","",3914.75,22.64,-18847.47,19.38,10576.63,40,2470.36,14.7,"","",13420.55,14.89,7214.54,15.84,14999.63,51.53}
,{200,87,6132.498,30.611,7700.334,0.153,"","",200.006583507,32.861,0,0.0475,"",0.0028,"",3,1,"","",{"A","B-","B-SF"},{0,"","",1.4,0},{"=","",">"},{0,"","",1.4,0},19584.16,44.44,1730.93,31.17,7622.26,4.46,"","",7666.9,31.08,"","",8710.21,33.55,-342.98,48.48,"","",18073.66,33.42,9486.2,34.63,18134.15,31.63}
,{201,76,-15239,298,7851,1,4657,357,200.98364,320,0,1,"",3e-07,">",0.5,-1,"","",{},{},{},{},10898,357,"","",-2525,499,8501,302,"","",-1700,357,4532,422,"","",12423,298,10332,499,6764,499,"",""}
,{201,77,-19897,196,7871,1,3844,202,200.97864,210,0,21,"",5,"",1.5,1,"","",{"B-"},{0},{"="},{0},11641,200,19615,446,-1819,357,6504,196,"","",-1369,197,6357,277,8407,357,7284,196,11298,277,8804,277,2889,446}
,{201,78,-23740.714,50.103,7885.833,0.249,2660,50,200.974513293,53.788,0,150,"",6,"",2.5,-1,"","",{"B-"},{0},{"="},{0},12494.67,50.15,17835,202,-857,202,3921.83,50.1,-12251,302,-4571.94,56.78,5212.87,53.99,9419,202,1530.32,51.95,11368.61,64.77,6944,202,5743,202}
,{201,79,-26400.714,3.218,7895.175,0.016,1261.827,3.147,200.971657665,3.454,0,1560,"",48,"",1.5,1,"","",{"B-"},{0},{"="},{0},13449.61,3.24,16580.14,41.18,-561.52,20.36,780.12,14.52,-12079,196,-4968.76,3.2,7231.94,26.91,7090.52,20.36,-4984.28,15.52,11698.77,3.86,8367.34,3.83,5067,196}
,{201,80,-27662.542,0.711,7897.56,0.004,-481.704,14.181,200.970303038,0.763,1,"s","","s","",1.5,-1,"","",{},{},{},{},14259.11,0.59,14851.8,2.25,332.29,0.84,-2391.51,13.76,-8352.35,20.12,-8686.63,5.77,6230.59,0.59,7711.42,26.72,-11141.36,4.97,12142.01,0.8,6782.29,0.8,7887.86,2.19}
,{201,81,-27180.838,14.185,7891.271,0.071,-1909.802,18.53,200.970820168,15.228,0,263018.88,"",164.16,"",0.5,1,"","",{"EC"},{0},{"="},{0},15264.08,31.34,12665.04,14.19,1533.98,14.19,-5764.4,20.77,-7229.72,30.25,-9001.1,17.84,8204.93,15.3,4966.54,14.19,-16391.4,16.38,13076.04,14.19,8637.53,14.19,8046.34,14.19}
,{201,82,-25271.036,13.747,7877.877,0.068,-3854.603,20.481,200.972870425,14.758,0,33588,"",108,"",2.5,-1,"","",{"B+"},{0},{"="},{0},16181.87,17,10302.91,13.76,2844.28,14.12,-8749.85,14.61,-3056.74,13.76,-12971.6,26.22,7091.3,17.55,5512.78,14.9,-21198.71,51.6,13499.16,31.14,7121.77,15.68,11329.68,13.75}
,{201,83,-21416.433,15.183,7854.808,0.076,-4895.248,15.962,200.977008512,16.299,0,6180,"",180,"",4.5,-1,"","",{"B+"},{0},{"="},{0},16761.5,18.5,7934.98,31.8,4500.3,6,-10627,17.25,-1658.17,16.24,-12545.99,16.95,9117,27,2454.35,18.69,-25005.01,17.69,14526.18,18.18,9515.11,17.51,11758.71,16.95}
,{201,84,-16521.185,4.942,7826.561,0.025,-5731.747,9.561,200.982263777,5.305,0,936,"",6,"",1.5,-1,"","",{"B+","A"},{0,1.13,0},{"=","="},{0,1.13,0},17455.34,18.72,5867.32,11.15,5799.3,1.7,-12448.86,49.98,2440.9,11.96,-15604.61,24.96,7650.74,9.01,3439.4,22.86,-28457.99,20.89,14987.19,11.66,7712.36,28.38,15192.71,10.03}
,{201,85,-10789.438,8.184,7794.153,0.041,-6717.113,50.401,200.988417061,8.786,0,85.2,"",1.6,"",4.5,-1,"","",{"A","B+"},{0,29,0},{"=","="},{0,29,0},18108.7,9.8,4569.81,13.37,6472.84,1.57,-14378.01,12.22,2292.35,23.77,-14855.99,15.94,9872.86,25.8,1136.65,11.15,"","",15129.85,19.83,9547.97,19.25,14226.45,29.12}
,{201,86,-4072.324,49.732,7756.842,0.247,-7660.902,50.554,200.995628179,53.389,0,7,"",0.4,"",1.5,-1,"","",{"A","B+"},{"",49,0},{"","="},{"",49,0},18715.51,62.34,3441.78,52.91,6860.75,2.28,-16009.13,53.72,5580.47,50.31,-18276.14,58.4,8138.88,51.58,2373.4,55.42,"","",15461.85,50.02,7506.24,50.08,17047.43,52.7}
,{201,87,3588.577,9.08,7714.836,0.045,-8348.224,22.239,201.003852496,9.747,0,0.0628,"",0.0019,"",4.5,-1,"","",{"A"},{0},{"="},{0},19325.45,16.46,2165.99,10.56,7518.91,4.33,"","",5287.5,26.1,"","",10615.24,31.93,-304.37,16.42,"","",15798.83,38.67,9682.99,16.2,15949.49,10.81}
,{201,88,11936.801,20.301,7669.41,0.101,"","",201.012814683,21.794,0,0.02,"",0.03,"",1.5,-1,"","",{"A"},{0},{"="},{0},"","",1141.69,42.72,8001.53,12.24,"","",8652.6,24.47,"","","","",1484.67,36.73,"","",15876.21,24.51,7226.83,38.08,18813.56,24.33}
,{202,76,-13087,401,7842,2,3689,499,201.98595,430,0,0.2,"",3e-07,">",0,1,"","",{},{},{},{},10451,499,"","","","",9605,401,"","",-1262,446,5920,499,"","",14258,401,"","",6637,566,"",""}
,{202,77,-16776,298,7856,1,5916,299,201.98199,320,0,11,"",3,"",2,-1,"","",{"B-"},{0},{"="},{0},11308,357,"","",-2062,499,7577,299,"","",-1107,302,4951,357,8826,422,9204,298,12714,422,8571,357,3730,499}
,{202,78,-22692.125,25.15,7881.56,0.125,1660.854,34.276,201.975639,27,0,158400,"",54000,"",0,1,"","",{"B-"},{0},{"="},{0},12235.6,32.2,18491,299,-1280,197,4653.2,25.16,-14742,299,-4362.73,25.36,7022.73,56.06,10084,197,3248.49,25.44,9629,197,6570.44,48.15,3438,197}
,{202,79,-24352.979,23.287,7885.909,0.115,2992.345,23.298,201.973856,25,0,28.4,"",1.2,"",1,-1,"","",{"B-"},{0},{"="},{0},13255.52,35.44,17320,197,-957,197,1627.24,23.34,-11745,197,-4761.75,23.3,6023.58,23.51,7901.24,55.25,-3611.5,27.92,12956.99,30.77,7899.76,23.39,5691.94,47.2}
,{202,80,-27345.324,0.705,7896.85,0.003,-1365.108,1.636,201.970643585,0.756,1,"s","","s","",0,1,"","",{},{},{},{},13984.69,0.59,15324.1,20.12,133.76,2.19,-1404.71,3.85,-10893.58,50.1,-8235.8,14.18,7754.1,0.2,8233.58,3.14,-9403.71,8.67,10605.57,26.72,6612.47,0.8,5689.76,2.24}
,{202,81,-25980.216,1.606,7886.219,0.008,-39.602,4.096,201.972109089,1.723,0,1063584,"",6912,"",2,-1,"","",{"EC"},{0},{"="},{0},15075.62,5.96,13318.06,26.76,1175.65,1.67,-5238.73,15.48,-6868.47,3.54,-8780.5,13.83,6870.7,14.23,5606.64,1.64,-15389.48,28.02,14233.86,1.64,8429.91,1.64,8759.93,1.67}
,{202,82,-25940.614,3.796,7882.15,0.019,-5199.13,15.856,201.972151604,4.075,0,1656738615000,"",88359392800,"",0,1,"","",{"EC"},{0},{"="},{0},15832.19,11.55,11015.28,3.83,2588.78,3.82,-7999,9.45,-5567.04,3.85,-12595.5,15.65,8740.89,14.26,6048.75,14.67,-19665.98,17.92,11817.42,6.89,6982.84,28.2,9251.86,3.83}
,{202,83,-20741.484,15.396,7852.539,0.076,-2799.868,17.666,201.9777331,16.528,0,6192,"",180,"",0,0,"","",{"B+","A"},{0,1,0},{"=","<"},{0,1,0},16513.36,27.12,8272.2,16.44,4362.35,17.15,-10150.75,31.93,-849.62,20.93,-12291.62,16.17,7396.37,21.56,2759.42,20.64,-23837.72,16.93,16220.38,18.87,9354.38,18.36,12964.31,31.91}
,{202,84,-17941.616,8.67,7834.805,0.043,-7350.884,29.289,201.980738881,9.307,0,2676,"",24,"",0,1,"","",{"B+","A"},{"",1.92,0},{"","="},{"",1.92,0},17142.49,11.45,6268.5,13.89,5700.96,1.69,-11666.98,19.51,40.45,16.25,-15223.5,11.92,9491.75,9.96,3814.15,17.47,-27016.48,17.32,13139.95,23.95,7720,13.66,12936.59,13.23}
,{202,85,-10590.732,27.977,7794.541,0.138,-4316.097,33.01,201.98863038,30.034,0,184,"",1,"",0,0,"","",{"B+","A"},{"",12,0},{"","="},{"",12,0},17745.47,37.16,4797.92,35.79,6353.84,1.34,-13686.97,28.85,3536.73,31.83,-14589.72,57.06,7872.61,29.15,1358.52,28.41,"","",17061.84,28.99,9481.81,33.3,15853.24,29.91}
,{202,86,-6274.635,17.52,7769.301,0.087,-9370.871,18.881,201.993263902,18.808,0,9.7,"",0.1,"",0,1,"","",{"A"},{0},{"="},{0},18412.5,22.2,3910.81,19.03,6773.8,1.83,-15349.5,23.05,2957.58,18.18,-17934.53,19.73,10273.63,52.73,2774.17,19.34,"","",13424.06,30.09,7412.79,18.33,14580.25,25.14}
,{202,87,3096.237,7.04,7719.038,0.035,-5978.625,16.586,202.003323946,7.557,0,0.372,"",0.012,"",3,1,"","",{"A","B+"},{"",14,0},{"","="},{"",14,0},19178.9,31.41,2493.81,25.46,7385.83,3.89,"","",6596.7,10.8,-16911.88,21.49,8563.66,11.49,120.41,50.23,"","",17811.81,15.39,9459.74,38.24,17566.01,8.86}
,{202,88,9074.861,15.018,7685.568,0.074,"","",202.009742264,16.122,0,0.0041,"",0.0011,"",0,1,"","",{"A"},{0},{"="},{0},"","",1498.32,20.3,7880.3,6.74,"","",5858.21,51.95,"","",10933.26,25.25,1802.69,17.55,"","",13653.17,34.1,7167.52,20.34,16220.71,40.48}
,{203,76,-7640,401,7816,2,7050,566,202.991798,430,0,0.1,"",3e-07,">",4.5,1,"","",{"B-n"},{0},{"="},{0},8544,499,"","","","",11986,446,"","",1065,499,2624,566,"","",17629,401,"","","","","",""}
,{203,77,-14690,401,7847,2,4937,446,202.98423,430,0,6,"",3e-07,">",1.5,1,"","",{},{},{},{},10936,446,"","",-2254,566,8454,401,"","",-69,401,5985,499,8891,566,11072,401,11260,499,8953,499,"",""}
,{203,78,-19627,196,7867,1,3517,196,202.97893,210,0,22,"",4,"",0.5,-1,"","",{"B-"},{0},{"="},{0},12028,202,18965,357,-1568,277,5643,196,-13828,446,-3345,197,5006,197,10139,357,5160,196,10981,277,6848,277,4799,357}
,{203,79,-23143.436,3.083,7880.864,0.015,2125.829,3.451,202.975154498,3.309,0,60,"",6,"",1.5,1,"","",{"B-"},{0},{"="},{0},12885.36,4.38,17825,196,-1169.84,41.17,2617.94,3.26,-13656,298,-3869.43,3.13,6861.77,23.49,7740.28,25.34,-1618.61,13.14,11308.08,50.19,8319.78,20.34,4114,196}
,{203,80,-25269.265,1.627,7887.482,0.008,492.112,1.225,202.972872326,1.746,0,4027363.2,"",1555.2,"",2.5,-1,"","",{"B-"},{0},{"="},{0},13749.36,1.58,16106.49,50.12,-305.5,2.69,-482.71,6.57,-9866.11,25.2,-7360.37,1.95,5995.26,1.57,8205.26,23.34,-7958.38,8.81,11842.26,3.5,6834.88,26.76,6976.3,20.17}
,{203,81,-25761.377,1.166,7886.053,0.006,-974.82,6.461,202.972344022,1.252,1,"s","","s","",0.5,1,"","",{},{},{},{},14723.17,14.15,13938.6,3.31,907.45,1.24,-4236.55,12.83,-8697.37,23.32,-7892.08,3.92,7852.48,1.55,5705.02,1.08,-13598.82,10.62,12611.97,1.09,8605.95,1.16,7125.12,26.74}
,{203,82,-24786.557,6.554,7877.397,0.032,-3261.729,14.356,202.973390535,7.036,0,186897.6,"",54,"",2.5,-1,"","",{"EC"},{0},{"="},{0},15658.16,15.22,11701.96,6.54,2334.6,6.55,-7475.67,10.86,-4730.2,6.54,-12116.39,16.73,6917.26,7.55,6095.31,6.64,-18632.86,19.3,13105.09,15.55,7124.73,8.71,10363.11,6.55}
,{203,83,-21524.827,12.778,7857.475,0.063,-4213.939,15.433,202.976892145,13.717,0,42336,"",180,"",4.5,-1,"","",{"B+"},{0},{"="},{0},16251.03,19.8,8921.93,19.09,4109.65,30.73,-9362.27,16.59,-2833.58,12.88,-11654.53,15.44,8854.66,19.99,2873.18,13.33,-22401.24,14.22,14457.01,18.77,9590.28,16.81,11168.8,14.02}
,{203,84,-17310.889,8.655,7832.863,0.043,-5148.332,13.666,202.981415995,9.291,0,2202,"",30,"",2.5,-1,"","",{"B+","A"},{0,0.11,0},{"~","="},{0,0.11,0},16932.34,9.97,6617.79,16.24,5496,5,-11157.19,20.13,1340.75,9.45,-14791.47,29.29,7440.59,12.25,3858.38,17.66,-25972.61,39.09,14816.35,17.48,7923.92,23.94,14586.57,13.94}
,{203,85,-12162.557,10.576,7803.648,0.052,-6008.858,21.027,202.986942957,11.353,0,444,"",12,"",4.5,-1,"","",{"B+","A"},{0,31,0},{"=","="},{0,31,0},17515.75,13.37,5324.06,18.5,6210.09,0.84,-13038.97,12.28,1289.96,18.68,-13959.24,20.45,9643.14,29.91,1509.91,13.66,"","",15069.43,11.67,9643.26,12.99,13854.6,24.7}
,{203,86,-6153.699,18.179,7770.193,0.09,-7030.116,19.218,202.993393732,19.516,0,44,"",2,"",1.5,-1,"","",{"A"},{0},{"="},{0},18224.01,52.95,4210.46,18.83,6629.87,2.08,-14815.42,42.24,4498.95,20.12,-17321.25,19.49,7950.38,25.23,2851.94,33.36,"","",15346.54,19.94,7698.25,30.48,16434.46,19.67}
,{203,87,876.417,6.232,7731.708,0.031,-7785.309,38.63,203.000940872,6.689,0,0.55,"",0.01,"",4.5,-1,"","",{"A","B+"},{0,5,0},{"~","="},{0,5,0},18854.79,11.01,2912.09,10.29,7274.87,3.57,"","",4178.18,28.66,-16269.76,16.26,10291.14,9.4,137.92,18.6,"","",15659.55,50.12,9745.24,15.03,15510.71,25.25}
,{203,88,8661.726,38.124,7689.503,0.188,"","",203.009298745,40.928,0,0.036,"",0.013,"",1.5,-1,"","",{"A"},{0},{"~"},{0},19417.71,43.19,1843.89,62.66,7736.26,6.37,"","",7647.39,41.96,"","",8484.45,40.98,1723.48,38.77,"","",15783.95,39.19,7393.28,48.89,18312.89,40.5}
,{204,77,-9688,401,7824,2,8234,446,203.9896,430,0,1,"",3e-07,">",0,0,"","",{"B-n"},{""},{""},{""},9054,499,"","","","",10963,448,"","",1868,446,3069,566,9336,566,14659,401,14111,566,10416,499,"",""}
,{204,78,-17922,196,7860,1,2728,280,203.98076,210,0,10.3,"",1.4,"",0,1,"","",{"B-"},{0},{"="},{0},11372,197,19412,446,-1568,357,6768,196,-17571,446,-2850,196,6367,277,10521,446,7188,196,9565,357,6839,277,2964,357}
,{204,79,-20650,200,7870,1,4040,200,203.977831,215,0,38.3,"",1.3,"",2,-1,"","",{"B-"},{0},{"="},{0},12440,201,18452,359,-1464,280,3696,200,-13249,448,-3452,200,5578,200,8313,280,-4,200,12753,202,7955,206,4893,280}
,{204,80,-24690.145,0.498,7885.545,0.002,-344,1.186,203.973494037,0.534,1,"s","","s","",0,1,"","",{},{},{},{},13487.46,0.73,16575.96,25.16,-515.9,20.12,419.75,1.18,-12353,196,-7000.09,1.2,7492.2,1.65,8835.68,3.04,-6348.9,11.02,10373.64,23.29,6574.62,3.22,4696.97,50.1}
,{204,81,-24346.145,1.152,7880.023,0.006,763.748,0.177,203.973863337,1.236,0,119379851.058,"",378683.112,"",2,-1,"","",{"B-","EC+B+"},{0,2.92,0},{"=","="},{0,2.92,0},14508.56,1.56,14571.11,23.32,469.03,26.74,-3700.25,9.25,-8491.68,3.26,-7630.9,6.46,6656.08,0.29,6365.85,1.25,-12470.71,22.32,13709.99,1.06,8180.45,1.07,7700.97,3.31}
,{204,82,-25109.892,1.146,7879.932,0.006,-4463.996,9.248,203.97304342,1.23,1,"s","","s","",0,1,"","",{},{},{},{},15311.91,3.92,12342.51,1.05,1968.46,1.14,-6768.65,10.95,-7129.6,1.26,-11656.38,12.82,8394.65,6.46,6637.49,0.34,-17139.7,7.36,11581.13,1.57,6935,14.15,8199.05,1.06}
,{204,83,-20645.896,9.18,7854.215,0.045,-2304.652,14.335,203.977835717,9.854,0,40392,"",360,"",6,1,"","",{"B+"},{0},{"="},{0},16047.05,17.92,9243.62,9.32,3976.42,10.84,-8770.46,24.1,-2173.49,9.25,-11406.32,12.62,7192.39,15.73,3148.31,11.28,-21253.21,26.24,16005.52,9.93,9489.2,16.53,12181.34,16.89}
,{204,84,-18341.244,11.013,7839.083,0.054,-6465.811,24.86,203.980309863,11.822,0,12668.4,"",43.2,"",0,1,"","",{"B+","A"},{0,0.67,0},{"=","="},{0,0.67,0},16542.26,13.96,6978.57,11.63,5484.89,1.37,-10371.05,13.2,-843.66,12.71,-14250,15.25,9101.67,14.01,4105.39,16.86,-24398.03,18.79,13111.05,18.92,7939.24,18.74,12576.19,17.61}
,{204,85,-11875.433,22.288,7803.552,0.109,-3905.24,23.498,203.987251197,23.926,0,547.2,"",6.6,"",7,1,"","",{"B+","A"},{0,3.8,0},{"=","="},{0,3.8,0},17427.34,35.77,5711.89,27.09,6070.41,1.22,-12482.74,33.18,2360.42,25.69,-13793.05,28.76,7784.19,24.67,1853.51,23.91,"","",16776.99,23.91,9509.81,22.83,15187.4,26.97}
,{204,86,-7970.193,7.444,7780.574,0.036,-8577.503,25.684,203.991443644,7.991,0,74.52,"",1.38,"",0,1,"","",{"A"},{0},{"="},{0},17838.19,18.97,4606.52,11.36,6546.65,1.82,-14026.98,16.95,2051.72,11.42,-16917.93,9.71,9887.81,19.62,3096.61,12.91,"","",13331.34,28.95,7683.3,11.06,14197.39,8.89}
,{204,87,607.31,24.581,7734.692,0.12,-5449.477,28.94,204.000651974,26.389,0,1.75,"",0.26,"",3,1,"","",{"A"},{0},{"="},{0},18631.56,25.57,3379.9,37.24,7170.29,2.39,"","",5480.9,26.76,-16125.73,45.36,8340.42,25.36,527.96,30.57,"","",17592.75,30.19,9543.69,55.48,17043.15,25.91}
,{204,88,6056.787,15.273,7704.144,0.075,"","",204.006502228,16.396,0,0.06,"",0.009,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},19160.71,21.4,2246.52,23.21,7636.64,6.79,"","",4921.51,23.73,"","",10676.26,41.07,2108.6,16.5,"","",13671.36,16.82,7332.26,17.77,15775.51,52.02}
,{205,77,-5960,503,7807,2,7007,585,204.993602,540,0,0.3,"",3e-07,">",1.5,1,"","",{"B-n"},{0},{"="},{0},7413,643,"","","","",12810,540,"","",3891,540,4343,643,"","",17861,503,12391,643,11992,643,"",""}
,{205,78,-12966,298,7837,1,5803,357,204.98608,320,0,5,"",3e-07,">",4.5,1,"","",{},{},{},{},9482,357,19904,499,-152,422,9321,298,"","",-388,359,3116,357,10568,499,10804,298,12434,499,8674,422,5767,499}
,{205,79,-18770,196,7861,1,3518,196,204.97985,210,0,32.5,"",1.4,"",1.5,1,"","",{"B-"},{0},{"="},{0},11769,196,18658,446,-1298,277,5051,196,-16371,446,-2151,196,6191,280,8137,277,2295,196,11568,277,8787,197,3653,357}
,{205,80,-22287.74,3.654,7874.732,0.018,1533.135,3.724,204.976073125,3.923,0,308.4,"",5.4,"",0.5,-1,"","",{"B-"},{0},{"="},{0},13161.11,3.67,17239,196,-971.94,50.24,1482.5,3.7,-11655,196,-6012.91,3.7,5668.91,3.62,8927,200,-4766.34,10.7,11566.5,4.73,6929.29,23.57,6050.79,25.41}
,{205,81,-23820.874,1.237,7878.394,0.006,-50.636,0.503,204.974427237,1.328,1,"s","","s","",0.5,1,"","",{},{},{},{},14202.13,0.54,15255.38,3.22,154.92,3.27,-2756.37,5.13,-10460,200,-6782.3,0.5,7546.05,0.48,6419.7,1.27,-10848.93,15.12,12159.2,1.33,8388.5,1.15,6178.51,23.32}
,{205,82,-23770.239,1.144,7874.331,0.006,-2705.734,5.107,204.974481597,1.228,0,5.459348198e+14,"",22089848200000,"",2.5,-1,"","",{"EC"},{0},{"="},{0},15126.32,6.46,13078.92,1.27,1467.39,1.06,-6248.84,10.12,-6369.06,1.18,-11195.66,9.25,6731.66,0.11,6713.06,0.21,-16060.45,5.13,12701.94,0.35,7074.03,1.57,9221.49,1.05}
,{205,83,-21064.504,5.111,7857.316,0.025,-3543.106,11.28,204.977386323,5.487,0,1322784,"",3456,"",4.5,-1,"","",{"B+"},{0},{"="},{0},15682.31,13.76,9881.07,5.12,3691.42,15.04,-8092.56,15.92,-4007.33,5.11,-10794.58,12.09,8489.93,10.51,3243.58,5.11,-19754.69,9.35,14432.86,8.23,9740.16,6.35,10562.11,5.29}
,{205,84,-17521.398,10.059,7836.216,0.049,-4549.452,18.13,204.981190004,10.798,0,6264,"",288,"",2.5,-1,"","",{"B+","A"},{0,0.04,0},{"~","="},{0,0.04,0},16353.14,13.27,7312.78,12,5324.72,9.94,-9811.61,11.27,299.52,10.12,-13717.28,24.45,7251.47,14.91,4164.47,13.62,-23360.39,71.23,14714.24,16.26,8084.14,18.39,14065.62,10.75}
,{205,85,-12971.946,15.085,7810.207,0.074,-5262.161,15.913,204.986074041,16.194,0,2028,"",12,"",4.5,-1,"","",{"A"},{0},{"="},{0},16952.02,18.42,6025.06,19.73,6019.57,1.72,-11662.13,16.99,384.98,17.64,-13073.07,16.81,9167.83,26.91,1919.67,18.66,-27078.64,53.01,15049.75,17.39,9833.72,17.39,13415.94,21.49}
,{205,86,-7709.786,5.08,7780.722,0.025,-6399.973,9.329,204.991723204,5.453,0,169.8,"",4.2,"",2.5,-1,"","",{"A"},{0},{"="},{0},17698.72,18.87,4976.84,10.04,6386.48,1.84,-13548.78,70.7,3342.49,12.09,-16388.41,25.1,7810.91,8.97,3123.32,22.86,"","",15163.58,11.73,7745,28.43,15878.23,10.02}
,{205,87,-1309.813,7.824,7745.686,0.038,-7148.804,70.954,204.998593858,8.399,0,3.82,"",0.06,"",4.5,-1,"","",{"A","B+"},{0,1,0},{"~","<"},{0,1,0},18328.86,10,3725.2,13.16,7054.71,2.4,-15416.51,51.42,3276.65,23.62,-15437.92,17.16,9988.44,25.8,628.59,10.8,"","",15554.69,19.79,9828.88,19.19,14927.32,29.05}
,{205,88,5838.991,70.521,7706.998,0.344,-8267.702,86.923,205.006268415,75.707,0,0.22,"",0.05,"",1.5,-1,"","",{"A"},{""},{""},{""},18965.37,80.17,2585.25,72.83,7486.4,50,"","",6520.21,70.91,"","",8289.11,72.16,2057.29,74.68,"","",15673.38,70.8,7606.81,70.87,17760.03,72.66}
,{205,89,14106.693,50.818,7662.851,0.248,"","",205.015144158,54.555,0,0.08,"",0.06,"",4.5,-1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},"","",1347.67,51.2,8093.2,50,"","",6210.41,56.45,"","","","",-760.94,53.06,"","",16155.77,63.53,9895.89,52.99,16656.86,51.3}
,{206,78,-9632,298,7822,1,4583,422,205.98966,320,0,5,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},7852,357,"","",1031,499,11314,299,"","",1067,357,4737,422,10961,585,14154,298,10767,499,9922,499,3655,499}
,{206,79,-14215,298,7840,1,6731,299,205.98474,320,0,47,"",11,"",5,1,"","",{"B-"},{0},{"="},{0},9707,359,19105,499,137,422,8039,298,-15544,585,2,298,3516,357,8537,422,5814,298,14418,357,10276,357,6121,499}
,{206,80,-20945.801,20.44,7869.172,0.099,1307.566,20.41,205.977513756,21.943,0,499.2,"",4.2,"",0,1,"","",{"B-"},{0},{"="},{0},12398.29,20.44,17602,197,-678.59,32.41,2839.78,20.41,-15268,299,-5196.24,20.41,6729.38,20.74,9465,197,-2757.13,20.82,10415,201,7061.69,20.66,4327,197}
,{206,81,-22253.367,1.284,7871.721,0.006,1532.217,0.612,205.976110026,1.378,0,252.12,"",0.66,"",0,-1,"","",{"B-"},{0},{"="},{0},14049.86,0.59,16181,200,-325.3,23.32,-2225.09,7.57,-10773,196,-6554.45,0.61,6503.81,0.39,7254.6,3.74,-9823.65,15.1,13147.58,1.32,7879.95,1.38,6536.47,3.25}
,{206,82,-23785.584,1.144,7875.362,0.006,-3757.306,7.546,205.974465124,1.227,1,"s","","s","",0,1,"","",{},{},{},{},14818.33,0.12,13673.38,1.18,1134.82,1.05,-5596.91,4.13,-8786.81,3.7,-10792.4,5.11,8086.66,0.06,7253.68,0.5,-14652.62,8.58,11271.37,0.21,6839.85,0.36,7130.08,1.27}
,{206,83,-20028.278,7.632,7853.324,0.037,-1839.604,8.6,205.978498757,8.193,0,539395.2,"",259.2,"",0,0,"","",{"B+"},{0},{"="},{0},15525.02,11.94,10260.07,7.55,3527.02,7.71,-7598.56,16.87,-3496.37,7.56,-10578.2,12.62,7035.09,9.11,3547.01,7.55,-18785.86,29.21,15792.42,7.55,9622.33,9.93,11379.5,7.55}
,{206,84,-18188.674,4.012,7840.597,0.019,-5758.956,15.58,205.980473654,4.306,0,760320,"",8640,"",0,1,"","",{"B+","A"},{0,5.45,0},{"=","="},{0,5.45,0},15990.06,11.7,7656.72,4.13,5327.02,1.3,-9055.71,9.47,-1707.41,4.13,-13288.04,15.61,8738.59,10.83,4413.14,6.48,-21754.21,18.44,13168.03,10.02,8200.21,13.39,12244.28,7.66}
,{206,85,-12429.718,15.056,7808.843,0.073,-3296.753,17.33,205.986656148,16.162,0,1836,"",48,"",0,0,"","",{"B+","A"},{0,0.9,0},{"=","="},{0,0.9,0},16696.92,26.9,6361.76,17.62,5886.85,4.94,-11187.3,31.96,1345.82,15.9,-12791.25,15.89,7529.09,21.25,2197.29,18.11,-25909.17,52.69,16622.33,18.65,9745.23,17.37,14741.51,19.73}
,{206,86,-9132.965,8.591,7789.041,0.042,-7890.549,29.475,205.990195358,9.223,0,340.2,"",10.2,"",0,1,"","",{"A","B+"},{0,38,0},{"=","="},{0,38,0},17305.41,11.3,5369.66,13.91,6383.74,1.64,-12698.5,19.91,1099.46,13.23,-15894.47,11.62,9494.5,9.96,3449.99,17.35,"","",13453.27,23.89,7893.65,13.61,13824.33,12.2}
,{206,87,-1242.416,28.195,7746.94,0.137,-4807.955,33.455,205.998666211,30.268,0,16,"","s","",3,1,"","",{"B+","A"},{"",88.4,0},{"","="},{"",88.4,0},17992.36,37.41,3944.92,35.94,6923.4,3.5,-14721.87,57.83,4440.56,31.98,-15152.72,75.95,8003.92,29.26,821.6,28.65,"","",17438.58,29.16,9775.34,33.55,16566.54,30.11}
,{206,88,3565.539,18.008,7719.802,0.087,-9913.913,53.608,206.003827763,19.332,0,0.24,"",0.02,"",0,1,"","",{"A","B+"},{"","",""},{"",""},{"","",""},18633.88,23.58,3042.21,19.42,7415.26,4.16,"","",3986.35,18.69,-18612.47,53.91,10344.77,72.78,2413.62,19.63,"","",13669.04,30.47,7553.18,19.06,15365.64,25.57}
,{206,89,13479.452,50.493,7667.879,0.245,"","",206.014470787,54.206,0,0.025,"",0.007,"",3,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},"","",1705.8,56.16,7958.3,50,"","",7500.29,51.1,"","",8698.56,71.64,-351.49,86.73,"","",18133.47,52.75,9681.78,63.27,18249.44,50.88}
,{207,78,-4540,401,7798,2,6270,500,206.995126,430,0,1,"",3e-07,">",4.5,1,"","",{"B-n"},{0},{"="},{0},7716,499,"","",675,566,11947,402,"","",1603,499,2980,499,"","",17912,401,12130,643,10011,566,"",""}
,{207,79,-10810,300,7825,1,5677,301,206.988395,322,0,10,"",3e-07,">",1.5,1,"","",{"B-n"},{""},{""},{""},8183,358,19428,586,1455,500,10224,300,"","",2064,301,4667,423,8467,423,9245,300,12867,423,11976,358,4524,500}
,{207,80,-16487.444,29.808,7848.61,0.144,4547.008,30.3,206.9823,32,0,174,"",12,"",4.5,1,"","",{"B-"},{0},{"="},{0},10342.34,30.03,18099,300,714,198,5964.6,29.83,-14145,300,-2305.39,29.84,3612.96,36.14,9562,300,658.33,30.54,12993,198,9027,202,7081,198}
,{207,81,-21034.451,5.439,7866.797,0.026,1417.595,5.402,206.977418586,5.839,0,286.2,"",1.2,"",0.5,1,"","",{"B-"},{0},{"="},{0},13356.21,5.42,16843,196,-315.93,6.24,-979.82,5.8,-14109,298,-5320.18,5.4,6852.4,5.43,7377.62,21.11,-7807.04,13.53,11964.09,6.5,8519.75,5.45,5262,200}
,{207,82,-22452.047,1.147,7869.866,0.006,-2397.42,2.118,206.975896735,1.23,1,"s","","s","",0.5,-1,"","",{},{},{},{},14824.44,0.11,14742.25,3.7,392.3,1.27,-5306.27,6.56,-8795.22,20.41,-10495.09,7.55,6737.78,0.1,7487.65,0.62,-13817.28,8.57,12079.63,0.51,6758.15,0.23,7884.5,1.18}
,{207,83,-20054.627,2.397,7854.505,0.012,-2908.852,6.614,206.978470471,2.573,0,984576091.2,"",946707.78,"",4.5,-1,"","",{"B+"},{0},{"="},{0},15132.76,5.53,10811.69,2.12,3281.83,2.13,-6827.21,12.63,-5090.23,2.12,-9937.27,4.63,8097.67,7.84,3558.01,2.12,-17210.29,17.67,14426.42,2.12,9919.32,2.12,9937.92,2.12}
,{207,84,-17145.775,6.659,7836.673,0.032,-3918.358,14.075,206.981593252,7.148,0,20880,"",72,"",2.5,-1,"","",{"B+","A"},{0,0.021,0},{"~","="},{0,0.021,0},15767.01,12.06,7953.48,6.56,5215.87,2.5,-8511.01,10.8,-649.16,6.56,-12787.37,16.46,7028.42,7.75,4406.47,10,-20690.26,53.61,14629.54,8.31,8364.18,11.34,13610.52,6.56}
,{207,85,-13227.416,12.406,7813.964,0.06,-4592.654,15.037,206.985799783,13.318,0,6516,"",108,"",4.5,-1,"","",{"A"},{0},{"~"},{0},16398.1,19.49,6740.85,13.42,5872.5,3.06,-10383.08,21.46,-488.11,14.56,-12165.77,15.09,8869.02,19.49,2327.71,13.04,-24373.65,51.89,15004.79,15.97,9977.88,16.58,13064.88,15.43}
,{207,86,-8634.762,8.497,7787.998,0.041,-5790.421,19.458,206.9907302,9.121,0,555,"",10.2,"",2.5,-1,"","",{"B+","A"},{0,21,0},{"=","="},{0,21,0},17067.61,9.9,5691.31,13.17,6251.21,1.65,-12179.25,53.88,2264.94,9.4,-15463.66,29.45,7573.11,12.08,3494.01,17.29,"","",15047.99,17.31,8104.73,23.85,15352.88,13.91}
,{207,87,-2844.341,17.505,7756.246,0.085,-6388.826,56.008,206.996946474,18.792,0,14.8,"",0.1,"",4.5,-1,"","",{"A"},{0},{"="},{0},17677.16,19.17,4450.34,23.11,6893.3,19.77,-13990.57,53.34,2296.41,23.09,-14481.2,25.11,9673.24,33.19,1000.35,19.5,"","",15576.25,18.23,9989.91,19.02,14677.49,28.34}
,{207,88,3544.485,53.202,7721.602,0.257,-7601.748,73.276,207.003805161,57.115,0,1.38,"",0.18,"",2.5,-1,"","",{"A"},{0},{"~"},{0},18437.14,88.34,3323.67,53.44,7273.27,50,"","",5388.48,53.89,-18006.28,73.35,8092.37,56.16,2502.07,60.21,"","",15565.1,53.77,7801.23,58.61,17161.08,53.71}
,{207,89,11146.233,50.387,7681.099,0.243,"","",207.011965973,54.092,0,0.031,"",0.008,"",4.5,-1,"","",{"A"},{0},{"~"},{0},19103.09,71.56,2121.9,50.99,7844.9,50,"","",5099.68,57.74,"","",10404.54,71.33,-291.72,53.51,"","",16018.05,86.67,9953.5,52.65,16185.32,56.06}
,{208,78,-990,400,7783,2,5111,499,207.998937,429,0,1,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},7501,499,"","","","",12275,401,"","",1748,500,4521,566,"","",20758,400,"","",9834,642,"",""}
,{208,79,-6101,298,7804,1,7164,300,207.99345,320,0,10,"",3e-07,">",0,0,"","",{"B-n"},{0},{"="},{0},8029,422,"","",1161,499,10649,298,"","",2315,300,3363,423,8850,499,12769,298,14241,422,11729,422,5505,585}
,{208,80,-13265.406,30.739,7834.191,0.148,3484.726,30.795,207.985759,33,0,2520,"",300,"",0,1,"","",{"B-"},{0},{"="},{0},8462.24,36.91,18212,300,2232,198,8483.19,30.76,-16014,402,-302.27,31.22,4849.28,42.82,9744,302,4204.19,30.79,11660,300,10368,198,5347,300}
,{208,81,-16750.132,1.854,7847.183,0.009,4998.466,1.669,207.982017992,1.99,0,183.18,"",0.24,"",5,1,"","",{"B-"},{0},{"="},{0},10639.4,1.78,17113,298,1475,200,2120.09,2.61,-13229,300,-2369.4,1.67,3787,5.6,7551.66,29.87,-4280.26,9.1,14906.47,20.48,10401.66,4.01,7666,196}
,{208,82,-21748.598,1.148,7867.453,0.006,-2878.375,2.013,207.976651918,1.231,1,"s","","s","",0,1,"","",{},{},{},{},14105.65,0.11,15380.74,20.41,516.63,1.18,-4279,1.31,-12550.12,29.83,-9765.29,2.12,7367.87,0.05,8003.12,5.4,-12093.01,11.08,11215.58,0.62,6936.33,0.52,6185.54,3.7}
,{208,83,-18870.223,2.304,7849.853,0.011,-1400.628,2.397,207.979741981,2.473,0,11612948768000,"",126227704000,"",5,1,"","",{"B+"},{0},{"="},{0},14984.58,7.81,11194.8,2.01,3051.01,2.01,-6400.35,9.21,-5124.74,5.76,-9795.77,6.83,6886.91,2.71,3707.15,2.01,-16204.3,12.06,15626.17,2.01,9764.07,2.01,10597.05,2.01}
,{208,84,-17469.596,1.737,7839.358,0.008,-4999.725,9.086,207.981245616,1.864,0,91451971.548,"",63113.852,"",0,1,"","",{"A","B+"},{0,0.004,0},{"~","="},{0,0.004,0},15423.56,4.33,8261.95,1.31,5215.38,1.3,-7814,11.16,-2306.52,1.31,-12313.5,12.52,8395.14,6.69,4703.94,2.49,-19197.45,9.05,13269.49,7.66,8458.96,5.27,11947.04,1.31}
,{208,85,-12469.871,8.921,7811.56,0.043,-2814.279,14.269,207.986613042,9.577,0,5868,"",108,"",6,1,"","",{"B+","A"},{0,0.55,0},{"=","="},{0,0.55,0},16182.79,17.49,7019.53,11.74,5751.11,2.16,-9803.95,14.82,295.79,9.23,-11906.43,12.32,7313.77,15.27,2613.07,11.13,-23223.11,56.43,16429.61,9.78,9915.58,13.44,14241.04,10.28}
,{208,86,-9655.591,11.138,7794.268,0.054,-6989.672,16.251,207.989634295,11.957,0,1461,"",8.4,"",0,1,"","",{"A","B+"},{0,38,0},{"=","="},{0,38,0},16665.26,14.01,6044.86,11.82,6260.74,1.67,-11383.45,14.25,201.21,12.88,-14882.57,20.75,9092.15,14.01,3717.15,16.67,-26339.32,35.94,13484.93,18.72,8180.41,18.74,13512.21,15}
,{208,87,-2665.919,11.834,7756.903,0.057,-4393.774,14.881,207.997138018,12.704,0,59.1,"",0.3,"",7,1,"","",{"A","B+"},{0,11,0},{"=","="},{0,11,0},17566.14,30.58,4814.14,19.15,6784.6,24.12,-13419.15,56.96,3272.53,17.15,-14281.72,54.5,7892.89,21.13,1320.13,14.57,"","",17177.85,14.62,9907.92,12.88,15952.43,19.17}
,{208,88,1727.856,9.023,7732.017,0.043,-9025.38,56.442,208.001854929,9.686,0,1.11,"",0.045,"",0,1,"","",{"A"},{0},{"="},{0},17980.32,20.08,3717.12,12.4,7273.13,5.1,-14955.87,35.34,3073.65,12.39,-17489.69,51.19,9887.95,53.95,2716.77,19.69,"","",13681.08,29.6,7901.72,11.94,15084.04,10.32}
,{208,89,10753.235,55.716,7684.865,0.268,-5930.495,65.37,208.011544073,59.813,0,0.097,"",0.015,"",3,1,"","",{"A","B+"},{"",1,0},{"","="},{"",1,0},18868.85,75.19,2582.29,62.44,7721.01,50,"","",6308.61,58.4,"","",8464.31,75.12,80.22,77.04,"","",17898.5,58.55,9778.3,89.87,17709.45,56.26}
,{208,90,16683.73,34.19,7652.592,0.164,"","",208.017910722,36.704,0,0.0024,"",0.0012,"",0,1,"","",{"A"},{0},{"~"},{0},"","",1459.75,38.62,8202.03,30.59,"","",5850.28,63.24,"","","","",1751.47,60.89,"","",13915.08,60.98,7441.09,61.25,16491.14,78.37}
,{209,79,-2540,400,7788,2,6104,426,208.997273,429,0,1,"",3e-07,">",1.5,1,"","",{"B-n"},{0},{"="},{0},7873,500,"","",995,642,11105,400,"","",2654,401,4510,499,8839,565,15718,400,12711,566,11956,499,"",""}
,{209,80,-8644,149,7813,1,5000,149,208.99072,160,0,38,"",6,"",4.5,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},8299,152,18682,427,1897,333,8970,149,-14943,426,35,149,3450,152,9832,333,7722,149,12877,335,10434,333,6634,333}
,{209,81,-13644.757,6.11,7833.397,0.029,3969.889,6.211,208.98535175,6.559,0,129.72,"",0.42,"",0.5,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},8752.94,8.04,17413,300,2700,196,4613.91,6.16,-14832,298,32.52,6.14,4965.94,6.27,7668.32,31.34,-762.14,7.93,13553.49,30.43,12165.1,21.31,6216,298}
,{209,82,-17614.646,1.747,7848.648,0.008,644.016,1.146,208.981089898,1.875,0,11642.4,"",25.2,"",4.5,1,"","",{"B-"},{0},{"="},{0},11305.23,1.34,15705.14,29.86,2248.18,3.93,-1248.55,1.91,-11638.21,30.79,-6815.74,2.18,3937.37,1.34,8153.48,2.13,-8673.6,10.11,14130.61,5.56,9502.78,1.36,8977.56,20.43}
,{209,83,-18258.662,1.364,7847.987,0.007,-1892.57,1.564,208.980398519,1.464,0,6.342942126e+26,"",2.52455408e+25,"",4.5,-1,"","",{"A"},{0},{"="},{0},14346.67,1.98,11802.15,5.45,3137.3,0.77,-5376.05,5.16,-8797.5,1.83,-8860.38,1.52,7459.76,1.86,3799.03,0.78,-14489.09,14.69,14904.19,0.77,10390.98,0.77,9641.11,0.78}
,{209,84,-16366.092,1.778,7835.188,0.009,-3483.478,5.287,208.982430276,1.908,0,3913058824,"",94670778,"",0.5,-1,"","",{"A","B+"},{0,0.454,0},{"~","="},{0,0.454,0},15362.95,6.7,8491.99,1.37,4979.23,1.36,-7425.04,10.11,-1906.46,1.37,-11967.54,9.09,6967.81,1.89,4784.84,2.43,-18224.31,5.95,14399.34,2.52,8526.24,7.67,13065.89,1.36}
,{209,85,-12882.613,5.102,7814.777,0.024,-3941.564,11.188,208.986169944,5.477,0,19512,"",180,"",4.5,-1,"","",{"B+","A"},{0,4.1,0},{"=","="},{0,4.1,0},15797.83,13.41,7405.93,5.53,5756.98,2,-9113.04,15.5,-1301.36,5.49,-11298.34,12.2,8484.06,10.28,2701.99,5.27,-21726.42,50.87,14973.97,8.32,10170.12,6.48,12792.07,9.11}
,{209,86,-8941.049,9.96,7792.175,0.048,-5171.477,17.713,208.990401388,10.692,0,1728,"",60,"",2.5,-1,"","",{"B+","A"},{0,17,0},{"=","="},{0,17,0},16448.92,13.09,6373.22,11.98,6155.43,1.95,-10799.27,11.5,1239.58,10.1,-14346.45,15.47,7356.78,14.94,3760.15,13.37,-25308,140,14997.17,15.91,8352.72,18.05,14894.03,10.74}
,{209,87,-3769.572,14.648,7763.688,0.07,-5627.791,15.73,208.995953197,15.725,0,50.5,"",0.7,"",4.5,-1,"","",{"A","B+"},{0,11,0},{"=","="},{0,11,0},17067.87,22.83,5120.1,19.15,6777.46,3.6,-12613.38,52.69,1411.33,17.13,-13568.74,17.19,9174.97,18.83,1402.95,18.39,"","",15576,16.93,10227.45,16.97,14306.55,20.94}
,{209,88,1858.219,5.747,7733.017,0.027,-6985.59,50.934,209.001994879,6.169,0,4.71,"",0.08,"",2.5,-1,"","",{"A"},{0},{"~"},{0},17828.9,53.51,4084.96,10.26,7143.09,2.69,-14509,140,4224.84,12.5,-16966.33,56.01,7940.95,10.66,2764.83,13.16,"","",15413.37,18.42,7964.69,28.77,16637.59,10.31}
,{209,89,8843.809,50.608,7695.85,0.242,-7523,148,209.00949422,54.33,0,0.094,"",0.01,"",4.5,-1,"","",{"A","B+"},{"",1,0},{"","="},{"",1,0},18445.06,71.41,2889.79,53.55,7728.71,50,"","",4220.76,51.97,-15911.24,61.08,9980.74,75.27,173.02,51.41,"","",16010.13,73.43,10142.33,53.72,15732.63,57.93}
,{209,90,16367,140,7656,1,"","",209.017571,150,0,0.06,"","s","",2.5,-1,"","",{},{},{},{},"","",1755,149,8103,140,"","",7350,140,"","",8388,144,1675,150,"","",15932,148,7752,148,18448,141}
,{210,79,2329,401,7766,2,7694,446,210.0025,430,0,1,"",3e-07,">",0,0,"","",{"B-n"},{0},{"="},{0},7713,499,"","","","",11576,401,"","",2902,427,3202,566,"","",17121,401,14030,566,11733,566,"",""}
,{210,80,-5365,196,7799,1,3882,196,209.99424,210,0,64,"",10,"",0,1,"","",{"B-","B-n"},{0,2.2,0},{"=","="},{0,2.2,0},8243,198,18953,445,1841,357,9363,196,"","",208,196,4792,246,10114,445,10588,196,11447,357,10309,358,4821,446}
,{210,81,-9246.969,11.604,7813.588,0.055,5481.534,11.561,209.99007297,12.456,0,78,"",1.8,"",5,1,"","",{"B-","B-n"},{0,0.009,0},{"=","="},{0,0.009,0},8639.47,11.67,17724,298,2543,298,5545.01,11.57,-13996,400,296.36,11.62,3673.53,13.06,7892,149,2725.21,13.85,14729.24,32.86,12104.53,31.99,7209,300}
,{210,82,-14728.502,1.447,7835.965,0.007,63.476,0.499,209.984188301,1.553,0,700563757.2,"",6942523.72,"",0,1,"","",{"B-","A"},{0,1.9,0},{"=","="},{0,1.9,0},9122.54,0.92,16041.04,30.77,3792.38,20.39,1224.64,0.91,-13373,149,-4541.16,0.51,5185.17,1.25,8372.72,6.18,-5123.73,4.74,12732.44,1.9,11170,5.47,7405.34,29.84}
,{210,83,-14791.979,1.363,7832.542,0.006,1161.159,0.766,209.984120156,1.462,0,433036.8,"",432,"",1,-1,"","",{"B-","A"},{0,13.2,0},{"=","="},{0,13.2,0},12064.39,1.86,12619.79,1.83,5036.47,0.78,-2819.8,7.65,-8436.19,6.16,-6497.2,1.56,4604.63,0.08,4466.3,1.15,-11458.77,15.21,17667.43,0.77,12524.12,0.77,11888.87,5.45}
,{210,84,-15953.137,1.146,7834.346,0.005,-3980.96,7.61,209.982873601,1.23,0,11955686.4,"",172.8,"",0,1,"","",{"A"},{0},{"="},{0},14626.18,1.31,8782.48,0.13,5407.53,0.07,-6348.37,4.66,-5627.46,1.34,-11141.84,5.11,7658.36,1.36,4983.45,0.77,-16395.93,9.18,13627.89,2.01,8965.54,2.12,12145.31,0.12}
,{210,85,-11972.177,7.695,7811.663,0.037,-2367.407,8.922,209.987147338,8.261,0,29160,"",1440,"",0,0,"","",{"B+","A"},{0,0.175,0},{"~","="},{0,0.175,0},15644.94,11.78,7679.9,7.87,5631.19,0.98,-8638.97,16.99,-1002.49,7.65,-11102.44,12.58,7160.88,9.17,2895.06,7.73,-20761.88,57.92,16208.22,7.72,10037.65,10.05,13728.85,7.9}
,{210,86,-9604.77,4.557,7796.665,0.022,-6271.565,15.824,209.989688854,4.892,0,8640,"",360,"",0,1,"","",{"A"},{0},{"="},{0},16091.81,12.02,6713.12,4.84,6158.99,2.16,-10047.56,10.25,-527.65,4.85,-13906.52,15.34,8735.04,10.95,4011.13,6.83,-23664.22,19.44,13575.91,10.02,8486.7,13.22,13187.41,8.05}
,{210,87,-3333.205,15.154,7763.075,0.072,-3775.997,17.72,209.996421657,16.268,0,190.8,"",3.6,"",6,1,"","",{"A"},{0},{"="},{0},16809.92,19.23,5441.28,17.58,6671.6,5.03,-12122.9,59.37,2260.44,15.99,-13262.74,16.21,7634.95,21.01,1681.13,18.13,"","",17033.19,18.8,10165.61,17.37,15540.61,19.56}
,{210,88,442.792,9.193,7741.368,0.044,-8346.908,58.133,210.000475356,9.868,0,4,"",0.1,"",0,1,"","",{"A","B+"},{"",4,0},{"","="},{"",4,0},17427.7,12.82,4479.56,14.39,7150.84,3.27,-13616.65,20.99,2094.87,13.55,-16472.33,51.44,9486.74,10.82,3076.61,17.28,"","",13819.52,14.98,8151.19,19.77,14723.96,12.52}
,{210,89,8789.699,57.402,7697.896,0.273,-5269.747,60.436,210.00943613,61.623,0,0.35,"",0.04,"",7,1,"","",{"A","B+"},{"",9,0},{"","="},{"",9,0},18106.17,79.99,3122.32,58.61,7607.2,50,"","",5270.3,59.24,-15649,151,8125.43,76.53,357.49,57.69,"","",17772.65,58.11,10109.27,78.27,17280.44,60.01}
,{210,90,14059.446,18.909,7669.076,0.09,"","",210.015093437,20.299,0,0.016,"",0.0036,"",0,1,"","",{"A","B+"},{"",1,0},{"","="},{"",1,0},18766.92,39.05,2246.35,20.89,8068.99,5.77,"","",4912.26,19.74,"","",10379,141,2073.33,54.03,"","",14017.02,58.84,7777.27,53.82,16161.36,56.45}
,{211,80,-624,196,7778,1,5454,200,210.99933,210,0,26,"",8,"",4.5,1,"","",{"B-","B-n"},{0,6.3,0},{"=","="},{0,6.3,0},8122,246,"","",1491,446,9869,196,"","",552,196,3330,277,10242,446,11808,196,12627,445,10341,357,6012,445}
,{211,81,-6077.998,41.917,7799.791,0.199,4414.95,41.978,210.993475,45,0,80,"",16,"",0.5,1,"","",{"B-","B-n"},{0,2.2,0},{"=","="},{0,2.2,0},8575.88,42.36,18116,402,2307,303,5781.13,42.27,-15696,403,579.19,41.94,4902.35,43.49,8002,200,5569.27,42.01,13277,155,12051.46,51.98,5670,301}
,{211,82,-10492.948,2.261,7817.007,0.011,1366.183,5.471,210.988735356,2.426,0,2169.84,"",0.72,"",4.5,1,"","",{"B-"},{0},{"="},{0},9020.94,2.75,16427,149,3569.58,29.89,1939.62,2.48,-12417,196,-3772.29,2.53,3835.76,2.57,8534.95,11.77,-1737.54,7.14,13862.61,6.19,11121.24,2.68,8418.86,30.82}
,{211,83,-11859.131,5.442,7819.774,0.026,573.439,5.43,210.987268698,5.842,0,128.4,"",1.2,"",4.5,-1,"","",{"A","B-"},{0,0.276,0},{"~","="},{0,0.276,0},9743.1,5.45,12792.32,8.04,6750.4,0.46,-211.87,5.94,-9901.13,12.75,-3977.31,5.41,5138.47,5.45,4419.6,5.48,-7718.88,13.16,16466.32,5.56,14753.52,5.41,10537.4,5.6}
,{211,84,-12432.571,1.255,7818.784,0.006,-785.307,2.539,210.986653085,1.347,0,0.516,"",0.003,"",4.5,1,"","",{"A"},{0},{"="},{0},12209.11,1.46,9395.87,1.44,7594.56,0.51,-3677.17,6.74,-4993.04,1.05,-8531.71,7.63,4550.75,0.52,4929.56,0.92,-13264.59,8.02,16536.9,0.93,11301.71,2.08,14962.43,0.51}
,{211,85,-11647.264,2.729,7811.354,0.013,-2891.86,6.894,210.987496147,2.929,0,25970.4,"",25.2,"",4.5,-1,"","",{"EC","A"},{0,41.8,0},{"=","="},{0,41.8,0},14907.28,5.68,7966.54,2.37,5982.45,1.3,-7507.01,12.29,-4144.26,2.37,-10113.81,5.28,7746.4,8.01,2983.1,2.49,-18849.48,53.05,15429.63,2.83,10686.39,2.81,12869.36,3.01}
,{211,86,-8755.404,6.813,7793.941,0.032,-4615.155,13.786,210.990600686,7.314,0,52560,"",720,"",0.5,-1,"","",{"B+","A"},{0,27.4,0},{"=","="},{0,27.4,0},15956.99,12.06,6967.25,6.85,5965.45,1.44,-9587.43,10.45,-91.24,6.72,-13493.52,16.61,7221.95,8.17,4072.2,10.15,-22665.58,73.32,14838.02,8.44,8578.52,11.22,14360.59,6.84}
,{211,87,-4140.249,11.991,7768.36,0.057,-4972.272,14.369,210.995555259,12.872,0,186,"",1.2,"",4.5,-1,"","",{"A"},{0},{"="},{0},16513.31,18.88,5835.58,13.03,6662.25,3.18,-11342.46,54.32,542.96,14.24,-12654.36,15.11,8878.36,19.3,1824.45,12.83,-26220,103,15511.61,15.59,10379.4,16.36,13976.02,14.94}
,{211,88,832.023,7.918,7741.087,0.038,-6370.191,53.564,211.000893213,8.5,0,13.2,"",1.4,"",0,0,"","",{"A","B+"},{0,7,0},{">","<"},{0,7,0},17168.83,9.78,4804.87,12.72,7041.87,3.08,-13078.15,73.44,3147.82,9.14,-16028.99,57.95,7682.09,12.13,3123.74,17.1,"","",15312.4,16.65,8362,14.24,16134.02,13.67}
,{211,89,7202.214,52.976,7707.189,0.251,-6707.958,90.205,211.007731894,56.871,0,0.213,"",0.025,"",4.5,-1,"","",{"A","B+"},{0,0.2,0},{"~","<"},{0,0.2,0},17784.23,73.26,3606.16,54.96,7621.64,50,-14878,115,3246.45,55.1,-14928.55,56.25,9658.8,78.11,529.55,53.77,"","",16054.8,53.29,10338.41,53.74,15514.53,54.28}
,{211,90,13910.171,73.01,7671.69,0.346,-8170,126,211.014933183,78.379,0,0.048,"",0.02,"",2.5,-1,"","",{"A","B+"},{"","",""},{"",""},{"","",""},18600,157,2525.99,73.23,7940.77,50,"","",6178.41,73.58,"","",8220.59,75.41,2168.5,92.87,"","",15777.17,88.84,8020.99,91.84,17828.72,73.56}
,{211,91,22080,102,7629,0,"","",211.023704,110,0,0.003,"",3e-07,">",4.5,-1,"","",{},{},{},{},"","",1342,114,8509,114,"","",6001,117,"","","","",-732,104,"","",16424,173,10260,108,16973,117}
,{212,80,2757,298,7763,1,4308,359,212.00296,320,0,60,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},8020,357,"","",1322,499,10306,298,"","",764,301,4690,357,"","",13127,298,11139,499,10161,499,"",""}
,{212,81,-1551,200,7780,1,5998,200,211.998335,215,0,31,"",8,"",5,1,"","",{"B-","B-n"},{0,1.8,0},{"=","="},{0,1.8,0},8447,201,18458,448,2125,359,6567,200,"","",871,200,3544,205,8216,280,7077,200,14525,280,11957,250,6636,447}
,{212,82,-7548.85,1.842,7804.319,0.009,569.104,1.825,211.991895975,1.977,0,38304,"",36,"",0,1,"","",{"B-"},{0},{"="},{0},8962.98,2.1,16761,196,3291.64,30.79,2820.64,1.91,-14214,196,-3761.04,5.6,5127.22,2.46,8759.82,41.96,1110.76,3.5,12408.92,11.67,10959.96,6.21,6742,149}
,{212,83,-8117.954,1.854,7803.313,0.009,2251.533,1.667,211.991285016,1.989,0,3633,"",3.6,"",0,0,"","",{"B-","A","B-A"},{0,35.94,0,0.014,0},{"=","=","="},{0,35.94,0,0.014,0},9468.61,1.83,13448.93,11.67,6207.26,0.03,510.27,2.68,-9328.93,41.96,-3756.7,1.75,4330.14,5.6,4913.98,2.68,-4601.99,8.96,17321.35,1.9,14360.75,2.13,11173.2,6.27}
,{212,84,-10369.487,1.152,7810.243,0.005,-1741.266,2.107,211.988867896,1.236,0,2.947e-07,"",1e-09,"",0,1,"","",{"A"},{0},{"="},{0},10558.98,0.17,10218.93,0.93,8954.2,0.11,-1709.88,2.94,-7165.51,2.43,-6793.54,2.49,6008.23,0.52,5799.33,5.41,-10170.52,11.21,15133.3,0.78,12753.23,0.78,12891.56,1.35}
,{212,85,-8628.221,2.384,7798.34,0.011,31.387,3.605,211.990737223,2.559,0,0.314,"",0.002,"",1,-1,"","",{"A","B+","B-"},{0,0.03,0,2,0},{"~","<","<"},{0,0.03,0,2,0},12798.68,7.89,8414.18,1.96,7817.09,0.61,-5112.25,9.09,-4058.06,5.79,-7944.13,7,5052.27,3.07,3484.62,2.16,-15905.52,51.44,18035.72,2.1,12601.93,2.5,15276.84,1.96}
,{212,86,-8659.608,3.145,7794.797,0.015,-5143.64,9.318,211.990703528,3.376,0,1434,"",72,"",0,1,"","",{"A"},{0},{"="},{0},15197.47,5.5,7284.41,2.93,6385.07,2.62,-8460.64,11.58,-3516.01,2.98,-12590.68,12.39,7975.52,7.33,4301.31,3.84,-20770.42,10.47,14023.38,8.15,9087.06,5.89,13352.89,3.23}
,{212,87,-3515.968,8.775,7766.845,0.041,-3317,14.276,211.996225453,9.42,0,1200,"",36,"",5,1,"","",{"B+","A"},{0,43,0},{"=","="},{0,43,0},16325.4,17.5,6121.73,11.67,6528.99,1.61,-10793.27,52.13,842.33,9.19,-12419.31,11.82,7447.04,14.85,2049.53,11.11,-25109.33,75.37,16799.61,9.89,10289.14,13.27,15013.05,10.15}
,{212,88,-198.968,11.263,7747.508,0.053,-7476.266,52.601,211.999786399,12.091,0,13,"",0.2,"",0,1,"","",{"A","B+"},{"",15,0},{"","="},{"",15,0},16784.39,14.48,5172.14,12.13,7031.71,1.67,-12309.78,15.05,1267.47,13.06,-15472.5,54.16,9102.31,13.77,3347.69,16.45,"","",13845.04,18.88,8434.66,18.46,14388.48,15.03}
,{212,89,7277.298,51.381,7708.552,0.242,-4833.51,52.366,212.007812501,55.16,0,0.895,"",0.028,"",6,1,"","",{"A","B+"},{"",3,0},{"","="},{"",3,0},17655.04,77.04,3967.44,53.57,7518.3,50,-14316.06,90.8,4128.58,52.76,-14704.19,89.28,7996.23,73.8,843.7,51.99,"","",17545.31,52.2,10283.13,51.7,16693.27,53.43}
,{212,90,12110.808,10.109,7682.062,0.048,-9482.551,75.541,212.013001487,10.852,0,0.0317,"",0.0013,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},18091.27,21.39,2909.92,13.61,7958.04,4.56,"","",3989.81,12.84,-18041,103,9870.68,73.7,2380.38,53.93,"","",14031.91,58.29,8131.05,51.61,15898.99,11.59}
,{212,91,21593.358,74.862,7633.643,0.353,"","",212.023181425,80.367,0,0.0075,"",0.0028,"",7,1,"","",{"A"},{0},{"="},{0},"","",1774.28,94.34,8415.21,50,"","",7102.17,91.71,"","",8558,127,-394.22,104.57,"","",18244.72,77.21,10090,158,18395.95,90.36}
,{213,80,7666,298,7741,1,5882,299,213.00823,320,0,1,"",3e-07,">",2.5,1,"","",{"B-n"},{0},{"="},{0},7852,357,"","","","",10870,298,"","",1146,359,3162,422,"","",14320,298,"","",10202,499,"",""}
,{213,81,1783.811,27.013,7765.43,0.127,4987.343,27.894,213.001915,29,0,24,"",4,"",0.5,1,"","",{"B-","B-n"},{0,7.6,0},{"=","="},{0,7.6,0},8280.82,49.87,"","",1899,401,7015.45,27.49,"","",1261.34,27.08,4737,202,8262,299,8363.41,27.45,13119,197,12013,197,5101,401}
,{213,82,-3203.532,6.954,7785.172,0.033,2028.103,8.371,212.996560867,7.465,0,612,"",18,"",4.5,1,"","",{"B-"},{0},{"="},{0},8853.22,7.15,17157,196,3016,149,3450.05,7.55,-13250,298,-3156.89,7.12,3726,7.04,8942,200,2492.49,7.7,13585.27,42.49,10907.49,13.49,7808,196}
,{213,83,-5231.635,5.082,7791.021,0.024,1421.949,5.49,212.994383608,5.456,0,2736.6,"",2.4,"",4.5,-1,"","",{"B-","A"},{0,2.09,0},{"=","="},{0,2.09,0},9515.14,7.29,13731.58,42.22,5988.21,3.39,1347.96,6.97,-10970,200,-2933.46,5.12,5185,5.27,4971.76,5.2,-1678.79,7.16,15972.12,5.18,14360.92,5.17,9661.74,12.61}
,{213,84,-6653.584,3.053,7794.024,0.014,-73.989,5.465,212.992857083,3.277,0,3.708e-06,"",8e-09,"",4.5,1,"","",{"A"},{0},{"="},{0},10363.65,2.9,10738.58,3.69,8536.15,2.56,-957.56,4.27,-6393.7,3.4,-6096.68,3.4,4355.41,2.86,5824.6,3.29,-6999.14,10.28,15916.35,6.1,13002.45,2.78,13721.32,2.83}
,{213,85,-6579.595,4.898,7790.003,0.023,-883.569,5.724,212.992936514,5.257,0,1.25e-07,"",6e-09,"",4.5,-1,"","",{"A"},{0},{"="},{0},11074.97,5.27,9298.4,7.2,9254.15,4.7,-3026.75,6.98,-5750.61,5.05,-5991.3,5.59,6022.69,5.09,3499.08,4.77,-12734.29,16.02,16563.78,4.79,14237.6,4.77,13858.79,4.7}
,{213,86,-5696.026,3.37,7782.182,0.016,-2143.179,6.006,212.993885064,3.617,0,0.0195,"",0.0001,"",4.5,1,"","",{"A"},{0},{"="},{0},13083.26,7.43,7841.4,3.21,8245.15,2.86,-6041.58,10.37,-2615.51,3.17,-10251.38,9.4,5107.74,4.32,4356.78,3.8,-17816.11,9.77,16662.04,4.03,11140.21,8.24,15903.51,3.17}
,{213,87,-3552.848,5.091,7768.447,0.024,-3898.405,11.057,212.996185861,5.465,0,34.14,"",0.06,"",4.5,-1,"","",{"A","B+"},{0,0.56,0},{"=","="},{0,0.56,0},15555.23,13.02,6483.52,5.67,6904.85,1.23,-9707.54,16.09,-2213.6,5.51,-11425.2,12.31,8108.2,10.14,2182.21,5.88,-23215.47,71.32,15913.36,8.43,10915.98,6.82,14065.73,9.16}
,{213,88,345.557,9.818,7746.472,0.046,-5809.134,18.156,213.00037097,10.54,0,163.8,"",3,"",0.5,-1,"","",{"A"},{0},{"="},{0},16629.1,12.61,5476.98,11.95,6861.69,2.28,-11774.53,13.47,1716.19,10.3,-15003.06,52.31,7526.79,14.94,3427.45,13.17,"","",15196.61,15.5,8542.82,18.06,15596.73,10.82}
,{213,89,6154.692,15.272,7715.526,0.072,-5965.394,17.834,213.006607333,16.395,0,0.738,"",0.016,"",4.5,-1,"","",{"A"},{""},{""},{""},17190.16,55.13,4283,19.37,7499.35,4.32,-13507.93,72.76,2381.69,17.59,-14027.43,18.3,9193.92,53.6,935.31,18.96,"","",16033.47,17.2,10575.95,17.82,15134.3,21.45}
,{213,90,12120.086,9.217,7683.846,0.043,-7542.539,71.737,213.013011447,9.895,0,0.144,"",0.021,"",2.5,-1,"","",{"A","B+"},{"","",""},{"",""},{"","",""},17932.72,73.59,3289.88,12.15,7836.95,7.21,"","",5030.08,14.53,-17544.59,75.43,8062.04,13.65,2446.18,52.2,"","",15628.68,53.77,8194.44,58.14,17323.7,13}
,{213,91,19662.625,71.142,7644.762,0.334,"","",213.021108697,76.374,0,0.007,"",0.003,"",4.5,-1,"","",{"A"},{0},{"="},{0},18560,125,2117.53,88.7,8393.9,50,"","",5096.36,87.76,"","",10002.05,103.27,-262.85,71.86,"","",16463.26,101.94,10467.23,73.61,16519.33,91.41}
,{214,80,11178,401,7727,2,4713,446,214.012,430,0,1,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},7722,499,"","","","",11361,401,"","",1323,401,4560,499,"","",15648,401,"","","","","",""}
,{214,81,6465,196,7745,1,6647,196,214.00694,210,0,11,"",2,"",5,1,"","",{"B-","B-n"},{0,34,""},{"=","="},{0,34,""},8127,280,"","",1711,446,7665,196,"","",1597,196,3391,197,8491,357,9844,196,14418,357,11953,277,"",""}
,{214,82,-182.769,1.975,7772.394,0.009,1017.984,11.256,213.999803788,2.12,0,1623.6,"",4.2,"",0,1,"","",{"B-"},{0},{"="},{0},8776.55,2,17518,298,2758,196,4287.28,2.32,-15138,298,-3022.45,5.27,5050.55,7.07,9255.55,27.09,4136.97,9.37,12079,200,10759.28,41.96,6088,196}
,{214,83,-1200.753,11.209,7773.495,0.052,3269.293,11.165,213.998710938,12.033,0,1194,"",24,"",1,-1,"","",{"B-","A","B-A"},{0,0.021,0,0.003,0},{"~","=","="},{0,0.021,0,0.003,0},9225.43,11.28,14228,201,5621.3,3,2179.08,11.89,-10273.53,29.25,-2618.49,11.51,4040.44,12.25,5286.19,13.15,-242.05,14.08,17058.9,11.28,14156.25,11.38,10523.65,43.39}
,{214,84,-4470.046,1.449,7785.116,0.007,-1090.215,4.107,213.995201208,1.555,0,0.00016372,"",2.7e-07,"",0,1,"","",{"A"},{0},{"="},{0},10243.19,0.93,11499.14,2.1,7833.54,0.06,-150.3,9.16,-8555.48,7.07,-5961.77,4.73,5887.78,2.83,6527.38,5.17,-4562.78,5.41,14358.71,1.9,12253.14,5.48,11669.3,2.57}
,{214,85,-3379.831,4.298,7776.366,0.02,939.911,10.014,213.996371601,4.614,0,5.58e-07,"",1e-08,"",1,-1,"","",{"A"},{0},{"="},{0},10894.24,4.52,9839.82,4.47,8987.23,4.08,-2421.12,9.51,-5437.17,6.56,-5755.12,5.22,4871.55,6.22,4015.22,4.94,-9823.69,15.94,17700.46,4.15,13916.79,4.18,14125.7,6.81}
,{214,86,-4319.742,9.187,7777.102,0.043,-3361.035,12.503,213.995362566,9.862,0,2.7e-07,"",2e-08,"",0,1,"","",{"A"},{0},{"="},{0},11802.77,9.57,8528.2,9.12,9208.48,9.12,-4412.48,10.56,-4955.13,9.55,-8838.21,10.45,6695.03,9.65,5029.12,10.29,-15014.63,14.02,15019.29,9.35,12191.58,9.45,13759.23,9.13}
,{214,87,-958.707,8.634,7757.74,0.04,-1051.441,10.086,213.998970785,9.268,0,0.00518,"",0.00016,"",1,-1,"","",{"A"},{0},{"="},{0},13585.37,12.31,6908.43,8.81,8588.55,3.91,-7402.56,17.61,-1668.08,9.8,-9375.58,13.07,5477.18,9.96,2551.65,9.13,-20444.22,76.61,18411.71,9.05,12660.75,10.88,16334.96,8.91}
,{214,88,92.734,5.25,7749.171,0.025,-6351.12,16.232,214.000099554,5.636,0,2.437,"",0.016,"",0,1,"","",{"A","B+"},{0,0.059,0},{"~","="},{0,0.059,0},15850.93,12.41,5825.6,6.09,7272.59,2.61,-10602.15,11.87,-1500.21,6.21,-14133.27,16.15,8324.14,11.13,3643.39,7.3,"","",14319.51,10.22,9097.04,13.09,14494.54,8.58}
,{214,89,6443.854,15.36,7715.837,0.072,-4251.03,18.693,214.006917762,16.489,0,8.2,"",0.2,"",5,1,"","",{"A","B+"},{0,11,0},{">","<"},{0,11,0},16976.08,53.63,4618.12,17.68,7352.14,2.51,-13041.66,77.66,2707.73,16.18,-13747.55,17.91,7782.15,21.59,1190.67,18.23,"","",17353.63,19.04,10475.89,17.28,16230.5,19.47}
,{214,90,10694.885,10.661,7692.317,0.05,-8790.63,76.867,214.011481431,11.445,0,0.087,"",0.01,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},17558.56,14.64,3684.09,15.46,7827.18,5.4,"","",3060.36,14.49,-17039.06,71.94,9496.52,14.08,2748.78,18.62,"","",14128.39,52.48,8356.73,54.04,15509.26,13.28}
,{214,91,19485.515,76.125,7647.583,0.356,"","",214.020918561,81.723,0,0.017,"",0.003,"",0,0,"","",{"A"},{0},{"~"},{0},18250.48,106.77,2369.72,91.84,8270.9,50,"","",6041.85,77.64,"","",8248.43,104.19,-76.46,76.68,"","",18085.51,76.79,10439.4,105.48,17929.7,92.74}
,{215,80,16208,401,7705,2,6297,499,215.0174,430,0,1,"",3e-07,">",1.5,1,"","",{"B-n"},{0},{"="},{0},7601,499,"","","","",11866,404,"","",1672,446,3041,566,"","",16750,401,"","","","","",""}
,{215,81,9911,298,7730,1,5569,303,215.01064,320,0,10,"",4,"",0.5,1,"","",{"B-","B-n"},{0,4.6,0},{"=","="},{0,4.6,0},8015,299,"","","","",8282,298,"","",2023,298,4625,357,8556,499,11167,298,12956,422,12018,422,"",""}
,{215,82,4342.244,52.448,7752.737,0.244,2712.922,52.748,215.00466159,56.304,0,140.4,"",11.4,"",4.5,1,"","",{"B-"},{0},{"="},{0},8596.86,52.91,17902,303,2541,203,4883.95,52.49,-14125,404,-2528.32,53.63,3546.3,52.48,9411,203,5510.8,53.01,13269.24,59,10757,207,7231,303}
,{215,83,1629.322,5.624,7761.717,0.026,2171.028,5.53,215.001749149,6.037,0,456,"",12,"",4.5,-1,"","",{"B-"},{0},{"="},{0},9281.68,7.37,14732.43,27.59,5282.4,42.29,2885.08,8.67,-12124,196,-1971.95,5.77,5241.24,12.51,5476.88,5.81,1311.26,9.01,15543.66,8.85,14042.23,5.76,8827,200}
,{215,84,-541.706,2.121,7768.176,0.01,714.049,6.819,214.999418454,2.276,0,0.001781,"",5e-06,"",4.5,1,"","",{"A","B-"},{0,2.3,0},{"=","="},{0,2.3,0},10030.76,3.6,11916.12,7.11,7526.33,0.81,626.85,7.93,-7647.91,2.45,-5233.19,4.73,4142.98,2.46,6629.92,11.36,-3075.44,7.87,15400.73,5.12,12440.3,2.56,12653.55,2.33}
,{215,85,-1255.756,6.799,7767.858,0.032,-87.195,10.168,214.99865189,7.299,0,0.0001,"",2e-05,"",4.5,-1,"","",{"A"},{0},{"="},{0},10818.8,8.28,10602.06,8.35,8178.46,4.08,-1573.82,9.72,-7343.97,13.05,-5007.33,11.35,5947.24,7.94,4074.68,6.83,-7286.37,14.14,16108.63,7.33,13977.79,6.77,12508.6,6.93}
,{215,86,-1168.561,7.672,7763.814,0.036,-1486.625,10.306,214.998745498,8.236,0,2.3e-06,"",1e-07,"",4.5,1,"","",{"A"},{0},{"="},{0},11615.17,8.22,9092.92,8.11,8839.09,7.57,-3702.3,10.69,-3987.49,7.64,-8281.17,11.44,4920.14,11.86,5077.7,8.65,-12090.15,11.71,16121.84,8.96,12323.72,7.87,14847.33,7.59}
,{215,87,318.065,7.066,7753.26,0.033,-2215.674,10.077,215.000341456,7.585,0,8.6e-08,"",5e-09,"",4.5,-1,"","",{"A"},{0},{"="},{0},12271.72,8.64,7680.28,8.38,9540.41,6.52,-5712.55,14.27,-3591.07,8.04,-7845.99,8.78,6794.55,11.04,2651.16,11.48,-17545.87,73.19,16724.9,7.66,13841.73,7.57,14592.69,7.2}
,{215,88,2533.739,7.613,7739.316,0.035,-3496.877,14.551,215.00272008,8.172,0,0.00167,"",1e-05,"",4.5,1,"","",{"A"},{0},{"="},{0},13954.45,12.42,6348.18,8.17,8864.23,3.4,-8387.85,11.67,-435.49,11.82,-11981.43,17.14,5630.31,9.23,3796.53,11.4,-22389.35,88.81,16797.39,9.09,10913.76,11.61,16839.75,8.08}
,{215,89,6030.615,12.406,7719.413,0.058,-4890.971,15.234,215.006474132,13.318,0,0.17,"",0.01,"",4.5,-1,"","",{"A","B+"},{0,0.09,0},{"~","="},{0,0.09,0},16266.71,19.63,4994.48,13.41,7745.95,3.18,-11833.32,73.89,-299.65,15.11,-12735.59,16.35,8484.56,19.72,1351.09,13.47,"","",16395.86,15.82,11093.64,16.75,15192.98,15.19}
,{215,90,10921.586,8.84,7693.025,0.041,-6942.353,73.38,215.011724805,9.49,0,1.2,"",0.2,"",0.5,-1,"","",{"A"},{0},{"="},{0},17341.13,12.77,4001.91,13.21,7664.65,3.93,-14001.5,88.93,3539.88,10.28,-16635.25,76.64,7844.62,13.85,2811.24,17.72,"","",15477.7,17.65,8508.34,52.14,16766.96,14.32}
,{215,91,17863.939,72.845,7657.096,0.339,-7059.147,114.616,215.019177728,78.202,0,0.014,"",0.002,"",4.5,-1,"","",{"A"},{0},{"="},{0},17941.32,101.82,2868.69,74.43,8236.81,50,"","",4131.11,74.45,"","",9692.89,105.36,119.92,73.62,"","",16454.66,73.43,10617.19,73.54,16233.04,89.14}
,{215,92,24923.087,88.49,7620.624,0.412,"","",215.026756035,94.997,0,0.0014,"",0.0009,"",2.5,-1,"","",{"A"},{0},{">"},{0},"","",1774.94,88.97,8588,50,"","",6939.23,89.13,"","","","",1851.4,116.73,"","",15971.27,113.54,8193.78,115.91,18458.68,89.06}
,{216,80,19859,401,7690,2,5142,499,216.02132,430,0,0.1,"",3e-07,">",0,1,"","",{"B-n"},{0},{"="},{0},7461,566,"","","","",12380,446,"","",1877,499,4420,566,"","",18077,401,"","","","","",""}
,{216,81,14718,298,7710,1,7238,357,216.0158,320,0,6,"",3,"",5,1,"","",{"B-","B-n"},{0,11.5,0},{"=","<"},{0,11.5,0},7890,357,"","","","",8844,298,"","",2304,303,3265,422,8779,499,12461,298,14250,499,11915,422,"",""}
,{216,82,7480,196,7740,1,1606,196,216.00803,210,0,99,"",12,"",0,1,"","",{"B-"},{0},{"="},{0},8480,196,18276,446,2298,357,5697,196,-16017,446,-2221,196,4934,203,9720,357,7227,196,11726,277,10560,197,5460,357}
,{216,83,5873.991,11.178,7743.499,0.052,4091.571,11.324,216.006305989,12,0,135,"",3,"",6,-1,"","",{"B-"},{0},{"~"},{0},9067.89,15.83,15169,196,5000,200,3617.32,11.74,-11326,298,-1655.62,11.38,3826.65,12.51,5757.22,53.63,2903.04,11.93,16767.57,11.35,13941.58,13.16,9736.58,29.23}
,{216,84,1782.42,1.816,7758.819,0.008,-474.246,3.571,216.001913506,1.949,0,0.145,"",0.002,"",0,1,"","",{"A"},{0},{"="},{0},9890.17,2.09,12612.75,1.96,6906.35,0.51,1529.55,6.18,-9848.79,52.48,-5033.14,6.92,5747.19,2.29,7135.87,5.75,-1508.66,8.87,13693.98,11.28,11878.11,5.19,10632.35,7.03}
,{216,85,2256.666,3.575,7753.002,0.017,2003.799,6.836,216.002422631,3.837,0,0.0003,"",3e-05,"",0,0,"","",{"A","B-","EC"},{0,0.006,0,3,0},{"~","<","<"},{0,0.006,0,3,0},10506.14,5.41,11120.52,11.69,7949.71,3.06,-714.28,5.32,-6661.63,6.59,-4646.09,8.35,4558.9,7.57,4490.6,3.99,-5887.73,11.41,17437.52,3.6,13774.31,4.49,13134.7,6.1}
,{216,86,252.868,5.994,7758.657,0.028,-2718.082,7.126,216.000271464,6.435,0,4.5e-05,"",5e-06,"",0,1,"","",{"A"},{0},{"="},{0},11570.02,10.85,9855.03,5.96,8197.44,5.88,-3038.21,10.47,-6494.4,6.32,-8136.51,9.13,6649.89,9.6,5780.35,8.97,-10045.46,13.35,14343.5,7.2,11696.52,7.57,12552.85,6.54}
,{216,87,2970.95,4.173,7742.451,0.019,-320.128,9.548,216.003189445,4.48,0,7e-07,"",2e-08,"",1,-1,"","",{"A","B+"},{0,2,0},{"=","<"},{0,2,0},12212.98,9.45,8227.16,5.67,9174.26,3.43,-5173.45,11.61,-3062.27,7.87,-7634.11,8.5,5418.43,7.98,3149.46,8.59,-14828.26,53.69,18001.5,9.96,13531.03,5.12,15196.95,6.14}
,{216,88,3291.077,8.737,7737.347,0.04,-4853.317,13.921,216.003533117,9.379,0,1.82e-07,"",1e-08,"",0,1,"","",{"A","EC"},{0,1,0},{"=","<"},{0,1,0},12944.29,10.17,6967.12,12.57,9525.77,8.15,-7007.25,14.79,-2829.33,11.51,-10810.86,15.17,7313.98,11.48,4315.96,11.12,-19775.27,29.38,14960.59,12.18,11707.98,10.05,14633.51,9.22}
,{216,89,8144.395,10.84,7711.256,0.05,-2153.937,16.201,216.008743367,11.637,0,0.00044,"",1.6e-05,"",1,-1,"","",{"A","B+"},{0,7,0},{"=","="},{0,7,0},14442.09,18.79,5474.84,13.86,9235.45,6.37,-9654.82,54.61,537.36,12.94,-10848.51,13.99,5957.54,16.47,1678.31,13.24,"","",18762.47,12.04,12662.89,14.63,17343.64,11.97}
,{216,90,10298.332,12.042,7697.662,0.056,-7500.882,54.864,216.011055714,12.928,0,0.026,"",0.0002,"",0,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},16539.19,16.03,4372.34,13.12,8072.38,4.26,-12768.02,30.52,475.62,14.16,-15636.92,73.83,8694.57,14.94,3021.25,17.29,"","",14565.28,19.51,9007.7,19.44,15599.18,15.53}
,{216,91,17799.214,53.526,7659.314,0.248,-5267.137,60.45,216.019108242,57.462,0,0.105,"",0.012,"",0,0,"","",{"A","B+"},{"",2,0},{"","="},{"",2,0},17828.94,93.06,3222.58,55.69,8097,15,"","",4479.63,54.94,-15195.19,103.42,8136.04,90.4,411.34,54.25,"","",17815.14,54.58,10543.18,54.31,17290.92,55.66}
,{216,92,23066.351,28.093,7631.307,0.13,"","",216.024762747,30.158,0,0.0069,"",0.0029,"",0,1,"","",{"A"},{0},{"="},{0},"","",2206.47,30.02,8530.63,26.21,"","",4855.79,29.45,"","",9928.05,92.84,2086.56,78.07,"","",14291.64,81.14,8267.78,76.49,16592.67,29.55}
,{217,81,18313,401,7695,2,6073,499,217.01966,430,0,1,"",3e-07,">",0.5,1,"","",{"B-n"},{0},{"="},{0},7741,499,"","","","",9583,401,"","",2762,446,4476,499,8835,566,13919,401,12816,566,11999,566,"",""}
,{217,82,12240,298,7719,1,3510,299,217.01314,320,0,20,"",5,"",4.5,1,"","",{"B-"},{0},{"="},{0},8245,303,18546,499,2149,422,6356,298,-14909,499,-1705,298,3311,357,9767,422,8581,298,13040,422,10639,357,6708,499}
,{217,83,8729.962,17.698,7731.848,0.082,2846.444,18.87,217.009372,19,0,98.5,"",1.3,"",4.5,-1,"","",{"B-"},{0},{"="},{0},9041.99,18.57,15759,299,4521.24,32.29,4335.33,18.39,-13277,299,-1123.78,17.79,5215.35,20.93,6039,196,4415.37,18.86,15098.52,55.35,13776.79,17.81,7912,196}
,{217,84,5883.518,6.544,7741.36,0.03,1488.883,7.979,217.006316216,7.025,0,1.514,"",0.026,"",4.5,1,"","",{"A","B-"},{0,5,0},{">","<"},{0,5,0},9717.41,6.71,13036.67,52.85,6662.13,2.35,2225.02,7.73,-8885,196,-4444.47,7.38,3970.22,6.63,7279.44,12.95,-6.14,9.71,14965,8.53,11948.33,12.94,11712.69,6.66}
,{217,85,4394.635,5.001,7744.616,0.023,736.135,6.151,217.004717835,5.369,0,0.03262,"",0.00024,"",4.5,-1,"","",{"A","B-"},{0,0.008,0},{"~","="},{0,0.008,0},10492.24,8.3,11812.63,7.31,7201.35,1.22,80.05,8.15,-8768.33,12.25,-3929.55,7.75,5933.35,6.03,4676.76,5.11,-4309.04,12.42,15647.15,5.03,13728.74,5.09,11241.79,12.22}
,{217,86,3658.501,4.198,7744.403,0.019,-656.089,7.538,217.003927562,4.506,0,0.00054,"",5e-05,"",4.5,1,"","",{"A"},{0},{"="},{0},11315.57,8.6,10377.73,4.61,7887.17,2.88,-2231.16,8.19,-5412.89,4.45,-7383.77,5.62,4665.68,7.15,5887.14,5.34,-8547.28,11.41,15625.06,7.88,11902.39,5.71,13774.95,4.04}
,{217,87,4314.59,6.531,7737.775,0.03,-1575.067,9.588,217.004631902,7.01,0,1.68e-05,"",1.9e-06,"",4.5,-1,"","",{"A"},{0},{"="},{0},12146.11,9.43,9007.6,9.34,8469.27,4.32,-4389.08,13.08,-5231.05,7.31,-7047.8,10.79,6727.68,7.51,3227.25,8.72,-12753.82,17.19,16193.96,9.95,13498.39,11.16,13340.82,7.58}
,{217,88,5889.656,7.202,7726.911,0.033,-2814.017,13.43,217.006322806,7.731,0,1.63e-06,"",1.7e-07,"",4.5,1,"","",{"A"},{0},{"="},{0},12786.72,10.36,7519.72,10.4,9160.77,6.36,-6316.12,12.82,-1652.18,9.23,-10326.06,13.01,5472.74,11.21,4370.26,8.17,-17084,72,16282.4,9.96,11712.42,11.13,15855.8,11.56}
,{217,89,8703.673,11.389,7710.338,0.052,-3502.107,15.566,217.009343777,12.226,0,6.9e-08,"",4e-09,"",4.5,-1,"","",{"A","B+"},{0,6.9,0},{"=","="},{0,6.9,0},13469.58,16.84,6192.33,13.36,9831.6,10.19,-8364.74,19.57,-1556.25,12.08,-9665.98,16.54,7512.04,15.72,1876.38,14.31,"","",16880.74,13.66,13474.99,12.53,15308.78,14.25}
,{217,90,12205.78,10.614,7690.594,0.049,-4862.63,19.132,217.013103444,11.394,0,0.000247,"",4e-06,"",4.5,1,"","",{"A"},{0},{"="},{0},14858.44,13.81,4905.9,13.06,9435.31,4.03,-10768,72,1625.73,13.74,-13664.75,54.57,6163.87,16.05,3227.59,15.17,"","",16885.97,16.33,10625.98,18.67,17759.45,11.84}
,{217,91,17068.41,15.918,7664.58,0.073,-5905,73,217.018323692,17.089,0,0.00348,"",9e-05,"",4.5,-1,"","",{"A","B"},{0,"",""},{"=",""},{0,"",""},16938.16,74.56,3540.15,20.14,8488.8,4.49,"","",1635.04,19.24,-14069.26,32.28,8802.12,55.84,518.89,19.95,"","",16857.63,18.21,11237.58,19.15,16270.96,22.05}
,{217,92,22973,71,7634,0,"","",217.024663,77,0,0.0008,"",0.0007,"",0.5,-1,"","",{"A","B-"},{0,"",""},{"~",""},{0,"",""},18092,114,2526,72,8428,71,"","",5386,72,"","",8164,77,2115,89,"","",15820,102,8352,104,17925,72}
,{218,81,23180,400,7674,2,7727,499,218.024885,429,0,0.2,"","s","",5,1,"","",{"B-n"},{0},{"="},{0},7680,499,"","","","",9964,401,"","",2869,499,3204,566,"","",15082,400,14032,566,11836,566,"",""}
,{218,82,15453,298,7706,1,2237,299,218.01659,320,0,15,"",7,"",0,1,"","",{"B-"},{0},{"="},{0},8169,357,18984,499,1851,499,7097,298,"","",-1348,299,4858,422,10149,499,10236,298,11447,422,10406,422,4892,499}
,{218,83,13216.037,27.013,7712.827,0.124,4859.136,27.085,218.014188,29,0,33,"",1,"",6,-1,"","",{"B-"},{0},{"="},{0},8800.59,29.23,16080,299,4327,197,5117.87,29.4,-12386,401,-738.8,27.79,3585.24,32.29,6313,299,6156.92,27.43,16447,197,13737.85,59,8951,299}
,{218,84,8356.901,1.973,7731.528,0.009,258.738,11.649,218.008971502,2.118,0,185.88,"",0.72,"",0,1,"","",{"A","B-"},{0,"",""},{"~",""},{0,"",""},9568.15,1.96,13701,196,6114.75,0.09,3139.55,2.92,-11172,298,-4109.05,5.18,5597.93,6.66,7662.03,17.81,1705.73,11.32,13193.72,11.35,11591.63,5.81,9661.06,52.48}
,{218,85,8098.162,11.604,7729.126,0.053,2880.816,11.705,218.008693735,12.456,0,1.5,"",0.3,"",1,-1,"","",{"A","B-"},{0,"",""},{"~",""},{0,"",""},10301.14,12.06,12353.77,16.11,6874,3,1039.05,12.43,-7920.77,21.16,-3631.66,12.23,4367.79,12.58,5074.33,13.28,-2745.45,52.03,17026.55,11.67,13503.92,11.75,12115.24,12.86}
,{218,86,5217.347,2.316,7738.752,0.011,-1841.77,4.942,218.005601052,2.486,0,0.03375,"",0.00015,"",0,1,"","",{"A"},{0},{"="},{0},11178.16,6.23,11143.01,2.74,7262.48,1.85,-1433.82,11.3,-7955.14,6.9,-7168.56,6.67,6512.47,4.44,6466.26,5.4,-7149.39,10.75,13671.49,4.03,11337.16,7.06,11405.45,3.03}
,{218,87,7059.117,4.757,7726.715,0.022,407.947,12.039,218.007578274,5.106,0,0.001,"",0.0006,"",1,-1,"","",{"A"},{0},{"="},{0},12054.47,6.03,9775.49,5.78,8014.03,2.04,-3784.49,50.94,-4624.49,6.82,-6901.86,8.48,5326.79,7.85,3888.35,6.07,-11624.65,18.93,17517.06,7.48,13091.73,8.88,13961.27,8.19}
,{218,88,6651.17,11.176,7724.998,0.051,-4192.439,51.931,218.007140325,11.997,0,2.52e-05,"",3e-07,"",0,1,"","",{"A"},{0},{"="},{0},12782.54,14.09,8179.64,12.58,8546,6.36,-5715.57,15.33,-4296.3,11.83,-10123.82,15.92,7309.8,13.2,4952.39,12.84,-15243.44,17.65,14391.03,11.82,11197.16,13.12,13466.13,13.46}
,{218,89,10843.609,50.74,7702.177,0.233,-1523.132,51.815,218.011641093,54.471,0,1e-06,"",4e-08,"",1,-1,"","",{"A"},{0},{"="},{0},13443.42,51.88,6705.28,50.89,9377.4,50,-7840.16,53.95,-759.95,51.13,-9433.49,51.84,5931.38,51.99,2335.02,51.22,"","",18263.34,51.46,13173.93,51.28,16171.95,51.2}
,{218,90,12366.741,10.516,7691.602,0.048,-6317.029,21.13,218.013276242,11.289,0,1.17e-07,"",9e-09,"",0,1,"","",{"A"},{0},{"="},{0},14074.23,15.98,5502.28,13.66,9849.09,9.11,-9527.87,17.28,-811.89,12.73,-12772.99,19.08,7910.36,14.94,3625.9,15.5,"","",14933.15,15.1,11200.18,16.26,15479.4,12.97}
,{218,91,18683.77,18.329,7659.036,0.084,-3210.838,22.888,218.020057853,19.676,0,0.000113,"",1e-05,"",0,0,"","",{"A"},{0},{"="},{0},15258.08,56.58,4038.57,21.29,9815,10,"","",2691.13,21.58,-12361,74,6455.96,24.22,810.98,21.18,"","",19096.24,21.93,12626.24,20.35,18299.56,22.11}
,{218,92,21894.608,13.714,7640.719,0.063,"","",218.023504829,14.722,0,0.00055,"",0.00014,"",0,1,"","",{"A"},{0},{"="},{0},17314.38,31.24,2981.67,18.21,8774.81,8.63,"","",2399.86,17.34,"","",9150,73,2462.77,21,"","",14806.2,55.25,8894.72,74.12,16619.42,16.32}
,{219,82,20279,401,7686,2,3996,446,219.02177,430,0,10,"",3e-07,">",4.5,1,"","",{},{},{},{},8104,499,"","",1646,566,7597,401,"","",-1009,401,3246,499,10191,566,11449,401,12676,566,10425,499,6066,566}
,{219,83,16283,196,7700,1,3601,196,219.01748,210,0,8.7,"",2.9,"",4.5,-1,"","",{"B-"},{0},{"="},{0},8590,196,16609,446,3947,357,5886,196,-14187,445,-146,196,5005,197,6460,357,7665,196,14753,357,13667,277,7211,357}
,{219,84,12681.359,15.835,7713.333,0.072,2285.283,16.163,219.013614,17,0,618,"",60,"",4.5,1,"","",{"A"},{0},{"="},{0},9344.79,17.13,14136,298,5914.2,50,3851.96,15.97,-10061,298,-3488.12,19.63,3746.86,15.96,7823.65,31.31,3287.08,17.86,14662.2,23.75,11671.42,19.38,10848,196}
,{219,85,10396.076,3.237,7720.196,0.015,1566.675,2.947,219.011160647,3.474,0,56,"",3,"",4.5,-1,"","",{"A","B-"},{0,"",""},{"=",""},{0,"",""},10141.19,5.65,12911.83,17.99,6341.84,4.83,1778.31,7.56,-10108.93,27.21,-2892.59,3.91,5773.4,12.01,5249.79,3.52,-1173.4,50.6,15223.36,7.17,13477.71,3.41,10168.49,11.64}
,{219,86,8829.402,2.1,7723.777,0.01,211.635,7.058,219.009478753,2.254,0,3.96,"",0.01,"",2.5,1,"","",{"A"},{0},{"="},{0},10971.73,4.6,11632.06,6.7,6946.19,0.31,-564.88,8.49,-6816.47,2.43,-6301.03,5.15,4459.26,3.02,6557.73,11.74,-5641.99,50.61,15145.57,5.02,11436.79,3.98,12693.38,2.27}
,{219,87,8617.767,7.039,7721.171,0.032,-776.515,10.772,219.009251553,7.556,0,0.02,"",0.002,"",4.5,-1,"","",{"A"},{0},{"="},{0},11839.46,9.51,10354.81,8.5,7448.61,1.82,-2951.71,50.97,-6769.37,13.51,-6104.72,13.14,6512.67,8.39,3888.55,7.29,-9922.36,51.99,15670.07,8.09,13228.95,9.15,12007.5,7.79}
,{219,88,9394.282,8.258,7714.053,0.038,-2175.199,51.142,219.010085176,8.865,0,0.01,"",0.003,"",0,0,"","",{"A"},{0},{"="},{0},12638.01,10.84,8842.16,9.13,8137.93,3.06,-5077.11,51.22,-3112.04,8.43,-9520.64,51.38,5328.21,13.8,4953.81,9.39,-13892.29,51.44,15790.5,10.41,11287.39,9.11,14787.82,10.08}
,{219,89,11569.48,50.497,7700.549,0.231,-2901.91,71.425,219.012420348,54.21,0,1.18e-05,"",1.5e-06,"",4.5,-1,"","",{"A","B+"},{0,1,0},{"=","="},{0,1,0},13276.83,51.75,7323.05,50.88,8826.5,50,-6970.65,72.14,-2778.61,50.68,-8868.58,51.58,7345.45,71.57,2370.66,51.69,-17887.17,101.77,16390.63,50.98,13142.46,51.22,14244.93,50.63}
,{219,90,14471.39,50.576,7683.725,0.231,-4068.741,72.192,219.015535677,54.295,0,1.021e-06,"",2.4e-08,"",4.5,1,"","",{"A","B+"},{0,1,0},{"=","="},{0,1,0},13877.02,51.68,5996.21,51.06,9512.74,50,-8815.18,71.67,531.25,51.77,-12283.7,53.79,5966.67,51.65,3661.19,71.62,"","",16478.52,51.83,11191.05,51.72,16826.71,51.3}
,{219,91,18540.131,51.516,7661.574,0.235,-4746.439,72.333,219.01990365,55.304,0,5.3e-08,"",1e-08,"",4.5,-1,"","",{"A","B+"},{0,5,0},{"=","="},{0,5,0},14670.91,53.9,4741.48,52.76,10084.6,50,-10916.52,102.28,407.55,72.31,-11425.79,53.31,8214.96,54.67,1115.58,52.58,"","",17045.16,52.6,13105.85,52.9,16042.14,52.64}
,{219,92,23286.569,50.775,7636.329,0.232,-6170.086,101.905,219.024999161,54.509,0,5.5e-05,"",2.5e-05,"",4.5,1,"","",{"A","B+"},{0,1.4,0},{"=","="},{0,1.4,0},15830,88,3497.15,51.87,9940.07,50,"","",3630.86,51.85,"","",6679.36,52.59,2686.17,53.98,"","",16928.97,53.21,10351.41,73.78,18634.64,52.18}
,{219,93,29456.655,88.354,7604.583,0.403,"","",219.031623021,94.851,0,5e-06,"","s","",4.5,-1,"","",{"A"},{0},{"="},{0},"","",2189.7,89.78,9167.8,50,"","",3483.91,90.23,"","","","",-273.08,89.41,"","",17194,114,11254.36,92.71,17303.84,103.3}
,{220,82,23669,401,7672,2,2850,499,220.02541,430,0,30,"",3e-07,">",0,1,"","",{},{},{},{},7927,499,"","",1385,566,8406,401,"","",-685,446,4681,566,"","",13057,401,11200,566,10220,566,"",""}
,{220,83,20819,298,7682,1,5555,299,220.02235,320,0,9.5,"",5.7,"",1,-1,"","",{"B-","B-n"},{0,"",""},{"=",""},{0,"",""},8540,299,16939,499,3676,422,6443,298,"","",66,298,3535,357,6749,499,9337,298,16076,422,13443,422,8152,499}
,{220,84,15263.461,17.698,7703.224,0.08,887.714,22.549,220.016386,19,0,40,"",3e-07,">",0,1,"","",{},{},{},{},9236.07,17.81,14768,299,5359,196,4651.38,17.79,-12304,401,-3203.93,17.99,5489.22,23.75,8308,196,4993.22,19.52,12758.23,32.29,11397.55,25.03,8670,299}
,{220,85,14375.747,13.972,7703.703,0.064,3763.67,14.09,220.015433,15,0,222.6,"",2.4,"",0,0,"","",{"B-","A"},{0,8,""},{"=","="},{0,8,""},9865.05,18.16,13418.23,30.41,6076.84,17.89,2893.43,14.54,-9196,196,-2524.97,14.13,4091.65,14.34,5594.58,21.12,632.06,15.26,16729.65,14.11,13356.28,15.43,11292.19,22.55}
,{220,86,10612.077,1.815,7717.254,0.008,-870.242,4.026,220.011392534,1.948,0,55.6,"",0.1,"",0,1,"","",{"A"},{0},{"="},{0},10747.9,2.74,12322.76,1.96,6404.74,0.1,341.83,8.37,-9358.25,15.94,-6077.01,7.15,6288.64,2.27,7072.97,3.41,-4057.02,22.22,13224.72,11.67,11081.5,5.11,10374.96,6.63}
,{220,87,11482.32,4.028,7709.742,0.018,1212.075,9.061,220.012326778,4.324,0,27.4,"",0.3,"",1,1,"","",{"A","B-"},{0,0.35,0},{"~","="},{0,0.35,0},11719.43,6.08,11193.78,12.21,6800.74,1.86,-2261.36,7.2,-6202.73,5.06,-5983.28,9.08,5206.76,8.01,4636.05,4.39,-8736,51,16975.78,4.43,12687.87,5.65,12734.09,6.31}
,{220,88,10270.245,8.237,7711.696,0.037,-3473.437,10.141,220.011025562,8.843,0,0.0179,"",0.0014,"",0,1,"","",{"A"},{0},{"="},{0},12523.56,13.79,9525.04,8.41,7592.46,5.65,-4398.85,23.59,-5848.13,8.47,-9370.55,51.14,7195.35,11.55,5636.49,10.76,-12663,101,13921.93,9.38,10819.71,10.39,12258.15,9.11}
,{220,89,13743.682,6.129,7692.351,0.028,-925.417,22.941,220.01475445,6.579,0,0.02636,"",0.00019,"",3,-1,"","",{"A","B+"},{0,5,0},{"=","="},{0,5,0},13242.56,51.08,7893.38,7.52,8347.82,4.49,-6475,52,-2163.05,9.24,-8799.02,50.92,5897.11,50.83,2939.57,10.16,-16567,196,17803.32,12.64,12718.08,9.32,15075.49,8.75}
,{220,90,14669.1,22.166,7684.589,0.101,-5549,56,220.015747926,23.795,0,9.7e-06,"",6e-07,"",0,1,"","",{"A","EC"},{0,2,0},{"=","="},{0,2,0},13840.28,24.53,6560.01,24.77,8953.11,20.37,-8264,103,-2014.15,23.6,-11942.35,56.08,7873.61,55.2,4189.35,55.12,"","",14536.3,55.35,10829.48,24.9,14425.84,23.25}
,{220,91,20218,51,7656,0,-2715,113,220.021705,55,0,7.8e-07,"",1.6e-07,"",1,-1,"","",{"A","B+"},{0,3,0},{"=","="},{0,3,0},14608,54,5203,72,9649,50,-10093,202,1360,72,-11140,72,6393,73,1542,72,"","",18562,52,12877,52,17161,52}
,{220,92,22933,101,7640,0,-7378,220,220.02462,108,0,6e-08,"","s","",0,1,"","",{},{},{},{},15104,102,4011,101,10210,100,"","",1173,113,-14595,134,8425,113,2896,113,"","",14960,102,10729,102,16374,101}
,{220,93,30311,196,7603,1,"","",220.03254,210,0,3e-08,"","s","",1,-1,"","",{},{},{},{},"","",2951,196,10087,203,"","",4482,202,"","",7217,215,265,202,"","",19127,196,12201,208,18889,196}
,{221,83,24098,298,7668,1,4324,299,221.02587,320,0,5,"",3e-07,">",4.5,-1,"","",{"B-n"},{0},{"="},{0},8327,357,"","",3360,499,7315,298,"","",763,299,4792,422,6860,499,10820,298,14530,499,13508,422,6564,499}
,{221,84,19773.755,19.561,7684.481,0.089,2991.027,24.039,221.021228,21,0,132,"",42,"",4.5,1,"","",{},{},{},{},9050.24,25.17,15083,401,5109,299,5302.33,20.38,-11184,401,-2673.31,24.04,3561.02,26.38,8334,299,6809.94,20.1,14202,197,11421.77,33.35,9967,299}
,{221,85,16782.727,13.972,7694.475,0.063,2311.308,15.096,221.018017,15,0,138,"",12,"",1.5,-1,"","",{"B-"},{0},{"="},{0},9755.98,14.34,14078,196,5627.85,22.55,3505.44,14.8,-11325,298,-1900.67,14.09,5664.34,19.76,5769.7,22.55,2259.62,52.32,14812.17,21.12,13289.88,14.11,9213.09,30.41}
,{221,86,14471.42,5.714,7701.393,0.026,1194.13,7.231,221.015535709,6.134,0,1542,"",30,"",3.5,1,"","",{"B-","A"},{0,22,0},{"=","="},{0,22,0},10500.62,5.9,12787.88,16.83,6162.99,3.19,1507.61,7.31,-8081.01,18.6,-5082.22,6.91,4211.97,5.81,7193.3,15.1,-2468.95,9.95,14786.15,6.42,11237.31,12.89,11760.92,5.85}
,{221,87,13277.29,4.886,7703.256,0.022,313.479,6.386,221.014253757,5.245,0,288.06,"",0.3,"",2.5,-1,"","",{"A","B-","14C"},{0,0.0048,0,8.8,0},{"~","=","="},{0,0.0048,0,8.8,0},11483.11,8.43,11696.73,5.55,6457.74,1.4,-1245.82,50.65,-8387.43,14.8,-5064.27,9.53,6276.35,6.22,4623.76,5,-7099,51.51,15158.69,4.9,12924,5.3,10825.53,12.53}
,{221,88,12963.811,4.63,7701.135,0.021,-1559.298,50.603,221.013917224,4.97,0,28,"",2,"",2.5,1,"","",{"A","14C"},{0,1.2,0},{"=","="},{0,1.2,0},12573.1,9.34,10443.53,5,6880.39,1.95,-3976.56,9.26,-4937.24,4.86,-8851.19,7.45,5377.75,9.32,5807.48,5.98,-11556.18,51.32,15056.85,8.32,10768.75,6.37,13392.87,4.85}
,{221,89,14523.109,50.425,7690.539,0.228,-2417.261,51.056,221.015591199,54.133,0,0.052,"",0.002,"",4.5,-1,"","",{"A"},{0},{"="},{0},13189.01,71.34,8672.6,50.9,7783.6,50,-5853.18,71.91,-4248.18,50.57,-8217.31,55.06,7291.89,50.76,3036.11,51.07,-15327,207,15839.63,51.07,12735.99,51.62,13110.39,50.61}
,{221,90,16940.371,8.166,7676.061,0.037,-3435.918,51.915,221.018186236,8.766,0,0.00178,"",3e-05,"",3.5,1,"","",{"A"},{0},{"="},{0},13673.65,51.21,7031.85,11.5,8625.8,3.85,-7579.62,51.76,-618.85,11.49,-11349,52,5800.05,23.57,4092.28,10.08,"","",16081.7,51.13,10960.82,51.37,15935.6,13.75}
,{221,91,20376.288,51.281,7656.974,0.232,-4143.707,72.404,221.021874846,55.052,0,5.9e-06,"",1.7e-06,"",4.5,-1,"","",{"A"},{0},{"="},{0},14306.48,72.69,5771.13,71.96,9247.7,50,-9473,207,-656.36,51.63,-10628,113,7913,72,1581.78,55.86,"","",16615.7,72.02,12873.6,52.35,15179.08,72.13}
,{221,92,24519.995,51.114,7634.684,0.231,-5330,207,221.026323299,54.873,0,6.6e-07,"",1.4e-07,"",4.5,1,"","",{"A"},{0},{"~"},{0},14909.21,72.05,4529.34,71.91,9889.3,50,"","",2561.93,55.71,-13862,202,6485,113,2987,72,"","",16690.67,72.57,10700.28,54.3,17799.66,52.18}
,{221,93,29850,200,7607,1,"","",221.032045,215,0,3e-08,"","s","",4.5,-1,"","",{},{},{},{},15750,219,3268,207,10356,201,"","",2342,207,"","",8532,280,372,224,"","",17274,207,12819,201,16812,201}
,{222,83,28729,300,7649,1,6243,303,222.030842,322,0,2,"",3e-07,">",1,-1,"","",{"B-n"},{0},{"="},{0},8232,423,"","",3124,500,7776,300,"","",884,301,3440,423,"","",12351,300,15771,500,13315,500,"",""}
,{222,84,22486.265,40.054,7674.005,0.18,1533.239,43.071,222.02414,43,0,546,"",432,"",0,1,"","",{},{},{},{},8919.83,43.79,15761,403,4608,301,6114.06,40.1,"","",-2367.78,42.42,5358.81,44.58,8900,301,8166.08,40.3,12378,301,11068,200,7854,403}
,{222,85,20953.026,15.835,7677.387,0.071,4580.82,15.955,222.022494,17,0,54,"",10,"",0,0,"","",{"B-"},{0},{"="},{0},9565.36,21.12,14444,298,5312.07,31.31,4574.92,17.5,-10434,298,-1589.71,16.83,3901.02,21.12,6109.7,25.17,4331.55,16.66,16400.37,23.75,13135.72,22.39,10317,196}
,{222,86,16372.206,1.95,7694.497,0.009,-5.9,7.703,222.017576286,2.093,0,330177.6,"",17.28,"",0,1,"","",{"A"},{0},{"="},{0},10382.51,1.93,13469.2,17.81,5590.39,0.31,2052.02,4.71,-10690.52,19.66,-4976.4,5.06,6170.53,5.84,7699.49,14.11,-830.91,12.41,12707.26,14.11,10840.18,3.5,9337.25,15.95}
,{222,87,16378.105,7.452,7690.947,0.034,2057.917,8.682,222.01758262,8,0,852,"",18,"",2,-1,"","",{"B-"},{0},{"="},{0},11246.85,8.47,12575.58,15.84,5855.03,13.79,-243.37,9.07,-7693.59,15.84,-4657.02,8.77,4970.5,8.91,5382.29,9.39,-5776,73,16476.83,7.67,12412.76,7.74,11628.43,8.12}
,{222,88,14320.188,4.454,7696.692,0.02,-2301.285,6.637,222.015373355,4.781,0,33.6,"",0.4,"",0,1,"","",{"A","14C"},{0,3,0},{"=","="},{0,3,0},12092.69,9.27,10869.83,4.61,6677.93,4.23,-2882.92,12.99,-7440.2,7.17,-8274.24,50.6,6714.94,6.23,6246.07,6.5,-9952.64,52.18,13548.67,5.85,10566.48,8.23,11137.19,4.8}
,{222,89,16621.474,5.174,7682.802,0.023,-581.637,13.228,222.017843887,5.554,0,5,"",0.5,"",1,-1,"","",{"A","B+"},{0,1,""},{"=","="},{0,1,""},13264.84,7.79,9438.79,6.41,7137.44,2.04,-5533,73,-3944.79,7.04,-8390.21,9.53,5972.95,50.65,3631.31,6.69,-14397,196,17062.03,9.59,12091.25,9.61,13650.11,8.64}
,{222,90,17203.111,12.279,7676.658,0.055,-4951,74,222.0184683,13.182,0,0.00224,"",3e-05,"",0,1,"","",{"A","EC"},{0,1.3,0},{"=","<"},{0,1.3,0},13608.62,25.29,7645.08,14.7,8127.03,5.09,-7069.72,53.42,-3049.67,13.03,-11244.49,52.72,7808.58,14.66,4608.97,51.87,"","",14170.23,13.63,10497.69,51.94,13455.23,14.71}
,{222,91,22155,72,7651,0,-2118,89,222.023784,78,0,0.0032,"",0.0003,"",0,0,"","",{"A"},{0},{"="},{0},14206,89,6167,73,8886,52,-8864,209,343,88,-10437,89,6293,89,2075,73,"","",18196,76,12547,88,16232,88}
,{222,92,24272.827,51.994,7637.764,0.234,-6746,202,222.026057953,55.817,0,4.7e-06,"",7e-07,"",0,1,"","",{"A","B+"},{0,1,0},{"=","<"},{0,1,0},14803,113,4974.21,56.52,9481.17,50.92,"","",43.49,52.63,-13648,207,8318.49,72.91,3392.43,73.03,"","",14765,73,10596.75,73.19,15447.84,72.53}
,{222,93,31019,196,7604,1,"","",222.0333,210,0,7e-07,"","s","",1,-1,"","",{},{},{},{},15435,277,3778,202,9910,196,"","",3353,202,"","",6902,280,790,202,"","",18796,220,12596,202,18125,202}
,{223,83,32137,401,7636,2,5058,446,223.0345,430,0,1,"",3e-07,">",4.5,-1,"","",{"B-n"},{0},{"="},{0},8104,499,"","","","",8709,401,"","",1579,403,4664,500,"","",13754,401,"","",13331,566,"",""}
,{223,84,27079,196,7655,1,3651,196,223.02907,210,0,60,"",3e-07,">",4.5,1,"","",{},{},{},{},8838,197,"","",4375,446,6689,196,"","",-1946,196,3479,200,8940,358,9845,196,13692,357,11124,357,9056,446}
,{223,85,23428.006,13.972,7668.055,0.063,3038.267,16.013,223.025151,15,0,50,"",7,"",1.5,-1,"","",{"B-","A"},{0,"",""},{"~",""},{0,"",""},9497.36,19.76,15248,298,4721,196,5045.61,14.11,-12590,300,-1015.52,14.11,5596.34,21.12,6347.23,42.42,5602.12,15.68,14365.06,24.04,13028.6,22.55,8256,298}
,{223,86,20389.739,7.822,7678.171,0.035,2007.344,8.057,223.021889285,8.397,0,1458,"",24,"",0,0,"","",{"B-","A"},{0,"",""},{"=",""},{0,"",""},10224.32,9.69,13961.96,21.07,5283.46,17.66,3156.43,8.1,-9385.5,40.81,-4059.68,10.8,4053.78,8.06,7852.26,17.66,1003.91,12.09,14317.82,16.01,10878.05,16.01,10772.68,19.35}
,{223,87,18382.394,1.932,7683.664,0.009,1149.085,0.848,223.019734313,2.073,0,1320,"",4.2,"",1.5,-1,"","",{"B-","A"},{0,0.006,0},{"~","="},{0,0.006,0},11037.53,4.83,12978.27,14.11,5561.4,2.82,556.51,7.13,-9859.6,15.95,-4009.11,4.73,6067.03,7.7,5278.78,2.27,-3938.28,71.09,14621.78,5.84,12634.37,2.12,9653.05,14.11}
,{223,88,17233.309,2.09,7685.309,0.009,-592.573,7.128,223.018500719,2.244,0,988217.28,"",190.08,"",1.5,1,"","",{"A","14C"},{0,8.9,0},{"=","="},{0,8.9,0},11873.14,5,11816.05,5.89,5978.99,0.21,-2152.52,9.42,-6427.87,2.41,-7459.48,5.53,5158.2,4.79,6433.77,7.74,-8603.7,71.15,14666.83,4.9,10615.04,4.39,12267.63,2.26}
,{223,89,17825.882,7.11,7679.143,0.032,-1559.948,11.563,223.019136872,7.632,0,126,"",3,"",2.5,-1,"","",{"A","EC"},{0,1,0},{"=","="},{0,1,0},12839.86,50.91,10029.35,8.49,6783.2,1,-4494.79,71.41,-5841.19,10.3,-7448.55,14.13,6866.91,8.69,3783.28,8.29,-12774,196,15572.88,8.38,12419.69,10.8,11989.96,8.07}
,{223,90,19385.831,9.212,7668.64,0.041,-2934.845,71.639,223.020811546,9.889,0,0.6,"",0.02,"",0,0,"","",{"A"},{0},{"="},{0},13697.17,12.2,8155.92,10.19,7566.63,4.08,-6451.18,71.7,-2223.33,10.14,-10840,73,5888.6,15.27,4524.61,10.44,"","",15573.53,51.23,10506.2,10.95,14761.99,12.25}
,{223,91,22320.676,71.063,7651.971,0.319,-3516.33,100.506,223.023962232,76.289,0,0.0051,"",0.0003,"",4.5,-1,"","",{"A","B+"},{0,"",""},{"=",""},{0,"",""},14198.25,87.63,6780.37,87.11,8326.28,50,-8279,208,-1589.77,71.23,-10023.47,88.05,7905,102,2171.41,72.1,"","",16091.11,71.51,12515.63,74.42,14223.39,71.3}
,{223,92,25837.006,71.119,7632.694,0.319,-4763,208,223.027737168,76.349,0,2.1e-05,"",8e-06,"",3.5,1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},14825.62,87.58,5681.31,71.57,8940.7,50,"","",1344.92,72.15,-13253,208,6507.14,88.1,3607,102,"","",16171.52,87.67,10483,88,16814.31,74.48}
,{223,93,30600,196,7608,1,"","",223.03285,210,0,1e-06,"","s","",4.5,-1,"","",{},{},{},{},15393,280,4355,202,9635,202,"","",1156,209,"","",8490,277,962,202,"","",16790,202,12530,220,16028,202}
,{224,83,36830,400,7617,2,6920,445,224.039539,429,0,0.3,"",3e-07,">",1,-1,"","",{"B-n"},{0},{"="},{0},8041,500,"","","","",9119,400,"","",1680,445,3378,566,"","",15082,400,"","","","","",""}
,{224,84,29910,196,7644,1,2199,197,224.03211,210,0,60,"",3e-07,">",0,1,"","",{},{},{},{},8719,200,"","",3816,446,7465,196,"","",-1589,196,5240,277,9515,446,11084,196,11892,358,10677,357,"",""}
,{224,85,27711.015,22.356,7650.735,0.1,5265.917,24.415,224.029749,24,0,150,"",90,"",0,0,"","",{},{},{},{},9384.65,27.4,15596,301,4467,299,5962.4,24.99,-11714,401,-750.04,23.68,3788.31,26.36,6656,197,7476.88,22.73,15935.56,45.87,12801.32,29.71,9260,299}
,{224,86,22445.098,9.814,7670.751,0.044,696.482,14.875,224.024095804,10.536,0,6420,"",180,"",0,1,"","",{"B-"},{0},{"="},{0},10069.74,10.01,14619.11,41.24,4756.72,20.24,3619.18,9.98,-11922,196,-4008.61,10,6015.96,12.55,8271.88,17.07,2451.36,14.1,12202.88,18.63,10526.43,17.07,8317.74,21.89}
,{224,87,21748.616,11.178,7670.367,0.05,2922.699,11.324,224.0233481,12,0,199.8,"",6,"",1,-1,"","",{"B-"},{0},{"="},{0},10772.12,13.43,13782.35,19.38,4947.95,17.89,1514.48,11.9,-8968.36,17.89,-3556.01,11.37,4705.1,11.34,5930.09,13.64,-2113.66,13.51,16087.22,11.35,12141.25,12.55,10612.29,17.89}
,{224,88,18825.917,1.813,7679.922,0.008,-1408.219,4.087,224.020210453,1.945,0,313796.16,"",198.72,"",0,1,"","",{"A","14C"},{0,4,0},{"=","="},{0,4,0},11636.91,4.61,12124.23,1.93,5788.92,0.15,-1167.82,10.23,-8852.79,8.03,-7071.28,7.22,6478.71,2.26,6845.45,2.11,-6896.34,23.22,13158.62,7.67,10412.68,5,10000.9,5.81}
,{224,89,20234.135,4.089,7670.143,0.018,240.401,10.823,224.021722239,4.389,0,10008,"",576,"",0,-1,"","",{"B+","A","B-"},{0,9.4,0,"",""},{"=","=",""},{0,9.4,0,"",""},12529.97,6.45,10721.91,8.5,6326.9,0.7,-3628.14,8.51,-5437.23,4.37,-7223.01,9.98,5663.06,8.1,4288.14,4.44,-11642,196,16624.75,5.89,12134.38,6.02,12603.25,6.26}
,{224,90,19993.734,10.12,7667.724,0.045,-3868.544,12.546,224.021464157,10.864,0,1.04,"",0.02,"",0,1,"","",{"A"},{0},{"="},{0},13352.01,15.83,8904.4,10.97,7298.57,5.88,-5728.52,25.23,-4528.55,10.31,-10398.26,71.76,7463.41,13.59,5121.12,12.3,"","",14083.07,11.25,10334.68,51.41,12676.32,11.02}
,{224,91,23862.278,7.587,7646.961,0.034,-1859.974,24.329,224.02561721,8.145,0,0.846,"",0.02,"",5,-1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},14435,73,7337.14,8.98,7693.68,4.47,-8013,196,-1252.57,10.31,-10046.04,71.5,6529.71,71.44,2812.52,11.83,"","",17369.97,14.34,11785.96,11.03,14985.57,50.96}
,{224,92,25722.252,23.171,7635.165,0.103,-6153,197,224.027613974,24.875,0,0.000396,"",1.7e-05,"",0,1,"","",{"A","B+"},{0,1.2,0},{"=","<"},{0,1.2,0},14693.21,56.92,6058.8,26.17,8628.24,6.75,"","",-952.55,24.88,-12949,197,8186.07,74.78,3887.39,74.73,"","",14278,76,10210.02,56.26,14428.28,24.51}
,{224,93,31876,196,7604,1,"","",224.03422,210,0,0.0001,"","s","",1,-1,"","",{},{},{},{},15286,277,4857,209,9232,202,"","",2266,208,"","",6795,277,1250,208,"","",18314,202,12220,202,17146,202}
,{225,84,34530,298,7626,1,4136,422,225.03707,320,0,20,"",3e-07,">",4.5,1,"","",{},{},{},{},8691,357,"","","","",7996,298,"","",-1252,299,3451,357,9589,499,12537,298,13105,499,10665,423,"",""}
,{225,85,30395,298,7641,1,3861,298,225.03263,320,0,120,"",3e-07,">",0.5,1,"","",{},{},{},{},9176,298,16320,499,3872,422,6574,298,-13725,499,-122,298,5388,299,6805,357,8757,298,14027,357,12772,301,7312,423}
,{225,86,26534.141,11.14,7654.357,0.05,2713.531,16.349,225.028485574,11.958,0,279.6,"",2.4,"",3.5,-1,"","",{"B-"},{0},{"="},{0},9998.23,13.61,15122,196,4335.47,22.51,4541.03,11.44,-10665,196,-3285.79,15.78,3982.27,14.85,8465.84,24.98,4224.01,12.25,13816.94,17.87,10445.17,19.36,9694.28,41.57}
,{225,87,23820.61,11.967,7662.94,0.053,1827.501,12.158,225.025572478,12.847,0,237,"",8.4,"",1.5,-1,"","",{"B-"},{0},{"="},{0},10704.42,12.11,14185.34,18.4,4612.97,18.4,2183.26,12.85,-11179.38,25.36,-3076.62,12.09,5999.32,16.38,5913.46,15.48,-520.11,72.01,14141.68,14.3,12312.46,12.11,8513.99,19.85}
,{225,88,21993.109,2.596,7667.586,0.012,355.763,5.007,225.023610574,2.787,0,1287360,"",17280,"",0.5,1,"","",{"B-"},{0},{"="},{0},11382.83,2.97,12974.57,8.24,5096.77,5.09,-317.02,5.65,-7740.96,10.15,-6312.34,4.72,4904.12,2.79,7044.48,11.48,-5386.81,11.2,14321.52,2.86,10479.06,7.89,11267.3,2.86}
,{225,89,21637.346,4.758,7665.69,0.021,-672.781,6.658,225.023228647,5.107,0,857088,"",259.2,"",1.5,-1,"","",{"A","14C"},{0,4.5,0},{"=","="},{0,4.5,0},12331.17,8.41,11322.99,4.69,5935.14,1.43,-2703.38,71.16,-7400.24,12.15,-6427.71,11.14,6668.11,6.16,4477.54,4.87,-9950.36,71.78,15114.84,4.76,12181.21,6.4,10905.64,8.84}
,{225,90,22310.127,5.093,7659.222,0.023,-2030.598,71.17,225.023950907,5.467,0,525,"",2.4,"",1.5,1,"","",{"A","EC"},{0,10,0},{"~","~"},{0,10,0},13218.34,10.41,9501.12,5.43,6921.4,2.12,-5069.79,11.94,-3804.76,5.3,-9623.47,8.95,5754.92,11.22,5212.98,6.38,"","",15195.05,8.64,10552.71,7.02,13636.34,6.58}
,{225,91,24340.725,71.012,7646.72,0.316,-3039.196,71.827,225.026130844,76.234,0,1.7,"",0.2,"",2.5,-1,"","",{"A"},{0},{"="},{0},14122.59,100.44,8063.1,71.35,7392.7,50,-7246.98,100.85,-3182.38,71.12,-9452.84,74.68,7592.87,71.39,2941.98,71.71,"","",15665.7,71.59,12001.67,72.05,13365.65,71.17}
,{225,92,27379.921,10.909,7629.736,0.048,-4207.783,72.44,225.029393555,11.711,0,0.061,"",0.004,"",2.5,1,"","",{"A"},{0},{"="},{0},14599.72,71.93,6583.85,14.19,8014.63,7.23,"","",97.22,14.79,-12567,196,6413.65,25.56,3771.33,13.19,"","",15770.05,71.88,10089,73,15823.21,16.35}
,{225,93,31587.704,71.622,7607.557,0.318,"","",225.033910797,76.889,0,0.006,"",0.005,"",4.5,-1,"","",{"A"},{0},{"="},{0},15155,208,5310.91,100.89,8786.5,50,"","",436.46,72.01,"","",8359,208,1423.52,75.27,"","",16461.5,100.93,12178.93,88.5,15080,102}
,{226,84,37549,401,7614,2,2934,499,226.04031,430,0,20,"",3e-07,">",0,1,"","",{},{},{},{},8504,446,"","","","",8801,401,"","",-917,499,5053,499,"","",13881,401,11429,566,10276,566,"",""}
,{226,85,34614,298,7624,1,5867,298,226.03716,320,0,20,"",3e-07,">",0,0,"","",{"B-n"},{0},{"="},{0},9239,299,16794,499,3460,423,7094,298,"","",9,298,3852,422,7205,422,10305,298,15415,357,12400,357,8124,499}
,{226,86,28747.192,10.477,7646.41,0.046,1226.653,12.19,226.030861382,11.247,0,444,"",6,"",0,1,"","",{"B-"},{0},{"="},{0},9840.54,14.36,15741,196,3836.01,41.4,5079.37,10.65,-13072,298,-3144.73,15.91,5858.27,15.29,8936,298,5549.56,11.4,11746.98,24.69,10183.24,17.46,7315,196}
,{226,87,27520.539,6.23,7648.376,0.028,3852.715,6.523,226.029544515,6.688,0,49,"",1,"",1,-1,"","",{"B-"},{0},{"="},{0},10370.71,12.8,14768.42,23.21,4142.6,17.02,3211.28,6.96,-10163,298,-2543.89,6.75,4371.39,13.49,6302.57,12.76,1487.26,13.01,15786.25,11.62,11994.86,10,9738.94,15.3}
,{226,88,23667.824,1.933,7661.962,0.009,-641.44,3.274,226.025408455,2.075,0,50491081600,"",220898482,"",0,1,"","",{"A","14C"},{0,2.6,0},{"=","="},{0,2.6,0},11300.73,1.91,13355.21,10,4870.7,0.25,470.19,4.73,-10155.29,11.31,-6040.84,4.93,6396.6,2.85,7441.76,12.11,-3661.05,13.12,12630.01,11.34,10149.48,2.25,8924.49,8.06}
,{226,89,24309.264,3.1,7655.662,0.014,1111.63,4.563,226.026097069,3.328,0,105732,"",432,"",0,0,"","",{"B-","EC","A"},{0,17,0,0.006,0},{"=","=","="},{0,17,0,0.006,0},12067.51,4.96,12017.29,11.6,5506.24,8.07,-1724.01,11.79,-6800.32,12.35,-6072.18,5.88,5399.4,5.5,4972.82,3.77,-8468,88,16194.15,3.13,11940.01,3.43,11573.27,3.34}
,{226,90,23197.634,4.481,7657.119,0.02,-2835.642,12.165,226.024903686,4.81,0,1842,"",1.8,"",0,1,"","",{"A","18O"},{0,3.2,0},{"=","<"},{0,3.2,0},12938.73,10.99,10206.22,4.63,6452.53,1.01,-4131.24,13.68,-6084.45,5.06,-9214.41,71.14,7183.81,6.61,5728.68,6.42,"","",13674.3,5.91,10235.81,8.31,11610.73,4.81}
,{226,91,26033.276,11.42,7641.11,0.051,-1295.593,17.228,226.027947872,12.259,0,108,"",12,"",0,0,"","",{"A","B+"},{0,26,0},{"=","="},{0,26,0},13971.64,13.57,8778.8,12.05,6986.89,10.18,-6744,89,-2893.04,12.33,-9417.96,15.71,6378.77,71.9,3565.82,12.37,"","",16750.35,15.17,11511.5,14.58,13853.8,13.39}
,{226,92,27328.869,12.999,7631.916,0.058,-5448,89,226.029338749,13.955,0,0.269,"",0.006,"",0,1,"","",{"A"},{0},{"="},{0},14536.02,26.52,7242.81,16.39,7700.84,4.27,"","",-2270.23,13.87,-12330.15,72.78,8122.37,16.89,4300.83,72.17,"","",14177.4,14.97,9872.25,72.22,13589.44,15.85}
,{226,93,32777,88,7604,0,"","",226.035188,95,0,0.035,"",0.01,"",0,0,"","",{"A","B+"},{0,"",""},{"=",""},{0,"",""},15241,215,5663,88,8197.51,50,"","",1147,113,"","",6882,114,1892,89,"","",17766,91,11804,113,16103,113}
,{227,84,42281,401,7596,2,4797,499,227.04539,430,0,5,"",3e-07,">",4.5,1,"","",{},{},{},{},8393,499,"","","","",9395,401,"","",-405,499,3339,566,"","",15103,401,"","",10314,566,"",""}
,{227,85,37483,298,7613,1,4597,298,227.04024,320,0,20,"",3e-07,">",0.5,1,"","",{"B-n"},{""},{""},{""},9054,422,"","",2922,499,7801,298,"","",665,298,5202,422,7354,499,11634,298,13664,422,12437,357,6299,499}
,{227,86,32885.834,14.091,7630.05,0.062,3203.388,15.276,227.035304396,15.127,0,20.2,"",0.4,"",0,0,"","",{"B-"},{0},{"="},{0},9790.94,17.96,16223,298,3382,196,5708.12,14.23,-11952,401,-2706.02,15.41,3932.68,17.56,9017,298,7081.01,14.24,13202,298,10038.87,26.43,8622,196}
,{227,87,29682.445,5.898,7640.715,0.026,2504.734,6.213,227.031865417,6.332,0,148.2,"",1.8,"",0.5,1,"","",{"B-"},{0},{"="},{0},10280.8,13.34,15290,298,3829.52,15.17,3832.87,6.21,-12221,298,-2056.7,6.21,5909.41,8.58,6353.72,12.02,2851.25,9.48,13859.11,12.6,12101.4,11.45,7617.83,23.12}
,{227,88,27177.711,1.952,7648.303,0.009,1328.132,2.265,227.029176474,2.095,0,2532,"",30,"",1.5,1,"","",{"B-"},{0},{"="},{0},10958.03,2.87,13934.37,11.31,4363.06,8.06,1372.89,2.41,-8858.45,10.66,-5202.87,3.29,4561.43,0.27,7631.8,6.53,-1867.75,9.87,14067.91,12.11,10293.15,11.35,10379.02,10.01}
,{227,89,25849.58,1.927,7650.707,0.008,44.757,0.83,227.027750666,2.068,0,687057392.872,"",94670.778,"",1.5,-1,"","",{"B-","A"},{0,1.38,0},{"=","="},{0,1.38,0},11930.4,4.69,12548.97,12.11,5042.27,0.14,-981.62,7.43,-8959.93,6.52,-5419.37,4.75,6531,3.34,5107.22,2.25,-6712.5,72.53,14567.28,2.85,11887.72,2.11,9747.37,11.34}
,{227,90,25804.823,2.088,7647.458,0.009,-1026.375,7.437,227.027702618,2.241,0,1615420.8,"",604.8,"",0.5,1,"","",{"A"},{0},{"="},{0},12647.94,5.43,10766.23,2.97,6146.6,0.1,-3240.64,9.9,-5151.97,2.39,-8299.77,11.59,5464.13,4.81,5793.41,3.43,-10965,100,14878.28,4.76,10434.74,4.44,12625.31,2.26}
,{227,91,26831.198,7.42,7639.49,0.033,-2214.264,12.146,227.028804477,7.965,0,2298,"",18,"",2.5,-1,"","",{"A","EC"},{0,15,0},{"=","="},{0,15,0},13652.16,71.39,9384.09,8.68,6580.4,2.12,-5730.88,72.87,-4767.04,7.95,-8568.99,14.91,7273.4,13.56,3655.41,8.58,"","",15231.88,8.9,11701.52,12.48,12243.46,8.37}
,{227,92,29045.462,9.705,7626.289,0.043,-3516.618,73.135,227.031181587,10.419,0,66,"",6,"",1.5,1,"","",{"A","B+"},{0,"",""},{"=",""},{0,"",""},14477.09,14.51,7842.61,10.85,7234.72,3.05,-7724,100,-1441.14,10.61,-11803,89,6354.72,16.14,4276.78,14.9,"","",15415.54,71.65,10047.24,12.21,14698.13,13.93}
,{227,93,32562.08,72.506,7607.351,0.319,-4208,123,227.034956832,77.838,0,0.51,"",0.06,"",2.5,-1,"","",{"A","B+"},{0,"",""},{"~",""},{0,"",""},15168.26,101.91,6356.59,101.47,7816.49,14.4,"","",-760.17,73.38,"","",8286,114,2055.76,73.64,"","",15892.96,73.3,11703.88,76.1,14346.2,72.88}
,{227,94,36770,100,7585,0,"","",227.039474,107,0,0.02,"","s","",2.5,1,"","",{},{},{},{},"","",5188,100,8508,122,"","",2152,101,"","","","",3296,133,"","",15893,123,9758,220,16694,102}
,{228,85,41684,401,7597,2,6441,401,228.04475,430,0,5,"",3e-07,">",0,0,"","",{"B-n"},{""},{""},{""},9073,499,"","",2429,566,8300,401,"","",727,401,3870,499,7885,566,12790,401,14847,566,12018,499,"",""}
,{228,86,35243.465,17.677,7621.645,0.078,1859.244,18.916,228.037835418,18.977,0,65,"",2,"",0,1,"","",{"B-"},{0},{"="},{0},9646.36,20.55,16883,401,2908,196,6303.2,17.79,-14326,401,-2510.3,18.64,5713.69,22.61,9529,299,8472.48,17.77,11340,299,9713,299,6359,299}
,{228,87,33384.221,6.732,7626.368,0.03,4443.953,7.021,228.035839437,7.226,0,38,"",1,"",2,-1,"","",{"B-"},{0},{"="},{0},10278.95,9.17,15808,298,3248.29,23.35,4489.49,7.05,-11388,298,-1864.81,7.01,4369.54,8.95,6790.58,15.62,4460.63,8.01,15347.83,12.45,11714.13,13.02,8636,298}
,{228,88,28940.268,1.996,7642.428,0.009,45.54,0.634,228.031068657,2.142,0,181452324.5,"",946707.78,"",0,1,"","",{"B-"},{0},{"="},{0},10870.19,2.32,14384.87,10.67,4070.25,10.02,2169.28,2.57,-11234.54,14.23,-4980.63,2.34,6308.76,2.34,8031.15,6.23,-281.96,14.49,12130.53,6.54,9983.71,12.12,8052.53,11.32}
,{228,89,28894.728,2.094,7639.196,0.009,2123.743,2.645,228.031019767,2.247,0,22140,"",72,"",3,1,"","",{"B-"},{0},{"="},{0},11557.17,3.45,13203.75,6.57,4721.2,11.37,-28.86,4.78,-8076.69,6.26,-4981.41,2.56,5026.17,2.42,5571.95,2.42,-4700.97,50.61,15937.71,2.41,11765.67,2.95,10720.52,12.13}
,{228,90,26770.984,1.807,7645.08,0.008,-2152.602,4.34,228.028739835,1.94,0,60349465.2824,"",25245.5408,"",0,1,"","",{"A","20O"},{0,1.13,0},{"=","="},{0,1.13,0},12569.28,4.63,11474.78,1.9,5520.15,0.22,-2451.24,14.43,-7695.7,1.92,-8131.53,7.53,7105.16,2.25,6367.57,2.1,-9316.39,29.18,13172.53,3.12,9997.69,4.86,10424.28,2.79}
,{228,91,28923.586,4.34,7632.207,0.019,-298.64,14.929,228.031050748,4.659,0,79200,"",3600,"",3,1,"","",{"B+","A"},{0,1.85,0},{"=","="},{0,1.85,0},13252.32,12.14,9963.62,5.17,6264.54,1.46,-4672.11,50.74,-4214.96,4.6,-8193.19,10.54,5978.93,8.5,4170.21,4.67,"","",16436.76,6.09,11477.51,6.55,12932.64,6.33}
,{228,92,29222.226,14.354,7627.466,0.063,-4373.468,52.545,228.031371351,15.409,0,546,"",12,"",0,1,"","",{"A","EC"},{0,5,0},{">","<"},{0,5,0},14249.28,19.3,8553.35,14.98,6803.58,10.18,-6865.14,32.45,-3871.57,14.49,-11411.17,73.9,7894.55,17.25,4897.94,16.1,"","",13899.76,18.27,9745.56,72.43,12558.5,15.15}
,{228,93,33595.694,50.572,7604.853,0.222,-2491.677,58.346,228.036066462,54.291,0,61.4,"",1.4,"",0,0,"","",{"EC","A","B+SF"},{0,40,0,0.012,0},{"=","=","="},{0,40,0,0.012,0},15324,102,7015.52,51.81,7308.5,50,"","",-524.47,51.1,-11245,112,7037.7,88.38,2738.74,51.47,"","",16977.63,52.19,11079.83,51.71,14901.37,87.16}
,{228,94,36087.37,29.143,7590.493,0.128,"","",228.038741387,31.286,0,2.1,"",1.3,"",0,1,"","",{"A","B+"},{0,7,0},{"~","<"},{0,7,0},"","",5819.44,31.87,7940.2,17.68,"","",-247.06,30.67,"","",8754,104,3763.68,78.13,"","",14021,93,9363.72,77.32,14353.85,31.08}
,{229,85,44823,401,7585,2,5461,401,229.04812,430,0,5,"",3e-07,">",0.5,1,"","",{"B-n"},{0},{"="},{0},8802,499,"","","","",9155,401,"","",1509,401,4932,566,"","",14134,401,13254,566,12139,566,"",""}
,{229,86,39362.4,13.041,7605.622,0.057,3694.138,13.967,229.042257276,14,0,11.9,"",1.3,"",2.5,1,"","",{},{},{},{},9666.07,19.2,17496,401,2407,298,6800.44,20.21,"","",-2093.14,14.68,3952.38,21.97,9611,401,9776.82,13.26,12590,298,9612,298,7460,401}
,{229,87,35668.262,5.001,7618.337,0.022,3106.298,16.231,229.038291455,5.368,0,50.2,"",0.4,"",0.5,1,"","",{"B-"},{0},{"="},{0},10156.82,7.73,16393,298,2849,298,4978.33,13.1,-13305,401,-1343.32,5.35,5787.28,8.39,6864.17,18.37,5771.35,5.96,13493.23,14.95,11785.12,11.61,6700,298}
,{229,88,32561.963,15.441,7628.485,0.067,1872.03,19.623,229.034956707,16.576,0,240,"",12,"",2.5,1,"","",{"B-"},{0},{"="},{0},10758.38,15.56,14901.81,20.9,3602.91,19.04,2976.38,15.63,-9970.47,23.47,-4404.08,15.58,4449.62,15.57,8111.23,16.84,1351.41,16.54,13590.32,16.53,9905.48,16.65,9461.17,18.66}
,{229,89,30689.933,12.109,7633.244,0.053,1104.35,12.346,229.032947,13,0,3762,"",30,"",1.5,1,"","",{"B-"},{0},{"="},{0},11302.28,12.26,13570.45,13.47,4444.41,17.02,793.03,12.55,-9983.26,13.85,-4152.37,12.24,6276.11,12.29,5539.31,12.27,-3089.74,87.69,14223.03,12.27,11886.16,12.26,8815.79,13.62}
,{229,90,29585.583,2.405,7634.65,0.011,-311.325,3.715,229.031761431,2.581,0,249930853920,"",536467742,"",2.5,1,"","",{"A"},{0},{"="},{0},12361.87,2.8,12170.07,2.69,5167.56,1.02,-1624.97,6.35,-6643.66,2.71,-7409.32,4.84,5256.72,2.61,6598.12,2.78,-7810.01,51.23,14446.81,2.68,10140.37,3.64,11564.16,2.68}
,{229,91,29896.908,3.28,7629.874,0.014,-1313.646,6.655,229.032095652,3.521,0,129600,"",4320,"",2.5,1,"","",{"EC","A"},{0,0.48,0},{"~","="},{0,0.48,0},13076.92,7.94,10530.61,2.96,5834.65,4.26,-3882.77,86.91,-6286.79,3.6,-7396.64,14.7,7098,5.31,4163.05,3.39,-12253.11,87.41,14802.89,3.08,11563.33,5.43,11234.05,4.27}
,{229,92,31210.554,5.938,7620.721,0.026,-2569.122,87.031,229.033505909,6.374,0,3468,"",30,"",1.5,1,"","",{"B+","A"},{0,20,0},{"~","~"},{0,20,0},13977.54,11.27,9172.21,6.23,6475.51,3.05,-6185.04,51.5,-2849.4,6.12,-10456.46,50.89,6082.99,15.45,5002,7.22,"","",15090.16,9.41,10041.33,12.74,13659.32,7.28}
,{229,93,33779.675,86.848,7606.086,0.379,-3615.915,100.792,229.036263974,93.235,0,240,"",10.8,"",2.5,1,"","",{"A"},{""},{"="},{""},14925.04,113.12,7629.46,87.15,7014.03,50,-8370.34,123.17,-2432.88,86.95,-10379.01,91.59,7887.34,100.48,2731.52,88.01,"","",15445.02,87.37,11314.86,87.8,13392.8,87.57}
,{229,94,37395.59,51.176,7586.88,0.223,-4754.43,101.23,229.040145819,54.939,0,91,"",26,"",1.5,1,"","",{"A","B+","SF"},{"",50,"",7,0},{"=","=","<"},{"",50,"",7,0},15517,112,6227.81,52.06,7590.75,50,"","",884.39,53.13,"","",6763.1,58.87,3489.07,71.93,"","",15544.32,88.73,9483,102,15713.12,52.78}
,{229,95,42150.02,87.348,7562.702,0.381,"","",229.045249909,93.772,0,1.8,"",1.5,"",2.5,-1,"","",{"A"},{0},{"~"},{0},"","",4990,113.52,8137.4,50,"","",1265.36,100.93,"","","","",1226.32,92.08,"","",16091,133,"","",15019,124}
,{230,86,42048,196,7596,1,2561,196,230.04514,210,0,10,"",3e-07,">",0,1,"","",{},{},{},{},9338,196,"","",2074,446,7531,196,"","",-1692,196,5386,196,10065,446,11185,196,11074,446,9428,357,5414,446}
,{230,87,39486.768,6.541,7603.704,0.028,4970.462,12.198,230.042390791,7.022,0,19.1,"",0.5,"",0,0,"","",{"B-"},{0},{"="},{0},10040.09,9.39,16776,401,2448,298,5648.39,17.13,-12626,401,-1146.51,16.77,4252.81,8.23,7164.6,14.59,7313.16,7.21,14954.11,18.85,11464.99,15.54,7650,298}
,{230,88,34516.306,10.296,7621.914,0.045,677.924,18.888,230.03705478,11.053,0,5580,"",120,"",0,1,"","",{"B-"},{0},{"="},{0},10566.6,10.49,15305.1,20.46,3344.2,14.69,3653.71,10.37,-12135.06,16.62,-4244.94,15.89,6116.97,18.56,8440.93,11.45,2901.3,11.24,11842.89,12.3,9697.92,11.87,7276.87,17.45}
,{230,89,33838.383,15.835,7621.46,0.069,2975.789,15.882,230.036327,17,0,122,"",3,"",1,1,"","",{"B-","B-SF"},{0,1.2,0},{"=","="},{0,1.2,0},11198.98,15.97,14123.78,17.21,3892.93,17.02,1664.78,16.12,-9118.85,16.61,-3818.52,16.02,4922.87,19.93,6012.55,22.12,-1397.91,53.68,15608.92,15.96,11524.73,15.96,9802.34,16.9}
,{230,90,30862.593,1.21,7630.996,0.005,-1311.014,2.833,230.033132358,1.299,0,2379392220400,"",9467077800,"",0,1,"","",{"A","SF","24Ne"},{0,4,0,5.8,0},{"=","<","="},{0,4,0,5.8,0},12051.03,1.14,12655.62,1.76,4769.85,1.52,-752.41,4.51,-8988.34,15.49,-7105.63,3.14,6794.31,2.21,7116.31,12.17,-6071.8,14.85,12678.67,1.87,9877.07,1.66,9331.28,1.54}
,{230,91,32173.607,3.038,7621.895,0.013,558.605,4.592,230.034539789,3.261,0,1503360,"",43200,"",2,-1,"","",{"B+","B-","A"},{0,7.8,0,0.0032,0},{"=","=","="},{0,7.8,0,0.0032,0},12892.61,5.13,11299.06,3.39,5439.43,0.71,-3062.68,51.37,-5805.3,12.48,-7108.26,6.59,5794.62,4.22,4700.95,3.59,-10758,133,16113.43,3.06,11232.84,3.37,11970.43,3.28}
,{230,92,31615.002,4.509,7620.922,0.02,-3621.29,51.461,230.033940102,4.841,0,1747872,"",1728,"",0,1,"","",{"A","22Ne","SF"},{0,4.8,0,1.4,0},{"=","=","<"},{0,4.8,0,1.4,0},13749.86,14.99,9733.92,4.65,5992.45,0.5,-5319.39,15.44,-5259.55,4.99,-10235.99,86.95,7666.87,7.29,5570.88,5.46,"","",13402.22,6.11,9647.86,8.59,11456.58,4.84}
,{230,93,35236.291,51.288,7601.776,0.223,-1698.101,53.363,230.037827716,55.059,0,276,"",18,"",0,0,"","",{"B+","A"},{0,3,0},{"<",">"},{0,3,0},14502.04,72,8265.24,51.45,6778.1,50,-7696,143,-1949.59,51.39,-10230.62,72.44,6614.7,100.84,3263.23,51.6,"","",16724.87,53.23,11054.88,52.17,14051.5,51.8}
,{230,94,36934.392,14.824,7590.991,0.064,-5998,134,230.039650703,15.913,0,102,"",10.2,"",0,1,"","",{"A"},{0},{"~"},{0},15295.61,32.66,6865.77,20.57,7180.61,7.12,"","",-1565.13,15.89,-13286.94,88.59,8532.52,53.26,4134.25,88.09,"","",14049.5,52.68,9236.37,73.99,13535.33,17.64}
,{230,95,42932,133,7562,1,"","",230.046089,143,0,40,"",16,"",0,0,"","",{"B+","B+SF","SF"},{0,"","","",""},{"~","",""},{0,"","","",""},"","",5242,143,7730,100,"","",1863,159,"","",7289,159,1753,143,"","",17555,136,11026,166,16016,152}
,{231,86,46454,298,7579,1,4373,298,231.04987,320,0,0.3,"",3e-07,">",0.5,1,"","",{},{},{},{},9051,298,"","",1748,499,8237,298,"","",-1104,298,3665,357,"","",12638,298,12341,499,9633,499,"",""}
,{231,87,42080.575,7.731,7594.5,0.033,3864.089,13.749,231.045175357,8.3,0,17.6,"",0.6,"",0.5,1,"","",{"B-"},{0},{"="},{0},9730.32,9.21,17321,401,2172,298,6317.73,15.16,"","",-507.05,12.88,5477.51,10.13,7256,196,8656.17,7.93,13428.98,15.16,11701.16,19.29,6043,401}
,{231,88,38216.486,11.37,7607.841,0.049,2453.636,17.301,231.041027086,12.206,0,104,"",1,"",2.5,1,"","",{"B-"},{0},{"="},{0},10488.11,19.18,15723.86,17.3,2905.74,18.11,4400.59,11.43,-11120,196,-3693.21,19.49,4371.14,15.34,8559.25,13.12,4410.47,11.68,13259.03,12.42,9696.32,13.21,8619.42,21.02}
,{231,89,35762.849,13.041,7615.076,0.056,1946.959,13.098,231.038393,14,0,450,"",6,"",0.5,1,"","",{"B-"},{0},{"="},{0},11069.72,17.8,14483.35,13.97,3655.49,14.31,2338.45,13.16,-11012.89,14.59,-3171.06,13.1,6146.85,20.51,6042.43,16.62,138.34,52.2,13911.69,20.21,11686.64,13.19,8025.03,14.68}
,{231,90,33815.891,1.218,7620.118,0.005,391.487,1.46,231.036302853,1.308,0,91872,"",36,"",2.5,1,"","",{"B-","A"},{0,4,0},{"=","="},{0,4,0},11912.33,2.21,13324.01,15.49,4213.26,1.55,9.88,2.48,-7989.39,10.37,-6429.03,2.84,5118.02,0.2,7311.46,15.88,-4493.11,22.57,13836.76,12.17,9785.22,1.87,10522.02,1.76}
,{231,91,33424.404,1.772,7618.426,0.008,-381.611,2.033,231.035882575,1.902,0,1033804895760,"",3471261860,"",1.5,-1,"","",{"A","SF ","24Ne","23F"},{0,3,0,13.4,0,9.9,0},{"=","<","=","="},{0,3,0,13.4,0,9.9,0},12615.14,2.85,11843.47,12.24,5149.91,0.83,-2200.11,50.55,-7702.95,15.93,-6261.91,4.71,6820.52,3.18,4727.16,1.46,-8986,300,14549.63,2.57,11517.47,1.95,10176.08,2.29}
,{231,92,33806.015,2.67,7613.387,0.012,-1818.498,50.577,231.036292252,2.866,0,362880,"",8640,"",0,0,"","",{"EC","A"},{0,0.004,0},{"~","="},{0,0.004,0},13547.17,6.45,10357.51,3.26,5576.28,1.66,-4502.99,22.69,-4345.55,2.49,-9501.59,51.35,5880.3,5.12,5656.56,3.76,-13464,300,14619.91,3.5,9746.48,4.96,12681.43,2.8}
,{231,93,35624.513,50.547,7602.128,0.219,-2684.492,55.333,231.03824449,54.264,0,2928,"",12,"",0,0,"","",{"B+","A"},{0,2,""},{"=","="},{0,2,""},14297.8,100.48,8850.34,50.63,6368.4,50,-6785,304,-3838.06,50.62,-9381.2,52.66,7683.1,72,3279.46,50.73,"","",15124.77,50.88,11266.34,52.53,12347.33,50.72}
,{231,94,38309.005,22.549,7587.12,0.098,-4101,301,231.04112641,24.206,0,516,"",30,"",1.5,1,"","",{"B+","A"},{0,13,0},{"=","="},{0,13,0},15229.22,55.9,7479.49,23.26,6838.63,20.35,-8961,301,-594.97,22.96,-12694,135,6696.7,26.94,4216.26,56,"","",15240.14,89.71,9577.37,55.35,14733.18,26.68}
,{231,95,42410,300,7566,1,-4860,424,231.045529,322,0,60,"","s","",2.5,-1,"","",{},{},{},{},15883,312,5948,312,7423,309,"","",-115,304,"","",8593,328,1813,300,"","",15725,304,11187,301,14461,304}
,{231,96,47270,300,7542,1,"","",231.050746,322,0,20,"","s","",1.5,1,"","",{},{},{},{},"","",4704,304,8075,316,"","",3046,300,"","","","",2951,328,"","",15830,312,"","",16829,301}
,{232,87,46072.834,13.972,7579.347,0.06,5575.88,16.702,232.049461224,15,0,5.5,"",0.6,"",0,0,"","",{"B-","B-SF"},{0,2,0},{"=","<"},{0,2,0},9556.57,15.43,"","",1964,401,6918.41,19.11,"","",-214.97,18.01,4079.06,15.97,7670,298,10126.2,15.93,14736,196,11574.49,19.11,6896,401}
,{232,88,40496.953,9.151,7600.009,0.039,1342.534,15.931,232.04347527,9.823,0,240,"",18,"",0,1,"","",{"B-"},{0},{"="},{0},10161.99,13.78,16129,196,2828.57,19.91,5050.17,9.26,-13246,298,-3337.21,15.93,5790.85,14.59,8872.59,11.98,5887.42,9.33,11720.99,11.25,9692.75,10.43,6780.96,15.93}
,{232,89,39154.419,13.041,7602.424,0.056,3707.635,13.118,232.042034,14,0,118.8,"",4.8,"",1,1,"","",{"B-"},{0},{"="},{0},10826.6,20.51,14910.29,14.59,3345.28,14.68,3207.79,15.12,-10215.13,15.16,-2732.79,13.1,4679.75,18.44,6351.04,17.3,1795,101,15348.92,16.62,11456.51,20.21,9132.56,13.97}
,{232,90,35446.784,1.422,7615.033,0.006,-499.85,7.734,232.038053689,1.526,0,4.41796964e+17,"",3.1556926e+15,"",0,1,"","",{"A","SF","24Ne+26Ne"},{0,1.1,0,2.78,0},{"=","=","<"},{0,1.1,0,2.78,0},11558.44,1.06,13647.46,10.39,4081.6,1.4,837.25,2.15,-10058.67,11.46,-6048.94,1.7,6440.42,1.07,7605.04,13.12,-2916.36,17.65,12319.21,15.9,9620.91,12.19,8531.22,15.51}
,{232,91,35946.633,7.645,7609.506,0.033,1337.103,7.428,232.0385903,8.207,0,114048,"",1728,"",2,-1,"","",{"B-","EC"},{0,0.003,0},{"~","="},{0,0.003,0},12369.61,8.03,12469.69,17.58,4626.99,7.89,-1413,100,-7105.19,15.12,-5930.7,7.94,5549.09,7.68,5158.23,7.52,-7393,300,15794.85,7.52,11225.11,7.87,10903.1,14.32}
,{232,92,34609.53,1.809,7611.897,0.008,-2750,100,232.03715486,1.942,0,2174272201.4,"",12622770.4,"",0,1,"","",{"A","24Ne","SF","28Mg"},{0,8.9,0,2.7,0,5,0},{"=","=","=","<"},{0,8.9,0,2.7,0,5,0},13148.11,4.66,10831,1.15,5413.63,0.09,-3753.61,17.66,-6495.33,1.17,-9086.3,50.56,7267.8,2.8,6103.84,1.95,-11703,202,13146.73,3.06,9576.68,3.4,10670.35,2.61}
,{232,93,37360,100,7597,0,-1004,102,232.040107,107,0,882,"",18,"",4,1,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},14019,112,9392,100,6011,100,-5980,316,-3354,100,-9021,103,6336,112,3735,100,"","",16455,100,11013,100,13109,100}
,{232,94,38363.14,17.595,7588.974,0.076,-4976,300,232.041184526,18.888,0,2022,"",30,"",0,1,"","",{"EC","A"},{0,11,0},{"=","="},{0,11,0},14713.89,22.95,7829.8,18.11,6716,10.18,-7949,203,-2731.85,17.78,-12118,300,8017.18,28.55,4550.34,53.51,"","",13837.65,54.2,9447.52,88.6,12798.99,18.5}
,{232,95,43340,300,7564,1,-2973,362,232.046527,322,0,78.6,"",2.4,"",1,-1,"","",{"B+","A","B+SF"},{"",3,0,0.069,0},{"","=","="},{"",3,0,0.069,0},15735,328,6475,304,7319,304,"","",426,304,-12001,424,7142,424,2258,301,"","",17116,300,10808,304,15206,312}
,{232,96,46312,202,7548,1,"","",232.049718,217,0,10,"","s","",0,1,"","",{},{},{},{},"","",5200,203,7800,200,"","",714,203,"","",9029,362,3387,362,"","",14091,242,9026,220,14563,208}
,{233,87,48920.051,19.561,7569.239,0.084,4585.991,21.369,233.052517838,21,0,0.9,"",0.1,"",0.5,1,"","",{"B-","B-n"},{0,0,0},{"=","="},{0,0,0},9303.16,21.03,"","",1672,401,7612.02,23.51,"","",351.78,21.6,5224.1,24.04,"","",11430.58,19.61,13177,299,11736,197,"",""}
,{233,88,44334.06,8.603,7585.564,0.037,3026.027,15.623,233.047594573,9.235,0,30,"",5,"",0.5,1,"","",{"B-"},{0},{"="},{0},10025.06,14.26,16697,298,2546.74,15.62,5602.35,8.72,"","",-2891.68,15.62,4234.21,12.56,9027.74,16.41,7414.88,8.89,12964.29,11.57,9711.35,10.81,7933,196}
,{233,89,41308.033,13.041,7595.193,0.056,2576.318,13.118,233.044346,14,0,145,"",10,"",0.5,1,"","",{"B-"},{0},{"="},{0},10597.45,18.44,15350.48,15.16,3214.86,13.97,3818.56,13.11,-12053.77,19.11,-2210.07,13.12,5917.7,18.44,6477.89,15.93,3359.44,52.62,13802.35,17.3,11655.78,16.62,7467.67,14.59}
,{233,90,38731.715,1.425,7602.893,0.006,1242.243,1.122,233.041580208,1.529,0,1309.8,"",2.4,"",0,0,"","",{"B-"},{0},{"="},{0},11226.81,1.07,14062.71,11.46,3744.84,15.51,1812.54,2.16,-9054.21,9.26,-5286.24,7.73,4786.39,0.09,7711.67,13.12,-1320.05,50.37,13679.67,13.12,9757.39,15.9,9861.81,10.39}
,{233,91,37489.472,1.336,7604.866,0.006,570.296,1.975,233.040246605,1.434,0,2330640,"",1123.2,"",1.5,-1,"","",{"B-"},{0},{"="},{0},12077.57,1.66,12851.32,13.11,4374.62,12.18,-459.12,50.98,-8953.92,13.11,-5191.38,1.81,6528.48,7.64,5246.28,1.12,-5774,102,14384.39,1.03,11490.93,1.03,9297.49,15.89}
,{233,92,36919.176,2.255,7603.956,0.01,-1029.415,51.005,233.039634367,2.42,0,5023862619200,"",6311385200,"",2.5,1,"","",{"A","SF","24Ne","28Mg"},{0,6,0,7.2,0,1.3,0},{"=","<","=","<"},{0,6,0,7.2,0,1.3,0},13029.47,3.16,11474.66,2.06,4908.68,1.18,-3132.59,50.4,-5816.58,2.16,-8512,100,5761.67,2.49,6316.43,7.83,-10374.83,71.58,14205.58,2.44,9609.62,3.49,11702.98,2.05}
,{233,93,37948.59,50.981,7596.181,0.219,-2103.179,71.642,233.040739489,54.729,0,2172,"",6,"",2.5,1,"","",{"B+","A"},{0,0.0007,0},{"~","="},{0,0.0007,0},13818.56,71.77,10053.75,50.95,5626.77,50.87,-5315,114,-5287.01,51.53,-8485.87,53.93,7482,112,3949.91,50.99,-14912,230,14853.38,51,11197.64,51.17,11421.38,51.05}
,{233,94,40051.769,50.351,7583.796,0.216,-3211,113,233.042997345,54.054,0,1254,"",24,"",2.5,1,"","",{"B+","A"},{0,0.12,0},{"~","="},{0,0.12,0},14399.87,55.15,8332.19,50.41,6416.3,50,-7242.24,87.47,-1846.73,50.37,-11359,304,6382.69,53.31,4597,112,"","",15138.06,71.33,9679.53,71.85,14083.17,50.53}
,{233,95,43263,102,7567,0,-4031,124,233.046445,109,0,192,"",48,"",2.5,-1,"","",{"A"},{0},{"="},{0},15289,317,6939,114,7059,53,-9598,246,-1385,143,-11120,226,8148,317,2389,103,"","",15665,104,11193,103,13673,114}
,{233,96,47294.006,71.547,7545.998,0.307,-5567,235,233.050772206,76.809,0,27,"",10,"",1.5,1,"","",{"A","B+"},{"",80,""},{"=","="},{"",80,""},16118,308,5592.94,75,7473.5,50,"","",1641.9,73.66,"","",7090,214,3335,308,"","",15595,308,9226,151,16006.02,73.05}
,{233,97,52861,224,7519,1,"","",233.056748,240,0,40,"",30,"",0,0,"","",{"A"},{0},{"~"},{0},"","",4127,374,8286,206,"","",2232,374,"","","","",740,302,"","",16302,374,"","",15575,261}
,{234,88,46930.629,8.383,7576.543,0.036,2089.439,16.294,234.050382104,9,0,30,"",10,"",0,1,"","",{"B-","B-SF"},{0,1,0},{"=","<"},{0,1,0},9708.96,12.41,"","",2458,196,6317.62,8.77,"","",-2448.72,15.5,5474.75,12.01,9278.39,21.28,8785.6,8.46,11568.6,16.29,9714.11,11.4,6123,298}
,{234,89,44841.19,13.972,7582.129,0.06,4228.181,14.21,234.048139,15,0,45,"",2,"",1,1,"","",{"B-"},{0},{"="},{0},10455.86,19.11,15809.58,19.76,2929.51,15.43,4502.27,14.56,-11367.83,24.04,-1961.84,14.04,4538.16,19.11,6781.84,16.41,4886.32,16.3,15055.04,16.7,11488.76,18.01,8407.02,15.97}
,{234,90,40613.009,2.589,7596.855,0.011,274.088,3.172,234.04359986,2.779,0,2082240,"",2592,"",0,1,"","",{"B-","A"},{0,1,0},{"=","<"},{0,1,0},10976.41,2.57,14461.89,9.51,3671.79,10.62,2467.98,2.44,-11010.02,8.98,-4947.78,2.53,6190.02,2.57,7983.99,13.3,263.04,7.21,12169.4,13.3,9714.21,13.3,8042.93,11.66}
,{234,91,40338.921,4.094,7594.683,0.017,2193.896,4,234.043305615,4.395,0,24120,"",180,"",4,1,"","",{"B-","SF"},{0,3,0},{"=","<"},{0,3,0},11750.35,8.58,13393.44,13.67,4075.62,16.36,384.05,9.23,-8258.08,13.67,-4651.57,4.45,5221.87,4.06,5681.76,4.08,-4122,159,15602.94,4.08,11387.09,4.05,10222.47,13.67}
,{234,92,38145.025,1.13,7600.715,0.005,-1809.846,8.321,234.04095037,1.213,0,7747225333000,"",18934155600,"",0,1,"","",{"A","SF","28Mg","24Ne+26Ne"},{0,1.64,0,1.4,0,9,0},{"=","=","=","="},{0,1.64,0,1.4,0,9,0},12607.14,1.57,11879.7,0.92,4857.52,0.68,-2204.95,6.81,-7875.66,0.93,-7874.88,50.97,6845.47,2,6633.42,0.82,-8579.61,17.42,12909.2,7.59,9584.68,1.48,9975.54,0.69}
,{234,93,39954.871,8.397,7589.637,0.036,-395.1,10.752,234.04289332,9.014,0,380160,"",8640,"",0,1,"","",{"B+"},{0},{"="},{0},13547,100,10569.7,11.26,5356.35,8.81,-4506,159,-4823.57,8.36,-8168.22,51.04,6065.04,51.65,4253.27,8.56,-13501,143,16056.15,8.47,11012.91,8.69,12176.87,8.45}
,{234,94,40349.971,6.798,7584.605,0.029,-4111,159,234.043317478,7.298,0,31680,"",360,"",0,1,"","",{"EC","A"},{0,6,0},{"~","~"},{0,6,0},14155.8,18.81,8837.5,6.9,6310.05,5.09,-6374.66,18.63,-3858.18,7.08,-10985,102,7773.12,50.78,4887.59,51.42,"","",13701,100,9589.51,50.99,12190.36,7.22}
,{234,95,44461,159,7564,1,-2263,159,234.047731,170,0,139.2,"",4.8,"",0,0,"","",{"B+","A","B+SF"},{0,0.039,0,0.0066,0},{"~","=","="},{0,0.039,0,0.0066,0},15021,339,7476,187,6800,150,-8994,213,-776,167,-10904,174,6873,188,2880,166,"","",16809,159,11016,160,14483,166}
,{234,96,46724.633,17.394,7550.677,0.074,-6731,143,234.050160959,18.673,0,52,"",9,"",0,1,"","",{"B+","A","SF"},{0,27,0,2,0},{"~","~","~"},{0,27,0,2,0},15730,203,6216.45,24.69,7365.33,9.1,"","",-616.11,53.25,-14208,225,8640.69,73.61,3828,103,"","",14096,300,9179,300,14062.03,28.43}
,{234,97,53455,142,7519,1,"","",234.057387,153,0,20,"",5,"",0,0,"","",{"A","B+"},{0,20,0},{">","<"},{0,20,0},"","",4462,332,8098.6,50,"","",2903,175,"","",7477,265,1128,159,"","",17854,247,11050,332,16692,332}
,{235,88,51130,300,7561,1,3773,300,235.05489,322,0,3,"","s","",2.5,1,"","",{},{},{},{},9347,300,"","",2251,423,7112,300,"","",-1783,300,3872,300,"","",10211,300,12920,301,9921,300,"",""}
,{235,89,47357.155,13.972,7573.504,0.059,3339.406,19.113,235.05084,15,0,62,"",4,"",0.5,1,"","",{},{},{},{},10093.51,19.11,16140.84,24.04,2851.66,15.97,5068.26,19.76,"","",-1327.17,14.21,5555.35,19.76,6862.44,16.29,6314.05,14.04,13733.9,16.41,11724.26,16.7,6930.72,19.76}
,{235,90,44017.749,13.041,7584.385,0.055,1728.853,19.113,235.047255,14,0,432,"",6,"",0.5,1,"","",{"B-"},{0},{"="},{0},10856.6,13.12,14894.25,15.62,3376.35,17.3,3098.9,13.09,-10201.85,15.5,-4392.49,13.67,4666.58,13.3,8112.41,19.11,1835.34,24.31,13420.52,18.44,9727.39,18.44,9167.2,15.93}
,{235,91,42288.896,13.972,7588.413,0.059,1370.05,14.017,235.045399,15,0,1464,"",12,"",1.5,-1,"","",{"B-"},{0},{"="},{0},11343.21,14.04,13597.08,19.11,4101.13,19.11,1245.79,14.04,-9841.26,19.76,-3927.45,14.02,6121.34,14.56,5613.08,14.21,-2336.53,54.03,14267.99,14.04,11706.17,14.04,8780.88,19.11}
,{235,92,40918.846,1.117,7590.914,0.005,-124.262,0.852,235.04392819,1.199,0,2.2216075904e+16,"",31556926000000,"",3.5,-1,"","",{"A","SF","20Ne","25Ne","28Mg"},{0,7,0,8,0,8,0,8,0},{"=","=","=","~","="},{0,7,0,8,0,8,0,8,0},12142.96,2,12390.81,0.91,4678.04,0.69,-1263.56,20.5,-6983.13,2.43,-7107.34,8.32,5297.5,0.23,6709.05,3.99,-7115,201,14140.18,0.8,9836.27,7.6,11118.46,0.9}
,{235,93,41043.108,1.389,7587.056,0.006,-1139.302,20.499,235.044061591,1.491,0,34223040,"",103680,"",2.5,1,"","",{"EC","A"},{0,0.0026,0},{"~","="},{0,0.0026,0},13048.12,50.97,11024.3,1.17,5193.79,1.47,-3582.32,52.2,-6584.78,4.08,-7378.18,6.86,6983.08,8.37,4390.89,0.88,-11661,401,14834.74,2.16,11297.63,1.76,10742.88,7.63}
,{235,94,42182.41,20.521,7578.879,0.087,-2443.019,56.045,235.045284682,22.03,0,1518,"",30,"",2.5,1,"","",{"B+","A"},{0,0.0028,0},{"~","="},{0,0.0028,0},14011.99,54.37,9314.71,20.59,5951.48,20.35,-5852,202,-3251.59,20.5,-10350,160,6238.88,21.59,5061.43,22.12,"","",14944.63,54.9,9687,102,13219.28,20.54}
,{235,95,44625.429,52.192,7565.154,0.222,-3408,208,235.047907371,56.03,0,618,"",36,"",2.5,-1,"","",{"B+","A"},{0,0.4,0},{"~","="},{0,0.4,0},14780,114,7901.1,72.94,6576,13,-8079,404,-2618.41,52.85,-10170.52,55,7907,167,3013.51,52.62,"","",15284.47,72.51,11126.34,55.06,12912,113}
,{235,96,48034,201,7547,1,-4670,448,235.051567,216,0,300,"","s","",2.5,1,"","",{},{},{},{},15403,214,6596,207,7300,200,"","",395,201,-13493,246,6762,202,3716,256,"","",15481,225,9558,361,15317,202}
,{235,97,52704,401,7524,2,"","",235.05658,430,0,60,"","s","",0,0,"","",{},{},{},{},16300,459,5137,413,7869,500,"","",954,431,"","",8823,425,1310,401,"","",16121,407,11256,449,15011,500}
,{236,89,51220.992,38.191,7559.242,0.162,4965.795,40.667,236.054988,41,0,270,"",216,"",0,0,"","",{},{},{},{},9762.83,40.67,"","",2723.24,40.67,5887.04,40.67,"","",-868.07,40.36,4207.48,40.67,7198,302,7842.81,63.25,15001.17,39.1,11750.99,39.15,7947.34,42.91}
,{236,90,46255.198,13.972,7576.968,0.059,921.248,19.76,236.049657,15,0,2238,"",90,"",0,1,"","",{"B-"},{0},{"="},{0},10500.45,14.21,15253.37,16.29,3333.33,16.7,3810.55,14.02,-12163,300,-4105.02,19.76,5833.87,19.11,8390.93,19.76,3353.61,14.09,12124.81,19.76,9811.22,19.11,7567.54,16.41}
,{236,91,45333.95,13.972,7577.557,0.059,2889.306,14.017,236.048668,15,0,546,"",6,"",0,0,"","",{"B-","B-SF"},{0,6,0},{"=","="},{0,6,0},11147.6,14.56,14085.18,19.76,3754.62,19.11,1955.77,52.32,-9312.18,19.76,-3656.21,14.02,5026.26,19.76,5972.77,19.11,-707,113,15431.75,14.21,11466.29,14.04,9672.32,19.11}
,{236,92,42444.644,1.113,7586.484,0.005,-933.534,50.415,236.045566201,1.194,0,7.3906320692e+14,"",946707780000,"",0,1,"","",{"A","SF"},{0,9.4,0},{"=","="},{0,9.4,0},11843.02,0.33,12746.31,2.42,4572.94,0.87,-456.95,1.63,-8862.08,13.09,-6669.78,0.89,6545.52,0.26,7133.22,14.02,-5410.4,18.34,12816.53,3.99,9819.23,0.77,9359.33,0.88}
,{236,93,43378.178,50.421,7579.214,0.214,476.585,50.389,236.046568392,54.129,0,4828209678000,"",157784630000,"",6,-1,"","",{"EC","B-","A"},{0,13.5,0,0.16,0},{"=","=","="},{0,13.5,0,0.16,0},12719.33,51.1,11538.68,50.57,5006.63,50.93,-2662,123,-6199.69,52.32,-6875.55,54.41,5736.25,50.42,4829.64,50.41,-10164,404,15943.96,50.41,11323.06,50.45,11535.11,50.42}
,{236,94,42901.593,1.811,7577.918,0.008,-3139,112,236.046056756,1.944,0,90189694.508,"",252455.408,"",0,1,"","",{"A","SF","28Mg"},{0,1.9,0,2,0},{"=","=","="},{0,1.9,0,2,0},13591.01,6.9,9821.37,1.58,5867.15,0.08,-4953.45,18.38,-5306.22,1.59,-9795.15,52.21,7352.13,20.54,5430.49,1.76,"","",13657.53,8.47,9817.06,50.99,11628.82,2.49}
,{236,95,46041,112,7561,0,-1814,113,236.049427,120,0,216,"",6,"",5,-1,"","",{"B+","A"},{"",4,0},{"","="},{"",4,0},14563,194,8492,112,6256.2,50,-7502,416,-2291,112,-10065,230,6656,123,3431,114,"","",16401,112,10853,123,13738,123}
,{236,96,47855.045,18.315,7550.299,0.078,-5687,401,236.051374506,19.662,0,408,"",48,"",0,1,"","",{"B+","A","SF"},{0,18,0,0.1,0},{"=","=","<"},{0,18,0,0.1,0},15012.22,25.21,7072.87,19.49,7066.99,5.09,"","",-1616.34,27.5,-12920,401,8250,202,4059.35,55.3,"","",14105,160,9456,103,13449.68,53.56}
,{236,97,53542,401,7523,2,"","",236.05748,430,0,120,"","s","",0,0,"","",{},{},{},{},16056,425,5497,431,7778,500,"","",1628,404,"","",7233,566,1781,448,"","",17528,401,11112,407,15925,413}
,{237,89,54020,400,7550,2,4065,400,237.057993,429,0,240,"","s","",0.5,1,"","",{},{},{},{},9480,400,"","",2675,400,6493,400,"","",-306,400,5272,401,"","",9148,400,13601,500,11954,400,"",""}
,{237,90,49955.092,15.835,7563.443,0.067,2427.473,20.514,237.053629,17,0,288,"",30,"",2.5,1,"","",{"B-"},{0},{"="},{0},10205.29,20.51,15753,300,3196.12,18.02,4564.9,15.88,"","",-3450.18,21.12,4371.42,21.12,8554.87,41.34,4863.37,15.93,13308.74,21.12,9977.96,21.12,8670.86,17.92}
,{237,91,47527.619,13.041,7570.384,0.055,2137.425,13.096,237.051023,14,0,522,"",12,"",0.5,1,"","",{"B-"},{0},{"="},{0},10903.91,19.11,14407.48,19.11,3794.67,18.44,2655.96,13.09,-10982.34,40.36,-2988.34,13.09,5877.65,19.11,6016.55,19.11,958,61,14220.68,18.44,11778.66,13.3,8332.83,19.11}
,{237,92,45390.194,1.203,7576.102,0.005,518.534,0.52,237.04872838,1.291,0,583372.8,"",172.8,"",0.5,1,"","",{"B-"},{0},{"="},{0},11671.29,0.53,13205.5,13.1,4233.56,0.99,298.47,1.38,-8153.97,14.02,-6059.3,50.42,5125.77,0.46,7232.73,14.02,-3856.89,70.97,13812.1,14.02,9915.33,4.02,10423.59,2.46}
,{237,93,44871.659,1.12,7574.989,0.005,-220.063,1.294,237.04817171,1.202,0,67658049344000,"",220898482000,"",2.5,1,"","",{"A","SF","30Mg"},{0,2,0,4,0},{"=","<","<"},{0,2,0,4,0},12314.08,0.91,11995.18,14.02,4957.27,0.74,-1698,59,-7751.26,14.02,-6101.25,1.64,6577.84,50.42,4861.95,0.25,-8316,224,14663.62,0.33,11590.69,0.39,10179.14,3.99}
,{237,94,45091.722,1.697,7570.759,0.007,-1478,59,237.048407957,1.822,0,3943296,"",3456,"",3.5,-1,"","",{"EC","A"},{0,0.0042,0},{"~","="},{0,0.0042,0},13233.32,20.54,10405.07,1.32,5747.63,2.26,-4155.36,70.98,-4641.89,1.31,-9020,112,5881.19,2.08,5575.43,50.43,-12847.2,87.3,14759.42,1.57,10000.91,8.43,12593.1,1.34}
,{237,95,46570,59,7561,0,-2677,93,237.049995,64,0,4416,"",48,"",0,0,"","",{"B+","A"},{0,0.025,0},{"~","="},{0,0.025,0},14198,79,9051,59,6196,30,-6618,232,-4097,78,-9357,62,7542,127,3621,59,"","",15098,63,11084,60,12261,60}
,{237,96,49247.085,70.96,7546.624,0.299,-3941,235,237.052868923,76.178,0,1200,"","s","",2.5,1,"","",{"A"},{0},{"="},{0},14929,213,7513.27,73.86,6770.4,50,-8691.84,112.48,-943.48,70.97,-12367,407,6679.28,73.27,4083,132,"","",15332.46,88.08,9650,174,14543.52,71.27}
,{237,97,53188,224,7527,1,-4751,241,237.0571,241,0,120,"","s","",1.5,-1,"","",{},{},{},{},15658,459,6015,230,7500,200,"","",-141,251,"","",8425,459,1956,225,"","",15865,301,11328,225,14373,275}
,{237,98,57938.921,87.287,7503.347,0.368,"","",237.062199993,93.706,0,0.8,"",0.2,"",2.5,1,"","",{"A","SF"},{"",30,""},{"=","="},{"",30,""},"","",4673,219,8220,50,"","",2794.91,89.17,"","","","",2892,410,"","",15946,410,9348,167,16860.69,88.99}
,{238,90,52525,283,7555,1,1631,284,238.056388,304,0,564,"",120,"",0,1,"","",{"B-"},{0},{"="},{0},9873,284,"","",3169,283,5217,283,"","",-3074,284,5501,284,8784,490,6362,283,12015,286,10032,284,7042,413}
,{238,91,50894.038,15.835,7558.344,0.067,3586.255,15.906,238.054637,17,0,136.8,"",5.4,"",3,-1,"","",{"B-","B-SF"},{0,2.6,0},{"=","<"},{0,2.6,0},10582.55,21.12,14904.9,41.34,3627.93,21.12,3439.38,15.88,-10415,400,-2567.47,15.88,4704.9,20.51,6350.02,22.39,2472.55,53.12,15349.65,21.12,11740.34,20.51,9183.28,21.12}
,{238,92,47307.783,1.493,7570.125,0.006,-146.874,1.201,238.050786996,1.602,0,1.40996345368e+17,"",1.89341556e+14,"",0,1,"","",{"A","SF","2B-"},{0,5.45,0,2.2,0},{"=","=","="},{0,5.45,0,2.2,0},11279.5,1.18,13525.36,14.05,4269.86,2.12,1144.57,1.22,-9936.28,15.91,-5635.19,1.18,6153.73,1.26,7508.81,13.13,-2137.4,12.29,12684.64,14.05,9882.94,14.05,8936.44,13.13}
,{238,93,47454.656,1.138,7566.221,0.005,1291.443,0.457,238.050944671,1.221,0,181353.6,"",172.8,"",2,1,"","",{"B-"},{0},{"="},{0},12066.16,50.42,12457.23,14.02,4690.82,4,-966.83,50.69,-7361.93,13.09,-5708.38,1.31,5488.32,0.2,5224.51,0.56,-6761,255,15720.82,0.32,11399.87,0.39,10812.16,14.02}
,{238,94,46163.213,1.139,7568.36,0.005,-2258.273,50.688,238.04955825,1.222,0,2767542410.2,"",3155692.6,"",0,1,"","",{"A","SF","32Si","28Mg+30Mg"},{0,1.9,0,1.4,0,6,0},{"=","=","~","~"},{0,1.9,0,1.4,0,6,0},12881.01,1.59,10859.37,0.36,5593.27,0.19,-3281.97,12.24,-6515.95,0.58,-8478,59,6999.83,1.35,5997.42,0.41,-11114,298,13495.84,50.41,9984.16,0.89,10890.77,0.28}
,{238,95,48421.487,50.7,7555.584,0.213,-1023.701,52.145,238.051982607,54.428,0,5880,"",120,"",1,1,"","",{"B+","A"},{0,1,0},{"=","="},{0,1,0},13762,123,9534.63,71.49,6041.7,50,-5795,260,-3739.14,50.69,-8896.92,87.21,6220,78,3959.21,50.71,"","",16230.7,50.71,11103.13,54.68,13024.78,50.7}
,{238,96,49445.188,12.234,7547.996,0.051,-4771,255,238.053081595,13.133,0,7920,"",1440,"",0,1,"","",{"A","SF"},{0,0.048,0},{"=","="},{0,0.048,0},14552.49,21.98,8034.35,12.29,6670.3,10.17,-7832,298,-2935.51,12.31,-11814,225,7873.21,71.99,4414,61,"","",14115,112,9683.81,53.59,12909.18,23.86}
,{238,97,54216,255,7525,1,-3061,392,238.058203,274,0,144,"",4.8,"",0,0,"","",{"B+","B+SF"},{0,0.048,0},{"~","="},{0,0.048,0},15469,475,6402,279,7330,200,"","",357,262,-11794,270,7043,340,2320,265,"","",17072,256,11046,325,15237,260}
,{238,98,57278,298,7509,1,"","",238.06149,320,0,0.0211,"",0.0013,"",0,1,"","",{"SF","A"},{0,0.2,0},{"~","~"},{0,0.2,0},"","",5155,299,8128,299,"","",742,306,"","",8733,311,3200,373,"","",14446,499,9438,499,14890,360}
,{239,90,56450,400,7541,2,3113,445,239.060602,429,0,120,"","s","",3.5,1,"","",{},{},{},{},9647,400,"","",2896,500,5878,400,"","",-2515,400,4146,490,"","",7862,400,13141,565,10093,401,"",""}
,{239,91,53337,196,7550,1,2765,196,239.05726,210,0,6480,"",1800,"",0,0,"","",{"B-"},{0},{"="},{0},10333,196,15261,445,3555,196,4026,196,"","",-2042,196,5628,196,6477,344,3947,196,14093,196,11946,196,7763,199}
,{239,92,50572.718,1.503,7558.561,0.006,1261.661,1.493,239.054292048,1.613,0,1407,"",1.2,"",2.5,1,"","",{"B-"},{0},{"="},{0},10960.11,1.27,13960.32,15.91,4130.05,13.13,1984.44,1.2,-9241,283,-4953.26,1.21,4806.38,0.17,7610.29,15.91,-574.31,54.05,13755.91,13.13,10102.82,14.05,9963.92,14.05}
,{239,93,49311.057,1.311,7560.567,0.005,722.774,0.93,239.052937599,1.407,0,203558.4,"",259.2,"",2.5,1,"","",{"B-","A"},{0,5,0},{"=","="},{0,5,0},11703.24,0.97,12794.5,13.11,4597.24,14.03,-79.37,1.9,-8871.95,15.89,-4923.47,0.98,6214.92,0.99,5285.7,1.48,-4939,207,14631.67,1.06,11730.47,0.96,9623.51,14.03}
,{239,94,48588.282,1.113,7560.318,0.005,-802.142,1.664,239.052161669,1.195,0,760837485860,"",946707780,"",0.5,1,"","",{"A","SF"},{0,3.1,0},{"=","="},{0,3.1,0},12646.07,1.32,11379.85,0.52,5244.52,0.21,-2558.74,54.04,-6008.47,1.19,-7904.52,50.69,5646.25,0.31,6155.34,0.37,-9681,209,14427.43,0.31,10074.16,50.41,11790.04,0.25}
,{239,95,49390.424,1.982,7553.688,0.008,-1756.602,54.058,239.053022803,2.128,0,42840,"",360,"",0,0,"","",{"EC","A"},{0,0.01,0},{"~","="},{0,0.01,0},13322,59,10059.18,1.68,5922.4,1.41,-4860,207,-5353.2,1.69,-8126.08,12.35,7102.38,50.71,4061.76,1.67,-14165,298,15009.51,2.12,11352.89,2.26,11658.65,50.44}
,{239,96,51147.025,54.047,7543.065,0.226,-3103,214,239.054908593,58.022,0,9000,"",1440,"",3.5,-1,"","",{"B+","A"},{0,6.2,0},{"~","="},{0,6.2,0},14242.69,89.19,8522.64,54.05,6539.7,50,-7122,216,-2305.16,54.04,-11140,261,6369.48,55.4,4563.43,74.09,"","",15288,80,9970,124,13891.83,54.05}
,{239,97,54250,207,7527,1,-4019,294,239.05824,222,0,240,"","s","",3.5,1,"","",{"B+","A","SF"},{0,1,0,1,0},{">","<","<"},{0,1,0,1,0},15080,305,6897,215,7200,200,-9305,363,-1460,213,-11099,363,8037,328,2484,207,"","",15714,219,11259,208,13856,235}
,{239,98,58269,209,7507,1,-5287,364,239.062554,224,0,60,"",30,"",2.5,1,"","",{"A"},{""},{""},{""},15813,226,5556,221,7810,56,"","",1535,209,"","",7080,364,3236,330,"","",15792,307,9591,452,16060,210}
,{239,99,63556,298,7481,1,"","",239.06823,320,0,1,"","s","",0,0,"","",{},{},{},{},"","",4210,373,8427,499,"","",2051,392,"","","","",1011,422,"","",16328,311,"","",15660,499}
,{240,91,56910,200,7538,1,4194,200,240.061095,215,0,120,"","s","",0,0,"","",{},{},{},{},10127,201,"","",3264,204,4593,201,"","",-1734,200,4499,280,6830,447,5399,201,15095,347,11819,201,8536,447}
,{240,92,52715.505,2.553,7551.77,0.011,399.233,17.083,240.056592425,2.74,0,50760,"",360,"",0,1,"","",{"B-","A"},{0,1,0},{"=","<"},{0,1,0},10734.91,2.85,14387,283,4035.39,14.2,2590.12,2.69,-11024,400,-4666.87,2.79,5928.53,2.86,7911,196,991.2,3.12,12532.27,16.04,10051.94,13.29,8406.81,16.04}
,{240,93,52316.272,17.032,7550.173,0.071,2190.891,17.015,240.05616383,18.284,0,3714,"",12,"",5,1,"","",{"B-"},{0},{"="},{0},11281.02,17.02,13155.71,23.26,4557.41,22.03,806.1,21.9,-8310,196,-4343.33,17.02,5066.1,17.04,5545.42,17.05,-3348,151,15719.29,17.05,11790.13,17.02,10435.05,21.45}
,{240,94,50125.38,1.106,7556.042,0.005,-1384.789,13.788,240.053811812,1.187,0,207044991486,"",220898482,"",0,1,"","",{"A","SF","34Si"},{0,5.63,0,1.3,0},{"=","=","<"},{0,5.63,0,1.3,0},12180.47,0.36,11760.34,1.17,5255.82,0.14,-1598.93,1.73,-7736.31,1.18,-7336.36,1.67,6534.22,0.23,6474.65,0.95,-7865.56,18.72,13381.53,0.29,10117.78,0.21,10381.59,0.48}
,{240,95,51510.169,13.832,7547.013,0.058,-214.137,13.897,240.055298444,14.849,0,182880,"",1080,"",3,-1,"","",{"B+","A"},{0,1.9,0},{"=","~"},{0,1.9,0},13053.95,52.53,10522.43,13.79,5707.08,52.27,-4154,151,-5089.86,13.82,-7708.17,55.77,5951.57,13.89,4367.08,13.79,-12688,401,16057.76,13.79,11282.5,13.85,12284.91,13.79}
,{240,96,51724.306,1.906,7542.861,0.008,-3940,150,240.055528329,2.046,0,2332800,"",86400,"",0,1,"","",{"A","EC","SF"},{0,0.5,0,3.9,0},{"~","<","="},{0,0.5,0,3.9,0},13863.52,12.3,9016.85,1.7,6397.8,0.6,-6266.64,18.77,-4152.95,1.71,-10597,207,7494.04,54.06,4955.09,2.34,"","",14013.63,50.72,10019,59,12278.99,2.16}
,{240,97,55664,150,7523,1,-2327,151,240.059758,161,0,288,"",48,"",0,0,"","",{"A","B+SF"},{0,0.002,0},{"=","="},{0,0.002,0},14694,296,7335,158,7199,187,-8534,428,-1015,150,-10676,257,6657,255,2772,159,"","",16930,151,11281,166,14741,161}
,{240,98,57990.944,18.7,7510.23,0.078,-6208,401,240.062255842,20.075,0,40.3,"",0.9,"",0,1,"","",{"A","SF"},{0,1.5,0},{"=","="},{0,1.5,0},15429,299,6032.19,22.31,7710.98,3.78,"","",-445.05,57.19,-13636,299,8349,210,3548,208,"","",14486,256,9667,225,14390.26,73.37}
,{240,99,64199,401,7481,2,"","",240.06892,430,0,1,"","s","",0,0,"","",{},{},{},{},"","",4595,475,8231,566,"","",2659,451,"","",7429,499,1359,452,"","",17632,499,11124,410,16657,459}
,{241,91,59640,300,7528,1,3443,358,241.064026,322,0,120,"","s","",1.5,-1,"","",{},{},{},{},9840,358,"","",3195,500,5380,308,"","",-1147,300,5341,361,"","",6705,300,13900,500,11979,413,"",""}
,{241,92,56197,196,7539,1,1937,208,241.06033,210,0,300,"","s","",3.5,1,"","",{},{},{},{},10518,196,14831,445,3817,196,3242,196,"","",-4191,196,4590,196,8002,280,2495,196,13570,277,10167,196,9318,344}
,{241,93,54260.175,70.719,7544.27,0.293,1305,70.711,241.058250697,75.92,0,834,"",12,"",2.5,1,"","",{"B-","A"},{0,10,0},{"=","<"},{0,10,0},11193.52,70.72,13655,208,4307.64,71.91,1325.78,70.71,-9938,212,-3936.52,70.71,6127.41,72.73,5744.3,70.76,-1772,212,14398.26,70.72,11816.45,70.72,9012.54,72.47}
,{241,94,52955.175,1.106,7546.439,0.005,20.78,0.166,241.056849722,1.187,0,452179192.654,"",915150.854,"",2.5,1,"","",{"B-","A","SF"},{0,0.00247,0,2.4,0},{"~","=","<"},{0,0.00247,0,2.4,0},11775.74,0.23,12195.48,1.18,5140.07,0.48,-746.65,1.18,-7049.3,2.69,-6626.31,13.79,5241.52,0.03,6650.07,17.02,-6372,166,14354.93,0.95,10364.57,0.29,11293.79,1.17}
,{241,95,52934.395,1.114,7543.278,0.005,-767.434,1.168,241.056827413,1.195,0,13651526187.6,"",18934155.6,"",2.5,-1,"","",{"A","SF","34Si"},{0,3.6,0,7.4,0},{"=","=","<"},{0,3.6,0,7.4,0},12598.66,1.68,10954.6,0.97,5637.82,0.12,-3097,200,-6670.85,17.02,-6861.23,1.74,6647.09,13.79,4479.96,0.17,-10929,225,15056.92,0.29,11635.24,0.39,11126.14,0.23}
,{241,96,53701.83,1.608,7536.848,0.007,-2330,200,241.057651288,1.726,0,2833920,"",17280,"",0.5,1,"","",{"EC","A"},{0,1,0},{"=","="},{0,1,0},13587.83,54.05,9464.39,1.2,6185.19,0.57,-5625,166,-3712.52,1.18,-10034,150,6093.79,2.09,5097.31,13.84,-15424,298,15022.21,2.04,10144.4,50.7,13185.02,1.23}
,{241,97,56032,200,7524,1,-3295,260,241.060153,215,0,276,"",24,"",3.5,1,"","",{},{},{},{},14361,288,7937,200,7037,209,-7831,301,-2767,200,-10030,201,7704,250,2981,200,"","",15596,207,11451,200,13257,206}
,{241,98,59327,166,7507,1,-4537,280,241.06369,178,0,141,"",10.8,"",3.5,-1,"","",{"A"},{0},{"~"},{0},15085,267,6398,175,7655,150,-9799,341,313,166,-12943,434,6736,167,3627,224,"","",15787,265,9975,304,15528,166}
,{241,99,63863,225,7485,1,-5263,374,241.06856,242,0,10,"",5,"",1.5,-1,"","",{"A"},{""},{""},{""},15835,374,4965,306,8250.17,20.34,"","",910,271,"","",8407,460,1417,226,"","",16305,307,11450,374,15294,340}
,{241,100,69126,298,7460,1,"","",241.07421,320,0,0.00073,"",6e-05,"",2.5,1,"","",{"SF","A","B+"},{"",14,0,12,0},{"","<","<"},{"",14,0,12,0},"","",3721,364,8762,311,"","",3846,299,"","","","",2361,499,"","",16281,422,"","",17495,422}
,{242,92,58620,201,7532,1,1203,283,242.062931,215,0,1008,"",30,"",0,1,"","",{"B-"},{0},{"="},{0},10238,201,"","",3670,200,3903,201,"","",-3712,213,5648,280,8309,361,3816,201,12421,283,10147,280,7816,447}
,{242,93,57416.932,200.004,7533.403,0.826,2700,200,242.061639615,214.713,0,132,"",12,"",1,1,"","",{"B-"},{0},{"="},{0},11041.97,200.72,14071,283,4097.98,200.63,1948.86,200,-9512,361,-3609.56,200,4914.56,212.13,6069,280,-317,283,15412.23,200.02,11708.27,200,9726,280}
,{242,94,54716.932,1.245,7541.327,0.005,-751.14,0.708,242.058741045,1.336,0,11833847250000,"",63113852000,"",0,1,"","",{"A","SF"},{0,5.56,0},{"=","="},{0,5.56,0},11551.08,0.68,12576.51,2.72,4984.23,0.99,-86.83,0.77,-8769,196,-6288.78,0.7,6309.56,0.68,6832.21,70.71,-4670.03,12.91,13111.47,17.03,10269.93,1.16,9790.62,1}
,{242,95,55468.072,1.119,7534.991,0.005,664.309,0.414,242.059547428,1.2,0,57672,"",72,"",1,-1,"","",{"B-","EC"},{0,17.3,0},{"=","="},{0,17.3,0},12184.73,13.79,11426.14,17.02,5588.5,0.25,-2266,200,-6081.07,70.71,-6305.07,1.17,5537.64,0.1,4776.07,0.19,-9333,256,16053.5,0.2,11743.84,0.3,11803.42,0.97}
,{242,96,54803.764,1.142,7534.503,0.005,-2930,200,242.058834263,1.225,0,14065920,"",17280,"",0,1,"","",{"A","SF","34Si"},{0,6.2,0,1.1,0},{"=","=","="},{0,6.2,0,1.1,0},13063.18,1.7,9899.56,0.37,6215.63,0.08,-4583.2,12.9,-5440.38,0.37,-9299,200,6969.38,1.23,5419.6,0.4,-13596,401,14004.4,13.79,10277.39,1.68,11861.88,0.32}
,{242,97,57734,200,7519,1,-1653,200,242.06198,215,0,420,"",78,"",2,-1,"","",{"B+","B+SF"},{0,3,0},{"~","<"},{0,3,0},14073,250,8354,200,6887,206,-7067,325,-2490,200,-9664,260,6369,283,3257,200,"","",16720,200,11451,207,13990,200}
,{242,98,59386.966,12.892,7509.098,0.053,-5414,256,242.063754533,13.84,0,209.4,"",9,"",0,1,"","",{"A","SF"},{"",0.014,0},{"=","<"},{"",0.014,0},14746.61,22.67,6915.28,12.96,7516.86,4.07,-9013,401,-1603.83,12.95,-12548,226,8011,166,3934,200,"","",14433,151,10001,207,13886.34,55.55}
,{242,99,64801,256,7483,1,-3598,475,242.069567,275,0,17.8,"",1.6,"",0,0,"","",{"A","B+","B+SF"},{0,43,0,0.6,0},{"=","=","="},{0,43,0,0.6,0},15540,475,5441,297,8160.12,20.34,"","",1480,325,-12396,393,7133,341,1814,305,"","",17521,257,11396,330,16197,329}
,{242,100,68400,401,7465,2,"","",242.07343,430,0,0.0008,"",0.0002,"",0,1,"","",{"SF"},{""},{""},{""},"","",4169,401,8697,499,"","",1784,434,"","",8798,499,2753,460,"","",14912,566,9708,499,15777,452}
,{243,92,62360,300,7518,1,2484,302,243.066946,322,0,600,"","s","",4.5,-1,"","",{},{},{},{},9980,358,"","",3484,500,4605,300,"","",-3128,361,4331,361,"","",5178,300,13431,424,10314,361,"",""}
,{243,93,59876,32,7525,0,2121,32,243.064279,34,0,111,"",9,"",2.5,1,"","",{"B-"},{0},{"="},{0},10527,77,14342,302,4114,198,2701,32,"","",-2912,32,5612,203,6033,203,1186,32,14390,198,12024,32,8613,203}
,{243,94,57754.602,2.542,7531.008,0.01,579.556,2.622,243.062002119,2.728,0,17841.6,"",10.8,"",3.5,1,"","",{"B-"},{0},{"="},{0},11343.21,2.43,13020,196,4756.97,2.58,572.6,2.64,-8154,201,-5784.79,2.44,5033.65,2.39,6951.3,200.01,-3235,114,14205.23,70.75,10302.39,17.15,10685.5,3.1}
,{243,95,57175.046,1.388,7530.173,0.006,-6.952,1.569,243.06137994,1.49,0,232385203064,"",694252372,"",2.5,-1,"","",{"A","SF"},{0,3.7,0},{"=","="},{0,3.7,0},11901.98,1.23,11663.07,70.72,5439.07,0.93,-1514.65,4.55,-7530.86,200,-5700.03,1.25,6364.34,1.24,4830.86,1.38,-7572,207,14930.68,1.22,11913.72,1.22,10505.18,17.05}
,{243,96,57181.998,1.496,7526.925,0.006,-1507.695,4.506,243.061387403,1.606,0,918306546.6,"",3155692.6,"",2.5,1,"","",{"A","EC","SF"},{0,0.29,0,5.3,0},{"~","=","="},{0,0.29,0,5.3,0},12662.47,1.56,10351.12,1.03,6168.8,1,-3808,114,-4823.9,1.23,-8623,200,5693.08,1.05,5575.04,1.04,-12205,215,14958.41,1.04,10535.88,13.83,12703.02,1.03}
,{243,97,58689.693,4.524,7517.501,0.019,-2300,114,243.06300598,4.857,0,16560,"",720,"",1.5,-1,"","",{"B+","A"},{0,0.15,0},{"~","~"},{0,0.15,0},13485,200,8822.64,4.4,6874.35,4.07,-6058,207,-4067.35,4.4,-8768.59,13.62,7115,200,3403.04,4.4,"","",15698.67,4.55,11829.44,4.69,12825.93,14.47}
,{243,98,60990,114,7505,0,-3757,236,243.065475,123,0,642,"",30,"",0.5,1,"","",{"B+","A"},{0,14,0},{"~","~"},{0,14,0},14479,201,7290,114,7418,100,-8397,243,-1103,114,-11883,280,6468,115,4033,230,"","",15669,230,10190,188,14912,114}
,{243,99,64747,207,7486,1,-4640,298,243.069509,222,0,21.6,"",1.6,"",3.5,1,"","",{"A","B+","SF"},{0,39,0,1,0},{"=","=","<"},{0,39,0,1,0},15259,306,5862,288,8072.11,10.17,"","",-275,288,-11724,451,8125,329,1929,207,"","",16131,265,11620,208,14729,256}
,{243,100,69387,215,7464,1,"","",243.07449,231,0,0.231,"",0.009,"",3.5,-1,"","",{"A","SF"},{0,9,""},{"=","="},{0,9,""},15882,367,4517,271,8693.4,50,"","",2711,215,"","",7084,455,2703,334,"","",16235,311,10053,455,17043,216}
,{244,93,63202,298,7514,1,3396,298,244.06785,320,0,137.4,"",9.6,"",7,-1,"","",{"B-"},{0},{"="},{0},10358,359,"","",3867,359,3323,298,"","",-2624,298,4745,300,6447,423,2488,298,15293,359,11869,357,9208,423}
,{244,94,59806.028,2.346,7524.815,0.01,-73.168,2.686,244.064204415,2.518,0,2.52455408e+15,"",28401233400000,"",0,1,"","",{"A","SF","2B-"},{0,0.121,0,7.3,0},{"~","=","<"},{0,0.121,0,7.3,0},11053.54,2.53,13392,201,4665.61,1.02,1354.13,2.49,-9843,300,-5440.34,2.65,6019.89,2.93,7359,32,-1672.15,3.46,13099.9,200.02,10409.91,70.75,9255,196}
,{244,95,59879.196,1.492,7521.308,0.006,1427.3,1,244.064282964,1.601,0,36360,"",360,"",6,-1,"","",{"B-"},{0},{"="},{0},11731.51,1.02,12115.68,200,5138.01,17.04,-834.69,14.39,-7286,32,-5374.12,1.43,5367.17,1.58,5164.38,2.63,-6146,181,15873.07,1.21,11788.08,1,11265.42,70.72}
,{244,96,58451.896,1.107,7523.952,0.005,-2261.989,14.357,244.062750694,1.188,0,571180360.6,"",631138.52,"",0,1,"","",{"A","SF"},{0,1.37,0},{"=","="},{0,1.37,0},12494.5,0.37,10842.98,0.68,5901.6,0.03,-3026.28,2.5,-6591.68,2.43,-8309.11,4.4,6801.42,1.03,6012.12,1.22,-10514,201,13694.63,0.2,10381.56,0.17,11143.12,0.04}
,{244,97,60713.885,14.399,7511.475,0.059,-764.294,14.572,244.065179039,15.457,0,18072,"",108,"",4,-1,"","",{"A"},{0},{"="},{0},13163,201,9332.13,14.36,6778.8,4,-5312,182,-3750.13,14.41,-8347,115,6047.13,15.01,3757.08,14.39,"","",16620.93,14.36,11876.11,14.4,13425.89,14.36}
,{244,98,61478.179,2.618,7505.136,0.011,-4547,181,244.065999543,2.81,0,1164,"",36,"",0,1,"","",{"A"},{0},{"~"},{0},14051.42,13.08,7903.53,2.47,7328.96,1.81,-7488,201,-2992.79,2.68,-11341,207,7583,114,4500.48,5.02,"","",14455,200,10310,200,13422.75,2.76}
,{244,99,66026,181,7483,1,-2940,271,244.070881,195,0,37,"",4,"",0,0,"","",{"B+","A","B+SF"},{"",5,"",0.01,0},{"","=","="},{"",5,"",0.01,0},14918,314,6286,270,7936,102,"","",47,181,-11433,281,6793,275,2253,214,"","",17349,182,11563,246,15640,270}
,{244,100,68966,201,7468,1,"","",244.074038,216,0,0.00312,"",8e-05,"",0,1,"","",{"SF","B+","A"},{0,2,0,"",""},{"~","<",""},{0,2,0,"",""},15576,448,4999,201,8550,200,"","",687,231,"","",8493,294,3070,288,"","",14876,325,9967,302,15286,261}
,{245,93,65890,300,7505,1,2712,300,245.070736,322,0,120,"","s","",2.5,1,"","",{},{},{},{},10128,302,"","",3825,424,3990,300,"","",-1987,300,5383,423,"","",4076,300,14241,424,12134,361,"",""}
,{245,94,63178.179,13.62,7513.281,0.056,1277.71,13.733,245.067824568,14.621,0,37800,"",360,"",4.5,-1,"","",{"B-"},{0},{"="},{0},10719.06,13.73,13760,300,4556,196,2173.6,13.65,"","",-4772.33,13.68,4699.17,13.42,7313,298,-207.03,13.82,14013,34,10625.3,200.47,10205,201}
,{245,95,61900.469,1.887,7515.303,0.008,895.889,1.549,245.06645289,2.025,0,7380,"",36,"",0,0,"","",{"B-"},{0},{"="},{0},11417.21,2.01,12553,32,5215.38,70.73,86.63,2.15,-8590,298,-4622.74,1.62,6050.04,1.9,5194.53,2.93,-4466,200,14856.67,2.91,12047.59,1.75,10129.94,200.01}
,{245,96,61004.58,1.15,7515.767,0.005,-809.256,1.496,245.065491113,1.234,0,260344639500,"",2208984820,"",3.5,1,"","",{"A","SF"},{0,6.1,0},{"=","="},{0,6.1,0},12320.05,1.14,11327.96,2.47,5624.49,0.49,-2380.63,2.23,-6090.42,2.52,-7780.62,14.36,5518.63,0.49,6163.59,1.11,-9183,195,14540.34,1.3,10400.56,0.53,11934.05,0.83}
,{245,97,61813.836,1.793,7509.27,0.007,-1571.374,2.586,245.066359885,1.924,0,427680,"",2592,"",1.5,-1,"","",{"EC","A"},{0,0.12,0},{"~","="},{0,0.12,0},13018.49,4.62,9939.15,1.87,6454.52,1.4,-4552,200,-5354.33,1.73,-7735.66,2.87,6971.37,14.42,3927.03,1.41,-13459,305,15342.64,1.75,11874.13,1.46,11992.16,1.41}
,{245,98,63385.21,2.428,7499.663,0.01,-2981,200,245.068046825,2.606,0,2700,"",90,"",0.5,1,"","",{"A"},{0},{"="},{0},13747,114,8374.73,2.41,7258.46,1.84,-6802,195,-2355.66,2.18,-10712,181,6164.29,3.31,4617.65,14.52,"","",15406.32,4.91,10516,200,14227.85,2.21}
,{245,99,66366,200,7484,1,-3821,279,245.071247,215,0,66,"",6,"",1.5,-1,"","",{"A"},{""},{"="},{""},14524,288,6902,200,7909.36,3.05,-8906,365,-1637,201,-10671,283,7731,270,2401,200,"","",16087,230,11843,200,14279,283}
,{245,100,70187,195,7466,1,-5085,362,245.075349,209,0,4.2,"",1.3,"",0.5,1,"","",{"A","B+","SF"},{"","","","",""},{"","",""},{"","","","",""},15343,290,5381,226,8436,102,"","",1420,195,"","",6850,280,3127,266,"","",16151,284,10250,322,16447,195}
,{245,101,75272,305,7442,1,"","",245.080808,328,0,0.4,"",0.2,"",3.5,-1,"","",{"A"},{""},{""},{""},"","",4053,369,8984,206,"","",1958,355,"","","","",982,366,"","",16596,373,11737,504,16118,398}
,{246,94,65394.801,14.985,7506.539,0.061,401,14,246.070204209,16.087,0,936576,"",1728,"",0,1,"","",{"B-"},{0},{"="},{0},10553.86,14.95,"","",4350,200,2777.83,14.98,"","",-4576.99,15.07,5854.7,20.09,7784,300,1304.51,15.02,12904,298,10383,35,8681,300}
,{246,95,64994,18,7505,0,2377,18,246.069774,19,0,2340,"",180,"",7,-1,"","",{"B-"},{0},{"="},{0},11028,18,12786,299,5152,201,1027,63,-8185,300,-4082,18,4978,18,5473,22,-2907,224,15899,18,12103,18,10765,36}
,{246,96,62616.967,1.526,7511.471,0.006,-1350,60,246.067222082,1.638,0,148506893756,"",1262277040,"",0,1,"","",{"A","SF"},{0,0.02615,0},{"~","="},{0,0.02615,0},11977.56,1.12,11767,2.67,5475.12,0.89,-1473.32,1.54,-7850.18,13.68,-7268.19,1.8,6458.93,1.22,6572.47,1.96,-7571.87,15.38,13448.58,1.5,10305.98,1.64,10508.77,2.53}
,{246,97,63966.967,60.019,7502.803,0.244,-123.325,60.02,246.068671367,64.433,0,155520,"",1728,"",0,0,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},12889.55,61.7,10490.17,60.02,6073.98,60.01,-3934,232,-5222.47,60.03,-7489.56,60.05,5918.19,60.03,4326.58,60.01,-12148,266,16225.88,60.01,11649.02,60.02,12438.32,60.02}
,{246,98,64090.292,1.515,7499.121,0.006,-3810,224,246.068803762,1.626,0,128520,"",1800,"",0,1,"","",{"A","SF","EC"},{0,2.4,0,4,0},{"=","=","<"},{0,2.4,0,4,0},13530.52,2.67,8939.55,1.06,6861.61,1,-6098.54,15.37,-4203.26,1.17,-10347,200,7366.23,2.42,5012.51,1.77,"","",14087.21,14.4,10264.65,4.51,12554.7,1.45}
,{246,99,67901,224,7480,1,-2288,224,246.072894,240,0,450,"",30,"",4,-1,"","",{"B+","A","B+SF"},{0,9.9,0,0.003,0},{"=","=","~"},{0,9.9,0,0.003,0},14268,288,7391,224,7742,100,-8214,342,-1202,224,-10358,297,6537,300,2773,224,"","",17133,224,11775,251,14857,224}
,{246,100,70188.833,15.333,7467.97,0.062,-5926,260,246.075350815,16.46,0,1.54,"",0.04,"",0,1,"","",{"A","SF","EC","B+SF"},{"",6.8,0,1.3,0,10,0},{"","=","<","="},{"",6.8,0,1.3,0,10,0},14920,201,5867.29,15.49,8376.95,8.3,"","",-485.35,15.49,-13155,306,8070,195,3466,201,"","",14874,182,10306,208,14845,115}
,{246,101,76115,259,7441,1,"","",246.081713,278,0,0.92,"",0.18,"",0,0,"","",{"A"},{0},{"="},{0},"","",4489,316,8888.79,40.66,"","",2460,327,"","",7229,401,1361,324,"","",17860,328,11592,337,17014,332}
,{247,94,69108,196,7494,1,1954,220,247.07419,210,0,196128,"",19872,"",0.5,1,"","",{"B-"},{0},{"="},{0},10213,196,"","",4323,358,3574,196,"","",-3958,196,4359,196,"","",3004,196,13928,358,10770,357,"",""}
,{247,95,67153,100,7499,0,1620,100,247.072092,107,0,1380,"",78,"",0,0,"","",{"B-"},{0},{"="},{0},10890,100,13315,316,4852,105,1664,100,"","",-3535,100,5912,102,5531,101,-1425,102,14686,101,12211,100,9598,314}
,{247,96,65533.143,3.797,7501.931,0.015,43.581,6.324,247.070352726,4.076,0,4.922880456e+14,"",15778463000000,"",4.5,-1,"","",{"A"},{0},{"="},{0},11614.07,3.77,12222.98,13.99,5353.62,3.36,-570.76,15.8,-7150.63,15.35,-6505.14,60.12,5155.14,3.78,6750,18,-6139,115,14343.48,4.06,10518,3.87,11373.52,3.97}
,{247,97,65489.562,5.189,7498.94,0.021,-614.341,16.188,247.07030594,5.57,0,43548557880,"",7889231500,"",1.5,-1,"","",{"A"},{0},{"~"},{0},12466.91,5.34,10988.85,5.39,5889.6,5,-3088.83,20.12,-6793,19,-6672.05,5.25,6548.72,60.23,4416.38,5.26,-10447,207,15195.79,5.17,11901.72,5.15,11256.77,5.24}
,{247,98,66103.903,15.334,7493.285,0.062,-2474.485,24.76,247.070965462,16.461,0,11196,"",108,"",3.5,1,"","",{"EC","A"},{0,0.035,0},{"~","="},{0,0.035,0},13423.94,15.52,9478.62,15.38,6496.99,15.41,-5569,116,-3802.03,15.41,-9868,224,6057.71,15.41,5152.03,61.95,"","",15000.87,15.44,10254.07,21.03,13298.41,15.37}
,{247,99,68578.388,19.441,7480.1,0.079,-3094,116,247.073621932,20.87,0,273,"",15.6,"",3.5,1,"","",{"B+","A","SF"},{0,7,0,9,0},{"~","~","~"},{0,7,0,9,0},13930,201,7813.39,19.52,7463.78,19.96,-7358,208,-2677.55,63.09,-9681.76,24.76,7394,224,2800.87,19.5,"","",15903.98,19.59,11964.26,19.62,13510.91,24.19}
,{247,100,71673,115,7464,0,-4264,237,247.076944,123,0,31,"",1,"",3.5,1,"","",{"A"},{0},{"="},{0},14657,226,6291,115,8257.67,9.74,"","",293,115,-12514,283,6588,116,3517,251,"","",16017,230,10511,215,15841,115}
,{247,101,75937,207,7444,1,"","",247.081521,222,0,1.2,"",0.1,"",3.5,-1,"","",{"A","SF"},{0,0.1,0},{"~","<"},{0,0.1,0},15478,369,5007,288,8764.4,10,"","",747,305,"","",8249,332,1541,208,"","",16460,284,11835,289,15557,275}
,{248,95,70563,200,7487,1,3170,200,248.075752,215,0,180,"","s","",0,0,"","",{},{},{},{},10574,201,"","",4936,359,2483,212,"","",-3042,200,4662,224,5834,280,264,207,15879,201,12249,200,10319,361}
,{248,96,67392.755,2.358,7496.728,0.01,-687,71,248.072349101,2.531,0,10981810248000,"",189341556000,"",0,1,"","",{"A","SF"},{0,8.39,0},{"=","="},{0,8.39,0},11366.85,2.68,12579.99,14.96,5161.81,0.25,154.74,5.59,-9004,196,-6168.12,5.66,6211.71,3.97,7049,100,-4505.1,8.8,13110,18,10356.34,2.94,9860.98,13.42}
,{248,97,68080,71,7491,0,842,71,248.073087,76,0,284012334,"","s","",6,1,"","",{},{},{},{},12029,93,11492,73,5776,71,-2219,88,-6362,123,-6095,72,5481,71,4742,71,-9068,248,16174,71,11940,71,11826,71}
,{248,98,67238.012,5.121,7491.043,0.021,-3061,53,248.072182978,5.497,0,28814400,"",241920,"",0,1,"","",{"A","SF"},{0,0.0029,0},{"~","="},{0,0.0029,0},12994.91,5.11,9956.9,5.12,6361.2,5,-4659.85,9.85,-5584.1,6.24,-9411.69,20.1,6937.21,16.17,5540.52,7.18,-13383,224,13981.85,60.22,10288.23,5.2,11879.83,5.02}
,{248,99,70299,52,7476,0,-1599,53,248.075469,56,0,1440,"",180,"",2,-1,"","",{"B+","A","B+SF"},{0,0.25,0,3,0},{"~","~","="},{0,0.25,0,3,0},13744,230,8246,80,7160,50,-6849,243,-2479,53,-9445,126,6350,56,3094,54,"","",16920,52,11778,52,14132,52}
,{248,100,71897.857,8.497,7465.944,0.034,-5250,238,248.077185528,9.122,0,34.5,"",1.2,"",0,1,"","",{"A","B+","SF"},{0,5,"",0.1,0},{"=","=","="},{0,5,"",0.1,0},14433.61,17.49,6770.38,8.54,7994.76,8.27,-8723,225,-1495.02,17.53,-12110,207,7846,115,3969.5,21.22,"","",14708,224,10396,200,14159.05,8.76}
,{248,101,77148,237,7442,1,-3473,327,248.082822,255,0,7,"",3,"",0,0,"","",{"B+","A","B+SF"},{"",20,"",0.05,0},{"=","=","<"},{"",20,"",0.05,0},15110,351,5331,326,8697,153,"","",1280,238,"","",6860,315,1814,264,"","",17670,238,11825,307,16428,310}
,{248,102,80621,224,7424,1,"","",248.08655,241,0,2e-06,"","s","",0,1,"","",{},{},{},{},"","",4146,225,9230,100,"","",1659,252,"","","","",2605,305,"","",15217,343,10212,379,16080,297}
,{249,95,73104,298,7479,1,2353,298,249.07848,320,0,60,"","s","",0,0,"","",{},{},{},{},10192,314,"","",4789,423,3257,298,"","",-2360,298,5530,359,"","",1929,300,14707,357,12573,298,"",""}
,{249,96,70750.702,2.371,7485.55,0.01,904.317,2.594,249.075954006,2.545,0,3849,"",1.8,"",0.5,1,"","",{"B-"},{0},{"="},{0},10925.08,3.98,12935,196,5147.61,13.42,1027.92,2.56,"","",-5401,71,4713.37,0.25,7101,200,-2768.49,6.62,14308,100,10621,18,11002.3,14.96}
,{249,97,69846.384,1.249,7486.04,0.005,123.6,0.4,249.074983182,1.34,0,28270080,"",25920,"",3.5,1,"","",{"B-","A","SF"},{0,0.00145,0,47,0},{"~","=","="},{0,0.00145,0,47,0},11785.81,5.2,11885,100,5521,1.41,-1328,30,-8005,200,-5462.94,5.06,6305,71,4835.34,2.58,-7386,201,15024.05,3.81,12093.47,1.36,10499,18}
,{249,98,69722.784,1.183,7483.394,0.005,-1452,30,249.074850491,1.27,0,11076481026,"",63113852,"",4.5,-1,"","",{"A","SF"},{0,5,0},{"=","="},{0,5,0},12523.75,15.38,10388.3,3.79,6293.29,0.49,-3796.4,6.19,-4958.94,2.55,-8648,52,5586.54,5.05,5646,71,-12059,279,14944.03,5.18,10619.87,60.01,12752.22,1.3}
,{249,99,71175,30,7474,0,-2344,31,249.076409,32,0,6132,"",36,"",3.5,1,"","",{"B+","A"},{0,0.57,0},{"~","="},{0,0.57,0},13546,36,8893,31,6936,30,-6057,203,-4194,77,-8794,31,7196,60,3352,31,"","",15782,34,11949,30,12854,67}
,{249,100,73519.188,6.212,7461.864,0.025,-3713,201,249.078926098,6.668,0,96,"",6,"",3.5,1,"","",{"A"},{0},{"="},{0},14296,115,7162.66,16.54,7709.06,5.93,-8263,279,-1007.79,7.93,-11700,237,6449.99,10.47,4069,53,"","",15651.61,20.41,10483,224,15075.3,6.25}
,{249,101,77232,201,7444,1,-4550,344,249.082912,216,0,23.4,"",2.4,"",3.5,-1,"","",{"A"},{0},{">"},{0},14847,289,5924,202,8441.08,17.54,"","",-356,207,-11460,301,7987,311,1955,201,"","",16270,231,11907,201,14978,301}
,{249,102,81782,279,7422,1,"","",249.087797,300,0,5.7e-05,"",1.2e-05,"",2.5,1,"","",{},{},{},{},"","",4468,302,9170,200,"","",2595,279,"","",6910,358,2655,366,"","",16556,348,10531,381,17240,280}
,{250,96,72989.594,10.274,7478.938,0.041,39.616,10.894,250.078357556,11.029,0,261922485800,"","s","",0,1,"","",{"SF","A","B-"},{0,18,0,8,0},{"~","~","~"},{0,18,0,8,0},10545.79,10,"","",5169.88,17.99,1819.2,10.35,"","",-4928.11,10.33,5832.42,10,7403,298,-1082.65,12.94,13138,200,10701,101,9528,196}
,{250,97,72949.978,3.719,7475.967,0.015,1779.587,3.386,250.078315027,3.992,0,11563.2,"",18,"",2,-1,"","",{"B-"},{0},{"="},{0},11273,71,12191,200,5531,18,-275,100,-7443,298,-4844.12,3.63,4967.72,3.65,5089.69,4.33,-5680,301,16268.03,4.32,12280.89,5.07,11443,100}
,{250,98,71170.391,1.538,7479.956,0.006,-2055,100,250.076404561,1.651,0,412764592.08,"",2840123.34,"",0,1,"","",{"A","SF"},{0,0.077,0},{"~","="},{0,0.077,0},12210.25,5.13,10800.3,2.68,6128.51,0.19,-2901.85,7.92,-6869.28,2.7,-8076,30,6623.71,1.32,5964.96,1.37,-10393,201,13801,71,10544.88,5.26,11283.65,3.78}
,{250,99,73225,100,7469,0,-847,100,250.078611,107,0,30960,"",360,"",6,1,"","",{"B+"},{0},{">"},{0},13216,113,9433,123,6834,117,-5405,317,-3910,100,-8365,100,6021,104,3786,100,"","",16698,100,11986,101,13382,100}
,{250,100,74072.243,7.888,7462.09,0.032,-4558,301,250.079519828,8.468,0,1824,"",90,"",0,1,"","",{"A","EC","SF"},{0,10,0,0.0069,0},{">","<","="},{0,10,0,0.0069,0},13968.25,11.54,7743.71,9.3,7557.04,7.8,-7492,201,-2939.51,7.87,-11231,201,7518.26,9.97,4392,31,"","",14484,53,10357.91,20.98,13614.74,17.24}
,{250,101,78630,301,7441,1,-2933,362,250.084413,323,0,52,"",5,"",0,0,"","",{"B+","A","B+SF"},{0,7,"",0.02,0},{"=","=","="},{0,7,"",0.02,0},14660,383,6247,306,8305,201,"","",167,303,-11223,411,6673,362,2178,301,"","",17443,301,11822,322,15698,302}
,{250,102,81564,201,7426,1,"","",250.087562,215,0,5e-06,"",6e-07,"",0,1,"","",{"SF","A","B+"},{0,2.1,0,"",""},{"~","<",""},{0,2.1,0,"",""},15200,301,4912,201,8950,200,"","",756,201,"","",8290,344,2957,284,"","",15127,311,10491,288,15538,231}
,{251,96,76648.018,22.698,7466.722,0.09,1420,20,251.082285036,24.367,0,1008,"",12,"",0.5,1,"","",{"B-"},{0},{"="},{0},10245.32,22.73,"","",5116,197,2513,22.36,"","",-4373.28,22.95,4412.89,24.83,"","",694.1,27.32,14255,299,10949,201,"",""}
,{251,97,75228.018,10.734,7469.263,0.043,1093,10,251.080760603,11.523,0,3336,"",66,"",1.5,-1,"","",{"B-"},{0},{"="},{0},10761,10.74,12454,298,5650,101,715.74,12.24,"","",-4013.69,10.73,5793.28,11.25,5050.55,14.72,-3738.73,21.75,15188.12,10.8,12699.32,10.8,10312,200}
,{251,98,74135.018,3.901,7470.5,0.016,-377.259,7.057,251.079587219,4.187,0,28401233400,"",1262277040,"",0.5,1,"","",{"A"},{0},{"~"},{0},11730.4,3.89,11193.62,4.08,6176.96,0.89,-1818.9,15.7,-6143.55,10.8,-7162,100,5106.69,3.88,6103.93,5.15,-8714,115,14999.44,3.91,10919,71,12388.67,4.07}
,{251,99,74512.277,5.994,7465.881,0.024,-1441.641,16.342,251.079992224,6.434,0,118800,"",3600,"",1.5,-1,"","",{"A"},{0},{"="},{0},12805,31,9912.05,6,6597.8,3,-4454.47,19.85,-5726.67,6.94,-7631.28,9.84,6784,100,3947.08,6.06,-13216,298,15500.3,5.99,12138.32,7.78,12078,71}
,{251,100,75953.919,15.203,7457.02,0.061,-3012.825,24.271,251.081539889,16.32,0,19080,"",288,"",4.5,-1,"","",{"B+","A"},{0,1.8,0},{"=","="},{0,1.8,0},13707.9,16.42,8346.81,15.25,7425.1,2,-6895,115,-2505.44,15.28,-10748,301,6189.64,17.13,4560,101,"","",15490,34,10519,54,14362.31,16.04}
,{251,101,78966.744,18.919,7441.9,0.075,-3882,116,251.084774291,20.31,0,252.6,"",13.8,"",3.5,-1,"","",{"A"},{0},{"="},{0},14408,202,6786,36,7963.44,4.47,-8761,299,-1548,102,-10668,201,7735,302,2394.47,20.5,"","",16158.36,19.91,11932.94,20.74,14314,56}
,{251,102,82849,114,7423,0,-4879,319,251.088942,123,0,0.8,"",0.01,"",3.5,1,"","",{"A","SF"},{"",0.3,0},{"=","<"},{"",0.3,0},15075,302,5248,115,8751.71,4.06,"","",1488,115,"","",6786,231,3070,322,"","",16328,231,10565,264,16598,115}
,{251,103,87728,298,7401,1,"","",251.09418,320,0,0.00015,"","s","",0,0,"","",{},{},{},{},"","",4082,359,9367,363,"","",1809,424,"","","","",1125,359,"","",16657,408,11971,373,16227,381}
,{252,96,79056,298,7460,1,521,359,252.08487,320,0,60,"",172800,"<",0,1,"","",{},{},{},{},10076,298,"","","","",3021,298,"","",-4243,298,5663,299,"","",2240,298,"","",10816,422,"",""}
,{252,97,78535,200,7459,1,2500,200,252.08431,215,0,108,"",30,"",0,0,"","",{"B-"},{""},{""},{""},10558,200,"","",5547,283,1240,206,"","",-3672,200,4765,200,5402,201,-1976,239,16256,200,12648,200,11077,359}
,{252,98,76034.617,2.358,7465.347,0.009,-1260,50,252.081626523,2.531,0,83468069.27,"",252455.408,"",0,1,"","",{"A","SF"},{0,3.092,0},{"=","="},{0,3.092,0},11278.41,2.69,11532.92,10,6216.95,0.04,-781.01,5.94,-7902.37,22.73,-6548.98,6.41,6171.72,4.07,6482.37,10.8,-6836.81,9.57,13795.44,4.32,11052.29,2.58,10930.32,0.25}
,{252,99,77294.617,50.056,7457.242,0.199,478.99,50.351,252.082979189,53.736,0,40754880,"",164160,"",4,1,"","",{"A","EC"},{0,22,0},{"=","="},{0,22,0},12073,112,10233.3,50.19,6789,50,-3216,140,-5222.37,51.15,-6730.62,52.31,5288.98,50.41,4129.37,50.17,-11442,243,16835.03,50.07,12435.89,50.07,13094.63,50.07}
,{252,100,76815.627,5.498,7456.038,0.022,-3695,130,252.082464972,5.902,0,91404,"",144,"",0,1,"","",{"A","SF"},{0,0.0023,0},{"~","="},{0,0.0023,0},13399.25,9.52,8932.7,5.5,7152.7,2,-6055.8,10.74,-4608.36,6.62,-10222.43,19.7,7209.61,16.17,4985.62,8.03,"","",14301,100,10505,31,12739.24,5.43}
,{252,101,80510,130,7438,1,-2361,131,252.086432,140,0,138,"",48,"",0,0,"","",{"B+"},{0},{">"},{0},14262,328,7293,164,7786,140,-8227,271,-1291,131,-10410,173,6528,132,2732,131,"","",17149,131,11855,131,14982,134}
,{252,102,82871.427,9.292,7425.798,0.037,-5866,238,252.088966141,9.975,0,2.45,"",0.02,"",0,1,"","",{"A","SF","B+"},{0,32.2,0,1.1,0},{">","=","<"},{0,32.2,0,1.1,0},14835,201,5778.76,12.14,8548.65,5.32,"","",-371.46,17.82,-12928,298,8049,115,3384.29,21.08,"","",14952,301,10503,201,14998.64,11.13}
,{252,103,88737,238,7399,1,"","",252.095263,255,0,0.369,"",0.075,"",0,0,"","",{"B+","A","SF"},{0,"","",1,0},{"=","","<"},{0,"","",1,0},"","",4471,384,9164.34,16.91,"","",2481,239,"","",7062,381,1401,264,"","",17884,311,11819,367,17151,311}
,{253,97,80929,359,7451,1,1627,359,253.08688,385,0,600,"","s","",0,0,"","",{},{},{},{},10442,359,"","",5400,200,1918,359,"","",-3177,359,5677,411,5416,467,-244,360,14991,360,12803,359,"",""}
,{253,98,79301.567,4.257,7454.829,0.017,291.03,4.385,253.085133738,4.57,0,1538784,"",6912,"",3.5,1,"","",{"B-","A"},{0,0.31,0},{"~","="},{0,0.31,0},10976.09,5.4,11924.39,23,6125.95,3.54,-44.17,5.13,-7043,298,-6064.37,50.13,4804.37,3.54,6522,200,-5057.17,8.1,14784.36,11.36,11215.64,5.59,11958.37,10.61}
,{253,99,79010.538,1.25,7452.887,0.005,-335.202,2.713,253.084821305,1.341,0,1768608,"",2592,"",3.5,1,"","",{"A","SF"},{0,10,0},{"=","="},{0,10,0},11644.37,6,10795.42,10.74,6739.24,0.05,-2162,31,-6813,200,-5876.41,5.44,6355.4,50.07,4313.05,2.58,-9565,202,15586.33,3.91,12704.2,1.38,11706.96,3.65}
,{253,100,79345.74,2.932,7448.47,0.012,-1827,31,253.08518116,3.148,0,259200,"",10368,"",0,0,"","",{"EC","A"},{0,12,0},{"=","="},{0,12,0},12750.81,15.48,9367.22,4.73,7198.04,2.68,-5012.99,7.41,-3977.85,3.7,-9236,130,5541.2,6.05,5237.85,50.14,-14211,410,15544.27,6.56,10984,100,13821.75,2.99}
,{253,101,81173,31,7438,0,-3186,32,253.087143,34,0,720,"",480,"",3.5,-1,"","",{"B+","A"},{0,"",""},{"~",""},{0,"",""},13937,37,7917,32,7573.08,8.32,-7402,204,-3411,59,-9770,33,7409,134,2932,32,"","",15930,35,11965,32,13594,105}
,{253,102,84358.735,6.912,7422.471,0.027,-4217,202,253.090562831,7.42,0,93.6,"",1.2,"",4.5,-1,"","",{"A","SF"},{0,"",""},{"=",""},{0,"",""},14633,115,6173.13,16.7,8414.63,4.33,-9198,410,254.14,8.74,-12450,238,6584.01,11.54,3441,131,"","",16102.8,20.14,10592,301,15932.89,10.43}
,{253,103,88575,202,7403,1,-4982,457,253.095089,217,0,0.632,"",0.046,"",3.5,-1,"","",{"A","SF","B+"},{"",2.6,0,1,0},{"=","=","="},{"",2.6,0,1,0},15295,360,4969,203,8918.25,20.32,"","",776,240,"","",8233,312,1585,202,"","",16437,232,11876,285,15591,362}
,{253,104,93557,410,7380,2,"","",253.100438,440,0,0.013,"",0.005,"",0,0,"","",{"SF"},{""},{""},{""},"","",3870,426,9350,300,"","",3397,410,"","","","",2469,474,"","",16540,507,"","",17640,456}
,{254,97,84393,298,7440,1,3052,298,254.0906,320,0,60,"","s","",0,0,"","",{},{},{},{},10284,359,"","","","",2403,298,"","",-2980,298,4607,467,"","",941,314,16048,422,12609,299,"",""}
,{254,98,81341.401,11.462,7449.225,0.045,-649.193,12.113,254.08732359,12.304,0,5227200,"",17280,"",0,1,"","",{"SF","A"},{0,0.31,0},{"~","="},{0,0.31,0},10835.85,11.22,12292,298,5926.89,5.08,438.61,11.68,"","",-5740.45,11.51,6031.48,11.76,6876,359,-3381.95,14.98,13518,200,10977.44,15.57,10339.78,25.35}
,{254,99,81990.594,4.01,7443.589,0.016,1087.8,3.202,254.088020527,4.304,0,23820480,"",43200,"",7,1,"","",{"A","EC","B-","SF"},{0,"","",1.74,0,3,0},{"~","","=","<"},{0,"","",1.74,0,3,0},11446.66,50.21,11122,200,6615.7,1.5,-1462,100,-6227,359,-5426.46,4.76,5091.26,3.95,4599.94,5.79,-7881,301,16666.78,4.57,12719.63,5.37,12408.98,11.35}
,{254,100,80902.794,2.414,7444.792,0.01,-2550,100,254.086852726,2.591,0,11664,"",7.2,"",0,1,"","",{"A","SF"},{0,0.0592,0},{"~","="},{0,0.0592,0},12055.47,5.81,9709.76,3.27,7307.49,1.86,-3820.55,9.89,-5687.74,4.82,-8341,31,6514.26,3.52,5396.71,2.31,-12296,283,14318.98,50.11,11254.57,6.34,12414.18,4.31}
,{254,101,83453,100,7432,0,-1271,100,254.08959,107,0,600,"",180,"",0,-1,"","",{"B+"},{0},{"~"},{0},13200,164,8420,112,7802,141,-6419,317,-2847,100,-8977,100,5791,105,3182,100,"","",17348,100,12363,101,14587,100}
,{254,102,84723.347,9.658,7423.59,0.038,-5148,301,254.090954259,10.367,0,51.2,"",0.4,"",0,1,"","",{"A","B+","SF"},{0,10,0,0.23,0},{"=","=","="},{0,10,0,0.23,0},14290.71,13.37,6670.22,11.05,8226.19,8.05,-8475,283,-1911.36,10.03,-11923,202,7706.7,11.84,3738,33,"","",14924,131,10620.66,21.24,14415.83,18.01}
,{254,103,89871,301,7400,1,-3327,414,254.096481,323,0,17.1,"",1.8,"",0,0,"","",{"A","B+"},{0,28,0},{"=","="},{0,28,0},15008,384,5217,328,8816.26,12.39,"","",1410,303,-11757,509,6775,363,1776,301,"","",17711,301,11886,322,16551,302}
,{254,104,93199,283,7384,1,"","",254.100053,304,0,2.32e-05,"",1e-06,"",0,1,"","",{"SF","A"},{"",1.5,0},{"","<"},{"",1.5,0},"","",4251,283,9210,200,"","",1551,283,"","",8430,498,2666,348,"","",15172,370,10335,411,15996,306}
,{255,98,84809,200,7438,1,720,200,255.091047,215,0,5100,"",1080,"",3.5,1,"","",{"B-","SF","A"},{0,"","",2,0},{"=","","="},{0,"","",2,0},10635,200,"","",5736,201,1010,200,"","",-5253,200,4603,201,6873,359,-1998,201,14592,411,11139,283,11400,359}
,{255,99,84089.274,10.817,7437.821,0.042,289.62,10.247,255.090273553,11.612,0,3438720,"",103680,"",3.5,1,"","",{"B-","A","SF"},{0,8,0,0.0041,0},{"=","=","="},{0,8,0,0.0041,0},11063.9,10.82,11417,359,6436.34,1.34,-753.8,12.59,-7593,298,-4884.84,10.97,5972.64,11.43,4541.1,15.63,-5858.03,20.74,15498.51,11.44,12918.71,10.88,11201,200}
,{255,100,83799.654,4.291,7435.888,0.017,-1043.416,7.747,255.089962633,4.607,0,72252,"",252,"",3.5,1,"","",{"A","SF"},{0,2.4,0},{"=","="},{0,2.4,0},11688.72,5.06,10079.85,5.69,7239.72,1.79,-3007.58,15.51,-4830.72,12.07,-7724,100,5174.46,4.66,5479.91,5.66,-10530,115,15499.92,4.3,11369.09,50.2,13411.44,4.45}
,{255,101,84843.07,6.553,7428.729,0.026,-1964.164,16.281,255.091082787,7.035,0,1620,"",120,"",3.5,-1,"","",{"B+","A","SF"},{0,7,"",0.15,0},{"=","=","<"},{0,7,"",0.15,0},12472,32,8745.41,6.56,7905.88,2.65,-5104.23,18.87,-4436.49,7.58,-7951.59,11.63,6681,100,3348.69,6.87,-14750,359,16208.14,7.08,12891.5,8.46,13194.85,50.48}
,{255,102,86807.234,14.904,7417.958,0.058,-3140.066,23.138,255.093191404,16,0,211.2,"",10.8,"",0.5,1,"","",{"B+","A"},{0,30,0},{"=","="},{0,30,0},13694.13,16.43,7116.45,15.19,8428.4,3,-7522,115,-1384.53,15.1,-11136,302,5987.43,17.76,3935,101,"","",16345,35,11161,131,15638.01,15.89}
,{255,103,89947.3,17.698,7402.576,0.069,-4382,116,255.096562404,19,0,31.1,"",1.1,"",0.5,-1,"","",{"A","B+","SF"},{0,0.3,0,0.1,0},{"=","=","<"},{0,0.3,0,0.1,0},14771,203,5803,36,8555.64,6.69,-9646,359,-794,102,-11323,284,7996,302,2065.02,20.16,"","",16299.37,19,11939.93,19.99,15083,132}
,{255,104,94330,115,7382,0,-5263,377,255.101267,123,0,1.66,"",0.07,"",4.5,-1,"","",{"SF","A","B+"},{0,48,0,1,0},{"=","=","<"},{0,48,0,1,0},15370,426,4607,115,9055.46,3.92,"","",2317,115,"","",6940,306,2831,322,"","",16465,232,10457,264,17105,115}
,{255,105,99593,359,7359,1,"","",255.106918,385,0,1.7,"",0.5,"",0,0,"","",{"SF"},{0},{"~"},{0},"","",3560,412,9440,200,"","",2433,469,"","","","",895,457,"","",16747,545,"","",16502,431}
,{256,98,87041,314,7432,1,-146,330,256.093442,338,0,738,"",72,"",0,1,"","",{"SF","A"},{0,6.2,0},{"=","="},{0,6.2,0},10443,315,"","",5560,100,1554,314,"","",-5120,315,5840,373,"","",-781,315,13358,433,10976,477,"",""}
,{256,99,87187,100,7428,0,1700,100,256.093599,108,0,1524,"",144,"",1,1,"","",{"B-"},{0},{"="},{0},10946,100,11784,314,6227,224,-269,158,"","",-4684,100,4974,101,4911,224,-4560,130,16556,101,12749,100,11905,373}
,{256,100,85486.817,5.6,7431.78,0.022,-1969,123,256.091773878,6.012,0,9456,"",78,"",0,1,"","",{"SF","A"},{0,8.1,0},{"=","="},{0,8.1,0},11558.61,6.04,10432.53,12.31,7027.28,5.08,-2335.24,9.53,-6611,200,-7427.57,8.6,6384.15,6.75,5891.43,12.01,-8735.23,18.7,14207.03,6.84,11340.33,5.7,11831.65,6.19}
,{256,101,87456,122,7421,0,-366,123,256.093888,132,0,1800,"","s","",7,-1,"","",{},{},{},{},12139,158,9112,123,7737,112,-4290,148,-3922,123,-7422,123,5458,123,3632,123,-13042,269,17264,123,12974,123,14092,123}
,{256,102,87822.062,7.743,7416.546,0.03,-3924.536,83.264,256.094280866,8.312,0,2.91,"",0.05,"",0,1,"","",{"A","SF","EC"},{0,0.53,0,"",""},{"~","=",""},{0,0.53,0,"",""},13043.92,12.32,7658.67,7.97,8581.52,5.45,-6399.99,19.42,-3266.56,8.76,-10196.56,19.32,7056.49,16.8,4309.98,10.06,"","",15080,100,11513,32,14122.72,8.15}
,{256,103,91746.598,82.903,7398.16,0.324,-2475.451,84.802,256.098494029,89,0,27,"",3,"",0,0,"","",{"A","B+","SF"},{"",15,"",0.03,0},{"=","=","<"},{"",15,"",0.03,0},14268,312,6284,130,8811,101,-8752,254,-385.44,83.16,-10654,141,6272.02,84.77,2349.61,84.23,"","",17734.06,83.46,12251.92,83.19,16220,89}
,{256,104,94222.049,17.848,7385.434,0.07,-6276,241,256.101151535,19.16,0,0.00667,"",0.0001,"",0,1,"","",{"SF","A"},{"",0.32,0},{"","="},{"",0.32,0},15119,284,5079.24,20.27,8925.71,15.24,"","",125.84,23.25,-13442,359,8179,116,3014.22,25.14,"","",15061,302,10511,203,15509.72,19.12}
,{256,105,100498,240,7358,1,"","",256.107889,258,0,1.7,"",0.4,"",0,0,"","",{"A","B+","SF"},{"",36,"","",""},{"=","=",""},{"",36,"","",""},"","",3951,385,9336.13,30.48,"","",3262,241,"","",7166,432,1120,266,"","",18010,371,11805,475,17569,314}
,{257,99,89403,411,7422,2,813,411,257.095979,441,0,665280,"",17280,"",3.5,1,"","",{"B-","A"},{0,4,0},{"=","="},{0,4,0},10828,411,"","",6050,200,410,411,"","",-4155,411,5855,423,4926,517,-3262,413,15305,457,12926,411,10657,508}
,{257,100,88590.033,4.486,7422.194,0.017,-403.02,4.715,257.095105317,4.815,0,8683200,"",17280,"",4.5,1,"","",{"A","SF"},{0,0.21,0},{"~","="},{0,0.21,0},11352.26,5.86,10797,200,6863.55,1.41,-1657.22,8.02,-5740,314,-6937,123,4968.1,6.35,5886,100,-7276.39,11.7,15211.57,11.53,11463.49,5.96,12895.03,11.85}
,{257,101,88993.053,1.601,7417.582,0.006,-1254.202,6.661,257.095537977,1.718,0,19872,"",180,"",3.5,-1,"","",{"EC","A","SF"},{0,15,0,1,0},{"=","=","<"},{0,15,0,1,0},11992.65,6.64,9674.16,10.87,7557.6,1,-3672,44,-5483,100,-6900.33,7.77,6534,123,3782.73,5.79,-11214,203,15904.21,4.42,12954.31,2.52,12648.86,4.08}
,{257,102,90247.256,6.678,7409.657,0.026,-2418,45,257.096884419,7.169,0,24.5,"",0.5,"",1.5,1,"","",{"A","B+"},{"",15,0},{"","="},{"",15,0},12702.61,16.33,8130.34,7.85,8476.6,6,-5619.17,12.66,-2528.53,8.69,-9570.66,83.17,5646.12,10.12,4498,123,"","",16114.99,9.28,11659,100,14990.86,6.96}
,{257,103,92665,44,7397,0,-3201,45,257.09948,47,0,6,"",0.4,"",0.5,-1,"","",{"A","B+","SF"},{0,"","","",""},{"~","",""},{0,"","","",""},13424,48,6756,45,9067.74,31.21,-7541,208,-2080,130,-9628,48,7152,94,2446,45,"","",16569,47,12806,45,14859,109}
,{257,104,95866.427,10.817,7381.704,0.042,-4340,203,257.102916848,11.612,0,4.82,"",0.13,"",0.5,1,"","",{"A","B+","SF"},{"",19.4,0,1.3,0},{"","=","="},{"",19.4,0,1.3,0},14606,115,5518.75,18.42,9082.78,8.32,"","",755.39,13.24,-12703,240,6426.94,20.85,3169.14,83.61,"","",16629.93,20.74,10859,301,16789.48,14.47}
,{257,105,100207,203,7362,1,"","",257.107576,218,0,2.3,"",0.2,"",4.5,1,"","",{"A","SF","B+"},{0,6,0,1,0},{">","<","="},{0,6,0,1,0},15529,412,4319,204,9206.54,20.32,"","",1171,219,"","",8363,314,1304,204,"","",16588,233,11872,348,15982,363}
,{258,99,92702,401,7412,2,2276,448,258.09952,430,0,180,"","s","",0,0,"","",{},{},{},{},10627,413,"","",5884,499,1015,401,"","",-3959,401,4773,574,"","",-2080,413,16372,509,12757,448,"",""}
,{258,100,90426,200,7418,1,-1260,200,258.097077,215,0,0.00037,"",1.4e-05,"",0,1,"","",{"SF"},{0},{"~"},{0},11203,200,11192,373,6660,200,-1051,224,"","",-6638,200,6235,200,6266,457,-5915,203,13950,224,11201,201,11263,283}
,{258,101,91686.792,4.419,7409.675,0.017,209,100,258.098429825,4.743,0,4449600,"",25920,"",8,-1,"","",{"A","B+","B-"},{0,0.0015,0,0.0015,0},{"~","<","<"},{0,0.0015,0,0.0015,0},11912,123,10078,100,7271.28,1.86,-3095,102,-5006,411,-6631.78,7.88,5377.58,4.48,4192.21,6.24,-10110,305,16910.78,7.08,12751.19,5.95,13243.92,11.58}
,{258,102,91478,100,7407,0,-3304,143,258.098205,107,0,0.0012,"",0.0002,"",0,1,"","",{"SF","A"},{0,"",""},{"~",""},{0,"",""},12487,100,8587,100,8150,100,-4863,105,-4401,100,-9259,109,6841,100,4804,100,-13766,425,14732,158,11499,100,13324,100}
,{258,103,94782,102,7392,0,-1559,107,258.101753,109,0,3.6,"",0.4,"",0,0,"","",{"A","B+"},{"",2.6,0},{"","="},{"",2.6,0},13107,131,7252,159,8904.48,18.57,-7015,322,-1500,102,-9156,102,5955,111,2754,102,"","",17671,102,12839,103,15586,102}
,{258,104,96341.036,31.967,7382.538,0.124,-5456,307,258.103426362,34.317,0,0.0138,"",0.0009,"",0,1,"","",{"SF","A"},{0,13,0},{"=","="},{0,13,0},14023.65,36.6,6058.97,32.87,9192.77,30.47,-8903,414,-1195.19,32.64,-11937,205,7596.71,33.73,3613,55,"","",15305.24,88.85,11257.79,36.54,15180.2,35.27}
,{258,105,101797,305,7358,1,-3447,513,258.109284,328,0,4.5,"",0.4,"",0,0,"","",{"A","B+","SF"},{0,37,0,1,0},{"=","=","<"},{0,37,0,1,0},14844,388,4528,316,9500.6,50,"","",1843,309,"","",6481,367,1358,306,"","",18286,306,12332,326,17496,306}
,{258,106,105244,413,7342,2,"","",258.112984,443,0,0.0027,"",0.0005,"",0,1,"","",{"SF","A"},{"",20,0},{"","<"},{"",20,0},"","",3556,413,9620,300,"","",2088,413,"","","","",2252,460,"","",15456,477,10515,547,16560,428}
,{259,100,93704,283,7407,1,80,346,259.100596,304,0,1.5,"",0.2,"",1.5,1,"","",{"SF"},{0},{"="},{0},11028,283,"","",6470,200,-374,283,"","",-6054,283,4793,347,6287,490,-4658,292,15012,499,11381,300,12310,423}
,{259,101,93624,200,7405,1,-454,200,259.10051,215,0,5760,"",216,"",3.5,-1,"","",{"SF","A"},{"",1.3,0},{"","<"},{"",1.3,0},11511,200,10357,457,7110,200,-2228,212,-6367,448,-5925,224,6134,200,4091,283,-8367,207,15745,200,13001,200,12084,224}
,{259,102,94078.569,6.589,7399.974,0.025,-1773,71,259.100997503,7.073,0,3480,"",300,"",4.5,1,"","",{"A","EC","SF"},{0,25,0,10,0},{"=","=","<"},{0,25,0,10,0},12311.32,9.3,9089.4,7.7,7854,5,-4284,73,-3637,200,-8775,102,5470,100,4897.19,7.78,-12441,115,15796.32,6.67,11486,123,14238.15,8.4}
,{259,103,95852,71,7390,0,-2510,101,259.102901,76,0,6.2,"",0.3,"",0.5,-1,"","",{"A","SF","B+"},{0,22,0,"",""},{"=","=",""},{0,22,0,"",""},12956,84,7719,71,8584,71,-6139,89,-3124,71,-8561,78,7002,124,2915,123,"","",16315,71,12894,71,14042,142}
,{259,104,98362,72,7377,0,-3629,90,259.105596,78,0,2.63,"",0.26,"",3.5,1,"","",{"A","SF","B+"},{0,8,"","",""},{"=","=",""},{0,8,"","",""},13647,73,6463,73,9130,71,-8157,136,-404,123,-11506,314,6050,79,3709,125,"","",16408,85,11480,110,16187,73}
,{259,105,101991.016,53.04,7360.362,0.205,-4529,126,259.109491865,56.94,0,0.51,"",0.16,"",4.5,1,"","",{"A"},{0},{"="},{0},14358,210,5252,69,9618.8,50,"","",-80,115,-11324,416,7877,310,1638.99,61.93,"","",16835.39,54.13,12633.02,55.96,15890.82,98.42}
,{259,106,106520,115,7340,0,"","",259.114353,123,0,0.402,"",0.056,"",5.5,-1,"","",{"A","SF","EC"},{0,3,0,1,0},{"=","<","<"},{0,3,0,1,0},"","",3925,115,9765.08,8.13,"","",2890,119,"","",6795,428,2566,326,"","",17024,233,10885,266,17944,116}
,{260,100,95766,435,7402,2,-786,537,260.102809,467,0,60,"","s","",0,1,"","",{},{},{},{},10803,479,"","",6300,300,154,478,"","",-5930,479,6010,519,"","",-3381,478,13774,591,11226,598,"",""}
,{260,101,96552,316,7396,1,940,374,260.103653,340,0,2401920,"",69120,"",0,0,"","",{"SF","A","EC","B-"},{"",5,0,5,0,3.5,0},{"","<","<","<"},{"",5,0,5,0,3.5,0},11278,316,10728,510,6940,300,-1725,340,"","",-5598,316,5144,374,4441,424,-7121,330,16836,374,12826,316,12795,519}
,{260,102,95612,200,7397,1,-2665,235,260.102643,215,0,0.106,"",0.008,"",0,1,"","",{"SF"},{0},{"="},{0},12009,224,9393,283,7700,200,-3535,283,-5381,347,-8311,212,6538,200,5301,283,-10936,201,14636,200,11483,200,12668,200}
,{260,103,98277,124,7383,0,-870,236,260.105504,133,0,180,"",30,"",0,0,"","",{"A","B+"},{"",20,""},{"=","="},{"",20,""},12648,161,7988,124,8396,143,-5396,155,-2636,236,-8157,144,5646,143,3091,124,-15047,275,17510,159,12894,124,14930,124}
,{260,104,99147,200,7377,1,-4526,221,260.106439,215,0,0.021,"",0.001,"",0,1,"","",{"SF","A","EC"},{"",2,0,"",""},{"","=",""},{"",2,0,"",""},13337,203,6909,224,8900,200,-7401,201,-2221,200,-10915,207,7287,213,3994,212,"","",15076,225,11346,205,14546,200}
,{260,105,103673,93,7357,0,-2875,95,260.111297,100,0,1.52,"",0.13,"",0,0,"","",{"A","SF","B+"},{0,9.6,0,2.5,0},{">","<","<"},{0,9.6,0,2.5,0},14267,319,5687,138,9501,42,-9651,262,532,117,-10918,148,6390,107,1978,118,"","",18043,98,12670,94,16654,103}
,{260,106,106547.552,20.536,7342.562,0.079,-6776,246,260.114383508,22.045,0,0.00495,"",0.00033,"",0,1,"","",{"SF","A"},{"",40,""},{"=","="},{"",40,""},14839,413,4371.43,37.98,9900.59,10.16,"","",896,75,"","",8043,117,2732.43,56.88,"","",15461,306,11205,204,16327.53,23.19}
,{260,107,113323,245,7313,1,"","",260.121658,263,0,0.041,"",0.014,"",0,0,"","",{"A"},{0},{"~"},{0},"","",3052,392,10400.3,50,"","",4043,251,"","","","",485,271,"","",18791,480,"","",18763,318}
,{261,101,98578,509,7391,2,123,547,261.105828,546,0,2400,"","s","",3.5,-1,"","",{},{},{},{},11188,547,"","",6750,300,-980,547,"","",-5105,547,6045,599,4476,669,-5730,521,15585,582,13016,547,11523,648}
,{261,102,98455,200,7388,1,-1103,283,261.105696,215,0,10800,"","s","",1.5,1,"","",{},{},{},{},11766,200,9827,347,7440,200,-2864,206,-4600,478,-7893,235,5228,283,5386,374,-9550,201,15542,283,11632,200,13675,283}
,{261,103,99558,200,7381,1,-1761,206,261.10688,215,0,2340,"",720,"",0,0,"","",{"SF"},{""},{""},{""},12436,212,8644,283,8140,200,-4750,228,-4283,374,-7660,283,6790,235,3343,283,-13575,289,16190,200,12944,224,13518,200}
,{261,104,101318.594,50.444,7371.384,0.193,-2990,121,261.10876999,54.153,0,2.2,"",0.3,"",1.5,1,"","",{"SF","A"},{0,27,0},{"=","="},{0,27,0},13186,88,7337.92,50.86,8646.42,50,-6686.45,53.71,-1582,206,-10426,106,5900,206,4247,134,"","",16178,87,11400,114,15487,112}
,{261,105,104308,110,7357,0,-3697,112,261.11198,118,0,4.7,"",1,"",0,0,"","",{"SF","A"},{"","",""},{"=",""},{"","",""},13825,122,6122,131,9218,101,-8825,236,-1257,166,-10311,112,7436,144,2128,228,"","",16657,132,12831,115,15172,150}
,{261,106,108005.043,18.494,7339.77,0.071,-5128,210,261.115948188,19.853,0,0.183,"",0.005,"",1.5,1,"","",{"A","B+","SF"},{0,1.3,0,0.6,0},{"=","=","="},{0,1.3,0,0.6,0},14657,116,4935,75,9713.7,15,"","",1569,201,-13390,246,6613.83,27.62,2957,95,"","",16724.83,56.17,11072,306,17310.41,36.92}
,{261,107,113133,209,7317,1,"","",261.121454,224,0,0.0128,"",0.0032,"",2.5,-1,"","",{"A","SF"},{0,5,0},{"=","<"},{0,5,0},"","",3436,216,10501.6,50,"","",2171,229,"","",8261,322,703,210,"","",17325,238,12754,462,16983,370}
,{262,101,101627,500,7382,2,1526,617,262.109101,537,0,180,"","s","",0,0,"","",{},{},{},{},11067,592,"","",6500,300,-475,539,"","",-4899,539,5023,714,"","",-4626,520,16572,663,12787,575,"",""}
,{262,102,100101,361,7385,1,-2000,412,262.107463,387,0,0.005,"","s","",0,1,"","",{"SF"},{0},{"~"},{0},11653,412,10242,565,7250,300,-2291,424,"","",-7528,412,6425,412,5766,624,-8265,362,14260,480,11341,413,12043,459}
,{262,103,102102,200,7374,1,-291,300,262.109611,215,0,14400,"","s","",0,0,"","",{"B+","SF"},{"",10,0},{"","<"},{"",10,0},12318,235,9028,374,7990,200,-4152,246,-3766,547,-7288,206,5528,283,3642,283,-12440,365,17201,283,12887,200,14124,283}
,{262,104,102393,224,7370,1,-3861,265,262.109923,240,0,0.25,"",0.1,"",0,1,"","",{"SF"},{0},{"~"},{0},12897,300,7797,300,8490,200,-5973,226,-3351,300,-9987,249,6997,229,4454,300,"","",14827,256,11405,235,13960,224}
,{262,105,106253,143,7352,1,-2112,147,262.114068,154,0,34,"",4,"",0,0,"","",{"SF","A","B+"},{0,"","",3,0},{"=","","="},{0,"","",3,0},13562,171,6601,189,9046,101,-8288,338,-594,246,-9823,144,6126,181,2354,152,"","",17817,246,12755,160,16048,160}
,{262,106,108365.771,35.411,7341.185,0.135,-6176,308,262.116335446,38.015,0,0.0109,"",0.0023,"",0,1,"","",{"SF"},{0},{"~"},{0},14324.42,40.92,5359,203,9599.82,15.23,"","",-241.79,61.62,-12839,212,7710.59,39.94,3231,116,"","",15404,99,11238.81,63.77,15650,81}
,{262,107,114541,306,7315,1,"","",262.122965,328,0,0.084,"",0.011,"",0,0,"","",{"A","SF"},{"",20,0},{"","<"},{"",20,0},14925,392,3709,320,10319.5,15,"","",2944,325,"","",6663,370,753,306,"","",18705,306,12886,327,18197,310}
,{263,102,103129,490,7376,2,-600,566,263.110714,526,0,1200,"","s","",0,0,"","",{},{},{},{},11468,529,"","",7000,400,-1627,513,"","",-7044,529,5043,608,5787,700,-7061,499,15262,706,11441,583,13010,655}
,{263,103,103729,283,7371,1,-1027,322,263.111358,304,0,18000,"","s","",0,0,"","",{},{},{},{},11971,347,9427,582,7680,200,-3382,329,-5187,575,-6735,361,6444,347,3661,459,-10767,416,15985,347,12981,347,12824,424}
,{263,104,104756,153,7364,1,-2355,227,263.11246,164,0,660,"",180,"",1.5,1,"","",{"SF","A"},{"",30,0},{"","="},{"",30,0},12706,161,8277,252,8252,153,-5435,180,-2635,392,-9569,209,5708,271,4635,252,-14922,198,15909,252,11343,197,14790,252}
,{263,105,107111,168,7352,1,-3079,193,263.114988,181,0,29,"",9,"",0,0,"","",{"SF","A","B+"},{"","","",6.9,0},{"=","","="},{"","","",6.9,0},13340,201,7025,261,8834,152,-7385,348,-2280,261,-9326,172,7214,221,2571,280,"","",16503,176,12828,261,14481,209}
,{263,106,110190,95,7337,0,-4306,319,263.118294,102,0,0.94,"",0.14,"",3.5,1,"","",{"A","SF"},{0,13,0},{"=","="},{0,13,0},13957,96,5706,107,9403.26,60.93,-9488,157,509,243,-12422,320,6247,101,3352,172,"","",16593,145,11382,133,16690,221}
,{263,107,114496,305,7318,1,-5182,329,263.122916,327,0,0.2,"","s","",0,0,"","",{},{},{},{},14780,369,4390,324,10080,300,"","",954,337,"","",8117,432,1159,307,"","",17202,305,12812,305,16470,319}
,{263,108,119678,125,7295,0,"","",263.12848,134,0,0.00076,"",4e-05,"",1.5,1,"","",{"A","SF"},{"",8.4,0},{"","<"},{"",8.4,0},"","",2905,127,10733.5,50,"","",4023,130,"","","","",2152,330,"","",17256,244,11219,275,18777,127}
,{264,102,105011,591,7371,2,-1366,734,264.112734,634,0,60,"","s","",0,1,"","",{},{},{},{},11233,692,"","",6820,400,-1066,692,"","",-6790,655,6190,767,"","",-5771,655,14094,774,11296,780,"",""}
,{264,103,106377,436,7363,2,300,566,264.1142,468,0,36000,"","s","",0,0,"","",{},{},{},{},11868,480,9828,664,7400,300,-2985,495,"","",-6450,462,5424,520,4041,656,-9681,471,16986,566,12786,480,13445,670}
,{264,104,106077,361,7361,1,-3285,431,264.113878,387,0,3600,"","s","",0,1,"","",{},{},{},{},12459,424,8603,510,8040,300,-4705,458,-4341,608,-9106,398,6750,392,4941,458,-13487,362,14686,412,11383,412,13268,412}
,{264,105,109362,235,7346,1,-1420,368,264.117405,253,0,180,"","s","",0,0,"","",{},{},{},{},13034,275,7318,309,8660,200,-6696,295,-1656,368,-8900,254,5821,289,2683,281,"","",17680,325,12907,241,15450,309}
,{264,106,110782,283,7338,1,-5276,334,264.118929,304,0,0.047,"",0.02,"",0,1,"","",{"SF"},{0},{"~"},{0},13727,285,6189,361,9210,200,-8781,284,-1263,322,-11785,416,7480,298,3618,329,"","",15239,317,11338,304,15110,287}
,{264,107,116058,177,7315,1,-3506,180,264.124593,190,0,1.07,"",0.21,"",0,0,"","",{"A","SF"},{0,14,0},{"=","="},{0,14,0},14626,353,4774,228,9960,151,"","",1658,244,-11692,217,6510,353,1422,201,"","",18403,181,12917,178,17396,209}
,{264,108,119563.222,28.881,7298.375,0.109,"","",264.128356405,31.005,0,0.00054,"",0.0003,"",0,1,"","",{"A","SF"},{0,50,0},{"~","~"},{0,50,0},"","",3380.49,45.69,10590.75,20.31,"","",2084,99,"","",8186,129,2222,306,"","",15733,307,11294,211,17204.58,34.28}
,{265,103,108233,547,7359,2,-457,655,265.116193,587,0,36000,"","s","",0,0,"","",{},{},{},{},11638,616,"","",7230,200,-2250,591,"","",-5915,655,6215,699,4066,805,-8182,595,15815,734,12996,655,12253,741}
,{265,104,108690,361,7354,1,-1793,424,265.116683,387,0,96,"",48,"",1.5,1,"","",{"SF"},{0},{"~"},{0},12208,392,9017,608,7810,300,-4105,381,-3610,692,-8743,431,5458,510,4976,566,-12210,361,15672,458,11452,412,14235,510}
,{265,105,110483,224,7344,1,-2312,255,265.118608,240,0,900,"","s","",0,0,"","",{},{},{},{},12771,280,7824,361,8500,100,-5932,323,-3183,490,-8370,361,6950,325,2883,424,-16195,504,16438,271,12954,316,14028,300}
,{265,106,112794,123,7333,0,-3621,264,265.12109,132,0,9.2,"",1.6,"",4.5,1,"","",{"A"},{0},{">"},{0},13539,155,6539,196,9051,112,-8106,125,-571,381,-11335,216,6059,308,3856,265,"","",16394,208,11405,188,16048,255}
,{265,107,116415,234,7316,1,-4485,235,265.124977,251,0,1.19,"",0.52,"",0,0,"","",{"A"},{""},{""},{""},14224,384,5274,288,9682,206,-10263,508,-236,332,-11219,236,7714,293,1656,367,"","",16935,252,12913,236,15808,274}
,{265,108,120900.283,23.958,7296.247,0.09,-5778,452,265.129791799,25.719,0,0.00196,"",0.00016,"",1.5,1,"","",{"A","SF"},{0,1,0},{"~","<"},{0,1,0},14920,127,3868,98,10470.32,15.23,"","",2829,284,"","",6734.26,37.51,2446,179,"","",17115,306,11223,307,18180.91,42.74}
,{265,109,126678,451,7271,2,"","",265.135995,484,0,0.002,"","s","",0,0,"","",{},{},{},{},"","",2396,544,11120,400,"","",3331,485,"","","","",174,452,"","",17711,468,"","",17783,545}
,{266,103,111622,583,7349,2,1546,749,266.119831,626,0,75600,"",50400,"",0,0,"","",{"SF"},{0},{"="},{0},10897,728,"","",7570,300,-1115,648,"","",-5139,686,4683,800,"","",-6482,606,17322,830,13357,762,"",""}
,{266,104,110076,469,7352,2,-2660,548,266.118172,504,0,14400,"","s","",0,1,"","",{},{},{},{},12143,592,9512,754,7550,300,-3541,529,"","",-8478,520,6685,592,5446,720,-11060,471,14410,640,11211,548,12593,678}
,{266,105,112737,283,7339,1,-881,374,266.121028,304,0,4800,"",4200,"",0,0,"","",{},{},{},{},12768,368,8218,520,8210,200,-5368,326,-2786,616,-8129,308,5818,361,3242,458,-15225,417,17371,458,12845,322,14654,400}
,{266,106,113618,245,7332,1,-4487,294,266.121973,263,0,0.39,"",0.11,"",0,1,"","",{"SF"},{0},{"="},{0},13307,374,7037,436,8800,100,-7519,248,-2361,436,-10869,339,7248,274,4154,332,"","",14967,340,11371,297,14508,289}
,{266,107,118104,163,7313,1,-3032,167,266.12679,175,0,2.5,"",1.6,"",0,0,"","",{"A"},{0},{"~"},{0},14096,241,5835,286,9426,77,-9858,347,332,276,-10867,164,6382,285,1979,204,"","",18033,326,12778,188,16640,234}
,{266,108,121136.373,38.695,7298.273,0.145,-6826,309,266.130045252,41.54,0,0.00302,"",0.00054,"",0,1,"","",{"A","SF"},{"","",""},{"",""},{"","",""},14569.48,48.28,4223,286,10345.69,15.6,"","",1053,129,-13613,453,7835.23,45.5,2568,237,"","",15789,182,11504,307,16592,102}
,{266,109,127962,307,7270,1,"","",266.137373,329,0,0.0012,"",0.0004,"",0,0,"","",{"A","SF"},{"",5.5,0},{"","<"},{"",5.5,0},"","",2674,354,10995.65,25.38,"","",4258,386,"","",6787,546,227,308,"","",19110,308,13148,331,19112,432}
,{267,104,113444,575,7342,2,-630,707,267.121787,617,0,9000,"",5400,"",0,0,"","",{"SF"},{0},{"="},{0},11388,678,"","",7890,300,-2362,629,"","",-7364,640,4703,742,5467,819,-9209,582,15922,793,11931,721,14080,824}
,{267,105,114074,412,7336,2,-1732,486,267.122464,443,0,6000,"",3600,"",0,0,"","",{"SF"},{0},{"="},{0},12551,469,8737,685,7920,300,-4692,489,-4837,715,-7615,480,6734,500,3291,625,-13717,650,16095,548,12861,548,13344,600}
,{267,106,115806,257,7327,1,-2960,367,267.124322,276,0,108,"",42,"",0,0,"","",{"SF","A"},{0,17,0},{"=","="},{0,17,0},13131,284,7462,443,8625,206,-6847,274,-1560,535,-10370,304,5883,355,4220,382,-18074,290,16034,340,11308,348,15375,443}
,{267,107,118766,263,7313,1,-3887,279,267.1275,282,0,22,"",10,"",0,0,"","",{"A"},{0},{"="},{0},13792,352,6295,345,9230,202,-9025,567,-1260,386,-10442,265,7410,309,2141,359,"","",16682,290,12848,386,15051,353}
,{267,108,122653,96,7295,0,-5138,512,267.131673,103,0,0.055,"",0.011,"",2.5,1,"","",{"A"},{0},{">"},{0},14390,98,4719,155,10037.51,13.01,-11227,165,1746,263,-13380,321,6555,103,2740,189,"","",16949,253,11459,201,17517,299}
,{267,109,127791,503,7273,2,-6089,521,267.137189,540,0,0.01,"","s","",0,0,"","",{},{},{},{},15030,676,3202,554,10870,400,"","",2398,528,"","",8242,589,634,504,"","",17601,503,13092,504,17380,533}
,{267,110,133880,135,7248,1,"","",267.143726,145,0,1e-05,"",8e-06,"",1.5,1,"","",{"A"},{0},{"="},{0},"","",1599,137,11776.76,50.76,"","",5454,141,"","","","",1371,335,"","",17912,471,"","",19963,138}
,{268,104,115476,662,7337,2,-1586,848,268.123968,711,0,3600,"","s","",0,1,"","",{},{},{},{},10743,812,"","",8040,300,-1326,812,"","",-6670,780,6040,877,"","",-7354,721,14564,883,12106,859,"",""}
,{268,105,117062,529,7328,2,260,707,268.125671,568,0,104400,"",14400,"",0,0,"","",{"SF"},{0},{"~"},{0},11818,600,9138,788,8260,300,-3745,652,"","",-6815,588,5084,671,3671,781,-12089,578,17696,707,13236,640,14475,761}
,{268,106,116802,469,7326,2,-4005,605,268.125392,504,0,120,"","s","",0,1,"","",{},{},{},{},12959,529,7853,663,8300,300,-6028,548,-3931,742,-10036,538,7075,535,4561,625,-16847,558,14776,548,11183,520,13758,592}
,{268,107,120807,381,7308,1,-2023,475,268.129691,409,0,25,"","s","",0,0,"","",{},{},{},{},13440,415,6508,475,9020,300,-8344,447,-556,562,-9918,393,6031,463,2288,460,"","",17900,453,12876,401,15970,442}
,{268,108,122830,283,7298,1,-6321,367,268.131863,304,0,1.42,"",1.13,"",0,1,"","",{"A"},{0},{"~"},{0},14449,286,5366,375,9622.87,16.24,-10818,414,-265,382,-13032,577,7894,299,3225,386,"","",15436,327,11279,367,15682,309}
,{268,109,129151,233,7271,1,-4497,381,268.138649,250,0,0.027,"",0.006,"",5,1,"","",{"A"},{0},{"="},{0},14954,385,3532,284,10668,151,"","",3096,351,-12800,269,6711,554,791,252,"","",18725,236,13115,234,18382,330}
,{268,110,133648,301,7252,1,"","",268.143477,324,0,0.0001,"","s","",0,1,"","",{},{},{},{},"","",2066,304,11660,300,"","",3706,316,"","",8303,330,1432,586,"","",16397,430,11834,543,18394,302}
,{269,105,119148,624,7323,2,-614,722,269.127911,669,0,10800,"","s","",0,0,"","",{},{},{},{},11068,748,"","",8490,300,-2330,727,"","",-5725,780,5985,818,3616,910,-10222,777,16415,848,13936,780,13173,854}
,{269,106,119763,364,7318,1,-1715,522,269.12857,391,0,300,"",180,"",0,0,"","",{"A"},{0},{"~"},{0},12186,445,8259,680,8647.74,50,-4801,385,-3002,756,-9115,527,5110,594,4588,642,-15072,365,16399,550,11890,461,15333,594}
,{269,107,121478,374,7309,1,-3086,394,269.130412,402,0,60,"","s","",0,0,"","",{},{},{},{},13431,457,7174,557,8570,300,-7892,596,-2873,648,-9423,469,7400,534,2613,600,"","",16383,454,12724,447,14388,469}
,{269,108,124564,124,7294,0,-4806,480,269.133725,133,0,16,"",6,"",4.5,1,"","",{"A"},{0},{"="},{0},14232,157,5820,285,9344,159,-10271,128,473,485,-12658,264,6337,309,3532,401,"","",16509,290,11323,205,16593,275}
,{269,109,129370,463,7273,2,-5465,464,269.138884,497,0,0.1,"","s","",0,0,"","",{},{},{},{},14564,684,3974,533,10530,400,"","",1274,600,-12349,553,7852,519,749,543,"","",17428,473,13098,465,16912,491}
,{269,110,134834.709,31.403,7250.154,0.117,"","",269.144751021,33.712,0,0.00023,"",0.00011,"",4.5,1,"","",{"A"},{0},{"="},{0},15188,139,2396,101,11509.51,29.6,"","",4716,285,"","",6885,303,1605,235,"","",17755,504,11737,308,19344.74,49.82}
,{270,105,122307,617,7314,2,816,831,270.131302,662,0,7200,"",4680,"",0,0,"","",{"SF"},{0},{"="},{0},10897,813,"","",8260,200,-1919,680,"","",-5527,716,4913,877,"","",-8403,640,17542,905,13727,843,"",""}
,{270,106,121491,557,7314,2,-2735,627,270.130426,598,0,180,"","s","",0,1,"","",{},{},{},{},11453,728,8562,865,8990,300,-3621,610,"","",-8058,671,6343,665,4946,836,-13187,559,15140,768,12281,693,13693,800}
,{270,107,124226,287,7301,1,-886,379,270.133362,308,0,228,"",180,"",0,0,"","",{"A"},{0},{"="},{0},12723,477,7413,602,9064.5,50,-6484,334,-2211,687,-8409,313,5323,472,2825,464,"","",18135,550,13284,385,15798,503}
,{270,108,125112,248,7295,1,-5598,301,270.134314,266,0,9,"",4,"",0,1,"","",{"A"},{0},{"="},{0},13860,376,6267,531,9069.9,37.7,-9566,252,-1939,440,-12329,525,7523,277,3654,449,"","",15017,455,11211,361,14953,357}
,{270,109,130710,170,7271,1,-3968,177,270.140323,183,0,0.0063,"",0.0015,"",0,0,"","",{"A"},{0},{"~"},{0},14583,289,4674,418,10181.1,50,"","",1944,411,-12196,173,6731,494,1142,211,"","",18591,331,12922,195,17591,313}
,{270,110,134678.282,48.011,7253.775,0.178,"","",270.14458309,51.542,0,0.000205,"",4.8e-05,"",0,1,"","",{"A","SF"},{0,0.2,0},{"~","<"},{0,0.2,0},15112,305,2729,287,11116.99,28.42,"","",2826,133,"","",8227.74,57.36,1981,466,"","",16238,238,11751,505,17672,107}
,{271,106,124757,585,7305,2,-1164,718,271.133932,628,0,186,"",96,"",0,0,"","",{"A","SF"},{0,30,0},{"=","="},{0,30,0},11148,689,"","",8888,112,-2983,649,"","",-7540,652,4805,808,4839,850,-11191,593,16320,855,12560,789,14928,884}
,{271,107,125921,415,7298,2,-1819,501,271.135182,446,0,600,"",480,"",0,0,"","",{"A"},{0},{"="},{0},11699,559,7805,749,9422.13,50,-5180,531,-3675,744,-7263,484,6376,505,2859,695,"","",16869,552,13984,627,14506,673}
,{271,108,127740,280,7288,1,-3361,433,271.137135,301,0,10,"","s","",0,0,"","",{},{},{},{},12966,306,6600,459,9510,112,-8208,296,-1040,623,-11042,328,5444,374,3775,401,"","",16973,467,11798,473,16585,546}
,{271,109,131101,330,7273,1,-4847,344,271.140742,354,0,0.4,"","s","",0,0,"","",{},{},{},{},14412,569,4955,499,9910,200,"","",-414,438,-11649,334,7681,371,1301,413,"","",17248,353,13135,435,15941,504}
,{271,110,135948,97,7252,0,"","",271.145946,104,0,0.09,"",0.04,"",6.5,-1,"","",{"A"},{0},{"="},{0},15030,102,3194,158,10869.97,17.63,"","",3546,266,"","",6802,108,2052,196,"","",17289,473,11661,252,18764,300}
,{272,106,126580,727,7301,3,-2209,901,272.13589,781,0,240,"","s","",0,1,"","",{},{},{},{},11053,916,"","",8680,300,-2426,888,"","",-7412,838,6248,934,"","",-9434,836,14984,954,12296,958,"",""}
,{272,107,128789,532,7290,2,-217,737,272.138261,571,0,11.3,"",1.8,"",0,0,"","",{"A"},{0},{"~"},{0},11579,604,8095,814,9303,50,-4792,720,"","",-7022,601,5203,675,3257,791,-13984,581,18009,770,13891,644,15288,819}
,{272,108,129006,510,7286,2,-4575,704,272.138494,547,0,10,"","s","",0,1,"","",{},{},{},{},12249,567,7063,755,9780,200,-7008,656,-3040,776,-10166,607,6805,582,4204,658,"","",15491,585,12393,632,14890,627}
,{272,109,133581,485,7267,2,-2433,637,272.143406,521,0,0.4,"","s","",0,0,"","",{},{},{},{},13272,514,5223,564,10350,300,-9192,538,371,639,-10438,495,5591,587,1448,560,"","",19180,545,13882,501,17750,613}
,{272,110,136015,413,7255,2,-6758,474,272.146018,443,0,0.2,"","s","",0,1,"","",{},{},{},{},14806,415,3676,481,10760,300,"","",985,499,"","",8004,424,2375,528,"","",16015,446,11509,620,17097,431}
,{272,111,142773,233,7227,1,"","",272.153273,251,0,0.0045,"",0.001,"",5,1,"","",{"A"},{0},{"="},{0},"","",2515,289,11197.43,13.31,"","",4383,404,"","","","",464,253,"","",18806,238,12802,236,19050,519}
,{273,106,130018,503,7291,2,-615,855,273.13958,540,0,300,"","s","",0,0,"","",{},{},{},{},10882,772,"","","","",-1872,623,"","",-6843,732,4634,884,"","",-8338,520,"","",12575,796,"",""}
,{273,107,130633,692,7286,3,-1257,783,273.14024,743,0,60,"","s","",0,0,"","",{},{},{},{},11431,807,"","",9060,300,-4080,812,"","",-6445,860,6228,873,3236,1004,-12062,869,16587,906,14006,888,13973,927}
,{273,108,131890,367,7279,1,-2822,561,273.14159,394,0,1.06,"",0.5,"",1.5,1,"","",{"A"},{0},{"~"},{0},11992,462,7445,691,9702.85,50,-6465,391,-1979,815,-9763,609,5188,629,4188,646,"","",16680,555,12528,466,16046,667}
,{273,109,134713,424,7265,2,-3643,445,273.14462,455,0,0.8,"","s","",0,0,"","",{},{},{},{},12531,538,5786,594,10810,200,-7982,676,-1366,680,-9373,592,6940,645,1583,663,"","",17683,508,14464,491,16133,512}
,{273,110,138356,134,7249,0,-4339,543,273.148531,144,0,0.00024,"",8e-05,"",6.5,-1,"","",{"A"},{0},{"="},{0},13735,165,3963,310,11366.9,50,"","",2060,527,-12489,269,5730,434,2515,503,"","",17966,356,12509,216,18890,282}
,{273,111,142695,526,7231,2,"","",273.153189,565,0,0.002,"","s","",0,0,"","",{},{},{},{},"","",2984,621,10900,250,"","",1824,716,"","",8150,576,609,669,"","",17458,535,12881,529,17631,553}
,{274,107,133682,619,7278,2,196,856,274.143513,664,0,60,"",30,"",0,0,"","",{"A"},{0},{"="},{0},11251,816,"","",8949.62,50,-3564,713,"","",-6280,720,5023,928,3625,797,-10932,644,17812,955,13788,852,"",""}
,{274,108,133486,592,7276,2,-3760,689,274.143303,635,0,0.5,"","s","",0,1,"","",{},{},{},{},11663,781,7672,938,9570,200,-5711,708,-3821,777,-9298,728,6476,697,4436,910,"","",15407,795,12429,723,14375,832}
,{274,109,137246,354,7259,1,-1952,526,274.147339,380,0,0.85,"",0.54,"",0,0,"","",{"A"},{0},{"="},{0},12478,600,6122,638,10595,206,-7367,396,-676,777,-9181,378,5538,552,1934,510,"","",18950,621,14370,451,16971,546}
,{274,110,139197,389,7249,1,-5416,428,274.149434,418,0,0.01,"","s","",0,1,"","",{},{},{},{},12960,567,4387,641,11660,300,"","",18,535,-11569,655,7230,411,2804,576,"","",16327,622,12961,510,17104,479}
,{274,111,144613,177,7227,1,"","",274.155249,190,0,0.029,"",0.018,"",0,0,"","",{"A"},{0},{"~"},{0},14303,293,3546,517,11477.9,50,"","",2611,460,"","",6153,555,1031,222,"","",19309,449,13529,202,19159,375}
,{275,107,135691,596,7273,2,-929,837,275.14567,640,0,300,"","s","",0,0,"","",{},{},{},{},11085,913,"","","","",-3138,728,"","",-5867,840,6062,859,"","",-9605,790,16384,780,13974,940,"",""}
,{275,108,136620,587,7267,2,-2209,721,275.146667,631,0,0.29,"",0.15,"",0,0,"","",{"A"},{0},{"="},{0},11413,693,7976,773,9437.5,50,-4945,717,"","",-8698,686,4938,834,4351,853,"","",16697,908,12694,792,15685,935}
,{275,109,138829,418,7256,2,-2736,586,275.149039,449,0,0.117,"",0.074,"",0,0,"","",{"A"},{0},{"="},{0},12027,596,6382,809,10482.7,50,-6467,666,-2142,747,-8440,571,6488,548,1946,725,"","",17649,557,14686,660,15686,676}
,{275,110,141565,410,7244,1,-3731,661,275.151976,441,0,0.01,"","s","",0,0,"","",{},{},{},{},12933,432,4903,551,11400,300,"","",790,720,-11119,447,5704,566,2970,542,"","",17563,590,12848,635,18205,655}
,{275,111,145296,519,7227,2,"","",275.155981,557,0,0.005,"","s","",0,0,"","",{},{},{},{},13542,739,3995,670,11770,400,"","",761,628,"","",7389,548,1191,648,"","",17651,536,14145,663,17361,710}
,{276,108,138285,754,7264,3,-3029,923,276.148455,810,0,0.1,"","s","",0,1,"","",{},{},{},{},11343,959,"","",9280,200,-4256,932,"","",-8615,863,6405,956,4694,961,-12067,961,15315,976,12516,1024,13914,907}
,{276,109,141315,532,7250,2,-1227,763,276.151708,571,0,0.63,"",0.1,"",0,0,"","",{"A"},{0},{"="},{0},12074,638,6945,816,10100.41,9.02,-6172,823,-1665,799,-8322,672,5585,677,2594,792,"","",18540,795,14289,646,16328,873}
,{276,110,142541,548,7243,2,-4945,834,276.153024,588,0,0.1,"","s","",0,1,"","",{},{},{},{},12799,672,5523,806,11110,200,-7811,810,-1367,803,-10826,754,7095,684,3576,689,"","",16006,652,12693,693,16298,660}
,{276,111,147486,629,7222,2,-2866,866,276.158333,675,0,0.01,"","s","",0,0,"","",{},{},{},{},13269,653,4337,721,11480,400,"","",1369,755,"","",5881,815,1368,751,"","",19000,739,13995,643,18420,759}
,{276,112,150352,596,7209,2,"","",276.16141,640,0,0.0001,"","s","",0,1,"","",{},{},{},{},"","",3423,712,11913,725,"","",1498,724,"","","","",2232,790,"","",16450,622,12522,795,17643,611}
,{277,108,141493,541,7255,2,-1475,884,277.151899,581,0,0.011,"",0.009,"",1.5,1,"","",{"SF"},{0},{"="},{0},11269,799,"","",9050,200,-3648,664,"","",-7893,759,4864,928,"","",-10910,560,16513,805,12675,822,"",""}
,{277,109,142968,699,7247,3,-2172,798,277.153483,751,0,9,"",6,"",0,0,"","",{"SF"},{0},{"="},{0},12003,815,7301,919,9910,100,-5370,871,"","",-7645,888,6418,878,2606,1028,"","",17059,913,14346,916,14933,934}
,{277,110,145140,384,7237,1,-3197,646,277.155815,412,0,0.006,"",0.003,"",5.5,1,"","",{"A"},{0},{"~"},{0},12567,562,6057,702,10825,112,-7262,410,-434,846,-10417,737,5472,669,3463,656,"","",17022,568,12759,522,17301,705}
,{277,111,148338,520,7222,2,-4065,539,277.159247,558,0,0.01,"","s","",0,0,"","",{},{},{},{},13101,734,5069,667,11200,300,"","",-266,743,-10086,791,7220,816,1493,755,"","",17483,662,14004,649,16738,629}
,{277,112,152403,143,7205,1,"","",277.163611,153,0,0.00085,"",0.00028,"",1.5,1,"","",{"A"},{0},{"="},{0},"","",3740,434,11622.2,50,"","",2572,566,"","",6021,613,2373,645,"","",17818,538,12654,228,18852,415}
,{278,109,145736,621,7240,2,-645,881,278.156454,666,0,7,"",3,"",0,0,"","",{"A"},{0},{"="},{0},11722,817,"","",9629.03,50,-4781,716,"","",-7476,730,5304,935,3046,824,-13153,648,18161,977,13980,855,15691,861}
,{278,110,146381,625,7235,2,-4136,719,278.157146,671,0,0.27,"","s","",0,1,"","",{},{},{},{},12303,831,6482,979,10470,200,-6551,763,-2401,827,-10028,812,6831,733,3876,938,"","",15777,820,12416,752,15408,857}
,{278,111,150517,357,7218,1,-2415,565,278.161587,383,0,0.008,"",0.005,"",0,0,"","",{"A"},{0},{"="},{0},13112,723,5376,640,10846.3,50,-8372,402,260,785,-9957,385,5892,630,1912,524,"","",18686,654,13816,544,17335,550}
,{278,112,152932,438,7206,2,-5957,475,278.164179,470,0,0.002,"","s","",0,1,"","",{},{},{},{},13563,739,4187,701,11310,200,"","",503,582,"","",7542,460,2694,679,"","",16157,766,12501,679,17014,600}
,{278,113,158889,184,7182,1,"","",278.170574,198,0,0.0023,"",0.0013,"",0,0,"","",{"A"},{0},{"~"},{0},"","",3175,655,11850.8,50,"","",3262,551,"","","","",803,233,"","",19247,624,"","",19240,550}
,{279,109,147496,667,7237,2,-1630,896,279.158343,716,0,30,"","s","",0,0,"","",{},{},{},{},11615,967,"","",9380,300,-4279,789,"","",-6957,914,6311,912,"","",-11743,966,16714,859,14074,1007,"",""}
,{279,110,149126,598,7228,2,-2649,731,279.160093,642,0,0.21,"",0.05,"",0,0,"","",{"SF","A"},{0,10,0},{"=","="},{0,10,0},12157,711,6945,807,10081,112,-5904,752,"","",-9463,697,5326,865,3899,862,"","",16869,920,12675,800,16487,963}
,{279,111,151775,421,7216,2,-3255,621,279.162937,452,0,0.18,"",0.11,"",0,0,"","",{"A"},{0},{"="},{0},12706,669,5771,816,10521.1,50,-7464,816,-1250,750,-9229,607,6814,552,1895,753,"","",17345,570,14097,691,16106,678}
,{279,112,155030,456,7202,2,-4209,835,279.166432,490,0,0.005,"","s","",0,0,"","",{},{},{},{},13515,478,4688,597,11040,200,"","",1360,774,-11930,492,5974,632,2776,580,"","",17403,692,12408,777,18135,713}
,{279,113,159239,699,7184,3,"","",279.17095,750,0,0.001,"","s","",0,0,"","",{},{},{},{},"","",3677,871,11518,870,"","",1433,785,"","",7721,723,982,824,"","",17547,713,13751,918,17399,940}
,{280,110,150520,780,7226,3,-3366,944,280.16159,838,0,11,"",6,"",0,1,"","",{"SF"},{0},{"="},{0},12003,999,"","",9810,200,-5176,974,"","",-9326,887,6677,983,4264,1027,"","",15496,997,12416,1048,14674,950}
,{280,111,153886,532,7212,2,-1810,789,280.165203,571,0,4.3,"",0.7,"",0,0,"","",{"A"},{0},{"="},{0},12774,640,6428,817,10146.12,6.8,-7254,665,-899,853,-9215,701,5960,678,2529,800,"","",18216,820,13610,656,16564,878}
,{280,112,155696,583,7202,2,-5444,707,280.167147,626,0,0.005,"","s","",0,1,"","",{},{},{},{},13379,729,5263,854,10730,200,"","",-718,835,-11614,910,7405,741,3367,719,"","",15890,684,12223,781,16202,698}
,{280,113,161140,400,7180,1,"","",280.172991,429,0,0.01,"","s","",0,0,"","",{},{},{},{},13891,440,3955,536,11229,745,"","",2076,581,"","",6170,805,1179,607,"","",18919,593,13601,424,18449,656}
,{281,110,153431,579,7219,2,-1866,992,281.164715,622,0,14,"",4,"",1.5,1,"","",{"SF","A"},{"",15,""},{"=","="},{"",15,""},11837,833,"","",9513,206,-4588,697,"","",-8526,786,5161,972,"","","","",16646,884,12560,849,"",""}
,{281,111,155297,806,7210,3,-2722,894,281.166718,865,0,24,"",8,"",0,0,"","",{"SF"},{0},{"="},{0},12620,909,6777,1046,9904,400,-6513,860,"","",-8471,994,6660,965,2512,1121,"","",16882,1003,13780,1019,15208,1017}
,{281,112,158019,387,7197,1,-3790,490,281.169641,416,0,0.18,"",0.08,"",1.5,1,"","",{"A"},{0},{"~"},{0},13153,599,5684,712,10454.13,50,"","",210,871,-11192,557,5748,700,3155,658,"","",16956,572,12366,527,17285,735}
,{281,113,161810,300,7181,1,"","",281.17371,322,0,0.1,"","s","",0,0,"","",{},{},{},{},13572,760,4543,517,11047,600,"","",635,610,"","",7402,500,1175,656,"","",17491,546,13742,530,16939,466}
,{282,111,157800,654,7204,2,-1176,926,282.169405,702,0,96,"",42,"",0,0,"","",{"A"},{0},{"="},{0},12228,843,"","",9640,206,-5925,747,"","",-8291,760,5568,1038,2920,874,"","",17991,1018,13538,886,15951,935}
,{282,112,158976,656,7197,2,-4749,748,282.170668,704,0,0.0009,"",0.00024,"",0,1,"","",{"SF"},{0},{"="},{0},12863,878,6122,1019,10170,200,"","",-1744,875,-10905,721,7115,762,3610,1039,"","",15801,844,12065,780,15496,888}
,{282,113,163725,361,7177,1,"","",282.175766,387,0,0.14,"",0.09,"",0,0,"","",{"A"},{0},{"="},{0},13558,538,4739,642,10783.2,50,"","",1139,883,"","",6156,469,1583,529,"","",18740,686,13559,582,17597,555}
,{283,111,159281,697,7202,2,-2205,925,283.170995,748,0,30,"","s","",0,0,"","",{},{},{},{},12159,1065,"","",9360,200,-5426,822,"","",-7767,957,6591,956,"","","","",16560,906,13624,1046,"",""}
,{283,112,161486,608,7191,2,-3221,748,283.173362,653,0,4.1,"",1,"",0,0,"","",{"A","SF"},{"",10,0},{"","<"},{"",10,0},12676,721,6523,840,9935,112,"","","","",-10311,707,5561,895,3603,893,"","",16900,1009,12464,808,16612,989}
,{283,113,164707,436,7177,2,"","",283.17682,468,0,0.16,"",0.1,"",0,0,"","",{"A"},{0},{"="},{0},13246,529,5168,916,10507,112,"","",-383,786,"","",7090,566,1558,788,"","",17398,583,13874,728,16467,688}
,{284,112,162545,806,7190,3,-4046,966,284.174499,865,0,0.104,"",0.02,"",0,1,"","",{"SF"},{0},{"="},{0},12573,1039,"","",9600,200,-6376,1039,"","",-10233,916,7012,1009,4024,1065,"","",15456,1038,12112,1139,14761,992}
,{284,113,166591,534,7173,2,-2330,846,284.178843,573,0,0.93,"",0.14,"",0,0,"","",{"A"},{0},{"="},{0},13277,644,5787,844,10280.33,50,"","",22,878,"","",6187,689,2184,809,"","",18326,846,13436,660,16941,966}
,{284,114,168921,656,7162,2,"","",284.181344,704,0,0.0033,"",0.0014,"",0,1,"","",{"SF"},{0},{"~"},{0},"","",4633,927,10800,300,"","",147,895,"","","","",3074,787,"","",15907,748,11975,721,16548,762}
,{285,112,165173,581,7184,2,-2557,995,285.177321,624,0,32,"",9,"",2.5,1,"","",{"A"},{0},{"="},{0},12455,842,"","",9317.4,50,-5829,700,"","",-9489,789,5443,993,"","","","",16604,907,12237,875,"",""}
,{285,113,167731,807,7173,3,-3272,897,285.180066,866,0,3.3,"",1.1,"",0,0,"","",{"A"},{0},{"="},{0},13119,917,6128,1066,10008.7,50,"","","","",-9262,1040,6932,968,2104,1140,"","",16956,1011,13619,1040,15577,1039}
,{285,114,171003,391,7158,1,"","",285.183579,419,0,0.21,"",0.1,"",0,0,"","",{"A"},{0},{"~"},{0},"","",5061,723,10558.4,50,"","",1169,895,"","",5990,763,2877,662,"","",17007,585,12142,532,17673,763}
,{286,113,170014,656,7168,2,-1758,928,286.182518,704,0,7,"",3,"",0,0,"","",{"A"},{0},{"="},{0},12719,846,"","",9789.43,50,"","","","",-9060,764,5787,1040,2448,877,"","",18180,1039,13393,895,16380,957}
,{286,114,171773,657,7159,2,"","",286.184406,705,0,0.14,"",0.03,"",0,1,"","",{"SF","A"},{0,40,0},{"~","~"},{0,40,0},13291,928,5350,1039,10372.2,32.03,"","",-689,877,"","",7301,764,3247,1040,"","",15893,846,11930,788,15934,895}
,{287,113,171245,725,7167,3,-2827,948,287.18384,778,0,120,"","s","",0,0,"","",{},{},{},{},12628,1085,"","",9540,200,-6650,847,"","",-8599,978,6840,978,"","","","",16783,929,13564,1084,"",""}
,{287,114,174073,610,7154,2,-3823,752,287.186875,655,0,0.52,"",0.13,"",0,0,"","",{"A"},{0},{"="},{0},13073,725,5679,843,10161.9,50,"","","","","","",5772,897,3231,896,"","",17053,1012,12345,811,17174,1011}
,{287,115,177895,439,7138,2,"","",287.190978,471,0,0.095,"",0.06,"",0,0,"","",{"A"},{0},{"="},{0},"","",4413,919,10763.63,50,"","",592,789,"","","","",1167,790,"","",17603,587,13838,789,16950,691}
,{288,114,175042,806,7154,3,-4728,968,288.187916,865,0,0.75,"",0.14,"",0,1,"","",{"A"},{0},{"="},{0},12873,1039,"","",10072.12,13.28,"","","","",-10924,917,7102,1011,3492,1084,"","",15739,1039,12176,1140,15515,994}
,{288,115,179771,536,7135,2,"","",288.192992,576,0,0.17,"",0.025,"",0,0,"","",{"A"},{0},{"="},{0},"","",4822,847,10754.6,50,"","",1236,902,"","",6196,693,1591,813,"","",18708,848,13632,663,17686,969}
,{289,114,177564,584,7148,2,-3102,997,289.190623,626,0,2.4,"",0.6,"",2.5,1,"","",{"A"},{0},{"="},{0},12651,844,"","",9966.19,50,-6963,764,"","",-10277,793,5549,995,"","","","",17030,931,12414,878,"",""}
,{289,115,180666,809,7135,3,-3861,947,289.193953,868,0,0.31,"",0.09,"",0,0,"","",{"A"},{0},{"="},{0},13371,920,5157,1086,10510.7,50,"","","","","","",7176,970,1665,1141,"","",17304,1013,13757,1042,16298,1041}
,{289,116,184528,492,7119,2,"","",289.198099,529,0,0.002,"","s","",2.5,1,"","",{},{},{},{},"","",4123,784,11100,300,"","",2196,944,"","","","",2532,728,"","",17343,660,"","",18401,821}
,{290,115,182894,658,7130,2,-2304,932,290.196345,706,0,0.41,"",0.19,"",0,0,"","",{"A"},{0},{"="},{0},13019,849,"","",10454.4,50,"","","","",-9705,822,5844,1042,1960,879,"","",18562,1040,13685,898,17295,979}
,{290,116,185198,660,7120,2,"","",290.198818,708,0,0.008,"",0.003,"",0,1,"","",{"A"},{0},{"="},{0},"","",4422,1041,10999.98,65.91,"","",344,881,"","",7401,823,2757,1044,"","",16138,850,12167,793,16772,899}
,{291,115,183990,784,7130,3,-3397,995,291.197522,842,0,1,"","s","",0,0,"","",{},{},{},{},12818,1127,"","",10320,300,-7810,984,"","",-9279,1025,6975,1024,"","","","",17137,978,13812,1124,"",""}
,{291,116,187387,612,7116,2,-4413,853,291.201169,658,0,0.028,"",0.015,"",0,0,"","",{"A"},{0},{"="},{0},13283,786,4755,846,10890,50,"","","","","","",5882,900,2795,899,"","",17432,1014,12481,814,17992,1012}
,{291,117,191800,594,7098,2,"","",291.205906,637,0,0.002,"","s","",0,0,"","",{},{},{},{},"","",3444,1003,11480,400,"","",1617,886,"","","","",687,888,"","",17983,771,"","",17676,800}
,{292,116,188242,806,7116,3,-5334,1047,292.202086,865,0,0.024,"",0.012,"",0,1,"","",{"A"},{0},{"="},{0},13099,1042,"","",10774.38,14.87,"","","","",-11630,1001,7217,1012,3038,1125,"","",16059,1040,12439,1142,16323,995}
,{292,117,193576,669,7095,2,"","",292.207812,718,0,0.01,"","s","",0,0,"","",{},{},{},{},"","",3896,938,11380,400,"","",2296,1031,"","",6296,895,1101,907,"","",19088,940,13912,831,18556,1050}
,{293,116,190669,586,7111,2,-3716,1000,293.204691,629,0,0.08,"",0.04,"",0,0,"","",{"A"},{0},{"="},{0},12861,847,"","",10679.42,50,-8204,914,"","",-10978,889,5644,996,"","","","",17389,979,12639,881,"",""}
,{293,117,194385,810,7095,3,-4488,1072,293.20868,870,0,0.021,"",0.006,"",0,0,"","",{"A"},{0},{"="},{0},13558,1004,4184,1128,11293.4,50,"","","","","","",7262,1051,1146,1143,"","",17708,1016,14051,1045,17137,1044}
,{293,118,198873,702,7077,2,"","",293.213498,753,0,0.001,"","s","",0.5,1,"","",{},{},{},{},"","",3093,931,11920,500,"","",3342,1069,"","","","",1992,970,"","",17783,919,"","",19321,963}
,{294,117,196521,660,7092,2,-2942,936,294.210974,708,0,0.07,"",0.03,"",0,0,"","",{"A"},{0},{"="},{0},13197,940,"","",11202.6,50,"","","","",-10423,963,5935,1045,1437,882,"","",18991,1041,13998,900,18177,1025}
,{294,118,199463,663,7079,2,"","",294.214132,712,0,0.00115,"",0.00047,"",0,1,"","",{"A"},{0},{"="},{0},"","",3356,1044,11840.37,65.9,"","",1505,885,"","",7481,966,2210,1047,"","",16598,942,12527,890,17722,903}
,{295,118,201512,644,7075,2,"","",295.216332,692,0,0.01,"","s","",0,0,"","",{},{},{},{},13503,953,3734,871,11700,200,"","","","","","",6022,925,2298,922,"","",17839,1035,12801,929,18917,1032}
}return Isotopes